/*
 * GIS Cloud JavaScript API
 *
 * web: https://www.giscloud.com/
 * dev: https://docs.giscloud.com/
 *
 * copyright GIS Cloud Ltd 2024.
 *
 */

if (!self.giscloud_config) {

giscloud_config = {
    restHost : function () {  return "https://api.giscloud.com"; },
    apiHost : function () {
        if (document.location.protocol === "https:")
            return "https://api.giscloud.com";
        else
            return "http://api.giscloud.com";
    },
    authHost : function () {  return "https://auth.giscloud.com"; },
    liveSite : function () {  return "http://api.giscloud.com/"; },
    leafletScript : function () { return "leaflet.js"; },
    nch : "63794e4",
    tileSite : function () {
        var tile_site =  "http://tiles.giscloud.com/";
        if (tile_site) {
            return tile_site;
        }
        var domain = "giscloud.com" || "giscloud.com";
        var subdomain_pattern = new RegExp("\\S+\\." + domain.replace(/\./g, "\\.") + "$", "i");
        if (document && document.location && document.location.host &&
            document.location.host !== "dev.giscloud.com" &&
            document.location.host.match(subdomain_pattern)) {

            return document.location.protocol + "//" + document.location.host + "/";
        }

        return "http://tiles.giscloud.com/";
    },
    assetsSite : function() {
        return  "http://assets.giscloud.com/";
    },
    tileImageProxySite: function() {
        var proxy = "https://proxy.giscloud.com/{url}";
        return proxy ? proxy : this.tileSite() + "tms/image_proxy?url={url}&mid={mid}";
    },
    https : true};

}(function(v,C){function e(e){var i=he[e]={};return ge.each(e.split(ee),function(e,t){i[t]=!0}),i}function u(e,t,i){if(i===C&&e.nodeType===1){var n="data-"+t.replace(me,"-$1").toLowerCase();i=e.getAttribute(n);if(typeof i=="string"){try{i=i==="true"?!0:i==="false"?!1:i==="null"?null:+i+""===i?+i:pe.test(i)?ge.parseJSON(i):i}catch(e){}ge.data(e,t,i)}else i=C}return i}function c(e){var t;for(t in e){if(t==="data"&&ge.isEmptyObject(e[t]))continue;if(t!=="toJSON")return!1}return!0}function a(){return!1}function i(){return!0}function r(e){return!e||!e.parentNode||e.parentNode.nodeType===11}function t(e,t){do{e=e[t]}while(e&&e.nodeType!==1);return e}function n(e,n,r){n=n||0;if(ge.isFunction(n))return ge.grep(e,function(e,t){var i=!!n.call(e,t,e);return i===r});if(n.nodeType)return ge.grep(e,function(e,t){return e===n===r});if(typeof n=="string"){var t=ge.grep(e,function(e){return e.nodeType===1});if(Ne.test(n))return ge.filter(n,t,!r);n=ge.filter(n,t)}return ge.grep(e,function(e,t){return ge.inArray(e,n)>=0===r})}function y(e){var t=He.split("|"),i=e.createDocumentFragment();if(i.createElement)while(t.length)i.createElement(t.pop());return i}function d(e,t){return e.getElementsByTagName(t)[0]||e.appendChild(e.ownerDocument.createElement(t))}function l(e,t){if(t.nodeType!==1||!ge.hasData(e))return;var i,n,r,o=ge._data(e),s=ge._data(t,o),a=o.events;if(a){delete s.handle,s.events={};for(i in a)for(n=0,r=a[i].length;n<r;n++)ge.event.add(t,i,a[i][n])}s.data&&(s.data=ge.extend({},s.data))}function f(e,t){var i;if(t.nodeType!==1)return;t.clearAttributes&&t.clearAttributes(),t.mergeAttributes&&t.mergeAttributes(e),i=t.nodeName.toLowerCase(),i==="object"?(t.parentNode&&(t.outerHTML=e.outerHTML),ge.support.html5Clone&&e.innerHTML&&!ge.trim(t.innerHTML)&&(t.innerHTML=e.innerHTML)):i==="input"&&Ze.test(e.type)?(t.defaultChecked=t.checked=e.checked,t.value!==e.value&&(t.value=e.value)):i==="option"?t.selected=e.defaultSelected:i==="input"||i==="textarea"?t.defaultValue=e.defaultValue:i==="script"&&t.text!==e.text&&(t.text=e.text),t.removeAttribute(ge.expando)}function h(e){return typeof e.getElementsByTagName!="undefined"?e.getElementsByTagName("*"):typeof e.querySelectorAll!="undefined"?e.querySelectorAll("*"):[]}function _(e){Ze.test(e.type)&&(e.defaultChecked=e.checked)}function p(e,t){if(t in e)return t;var i=t.charAt(0).toUpperCase()+t.slice(1),n=t,r=vt.length;while(r--){t=vt[r]+i;if(t in e)return t}return n}function b(e,t){return e=t||e,ge.css(e,"display")==="none"||!ge.contains(e.ownerDocument,e)}function o(e,t){var i,n,r=[],o=0,s=e.length;for(;o<s;o++){i=e[o];if(!i.style)continue;r[o]=ge._data(i,"olddisplay"),t?(!r[o]&&i.style.display==="none"&&(i.style.display=""),i.style.display===""&&b(i)&&(r[o]=ge._data(i,"olddisplay",w(i.nodeName)))):(n=it(i,"display"),!r[o]&&n!=="none"&&ge._data(i,"olddisplay",n))}for(o=0;o<s;o++){i=e[o];if(!i.style)continue;if(!t||i.style.display==="none"||i.style.display==="")i.style.display=t?r[o]||"":"none"}return e}function s(e,t,i){var n=ut.exec(t);return n?Math.max(0,n[1]-(i||0))+(n[2]||"px"):t}function g(e,t,i,n){var r=i===(n?"border":"content")?4:t==="width"?1:0,o=0;for(;r<4;r+=2)i==="margin"&&(o+=ge.css(e,i+mt[r],!0)),n?(i==="content"&&(o-=parseFloat(it(e,"padding"+mt[r]))||0),i!=="margin"&&(o-=parseFloat(it(e,"border"+mt[r]+"Width"))||0)):(o+=parseFloat(it(e,"padding"+mt[r]))||0,i!=="padding"&&(o+=parseFloat(it(e,"border"+mt[r]+"Width"))||0));return o}function m(e,t,i){var n=t==="width"?e.offsetWidth:e.offsetHeight,r=!0,o=ge.support.boxSizing&&ge.css(e,"boxSizing")==="border-box";if(n<=0||n==null){n=it(e,t);if(n<0||n==null)n=e.style[t];if(dt.test(n))return n;r=o&&(ge.support.boxSizingReliable||n===e.style[t]),n=parseFloat(n)||0}return n+g(e,t,i||(o?"border":"content"),r)+"px"}function w(e){if(ht[e])return ht[e];var t=ge("<"+e+">").appendTo(W.body),i=t.css("display");t.remove();if(i==="none"||i===""){nt=W.body.appendChild(nt||ge.extend(W.createElement("iframe"),{frameBorder:0,width:0,height:0}));if(!rt||!nt.createElement)rt=(nt.contentWindow||nt.contentDocument).document,rt.write("<!doctype html><html><body>"),rt.close();t=rt.body.appendChild(rt.createElement(e)),i=it(t,"display"),W.body.removeChild(nt)}return ht[e]=i,i}function x(i,e,n,r){var t;if(ge.isArray(e))ge.each(e,function(e,t){n||bt.test(i)?r(i,t):x(i+"["+(typeof t=="object"?e:"")+"]",t,n,r)});else if(!n&&ge.type(e)==="object")for(t in e)x(i+"["+t+"]",e[t],n,r);else r(i,e)}function k(l){return function(e,t){typeof e!="string"&&(t=e,e="*");var i,n,r,o=e.toLowerCase().split(ee),s=0,a=o.length;if(ge.isFunction(t))for(;s<a;s++)i=o[s],r=/^\+/.test(i),r&&(i=i.substr(1)||"*"),n=l[i]=l[i]||[],n[r?"unshift":"push"](t)}}function L(e,t,i,n,r,o){r=r||t.dataTypes[0],o=o||{},o[r]=!0;var s,a=e[r],l=0,c=a?a.length:0,u=e===Nt;for(;l<c&&(u||!s);l++)s=a[l](t,i,n),typeof s=="string"&&(!u||o[s]?s=C:(t.dataTypes.unshift(s),s=L(e,t,i,n,s,o)));return(u||!s)&&!o["*"]&&(s=L(e,t,i,n,"*",o)),s}function T(e,t){var i,n,r=ge.ajaxSettings.flatOptions||{};for(i in t)t[i]!==C&&((r[i]?e:n||(n={}))[i]=t[i]);n&&ge.extend(!0,e,n)}function j(e,t,i){var n,r,o,s,a=e.contents,l=e.dataTypes,c=e.responseFields;for(r in c)r in i&&(t[c[r]]=i[r]);while(l[0]==="*")l.shift(),n===C&&(n=e.mimeType||t.getResponseHeader("content-type"));if(n)for(r in a)if(a[r]&&a[r].test(n)){l.unshift(r);break}if(l[0]in i)o=l[0];else{for(r in i){if(!l[0]||e.converters[r+" "+l[0]]){o=r;break}s||(s=r)}o=o||s}if(o)return o!==l[0]&&l.unshift(o),i[o]}function M(e,t){var i,n,r,o,s=e.dataTypes.slice(),a=s[0],l={},c=0;e.dataFilter&&(t=e.dataFilter(t,e.dataType));if(s[1])for(i in e.converters)l[i.toLowerCase()]=e.converters[i];for(;r=s[++c];)if(r!=="*"){if(a!=="*"&&a!==r){i=l[a+" "+r]||l["* "+r];if(!i)for(n in l){o=n.split(" ");if(o[1]===r){i=l[a+" "+o[0]]||l["* "+o[0]];if(i){i===!0?i=l[n]:l[n]!==!0&&(r=o[0],s.splice(c--,0,r));break}}}if(i!==!0)if(i&&e["throws"])t=i(t);else try{t=i(t)}catch(e){return{state:"parsererror",error:i?e:"No conversion from "+a+" to "+r}}}a=r}return{state:"success",data:t}}function I(){try{return new v.XMLHttpRequest}catch(e){}}function D(){try{return new v.ActiveXObject("Microsoft.XMLHTTP")}catch(e){}}function S(){return setTimeout(function(){Ut=C},0),Ut=ge.now()}function P(o,e){ge.each(e,function(e,t){var i=(Qt[e]||[]).concat(Qt["*"]),n=0,r=i.length;for(;n<r;n++)if(i[n].call(o,e,t))return})}function E(s,e,t){var i,n=0,r=0,o=Jt.length,a=ge.Deferred().always(function(){delete l.elem}),l=function(){var e=Ut||S(),t=Math.max(0,c.startTime+c.duration-e),i=t/c.duration||0,n=1-i,r=0,o=c.tweens.length;for(;r<o;r++)c.tweens[r].run(n);return a.notifyWith(s,[c,n,t]),n<1&&o?t:(a.resolveWith(s,[c]),!1)},c=a.promise({elem:s,props:ge.extend({},e),opts:ge.extend(!0,{specialEasing:{}},t),originalProperties:e,originalOptions:t,startTime:Ut||S(),duration:t.duration,tweens:[],createTween:function(e,t,i){var n=ge.Tween(s,c.opts,e,t,c.opts.specialEasing[e]||c.opts.easing);return c.tweens.push(n),n},stop:function(e){var t=0,i=e?c.tweens.length:0;for(;t<i;t++)c.tweens[t].run(1);return e?a.resolveWith(s,[c,e]):a.rejectWith(s,[c,e]),this}}),u=c.props;O(u,c.opts.specialEasing);for(;n<o;n++){i=Jt[n].call(c,s,u,c.opts);if(i)return i}return P(c,u),ge.isFunction(c.opts.start)&&c.opts.start.call(s,c),ge.fx.timer(ge.extend(l,{anim:c,queue:c.opts.queue,elem:s})),c.progress(c.opts.progress).done(c.opts.done,c.opts.complete).fail(c.opts.fail).always(c.opts.always)}function O(e,t){var i,n,r,o,s;for(i in e){n=ge.camelCase(i),r=t[n],o=e[i],ge.isArray(o)&&(r=o[1],o=e[i]=o[0]),i!==n&&(e[n]=o,delete e[i]),s=ge.cssHooks[n];if(s&&"expand"in s){o=s.expand(o),delete e[n];for(i in o)i in e||(e[i]=o[i],t[i]=r)}else t[n]=r}}function A(t,e,i){var n,r,o,s,a,l,c,u,d,f=this,h=t.style,p={},g=[],m=t.nodeType&&b(t);i.queue||(u=ge._queueHooks(t,"fx"),u.unqueued==null&&(u.unqueued=0,d=u.empty.fire,u.empty.fire=function(){u.unqueued||d()}),u.unqueued++,f.always(function(){f.always(function(){u.unqueued--,ge.queue(t,"fx").length||u.empty.fire()})})),t.nodeType===1&&("height"in e||"width"in e)&&(i.overflow=[h.overflow,h.overflowX,h.overflowY],ge.css(t,"display")==="inline"&&ge.css(t,"float")==="none"&&(!ge.support.inlineBlockNeedsLayout||w(t.nodeName)==="inline"?h.display="inline-block":h.zoom=1)),i.overflow&&(h.overflow="hidden",ge.support.shrinkWrapBlocks||f.done(function(){h.overflow=i.overflow[0],h.overflowX=i.overflow[1],h.overflowY=i.overflow[2]}));for(n in e){o=e[n];if(Yt.exec(o)){delete e[n],l=l||o==="toggle";if(o===(m?"hide":"show"))continue;g.push(n)}}s=g.length;if(s){a=ge._data(t,"fxshow")||ge._data(t,"fxshow",{}),"hidden"in a&&(m=a.hidden),l&&(a.hidden=!m),m?ge(t).show():f.done(function(){ge(t).hide()}),f.done(function(){var e;ge.removeData(t,"fxshow",!0);for(e in p)ge.style(t,e,p[e])});for(n=0;n<s;n++)r=g[n],c=f.createTween(r,m?a[r]:0),p[r]=a[r]||ge.style(t,r),r in a||(a[r]=c.start,m&&(c.end=c.start,c.start=r==="width"||r==="height"?1:0))}}function N(e,t,i,n,r){return new N.prototype.init(e,t,i,n,r)}function R(e,t){var i,n={height:e},r=0;t=t?1:0;for(;r<4;r+=2-t)i=mt[r],n["margin"+i]=n["padding"+i]=e;return t&&(n.opacity=n.width=e),n}function z(e){return ge.isWindow(e)?e:e.nodeType===9?e.defaultView||e.parentWindow:!1}var H,F,W=v.document,B=v.location,G=v.navigator,q=v.jQuery,$=v.$,U=Array.prototype.push,V=Array.prototype.slice,Y=Array.prototype.indexOf,Z=Object.prototype.toString,X=Object.prototype.hasOwnProperty,J=String.prototype.trim,ge=function(e,t){return new ge.fn.init(e,t,H)},Q=/[\-+]?(?:\d*\.|)\d+(?:[eE][\-+]?\d+|)/.source,K=/\S/,ee=/\s+/,te=/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g,ie=/^(?:[^#<]*(<[\w\W]+>)[^>]*$|#([\w\-]*)$)/,ne=/^<(\w+)\s*\/?>(?:<\/\1>|)$/,re=/^[\],:{}\s]*$/,oe=/(?:^|:|,)(?:\s*\[)+/g,se=/\\(?:["\\\/bfnrt]|u[\da-fA-F]{4})/g,ae=/"[^"\\\r\n]*"|true|false|null|-?(?:\d\d*\.|)\d+(?:[eE][\-+]?\d+|)/g,le=/^-ms-/,ce=/-([\da-z])/gi,ue=function(e,t){return(t+"").toUpperCase()},de=function(){W.addEventListener?(W.removeEventListener("DOMContentLoaded",de,!1),ge.ready()):W.readyState==="complete"&&(W.detachEvent("onreadystatechange",de),ge.ready())},fe={};ge.fn=ge.prototype={constructor:ge,init:function(e,t,i){var n,r,o,s;if(!e)return this;if(e.nodeType)return this.context=this[0]=e,this.length=1,this;if(typeof e=="string"){e.charAt(0)==="<"&&e.charAt(e.length-1)===">"&&e.length>=3?n=[null,e,null]:n=ie.exec(e);if(n&&(n[1]||!t)){if(n[1])return t=t instanceof ge?t[0]:t,s=t&&t.nodeType?t.ownerDocument||t:W,e=ge.parseHTML(n[1],s,!0),ne.test(n[1])&&ge.isPlainObject(t)&&this.attr.call(e,t,!0),ge.merge(this,e);r=W.getElementById(n[2]);if(r&&r.parentNode){if(r.id!==n[2])return i.find(e);this.length=1,this[0]=r}return this.context=W,this.selector=e,this}return!t||t.jquery?(t||i).find(e):this.constructor(t).find(e)}return ge.isFunction(e)?i.ready(e):(e.selector!==C&&(this.selector=e.selector,this.context=e.context),ge.makeArray(e,this))},selector:"",jquery:"1.8.3",length:0,size:function(){return this.length},toArray:function(){return V.call(this)},get:function(e){return e==null?this.toArray():e<0?this[this.length+e]:this[e]},pushStack:function(e,t,i){var n=ge.merge(this.constructor(),e);return n.prevObject=this,n.context=this.context,t==="find"?n.selector=this.selector+(this.selector?" ":"")+i:t&&(n.selector=this.selector+"."+t+"("+i+")"),n},each:function(e,t){return ge.each(this,e,t)},ready:function(e){return ge.ready.promise().done(e),this},eq:function(e){return e=+e,e===-1?this.slice(e):this.slice(e,e+1)},first:function(){return this.eq(0)},last:function(){return this.eq(-1)},slice:function(){return this.pushStack(V.apply(this,arguments),"slice",V.call(arguments).join(","))},map:function(i){return this.pushStack(ge.map(this,function(e,t){return i.call(e,t,e)}))},end:function(){return this.prevObject||this.constructor(null)},push:U,sort:[].sort,splice:[].splice},ge.fn.init.prototype=ge.fn,ge.extend=ge.fn.extend=function(){var e,t,i,n,r,o,s=arguments[0]||{},a=1,l=arguments.length,c=!1;typeof s=="boolean"&&(c=s,s=arguments[1]||{},a=2),typeof s!="object"&&!ge.isFunction(s)&&(s={}),l===a&&(s=this,--a);for(;a<l;a++)if((e=arguments[a])!=null)for(t in e){i=s[t],n=e[t];if(s===n)continue;c&&n&&(ge.isPlainObject(n)||(r=ge.isArray(n)))?(r?(r=!1,o=i&&ge.isArray(i)?i:[]):o=i&&ge.isPlainObject(i)?i:{},s[t]=ge.extend(c,o,n)):n!==C&&(s[t]=n)}return s},ge.extend({noConflict:function(e){return v.$===ge&&(v.$=$),e&&v.jQuery===ge&&(v.jQuery=q),ge},isReady:!1,readyWait:1,holdReady:function(e){e?ge.readyWait++:ge.ready(!0)},ready:function(e){if(e===!0?--ge.readyWait:ge.isReady)return;if(!W.body)return setTimeout(ge.ready,1);ge.isReady=!0;if(e!==!0&&--ge.readyWait>0)return;F.resolveWith(W,[ge]),ge.fn.trigger&&ge(W).trigger("ready").off("ready")},isFunction:function(e){return ge.type(e)==="function"},isArray:Array.isArray||function(e){return ge.type(e)==="array"},isWindow:function(e){return e!=null&&e==e.window},isNumeric:function(e){return!isNaN(parseFloat(e))&&isFinite(e)},type:function(e){return e==null?String(e):fe[Z.call(e)]||"object"},isPlainObject:function(e){if(!e||ge.type(e)!=="object"||e.nodeType||ge.isWindow(e))return!1;try{if(e.constructor&&!X.call(e,"constructor")&&!X.call(e.constructor.prototype,"isPrototypeOf"))return!1}catch(e){return!1}var t;for(t in e);return t===C||X.call(e,t)},isEmptyObject:function(e){var t;for(t in e)return!1;return!0},error:function(e){throw new Error(e)},parseHTML:function(e,t,i){var n;return!e||typeof e!="string"?null:(typeof t=="boolean"&&(i=t,t=0),t=t||W,(n=ne.exec(e))?[t.createElement(n[1])]:(n=ge.buildFragment([e],t,i?null:[]),ge.merge([],(n.cacheable?ge.clone(n.fragment):n.fragment).childNodes)))},parseJSON:function(e){if(!e||typeof e!="string")return null;e=ge.trim(e);if(v.JSON&&v.JSON.parse)return v.JSON.parse(e);if(re.test(e.replace(se,"@").replace(ae,"]").replace(oe,"")))return new Function("return "+e)();ge.error("Invalid JSON: "+e)},parseXML:function(e){var t,i;if(!e||typeof e!="string")return null;try{v.DOMParser?(i=new DOMParser,t=i.parseFromString(e,"text/xml")):(t=new ActiveXObject("Microsoft.XMLDOM"),t.async="false",t.loadXML(e))}catch(e){t=C}return(!t||!t.documentElement||t.getElementsByTagName("parsererror").length)&&ge.error("Invalid XML: "+e),t},noop:function(){},globalEval:function(e){e&&K.test(e)&&(v.execScript||function(e){v.eval.call(v,e)})(e)},camelCase:function(e){return e.replace(le,"ms-").replace(ce,ue)},nodeName:function(e,t){return e.nodeName&&e.nodeName.toLowerCase()===t.toLowerCase()},each:function(e,t,i){var n,r=0,o=e.length,s=o===C||ge.isFunction(e);if(i){if(s){for(n in e)if(t.apply(e[n],i)===!1)break}else for(;r<o;)if(t.apply(e[r++],i)===!1)break}else if(s){for(n in e)if(t.call(e[n],n,e[n])===!1)break}else for(;r<o;)if(t.call(e[r],r,e[r++])===!1)break;return e},trim:J&&!J.call("\ufeff ")?function(e){return e==null?"":J.call(e)}:function(e){return e==null?"":(e+"").replace(te,"")},makeArray:function(e,t){var i,n=t||[];return e!=null&&(i=ge.type(e),e.length==null||i==="string"||i==="function"||i==="regexp"||ge.isWindow(e)?U.call(n,e):ge.merge(n,e)),n},inArray:function(e,t,i){var n;if(t){if(Y)return Y.call(t,e,i);n=t.length,i=i?i<0?Math.max(0,n+i):i:0;for(;i<n;i++)if(i in t&&t[i]===e)return i}return-1},merge:function(e,t){var i=t.length,n=e.length,r=0;if(typeof i=="number")for(;r<i;r++)e[n++]=t[r];else while(t[r]!==C)e[n++]=t[r++];return e.length=n,e},grep:function(e,t,i){var n,r=[],o=0,s=e.length;i=!!i;for(;o<s;o++)n=!!t(e[o],o),i!==n&&r.push(e[o]);return r},map:function(e,t,i){var n,r,o=[],s=0,a=e.length,l=e instanceof ge||a!==C&&typeof a=="number"&&(a>0&&e[0]&&e[a-1]||a===0||ge.isArray(e));if(l)for(;s<a;s++)n=t(e[s],s,i),n!=null&&(o[o.length]=n);else for(r in e)n=t(e[r],r,i),n!=null&&(o[o.length]=n);return o.concat.apply([],o)},guid:1,proxy:function(e,t){var i,n,r;return typeof t=="string"&&(i=e[t],t=e,e=i),ge.isFunction(e)?(n=V.call(arguments,2),r=function(){return e.apply(t,n.concat(V.call(arguments)))},r.guid=e.guid=e.guid||ge.guid++,r):C},access:function(e,t,i,n,r,o,s){var a,l=i==null,c=0,u=e.length;if(i&&typeof i=="object"){for(c in i)ge.access(e,t,c,i[c],1,o,n);r=1}else if(n!==C){a=s===C&&ge.isFunction(n),l&&(a?(a=t,t=function(e,t,i){return a.call(ge(e),i)}):(t.call(e,n),t=null));if(t)for(;c<u;c++)t(e[c],i,a?n.call(e[c],c,t(e[c],i)):n,s);r=1}return r?e:l?t.call(e):u?t(e[0],i):o},now:function(){return(new Date).getTime()}}),ge.ready.promise=function(e){if(!F){F=ge.Deferred();if(W.readyState==="complete")setTimeout(ge.ready,1);else if(W.addEventListener)W.addEventListener("DOMContentLoaded",de,!1),v.addEventListener("load",ge.ready,!1);else{W.attachEvent("onreadystatechange",de),v.attachEvent("onload",ge.ready);var i=!1;try{i=v.frameElement==null&&W.documentElement}catch(e){}i&&i.doScroll&&function t(){if(!ge.isReady){try{i.doScroll("left")}catch(e){return setTimeout(t,50)}ge.ready()}}()}}return F.promise(e)},ge.each("Boolean Number String Function Array Date RegExp Object".split(" "),function(e,t){fe["[object "+t+"]"]=t.toLowerCase()}),H=ge(W);var he={};ge.Callbacks=function(r){r=typeof r=="string"?he[r]||e(r):ge.extend({},r);var t,i,n,o,s,a,l=[],c=!r.once&&[],u=function(e){t=r.memory&&e,i=!0,a=o||0,o=0,s=l.length,n=!0;for(;l&&a<s;a++)if(l[a].apply(e[0],e[1])===!1&&r.stopOnFalse){t=!1;break}n=!1,l&&(c?c.length&&u(c.shift()):t?l=[]:d.disable())},d={add:function(){if(l){var e=l.length;(function n(e){ge.each(e,function(e,t){var i=ge.type(t);i==="function"?(!r.unique||!d.has(t))&&l.push(t):t&&t.length&&i!=="string"&&n(t)})})(arguments),n?s=l.length:t&&(o=e,u(t))}return this},remove:function(){return l&&ge.each(arguments,function(e,t){var i;while((i=ge.inArray(t,l,i))>-1)l.splice(i,1),n&&(i<=s&&s--,i<=a&&a--)}),this},has:function(e){return ge.inArray(e,l)>-1},empty:function(){return l=[],this},disable:function(){return l=c=t=C,this},disabled:function(){return!l},lock:function(){return c=C,t||d.disable(),this},locked:function(){return!c},fireWith:function(e,t){return t=t||[],t=[e,t.slice?t.slice():t],l&&(!i||c)&&(n?c.push(t):u(t)),this},fire:function(){return d.fireWith(this,arguments),this},fired:function(){return!!i}};return d},ge.extend({Deferred:function(e){var s=[["resolve","done",ge.Callbacks("once memory"),"resolved"],["reject","fail",ge.Callbacks("once memory"),"rejected"],["notify","progress",ge.Callbacks("memory")]],r="pending",o={state:function(){return r},always:function(){return a.done(arguments).fail(arguments),this},then:function(){var o=arguments;return ge.Deferred(function(r){ge.each(s,function(e,t){var i=t[0],n=o[e];a[t[1]](ge.isFunction(n)?function(){var e=n.apply(this,arguments);e&&ge.isFunction(e.promise)?e.promise().done(r.resolve).fail(r.reject).progress(r.notify):r[i+"With"](this===a?r:this,[e])}:r[i])}),o=null}).promise()},promise:function(e){return e!=null?ge.extend(e,o):o}},a={};return o.pipe=o.then,ge.each(s,function(e,t){var i=t[2],n=t[3];o[t[1]]=i.add,n&&i.add(function(){r=n},s[e^1][2].disable,s[2][2].lock),a[t[0]]=i.fire,a[t[0]+"With"]=i.fireWith}),o.promise(a),e&&e.call(a,a),a},when:function(e){var t=0,i=V.call(arguments),n=i.length,r=n!==1||e&&ge.isFunction(e.promise)?n:0,o=r===1?e:ge.Deferred(),s=function(t,i,n){return function(e){i[t]=this,n[t]=arguments.length>1?V.call(arguments):e,n===a?o.notifyWith(i,n):--r||o.resolveWith(i,n)}},a,l,c;if(n>1){a=new Array(n),l=new Array(n),c=new Array(n);for(;t<n;t++)i[t]&&ge.isFunction(i[t].promise)?i[t].promise().done(s(t,c,i)).fail(o.reject).progress(s(t,l,a)):--r}return r||o.resolveWith(c,i),o.promise()}}),ge.support=function(){var s,e,t,i,n,r,o,a,l,c,u,d=W.createElement("div");d.setAttribute("className","t"),d.innerHTML="  <link/><table></table><a href='/a'>a</a><input type='checkbox'/>",e=d.getElementsByTagName("*"),t=d.getElementsByTagName("a")[0];if(!e||!t||!e.length)return{};i=W.createElement("select"),n=i.appendChild(W.createElement("option")),r=d.getElementsByTagName("input")[0],t.style.cssText="top:1px;float:left;opacity:.5",s={leadingWhitespace:d.firstChild.nodeType===3,tbody:!d.getElementsByTagName("tbody").length,htmlSerialize:!!d.getElementsByTagName("link").length,style:/top/.test(t.getAttribute("style")),hrefNormalized:t.getAttribute("href")==="/a",opacity:/^0.5/.test(t.style.opacity),cssFloat:!!t.style.cssFloat,checkOn:r.value==="on",optSelected:n.selected,getSetAttribute:d.className!=="t",enctype:!!W.createElement("form").enctype,html5Clone:W.createElement("nav").cloneNode(!0).outerHTML!=="<:nav></:nav>",boxModel:W.compatMode==="CSS1Compat",submitBubbles:!0,changeBubbles:!0,focusinBubbles:!1,deleteExpando:!0,noCloneEvent:!0,inlineBlockNeedsLayout:!1,shrinkWrapBlocks:!1,reliableMarginRight:!0,boxSizingReliable:!0,pixelPosition:!1},r.checked=!0,s.noCloneChecked=r.cloneNode(!0).checked,i.disabled=!0,s.optDisabled=!n.disabled;try{delete d.test}catch(e){s.deleteExpando=!1}!d.addEventListener&&d.attachEvent&&d.fireEvent&&(d.attachEvent("onclick",u=function(){s.noCloneEvent=!1}),d.cloneNode(!0).fireEvent("onclick"),d.detachEvent("onclick",u)),r=W.createElement("input"),r.value="t",r.setAttribute("type","radio"),s.radioValue=r.value==="t",r.setAttribute("checked","checked"),r.setAttribute("name","t"),d.appendChild(r),o=W.createDocumentFragment(),o.appendChild(d.lastChild),s.checkClone=o.cloneNode(!0).cloneNode(!0).lastChild.checked,s.appendChecked=r.checked,o.removeChild(r),o.appendChild(d);if(d.attachEvent)for(l in{submit:!0,change:!0,focusin:!0})a="on"+l,c=a in d,c||(d.setAttribute(a,"return;"),c=typeof d[a]=="function"),s[l+"Bubbles"]=c;return ge(function(){var e,t,i,n,r="padding:0;margin:0;border:0;display:block;overflow:hidden;",o=W.getElementsByTagName("body")[0];if(!o)return;e=W.createElement("div"),e.style.cssText="visibility:hidden;border:0;width:0;height:0;position:static;top:0;margin-top:1px",o.insertBefore(e,o.firstChild),t=W.createElement("div"),e.appendChild(t),t.innerHTML="<table><tr><td></td><td>t</td></tr></table>",i=t.getElementsByTagName("td"),i[0].style.cssText="padding:0;margin:0;border:0;display:none",c=i[0].offsetHeight===0,i[0].style.display="",i[1].style.display="none",s.reliableHiddenOffsets=c&&i[0].offsetHeight===0,t.innerHTML="",t.style.cssText="box-sizing:border-box;-moz-box-sizing:border-box;-webkit-box-sizing:border-box;padding:1px;border:1px;display:block;width:4px;margin-top:1%;position:absolute;top:1%;",s.boxSizing=t.offsetWidth===4,s.doesNotIncludeMarginInBodyOffset=o.offsetTop!==1,v.getComputedStyle&&(s.pixelPosition=(v.getComputedStyle(t,null)||{}).top!=="1%",s.boxSizingReliable=(v.getComputedStyle(t,null)||{width:"4px"}).width==="4px",n=W.createElement("div"),n.style.cssText=t.style.cssText=r,n.style.marginRight=n.style.width="0",t.style.width="1px",t.appendChild(n),s.reliableMarginRight=!parseFloat((v.getComputedStyle(n,null)||{}).marginRight)),typeof t.style.zoom!="undefined"&&(t.innerHTML="",t.style.cssText=r+"width:1px;padding:1px;display:inline;zoom:1",s.inlineBlockNeedsLayout=t.offsetWidth===3,t.style.display="block",t.style.overflow="visible",t.innerHTML="<div></div>",t.firstChild.style.width="5px",s.shrinkWrapBlocks=t.offsetWidth!==3,e.style.zoom=1),o.removeChild(e),e=t=i=n=null}),o.removeChild(d),e=t=i=n=r=o=d=null,s}();var pe=/(?:\{[\s\S]*\}|\[[\s\S]*\])$/,me=/([A-Z])/g;ge.extend({cache:{},deletedIds:[],uuid:0,expando:"jQuery"+(ge.fn.jquery+Math.random()).replace(/\D/g,""),noData:{embed:!0,object:"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000",applet:!0},hasData:function(e){return e=e.nodeType?ge.cache[e[ge.expando]]:e[ge.expando],!!e&&!c(e)},data:function(e,t,i,n){if(!ge.acceptData(e))return;var r,o,s=ge.expando,a=typeof t=="string",l=e.nodeType,c=l?ge.cache:e,u=l?e[s]:e[s]&&s;if((!u||!c[u]||!n&&!c[u].data)&&a&&i===C)return;u||(l?e[s]=u=ge.deletedIds.pop()||ge.guid++:u=s),c[u]||(c[u]={},l||(c[u].toJSON=ge.noop));if(typeof t=="object"||typeof t=="function")n?c[u]=ge.extend(c[u],t):c[u].data=ge.extend(c[u].data,t);return r=c[u],n||(r.data||(r.data={}),r=r.data),i!==C&&(r[ge.camelCase(t)]=i),a?(o=r[t],o==null&&(o=r[ge.camelCase(t)])):o=r,o},removeData:function(e,t,i){if(!ge.acceptData(e))return;var n,r,o,s=e.nodeType,a=s?ge.cache:e,l=s?e[ge.expando]:ge.expando;if(!a[l])return;if(t){n=i?a[l]:a[l].data;if(n){ge.isArray(t)||(t in n?t=[t]:(t=ge.camelCase(t),t in n?t=[t]:t=t.split(" ")));for(r=0,o=t.length;r<o;r++)delete n[t[r]];if(!(i?c:ge.isEmptyObject)(n))return}}if(!i){delete a[l].data;if(!c(a[l]))return}s?ge.cleanData([e],!0):ge.support.deleteExpando||a!=a.window?delete a[l]:a[l]=null},_data:function(e,t,i){return ge.data(e,t,i,!0)},acceptData:function(e){var t=e.nodeName&&ge.noData[e.nodeName.toLowerCase()];return!t||t!==!0&&e.getAttribute("classid")===t}}),ge.fn.extend({data:function(i,e){var n,r,t,o,s,a=this[0],l=0,c=null;if(i===C){if(this.length){c=ge.data(a);if(a.nodeType===1&&!ge._data(a,"parsedAttrs")){t=a.attributes;for(s=t.length;l<s;l++)o=t[l].name,o.indexOf("data-")||(o=ge.camelCase(o.substring(5)),u(a,o,c[o]));ge._data(a,"parsedAttrs",!0)}}return c}return typeof i=="object"?this.each(function(){ge.data(this,i)}):(n=i.split(".",2),n[1]=n[1]?"."+n[1]:"",r=n[1]+"!",ge.access(this,function(t){if(t===C)return c=this.triggerHandler("getData"+r,[n[0]]),c===C&&a&&(c=ge.data(a,i),c=u(a,i,c)),c===C&&n[1]?this.data(n[0]):c;n[1]=t,this.each(function(){var e=ge(this);e.triggerHandler("setData"+r,n),ge.data(this,i,t),e.triggerHandler("changeData"+r,n)})},null,e,arguments.length>1,null,!1))},removeData:function(e){return this.each(function(){ge.removeData(this,e)})}}),ge.extend({queue:function(e,t,i){var n;if(e)return t=(t||"fx")+"queue",n=ge._data(e,t),i&&(!n||ge.isArray(i)?n=ge._data(e,t,ge.makeArray(i)):n.push(i)),n||[]},dequeue:function(e,t){t=t||"fx";var i=ge.queue(e,t),n=i.length,r=i.shift(),o=ge._queueHooks(e,t),s=function(){ge.dequeue(e,t)};r==="inprogress"&&(r=i.shift(),n--),r&&(t==="fx"&&i.unshift("inprogress"),delete o.stop,r.call(e,s,o)),!n&&o&&o.empty.fire()},_queueHooks:function(e,t){var i=t+"queueHooks";return ge._data(e,i)||ge._data(e,i,{empty:ge.Callbacks("once memory").add(function(){ge.removeData(e,t+"queue",!0),ge.removeData(e,i,!0)})})}}),ge.fn.extend({queue:function(t,i){var e=2;return typeof t!="string"&&(i=t,t="fx",e--),arguments.length<e?ge.queue(this[0],t):i===C?this:this.each(function(){var e=ge.queue(this,t,i);ge._queueHooks(this,t),t==="fx"&&e[0]!=="inprogress"&&ge.dequeue(this,t)})},dequeue:function(e){return this.each(function(){ge.dequeue(this,e)})},delay:function(n,e){return n=ge.fx?ge.fx.speeds[n]||n:n,e=e||"fx",this.queue(e,function(e,t){var i=setTimeout(e,n);t.stop=function(){clearTimeout(i)}})},clearQueue:function(e){return this.queue(e||"fx",[])},promise:function(e,t){var i,n=1,r=ge.Deferred(),o=this,s=this.length,a=function(){--n||r.resolveWith(o,[o])};typeof e!="string"&&(t=e,e=C),e=e||"fx";while(s--)i=ge._data(o[s],e+"queueHooks"),i&&i.empty&&(n++,i.empty.add(a));return a(),r.promise(t)}});var ve,ye,_e,be=/[\t\r\n]/g,we=/\r/g,xe=/^(?:button|input)$/i,ke=/^(?:button|input|object|select|textarea)$/i,Ce=/^a(?:rea|)$/i,Le=/^(?:autofocus|autoplay|async|checked|controls|defer|disabled|hidden|loop|multiple|open|readonly|required|scoped|selected)$/i,Te=ge.support.getSetAttribute;ge.fn.extend({attr:function(e,t){return ge.access(this,ge.attr,e,t,arguments.length>1)},removeAttr:function(e){return this.each(function(){ge.removeAttr(this,e)})},prop:function(e,t){return ge.access(this,ge.prop,e,t,arguments.length>1)},removeProp:function(e){return e=ge.propFix[e]||e,this.each(function(){try{this[e]=C,delete this[e]}catch(e){}})},addClass:function(t){var e,i,n,r,o,s,a;if(ge.isFunction(t))return this.each(function(e){ge(this).addClass(t.call(this,e,this.className))});if(t&&typeof t=="string"){e=t.split(ee);for(i=0,n=this.length;i<n;i++){r=this[i];if(r.nodeType===1)if(!r.className&&e.length===1)r.className=t;else{o=" "+r.className+" ";for(s=0,a=e.length;s<a;s++)o.indexOf(" "+e[s]+" ")<0&&(o+=e[s]+" ");r.className=ge.trim(o)}}}return this},removeClass:function(t){var e,i,n,r,o,s,a;if(ge.isFunction(t))return this.each(function(e){ge(this).removeClass(t.call(this,e,this.className))});if(t&&typeof t=="string"||t===C){e=(t||"").split(ee);for(s=0,a=this.length;s<a;s++){n=this[s];if(n.nodeType===1&&n.className){i=(" "+n.className+" ").replace(be," ");for(r=0,o=e.length;r<o;r++)while(i.indexOf(" "+e[r]+" ")>=0)i=i.replace(" "+e[r]+" "," ");n.className=t?ge.trim(i):""}}}return this},toggleClass:function(o,s){var a=typeof o,l=typeof s=="boolean";return ge.isFunction(o)?this.each(function(e){ge(this).toggleClass(o.call(this,e,this.className,s),s)}):this.each(function(){if(a==="string"){var e,t=0,i=ge(this),n=s,r=o.split(ee);while(e=r[t++])n=l?n:!i.hasClass(e),i[n?"addClass":"removeClass"](e)}else if(a==="undefined"||a==="boolean")this.className&&ge._data(this,"__className__",this.className),this.className=this.className||o===!1?"":ge._data(this,"__className__")||""})},hasClass:function(e){var t=" "+e+" ",i=0,n=this.length;for(;i<n;i++)if(this[i].nodeType===1&&(" "+this[i].className+" ").replace(be," ").indexOf(t)>=0)return!0;return!1},val:function(n){var r,e,o,t=this[0];if(!arguments.length){if(t)return r=ge.valHooks[t.type]||ge.valHooks[t.nodeName.toLowerCase()],r&&"get"in r&&(e=r.get(t,"value"))!==C?e:(e=t.value,typeof e=="string"?e.replace(we,""):e==null?"":e);return}return o=ge.isFunction(n),this.each(function(e){var t,i=ge(this);if(this.nodeType!==1)return;o?t=n.call(this,e,i.val()):t=n,t==null?t="":typeof t=="number"?t+="":ge.isArray(t)&&(t=ge.map(t,function(e){return e==null?"":e+""})),r=ge.valHooks[this.type]||ge.valHooks[this.nodeName.toLowerCase()];if(!r||!("set"in r)||r.set(this,t,"value")===C)this.value=t})}}),ge.extend({valHooks:{option:{get:function(e){var t=e.attributes.value;return!t||t.specified?e.value:e.text}},select:{get:function(e){var t,i,n=e.options,r=e.selectedIndex,o=e.type==="select-one"||r<0,s=o?null:[],a=o?r+1:n.length,l=r<0?a:o?r:0;for(;l<a;l++){i=n[l];if((i.selected||l===r)&&(ge.support.optDisabled?!i.disabled:i.getAttribute("disabled")===null)&&(!i.parentNode.disabled||!ge.nodeName(i.parentNode,"optgroup"))){t=ge(i).val();if(o)return t;s.push(t)}}return s},set:function(e,t){var i=ge.makeArray(t);return ge(e).find("option").each(function(){this.selected=ge.inArray(ge(this).val(),i)>=0}),i.length||(e.selectedIndex=-1),i}}},attrFn:{},attr:function(e,t,i,n){var r,o,s,a=e.nodeType;if(!e||a===3||a===8||a===2)return;if(n&&ge.isFunction(ge.fn[t]))return ge(e)[t](i);if(typeof e.getAttribute=="undefined")return ge.prop(e,t,i);s=a!==1||!ge.isXMLDoc(e),s&&(t=t.toLowerCase(),o=ge.attrHooks[t]||(Le.test(t)?ye:ve));if(i!==C){if(i===null){ge.removeAttr(e,t);return}return o&&"set"in o&&s&&(r=o.set(e,i,t))!==C?r:(e.setAttribute(t,i+""),i)}return o&&"get"in o&&s&&(r=o.get(e,t))!==null?r:(r=e.getAttribute(t),r===null?C:r)},removeAttr:function(e,t){var i,n,r,o,s=0;if(t&&e.nodeType===1){n=t.split(ee);for(;s<n.length;s++)r=n[s],r&&(i=ge.propFix[r]||r,o=Le.test(r),o||ge.attr(e,r,""),e.removeAttribute(Te?r:i),o&&i in e&&(e[i]=!1))}},attrHooks:{type:{set:function(e,t){if(xe.test(e.nodeName)&&e.parentNode)ge.error("type property can't be changed");else if(!ge.support.radioValue&&t==="radio"&&ge.nodeName(e,"input")){var i=e.value;return e.setAttribute("type",t),i&&(e.value=i),t}}},value:{get:function(e,t){return ve&&ge.nodeName(e,"button")?ve.get(e,t):t in e?e.value:null},set:function(e,t,i){if(ve&&ge.nodeName(e,"button"))return ve.set(e,t,i);e.value=t}}},propFix:{tabindex:"tabIndex",readonly:"readOnly",for:"htmlFor",class:"className",maxlength:"maxLength",cellspacing:"cellSpacing",cellpadding:"cellPadding",rowspan:"rowSpan",colspan:"colSpan",usemap:"useMap",frameborder:"frameBorder",contenteditable:"contentEditable"},prop:function(e,t,i){var n,r,o,s=e.nodeType;if(!e||s===3||s===8||s===2)return;return o=s!==1||!ge.isXMLDoc(e),o&&(t=ge.propFix[t]||t,r=ge.propHooks[t]),i!==C?r&&"set"in r&&(n=r.set(e,i,t))!==C?n:e[t]=i:r&&"get"in r&&(n=r.get(e,t))!==null?n:e[t]},propHooks:{tabIndex:{get:function(e){var t=e.getAttributeNode("tabindex");return t&&t.specified?parseInt(t.value,10):ke.test(e.nodeName)||Ce.test(e.nodeName)&&e.href?0:C}}}}),ye={get:function(e,t){var i,n=ge.prop(e,t);return n===!0||typeof n!="boolean"&&(i=e.getAttributeNode(t))&&i.nodeValue!==!1?t.toLowerCase():C},set:function(e,t,i){var n;return t===!1?ge.removeAttr(e,i):(n=ge.propFix[i]||i,n in e&&(e[n]=!0),e.setAttribute(i,i.toLowerCase())),i}},Te||(_e={name:!0,id:!0,coords:!0},ve=ge.valHooks.button={get:function(e,t){var i;return i=e.getAttributeNode(t),i&&(_e[t]?i.value!=="":i.specified)?i.value:C},set:function(e,t,i){var n=e.getAttributeNode(i);return n||(n=W.createAttribute(i),e.setAttributeNode(n)),n.value=t+""}},ge.each(["width","height"],function(e,i){ge.attrHooks[i]=ge.extend(ge.attrHooks[i],{set:function(e,t){if(t==="")return e.setAttribute(i,"auto"),t}})}),ge.attrHooks.contenteditable={get:ve.get,set:function(e,t,i){t===""&&(t="false"),ve.set(e,t,i)}}),ge.support.hrefNormalized||ge.each(["href","src","width","height"],function(e,i){ge.attrHooks[i]=ge.extend(ge.attrHooks[i],{get:function(e){var t=e.getAttribute(i,2);return t===null?C:t}})}),ge.support.style||(ge.attrHooks.style={get:function(e){return e.style.cssText.toLowerCase()||C},set:function(e,t){return e.style.cssText=t+""}}),ge.support.optSelected||(ge.propHooks.selected=ge.extend(ge.propHooks.selected,{get:function(e){var t=e.parentNode;return t&&(t.selectedIndex,t.parentNode&&t.parentNode.selectedIndex),null}})),ge.support.enctype||(ge.propFix.enctype="encoding"),ge.support.checkOn||ge.each(["radio","checkbox"],function(){ge.valHooks[this]={get:function(e){return e.getAttribute("value")===null?"on":e.value}}}),ge.each(["radio","checkbox"],function(){ge.valHooks[this]=ge.extend(ge.valHooks[this],{set:function(e,t){if(ge.isArray(t))return e.checked=ge.inArray(ge(e).val(),t)>=0}})});var je=/^(?:textarea|input|select)$/i,Me=/^([^\.]*|)(?:\.(.+)|)$/,Ie=/(?:^|\s)hover(\.\S+|)\b/,De=/^key/,Se=/^(?:mouse|contextmenu)|click/,Pe=/^(?:focusinfocus|focusoutblur)$/,Ee=function(e){return ge.event.special.hover?e:e.replace(Ie,"mouseenter$1 mouseleave$1")};ge.event={add:function(e,t,i,n,r){var o,s,a,l,c,u,d,f,h,p,g;if(e.nodeType===3||e.nodeType===8||!t||!i||!(o=ge._data(e)))return;i.handler&&(h=i,i=h.handler,r=h.selector),i.guid||(i.guid=ge.guid++),a=o.events,a||(o.events=a={}),s=o.handle,s||(o.handle=s=function(e){return typeof ge=="undefined"||!!e&&ge.event.triggered===e.type?C:ge.event.dispatch.apply(s.elem,arguments)},s.elem=e),t=ge.trim(Ee(t)).split(" ");for(l=0;l<t.length;l++){c=Me.exec(t[l])||[],u=c[1],d=(c[2]||"").split(".").sort(),g=ge.event.special[u]||{},u=(r?g.delegateType:g.bindType)||u,g=ge.event.special[u]||{},f=ge.extend({type:u,origType:c[1],data:n,handler:i,guid:i.guid,selector:r,needsContext:r&&ge.expr.match.needsContext.test(r),namespace:d.join(".")},h),p=a[u];if(!p){p=a[u]=[],p.delegateCount=0;if(!g.setup||g.setup.call(e,n,d,s)===!1)e.addEventListener?e.addEventListener(u,s,!1):e.attachEvent&&e.attachEvent("on"+u,s)}g.add&&(g.add.call(e,f),f.handler.guid||(f.handler.guid=i.guid)),r?p.splice(p.delegateCount++,0,f):p.push(f),ge.event.global[u]=!0}e=null},global:{},remove:function(e,t,i,n,r){var o,s,a,l,c,u,d,f,h,p,g,m=ge.hasData(e)&&ge._data(e);if(!m||!(f=m.events))return;t=ge.trim(Ee(t||"")).split(" ");for(o=0;o<t.length;o++){s=Me.exec(t[o])||[],a=l=s[1],c=s[2];if(!a){for(a in f)ge.event.remove(e,a+t[o],i,n,!0);continue}h=ge.event.special[a]||{},a=(n?h.delegateType:h.bindType)||a,p=f[a]||[],u=p.length,c=c?new RegExp("(^|\\.)"+c.split(".").sort().join("\\.(?:.*\\.|)")+"(\\.|$)"):null;for(d=0;d<p.length;d++)g=p[d],(r||l===g.origType)&&(!i||i.guid===g.guid)&&(!c||c.test(g.namespace))&&(!n||n===g.selector||n==="**"&&g.selector)&&(p.splice(d--,1),g.selector&&p.delegateCount--,h.remove&&h.remove.call(e,g));p.length===0&&u!==p.length&&((!h.teardown||h.teardown.call(e,c,m.handle)===!1)&&ge.removeEvent(e,a,m.handle),delete f[a])}ge.isEmptyObject(f)&&(delete m.handle,ge.removeData(e,"events",!0))},customEvent:{getData:!0,setData:!0,changeData:!0},trigger:function(e,t,i,n){if(!i||i.nodeType!==3&&i.nodeType!==8){var r,o,s,a,l,c,u,d,f,h,p=e.type||e,g=[];if(Pe.test(p+ge.event.triggered))return;p.indexOf("!")>=0&&(p=p.slice(0,-1),o=!0),p.indexOf(".")>=0&&(g=p.split("."),p=g.shift(),g.sort());if((!i||ge.event.customEvent[p])&&!ge.event.global[p])return;e=typeof e=="object"?e[ge.expando]?e:new ge.Event(p,e):new ge.Event(p),e.type=p,e.isTrigger=!0,e.exclusive=o,e.namespace=g.join("."),e.namespace_re=e.namespace?new RegExp("(^|\\.)"+g.join("\\.(?:.*\\.|)")+"(\\.|$)"):null,c=p.indexOf(":")<0?"on"+p:"";if(!i){r=ge.cache;for(s in r)r[s].events&&r[s].events[p]&&ge.event.trigger(e,t,r[s].handle.elem,!0);return}e.result=C,e.target||(e.target=i),t=t!=null?ge.makeArray(t):[],t.unshift(e),u=ge.event.special[p]||{};if(u.trigger&&u.trigger.apply(i,t)===!1)return;f=[[i,u.bindType||p]];if(!n&&!u.noBubble&&!ge.isWindow(i)){h=u.delegateType||p,a=Pe.test(h+p)?i:i.parentNode;for(l=i;a;a=a.parentNode)f.push([a,h]),l=a;l===(i.ownerDocument||W)&&f.push([l.defaultView||l.parentWindow||v,h])}for(s=0;s<f.length&&!e.isPropagationStopped();s++)a=f[s][0],e.type=f[s][1],d=(ge._data(a,"events")||{})[e.type]&&ge._data(a,"handle"),d&&d.apply(a,t),d=c&&a[c],d&&ge.acceptData(a)&&d.apply&&d.apply(a,t)===!1&&e.preventDefault();return e.type=p,!n&&!e.isDefaultPrevented()&&(!u._default||u._default.apply(i.ownerDocument,t)===!1)&&(p!=="click"||!ge.nodeName(i,"a"))&&ge.acceptData(i)&&c&&i[p]&&(p!=="focus"&&p!=="blur"||e.target.offsetWidth!==0)&&!ge.isWindow(i)&&(l=i[c],l&&(i[c]=null),ge.event.triggered=p,i[p](),ge.event.triggered=C,l&&(i[c]=l)),e.result}return},dispatch:function(e){e=ge.event.fix(e||v.event);var t,i,n,r,o,s,a,l,c,u,d=(ge._data(this,"events")||{})[e.type]||[],f=d.delegateCount,h=V.call(arguments),p=!e.exclusive&&!e.namespace,g=ge.event.special[e.type]||{},m=[];h[0]=e,e.delegateTarget=this;if(g.preDispatch&&g.preDispatch.call(this,e)===!1)return;if(f&&(!e.button||e.type!=="click"))for(n=e.target;n!=this;n=n.parentNode||this)if(n.disabled!==!0||e.type!=="click"){o={},a=[];for(t=0;t<f;t++)l=d[t],c=l.selector,o[c]===C&&(o[c]=l.needsContext?ge(c,this).index(n)>=0:ge.find(c,this,null,[n]).length),o[c]&&a.push(l);a.length&&m.push({elem:n,matches:a})}d.length>f&&m.push({elem:this,matches:d.slice(f)});for(t=0;t<m.length&&!e.isPropagationStopped();t++){s=m[t],e.currentTarget=s.elem;for(i=0;i<s.matches.length&&!e.isImmediatePropagationStopped();i++){l=s.matches[i];if(p||!e.namespace&&!l.namespace||e.namespace_re&&e.namespace_re.test(l.namespace))e.data=l.data,e.handleObj=l,r=((ge.event.special[l.origType]||{}).handle||l.handler).apply(s.elem,h),r!==C&&(e.result=r,r===!1&&(e.preventDefault(),e.stopPropagation()))}}return g.postDispatch&&g.postDispatch.call(this,e),e.result},props:"attrChange attrName relatedNode srcElement altKey bubbles cancelable ctrlKey currentTarget eventPhase metaKey relatedTarget shiftKey target timeStamp view which".split(" "),fixHooks:{},keyHooks:{props:"char charCode key keyCode".split(" "),filter:function(e,t){return e.which==null&&(e.which=t.charCode!=null?t.charCode:t.keyCode),e}},mouseHooks:{props:"button buttons clientX clientY fromElement offsetX offsetY pageX pageY screenX screenY toElement".split(" "),filter:function(e,t){var i,n,r,o=t.button,s=t.fromElement;return e.pageX==null&&t.clientX!=null&&(i=e.target.ownerDocument||W,n=i.documentElement,r=i.body,e.pageX=t.clientX+(n&&n.scrollLeft||r&&r.scrollLeft||0)-(n&&n.clientLeft||r&&r.clientLeft||0),e.pageY=t.clientY+(n&&n.scrollTop||r&&r.scrollTop||0)-(n&&n.clientTop||r&&r.clientTop||0)),!e.relatedTarget&&s&&(e.relatedTarget=s===e.target?t.toElement:s),!e.which&&o!==C&&(e.which=o&1?1:o&2?3:o&4?2:0),e}},fix:function(e){if(e[ge.expando])return e;var t,i,n=e,r=ge.event.fixHooks[e.type]||{},o=r.props?this.props.concat(r.props):this.props;e=ge.Event(n);for(t=o.length;t;)i=o[--t],e[i]=n[i];return e.target||(e.target=n.srcElement||W),e.target.nodeType===3&&(e.target=e.target.parentNode),e.metaKey=!!e.metaKey,r.filter?r.filter(e,n):e},special:{load:{noBubble:!0},focus:{delegateType:"focusin"},blur:{delegateType:"focusout"},beforeunload:{setup:function(e,t,i){ge.isWindow(this)&&(this.onbeforeunload=i)},teardown:function(e,t){this.onbeforeunload===t&&(this.onbeforeunload=null)}}},simulate:function(e,t,i,n){var r=ge.extend(new ge.Event,i,{type:e,isSimulated:!0,originalEvent:{}});n?ge.event.trigger(r,null,t):ge.event.dispatch.call(t,r),r.isDefaultPrevented()&&i.preventDefault()}},ge.event.handle=ge.event.dispatch,ge.removeEvent=W.removeEventListener?function(e,t,i){e.removeEventListener&&e.removeEventListener(t,i,!1)}:function(e,t,i){var n="on"+t;e.detachEvent&&(typeof e[n]=="undefined"&&(e[n]=null),e.detachEvent(n,i))},ge.Event=function(e,t){if(!(this instanceof ge.Event))return new ge.Event(e,t);e&&e.type?(this.originalEvent=e,this.type=e.type,this.isDefaultPrevented=e.defaultPrevented||e.returnValue===!1||e.getPreventDefault&&e.getPreventDefault()?i:a):this.type=e,t&&ge.extend(this,t),this.timeStamp=e&&e.timeStamp||ge.now(),this[ge.expando]=!0},ge.Event.prototype={preventDefault:function(){this.isDefaultPrevented=i;var e=this.originalEvent;if(!e)return;e.preventDefault?e.preventDefault():e.returnValue=!1},stopPropagation:function(){this.isPropagationStopped=i;var e=this.originalEvent;if(!e)return;e.stopPropagation&&e.stopPropagation(),e.cancelBubble=!0},stopImmediatePropagation:function(){this.isImmediatePropagationStopped=i,this.stopPropagation()},isDefaultPrevented:a,isPropagationStopped:a,isImmediatePropagationStopped:a},ge.each({mouseenter:"mouseover",mouseleave:"mouseout"},function(e,s){ge.event.special[e]={delegateType:s,bindType:s,handle:function(e){var t,i=this,n=e.relatedTarget,r=e.handleObj,o=r.selector;if(!n||n!==i&&!ge.contains(i,n))e.type=r.origType,t=r.handler.apply(this,arguments),e.type=s;return t}}}),ge.support.submitBubbles||(ge.event.special.submit={setup:function(){if(ge.nodeName(this,"form"))return!1;ge.event.add(this,"click._submit keypress._submit",function(e){var t=e.target,i=ge.nodeName(t,"input")||ge.nodeName(t,"button")?t.form:C;i&&!ge._data(i,"_submit_attached")&&(ge.event.add(i,"submit._submit",function(e){e._submit_bubble=!0}),ge._data(i,"_submit_attached",!0))})},postDispatch:function(e){e._submit_bubble&&(delete e._submit_bubble,this.parentNode&&!e.isTrigger&&ge.event.simulate("submit",this.parentNode,e,!0))},teardown:function(){if(ge.nodeName(this,"form"))return!1;ge.event.remove(this,"._submit")}}),ge.support.changeBubbles||(ge.event.special.change={setup:function(){if(je.test(this.nodeName)){if(this.type==="checkbox"||this.type==="radio")ge.event.add(this,"propertychange._change",function(e){e.originalEvent.propertyName==="checked"&&(this._just_changed=!0)}),ge.event.add(this,"click._change",function(e){this._just_changed&&!e.isTrigger&&(this._just_changed=!1),ge.event.simulate("change",this,e,!0)});return!1}ge.event.add(this,"beforeactivate._change",function(e){var t=e.target;je.test(t.nodeName)&&!ge._data(t,"_change_attached")&&(ge.event.add(t,"change._change",function(e){this.parentNode&&!e.isSimulated&&!e.isTrigger&&ge.event.simulate("change",this.parentNode,e,!0)}),ge._data(t,"_change_attached",!0))})},handle:function(e){var t=e.target;if(this!==t||e.isSimulated||e.isTrigger||t.type!=="radio"&&t.type!=="checkbox")return e.handleObj.handler.apply(this,arguments)},teardown:function(){return ge.event.remove(this,"._change"),!je.test(this.nodeName)}}),ge.support.focusinBubbles||ge.each({focus:"focusin",blur:"focusout"},function(e,t){var i=0,n=function(e){ge.event.simulate(t,e.target,ge.event.fix(e),!0)};ge.event.special[t]={setup:function(){i++===0&&W.addEventListener(e,n,!0)},teardown:function(){--i===0&&W.removeEventListener(e,n,!0)}}}),ge.fn.extend({on:function(e,t,i,n,r){var o,s;if(typeof e=="object"){typeof t!="string"&&(i=i||t,t=C);for(s in e)this.on(s,t,i,e[s],r);return this}i==null&&n==null?(n=t,i=t=C):n==null&&(typeof t=="string"?(n=i,i=C):(n=i,i=t,t=C));if(n===!1)n=a;else if(!n)return this;return r===1&&(o=n,n=function(e){return ge().off(e),o.apply(this,arguments)},n.guid=o.guid||(o.guid=ge.guid++)),this.each(function(){ge.event.add(this,e,n,i,t)})},one:function(e,t,i,n){return this.on(e,t,i,n,1)},off:function(e,t,i){var n,r;if(e&&e.preventDefault&&e.handleObj)return n=e.handleObj,ge(e.delegateTarget).off(n.namespace?n.origType+"."+n.namespace:n.origType,n.selector,n.handler),this;if(typeof e=="object"){for(r in e)this.off(r,t,e[r]);return this}if(t===!1||typeof t=="function")i=t,t=C;return i===!1&&(i=a),this.each(function(){ge.event.remove(this,e,i,t)})},bind:function(e,t,i){return this.on(e,null,t,i)},unbind:function(e,t){return this.off(e,null,t)},live:function(e,t,i){return ge(this.context).on(e,this.selector,t,i),this},die:function(e,t){return ge(this.context).off(e,this.selector||"**",t),this},delegate:function(e,t,i,n){return this.on(t,e,i,n)},undelegate:function(e,t,i){return arguments.length===1?this.off(e,"**"):this.off(t,e||"**",i)},trigger:function(e,t){return this.each(function(){ge.event.trigger(e,t,this)})},triggerHandler:function(e,t){if(this[0])return ge.event.trigger(e,t,this[0],!0)},toggle:function(i){var n=arguments,e=i.guid||ge.guid++,r=0,t=function(e){var t=(ge._data(this,"lastToggle"+i.guid)||0)%r;return ge._data(this,"lastToggle"+i.guid,t+1),e.preventDefault(),n[t].apply(this,arguments)||!1};t.guid=e;while(r<n.length)n[r++].guid=e;return this.click(t)},hover:function(e,t){return this.mouseenter(e).mouseleave(t||e)}}),ge.each("blur focus focusin focusout load resize scroll unload click dblclick mousedown mouseup mousemove mouseover mouseout mouseenter mouseleave change select submit keydown keypress keyup error contextmenu".split(" "),function(e,i){ge.fn[i]=function(e,t){return t==null&&(t=e,e=null),arguments.length>0?this.on(i,null,e,t):this.trigger(i)},De.test(i)&&(ge.event.fixHooks[i]=ge.event.keyHooks),Se.test(i)&&(ge.event.fixHooks[i]=ge.event.mouseHooks)}),function(e,r){function w(e,t,i,n){i=i||[],t=t||S;var r,o,s,a,l=t.nodeType;if(!e||typeof e!="string")return i;if(l!==1&&l!==9)return[];s=g(t);if(!s&&!n)if(r=te.exec(e))if(a=r[1]){if(l===9){o=t.getElementById(a);if(!o||!o.parentNode)return i;if(o.id===a)return i.push(o),i}else if(t.ownerDocument&&(o=t.ownerDocument.getElementById(a))&&m(t,o)&&o.id===a)return i.push(o),i}else{if(r[2])return N.apply(i,R.call(t.getElementsByTagName(e),0)),i;if((a=r[3])&&he&&t.getElementsByClassName)return N.apply(i,R.call(t.getElementsByClassName(a),0)),i}return c(e.replace(J,"$1"),t,i,n,s)}function t(i){return function(e){var t=e.nodeName.toLowerCase();return t==="input"&&e.type===i}}function i(i){return function(e){var t=e.nodeName.toLowerCase();return(t==="input"||t==="button")&&e.type===i}}function n(s){return H(function(o){return o=+o,H(function(e,t){var i,n=s([],e.length,o),r=n.length;while(r--)e[i=n[r]]&&(e[i]=!(t[i]=e[i]))})})}function u(e,t,i){if(e===t)return i;var n=e.nextSibling;while(n){if(n===t)return-1;n=n.nextSibling}return 1}function p(e,t){var i,n,r,o,s,a,l,c=B[I][e+" "];if(c)return t?0:c.slice(0);s=e,a=[],l=C.preFilter;while(s){if(!i||(n=Q.exec(s)))n&&(s=s.slice(n[0].length)||s),a.push(r=[]);i=!1;if(n=K.exec(s))r.push(i=new D(n.shift())),s=s.slice(i.length),i.type=n[0].replace(J," ");for(o in C.filter)(n=le[o].exec(s))&&(!l[o]||(n=l[o](n)))&&(r.push(i=new D(n.shift())),s=s.slice(i.length),i.type=o,i.matches=n);if(!i)break}return t?s.length:s?w.error(e):B(e,a).slice(0)}function d(s,e,t){var a=e.dir,l=t&&e.dir==="parentNode",c=O++;return e.first?function(e,t,i){while(e=e[a])if(l||e.nodeType===1)return s(e,t,i)}:function(e,t,i){if(!i){var n,r=E+" "+c+" ",o=r+k;while(e=e[a])if(l||e.nodeType===1){if((n=e[I])===o)return e.sizset;if(typeof n=="string"&&n.indexOf(r)===0){if(e.sizset)return e}else{e[I]=o;if(s(e,t,i))return e.sizset=!0,e;e.sizset=!1}}}else while(e=e[a])if(l||e.nodeType===1)if(s(e,t,i))return e}}function f(r){return r.length>1?function(e,t,i){var n=r.length;while(n--)if(!r[n](e,t,i))return!1;return!0}:r[0]}function x(e,t,i,n,r){var o,s=[],a=0,l=e.length,c=t!=null;for(;a<l;a++)if(o=e[a])if(!i||i(o,n,r))s.push(o),c&&t.push(a);return s}function y(h,p,g,m,v,e){return m&&!m[I]&&(m=y(m)),v&&!v[I]&&(v=y(v,e)),H(function(e,t,i,n){var r,o,s,a=[],l=[],c=t.length,u=e||_(p||"*",i.nodeType?[i]:i,[]),d=h&&(e||!p)?x(u,a,h,i,n):u,f=g?v||(e?h:c||m)?[]:t:d;g&&g(d,f,i,n);if(m){r=x(f,l),m(r,[],i,n),o=r.length;while(o--)if(s=r[o])f[l[o]]=!(d[l[o]]=s)}if(e){if(v||h){if(v){r=[],o=f.length;while(o--)(s=f[o])&&r.push(d[o]=s);v(null,f=[],r,n)}o=f.length;while(o--)(s=f[o])&&(r=v?z.call(e,s):a[o])>-1&&(e[r]=!(t[r]=s))}}else f=x(f===t?f.splice(c,f.length):f),v?v(null,t,f,n):N.apply(t,f)})}function h(e){var n,t,i,r=e.length,o=C.relative[e[0].type],s=o||C.relative[" "],a=o?1:0,l=d(function(e){return e===n},s,!0),c=d(function(e){return z.call(n,e)>-1},s,!0),u=[function(e,t,i){return!o&&(i||t!==T)||((n=t).nodeType?l(e,t,i):c(e,t,i))}];for(;a<r;a++)if(t=C.relative[e[a].type])u=[d(f(u),t)];else{t=C.filter[e[a].type].apply(null,e[a].matches);if(t[I]){i=++a;for(;i<r;i++)if(C.relative[e[i].type])break;return y(a>1&&f(u),a>1&&e.slice(0,a-1).join("").replace(J,"$1"),t,a<i&&h(e.slice(a,i)),i<r&&h(e=e.slice(i)),i<r&&e.join(""))}u.push(t)}return f(u)}function s(m,v){var y=v.length>0,_=m.length>0,b=function(e,t,i,n,r){var o,s,a,l=[],c=0,u="0",d=e&&[],f=r!=null,h=T,p=e||_&&C.find.TAG("*",r&&t.parentNode||t),g=E+=h==null?1:Math.E;f&&(T=t!==S&&t,k=b.el);for(;(o=p[u])!=null;u++){if(_&&o){for(s=0;a=m[s];s++)if(a(o,t,i)){n.push(o);break}f&&(E=g,k=++b.el)}y&&((o=!a&&o)&&c--,e&&d.push(o))}c+=u;if(y&&u!==c){for(s=0;a=v[s];s++)a(d,l,t,i);if(e){if(c>0)while(u--)!d[u]&&!l[u]&&(l[u]=A.call(n));l=x(l)}N.apply(n,l),f&&!e&&l.length>0&&c+v.length>1&&w.uniqueSort(n)}return f&&(E=g,T=h),d};return b.el=0,y?H(b):b}function _(e,t,i){var n=0,r=t.length;for(;n<r;n++)w(e,t[n],i);return i}function c(e,t,i,n,r){var o,s,a,l,c,u=p(e),d=u.length;if(!n&&u.length===1){s=u[0]=u[0].slice(0);if(s.length>2&&(a=s[0]).type==="ID"&&t.nodeType===9&&!r&&C.relative[s[1].type]){t=C.find.ID(a.matches[0].replace(ae,""),t,r)[0];if(!t)return i;e=e.slice(s.shift().length)}for(o=le.POS.test(e)?-1:s.length-1;o>=0;o--){a=s[o];if(C.relative[l=a.type])break;if(c=C.find[l])if(n=c(a.matches[0].replace(ae,""),ne.test(s[0].type)&&t.parentNode||t,r)){s.splice(o,1),e=n.length&&s.join("");if(!e)return N.apply(i,R.call(n,0)),i;break}}}return v(e,u)(n,t,r,i,ne.test(e)),i}function o(){}var k,a,C,l,g,m,v,b,L,T,j=!0,M="undefined",I=("sizcache"+Math.random()).replace(".",""),D=String,S=e.document,P=S.documentElement,E=0,O=0,A=[].pop,N=[].push,R=[].slice,z=[].indexOf||function(e){var t=0,i=this.length;for(;t<i;t++)if(this[t]===e)return t;return-1},H=function(e,t){return e[I]=t==null||t,e},F=function(){var i={},n=[];return H(function(e,t){return n.push(e)>C.cacheLength&&delete i[n.shift()],i[e+" "]=t},i)},W=F(),B=F(),G=F(),q="[\\x20\\t\\r\\n\\f]",$="(?:\\\\.|[-\\w]|[^\\x00-\\xa0])+",U=$.replace("w","w#"),V="([*^$|!~]?=)",Y="\\["+q+"*("+$+")"+q+"*(?:"+V+q+"*(?:(['\"])((?:\\\\.|[^\\\\])*?)\\3|("+U+")|)|)"+q+"*\\]",Z=":("+$+")(?:\\((?:(['\"])((?:\\\\.|[^\\\\])*?)\\2|([^()[\\]]*|(?:(?:"+Y+")|[^:]|\\\\.)*|.*))\\)|)",X=":(even|odd|eq|gt|lt|nth|first|last)(?:\\("+q+"*((?:-\\d)?\\d*)"+q+"*\\)|)(?=[^-]|$)",J=new RegExp("^"+q+"+|((?:^|[^\\\\])(?:\\\\.)*)"+q+"+$","g"),Q=new RegExp("^"+q+"*,"+q+"*"),K=new RegExp("^"+q+"*([\\x20\\t\\r\\n\\f>+~])"+q+"*"),ee=new RegExp(Z),te=/^(?:#([\w\-]+)|(\w+)|\.([\w\-]+))$/,ie=/^:not/,ne=/[\x20\t\r\n\f]*[+~]/,re=/:not\($/,oe=/h\d/i,se=/input|select|textarea|button/i,ae=/\\(?!\\)/g,le={ID:new RegExp("^#("+$+")"),CLASS:new RegExp("^\\.("+$+")"),NAME:new RegExp("^\\[name=['\"]?("+$+")['\"]?\\]"),TAG:new RegExp("^("+$.replace("w","w*")+")"),ATTR:new RegExp("^"+Y),PSEUDO:new RegExp("^"+Z),POS:new RegExp(X,"i"),CHILD:new RegExp("^:(only|nth|first|last)-child(?:\\("+q+"*(even|odd|(([+-]|)(\\d*)n|)"+q+"*(?:([+-]|)"+q+"*(\\d+)|))"+q+"*\\)|)","i"),needsContext:new RegExp("^"+q+"*[>+~]|"+X,"i")},ce=function(e){var t=S.createElement("div");try{return e(t)}catch(e){return!1}finally{t=null}},ue=ce(function(e){return e.appendChild(S.createComment("")),!e.getElementsByTagName("*").length}),de=ce(function(e){return e.innerHTML="<a href='#'></a>",e.firstChild&&typeof e.firstChild.getAttribute!==M&&e.firstChild.getAttribute("href")==="#"}),fe=ce(function(e){e.innerHTML="<select></select>";var t=typeof e.lastChild.getAttribute("multiple");return t!=="boolean"&&t!=="string"}),he=ce(function(e){return e.innerHTML="<div class='hidden e'></div><div class='hidden'></div>",!e.getElementsByClassName||!e.getElementsByClassName("e").length?!1:(e.lastChild.className="e",e.getElementsByClassName("e").length===2)}),pe=ce(function(e){e.id=I+0,e.innerHTML="<a name='"+I+"'></a><div name='"+I+"'></div>",P.insertBefore(e,P.firstChild);var t=S.getElementsByName&&S.getElementsByName(I).length===2+S.getElementsByName(I+0).length;return a=!S.getElementById(I),P.removeChild(e),t});try{R.call(P.childNodes,0)[0].nodeType}catch(e){R=function(e){var t,i=[];for(;t=this[e];e++)i.push(t);return i}}w.matches=function(e,t){return w(e,null,null,t)},w.matchesSelector=function(e,t){return w(t,null,null,[e]).length>0},l=w.getText=function(e){var t,i="",n=0,r=e.nodeType;if(r){if(r===1||r===9||r===11){if(typeof e.textContent=="string")return e.textContent;for(e=e.firstChild;e;e=e.nextSibling)i+=l(e)}else if(r===3||r===4)return e.nodeValue}else for(;t=e[n];n++)i+=l(t);return i},g=w.isXML=function(e){var t=e&&(e.ownerDocument||e).documentElement;return t?t.nodeName!=="HTML":!1},m=w.contains=P.contains?function(e,t){var i=e.nodeType===9?e.documentElement:e,n=t&&t.parentNode;return e===n||!!(n&&n.nodeType===1&&i.contains&&i.contains(n))}:P.compareDocumentPosition?function(e,t){return t&&!!(e.compareDocumentPosition(t)&16)}:function(e,t){while(t=t.parentNode)if(t===e)return!0;return!1},w.attr=function(e,t){var i,n=g(e);return n||(t=t.toLowerCase()),(i=C.attrHandle[t])?i(e):n||fe?e.getAttribute(t):(i=e.getAttributeNode(t),i?typeof e[t]=="boolean"?e[t]?t:null:i.specified?i.value:null:null)},C=w.selectors={cacheLength:50,createPseudo:H,match:le,attrHandle:de?{}:{href:function(e){return e.getAttribute("href",2)},type:function(e){return e.getAttribute("type")}},find:{ID:a?function(e,t,i){if(typeof t.getElementById!==M&&!i){var n=t.getElementById(e);return n&&n.parentNode?[n]:[]}}:function(e,t,i){if(typeof t.getElementById!==M&&!i){var n=t.getElementById(e);return n?n.id===e||typeof n.getAttributeNode!==M&&n.getAttributeNode("id").value===e?[n]:r:[]}},TAG:ue?function(e,t){if(typeof t.getElementsByTagName!==M)return t.getElementsByTagName(e)}:function(e,t){var i=t.getElementsByTagName(e);if(e==="*"){var n,r=[],o=0;for(;n=i[o];o++)n.nodeType===1&&r.push(n);return r}return i},NAME:pe&&function(e,t){if(typeof t.getElementsByName!==M)return t.getElementsByName(name)},CLASS:he&&function(e,t,i){if(typeof t.getElementsByClassName!==M&&!i)return t.getElementsByClassName(e)}},relative:{">":{dir:"parentNode",first:!0}," ":{dir:"parentNode"},"+":{dir:"previousSibling",first:!0},"~":{dir:"previousSibling"}},preFilter:{ATTR:function(e){return e[1]=e[1].replace(ae,""),e[3]=(e[4]||e[5]||"").replace(ae,""),e[2]==="~="&&(e[3]=" "+e[3]+" "),e.slice(0,4)},CHILD:function(e){return e[1]=e[1].toLowerCase(),e[1]==="nth"?(e[2]||w.error(e[0]),e[3]=+(e[3]?e[4]+(e[5]||1):2*(e[2]==="even"||e[2]==="odd")),e[4]=+(e[6]+e[7]||e[2]==="odd")):e[2]&&w.error(e[0]),e},PSEUDO:function(e){var t,i;if(le.CHILD.test(e[0]))return null;if(e[3])e[2]=e[3];else if(t=e[4])ee.test(t)&&(i=p(t,!0))&&(i=t.indexOf(")",t.length-i)-t.length)&&(t=t.slice(0,i),e[0]=e[0].slice(0,i)),e[2]=t;return e.slice(0,3)}},filter:{ID:a?function(t){return t=t.replace(ae,""),function(e){return e.getAttribute("id")===t}}:function(i){return i=i.replace(ae,""),function(e){var t=typeof e.getAttributeNode!==M&&e.getAttributeNode("id");return t&&t.value===i}},TAG:function(t){return t==="*"?function(){return!0}:(t=t.replace(ae,"").toLowerCase(),function(e){return e.nodeName&&e.nodeName.toLowerCase()===t})},CLASS:function(e){var t=W[I][e+" "];return t||(t=new RegExp("(^|"+q+")"+e+"("+q+"|$)"))&&W(e,function(e){return t.test(e.className||typeof e.getAttribute!==M&&e.getAttribute("class")||"")})},ATTR:function(n,r,o){return function(e,t){var i=w.attr(e,n);return i==null?r==="!=":r?(i+="",r==="="?i===o:r==="!="?i!==o:r==="^="?o&&i.indexOf(o)===0:r==="*="?o&&i.indexOf(o)>-1:r==="$="?o&&i.substr(i.length-o.length)===o:r==="~="?(" "+i+" ").indexOf(o)>-1:r==="|="?i===o||i.substr(0,o.length+1)===o+"-":!1):!0}},CHILD:function(i,e,r,o){return i==="nth"?function(e){var t,i,n=e.parentNode;if(r===1&&o===0)return!0;if(n){i=0;for(t=n.firstChild;t;t=t.nextSibling)if(t.nodeType===1){i++;if(e===t)break}}return i-=o,i===r||i%r===0&&i/r>=0}:function(e){var t=e;switch(i){case"only":case"first":while(t=t.previousSibling)if(t.nodeType===1)return!1;if(i==="first")return!0;t=e;case"last":while(t=t.nextSibling)if(t.nodeType===1)return!1;return!0}}},PSEUDO:function(e,o){var t,s=C.pseudos[e]||C.setFilters[e.toLowerCase()]||w.error("unsupported pseudo: "+e);return s[I]?s(o):s.length>1?(t=[e,e,"",o],C.setFilters.hasOwnProperty(e.toLowerCase())?H(function(e,t){var i,n=s(e,o),r=n.length;while(r--)i=z.call(e,n[r]),e[i]=!(t[i]=n[r])}):function(e){return s(e,0,t)}):s}},pseudos:{not:H(function(e){var n=[],r=[],a=v(e.replace(J,"$1"));return a[I]?H(function(e,t,i,n){var r,o=a(e,null,n,[]),s=e.length;while(s--)if(r=o[s])e[s]=!(t[s]=r)}):function(e,t,i){return n[0]=e,a(n,null,i,r),!r.pop()}}),has:H(function(t){return function(e){return w(t,e).length>0}}),contains:H(function(t){return function(e){return(e.textContent||e.innerText||l(e)).indexOf(t)>-1}}),enabled:function(e){return e.disabled===!1},disabled:function(e){return e.disabled===!0},checked:function(e){var t=e.nodeName.toLowerCase();return t==="input"&&!!e.checked||t==="option"&&!!e.selected},selected:function(e){return e.parentNode&&e.parentNode.selectedIndex,e.selected===!0},parent:function(e){return!C.pseudos.empty(e)},empty:function(e){var t;e=e.firstChild;while(e){if(e.nodeName>"@"||(t=e.nodeType)===3||t===4)return!1;e=e.nextSibling}return!0},header:function(e){return oe.test(e.nodeName)},text:function(e){var t,i;return e.nodeName.toLowerCase()==="input"&&(t=e.type)==="text"&&((i=e.getAttribute("type"))==null||i.toLowerCase()===t)},radio:t("radio"),checkbox:t("checkbox"),file:t("file"),password:t("password"),image:t("image"),submit:i("submit"),reset:i("reset"),button:function(e){var t=e.nodeName.toLowerCase();return t==="input"&&e.type==="button"||t==="button"},input:function(e){return se.test(e.nodeName)},focus:function(e){var t=e.ownerDocument;return e===t.activeElement&&(!t.hasFocus||t.hasFocus())&&!!(e.type||e.href||~e.tabIndex)},active:function(e){return e===e.ownerDocument.activeElement},first:n(function(){return[0]}),last:n(function(e,t){return[t-1]}),eq:n(function(e,t,i){return[i<0?i+t:i]}),even:n(function(e,t){for(var i=0;i<t;i+=2)e.push(i);return e}),odd:n(function(e,t){for(var i=1;i<t;i+=2)e.push(i);return e}),lt:n(function(e,t,i){for(var n=i<0?i+t:i;--n>=0;)e.push(n);return e}),gt:n(function(e,t,i){for(var n=i<0?i+t:i;++n<t;)e.push(n);return e})}},b=P.compareDocumentPosition?function(e,t){return e===t?(L=!0,0):(!e.compareDocumentPosition||!t.compareDocumentPosition?e.compareDocumentPosition:e.compareDocumentPosition(t)&4)?-1:1}:function(e,t){if(e===t)return L=!0,0;if(e.sourceIndex&&t.sourceIndex)return e.sourceIndex-t.sourceIndex;var i,n,r=[],o=[],s=e.parentNode,a=t.parentNode,l=s;if(s===a)return u(e,t);if(!s)return-1;if(!a)return 1;while(l)r.unshift(l),l=l.parentNode;l=a;while(l)o.unshift(l),l=l.parentNode;i=r.length,n=o.length;for(var c=0;c<i&&c<n;c++)if(r[c]!==o[c])return u(r[c],o[c]);return c===i?u(e,o[c],-1):u(r[c],t,1)},[0,0].sort(b),j=!L,w.uniqueSort=function(e){var t,i=[],n=1,r=0;L=j,e.sort(b);if(L){for(;t=e[n];n++)t===e[n-1]&&(r=i.push(n));while(r--)e.splice(i[r],1)}return e},w.error=function(e){throw new Error("Syntax error, unrecognized expression: "+e)},v=w.compile=function(e,t){var i,n=[],r=[],o=G[I][e+" "];if(!o){t||(t=p(e)),i=t.length;while(i--)o=h(t[i]),o[I]?n.push(o):r.push(o);o=G(e,s(r,n))}return o},S.querySelectorAll&&function(){var n,d=c,f=/'|\\/g,r=/\=[\x20\t\r\n\f]*([^'"\]]*)[\x20\t\r\n\f]*\]/g,h=[":focus"],o=[":active"],s=P.matchesSelector||P.mozMatchesSelector||P.webkitMatchesSelector||P.oMatchesSelector||P.msMatchesSelector;ce(function(e){e.innerHTML="<select><option selected=''></option></select>",e.querySelectorAll("[selected]").length||h.push("\\["+q+"*(?:checked|disabled|ismap|multiple|readonly|selected|value)"),e.querySelectorAll(":checked").length||h.push(":checked")}),ce(function(e){e.innerHTML="<p test=''></p>",e.querySelectorAll("[test^='']").length&&h.push("[*^$]="+q+"*(?:\"\"|'')"),e.innerHTML="<input type='hidden'/>",e.querySelectorAll(":enabled").length||h.push(":enabled",":disabled")}),h=new RegExp(h.join("|")),c=function(e,t,i,n,r){if(!n&&!r&&!h.test(e)){var o,s,a=!0,l=I,c=t,u=t.nodeType===9&&e;if(t.nodeType===1&&t.nodeName.toLowerCase()!=="object"){o=p(e),(a=t.getAttribute("id"))?l=a.replace(f,"\\$&"):t.setAttribute("id",l),l="[id='"+l+"'] ",s=o.length;while(s--)o[s]=l+o[s].join("");c=ne.test(e)&&t.parentNode||t,u=o.join(",")}if(u)try{return N.apply(i,R.call(c.querySelectorAll(u),0)),i}catch(e){}finally{a||t.removeAttribute("id")}}return d(e,t,i,n,r)},s&&(ce(function(e){n=s.call(e,"div");try{s.call(e,"[test!='']:sizzle"),o.push("!=",Z)}catch(e){}}),o=new RegExp(o.join("|")),w.matchesSelector=function(e,t){t=t.replace(r,"='$1']");if(!g(e)&&!o.test(t)&&!h.test(t))try{var i=s.call(e,t);if(i||n||e.document&&e.document.nodeType!==11)return i}catch(e){}return w(t,null,null,[e]).length>0})}(),C.pseudos.nth=C.pseudos.eq,C.filters=o.prototype=C.pseudos,C.setFilters=new o,w.attr=ge.attr,ge.find=w,ge.expr=w.selectors,ge.expr[":"]=ge.expr.pseudos,ge.unique=w.uniqueSort,ge.text=w.getText,ge.isXMLDoc=w.isXML,ge.contains=w.contains}(v);var Oe=/Until$/,Ae=/^(?:parents|prev(?:Until|All))/,Ne=/^.[^:#\[\.,]*$/,Re=ge.expr.match.needsContext,ze={children:!0,contents:!0,next:!0,prev:!0};ge.fn.extend({find:function(e){var t,i,n,r,o,s,a=this;if(typeof e!="string")return ge(e).filter(function(){for(t=0,i=a.length;t<i;t++)if(ge.contains(a[t],this))return!0});s=this.pushStack("","find",e);for(t=0,i=this.length;t<i;t++){n=s.length,ge.find(e,this[t],s);if(t>0)for(r=n;r<s.length;r++)for(o=0;o<n;o++)if(s[o]===s[r]){s.splice(r--,1);break}}return s},has:function(e){var t,i=ge(e,this),n=i.length;return this.filter(function(){for(t=0;t<n;t++)if(ge.contains(this,i[t]))return!0})},not:function(e){return this.pushStack(n(this,e,!1),"not",e)},filter:function(e){return this.pushStack(n(this,e,!0),"filter",e)},is:function(e){return!!e&&(typeof e=="string"?Re.test(e)?ge(e,this.context).index(this[0])>=0:ge.filter(e,this).length>0:this.filter(e).length>0)},closest:function(e,t){var i,n=0,r=this.length,o=[],s=Re.test(e)||typeof e!="string"?ge(e,t||this.context):0;for(;n<r;n++){i=this[n];while(i&&i.ownerDocument&&i!==t&&i.nodeType!==11){if(s?s.index(i)>-1:ge.find.matchesSelector(i,e)){o.push(i);break}i=i.parentNode}}return o=o.length>1?ge.unique(o):o,this.pushStack(o,"closest",e)},index:function(e){return e?typeof e=="string"?ge.inArray(this[0],ge(e)):ge.inArray(e.jquery?e[0]:e,this):this[0]&&this[0].parentNode?this.prevAll().length:-1},add:function(e,t){var i=typeof e=="string"?ge(e,t):ge.makeArray(e&&e.nodeType?[e]:e),n=ge.merge(this.get(),i);return this.pushStack(r(i[0])||r(n[0])?n:ge.unique(n))},addBack:function(e){return this.add(e==null?this.prevObject:this.prevObject.filter(e))}}),ge.fn.andSelf=ge.fn.addBack,ge.each({parent:function(e){var t=e.parentNode;return t&&t.nodeType!==11?t:null},parents:function(e){return ge.dir(e,"parentNode")},parentsUntil:function(e,t,i){return ge.dir(e,"parentNode",i)},next:function(e){return t(e,"nextSibling")},prev:function(e){return t(e,"previousSibling")},nextAll:function(e){return ge.dir(e,"nextSibling")},prevAll:function(e){return ge.dir(e,"previousSibling")},nextUntil:function(e,t,i){return ge.dir(e,"nextSibling",i)},prevUntil:function(e,t,i){return ge.dir(e,"previousSibling",i)},siblings:function(e){return ge.sibling((e.parentNode||{}).firstChild,e)},children:function(e){return ge.sibling(e.firstChild)},contents:function(e){return ge.nodeName(e,"iframe")?e.contentDocument||e.contentWindow.document:ge.merge([],e.childNodes)}},function(n,r){ge.fn[n]=function(e,t){var i=ge.map(this,r,e);return Oe.test(n)||(t=e),t&&typeof t=="string"&&(i=ge.filter(t,i)),i=this.length>1&&!ze[n]?ge.unique(i):i,this.length>1&&Ae.test(n)&&(i=i.reverse()),this.pushStack(i,n,V.call(arguments).join(","))}}),ge.extend({filter:function(e,t,i){return i&&(e=":not("+e+")"),t.length===1?ge.find.matchesSelector(t[0],e)?[t[0]]:[]:ge.find.matches(e,t)},dir:function(e,t,i){var n=[],r=e[t];while(r&&r.nodeType!==9&&(i===C||r.nodeType!==1||!ge(r).is(i)))r.nodeType===1&&n.push(r),r=r[t];return n},sibling:function(e,t){var i=[];for(;e;e=e.nextSibling)e.nodeType===1&&e!==t&&i.push(e);return i}});var He="abbr|article|aside|audio|bdi|canvas|data|datalist|details|figcaption|figure|footer|header|hgroup|mark|meter|nav|output|progress|section|summary|time|video",Fe=/ jQuery\d+="(?:null|\d+)"/g,We=/^\s+/,Be=/<(?!area|br|col|embed|hr|img|input|link|meta|param)(([\w:]+)[^>]*)\/>/gi,Ge=/<([\w:]+)/,qe=/<tbody/i,$e=/<|&#?\w+;/,Ue=/<(?:script|style|link)/i,Ve=/<(?:script|object|embed|option|style)/i,Ye=new RegExp("<(?:"+He+")[\\s/>]","i"),Ze=/^(?:checkbox|radio)$/,Xe=/checked\s*(?:[^=]|=\s*.checked.)/i,Je=/\/(java|ecma)script/i,Qe=/^\s*<!(?:\[CDATA\[|\-\-)|[\]\-]{2}>\s*$/g,Ke={option:[1,"<select multiple='multiple'>","</select>"],legend:[1,"<fieldset>","</fieldset>"],thead:[1,"<table>","</table>"],tr:[2,"<table><tbody>","</tbody></table>"],td:[3,"<table><tbody><tr>","</tr></tbody></table>"],col:[2,"<table><tbody></tbody><colgroup>","</colgroup></table>"],area:[1,"<map>","</map>"],_default:[0,"",""]},et=y(W),tt=et.appendChild(W.createElement("div"));Ke.optgroup=Ke.option,Ke.tbody=Ke.tfoot=Ke.colgroup=Ke.caption=Ke.thead,Ke.th=Ke.td,ge.support.htmlSerialize||(Ke._default=[1,"X<div>","</div>"]),ge.fn.extend({text:function(e){return ge.access(this,function(e){return e===C?ge.text(this):this.empty().append((this[0]&&this[0].ownerDocument||W).createTextNode(e))},null,e,arguments.length)},wrapAll:function(t){if(ge.isFunction(t))return this.each(function(e){ge(this).wrapAll(t.call(this,e))});if(this[0]){var e=ge(t,this[0].ownerDocument).eq(0).clone(!0);this[0].parentNode&&e.insertBefore(this[0]),e.map(function(){var e=this;while(e.firstChild&&e.firstChild.nodeType===1)e=e.firstChild;return e}).append(this)}return this},wrapInner:function(i){return ge.isFunction(i)?this.each(function(e){ge(this).wrapInner(i.call(this,e))}):this.each(function(){var e=ge(this),t=e.contents();t.length?t.wrapAll(i):e.append(i)})},wrap:function(t){var i=ge.isFunction(t);return this.each(function(e){ge(this).wrapAll(i?t.call(this,e):t)})},unwrap:function(){return this.parent().each(function(){ge.nodeName(this,"body")||ge(this).replaceWith(this.childNodes)}).end()},append:function(){return this.domManip(arguments,!0,function(e){(this.nodeType===1||this.nodeType===11)&&this.appendChild(e)})},prepend:function(){return this.domManip(arguments,!0,function(e){(this.nodeType===1||this.nodeType===11)&&this.insertBefore(e,this.firstChild)})},before:function(){if(!r(this[0]))return this.domManip(arguments,!1,function(e){this.parentNode.insertBefore(e,this)});if(arguments.length){var e=ge.clean(arguments);return this.pushStack(ge.merge(e,this),"before",this.selector)}},after:function(){if(!r(this[0]))return this.domManip(arguments,!1,function(e){this.parentNode.insertBefore(e,this.nextSibling)});if(arguments.length){var e=ge.clean(arguments);return this.pushStack(ge.merge(this,e),"after",this.selector)}},remove:function(e,t){var i,n=0;for(;(i=this[n])!=null;n++)if(!e||ge.filter(e,[i]).length)!t&&i.nodeType===1&&(ge.cleanData(i.getElementsByTagName("*")),ge.cleanData([i])),i.parentNode&&i.parentNode.removeChild(i);return this},empty:function(){var e,t=0;for(;(e=this[t])!=null;t++){e.nodeType===1&&ge.cleanData(e.getElementsByTagName("*"));while(e.firstChild)e.removeChild(e.firstChild)}return this},clone:function(e,t){return e=e==null?!1:e,t=t==null?e:t,this.map(function(){return ge.clone(this,e,t)})},html:function(e){return ge.access(this,function(e){var t=this[0]||{},i=0,n=this.length;if(e===C)return t.nodeType===1?t.innerHTML.replace(Fe,""):C;if(typeof e=="string"&&!Ue.test(e)&&(ge.support.htmlSerialize||!Ye.test(e))&&(ge.support.leadingWhitespace||!We.test(e))&&!Ke[(Ge.exec(e)||["",""])[1].toLowerCase()]){e=e.replace(Be,"<$1></$2>");try{for(;i<n;i++)t=this[i]||{},t.nodeType===1&&(ge.cleanData(t.getElementsByTagName("*")),t.innerHTML=e);t=0}catch(e){}}t&&this.empty().append(e)},null,e,arguments.length)},replaceWith:function(n){return r(this[0])?this.length?this.pushStack(ge(ge.isFunction(n)?n():n),"replaceWith",n):this:ge.isFunction(n)?this.each(function(e){var t=ge(this),i=t.html();t.replaceWith(n.call(this,e,i))}):(typeof n!="string"&&(n=ge(n).detach()),this.each(function(){var e=this.nextSibling,t=this.parentNode;ge(this).remove(),e?ge(e).before(n):ge(t).append(n)}))},detach:function(e){return this.remove(e,!0)},domManip:function(i,n,r){i=[].concat.apply([],i);var e,t,o,s,a=0,l=i[0],c=[],u=this.length;if(!ge.support.checkClone&&u>1&&typeof l=="string"&&Xe.test(l))return this.each(function(){ge(this).domManip(i,n,r)});if(ge.isFunction(l))return this.each(function(e){var t=ge(this);i[0]=l.call(this,e,n?t.html():C),t.domManip(i,n,r)});if(this[0]){e=ge.buildFragment(i,this,c),o=e.fragment,t=o.firstChild,o.childNodes.length===1&&(o=t);if(t){n=n&&ge.nodeName(t,"tr");for(s=e.cacheable||u-1;a<u;a++)r.call(n&&ge.nodeName(this[a],"table")?d(this[a],"tbody"):this[a],a===s?o:ge.clone(o,!0,!0))}o=t=null,c.length&&ge.each(c,function(e,t){t.src?ge.ajax?ge.ajax({url:t.src,type:"GET",dataType:"script",async:!1,global:!1,throws:!0}):ge.error("no ajax"):ge.globalEval((t.text||t.textContent||t.innerHTML||"").replace(Qe,"")),t.parentNode&&t.parentNode.removeChild(t)})}return this}}),ge.buildFragment=function(e,t,i){var n,r,o,s=e[0];return t=t||W,t=!t.nodeType&&t[0]||t,t=t.ownerDocument||t,e.length===1&&typeof s=="string"&&s.length<512&&t===W&&s.charAt(0)==="<"&&!Ve.test(s)&&(ge.support.checkClone||!Xe.test(s))&&(ge.support.html5Clone||!Ye.test(s))&&(r=!0,n=ge.fragments[s],o=n!==C),n||(n=t.createDocumentFragment(),ge.clean(e,t,n,i),r&&(ge.fragments[s]=o&&n)),{fragment:n,cacheable:r}},ge.fragments={},ge.each({appendTo:"append",prependTo:"prepend",insertBefore:"before",insertAfter:"after",replaceAll:"replaceWith"},function(a,l){ge.fn[a]=function(e){var t,i=0,n=[],r=ge(e),o=r.length,s=this.length===1&&this[0].parentNode;if((s==null||s&&s.nodeType===11&&s.childNodes.length===1)&&o===1)return r[l](this[0]),this;for(;i<o;i++)t=(i>0?this.clone(!0):this).get(),ge(r[i])[l](t),n=n.concat(t);return this.pushStack(n,a,r.selector)}}),ge.extend({clone:function(e,t,i){var n,r,o,s;ge.support.html5Clone||ge.isXMLDoc(e)||!Ye.test("<"+e.nodeName+">")?s=e.cloneNode(!0):(tt.innerHTML=e.outerHTML,tt.removeChild(s=tt.firstChild));if((!ge.support.noCloneEvent||!ge.support.noCloneChecked)&&(e.nodeType===1||e.nodeType===11)&&!ge.isXMLDoc(e)){f(e,s),n=h(e),r=h(s);for(o=0;n[o];++o)r[o]&&f(n[o],r[o])}if(t){l(e,s);if(i){n=h(e),r=h(s);for(o=0;n[o];++o)l(n[o],r[o])}}return n=r=null,s},clean:function(e,t,i,n){var r,o,s,a,l,c,u,d,f,h,p,g,m=t===W&&et,v=[];if(!t||typeof t.createDocumentFragment=="undefined")t=W;for(r=0;(s=e[r])!=null;r++){typeof s=="number"&&(s+="");if(!s)continue;if(typeof s=="string")if(!$e.test(s))s=t.createTextNode(s);else{m=m||y(t),u=t.createElement("div"),m.appendChild(u),s=s.replace(Be,"<$1></$2>"),a=(Ge.exec(s)||["",""])[1].toLowerCase(),l=Ke[a]||Ke._default,c=l[0],u.innerHTML=l[1]+s+l[2];while(c--)u=u.lastChild;if(!ge.support.tbody){d=qe.test(s),f=a==="table"&&!d?u.firstChild&&u.firstChild.childNodes:l[1]==="<table>"&&!d?u.childNodes:[];for(o=f.length-1;o>=0;--o)ge.nodeName(f[o],"tbody")&&!f[o].childNodes.length&&f[o].parentNode.removeChild(f[o])}!ge.support.leadingWhitespace&&We.test(s)&&u.insertBefore(t.createTextNode(We.exec(s)[0]),u.firstChild),s=u.childNodes,u.parentNode.removeChild(u)}s.nodeType?v.push(s):ge.merge(v,s)}u&&(s=u=m=null);if(!ge.support.appendChecked)for(r=0;(s=v[r])!=null;r++)ge.nodeName(s,"input")?_(s):typeof s.getElementsByTagName!="undefined"&&ge.grep(s.getElementsByTagName("input"),_);if(i){p=function(e){if(!e.type||Je.test(e.type))return n?n.push(e.parentNode?e.parentNode.removeChild(e):e):i.appendChild(e)};for(r=0;(s=v[r])!=null;r++)if(!ge.nodeName(s,"script")||!p(s))i.appendChild(s),typeof s.getElementsByTagName!="undefined"&&(g=ge.grep(ge.merge([],s.getElementsByTagName("script")),p),v.splice.apply(v,[r+1,0].concat(g)),r+=g.length)}return v},cleanData:function(e,t){var i,n,r,o,s=0,a=ge.expando,l=ge.cache,c=ge.support.deleteExpando,u=ge.event.special;for(;(r=e[s])!=null;s++)if(t||ge.acceptData(r)){n=r[a],i=n&&l[n];if(i){if(i.events)for(o in i.events)u[o]?ge.event.remove(r,o):ge.removeEvent(r,o,i.handle);l[n]&&(delete l[n],c?delete r[a]:r.removeAttribute?r.removeAttribute(a):r[a]=null,ge.deletedIds.push(n))}}}}),function(){var e,t;ge.uaMatch=function(e){e=e.toLowerCase();var t=/(chrome)[ \/]([\w.]+)/.exec(e)||/(webkit)[ \/]([\w.]+)/.exec(e)||/(opera)(?:.*version|)[ \/]([\w.]+)/.exec(e)||/(msie) ([\w.]+)/.exec(e)||e.indexOf("compatible")<0&&/(mozilla)(?:.*? rv:([\w.]+)|)/.exec(e)||[];return{browser:t[1]||"",version:t[2]||"0"}},e=ge.uaMatch(G.userAgent),t={},e.browser&&(t[e.browser]=!0,t.version=e.version),t.chrome?t.webkit=!0:t.webkit&&(t.safari=!0),ge.browser=t,ge.sub=function(){function i(e,t){return new i.fn.init(e,t)}ge.extend(!0,i,this),i.superclass=this,i.fn=i.prototype=this(),i.fn.constructor=i,i.sub=this.sub,i.fn.init=function(e,t){return t&&t instanceof ge&&!(t instanceof i)&&(t=i(t)),ge.fn.init.call(this,e,t,n)},i.fn.init.prototype=i.fn;var n=i(W);return i}}();var it,nt,rt,ot=/alpha\([^)]*\)/i,st=/opacity=([^)]*)/,at=/^(top|right|bottom|left)$/,lt=/^(none|table(?!-c[ea]).+)/,ct=/^margin/,ut=new RegExp("^("+Q+")(.*)$","i"),dt=new RegExp("^("+Q+")(?!px)[a-z%]+$","i"),ft=new RegExp("^([-+])=("+Q+")","i"),ht={BODY:"block"},pt={position:"absolute",visibility:"hidden",display:"block"},gt={letterSpacing:0,fontWeight:400},mt=["Top","Right","Bottom","Left"],vt=["Webkit","O","Moz","ms"],yt=ge.fn.toggle;ge.fn.extend({css:function(e,t){return ge.access(this,function(e,t,i){return i!==C?ge.style(e,t,i):ge.css(e,t)},e,t,arguments.length>1)},show:function(){return o(this,!0)},hide:function(){return o(this)},toggle:function(e,t){var i=typeof e=="boolean";return ge.isFunction(e)&&ge.isFunction(t)?yt.apply(this,arguments):this.each(function(){(i?e:b(this))?ge(this).show():ge(this).hide()})}}),ge.extend({cssHooks:{opacity:{get:function(e,t){if(t){var i=it(e,"opacity");return i===""?"1":i}}}},cssNumber:{fillOpacity:!0,fontWeight:!0,lineHeight:!0,opacity:!0,orphans:!0,widows:!0,zIndex:!0,zoom:!0},cssProps:{float:ge.support.cssFloat?"cssFloat":"styleFloat"},style:function(e,t,i,n){if(!e||e.nodeType===3||e.nodeType===8||!e.style)return;var r,o,s,a=ge.camelCase(t),l=e.style;t=ge.cssProps[a]||(ge.cssProps[a]=p(l,a)),s=ge.cssHooks[t]||ge.cssHooks[a];if(i===C)return s&&"get"in s&&(r=s.get(e,!1,n))!==C?r:l[t];o=typeof i,o==="string"&&(r=ft.exec(i))&&(i=(r[1]+1)*r[2]+parseFloat(ge.css(e,t)),o="number");if(i==null||o==="number"&&isNaN(i))return;o==="number"&&!ge.cssNumber[a]&&(i+="px");if(!s||!("set"in s)||(i=s.set(e,i,n))!==C)try{l[t]=i}catch(e){}},css:function(e,t,i,n){var r,o,s,a=ge.camelCase(t);return t=ge.cssProps[a]||(ge.cssProps[a]=p(e.style,a)),s=ge.cssHooks[t]||ge.cssHooks[a],s&&"get"in s&&(r=s.get(e,!0,n)),r===C&&(r=it(e,t)),r==="normal"&&t in gt&&(r=gt[t]),i||n!==C?(o=parseFloat(r),i||ge.isNumeric(o)?o||0:r):r},swap:function(e,t,i){var n,r,o={};for(r in t)o[r]=e.style[r],e.style[r]=t[r];n=i.call(e);for(r in t)e.style[r]=o[r];return n}}),v.getComputedStyle?it=function(e,t){var i,n,r,o,s=v.getComputedStyle(e,null),a=e.style;return s&&(i=s.getPropertyValue(t)||s[t],i===""&&!ge.contains(e.ownerDocument,e)&&(i=ge.style(e,t)),dt.test(i)&&ct.test(t)&&(n=a.width,r=a.minWidth,o=a.maxWidth,a.minWidth=a.maxWidth=a.width=i,i=s.width,a.width=n,a.minWidth=r,a.maxWidth=o)),i}:W.documentElement.currentStyle&&(it=function(e,t){var i,n,r=e.currentStyle&&e.currentStyle[t],o=e.style;return r==null&&o&&o[t]&&(r=o[t]),dt.test(r)&&!at.test(t)&&(i=o.left,n=e.runtimeStyle&&e.runtimeStyle.left,n&&(e.runtimeStyle.left=e.currentStyle.left),o.left=t==="fontSize"?"1em":r,r=o.pixelLeft+"px",o.left=i,n&&(e.runtimeStyle.left=n)),r===""?"auto":r}),ge.each(["height","width"],function(e,n){ge.cssHooks[n]={get:function(e,t,i){if(t)return e.offsetWidth===0&&lt.test(it(e,"display"))?ge.swap(e,pt,function(){return m(e,n,i)}):m(e,n,i)},set:function(e,t,i){return s(e,t,i?g(e,n,i,ge.support.boxSizing&&ge.css(e,"boxSizing")==="border-box"):0)}}}),ge.support.opacity||(ge.cssHooks.opacity={get:function(e,t){return st.test((t&&e.currentStyle?e.currentStyle.filter:e.style.filter)||"")?.01*parseFloat(RegExp.$1)+"":t?"1":""},set:function(e,t){var i=e.style,n=e.currentStyle,r=ge.isNumeric(t)?"alpha(opacity="+t*100+")":"",o=n&&n.filter||i.filter||"";i.zoom=1;if(t>=1&&ge.trim(o.replace(ot,""))===""&&i.removeAttribute){i.removeAttribute("filter");if(n&&!n.filter)return}i.filter=ot.test(o)?o.replace(ot,r):o+" "+r}}),ge(function(){ge.support.reliableMarginRight||(ge.cssHooks.marginRight={get:function(e,t){return ge.swap(e,{display:"inline-block"},function(){if(t)return it(e,"marginRight")})}}),!ge.support.pixelPosition&&ge.fn.position&&ge.each(["top","left"],function(e,n){ge.cssHooks[n]={get:function(e,t){if(t){var i=it(e,n);return dt.test(i)?ge(e).position()[n]+"px":i}}}})}),ge.expr&&ge.expr.filters&&(ge.expr.filters.hidden=function(e){return e.offsetWidth===0&&e.offsetHeight===0||!ge.support.reliableHiddenOffsets&&(e.style&&e.style.display||it(e,"display"))==="none"},ge.expr.filters.visible=function(e){return!ge.expr.filters.hidden(e)}),ge.each({margin:"",padding:"",border:"Width"},function(r,o){ge.cssHooks[r+o]={expand:function(e){var t,i=typeof e=="string"?e.split(" "):[e],n={};for(t=0;t<4;t++)n[r+mt[t]+o]=i[t]||i[t-2]||i[0];return n}},ct.test(r)||(ge.cssHooks[r+o].set=s)});var _t=/%20/g,bt=/\[\]$/,wt=/\r?\n/g,xt=/^(?:color|date|datetime|datetime-local|email|hidden|month|number|password|range|search|tel|text|time|url|week)$/i,kt=/^(?:select|textarea)/i;ge.fn.extend({serialize:function(){return ge.param(this.serializeArray())},serializeArray:function(){return this.map(function(){return this.elements?ge.makeArray(this.elements):this}).filter(function(){return this.name&&!this.disabled&&(this.checked||kt.test(this.nodeName)||xt.test(this.type))}).map(function(e,i){var t=ge(this).val();return t==null?null:ge.isArray(t)?ge.map(t,function(e,t){return{name:i.name,value:e.replace(wt,"\r\n")}}):{name:i.name,value:t.replace(wt,"\r\n")}}).get()}}),ge.param=function(e,t){var i,n=[],r=function(e,t){t=ge.isFunction(t)?t():t==null?"":t,n[n.length]=encodeURIComponent(e)+"="+encodeURIComponent(t)};t===C&&(t=ge.ajaxSettings&&ge.ajaxSettings.traditional);if(ge.isArray(e)||e.jquery&&!ge.isPlainObject(e))ge.each(e,function(){r(this.name,this.value)});else for(i in e)x(i,e[i],t,r);return n.join("&").replace(_t,"+")};var Ct,Lt,Tt=/#.*$/,jt=/^(.*?):[ \t]*([^\r\n]*)\r?$/gm,Mt=/^(?:about|app|app\-storage|.+\-extension|file|res|widget):$/,It=/^(?:GET|HEAD)$/,Dt=/^\/\//,St=/\?/,Pt=/<script\b[^<]*(?:(?!<\/script>)<[^<]*)*<\/script>/gi,Et=/([?&])_=[^&]*/,Ot=/^([\w\+\.\-]+:)(?:\/\/([^\/?#:]*)(?::(\d+)|)|)/,At=ge.fn.load,Nt={},Rt={},zt=["*/"]+["*"];try{Lt=B.href}catch(e){Lt=W.createElement("a"),Lt.href="",Lt=Lt.href}Ct=Ot.exec(Lt.toLowerCase())||[],ge.fn.load=function(e,t,i){if(typeof e!="string"&&At)return At.apply(this,arguments);if(!this.length)return this;var n,r,o,s=this,a=e.indexOf(" ");return a>=0&&(n=e.slice(a,e.length),e=e.slice(0,a)),ge.isFunction(t)?(i=t,t=C):t&&typeof t=="object"&&(r="POST"),ge.ajax({url:e,type:r,dataType:"html",data:t,complete:function(e,t){i&&s.each(i,o||[e.responseText,t,e])}}).done(function(e){o=arguments,s.html(n?ge("<div>").append(e.replace(Pt,"")).find(n):e)}),this},ge.each("ajaxStart ajaxStop ajaxComplete ajaxError ajaxSuccess ajaxSend".split(" "),function(e,t){ge.fn[t]=function(e){return this.on(t,e)}}),ge.each(["get","post"],function(e,r){ge[r]=function(e,t,i,n){return ge.isFunction(t)&&(n=n||i,i=t,t=C),ge.ajax({type:r,url:e,data:t,success:i,dataType:n})}}),ge.extend({getScript:function(e,t){return ge.get(e,C,t,"script")},getJSON:function(e,t,i){return ge.get(e,t,i,"json")},ajaxSetup:function(e,t){return t?T(e,ge.ajaxSettings):(t=e,e=ge.ajaxSettings),T(e,t),e},ajaxSettings:{url:Lt,isLocal:Mt.test(Ct[1]),global:!0,type:"GET",contentType:"application/x-www-form-urlencoded; charset=UTF-8",processData:!0,async:!0,accepts:{xml:"application/xml, text/xml",html:"text/html",text:"text/plain",json:"application/json, text/javascript","*":zt},contents:{xml:/xml/,html:/html/,json:/json/},responseFields:{xml:"responseXML",text:"responseText"},converters:{"* text":v.String,"text html":!0,"text json":ge.parseJSON,"text xml":ge.parseXML},flatOptions:{context:!0,url:!0}},ajaxPrefilter:k(Nt),ajaxTransport:k(Rt),ajax:function(e,t){function i(e,t,i,n){var r,o,s,a,l,c=t;if(w===2)return;w=2,h&&clearTimeout(h),f=C,d=n||"",x.readyState=e>0?4:0,i&&(a=j(g,x,i));if(e>=200&&e<300||e===304)g.ifModified&&(l=x.getResponseHeader("Last-Modified"),l&&(ge.lastModified[u]=l),l=x.getResponseHeader("Etag"),l&&(ge.etag[u]=l)),e===304?(c="notmodified",r=!0):(r=M(g,a),c=r.state,o=r.data,s=r.error,r=!s);else{s=c;if(!c||e)c="error",e<0&&(e=0)}x.status=e,x.statusText=(t||c)+"",r?y.resolveWith(m,[o,c,x]):y.rejectWith(m,[x,c,s]),x.statusCode(b),b=C,p&&v.trigger("ajax"+(r?"Success":"Error"),[x,g,r?o:s]),_.fireWith(m,[x,c]),p&&(v.trigger("ajaxComplete",[x,g]),--ge.active||ge.event.trigger("ajaxStop"))}typeof e=="object"&&(t=e,e=C),t=t||{};var u,d,n,f,h,r,p,o,g=ge.ajaxSetup({},t),m=g.context||g,v=m!==g&&(m.nodeType||m instanceof ge)?ge(m):ge.event,y=ge.Deferred(),_=ge.Callbacks("once memory"),b=g.statusCode||{},s={},a={},w=0,l="canceled",x={readyState:0,setRequestHeader:function(e,t){if(!w){var i=e.toLowerCase();e=a[i]=a[i]||e,s[e]=t}return this},getAllResponseHeaders:function(){return w===2?d:null},getResponseHeader:function(e){var t;if(w===2){if(!n){n={};while(t=jt.exec(d))n[t[1].toLowerCase()]=t[2]}t=n[e.toLowerCase()]}return t===C?null:t},overrideMimeType:function(e){return w||(g.mimeType=e),this},abort:function(e){return e=e||l,f&&f.abort(e),i(0,e),this}};y.promise(x),x.success=x.done,x.error=x.fail,x.complete=_.add,x.statusCode=function(e){if(e){var t;if(w<2)for(t in e)b[t]=[b[t],e[t]];else t=e[x.status],x.always(t)}return this},g.url=((e||g.url)+"").replace(Tt,"").replace(Dt,Ct[1]+"//"),g.dataTypes=ge.trim(g.dataType||"*").toLowerCase().split(ee),g.crossDomain==null&&(r=Ot.exec(g.url.toLowerCase()),g.crossDomain=!(!r||r[1]===Ct[1]&&r[2]===Ct[2]&&(r[3]||(r[1]==="http:"?80:443))==(Ct[3]||(Ct[1]==="http:"?80:443)))),g.data&&g.processData&&typeof g.data!="string"&&(g.data=ge.param(g.data,g.traditional)),L(Nt,g,t,x);if(w===2)return x;p=g.global,g.type=g.type.toUpperCase(),g.hasContent=!It.test(g.type),p&&ge.active++===0&&ge.event.trigger("ajaxStart");if(!g.hasContent){g.data&&(g.url+=(St.test(g.url)?"&":"?")+g.data,delete g.data),u=g.url;if(g.cache===!1){var c=ge.now(),k=g.url.replace(Et,"$1_="+c);g.url=k+(k===g.url?(St.test(g.url)?"&":"?")+"_="+c:"")}}(g.data&&g.hasContent&&g.contentType!==!1||t.contentType)&&x.setRequestHeader("Content-Type",g.contentType),g.ifModified&&(u=u||g.url,ge.lastModified[u]&&x.setRequestHeader("If-Modified-Since",ge.lastModified[u]),ge.etag[u]&&x.setRequestHeader("If-None-Match",ge.etag[u])),x.setRequestHeader("Accept",g.dataTypes[0]&&g.accepts[g.dataTypes[0]]?g.accepts[g.dataTypes[0]]+(g.dataTypes[0]!=="*"?", "+zt+"; q=0.01":""):g.accepts["*"]);for(o in g.headers)x.setRequestHeader(o,g.headers[o]);if(!g.beforeSend||g.beforeSend.call(m,x,g)!==!1&&w!==2){l="abort";for(o in{success:1,error:1,complete:1})x[o](g[o]);f=L(Rt,g,t,x);if(!f)i(-1,"No Transport");else{x.readyState=1,p&&v.trigger("ajaxSend",[x,g]),g.async&&g.timeout>0&&(h=setTimeout(function(){x.abort("timeout")},g.timeout));try{w=1,f.send(s,i)}catch(e){if(!(w<2))throw e;i(-1,e)}}return x}return x.abort()},active:0,lastModified:{},etag:{}});var Ht=[],Ft=/\?/,Wt=/(=)\?(?=&|$)|\?\?/,Bt=ge.now();ge.ajaxSetup({jsonp:"callback",jsonpCallback:function(){var e=Ht.pop()||ge.expando+"_"+Bt++;return this[e]=!0,e}}),ge.ajaxPrefilter("json jsonp",function(e,t,i){var n,r,o,s=e.data,a=e.url,l=e.jsonp!==!1,c=l&&Wt.test(a),u=l&&!c&&typeof s=="string"&&!(e.contentType||"").indexOf("application/x-www-form-urlencoded")&&Wt.test(s);if(e.dataTypes[0]==="jsonp"||c||u)return n=e.jsonpCallback=ge.isFunction(e.jsonpCallback)?e.jsonpCallback():e.jsonpCallback,r=v[n],c?e.url=a.replace(Wt,"$1"+n):u?e.data=s.replace(Wt,"$1"+n):l&&(e.url+=(Ft.test(a)?"&":"?")+e.jsonp+"="+n),e.converters["script json"]=function(){return o||ge.error(n+" was not called"),o[0]},e.dataTypes[0]="json",v[n]=function(){o=arguments},i.always(function(){v[n]=r,e[n]&&(e.jsonpCallback=t.jsonpCallback,Ht.push(n)),o&&ge.isFunction(r)&&r(o[0]),o=r=C}),"script"}),ge.ajaxSetup({accepts:{script:"text/javascript, application/javascript, application/ecmascript, application/x-ecmascript"},contents:{script:/javascript|ecmascript/},converters:{"text script":function(e){return ge.globalEval(e),e}}}),ge.ajaxPrefilter("script",function(e){e.cache===C&&(e.cache=!1),e.crossDomain&&(e.type="GET",e.global=!1)}),ge.ajaxTransport("script",function(t){if(t.crossDomain){var n,r=W.head||W.getElementsByTagName("head")[0]||W.documentElement;return{send:function(e,i){n=W.createElement("script"),n.async="async",t.scriptCharset&&(n.charset=t.scriptCharset),n.src=t.url,n.onload=n.onreadystatechange=function(e,t){if(t||!n.readyState||/loaded|complete/.test(n.readyState))n.onload=n.onreadystatechange=null,r&&n.parentNode&&r.removeChild(n),n=C,t||i(200,"success")},r.insertBefore(n,r.firstChild)},abort:function(){n&&n.onload(0,1)}}}});var Gt,qt=v.ActiveXObject?function(){for(var e in Gt)Gt[e](0,1)}:!1,$t=0;ge.ajaxSettings.xhr=v.ActiveXObject?function(){return!this.isLocal&&I()||D()}:I,function(e){ge.extend(ge.support,{ajax:!!e,cors:!!e&&"withCredentials"in e})}(ge.ajaxSettings.xhr()),ge.support.ajax&&ge.ajaxTransport(function(u){if(!u.crossDomain||ge.support.cors){var d;return{send:function(e,a){var l,t,c=u.xhr();u.username?c.open(u.type,u.url,u.async,u.username,u.password):c.open(u.type,u.url,u.async);if(u.xhrFields)for(t in u.xhrFields)c[t]=u.xhrFields[t];u.mimeType&&c.overrideMimeType&&c.overrideMimeType(u.mimeType),!u.crossDomain&&!e["X-Requested-With"]&&(e["X-Requested-With"]="XMLHttpRequest");try{for(t in e)c.setRequestHeader(t,e[t])}catch(e){}c.send(u.hasContent&&u.data||null),d=function(e,t){var i,n,r,o,s;try{if(d&&(t||c.readyState===4)){d=C,l&&(c.onreadystatechange=ge.noop,qt&&delete Gt[l]);if(t)c.readyState!==4&&c.abort();else{i=c.status,r=c.getAllResponseHeaders(),o={},s=c.responseXML,s&&s.documentElement&&(o.xml=s);try{o.text=c.responseText}catch(e){}try{n=c.statusText}catch(e){n=""}!i&&u.isLocal&&!u.crossDomain?i=o.text?200:404:i===1223&&(i=204)}}}catch(e){t||a(-1,e)}o&&a(i,n,o,r)},u.async?c.readyState===4?setTimeout(d,0):(l=++$t,qt&&(Gt||(Gt={},ge(v).unload(qt)),Gt[l]=d),c.onreadystatechange=d):d()},abort:function(){d&&d(0,1)}}}});var Ut,Vt,Yt=/^(?:toggle|show|hide)$/,Zt=new RegExp("^(?:([-+])=|)("+Q+")([a-z%]*)$","i"),Xt=/queueHooks$/,Jt=[A],Qt={"*":[function(e,t){var i,n,r=this.createTween(e,t),o=Zt.exec(t),s=r.cur(),a=+s||0,l=1,c=20;if(o){i=+o[2],n=o[3]||(ge.cssNumber[e]?"":"px");if(n!=="px"&&a){a=ge.css(r.elem,e,!0)||i||1;do{l=l||".5",a/=l,ge.style(r.elem,e,a+n)}while(l!==(l=r.cur()/s)&&l!==1&&--c)}r.unit=n,r.start=a,r.end=o[1]?a+(o[1]+1)*i:i}return r}]};ge.Animation=ge.extend(E,{tweener:function(e,t){ge.isFunction(e)?(t=e,e=["*"]):e=e.split(" ");var i,n=0,r=e.length;for(;n<r;n++)i=e[n],Qt[i]=Qt[i]||[],Qt[i].unshift(t)},prefilter:function(e,t){t?Jt.unshift(e):Jt.push(e)}}),ge.Tween=N,N.prototype={constructor:N,init:function(e,t,i,n,r,o){this.elem=e,this.prop=i,this.easing=r||"swing",this.options=t,this.start=this.now=this.cur(),this.end=n,this.unit=o||(ge.cssNumber[i]?"":"px")},cur:function(){var e=N.propHooks[this.prop];return e&&e.get?e.get(this):N.propHooks._default.get(this)},run:function(e){var t,i=N.propHooks[this.prop];return this.options.duration?this.pos=t=ge.easing[this.easing](e,this.options.duration*e,0,1,this.options.duration):this.pos=t=e,this.now=(this.end-this.start)*t+this.start,this.options.step&&this.options.step.call(this.elem,this.now,this),i&&i.set?i.set(this):N.propHooks._default.set(this),this}},N.prototype.init.prototype=N.prototype,N.propHooks={_default:{get:function(e){var t;return e.elem[e.prop]==null||!!e.elem.style&&e.elem.style[e.prop]!=null?(t=ge.css(e.elem,e.prop,!1,""),!t||t==="auto"?0:t):e.elem[e.prop]},set:function(e){ge.fx.step[e.prop]?ge.fx.step[e.prop](e):e.elem.style&&(e.elem.style[ge.cssProps[e.prop]]!=null||ge.cssHooks[e.prop])?ge.style(e.elem,e.prop,e.now+e.unit):e.elem[e.prop]=e.now}}},N.propHooks.scrollTop=N.propHooks.scrollLeft={set:function(e){e.elem.nodeType&&e.elem.parentNode&&(e.elem[e.prop]=e.now)}},ge.each(["toggle","show","hide"],function(n,r){var o=ge.fn[r];ge.fn[r]=function(e,t,i){return e==null||typeof e=="boolean"||!n&&ge.isFunction(e)&&ge.isFunction(t)?o.apply(this,arguments):this.animate(R(r,!0),e,t,i)}}),ge.fn.extend({fadeTo:function(e,t,i,n){return this.filter(b).css("opacity",0).show().end().animate({opacity:t},e,i,n)},animate:function(t,e,i,n){var r=ge.isEmptyObject(t),o=ge.speed(e,i,n),s=function(){var e=E(this,ge.extend({},t),o);r&&e.stop(!0)};return r||o.queue===!1?this.each(s):this.queue(o.queue,s)},stop:function(r,e,o){var s=function(e){var t=e.stop;delete e.stop,t(o)};return typeof r!="string"&&(o=e,e=r,r=C),e&&r!==!1&&this.queue(r||"fx",[]),this.each(function(){var e=!0,t=r!=null&&r+"queueHooks",i=ge.timers,n=ge._data(this);if(t)n[t]&&n[t].stop&&s(n[t]);else for(t in n)n[t]&&n[t].stop&&Xt.test(t)&&s(n[t]);for(t=i.length;t--;)i[t].elem===this&&(r==null||i[t].queue===r)&&(i[t].anim.stop(o),e=!1,i.splice(t,1));(e||!o)&&ge.dequeue(this,r)})}}),ge.each({slideDown:R("show"),slideUp:R("hide"),slideToggle:R("toggle"),fadeIn:{opacity:"show"},fadeOut:{opacity:"hide"},fadeToggle:{opacity:"toggle"}},function(e,n){ge.fn[e]=function(e,t,i){return this.animate(n,e,t,i)}}),ge.speed=function(e,t,i){var n=e&&typeof e=="object"?ge.extend({},e):{complete:i||!i&&t||ge.isFunction(e)&&e,duration:e,easing:i&&t||t&&!ge.isFunction(t)&&t};n.duration=ge.fx.off?0:typeof n.duration=="number"?n.duration:n.duration in ge.fx.speeds?ge.fx.speeds[n.duration]:ge.fx.speeds._default;if(n.queue==null||n.queue===!0)n.queue="fx";return n.old=n.complete,n.complete=function(){ge.isFunction(n.old)&&n.old.call(this),n.queue&&ge.dequeue(this,n.queue)},n},ge.easing={linear:function(e){return e},swing:function(e){return.5-Math.cos(e*Math.PI)/2}},ge.timers=[],ge.fx=N.prototype.init,ge.fx.tick=function(){var e,t=ge.timers,i=0;Ut=ge.now();for(;i<t.length;i++)e=t[i],!e()&&t[i]===e&&t.splice(i--,1);t.length||ge.fx.stop(),Ut=C},ge.fx.timer=function(e){e()&&ge.timers.push(e)&&!Vt&&(Vt=setInterval(ge.fx.tick,ge.fx.interval))},ge.fx.interval=13,ge.fx.stop=function(){clearInterval(Vt),Vt=null},ge.fx.speeds={slow:600,fast:200,_default:400},ge.fx.step={},ge.expr&&ge.expr.filters&&(ge.expr.filters.animated=function(t){return ge.grep(ge.timers,function(e){return t===e.elem}).length});var Kt=/^(?:body|html)$/i;ge.fn.offset=function(t){if(arguments.length)return t===C?this:this.each(function(e){ge.offset.setOffset(this,t,e)});var e,i,n,r,o,s,a,l={top:0,left:0},c=this[0],u=c&&c.ownerDocument;if(!u)return;return(i=u.body)===c?ge.offset.bodyOffset(c):(e=u.documentElement,ge.contains(e,c)?(typeof c.getBoundingClientRect!="undefined"&&(l=c.getBoundingClientRect()),n=z(u),r=e.clientTop||i.clientTop||0,o=e.clientLeft||i.clientLeft||0,s=n.pageYOffset||e.scrollTop,a=n.pageXOffset||e.scrollLeft,{top:l.top+s-r,left:l.left+a-o}):l)},ge.offset={bodyOffset:function(e){var t=e.offsetTop,i=e.offsetLeft;return ge.support.doesNotIncludeMarginInBodyOffset&&(t+=parseFloat(ge.css(e,"marginTop"))||0,i+=parseFloat(ge.css(e,"marginLeft"))||0),{top:t,left:i}},setOffset:function(e,t,i){var n=ge.css(e,"position");n==="static"&&(e.style.position="relative");var r=ge(e),o=r.offset(),s=ge.css(e,"top"),a=ge.css(e,"left"),l=(n==="absolute"||n==="fixed")&&ge.inArray("auto",[s,a])>-1,c={},u={},d,f;l?(u=r.position(),d=u.top,f=u.left):(d=parseFloat(s)||0,f=parseFloat(a)||0),ge.isFunction(t)&&(t=t.call(e,i,o)),t.top!=null&&(c.top=t.top-o.top+d),t.left!=null&&(c.left=t.left-o.left+f),"using"in t?t.using.call(e,c):r.css(c)}},ge.fn.extend({position:function(){if(!this[0])return;var e=this[0],t=this.offsetParent(),i=this.offset(),n=Kt.test(t[0].nodeName)?{top:0,left:0}:t.offset();return i.top-=parseFloat(ge.css(e,"marginTop"))||0,i.left-=parseFloat(ge.css(e,"marginLeft"))||0,n.top+=parseFloat(ge.css(t[0],"borderTopWidth"))||0,n.left+=parseFloat(ge.css(t[0],"borderLeftWidth"))||0,{top:i.top-n.top,left:i.left-n.left}},offsetParent:function(){return this.map(function(){var e=this.offsetParent||W.body;while(e&&!Kt.test(e.nodeName)&&ge.css(e,"position")==="static")e=e.offsetParent;return e||W.body})}}),ge.each({scrollLeft:"pageXOffset",scrollTop:"pageYOffset"},function(t,r){var o=/Y/.test(r);ge.fn[t]=function(e){return ge.access(this,function(e,t,i){var n=z(e);if(i===C)return n?r in n?n[r]:n.document.documentElement[t]:e[t];n?n.scrollTo(o?ge(n).scrollLeft():i,o?i:ge(n).scrollTop()):e[t]=i},t,e,arguments.length,null)}}),ge.each({Height:"height",Width:"width"},function(o,s){ge.each({padding:"inner"+o,content:s,"":"outer"+o},function(n,e){ge.fn[e]=function(e,t){var i=arguments.length&&(n||typeof e!="boolean"),r=n||(e===!0||t===!0?"margin":"border");return ge.access(this,function(e,t,i){var n;return ge.isWindow(e)?e.document.documentElement["client"+o]:e.nodeType===9?(n=e.documentElement,Math.max(e.body["scroll"+o],n["scroll"+o],e.body["offset"+o],n["offset"+o],n["client"+o])):i===C?ge.css(e,t,i,r):ge.style(e,t,i,r)},s,i?e:C,i,null)}})}),v.jQuery=v.$=ge,typeof define=="function"&&define.amd&&define.amd.jQuery&&define("jquery",[],function(){return ge})})(window);(function(a,l){function n(e,t){var i,n,r,o=e.nodeName.toLowerCase();return"area"===o?(i=e.parentNode,n=i.name,!e.href||!n||i.nodeName.toLowerCase()!=="map"?!1:(r=a("img[usemap=#"+n+"]")[0],!!r&&s(r))):(/input|select|textarea|button|object/.test(o)?!e.disabled:"a"===o?e.href||t:t)&&s(e)}function s(e){return a.expr.filters.visible(e)&&!a(e).parents().andSelf().filter(function(){return a.css(this,"visibility")==="hidden"}).length}var e=0,t=/^ui-id-\d+$/;a.ui=a.ui||{};if(a.ui.version)return;a.extend(a.ui,{version:"1.9.2",keyCode:{BACKSPACE:8,COMMA:188,DELETE:46,DOWN:40,END:35,ENTER:13,ESCAPE:27,HOME:36,LEFT:37,NUMPAD_ADD:107,NUMPAD_DECIMAL:110,NUMPAD_DIVIDE:111,NUMPAD_ENTER:108,NUMPAD_MULTIPLY:106,NUMPAD_SUBTRACT:109,PAGE_DOWN:34,PAGE_UP:33,PERIOD:190,RIGHT:39,SPACE:32,TAB:9,UP:38}}),a.fn.extend({_focus:a.fn.focus,focus:function(t,i){return typeof t=="number"?this.each(function(){var e=this;setTimeout(function(){a(e).focus(),i&&i.call(e)},t)}):this._focus.apply(this,arguments)},scrollParent:function(){var e;return a.ui.ie&&/(static|relative)/.test(this.css("position"))||/absolute/.test(this.css("position"))?e=this.parents().filter(function(){return/(relative|absolute|fixed)/.test(a.css(this,"position"))&&/(auto|scroll)/.test(a.css(this,"overflow")+a.css(this,"overflow-y")+a.css(this,"overflow-x"))}).eq(0):e=this.parents().filter(function(){return/(auto|scroll)/.test(a.css(this,"overflow")+a.css(this,"overflow-y")+a.css(this,"overflow-x"))}).eq(0),/fixed/.test(this.css("position"))||!e.length?a(document):e},zIndex:function(e){if(e!==l)return this.css("zIndex",e);if(this.length){var t=a(this[0]),i,n;while(t.length&&t[0]!==document){i=t.css("position");if(i==="absolute"||i==="relative"||i==="fixed"){n=parseInt(t.css("zIndex"),10);if(!isNaN(n)&&n!==0)return n}t=t.parent()}}return 0},uniqueId:function(){return this.each(function(){this.id||(this.id="ui-id-"+ ++e)})},removeUniqueId:function(){return this.each(function(){t.test(this.id)&&a(this).removeAttr("id")})}}),a.extend(a.expr[":"],{data:a.expr.createPseudo?a.expr.createPseudo(function(t){return function(e){return!!a.data(e,t)}}):function(e,t,i){return!!a.data(e,i[3])},focusable:function(e){return n(e,!isNaN(a.attr(e,"tabindex")))},tabbable:function(e){var t=a.attr(e,"tabindex"),i=isNaN(t);return(i||t>=0)&&n(e,!i)}}),a(function(){var e=document.body,t=e.appendChild(t=document.createElement("div"));t.offsetHeight,a.extend(t.style,{minHeight:"100px",height:"auto",padding:0,borderWidth:0}),a.support.minHeight=t.offsetHeight===100,a.support.selectstart="onselectstart"in t,e.removeChild(t).style.display="none"}),a("<a>").outerWidth(1).jquery||a.each(["Width","Height"],function(e,i){function n(e,t,i,n){return a.each(r,function(){t-=parseFloat(a.css(e,"padding"+this))||0,i&&(t-=parseFloat(a.css(e,"border"+this+"Width"))||0),n&&(t-=parseFloat(a.css(e,"margin"+this))||0)}),t}var r=i==="Width"?["Left","Right"]:["Top","Bottom"],o=i.toLowerCase(),s={innerWidth:a.fn.innerWidth,innerHeight:a.fn.innerHeight,outerWidth:a.fn.outerWidth,outerHeight:a.fn.outerHeight};a.fn["inner"+i]=function(e){return e===l?s["inner"+i].call(this):this.each(function(){a(this).css(o,n(this,e)+"px")})},a.fn["outer"+i]=function(e,t){return typeof e!="number"?s["outer"+i].call(this,e):this.each(function(){a(this).css(o,n(this,e,!0,t)+"px")})}}),a("<a>").data("a-b","a").removeData("a-b").data("a-b")&&(a.fn.removeData=function(t){return function(e){return arguments.length?t.call(this,a.camelCase(e)):t.call(this)}}(a.fn.removeData)),function(){var e=/msie ([\w.]+)/.exec(navigator.userAgent.toLowerCase())||[];a.ui.ie=e.length?!0:!1,a.ui.ie6=parseFloat(e[1],10)===6}(),a.fn.extend({disableSelection:function(){return this.bind((a.support.selectstart?"selectstart":"mousedown")+".ui-disableSelection",function(e){e.preventDefault()})},enableSelection:function(){return this.unbind(".ui-disableSelection")}}),a.extend(a.ui,{plugin:{add:function(e,t,i){var n,r=a.ui[e].prototype;for(n in i)r.plugins[n]=r.plugins[n]||[],r.plugins[n].push([t,i[n]])},call:function(e,t,i){var n,r=e.plugins[t];if(!r||!e.element[0].parentNode||e.element[0].parentNode.nodeType===11)return;for(n=0;n<r.length;n++)e.options[r[n][0]]&&r[n][1].apply(e.element,i)}},contains:a.contains,hasScroll:function(e,t){if(a(e).css("overflow")==="hidden")return!1;var i=t&&t==="left"?"scrollLeft":"scrollTop",n=!1;return e[i]>0?!0:(e[i]=1,n=e[i]>0,e[i]=0,n)},isOverAxis:function(e,t,i){return e>t&&e<t+i},isOver:function(e,t,i,n,r,o){return a.ui.isOverAxis(e,i,r)&&a.ui.isOverAxis(t,n,o)}})})(jQuery);(function(u,a){var i=0,l=Array.prototype.slice,n=u.cleanData;u.cleanData=function(e){for(var t=0,i;(i=e[t])!=null;t++)try{u(i).triggerHandler("remove")}catch(e){}n(e)},u.widget=function(e,i,n){var t,r,o,s,a=e.split(".")[0];e=e.split(".")[1],t=a+"-"+e,n||(n=i,i=u.Widget),u.expr[":"][t.toLowerCase()]=function(e){return!!u.data(e,t)},u[a]=u[a]||{},r=u[a][e],o=u[a][e]=function(e,t){if(!this._createWidget)return new o(e,t);arguments.length&&this._createWidget(e,t)},u.extend(o,r,{version:n.version,_proto:u.extend({},n),_childConstructors:[]}),s=new i,s.options=u.widget.extend({},s.options),u.each(n,function(t,o){u.isFunction(o)&&(n[t]=function(){var n=function(){return i.prototype[t].apply(this,arguments)},r=function(e){return i.prototype[t].apply(this,e)};return function(){var e=this._super,t=this._superApply,i;return this._super=n,this._superApply=r,i=o.apply(this,arguments),this._super=e,this._superApply=t,i}}())}),o.prototype=u.widget.extend(s,{widgetEventPrefix:r?s.widgetEventPrefix:e},n,{constructor:o,namespace:a,widgetName:e,widgetBaseClass:t,widgetFullName:t}),r?(u.each(r._childConstructors,function(e,t){var i=t.prototype;u.widget(i.namespace+"."+i.widgetName,o,t._proto)}),delete r._childConstructors):i._childConstructors.push(o),u.widget.bridge(e,o)},u.widget.extend=function(e){var t=l.call(arguments,1),i=0,n=t.length,r,o;for(;i<n;i++)for(r in t[i])o=t[i][r],t[i].hasOwnProperty(r)&&o!==a&&(u.isPlainObject(o)?e[r]=u.isPlainObject(e[r])?u.widget.extend({},e[r],o):u.widget.extend({},o):e[r]=o);return e},u.widget.bridge=function(o,t){var s=t.prototype.widgetFullName||o;u.fn[o]=function(i){var e=typeof i=="string",n=l.call(arguments,1),r=this;return i=!e&&n.length?u.widget.extend.apply(null,[i].concat(n)):i,e?this.each(function(){var e,t=u.data(this,s);if(!t)return u.error("cannot call methods on "+o+" prior to initialization; "+"attempted to call method '"+i+"'");if(!u.isFunction(t[i])||i.charAt(0)==="_")return u.error("no such method '"+i+"' for "+o+" widget instance");e=t[i].apply(t,n);if(e!==t&&e!==a)return r=e&&e.jquery?r.pushStack(e.get()):e,!1}):this.each(function(){var e=u.data(this,s);e?e.option(i||{})._init():u.data(this,s,new t(i,this))}),r}},u.Widget=function(){},u.Widget._childConstructors=[],u.Widget.prototype={widgetName:"widget",widgetEventPrefix:"",defaultElement:"<div>",options:{disabled:!1,create:null},_createWidget:function(e,t){t=u(t||this.defaultElement||this)[0],this.element=u(t),this.uuid=i++,this.eventNamespace="."+this.widgetName+this.uuid,this.options=u.widget.extend({},this.options,this._getCreateOptions(),e),this.bindings=u(),this.hoverable=u(),this.focusable=u(),t!==this&&(u.data(t,this.widgetName,this),u.data(t,this.widgetFullName,this),this._on(!0,this.element,{remove:function(e){e.target===t&&this.destroy()}}),this.document=u(t.style?t.ownerDocument:t.document||t),this.window=u(this.document[0].defaultView||this.document[0].parentWindow)),this._create(),this._trigger("create",null,this._getCreateEventData()),this._init()},_getCreateOptions:u.noop,_getCreateEventData:u.noop,_create:u.noop,_init:u.noop,destroy:function(){this._destroy(),this.element.unbind(this.eventNamespace).removeData(this.widgetName).removeData(this.widgetFullName).removeData(u.camelCase(this.widgetFullName)),this.widget().unbind(this.eventNamespace).removeAttr("aria-disabled").removeClass(this.widgetFullName+"-disabled "+"ui-state-disabled"),this.bindings.unbind(this.eventNamespace),this.hoverable.removeClass("ui-state-hover"),this.focusable.removeClass("ui-state-focus")},_destroy:u.noop,widget:function(){return this.element},option:function(e,t){var i=e,n,r,o;if(arguments.length===0)return u.widget.extend({},this.options);if(typeof e=="string"){i={},n=e.split("."),e=n.shift();if(n.length){r=i[e]=u.widget.extend({},this.options[e]);for(o=0;o<n.length-1;o++)r[n[o]]=r[n[o]]||{},r=r[n[o]];e=n.pop();if(t===a)return r[e]===a?null:r[e];r[e]=t}else{if(t===a)return this.options[e]===a?null:this.options[e];i[e]=t}}return this._setOptions(i),this},_setOptions:function(e){var t;for(t in e)this._setOption(t,e[t]);return this},_setOption:function(e,t){return this.options[e]=t,e==="disabled"&&(this.widget().toggleClass(this.widgetFullName+"-disabled ui-state-disabled",!!t).attr("aria-disabled",t),this.hoverable.removeClass("ui-state-hover"),this.focusable.removeClass("ui-state-focus")),this},enable:function(){return this._setOption("disabled",!1)},disable:function(){return this._setOption("disabled",!0)},_on:function(s,a,e){var l,c=this;typeof s!="boolean"&&(e=a,a=s,s=!1),e?(a=l=u(a),this.bindings=this.bindings.add(a)):(e=a,a=this.element,l=this.widget()),u.each(e,function(e,t){function i(){if(!s&&(c.options.disabled===!0||u(this).hasClass("ui-state-disabled")))return;return(typeof t=="string"?c[t]:t).apply(c,arguments)}typeof t!="string"&&(i.guid=t.guid=t.guid||i.guid||u.guid++);var n=e.match(/^(\w+)\s*(.*)$/),r=n[1]+c.eventNamespace,o=n[2];o?l.delegate(o,r,i):a.bind(r,i)})},_off:function(e,t){t=(t||"").split(" ").join(this.eventNamespace+" ")+this.eventNamespace,e.unbind(t).undelegate(t)},_delay:function(e,t){function i(){return(typeof e=="string"?n[e]:e).apply(n,arguments)}var n=this;return setTimeout(i,t||0)},_hoverable:function(e){this.hoverable=this.hoverable.add(e),this._on(e,{mouseenter:function(e){u(e.currentTarget).addClass("ui-state-hover")},mouseleave:function(e){u(e.currentTarget).removeClass("ui-state-hover")}})},_focusable:function(e){this.focusable=this.focusable.add(e),this._on(e,{focusin:function(e){u(e.currentTarget).addClass("ui-state-focus")},focusout:function(e){u(e.currentTarget).removeClass("ui-state-focus")}})},_trigger:function(e,t,i){var n,r,o=this.options[e];i=i||{},t=u.Event(t),t.type=(e===this.widgetEventPrefix?e:this.widgetEventPrefix+e).toLowerCase(),t.target=this.element[0],r=t.originalEvent;if(r)for(n in r)n in t||(t[n]=r[n]);return this.element.trigger(t,i),!(u.isFunction(o)&&o.apply(this.element[0],[t].concat(i))===!1||t.isDefaultPrevented())}},u.each({show:"fadeIn",hide:"fadeOut"},function(o,s){u.Widget.prototype["_"+o]=function(t,e,i){typeof e=="string"&&(e={effect:e});var n,r=e?e===!0||typeof e=="number"?s:e.effect||s:o;e=e||{},typeof e=="number"&&(e={duration:e}),n=!u.isEmptyObject(e),e.complete=i,e.delay&&t.delay(e.delay),n&&u.effects&&(u.effects.effect[r]||u.uiBackCompat!==!1&&u.effects[r])?t[o](e):r!==o&&t[r]?t[r](e.duration,e.easing,i):t.queue(function(e){u(this)[o](),i&&i.call(t[0]),e()})}}),u.uiBackCompat!==!1&&(u.Widget.prototype._getCreateOptions=function(){return u.metadata&&u.metadata.get(this.element[0])[this.widgetName]})})(jQuery);(function(r,e){var o=!1;r(document).mouseup(function(e){o=!1}),r.widget("ui.mouse",{version:"1.9.2",options:{cancel:"input,textarea,button,select,option",distance:1,delay:0},_mouseInit:function(){var t=this;this.element.bind("mousedown."+this.widgetName,function(e){return t._mouseDown(e)}).bind("click."+this.widgetName,function(e){if(!0===r.data(e.target,t.widgetName+".preventClickEvent"))return r.removeData(e.target,t.widgetName+".preventClickEvent"),e.stopImmediatePropagation(),!1}),this.started=!1},_mouseDestroy:function(){this.element.unbind("."+this.widgetName),this._mouseMoveDelegate&&r(document).unbind("mousemove."+this.widgetName,this._mouseMoveDelegate).unbind("mouseup."+this.widgetName,this._mouseUpDelegate)},_mouseDown:function(e){if(o)return;this._mouseStarted&&this._mouseUp(e),this._mouseDownEvent=e;var t=this,i=e.which===1,n=typeof this.options.cancel=="string"&&e.target.nodeName?r(e.target).closest(this.options.cancel).length:!1;if(!i||n||!this._mouseCapture(e))return!0;this.mouseDelayMet=!this.options.delay,this.mouseDelayMet||(this._mouseDelayTimer=setTimeout(function(){t.mouseDelayMet=!0},this.options.delay));if(this._mouseDistanceMet(e)&&this._mouseDelayMet(e)){this._mouseStarted=this._mouseStart(e)!==!1;if(!this._mouseStarted)return e.preventDefault(),!0}return!0===r.data(e.target,this.widgetName+".preventClickEvent")&&r.removeData(e.target,this.widgetName+".preventClickEvent"),this._mouseMoveDelegate=function(e){return t._mouseMove(e)},this._mouseUpDelegate=function(e){return t._mouseUp(e)},r(document).bind("mousemove."+this.widgetName,this._mouseMoveDelegate).bind("mouseup."+this.widgetName,this._mouseUpDelegate),e.preventDefault(),o=!0,!0},_mouseMove:function(e){return!r.ui.ie||document.documentMode>=9||!!e.button?this._mouseStarted?(this._mouseDrag(e),e.preventDefault()):(this._mouseDistanceMet(e)&&this._mouseDelayMet(e)&&(this._mouseStarted=this._mouseStart(this._mouseDownEvent,e)!==!1,this._mouseStarted?this._mouseDrag(e):this._mouseUp(e)),!this._mouseStarted):this._mouseUp(e)},_mouseUp:function(e){return r(document).unbind("mousemove."+this.widgetName,this._mouseMoveDelegate).unbind("mouseup."+this.widgetName,this._mouseUpDelegate),this._mouseStarted&&(this._mouseStarted=!1,e.target===this._mouseDownEvent.target&&r.data(e.target,this.widgetName+".preventClickEvent",!0),this._mouseStop(e)),!1},_mouseDistanceMet:function(e){return Math.max(Math.abs(this._mouseDownEvent.pageX-e.pageX),Math.abs(this._mouseDownEvent.pageY-e.pageY))>=this.options.distance},_mouseDelayMet:function(e){return this.mouseDelayMet},_mouseStart:function(e){},_mouseDrag:function(e){},_mouseStop:function(e){},_mouseCapture:function(e){return!0}})})(jQuery);(function(x,o){function k(e,t,i){return[parseInt(e[0],10)*(c.test(e[0])?t/100:1),parseInt(e[1],10)*(c.test(e[1])?i/100:1)]}function C(e,t){return parseInt(x.css(e,t),10)||0}x.ui=x.ui||{};var r,L=Math.max,T=Math.abs,j=Math.round,n=/left|center|right/,s=/top|center|bottom/,a=/[\+\-]\d+%?/,l=/^\w+/,c=/%$/,t=x.fn.position;x.position={scrollbarWidth:function(){if(r!==o)return r;var e,t,i=x("<div style='display:block;width:50px;height:50px;overflow:hidden;'><div style='height:100px;width:auto;'></div></div>"),n=i.children()[0];return x("body").append(i),e=n.offsetWidth,i.css("overflow","scroll"),t=n.offsetWidth,e===t&&(t=i[0].clientWidth),i.remove(),r=e-t},getScrollInfo:function(e){var t=e.isWindow?"":e.element.css("overflow-x"),i=e.isWindow?"":e.element.css("overflow-y"),n=t==="scroll"||t==="auto"&&e.width<e.element[0].scrollWidth,r=i==="scroll"||i==="auto"&&e.height<e.element[0].scrollHeight;return{width:n?x.position.scrollbarWidth():0,height:r?x.position.scrollbarWidth():0}},getWithinInfo:function(e){var t=x(e||window),i=x.isWindow(t[0]);return{element:t,isWindow:i,offset:t.offset()||{left:0,top:0},scrollLeft:t.scrollLeft(),scrollTop:t.scrollTop(),width:i?t.width():t.outerWidth(),height:i?t.height():t.outerHeight()}}},x.fn.position=function(d){if(!d||!d.of)return t.apply(this,arguments);d=x.extend({},d);var f,h,p,g,m,v=x(d.of),y=x.position.getWithinInfo(d.within),_=x.position.getScrollInfo(y),e=v[0],b=(d.collision||"flip").split(" "),w={};return e.nodeType===9?(h=v.width(),p=v.height(),g={top:0,left:0}):x.isWindow(e)?(h=v.width(),p=v.height(),g={top:v.scrollTop(),left:v.scrollLeft()}):e.preventDefault?(d.at="left top",h=p=0,g={top:e.pageY,left:e.pageX}):(h=v.outerWidth(),p=v.outerHeight(),g=v.offset()),m=x.extend({},g),x.each(["my","at"],function(){var e=(d[this]||"").split(" "),t,i;e.length===1&&(e=n.test(e[0])?e.concat(["center"]):s.test(e[0])?["center"].concat(e):["center","center"]),e[0]=n.test(e[0])?e[0]:"center",e[1]=s.test(e[1])?e[1]:"center",t=a.exec(e[0]),i=a.exec(e[1]),w[this]=[t?t[0]:0,i?i[0]:0],d[this]=[l.exec(e[0])[0],l.exec(e[1])[0]]}),b.length===1&&(b[1]=b[0]),d.at[0]==="right"?m.left+=h:d.at[0]==="center"&&(m.left+=h/2),d.at[1]==="bottom"?m.top+=p:d.at[1]==="center"&&(m.top+=p/2),f=k(w.at,h,p),m.left+=f[0],m.top+=f[1],this.each(function(){var i,e,s=x(this),a=s.outerWidth(),l=s.outerHeight(),t=C(this,"marginLeft"),n=C(this,"marginTop"),r=a+t+C(this,"marginRight")+_.width,o=l+n+C(this,"marginBottom")+_.height,c=x.extend({},m),u=k(w.my,s.outerWidth(),s.outerHeight());d.my[0]==="right"?c.left-=a:d.my[0]==="center"&&(c.left-=a/2),d.my[1]==="bottom"?c.top-=l:d.my[1]==="center"&&(c.top-=l/2),c.left+=u[0],c.top+=u[1],x.support.offsetFractions||(c.left=j(c.left),c.top=j(c.top)),i={marginLeft:t,marginTop:n},x.each(["left","top"],function(e,t){x.ui.position[b[e]]&&x.ui.position[b[e]][t](c,{targetWidth:h,targetHeight:p,elemWidth:a,elemHeight:l,collisionPosition:i,collisionWidth:r,collisionHeight:o,offset:[f[0]+u[0],f[1]+u[1]],my:d.my,at:d.at,within:y,elem:s})}),x.fn.bgiframe&&s.bgiframe(),d.using&&(e=function(e){var t=g.left-c.left,i=t+h-a,n=g.top-c.top,r=n+p-l,o={target:{element:v,left:g.left,top:g.top,width:h,height:p},element:{element:s,left:c.left,top:c.top,width:a,height:l},horizontal:i<0?"left":t>0?"right":"center",vertical:r<0?"top":n>0?"bottom":"middle"};h<a&&T(t+i)<h&&(o.horizontal="center"),p<l&&T(n+r)<p&&(o.vertical="middle"),L(T(t),T(i))>L(T(n),T(r))?o.important="horizontal":o.important="vertical",d.using.call(this,e,o)}),s.offset(x.extend(c,{using:e}))})},x.ui.position={fit:{left:function(e,t){var i=t.within,n=i.isWindow?i.scrollLeft:i.offset.left,r=i.width,o=e.left-t.collisionPosition.marginLeft,s=n-o,a=o+t.collisionWidth-r-n,l;t.collisionWidth>r?s>0&&a<=0?(l=e.left+s+t.collisionWidth-r-n,e.left+=s-l):a>0&&s<=0?e.left=n:s>a?e.left=n+r-t.collisionWidth:e.left=n:s>0?e.left+=s:a>0?e.left-=a:e.left=L(e.left-o,e.left)},top:function(e,t){var i=t.within,n=i.isWindow?i.scrollTop:i.offset.top,r=t.within.height,o=e.top-t.collisionPosition.marginTop,s=n-o,a=o+t.collisionHeight-r-n,l;t.collisionHeight>r?s>0&&a<=0?(l=e.top+s+t.collisionHeight-r-n,e.top+=s-l):a>0&&s<=0?e.top=n:s>a?e.top=n+r-t.collisionHeight:e.top=n:s>0?e.top+=s:a>0?e.top-=a:e.top=L(e.top-o,e.top)}},flip:{left:function(e,t){var i=t.within,n=i.offset.left+i.scrollLeft,r=i.width,o=i.isWindow?i.scrollLeft:i.offset.left,s=e.left-t.collisionPosition.marginLeft,a=s-o,l=s+t.collisionWidth-r-o,c=t.my[0]==="left"?-t.elemWidth:t.my[0]==="right"?t.elemWidth:0,u=t.at[0]==="left"?t.targetWidth:t.at[0]==="right"?-t.targetWidth:0,d=-2*t.offset[0],f,h;if(a<0){f=e.left+c+u+d+t.collisionWidth-r-n;if(f<0||f<T(a))e.left+=c+u+d}else if(l>0){h=e.left-t.collisionPosition.marginLeft+c+u+d-o;if(h>0||T(h)<l)e.left+=c+u+d}},top:function(e,t){var i=t.within,n=i.offset.top+i.scrollTop,r=i.height,o=i.isWindow?i.scrollTop:i.offset.top,s=e.top-t.collisionPosition.marginTop,a=s-o,l=s+t.collisionHeight-r-o,c=t.my[1]==="top",u=c?-t.elemHeight:t.my[1]==="bottom"?t.elemHeight:0,d=t.at[1]==="top"?t.targetHeight:t.at[1]==="bottom"?-t.targetHeight:0,f=-2*t.offset[1],h,p;a<0?(p=e.top+u+d+f+t.collisionHeight-r-n,e.top+u+d+f>a&&(p<0||p<T(a))&&(e.top+=u+d+f)):l>0&&(h=e.top-t.collisionPosition.marginTop+u+d+f-o,e.top+u+d+f>l&&(h>0||T(h)<l)&&(e.top+=u+d+f))}},flipfit:{left:function(){x.ui.position.flip.left.apply(this,arguments),x.ui.position.fit.left.apply(this,arguments)},top:function(){x.ui.position.flip.top.apply(this,arguments),x.ui.position.fit.top.apply(this,arguments)}}},function(){var e,t,i,n,r,o=document.getElementsByTagName("body")[0],s=document.createElement("div");e=document.createElement(o?"div":"body"),i={visibility:"hidden",width:0,height:0,border:0,margin:0,background:"none"},o&&x.extend(i,{position:"absolute",left:"-1000px",top:"-1000px"});for(r in i)e.style[r]=i[r];e.appendChild(s),t=o||document.documentElement,t.insertBefore(e,t.firstChild),s.style.cssText="position: absolute; left: 10.7432222px;",n=x(s).offset().left,x.support.offsetFractions=n>10&&n<11,e.innerHTML="",t.removeChild(e)}(),x.uiBackCompat!==!1&&function(n){var r=n.fn.position;n.fn.position=function(e){if(!e||!e.offset)return r.call(this,e);var t=e.offset.split(" "),i=e.at.split(" ");return t.length===1&&(t[1]=t[0]),/^\d/.test(t[0])&&(t[0]="+"+t[0]),/^\d/.test(t[1])&&(t[1]="+"+t[1]),i.length===1&&(/left|center|right/.test(i[0])?i[1]="center":(i[1]=i[0],i[0]="center")),r.call(this,n.extend(e,{at:i[0]+t[0]+" "+i[1]+t[1],offset:o}))}}(jQuery)})(jQuery);(function(_,e){_.widget("ui.draggable",_.ui.mouse,{version:"1.9.2",widgetEventPrefix:"drag",options:{addClasses:!0,appendTo:"parent",axis:!1,connectToSortable:!1,containment:!1,cursor:"auto",cursorAt:!1,grid:!1,handle:!1,helper:"original",iframeFix:!1,opacity:!1,refreshPositions:!1,revert:!1,revertDuration:500,scope:"default",scroll:!0,scrollSensitivity:20,scrollSpeed:20,snap:!1,snapMode:"both",snapTolerance:20,stack:!1,zIndex:!1},_create:function(){this.options.helper=="original"&&!/^(?:r|a|f)/.test(this.element.css("position"))&&(this.element[0].style.position="relative"),this.options.addClasses&&this.element.addClass("ui-draggable"),this.options.disabled&&this.element.addClass("ui-draggable-disabled"),this._mouseInit()},_destroy:function(){this.element.removeClass("ui-draggable ui-draggable-dragging ui-draggable-disabled"),this._mouseDestroy()},_mouseCapture:function(e){var t=this.options;return this.helper||t.disabled||_(e.target).is(".ui-resizable-handle")?!1:(this.handle=this._getHandle(e),this.handle?(_(t.iframeFix===!0?"iframe":t.iframeFix).each(function(){_('<div class="ui-draggable-iframeFix" style="background: #fff;"></div>').css({width:this.offsetWidth+"px",height:this.offsetHeight+"px",position:"absolute",opacity:"0.001",zIndex:1e3}).css(_(this).offset()).appendTo("body")}),!0):!1)},_mouseStart:function(e){var t=this.options;return this.helper=this._createHelper(e),this.helper.addClass("ui-draggable-dragging"),this._cacheHelperProportions(),_.ui.ddmanager&&(_.ui.ddmanager.current=this),this._cacheMargins(),this.cssPosition=this.helper.css("position"),this.scrollParent=this.helper.scrollParent(),this.offset=this.positionAbs=this.element.offset(),this.offset={top:this.offset.top-this.margins.top,left:this.offset.left-this.margins.left},_.extend(this.offset,{click:{left:e.pageX-this.offset.left,top:e.pageY-this.offset.top},parent:this._getParentOffset(),relative:this._getRelativeOffset()}),this.originalPosition=this.position=this._generatePosition(e),this.originalPageX=e.pageX,this.originalPageY=e.pageY,t.cursorAt&&this._adjustOffsetFromHelper(t.cursorAt),t.containment&&this._setContainment(),this._trigger("start",e)===!1?(this._clear(),!1):(this._cacheHelperProportions(),_.ui.ddmanager&&!t.dropBehaviour&&_.ui.ddmanager.prepareOffsets(this,e),this._mouseDrag(e,!0),_.ui.ddmanager&&_.ui.ddmanager.dragStart(this,e),!0)},_mouseDrag:function(e,t){this.position=this._generatePosition(e),this.positionAbs=this._convertPositionTo("absolute");if(!t){var i=this._uiHash();if(this._trigger("drag",e,i)===!1)return this._mouseUp({}),!1;this.position=i.position}if(!this.options.axis||this.options.axis!="y")this.helper[0].style.left=this.position.left+"px";if(!this.options.axis||this.options.axis!="x")this.helper[0].style.top=this.position.top+"px";return _.ui.ddmanager&&_.ui.ddmanager.drag(this,e),!1},_mouseStop:function(e){var t=!1;_.ui.ddmanager&&!this.options.dropBehaviour&&(t=_.ui.ddmanager.drop(this,e)),this.dropped&&(t=this.dropped,this.dropped=!1);var i=this.element[0],n=!1;while(i&&(i=i.parentNode))i==document&&(n=!0);if(!n&&this.options.helper==="original")return!1;if(this.options.revert=="invalid"&&!t||this.options.revert=="valid"&&t||this.options.revert===!0||_.isFunction(this.options.revert)&&this.options.revert.call(this.element,t)){var r=this;_(this.helper).animate(this.originalPosition,parseInt(this.options.revertDuration,10),function(){r._trigger("stop",e)!==!1&&r._clear()})}else this._trigger("stop",e)!==!1&&this._clear();return!1},_mouseUp:function(e){return _("div.ui-draggable-iframeFix").each(function(){this.parentNode.removeChild(this)}),_.ui.ddmanager&&_.ui.ddmanager.dragStop(this,e),_.ui.mouse.prototype._mouseUp.call(this,e)},cancel:function(){return this.helper.is(".ui-draggable-dragging")?this._mouseUp({}):this._clear(),this},_getHandle:function(e){var t=!this.options.handle||!_(this.options.handle,this.element).length?!0:!1;return _(this.options.handle,this.element).find("*").andSelf().each(function(){this==e.target&&(t=!0)}),t},_createHelper:function(e){var t=this.options,i=_.isFunction(t.helper)?_(t.helper.apply(this.element[0],[e])):t.helper=="clone"?this.element.clone().removeAttr("id"):this.element;return i.parents("body").length||i.appendTo(t.appendTo=="parent"?this.element[0].parentNode:t.appendTo),i[0]!=this.element[0]&&!/(fixed|absolute)/.test(i.css("position"))&&i.css("position","absolute"),i},_adjustOffsetFromHelper:function(e){typeof e=="string"&&(e=e.split(" ")),_.isArray(e)&&(e={left:+e[0],top:+e[1]||0}),"left"in e&&(this.offset.click.left=e.left+this.margins.left),"right"in e&&(this.offset.click.left=this.helperProportions.width-e.right+this.margins.left),"top"in e&&(this.offset.click.top=e.top+this.margins.top),"bottom"in e&&(this.offset.click.top=this.helperProportions.height-e.bottom+this.margins.top)},_getParentOffset:function(){this.offsetParent=this.helper.offsetParent();var e=this.offsetParent.offset();this.cssPosition=="absolute"&&this.scrollParent[0]!=document&&_.contains(this.scrollParent[0],this.offsetParent[0])&&(e.left+=this.scrollParent.scrollLeft(),e.top+=this.scrollParent.scrollTop());if(this.offsetParent[0]==document.body||this.offsetParent[0].tagName&&this.offsetParent[0].tagName.toLowerCase()=="html"&&_.ui.ie)e={top:0,left:0};return{top:e.top+(parseInt(this.offsetParent.css("borderTopWidth"),10)||0),left:e.left+(parseInt(this.offsetParent.css("borderLeftWidth"),10)||0)}},_getRelativeOffset:function(){if(this.cssPosition=="relative"){var e=this.element.position();return{top:e.top-(parseInt(this.helper.css("top"),10)||0)+this.scrollParent.scrollTop(),left:e.left-(parseInt(this.helper.css("left"),10)||0)+this.scrollParent.scrollLeft()}}return{top:0,left:0}},_cacheMargins:function(){this.margins={left:parseInt(this.element.css("marginLeft"),10)||0,top:parseInt(this.element.css("marginTop"),10)||0,right:parseInt(this.element.css("marginRight"),10)||0,bottom:parseInt(this.element.css("marginBottom"),10)||0}},_cacheHelperProportions:function(){this.helperProportions={width:this.helper.outerWidth(),height:this.helper.outerHeight()}},_setContainment:function(){var e=this.options;e.containment=="parent"&&(e.containment=this.helper[0].parentNode);if(e.containment=="document"||e.containment=="window")this.containment=[e.containment=="document"?0:_(window).scrollLeft()-this.offset.relative.left-this.offset.parent.left,e.containment=="document"?0:_(window).scrollTop()-this.offset.relative.top-this.offset.parent.top,(e.containment=="document"?0:_(window).scrollLeft())+_(e.containment=="document"?document:window).width()-this.helperProportions.width-this.margins.left,(e.containment=="document"?0:_(window).scrollTop())+(_(e.containment=="document"?document:window).height()||document.body.parentNode.scrollHeight)-this.helperProportions.height-this.margins.top];if(!/^(document|window|parent)$/.test(e.containment)&&e.containment.constructor!=Array){var t=_(e.containment),i=t[0];if(!i)return;var n=t.offset(),r=_(i).css("overflow")!="hidden";this.containment=[(parseInt(_(i).css("borderLeftWidth"),10)||0)+(parseInt(_(i).css("paddingLeft"),10)||0),(parseInt(_(i).css("borderTopWidth"),10)||0)+(parseInt(_(i).css("paddingTop"),10)||0),(r?Math.max(i.scrollWidth,i.offsetWidth):i.offsetWidth)-(parseInt(_(i).css("borderLeftWidth"),10)||0)-(parseInt(_(i).css("paddingRight"),10)||0)-this.helperProportions.width-this.margins.left-this.margins.right,(r?Math.max(i.scrollHeight,i.offsetHeight):i.offsetHeight)-(parseInt(_(i).css("borderTopWidth"),10)||0)-(parseInt(_(i).css("paddingBottom"),10)||0)-this.helperProportions.height-this.margins.top-this.margins.bottom],this.relative_container=t}else e.containment.constructor==Array&&(this.containment=e.containment)},_convertPositionTo:function(e,t){t||(t=this.position);var i=e=="absolute"?1:-1,n=this.options,r=this.cssPosition!="absolute"||this.scrollParent[0]!=document&&!!_.contains(this.scrollParent[0],this.offsetParent[0])?this.scrollParent:this.offsetParent,o=/(html|body)/i.test(r[0].tagName);return{top:t.top+this.offset.relative.top*i+this.offset.parent.top*i-(this.cssPosition=="fixed"?-this.scrollParent.scrollTop():o?0:r.scrollTop())*i,left:t.left+this.offset.relative.left*i+this.offset.parent.left*i-(this.cssPosition=="fixed"?-this.scrollParent.scrollLeft():o?0:r.scrollLeft())*i}},_generatePosition:function(e){var t=this.options,i=this.cssPosition!="absolute"||this.scrollParent[0]!=document&&!!_.contains(this.scrollParent[0],this.offsetParent[0])?this.scrollParent:this.offsetParent,n=/(html|body)/i.test(i[0].tagName),r=e.pageX,o=e.pageY;if(this.originalPosition){var s;if(this.containment){if(this.relative_container){var a=this.relative_container.offset();s=[this.containment[0]+a.left,this.containment[1]+a.top,this.containment[2]+a.left,this.containment[3]+a.top]}else s=this.containment;e.pageX-this.offset.click.left<s[0]&&(r=s[0]+this.offset.click.left),e.pageY-this.offset.click.top<s[1]&&(o=s[1]+this.offset.click.top),e.pageX-this.offset.click.left>s[2]&&(r=s[2]+this.offset.click.left),e.pageY-this.offset.click.top>s[3]&&(o=s[3]+this.offset.click.top)}if(t.grid){var l=t.grid[1]?this.originalPageY+Math.round((o-this.originalPageY)/t.grid[1])*t.grid[1]:this.originalPageY;o=s?l-this.offset.click.top<s[1]||l-this.offset.click.top>s[3]?l-this.offset.click.top<s[1]?l+t.grid[1]:l-t.grid[1]:l:l;var c=t.grid[0]?this.originalPageX+Math.round((r-this.originalPageX)/t.grid[0])*t.grid[0]:this.originalPageX;r=s?c-this.offset.click.left<s[0]||c-this.offset.click.left>s[2]?c-this.offset.click.left<s[0]?c+t.grid[0]:c-t.grid[0]:c:c}}return{top:o-this.offset.click.top-this.offset.relative.top-this.offset.parent.top+(this.cssPosition=="fixed"?-this.scrollParent.scrollTop():n?0:i.scrollTop()),left:r-this.offset.click.left-this.offset.relative.left-this.offset.parent.left+(this.cssPosition=="fixed"?-this.scrollParent.scrollLeft():n?0:i.scrollLeft())}},_clear:function(){this.helper.removeClass("ui-draggable-dragging"),this.helper[0]!=this.element[0]&&!this.cancelHelperRemoval&&this.helper.remove(),this.helper=null,this.cancelHelperRemoval=!1},_trigger:function(e,t,i){return i=i||this._uiHash(),_.ui.plugin.call(this,e,[t,i]),e=="drag"&&(this.positionAbs=this._convertPositionTo("absolute")),_.Widget.prototype._trigger.call(this,e,t,i)},plugins:{},_uiHash:function(e){return{helper:this.helper,position:this.position,originalPosition:this.originalPosition,offset:this.positionAbs}}}),_.ui.plugin.add("draggable","connectToSortable",{start:function(t,e){var i=_(this).data("draggable"),n=i.options,r=_.extend({},e,{item:i.element});i.sortables=[],_(n.connectToSortable).each(function(){var e=_.data(this,"sortable");e&&!e.options.disabled&&(i.sortables.push({instance:e,shouldRevert:e.options.revert}),e.refreshPositions(),e._trigger("activate",t,r))})},stop:function(e,t){var i=_(this).data("draggable"),n=_.extend({},t,{item:i.element});_.each(i.sortables,function(){this.instance.isOver?(this.instance.isOver=0,i.cancelHelperRemoval=!0,this.instance.cancelHelperRemoval=!1,this.shouldRevert&&(this.instance.options.revert=!0),this.instance._mouseStop(e),this.instance.options.helper=this.instance.options._helper,i.options.helper=="original"&&this.instance.currentItem.css({top:"auto",left:"auto"})):(this.instance.cancelHelperRemoval=!1,this.instance._trigger("deactivate",e,n))})},drag:function(n,r){var o=_(this).data("draggable"),s=this,e=function(e){var t=this.offset.click.top,i=this.offset.click.left,n=this.positionAbs.top,r=this.positionAbs.left,o=e.height,s=e.width,a=e.top,l=e.left;return _.ui.isOver(n+t,r+i,a,l,o,s)};_.each(o.sortables,function(e){var t=!1,i=this;this.instance.positionAbs=o.positionAbs,this.instance.helperProportions=o.helperProportions,this.instance.offset.click=o.offset.click,this.instance._intersectsWith(this.instance.containerCache)&&(t=!0,_.each(o.sortables,function(){return this.instance.positionAbs=o.positionAbs,this.instance.helperProportions=o.helperProportions,this.instance.offset.click=o.offset.click,this!=i&&this.instance._intersectsWith(this.instance.containerCache)&&_.ui.contains(i.instance.element[0],this.instance.element[0])&&(t=!1),t})),t?(this.instance.isOver||(this.instance.isOver=1,this.instance.currentItem=_(s).clone().removeAttr("id").appendTo(this.instance.element).data("sortable-item",!0),this.instance.options._helper=this.instance.options.helper,this.instance.options.helper=function(){return r.helper[0]},n.target=this.instance.currentItem[0],this.instance._mouseCapture(n,!0),this.instance._mouseStart(n,!0,!0),this.instance.offset.click.top=o.offset.click.top,this.instance.offset.click.left=o.offset.click.left,this.instance.offset.parent.left-=o.offset.parent.left-this.instance.offset.parent.left,this.instance.offset.parent.top-=o.offset.parent.top-this.instance.offset.parent.top,o._trigger("toSortable",n),o.dropped=this.instance.element,o.currentItem=o.element,this.instance.fromOutside=o),this.instance.currentItem&&this.instance._mouseDrag(n)):this.instance.isOver&&(this.instance.isOver=0,this.instance.cancelHelperRemoval=!0,this.instance.options.revert=!1,this.instance._trigger("out",n,this.instance._uiHash(this.instance)),this.instance._mouseStop(n,!0),this.instance.options.helper=this.instance.options._helper,this.instance.currentItem.remove(),this.instance.placeholder&&this.instance.placeholder.remove(),o._trigger("fromSortable",n),o.dropped=!1)})}}),_.ui.plugin.add("draggable","cursor",{start:function(e,t){var i=_("body"),n=_(this).data("draggable").options;i.css("cursor")&&(n._cursor=i.css("cursor")),i.css("cursor",n.cursor)},stop:function(e,t){var i=_(this).data("draggable").options;i._cursor&&_("body").css("cursor",i._cursor)}}),_.ui.plugin.add("draggable","opacity",{start:function(e,t){var i=_(t.helper),n=_(this).data("draggable").options;i.css("opacity")&&(n._opacity=i.css("opacity")),i.css("opacity",n.opacity)},stop:function(e,t){var i=_(this).data("draggable").options;i._opacity&&_(t.helper).css("opacity",i._opacity)}}),_.ui.plugin.add("draggable","scroll",{start:function(e,t){var i=_(this).data("draggable");i.scrollParent[0]!=document&&i.scrollParent[0].tagName!="HTML"&&(i.overflowOffset=i.scrollParent.offset())},drag:function(e,t){var i=_(this).data("draggable"),n=i.options,r=!1;if(i.scrollParent[0]!=document&&i.scrollParent[0].tagName!="HTML"){if(!n.axis||n.axis!="x")i.overflowOffset.top+i.scrollParent[0].offsetHeight-e.pageY<n.scrollSensitivity?i.scrollParent[0].scrollTop=r=i.scrollParent[0].scrollTop+n.scrollSpeed:e.pageY-i.overflowOffset.top<n.scrollSensitivity&&(i.scrollParent[0].scrollTop=r=i.scrollParent[0].scrollTop-n.scrollSpeed);if(!n.axis||n.axis!="y")i.overflowOffset.left+i.scrollParent[0].offsetWidth-e.pageX<n.scrollSensitivity?i.scrollParent[0].scrollLeft=r=i.scrollParent[0].scrollLeft+n.scrollSpeed:e.pageX-i.overflowOffset.left<n.scrollSensitivity&&(i.scrollParent[0].scrollLeft=r=i.scrollParent[0].scrollLeft-n.scrollSpeed)}else{if(!n.axis||n.axis!="x")e.pageY-_(document).scrollTop()<n.scrollSensitivity?r=_(document).scrollTop(_(document).scrollTop()-n.scrollSpeed):_(window).height()-(e.pageY-_(document).scrollTop())<n.scrollSensitivity&&(r=_(document).scrollTop(_(document).scrollTop()+n.scrollSpeed));if(!n.axis||n.axis!="y")e.pageX-_(document).scrollLeft()<n.scrollSensitivity?r=_(document).scrollLeft(_(document).scrollLeft()-n.scrollSpeed):_(window).width()-(e.pageX-_(document).scrollLeft())<n.scrollSensitivity&&(r=_(document).scrollLeft(_(document).scrollLeft()+n.scrollSpeed))}r!==!1&&_.ui.ddmanager&&!n.dropBehaviour&&_.ui.ddmanager.prepareOffsets(i,e)}}),_.ui.plugin.add("draggable","snap",{start:function(e,t){var i=_(this).data("draggable"),n=i.options;i.snapElements=[],_(n.snap.constructor!=String?n.snap.items||":data(draggable)":n.snap).each(function(){var e=_(this),t=e.offset();this!=i.element[0]&&i.snapElements.push({item:this,width:e.outerWidth(),height:e.outerHeight(),top:t.top,left:t.left})})},drag:function(e,t){var i=_(this).data("draggable"),n=i.options,r=n.snapTolerance,o=t.offset.left,s=o+i.helperProportions.width,a=t.offset.top,l=a+i.helperProportions.height;for(var c=i.snapElements.length-1;c>=0;c--){var u=i.snapElements[c].left,d=u+i.snapElements[c].width,f=i.snapElements[c].top,h=f+i.snapElements[c].height;if(!(u-r<o&&o<d+r&&f-r<a&&a<h+r||u-r<o&&o<d+r&&f-r<l&&l<h+r||u-r<s&&s<d+r&&f-r<a&&a<h+r||u-r<s&&s<d+r&&f-r<l&&l<h+r)){i.snapElements[c].snapping&&i.options.snap.release&&i.options.snap.release.call(i.element,e,_.extend(i._uiHash(),{snapItem:i.snapElements[c].item})),i.snapElements[c].snapping=!1;continue}if(n.snapMode!="inner"){var p=Math.abs(f-l)<=r,g=Math.abs(h-a)<=r,m=Math.abs(u-s)<=r,v=Math.abs(d-o)<=r;p&&(t.position.top=i._convertPositionTo("relative",{top:f-i.helperProportions.height,left:0}).top-i.margins.top),g&&(t.position.top=i._convertPositionTo("relative",{top:h,left:0}).top-i.margins.top),m&&(t.position.left=i._convertPositionTo("relative",{top:0,left:u-i.helperProportions.width}).left-i.margins.left),v&&(t.position.left=i._convertPositionTo("relative",{top:0,left:d}).left-i.margins.left)}var y=p||g||m||v;if(n.snapMode!="outer"){var p=Math.abs(f-a)<=r,g=Math.abs(h-l)<=r,m=Math.abs(u-o)<=r,v=Math.abs(d-s)<=r;p&&(t.position.top=i._convertPositionTo("relative",{top:f,left:0}).top-i.margins.top),g&&(t.position.top=i._convertPositionTo("relative",{top:h-i.helperProportions.height,left:0}).top-i.margins.top),m&&(t.position.left=i._convertPositionTo("relative",{top:0,left:u}).left-i.margins.left),v&&(t.position.left=i._convertPositionTo("relative",{top:0,left:d-i.helperProportions.width}).left-i.margins.left)}!i.snapElements[c].snapping&&(p||g||m||v||y)&&i.options.snap.snap&&i.options.snap.snap.call(i.element,e,_.extend(i._uiHash(),{snapItem:i.snapElements[c].item})),i.snapElements[c].snapping=p||g||m||v||y}}}),_.ui.plugin.add("draggable","stack",{start:function(e,t){var i=_(this).data("draggable").options,n=_.makeArray(_(i.stack)).sort(function(e,t){return(parseInt(_(e).css("zIndex"),10)||0)-(parseInt(_(t).css("zIndex"),10)||0)});if(!n.length)return;var r=parseInt(n[0].style.zIndex)||0;_(n).each(function(e){this.style.zIndex=r+e}),this[0].style.zIndex=r+n.length}}),_.ui.plugin.add("draggable","zIndex",{start:function(e,t){var i=_(t.helper),n=_(this).data("draggable").options;i.css("zIndex")&&(n._zIndex=i.css("zIndex")),i.css("zIndex",n.zIndex)},stop:function(e,t){var i=_(this).data("draggable").options;i._zIndex&&_(t.helper).css("zIndex",i._zIndex)}})})(jQuery);(function(p,e){p.widget("ui.droppable",{version:"1.9.2",widgetEventPrefix:"drop",options:{accept:"*",activeClass:!1,addClasses:!0,greedy:!1,hoverClass:!1,scope:"default",tolerance:"intersect"},_create:function(){var e=this.options,t=e.accept;this.isover=0,this.isout=1,this.accept=p.isFunction(t)?t:function(e){return e.is(t)},this.proportions={width:this.element[0].offsetWidth,height:this.element[0].offsetHeight},p.ui.ddmanager.droppables[e.scope]=p.ui.ddmanager.droppables[e.scope]||[],p.ui.ddmanager.droppables[e.scope].push(this),e.addClasses&&this.element.addClass("ui-droppable")},_destroy:function(){var e=p.ui.ddmanager.droppables[this.options.scope];for(var t=0;t<e.length;t++)e[t]==this&&e.splice(t,1);this.element.removeClass("ui-droppable ui-droppable-disabled")},_setOption:function(e,t){e=="accept"&&(this.accept=p.isFunction(t)?t:function(e){return e.is(t)}),p.Widget.prototype._setOption.apply(this,arguments)},_activate:function(e){var t=p.ui.ddmanager.current;this.options.activeClass&&this.element.addClass(this.options.activeClass),t&&this._trigger("activate",e,this.ui(t))},_deactivate:function(e){var t=p.ui.ddmanager.current;this.options.activeClass&&this.element.removeClass(this.options.activeClass),t&&this._trigger("deactivate",e,this.ui(t))},_over:function(e){var t=p.ui.ddmanager.current;if(!t||(t.currentItem||t.element)[0]==this.element[0])return;this.accept.call(this.element[0],t.currentItem||t.element)&&(this.options.hoverClass&&this.element.addClass(this.options.hoverClass),this._trigger("over",e,this.ui(t)))},_out:function(e){var t=p.ui.ddmanager.current;if(!t||(t.currentItem||t.element)[0]==this.element[0])return;this.accept.call(this.element[0],t.currentItem||t.element)&&(this.options.hoverClass&&this.element.removeClass(this.options.hoverClass),this._trigger("out",e,this.ui(t)))},_drop:function(e,t){var i=t||p.ui.ddmanager.current;if(!i||(i.currentItem||i.element)[0]==this.element[0])return!1;var n=!1;return this.element.find(":data(droppable)").not(".ui-draggable-dragging").each(function(){var e=p.data(this,"droppable");if(e.options.greedy&&!e.options.disabled&&e.options.scope==i.options.scope&&e.accept.call(e.element[0],i.currentItem||i.element)&&p.ui.intersect(i,p.extend(e,{offset:e.element.offset()}),e.options.tolerance))return n=!0,!1}),n?!1:this.accept.call(this.element[0],i.currentItem||i.element)?(this.options.activeClass&&this.element.removeClass(this.options.activeClass),this.options.hoverClass&&this.element.removeClass(this.options.hoverClass),this._trigger("drop",e,this.ui(i)),this.element):!1},ui:function(e){return{draggable:e.currentItem||e.element,helper:e.helper,position:e.position,offset:e.positionAbs}}}),p.ui.intersect=function(e,t,i){if(!t.offset)return!1;var n=(e.positionAbs||e.position.absolute).left,r=n+e.helperProportions.width,o=(e.positionAbs||e.position.absolute).top,s=o+e.helperProportions.height,a=t.offset.left,l=a+t.proportions.width,c=t.offset.top,u=c+t.proportions.height;switch(i){case"fit":return a<=n&&r<=l&&c<=o&&s<=u;case"intersect":return a<n+e.helperProportions.width/2&&r-e.helperProportions.width/2<l&&c<o+e.helperProportions.height/2&&s-e.helperProportions.height/2<u;case"pointer":var d=(e.positionAbs||e.position.absolute).left+(e.clickOffset||e.offset.click).left,f=(e.positionAbs||e.position.absolute).top+(e.clickOffset||e.offset.click).top,h=p.ui.isOver(f,d,c,a,t.proportions.height,t.proportions.width);return h;case"touch":return(o>=c&&o<=u||s>=c&&s<=u||o<c&&s>u)&&(n>=a&&n<=l||r>=a&&r<=l||n<a&&r>l);default:return!1}},p.ui.ddmanager={current:null,droppables:{default:[]},prepareOffsets:function(e,t){var i=p.ui.ddmanager.droppables[e.options.scope]||[],n=t?t.type:null,r=(e.currentItem||e.element).find(":data(droppable)").andSelf();e:for(var o=0;o<i.length;o++){if(i[o].options.disabled||e&&!i[o].accept.call(i[o].element[0],e.currentItem||e.element))continue;for(var s=0;s<r.length;s++)if(r[s]==i[o].element[0]){i[o].proportions.height=0;continue e}i[o].visible=i[o].element.css("display")!="none";if(!i[o].visible)continue;n=="mousedown"&&i[o]._activate.call(i[o],t),i[o].offset=i[o].element.offset(),i[o].proportions={width:i[o].element[0].offsetWidth,height:i[o].element[0].offsetHeight}}},drop:function(e,t){var i=!1;return p.each(p.ui.ddmanager.droppables[e.options.scope]||[],function(){if(!this.options)return;!this.options.disabled&&this.visible&&p.ui.intersect(e,this,this.options.tolerance)&&(i=this._drop.call(this,t)||i),!this.options.disabled&&this.visible&&this.accept.call(this.element[0],e.currentItem||e.element)&&(this.isout=1,this.isover=0,this._deactivate.call(this,t))}),i},dragStart:function(e,t){e.element.parentsUntil("body").bind("scroll.droppable",function(){e.options.refreshPositions||p.ui.ddmanager.prepareOffsets(e,t)})},drag:function(o,s){o.options.refreshPositions&&p.ui.ddmanager.prepareOffsets(o,s),p.each(p.ui.ddmanager.droppables[o.options.scope]||[],function(){if(this.options.disabled||this.greedyChild||!this.visible)return;var e=p.ui.intersect(o,this,this.options.tolerance),t=!e&&this.isover==1?"isout":e&&this.isover==0?"isover":null;if(!t)return;var i;if(this.options.greedy){var n=this.options.scope,r=this.element.parents(":data(droppable)").filter(function(){return p.data(this,"droppable").options.scope===n});r.length&&(i=p.data(r[0],"droppable"),i.greedyChild=t=="isover"?1:0)}i&&t=="isover"&&(i.isover=0,i.isout=1,i._out.call(i,s)),this[t]=1,this[t=="isout"?"isover":"isout"]=0,this[t=="isover"?"_over":"_out"].call(this,s),i&&t=="isout"&&(i.isout=0,i.isover=1,i._over.call(i,s))})},dragStop:function(e,t){e.element.parentsUntil("body").unbind("scroll.droppable"),e.options.refreshPositions||p.ui.ddmanager.prepareOffsets(e,t)}}})(jQuery);(function(g,e){g.widget("ui.resizable",g.ui.mouse,{version:"1.9.2",widgetEventPrefix:"resize",options:{alsoResize:!1,animate:!1,animateDuration:"slow",animateEasing:"swing",aspectRatio:!1,autoHide:!1,containment:!1,ghost:!1,grid:!1,handles:"e,s,se",helper:!1,maxHeight:null,maxWidth:null,minHeight:10,minWidth:10,zIndex:1e3},_create:function(){var t=this,e=this.options;this.element.addClass("ui-resizable"),g.extend(this,{_aspectRatio:!!e.aspectRatio,aspectRatio:e.aspectRatio,originalElement:this.element,_proportionallyResizeElements:[],_helper:e.helper||e.ghost||e.animate?e.helper||"ui-resizable-helper":null}),this.element[0].nodeName.match(/canvas|textarea|input|select|button|img/i)&&(this.element.wrap(g('<div class="ui-wrapper" style="overflow: hidden;"></div>').css({position:this.element.css("position"),width:this.element.outerWidth(),height:this.element.outerHeight(),top:this.element.css("top"),left:this.element.css("left")})),this.element=this.element.parent().data("resizable",this.element.data("resizable")),this.elementIsWrapper=!0,this.element.css({marginLeft:this.originalElement.css("marginLeft"),marginTop:this.originalElement.css("marginTop"),marginRight:this.originalElement.css("marginRight"),marginBottom:this.originalElement.css("marginBottom")}),this.originalElement.css({marginLeft:0,marginTop:0,marginRight:0,marginBottom:0}),this.originalResizeStyle=this.originalElement.css("resize"),this.originalElement.css("resize","none"),this._proportionallyResizeElements.push(this.originalElement.css({position:"static",zoom:1,display:"block"})),this.originalElement.css({margin:this.originalElement.css("margin")}),this._proportionallyResize()),this.handles=e.handles||(g(".ui-resizable-handle",this.element).length?{n:".ui-resizable-n",e:".ui-resizable-e",s:".ui-resizable-s",w:".ui-resizable-w",se:".ui-resizable-se",sw:".ui-resizable-sw",ne:".ui-resizable-ne",nw:".ui-resizable-nw"}:"e,s,se");if(this.handles.constructor==String){this.handles=="all"&&(this.handles="n,e,s,w,se,sw,ne,nw");var i=this.handles.split(",");this.handles={};for(var n=0;n<i.length;n++){var r=g.trim(i[n]),o="ui-resizable-"+r,s=g('<div class="ui-resizable-handle '+o+'"></div>');s.css({zIndex:e.zIndex}),"se"==r&&s.addClass("ui-icon ui-icon-gripsmall-diagonal-se"),this.handles[r]=".ui-resizable-"+r,this.element.append(s)}}this._renderAxis=function(e){e=e||this.element;for(var t in this.handles){this.handles[t].constructor==String&&(this.handles[t]=g(this.handles[t],this.element).show());if(this.elementIsWrapper&&this.originalElement[0].nodeName.match(/textarea|input|select|button/i)){var i=g(this.handles[t],this.element),n=0;n=/sw|ne|nw|se|n|s/.test(t)?i.outerHeight():i.outerWidth();var r=["padding",/ne|nw|n/.test(t)?"Top":/se|sw|s/.test(t)?"Bottom":/^e$/.test(t)?"Right":"Left"].join("");e.css(r,n),this._proportionallyResize()}if(!g(this.handles[t]).length)continue}},this._renderAxis(this.element),this._handles=g(".ui-resizable-handle",this.element).disableSelection(),this._handles.mouseover(function(){if(!t.resizing){if(this.className)var e=this.className.match(/ui-resizable-(se|sw|ne|nw|n|e|s|w)/i);t.axis=e&&e[1]?e[1]:"se"}}),e.autoHide&&(this._handles.hide(),g(this.element).addClass("ui-resizable-autohide").mouseenter(function(){if(e.disabled)return;g(this).removeClass("ui-resizable-autohide"),t._handles.show()}).mouseleave(function(){if(e.disabled)return;t.resizing||(g(this).addClass("ui-resizable-autohide"),t._handles.hide())})),this._mouseInit()},_destroy:function(){this._mouseDestroy();var e=function(e){g(e).removeClass("ui-resizable ui-resizable-disabled ui-resizable-resizing").removeData("resizable").removeData("ui-resizable").unbind(".resizable").find(".ui-resizable-handle").remove()};if(this.elementIsWrapper){e(this.element);var t=this.element;this.originalElement.css({position:t.css("position"),width:t.outerWidth(),height:t.outerHeight(),top:t.css("top"),left:t.css("left")}).insertAfter(t),t.remove()}return this.originalElement.css("resize",this.originalResizeStyle),e(this.originalElement),this},_mouseCapture:function(e){var t=!1;for(var i in this.handles)g(this.handles[i])[0]==e.target&&(t=!0);return!this.options.disabled&&t},_mouseStart:function(e){var t=this.options,i=this.element.position(),n=this.element;this.resizing=!0,this.documentScroll={top:g(document).scrollTop(),left:g(document).scrollLeft()},(n.is(".ui-draggable")||/absolute/.test(n.css("position")))&&n.css({position:"absolute",top:i.top,left:i.left}),this._renderProxy();var r=p(this.helper.css("left")),o=p(this.helper.css("top"));t.containment&&(r+=g(t.containment).scrollLeft()||0,o+=g(t.containment).scrollTop()||0),this.offset=this.helper.offset(),this.position={left:r,top:o},this.size=this._helper?{width:n.outerWidth(),height:n.outerHeight()}:{width:n.width(),height:n.height()},this.originalSize=this._helper?{width:n.outerWidth(),height:n.outerHeight()}:{width:n.width(),height:n.height()},this.originalPosition={left:r,top:o},this.sizeDiff={width:n.outerWidth()-n.width(),height:n.outerHeight()-n.height()},this.originalMousePosition={left:e.pageX,top:e.pageY},this.aspectRatio=typeof t.aspectRatio=="number"?t.aspectRatio:this.originalSize.width/this.originalSize.height||1;var s=g(".ui-resizable-"+this.axis).css("cursor");return g("body").css("cursor",s=="auto"?this.axis+"-resize":s),n.addClass("ui-resizable-resizing"),this._propagate("start",e),!0},_mouseDrag:function(e){var t=this.helper,i=this.options,n={},r=this,o=this.originalMousePosition,s=this.axis,a=e.pageX-o.left||0,l=e.pageY-o.top||0,c=this._change[s];if(!c)return!1;var u=c.apply(this,[e,a,l]);this._updateVirtualBoundaries(e.shiftKey);if(this._aspectRatio||e.shiftKey)u=this._updateRatio(u,e);return u=this._respectSize(u,e),this._propagate("resize",e),t.css({top:this.position.top+"px",left:this.position.left+"px",width:this.size.width+"px",height:this.size.height+"px"}),!this._helper&&this._proportionallyResizeElements.length&&this._proportionallyResize(),this._updateCache(u),this._trigger("resize",e,this.ui()),!1},_mouseStop:function(e){this.resizing=!1;var t=this.options,i=this;if(this._helper){var n=this._proportionallyResizeElements,r=n.length&&/textarea/i.test(n[0].nodeName),o=r&&g.ui.hasScroll(n[0],"left")?0:i.sizeDiff.height,s=r?0:i.sizeDiff.width,a={width:i.helper.width()-s,height:i.helper.height()-o},l=parseInt(i.element.css("left"),10)+(i.position.left-i.originalPosition.left)||null,c=parseInt(i.element.css("top"),10)+(i.position.top-i.originalPosition.top)||null;t.animate||this.element.css(g.extend(a,{top:c,left:l})),i.helper.height(i.size.height),i.helper.width(i.size.width),this._helper&&!t.animate&&this._proportionallyResize()}return g("body").css("cursor","auto"),this.element.removeClass("ui-resizable-resizing"),this._propagate("stop",e),this._helper&&this.helper.remove(),!1},_updateVirtualBoundaries:function(e){var t=this.options,i,n,r,o,s;s={minWidth:m(t.minWidth)?t.minWidth:0,maxWidth:m(t.maxWidth)?t.maxWidth:Infinity,minHeight:m(t.minHeight)?t.minHeight:0,maxHeight:m(t.maxHeight)?t.maxHeight:Infinity};if(this._aspectRatio||e)i=s.minHeight*this.aspectRatio,r=s.minWidth/this.aspectRatio,n=s.maxHeight*this.aspectRatio,o=s.maxWidth/this.aspectRatio,i>s.minWidth&&(s.minWidth=i),r>s.minHeight&&(s.minHeight=r),n<s.maxWidth&&(s.maxWidth=n),o<s.maxHeight&&(s.maxHeight=o);this._vBoundaries=s},_updateCache:function(e){var t=this.options;this.offset=this.helper.offset(),m(e.left)&&(this.position.left=e.left),m(e.top)&&(this.position.top=e.top),m(e.height)&&(this.size.height=e.height),m(e.width)&&(this.size.width=e.width)},_updateRatio:function(e,t){var i=this.options,n=this.position,r=this.size,o=this.axis;return m(e.height)?e.width=e.height*this.aspectRatio:m(e.width)&&(e.height=e.width/this.aspectRatio),o=="sw"&&(e.left=n.left+(r.width-e.width),e.top=null),o=="nw"&&(e.top=n.top+(r.height-e.height),e.left=n.left+(r.width-e.width)),e},_respectSize:function(e,t){var i=this.helper,n=this._vBoundaries,r=this._aspectRatio||t.shiftKey,o=this.axis,s=m(e.width)&&n.maxWidth&&n.maxWidth<e.width,a=m(e.height)&&n.maxHeight&&n.maxHeight<e.height,l=m(e.width)&&n.minWidth&&n.minWidth>e.width,c=m(e.height)&&n.minHeight&&n.minHeight>e.height;l&&(e.width=n.minWidth),c&&(e.height=n.minHeight),s&&(e.width=n.maxWidth),a&&(e.height=n.maxHeight);var u=this.originalPosition.left+this.originalSize.width,d=this.position.top+this.size.height,f=/sw|nw|w/.test(o),h=/nw|ne|n/.test(o);l&&f&&(e.left=u-n.minWidth),s&&f&&(e.left=u-n.maxWidth),c&&h&&(e.top=d-n.minHeight),a&&h&&(e.top=d-n.maxHeight);var p=!e.width&&!e.height;return p&&!e.left&&e.top?e.top=null:p&&!e.top&&e.left&&(e.left=null),e},_proportionallyResize:function(){var e=this.options;if(!this._proportionallyResizeElements.length)return;var t=this.helper||this.element;for(var i=0;i<this._proportionallyResizeElements.length;i++){var n=this._proportionallyResizeElements[i];if(!this.borderDif){var r=[n.css("borderTopWidth"),n.css("borderRightWidth"),n.css("borderBottomWidth"),n.css("borderLeftWidth")],o=[n.css("paddingTop"),n.css("paddingRight"),n.css("paddingBottom"),n.css("paddingLeft")];this.borderDif=g.map(r,function(e,t){var i=parseInt(e,10)||0,n=parseInt(o[t],10)||0;return i+n})}n.css({height:t.height()-this.borderDif[0]-this.borderDif[2]||0,width:t.width()-this.borderDif[1]-this.borderDif[3]||0})}},_renderProxy:function(){var e=this.element,t=this.options;this.elementOffset=e.offset();if(this._helper){this.helper=this.helper||g('<div style="overflow:hidden;"></div>');var i=g.ui.ie6?1:0,n=g.ui.ie6?2:-1;this.helper.addClass(this._helper).css({width:this.element.outerWidth()+n,height:this.element.outerHeight()+n,position:"absolute",left:this.elementOffset.left-i+"px",top:this.elementOffset.top-i+"px",zIndex:++t.zIndex}),this.helper.appendTo("body").disableSelection()}else this.helper=this.element},_change:{e:function(e,t,i){return{width:this.originalSize.width+t}},w:function(e,t,i){var n=this.options,r=this.originalSize,o=this.originalPosition;return{left:o.left+t,width:r.width-t}},n:function(e,t,i){var n=this.options,r=this.originalSize,o=this.originalPosition;return{top:o.top+i,height:r.height-i}},s:function(e,t,i){return{height:this.originalSize.height+i}},se:function(e,t,i){return g.extend(this._change.s.apply(this,arguments),this._change.e.apply(this,[e,t,i]))},sw:function(e,t,i){return g.extend(this._change.s.apply(this,arguments),this._change.w.apply(this,[e,t,i]))},ne:function(e,t,i){return g.extend(this._change.n.apply(this,arguments),this._change.e.apply(this,[e,t,i]))},nw:function(e,t,i){return g.extend(this._change.n.apply(this,arguments),this._change.w.apply(this,[e,t,i]))}},_propagate:function(e,t){g.ui.plugin.call(this,e,[t,this.ui()]),e!="resize"&&this._trigger(e,t,this.ui())},plugins:{},ui:function(){return{originalElement:this.originalElement,element:this.element,helper:this.helper,position:this.position,size:this.size,originalSize:this.originalSize,originalPosition:this.originalPosition}}}),g.ui.plugin.add("resizable","alsoResize",{start:function(e,t){var i=g(this).data("resizable"),n=i.options,r=function(e){g(e).each(function(){var e=g(this);e.data("resizable-alsoresize",{width:parseInt(e.width(),10),height:parseInt(e.height(),10),left:parseInt(e.css("left"),10),top:parseInt(e.css("top"),10)})})};typeof n.alsoResize=="object"&&!n.alsoResize.parentNode?n.alsoResize.length?(n.alsoResize=n.alsoResize[0],r(n.alsoResize)):g.each(n.alsoResize,function(e){r(e)}):r(n.alsoResize)},resize:function(e,o){var t=g(this).data("resizable"),i=t.options,n=t.originalSize,r=t.originalPosition,s={height:t.size.height-n.height||0,width:t.size.width-n.width||0,top:t.position.top-r.top||0,left:t.position.left-r.left||0},a=function(e,i){g(e).each(function(){var e=g(this),n=g(this).data("resizable-alsoresize"),r={},t=i&&i.length?i:e.parents(o.originalElement[0]).length?["width","height"]:["width","height","top","left"];g.each(t,function(e,t){var i=(n[t]||0)+(s[t]||0);i&&i>=0&&(r[t]=i||null)}),e.css(r)})};typeof i.alsoResize=="object"&&!i.alsoResize.nodeType?g.each(i.alsoResize,function(e,t){a(e,t)}):a(i.alsoResize)},stop:function(e,t){g(this).removeData("resizable-alsoresize")}}),g.ui.plugin.add("resizable","animate",{stop:function(t,e){var i=g(this).data("resizable"),n=i.options,r=i._proportionallyResizeElements,o=r.length&&/textarea/i.test(r[0].nodeName),s=o&&g.ui.hasScroll(r[0],"left")?0:i.sizeDiff.height,a=o?0:i.sizeDiff.width,l={width:i.size.width-a,height:i.size.height-s},c=parseInt(i.element.css("left"),10)+(i.position.left-i.originalPosition.left)||null,u=parseInt(i.element.css("top"),10)+(i.position.top-i.originalPosition.top)||null;i.element.animate(g.extend(l,u&&c?{top:u,left:c}:{}),{duration:n.animateDuration,easing:n.animateEasing,step:function(){var e={width:parseInt(i.element.css("width"),10),height:parseInt(i.element.css("height"),10),top:parseInt(i.element.css("top"),10),left:parseInt(i.element.css("left"),10)};r&&r.length&&g(r[0]).css({width:e.width,height:e.height}),i._updateCache(e),i._propagate("resize",t)}})}}),g.ui.plugin.add("resizable","containment",{start:function(e,t){var i=g(this).data("resizable"),n=i.options,r=i.element,o=n.containment,s=o instanceof g?o.get(0):/parent/.test(o)?r.parent().get(0):o;if(!s)return;i.containerElement=g(s);if(/document/.test(o)||o==document)i.containerOffset={left:0,top:0},i.containerPosition={left:0,top:0},i.parentData={element:g(document),left:0,top:0,width:g(document).width(),height:g(document).height()||document.body.parentNode.scrollHeight};else{var a=g(s),l=[];g(["Top","Right","Left","Bottom"]).each(function(e,t){l[e]=p(a.css("padding"+t))}),i.containerOffset=a.offset(),i.containerPosition=a.position(),i.containerSize={height:a.innerHeight()-l[3],width:a.innerWidth()-l[1]};var c=i.containerOffset,u=i.containerSize.height,d=i.containerSize.width,f=g.ui.hasScroll(s,"left")?s.scrollWidth:d,h=g.ui.hasScroll(s)?s.scrollHeight:u;i.parentData={element:s,left:c.left,top:c.top,width:f,height:h}}},resize:function(e,t){var i=g(this).data("resizable"),n=i.options,r=i.containerSize,o=i.containerOffset,s=i.size,a=i.position,l=i._aspectRatio||e.shiftKey,c={top:0,left:0},u=i.containerElement;u[0]!=document&&/static/.test(u.css("position"))&&(c=o),a.left<(i._helper?o.left:0)&&(i.size.width=i.size.width+(i._helper?i.position.left-o.left:i.position.left-c.left),l&&(i.size.height=i.size.width/i.aspectRatio),i.position.left=n.helper?o.left:0),a.top<(i._helper?o.top:0)&&(i.size.height=i.size.height+(i._helper?i.position.top-o.top:i.position.top),l&&(i.size.width=i.size.height*i.aspectRatio),i.position.top=i._helper?o.top:0),i.offset.left=i.parentData.left+i.position.left,i.offset.top=i.parentData.top+i.position.top;var d=Math.abs((i._helper?i.offset.left-c.left:i.offset.left-c.left)+i.sizeDiff.width),f=Math.abs((i._helper?i.offset.top-c.top:i.offset.top-o.top)+i.sizeDiff.height),h=i.containerElement.get(0)==i.element.parent().get(0),p=/relative|absolute/.test(i.containerElement.css("position"));h&&p&&(d-=i.parentData.left),d+i.size.width>=i.parentData.width&&(i.size.width=i.parentData.width-d,l&&(i.size.height=i.size.width/i.aspectRatio)),f+i.size.height>=i.parentData.height&&(i.size.height=i.parentData.height-f,l&&(i.size.width=i.size.height*i.aspectRatio))},stop:function(e,t){var i=g(this).data("resizable"),n=i.options,r=i.position,o=i.containerOffset,s=i.containerPosition,a=i.containerElement,l=g(i.helper),c=l.offset(),u=l.outerWidth()-i.sizeDiff.width,d=l.outerHeight()-i.sizeDiff.height;i._helper&&!n.animate&&/relative/.test(a.css("position"))&&g(this).css({left:c.left-s.left-o.left,width:u,height:d}),i._helper&&!n.animate&&/static/.test(a.css("position"))&&g(this).css({left:c.left-s.left-o.left,width:u,height:d})}}),g.ui.plugin.add("resizable","ghost",{start:function(e,t){var i=g(this).data("resizable"),n=i.options,r=i.size;i.ghost=i.originalElement.clone(),i.ghost.css({opacity:.25,display:"block",position:"relative",height:r.height,width:r.width,margin:0,left:0,top:0}).addClass("ui-resizable-ghost").addClass(typeof n.ghost=="string"?n.ghost:""),i.ghost.appendTo(i.helper)},resize:function(e,t){var i=g(this).data("resizable"),n=i.options;i.ghost&&i.ghost.css({position:"relative",height:i.size.height,width:i.size.width})},stop:function(e,t){var i=g(this).data("resizable"),n=i.options;i.ghost&&i.helper&&i.helper.get(0).removeChild(i.ghost.get(0))}}),g.ui.plugin.add("resizable","grid",{resize:function(e,t){var i=g(this).data("resizable"),n=i.options,r=i.size,o=i.originalSize,s=i.originalPosition,a=i.axis,l=n._aspectRatio||e.shiftKey;n.grid=typeof n.grid=="number"?[n.grid,n.grid]:n.grid;var c=Math.round((r.width-o.width)/(n.grid[0]||1))*(n.grid[0]||1),u=Math.round((r.height-o.height)/(n.grid[1]||1))*(n.grid[1]||1);/^(se|s|e)$/.test(a)?(i.size.width=o.width+c,i.size.height=o.height+u):/^(ne)$/.test(a)?(i.size.width=o.width+c,i.size.height=o.height+u,i.position.top=s.top-u):/^(sw)$/.test(a)?(i.size.width=o.width+c,i.size.height=o.height+u,i.position.left=s.left-c):(i.size.width=o.width+c,i.size.height=o.height+u,i.position.top=s.top-u,i.position.left=s.left-c)}});var p=function(e){return parseInt(e,10)||0},m=function(e){return!isNaN(parseInt(e,10))}})(jQuery);(function(c,e){c.widget("ui.selectable",c.ui.mouse,{version:"1.9.2",options:{appendTo:"body",autoRefresh:!0,distance:0,filter:"*",tolerance:"touch"},_create:function(){var e=this;this.element.addClass("ui-selectable"),this.dragged=!1;var t;this.refresh=function(){t=c(e.options.filter,e.element[0]),t.addClass("ui-selectee"),t.each(function(){var e=c(this),t=e.offset();c.data(this,"selectable-item",{element:this,$element:e,left:t.left,top:t.top,right:t.left+e.outerWidth(),bottom:t.top+e.outerHeight(),startselected:!1,selected:e.hasClass("ui-selected"),selecting:e.hasClass("ui-selecting"),unselecting:e.hasClass("ui-unselecting")})})},this.refresh(),this.selectees=t.addClass("ui-selectee"),this._mouseInit(),this.helper=c("<div class='ui-selectable-helper'></div>")},_destroy:function(){this.selectees.removeClass("ui-selectee").removeData("selectable-item"),this.element.removeClass("ui-selectable ui-selectable-disabled"),this._mouseDestroy()},_mouseStart:function(i){var n=this;this.opos=[i.pageX,i.pageY];if(this.options.disabled)return;var e=this.options;this.selectees=c(e.filter,this.element[0]),this._trigger("start",i),c(e.appendTo).append(this.helper),this.helper.css({left:i.clientX,top:i.clientY,width:0,height:0}),e.autoRefresh&&this.refresh(),this.selectees.filter(".ui-selected").each(function(){var e=c.data(this,"selectable-item");e.startselected=!0,!i.metaKey&&!i.ctrlKey&&(e.$element.removeClass("ui-selected"),e.selected=!1,e.$element.addClass("ui-unselecting"),e.unselecting=!0,n._trigger("unselecting",i,{unselecting:e.element}))}),c(i.target).parents().andSelf().each(function(){var e=c.data(this,"selectable-item");if(e){var t=!i.metaKey&&!i.ctrlKey||!e.$element.hasClass("ui-selected");return e.$element.removeClass(t?"ui-unselecting":"ui-selected").addClass(t?"ui-selecting":"ui-unselecting"),e.unselecting=!t,e.selecting=t,e.selected=t,t?n._trigger("selecting",i,{selecting:e.element}):n._trigger("unselecting",i,{unselecting:e.element}),!1}})},_mouseDrag:function(i){var n=this;this.dragged=!0;if(this.options.disabled)return;var r=this.options,o=this.opos[0],s=this.opos[1],a=i.pageX,l=i.pageY;if(o>a){var e=a;a=o,o=e}if(s>l){var e=l;l=s,s=e}return this.helper.css({left:o,top:s,width:a-o,height:l-s}),this.selectees.each(function(){var e=c.data(this,"selectable-item");if(!e||e.element==n.element[0])return;var t=!1;r.tolerance=="touch"?t=!(e.left>a||e.right<o||e.top>l||e.bottom<s):r.tolerance=="fit"&&(t=e.left>o&&e.right<a&&e.top>s&&e.bottom<l),t?(e.selected&&(e.$element.removeClass("ui-selected"),e.selected=!1),e.unselecting&&(e.$element.removeClass("ui-unselecting"),e.unselecting=!1),e.selecting||(e.$element.addClass("ui-selecting"),e.selecting=!0,n._trigger("selecting",i,{selecting:e.element}))):(e.selecting&&((i.metaKey||i.ctrlKey)&&e.startselected?(e.$element.removeClass("ui-selecting"),e.selecting=!1,e.$element.addClass("ui-selected"),e.selected=!0):(e.$element.removeClass("ui-selecting"),e.selecting=!1,e.startselected&&(e.$element.addClass("ui-unselecting"),e.unselecting=!0),n._trigger("unselecting",i,{unselecting:e.element}))),e.selected&&!i.metaKey&&!i.ctrlKey&&!e.startselected&&(e.$element.removeClass("ui-selected"),e.selected=!1,e.$element.addClass("ui-unselecting"),e.unselecting=!0,n._trigger("unselecting",i,{unselecting:e.element})))}),!1},_mouseStop:function(t){var i=this;this.dragged=!1;var e=this.options;return c(".ui-unselecting",this.element[0]).each(function(){var e=c.data(this,"selectable-item");e.$element.removeClass("ui-unselecting"),e.unselecting=!1,e.startselected=!1,i._trigger("unselected",t,{unselected:e.element})}),c(".ui-selecting",this.element[0]).each(function(){var e=c.data(this,"selectable-item");e.$element.removeClass("ui-selecting").addClass("ui-selected"),e.selecting=!1,e.selected=!0,e.startselected=!0,i._trigger("selected",t,{selected:e.element})}),this._trigger("stop",t),this.helper.remove(),!1}})})(jQuery);(function(f,e){f.widget("ui.sortable",f.ui.mouse,{version:"1.9.2",widgetEventPrefix:"sort",ready:!1,options:{appendTo:"parent",axis:!1,connectWith:!1,containment:!1,cursor:"auto",cursorAt:!1,dropOnEmpty:!0,forcePlaceholderSize:!1,forceHelperSize:!1,grid:!1,handle:!1,helper:"original",items:"> *",opacity:!1,placeholder:!1,revert:!1,scroll:!0,scrollSensitivity:20,scrollSpeed:20,scope:"default",tolerance:"intersect",zIndex:1e3},_create:function(){var e=this.options;this.containerCache={},this.element.addClass("ui-sortable"),this.refresh(),this.floating=this.items.length?e.axis==="x"||/left|right/.test(this.items[0].item.css("float"))||/inline|table-cell/.test(this.items[0].item.css("display")):!1,this.offset=this.element.offset(),this._mouseInit(),this.ready=!0},_destroy:function(){this.element.removeClass("ui-sortable ui-sortable-disabled"),this._mouseDestroy();for(var e=this.items.length-1;e>=0;e--)this.items[e].item.removeData(this.widgetName+"-item");return this},_setOption:function(e,t){e==="disabled"?(this.options[e]=t,this.widget().toggleClass("ui-sortable-disabled",!!t)):f.Widget.prototype._setOption.apply(this,arguments)},_mouseCapture:function(e,t){var i=this;if(this.reverting)return!1;if(this.options.disabled||this.options.type=="static")return!1;this._refreshItems(e);var n=null,r=f(e.target).parents().each(function(){if(f.data(this,i.widgetName+"-item")==i)return n=f(this),!1});f.data(e.target,i.widgetName+"-item")==i&&(n=f(e.target));if(!n)return!1;if(this.options.handle&&!t){var o=!1;f(this.options.handle,n).find("*").andSelf().each(function(){this==e.target&&(o=!0)});if(!o)return!1}return this.currentItem=n,this._removeCurrentsFromItems(),!0},_mouseStart:function(e,t,i){var n=this.options;this.currentContainer=this,this.refreshPositions(),this.helper=this._createHelper(e),this._cacheHelperProportions(),this._cacheMargins(),this.scrollParent=this.helper.scrollParent(),this.offset=this.currentItem.offset(),this.offset={top:this.offset.top-this.margins.top,left:this.offset.left-this.margins.left},f.extend(this.offset,{click:{left:e.pageX-this.offset.left,top:e.pageY-this.offset.top},parent:this._getParentOffset(),relative:this._getRelativeOffset()}),this.helper.css("position","absolute"),this.cssPosition=this.helper.css("position"),this.originalPosition=this._generatePosition(e),this.originalPageX=e.pageX,this.originalPageY=e.pageY,n.cursorAt&&this._adjustOffsetFromHelper(n.cursorAt),this.domPosition={prev:this.currentItem.prev()[0],parent:this.currentItem.parent()[0]},this.helper[0]!=this.currentItem[0]&&this.currentItem.hide(),this._createPlaceholder(),n.containment&&this._setContainment(),n.cursor&&(f("body").css("cursor")&&(this._storedCursor=f("body").css("cursor")),f("body").css("cursor",n.cursor)),n.opacity&&(this.helper.css("opacity")&&(this._storedOpacity=this.helper.css("opacity")),this.helper.css("opacity",n.opacity)),n.zIndex&&(this.helper.css("zIndex")&&(this._storedZIndex=this.helper.css("zIndex")),this.helper.css("zIndex",n.zIndex)),this.scrollParent[0]!=document&&this.scrollParent[0].tagName!="HTML"&&(this.overflowOffset=this.scrollParent.offset()),this._trigger("start",e,this._uiHash()),this._preserveHelperProportions||this._cacheHelperProportions();if(!i)for(var r=this.containers.length-1;r>=0;r--)this.containers[r]._trigger("activate",e,this._uiHash(this));return f.ui.ddmanager&&(f.ui.ddmanager.current=this),f.ui.ddmanager&&!n.dropBehaviour&&f.ui.ddmanager.prepareOffsets(this,e),this.dragging=!0,this.helper.addClass("ui-sortable-helper"),this._mouseDrag(e),!0},_mouseDrag:function(e){this.position=this._generatePosition(e),this.positionAbs=this._convertPositionTo("absolute"),this.lastPositionAbs||(this.lastPositionAbs=this.positionAbs);if(this.options.scroll){var t=this.options,i=!1;this.scrollParent[0]!=document&&this.scrollParent[0].tagName!="HTML"?(this.overflowOffset.top+this.scrollParent[0].offsetHeight-e.pageY<t.scrollSensitivity?this.scrollParent[0].scrollTop=i=this.scrollParent[0].scrollTop+t.scrollSpeed:e.pageY-this.overflowOffset.top<t.scrollSensitivity&&(this.scrollParent[0].scrollTop=i=this.scrollParent[0].scrollTop-t.scrollSpeed),this.overflowOffset.left+this.scrollParent[0].offsetWidth-e.pageX<t.scrollSensitivity?this.scrollParent[0].scrollLeft=i=this.scrollParent[0].scrollLeft+t.scrollSpeed:e.pageX-this.overflowOffset.left<t.scrollSensitivity&&(this.scrollParent[0].scrollLeft=i=this.scrollParent[0].scrollLeft-t.scrollSpeed)):(e.pageY-f(document).scrollTop()<t.scrollSensitivity?i=f(document).scrollTop(f(document).scrollTop()-t.scrollSpeed):f(window).height()-(e.pageY-f(document).scrollTop())<t.scrollSensitivity&&(i=f(document).scrollTop(f(document).scrollTop()+t.scrollSpeed)),e.pageX-f(document).scrollLeft()<t.scrollSensitivity?i=f(document).scrollLeft(f(document).scrollLeft()-t.scrollSpeed):f(window).width()-(e.pageX-f(document).scrollLeft())<t.scrollSensitivity&&(i=f(document).scrollLeft(f(document).scrollLeft()+t.scrollSpeed))),i!==!1&&f.ui.ddmanager&&!t.dropBehaviour&&f.ui.ddmanager.prepareOffsets(this,e)}this.positionAbs=this._convertPositionTo("absolute");if(!this.options.axis||this.options.axis!="y")this.helper[0].style.left=this.position.left+"px";if(!this.options.axis||this.options.axis!="x")this.helper[0].style.top=this.position.top+"px";for(var n=this.items.length-1;n>=0;n--){var r=this.items[n],o=r.item[0],s=this._intersectsWithPointer(r);if(!s)continue;if(r.instance!==this.currentContainer)continue;if(o!=this.currentItem[0]&&this.placeholder[s==1?"next":"prev"]()[0]!=o&&!f.contains(this.placeholder[0],o)&&(this.options.type=="semi-dynamic"?!f.contains(this.element[0],o):!0)){this.direction=s==1?"down":"up";if(this.options.tolerance!="pointer"&&!this._intersectsWithSides(r))break;this._rearrange(e,r),this._trigger("change",e,this._uiHash());break}}return this._contactContainers(e),f.ui.ddmanager&&f.ui.ddmanager.drag(this,e),this._trigger("sort",e,this._uiHash()),this.lastPositionAbs=this.positionAbs,!1},_mouseStop:function(e,t){if(!e)return;f.ui.ddmanager&&!this.options.dropBehaviour&&f.ui.ddmanager.drop(this,e);if(this.options.revert){var i=this,n=this.placeholder.offset();this.reverting=!0,f(this.helper).animate({left:n.left-this.offset.parent.left-this.margins.left+(this.offsetParent[0]==document.body?0:this.offsetParent[0].scrollLeft),top:n.top-this.offset.parent.top-this.margins.top+(this.offsetParent[0]==document.body?0:this.offsetParent[0].scrollTop)},parseInt(this.options.revert,10)||500,function(){i._clear(e)})}else this._clear(e,t);return!1},cancel:function(){if(this.dragging){this._mouseUp({target:null}),this.options.helper=="original"?this.currentItem.css(this._storedCSS).removeClass("ui-sortable-helper"):this.currentItem.show();for(var e=this.containers.length-1;e>=0;e--)this.containers[e]._trigger("deactivate",null,this._uiHash(this)),this.containers[e].containerCache.over&&(this.containers[e]._trigger("out",null,this._uiHash(this)),this.containers[e].containerCache.over=0)}return this.placeholder&&(this.placeholder[0].parentNode&&this.placeholder[0].parentNode.removeChild(this.placeholder[0]),this.options.helper!="original"&&this.helper&&this.helper[0].parentNode&&this.helper.remove(),f.extend(this,{helper:null,dragging:!1,reverting:!1,_noFinalSort:null}),this.domPosition.prev?f(this.domPosition.prev).after(this.currentItem):f(this.domPosition.parent).prepend(this.currentItem)),this},serialize:function(t){var e=this._getItemsAsjQuery(t&&t.connected),i=[];return t=t||{},f(e).each(function(){var e=(f(t.item||this).attr(t.attribute||"id")||"").match(t.expression||/(.+)[-=_](.+)/);e&&i.push((t.key||e[1]+"[]")+"="+(t.key&&t.expression?e[1]:e[2]))}),!i.length&&t.key&&i.push(t.key+"="),i.join("&")},toArray:function(e){var t=this._getItemsAsjQuery(e&&e.connected),i=[];return e=e||{},t.each(function(){i.push(f(e.item||this).attr(e.attribute||"id")||"")}),i},_intersectsWith:function(e){var t=this.positionAbs.left,i=t+this.helperProportions.width,n=this.positionAbs.top,r=n+this.helperProportions.height,o=e.left,s=o+e.width,a=e.top,l=a+e.height,c=this.offset.click.top,u=this.offset.click.left,d=n+c>a&&n+c<l&&t+u>o&&t+u<s;return this.options.tolerance=="pointer"||this.options.forcePointerForContainers||this.options.tolerance!="pointer"&&this.helperProportions[this.floating?"width":"height"]>e[this.floating?"width":"height"]?d:o<t+this.helperProportions.width/2&&i-this.helperProportions.width/2<s&&a<n+this.helperProportions.height/2&&r-this.helperProportions.height/2<l},_intersectsWithPointer:function(e){var t=this.options.axis==="x"||f.ui.isOverAxis(this.positionAbs.top+this.offset.click.top,e.top,e.height),i=this.options.axis==="y"||f.ui.isOverAxis(this.positionAbs.left+this.offset.click.left,e.left,e.width),n=t&&i,r=this._getDragVerticalDirection(),o=this._getDragHorizontalDirection();return n?this.floating?o&&o=="right"||r=="down"?2:1:r&&(r=="down"?2:1):!1},_intersectsWithSides:function(e){var t=f.ui.isOverAxis(this.positionAbs.top+this.offset.click.top,e.top+e.height/2,e.height),i=f.ui.isOverAxis(this.positionAbs.left+this.offset.click.left,e.left+e.width/2,e.width),n=this._getDragVerticalDirection(),r=this._getDragHorizontalDirection();return this.floating&&r?r=="right"&&i||r=="left"&&!i:n&&(n=="down"&&t||n=="up"&&!t)},_getDragVerticalDirection:function(){var e=this.positionAbs.top-this.lastPositionAbs.top;return e!=0&&(e>0?"down":"up")},_getDragHorizontalDirection:function(){var e=this.positionAbs.left-this.lastPositionAbs.left;return e!=0&&(e>0?"right":"left")},refresh:function(e){return this._refreshItems(e),this.refreshPositions(),this},_connectWith:function(){var e=this.options;return e.connectWith.constructor==String?[e.connectWith]:e.connectWith},_getItemsAsjQuery:function(e){var t=[],i=[],n=this._connectWith();if(n&&e)for(var r=n.length-1;r>=0;r--){var o=f(n[r]);for(var s=o.length-1;s>=0;s--){var a=f.data(o[s],this.widgetName);a&&a!=this&&!a.options.disabled&&i.push([f.isFunction(a.options.items)?a.options.items.call(a.element):f(a.options.items,a.element).not(".ui-sortable-helper").not(".ui-sortable-placeholder"),a])}}i.push([f.isFunction(this.options.items)?this.options.items.call(this.element,null,{options:this.options,item:this.currentItem}):f(this.options.items,this.element).not(".ui-sortable-helper").not(".ui-sortable-placeholder"),this]);for(var r=i.length-1;r>=0;r--)i[r][0].each(function(){t.push(this)});return f(t)},_removeCurrentsFromItems:function(){var i=this.currentItem.find(":data("+this.widgetName+"-item)");this.items=f.grep(this.items,function(e){for(var t=0;t<i.length;t++)if(i[t]==e.item[0])return!1;return!0})},_refreshItems:function(e){this.items=[],this.containers=[this];var t=this.items,i=[[f.isFunction(this.options.items)?this.options.items.call(this.element[0],e,{item:this.currentItem}):f(this.options.items,this.element),this]],n=this._connectWith();if(n&&this.ready)for(var r=n.length-1;r>=0;r--){var o=f(n[r]);for(var s=o.length-1;s>=0;s--){var a=f.data(o[s],this.widgetName);a&&a!=this&&!a.options.disabled&&(i.push([f.isFunction(a.options.items)?a.options.items.call(a.element[0],e,{item:this.currentItem}):f(a.options.items,a.element),a]),this.containers.push(a))}}for(var r=i.length-1;r>=0;r--){var l=i[r][1],c=i[r][0];for(var s=0,u=c.length;s<u;s++){var d=f(c[s]);d.data(this.widgetName+"-item",l),t.push({item:d,instance:l,width:0,height:0,left:0,top:0})}}},refreshPositions:function(e){this.offsetParent&&this.helper&&(this.offset.parent=this._getParentOffset());for(var t=this.items.length-1;t>=0;t--){var i=this.items[t];if(i.instance!=this.currentContainer&&this.currentContainer&&i.item[0]!=this.currentItem[0])continue;var n=this.options.toleranceElement?f(this.options.toleranceElement,i.item):i.item;e||(i.width=n.outerWidth(),i.height=n.outerHeight());var r=n.offset();i.left=r.left,i.top=r.top}if(this.options.custom&&this.options.custom.refreshContainers)this.options.custom.refreshContainers.call(this);else for(var t=this.containers.length-1;t>=0;t--){var r=this.containers[t].element.offset();this.containers[t].containerCache.left=r.left,this.containers[t].containerCache.top=r.top,this.containers[t].containerCache.width=this.containers[t].element.outerWidth(),this.containers[t].containerCache.height=this.containers[t].element.outerHeight()}return this},_createPlaceholder:function(i){i=i||this;var n=i.options;if(!n.placeholder||n.placeholder.constructor==String){var r=n.placeholder;n.placeholder={element:function(){var e=f(document.createElement(i.currentItem[0].nodeName)).addClass(r||i.currentItem[0].className+" ui-sortable-placeholder").removeClass("ui-sortable-helper")[0];return r||(e.style.visibility="hidden"),e},update:function(e,t){if(r&&!n.forcePlaceholderSize)return;t.height()||t.height(i.currentItem.innerHeight()-parseInt(i.currentItem.css("paddingTop")||0,10)-parseInt(i.currentItem.css("paddingBottom")||0,10)),t.width()||t.width(i.currentItem.innerWidth()-parseInt(i.currentItem.css("paddingLeft")||0,10)-parseInt(i.currentItem.css("paddingRight")||0,10))}}}i.placeholder=f(n.placeholder.element.call(i.element,i.currentItem)),i.currentItem.after(i.placeholder),n.placeholder.update(i,i.placeholder)},_contactContainers:function(e){var t=null,i=null;for(var n=this.containers.length-1;n>=0;n--){if(f.contains(this.currentItem[0],this.containers[n].element[0]))continue;if(this._intersectsWith(this.containers[n].containerCache)){if(t&&f.contains(this.containers[n].element[0],t.element[0]))continue;t=this.containers[n],i=n}else this.containers[n].containerCache.over&&(this.containers[n]._trigger("out",e,this._uiHash(this)),this.containers[n].containerCache.over=0)}if(!t)return;if(this.containers.length===1)this.containers[i]._trigger("over",e,this._uiHash(this)),this.containers[i].containerCache.over=1;else{var r=1e4,o=null,s=this.containers[i].floating?"left":"top",a=this.containers[i].floating?"width":"height",l=this.positionAbs[s]+this.offset.click[s];for(var c=this.items.length-1;c>=0;c--){if(!f.contains(this.containers[i].element[0],this.items[c].item[0]))continue;if(this.items[c].item[0]==this.currentItem[0])continue;var u=this.items[c].item.offset()[s],d=!1;Math.abs(u-l)>Math.abs(u+this.items[c][a]-l)&&(d=!0,u+=this.items[c][a]),Math.abs(u-l)<r&&(r=Math.abs(u-l),o=this.items[c],this.direction=d?"up":"down")}if(!o&&!this.options.dropOnEmpty)return;this.currentContainer=this.containers[i],o?this._rearrange(e,o,null,!0):this._rearrange(e,null,this.containers[i].element,!0),this._trigger("change",e,this._uiHash()),this.containers[i]._trigger("change",e,this._uiHash(this)),this.options.placeholder.update(this.currentContainer,this.placeholder),this.containers[i]._trigger("over",e,this._uiHash(this)),this.containers[i].containerCache.over=1}},_createHelper:function(e){var t=this.options,i=f.isFunction(t.helper)?f(t.helper.apply(this.element[0],[e,this.currentItem])):t.helper=="clone"?this.currentItem.clone():this.currentItem;return i.parents("body").length||f(t.appendTo!="parent"?t.appendTo:this.currentItem[0].parentNode)[0].appendChild(i[0]),i[0]==this.currentItem[0]&&(this._storedCSS={width:this.currentItem[0].style.width,height:this.currentItem[0].style.height,position:this.currentItem.css("position"),top:this.currentItem.css("top"),left:this.currentItem.css("left")}),(i[0].style.width==""||t.forceHelperSize)&&i.width(this.currentItem.width()),(i[0].style.height==""||t.forceHelperSize)&&i.height(this.currentItem.height()),i},_adjustOffsetFromHelper:function(e){typeof e=="string"&&(e=e.split(" ")),f.isArray(e)&&(e={left:+e[0],top:+e[1]||0}),"left"in e&&(this.offset.click.left=e.left+this.margins.left),"right"in e&&(this.offset.click.left=this.helperProportions.width-e.right+this.margins.left),"top"in e&&(this.offset.click.top=e.top+this.margins.top),"bottom"in e&&(this.offset.click.top=this.helperProportions.height-e.bottom+this.margins.top)},_getParentOffset:function(){this.offsetParent=this.helper.offsetParent();var e=this.offsetParent.offset();this.cssPosition=="absolute"&&this.scrollParent[0]!=document&&f.contains(this.scrollParent[0],this.offsetParent[0])&&(e.left+=this.scrollParent.scrollLeft(),e.top+=this.scrollParent.scrollTop());if(this.offsetParent[0]==document.body||this.offsetParent[0].tagName&&this.offsetParent[0].tagName.toLowerCase()=="html"&&f.ui.ie)e={top:0,left:0};return{top:e.top+(parseInt(this.offsetParent.css("borderTopWidth"),10)||0),left:e.left+(parseInt(this.offsetParent.css("borderLeftWidth"),10)||0)}},_getRelativeOffset:function(){if(this.cssPosition=="relative"){var e=this.currentItem.position();return{top:e.top-(parseInt(this.helper.css("top"),10)||0)+this.scrollParent.scrollTop(),left:e.left-(parseInt(this.helper.css("left"),10)||0)+this.scrollParent.scrollLeft()}}return{top:0,left:0}},_cacheMargins:function(){this.margins={left:parseInt(this.currentItem.css("marginLeft"),10)||0,top:parseInt(this.currentItem.css("marginTop"),10)||0}},_cacheHelperProportions:function(){this.helperProportions={width:this.helper.outerWidth(),height:this.helper.outerHeight()}},_setContainment:function(){var e=this.options;e.containment=="parent"&&(e.containment=this.helper[0].parentNode);if(e.containment=="document"||e.containment=="window")this.containment=[0-this.offset.relative.left-this.offset.parent.left,0-this.offset.relative.top-this.offset.parent.top,f(e.containment=="document"?document:window).width()-this.helperProportions.width-this.margins.left,(f(e.containment=="document"?document:window).height()||document.body.parentNode.scrollHeight)-this.helperProportions.height-this.margins.top];if(!/^(document|window|parent)$/.test(e.containment)){var t=f(e.containment)[0],i=f(e.containment).offset(),n=f(t).css("overflow")!="hidden";this.containment=[i.left+(parseInt(f(t).css("borderLeftWidth"),10)||0)+(parseInt(f(t).css("paddingLeft"),10)||0)-this.margins.left,i.top+(parseInt(f(t).css("borderTopWidth"),10)||0)+(parseInt(f(t).css("paddingTop"),10)||0)-this.margins.top,i.left+(n?Math.max(t.scrollWidth,t.offsetWidth):t.offsetWidth)-(parseInt(f(t).css("borderLeftWidth"),10)||0)-(parseInt(f(t).css("paddingRight"),10)||0)-this.helperProportions.width-this.margins.left,i.top+(n?Math.max(t.scrollHeight,t.offsetHeight):t.offsetHeight)-(parseInt(f(t).css("borderTopWidth"),10)||0)-(parseInt(f(t).css("paddingBottom"),10)||0)-this.helperProportions.height-this.margins.top]}},_convertPositionTo:function(e,t){t||(t=this.position);var i=e=="absolute"?1:-1,n=this.options,r=this.cssPosition!="absolute"||this.scrollParent[0]!=document&&!!f.contains(this.scrollParent[0],this.offsetParent[0])?this.scrollParent:this.offsetParent,o=/(html|body)/i.test(r[0].tagName);return{top:t.top+this.offset.relative.top*i+this.offset.parent.top*i-(this.cssPosition=="fixed"?-this.scrollParent.scrollTop():o?0:r.scrollTop())*i,left:t.left+this.offset.relative.left*i+this.offset.parent.left*i-(this.cssPosition=="fixed"?-this.scrollParent.scrollLeft():o?0:r.scrollLeft())*i}},_generatePosition:function(e){var t=this.options,i=this.cssPosition!="absolute"||this.scrollParent[0]!=document&&!!f.contains(this.scrollParent[0],this.offsetParent[0])?this.scrollParent:this.offsetParent,n=/(html|body)/i.test(i[0].tagName);this.cssPosition=="relative"&&(this.scrollParent[0]==document||this.scrollParent[0]==this.offsetParent[0])&&(this.offset.relative=this._getRelativeOffset());var r=e.pageX,o=e.pageY;if(this.originalPosition){this.containment&&(e.pageX-this.offset.click.left<this.containment[0]&&(r=this.containment[0]+this.offset.click.left),e.pageY-this.offset.click.top<this.containment[1]&&(o=this.containment[1]+this.offset.click.top),e.pageX-this.offset.click.left>this.containment[2]&&(r=this.containment[2]+this.offset.click.left),e.pageY-this.offset.click.top>this.containment[3]&&(o=this.containment[3]+this.offset.click.top));if(t.grid){var s=this.originalPageY+Math.round((o-this.originalPageY)/t.grid[1])*t.grid[1];o=this.containment?s-this.offset.click.top<this.containment[1]||s-this.offset.click.top>this.containment[3]?s-this.offset.click.top<this.containment[1]?s+t.grid[1]:s-t.grid[1]:s:s;var a=this.originalPageX+Math.round((r-this.originalPageX)/t.grid[0])*t.grid[0];r=this.containment?a-this.offset.click.left<this.containment[0]||a-this.offset.click.left>this.containment[2]?a-this.offset.click.left<this.containment[0]?a+t.grid[0]:a-t.grid[0]:a:a}}return{top:o-this.offset.click.top-this.offset.relative.top-this.offset.parent.top+(this.cssPosition=="fixed"?-this.scrollParent.scrollTop():n?0:i.scrollTop()),left:r-this.offset.click.left-this.offset.relative.left-this.offset.parent.left+(this.cssPosition=="fixed"?-this.scrollParent.scrollLeft():n?0:i.scrollLeft())}},_rearrange:function(e,t,i,n){i?i[0].appendChild(this.placeholder[0]):t.item[0].parentNode.insertBefore(this.placeholder[0],this.direction=="down"?t.item[0]:t.item[0].nextSibling),this.counter=this.counter?++this.counter:1;var r=this.counter;this._delay(function(){r==this.counter&&this.refreshPositions(!n)})},_clear:function(e,t){this.reverting=!1;var i=[];!this._noFinalSort&&this.currentItem.parent().length&&this.placeholder.before(this.currentItem),this._noFinalSort=null;if(this.helper[0]==this.currentItem[0]){for(var n in this._storedCSS)if(this._storedCSS[n]=="auto"||this._storedCSS[n]=="static")this._storedCSS[n]="";this.currentItem.css(this._storedCSS).removeClass("ui-sortable-helper")}else this.currentItem.show();this.fromOutside&&!t&&i.push(function(e){this._trigger("receive",e,this._uiHash(this.fromOutside))}),(this.fromOutside||this.domPosition.prev!=this.currentItem.prev().not(".ui-sortable-helper")[0]||this.domPosition.parent!=this.currentItem.parent()[0])&&!t&&i.push(function(e){this._trigger("update",e,this._uiHash())}),this!==this.currentContainer&&(t||(i.push(function(e){this._trigger("remove",e,this._uiHash())}),i.push(function(t){return function(e){t._trigger("receive",e,this._uiHash(this))}}.call(this,this.currentContainer)),i.push(function(t){return function(e){t._trigger("update",e,this._uiHash(this))}}.call(this,this.currentContainer))));for(var n=this.containers.length-1;n>=0;n--)t||i.push(function(t){return function(e){t._trigger("deactivate",e,this._uiHash(this))}}.call(this,this.containers[n])),this.containers[n].containerCache.over&&(i.push(function(t){return function(e){t._trigger("out",e,this._uiHash(this))}}.call(this,this.containers[n])),this.containers[n].containerCache.over=0);this._storedCursor&&f("body").css("cursor",this._storedCursor),this._storedOpacity&&this.helper.css("opacity",this._storedOpacity),this._storedZIndex&&this.helper.css("zIndex",this._storedZIndex=="auto"?"":this._storedZIndex),this.dragging=!1;if(this.cancelHelperRemoval){if(!t){this._trigger("beforeStop",e,this._uiHash());for(var n=0;n<i.length;n++)i[n].call(this,e);this._trigger("stop",e,this._uiHash())}return this.fromOutside=!1,!1}t||this._trigger("beforeStop",e,this._uiHash()),this.placeholder[0].parentNode.removeChild(this.placeholder[0]),this.helper[0]!=this.currentItem[0]&&this.helper.remove(),this.helper=null;if(!t){for(var n=0;n<i.length;n++)i[n].call(this,e);this._trigger("stop",e,this._uiHash())}return this.fromOutside=!1,!0},_trigger:function(){f.Widget.prototype._trigger.apply(this,arguments)===!1&&this.cancel()},_uiHash:function(e){var t=e||this;return{helper:t.helper,placeholder:t.placeholder||f([]),position:t.position,originalPosition:t.originalPosition,offset:t.positionAbs,item:t.currentItem,sender:e?e.element:null}}})})(jQuery);(function(c,e){var t=0,f={},h={};f.height=f.paddingTop=f.paddingBottom=f.borderTopWidth=f.borderBottomWidth="hide",h.height=h.paddingTop=h.paddingBottom=h.borderTopWidth=h.borderBottomWidth="show",c.widget("ui.accordion",{version:"1.9.2",options:{active:0,animate:{},collapsible:!1,event:"click",header:"> li > :first-child,> :not(li):even",heightStyle:"auto",icons:{activeHeader:"ui-icon-triangle-1-s",header:"ui-icon-triangle-1-e"},activate:null,beforeActivate:null},_create:function(){var o=this.accordionId="ui-accordion-"+(this.element.attr("id")||++t),e=this.options;this.prevShow=this.prevHide=c(),this.element.addClass("ui-accordion ui-widget ui-helper-reset"),this.headers=this.element.find(e.header).addClass("ui-accordion-header ui-helper-reset ui-state-default ui-corner-all"),this._hoverable(this.headers),this._focusable(this.headers),this.headers.next().addClass("ui-accordion-content ui-helper-reset ui-widget-content ui-corner-bottom").hide(),!e.collapsible&&(e.active===!1||e.active==null)&&(e.active=0),e.active<0&&(e.active+=this.headers.length),this.active=this._findActive(e.active).addClass("ui-accordion-header-active ui-state-active").toggleClass("ui-corner-all ui-corner-top"),this.active.next().addClass("ui-accordion-content-active").show(),this._createIcons(),this.refresh(),this.element.attr("role","tablist"),this.headers.attr("role","tab").each(function(e){var t=c(this),i=t.attr("id"),n=t.next(),r=n.attr("id");i||(i=o+"-header-"+e,t.attr("id",i)),r||(r=o+"-panel-"+e,n.attr("id",r)),t.attr("aria-controls",r),n.attr("aria-labelledby",i)}).next().attr("role","tabpanel"),this.headers.not(this.active).attr({"aria-selected":"false",tabIndex:-1}).next().attr({"aria-expanded":"false","aria-hidden":"true"}).hide(),this.active.length?this.active.attr({"aria-selected":"true",tabIndex:0}).next().attr({"aria-expanded":"true","aria-hidden":"false"}):this.headers.eq(0).attr("tabIndex",0),this._on(this.headers,{keydown:"_keydown"}),this._on(this.headers.next(),{keydown:"_panelKeyDown"}),this._setupEvents(e.event)},_getCreateEventData:function(){return{header:this.active,content:this.active.length?this.active.next():c()}},_createIcons:function(){var e=this.options.icons;e&&(c("<span>").addClass("ui-accordion-header-icon ui-icon "+e.header).prependTo(this.headers),this.active.children(".ui-accordion-header-icon").removeClass(e.header).addClass(e.activeHeader),this.headers.addClass("ui-accordion-icons"))},_destroyIcons:function(){this.headers.removeClass("ui-accordion-icons").children(".ui-accordion-header-icon").remove()},_destroy:function(){var e;this.element.removeClass("ui-accordion ui-widget ui-helper-reset").removeAttr("role"),this.headers.removeClass("ui-accordion-header ui-accordion-header-active ui-helper-reset ui-state-default ui-corner-all ui-state-active ui-state-disabled ui-corner-top").removeAttr("role").removeAttr("aria-selected").removeAttr("aria-controls").removeAttr("tabIndex").each(function(){/^ui-accordion/.test(this.id)&&this.removeAttribute("id")}),this._destroyIcons(),e=this.headers.next().css("display","").removeAttr("role").removeAttr("aria-expanded").removeAttr("aria-hidden").removeAttr("aria-labelledby").removeClass("ui-helper-reset ui-widget-content ui-corner-bottom ui-accordion-content ui-accordion-content-active ui-state-disabled").each(function(){/^ui-accordion/.test(this.id)&&this.removeAttribute("id")}),this.options.heightStyle!=="content"&&e.css("height","")},_setOption:function(e,t){if(e==="active"){this._activate(t);return}e==="event"&&(this.options.event&&this._off(this.headers,this.options.event),this._setupEvents(t)),this._super(e,t),e==="collapsible"&&!t&&this.options.active===!1&&this._activate(0),e==="icons"&&(this._destroyIcons(),t&&this._createIcons()),e==="disabled"&&this.headers.add(this.headers.next()).toggleClass("ui-state-disabled",!!t)},_keydown:function(e){if(e.altKey||e.ctrlKey)return;var t=c.ui.keyCode,i=this.headers.length,n=this.headers.index(e.target),r=!1;switch(e.keyCode){case t.RIGHT:case t.DOWN:r=this.headers[(n+1)%i];break;case t.LEFT:case t.UP:r=this.headers[(n-1+i)%i];break;case t.SPACE:case t.ENTER:this._eventHandler(e);break;case t.HOME:r=this.headers[0];break;case t.END:r=this.headers[i-1]}r&&(c(e.target).attr("tabIndex",-1),c(r).attr("tabIndex",0),r.focus(),e.preventDefault())},_panelKeyDown:function(e){e.keyCode===c.ui.keyCode.UP&&e.ctrlKey&&c(e.currentTarget).prev().focus()},refresh:function(){var i,e,t=this.options.heightStyle,n=this.element.parent();t==="fill"?(c.support.minHeight||(e=n.css("overflow"),n.css("overflow","hidden")),i=n.height(),this.element.siblings(":visible").each(function(){var e=c(this),t=e.css("position");if(t==="absolute"||t==="fixed")return;i-=e.outerHeight(!0)}),e&&n.css("overflow",e),this.headers.each(function(){i-=c(this).outerHeight(!0)}),this.headers.next().each(function(){c(this).height(Math.max(0,i-c(this).innerHeight()+c(this).height()))}).css("overflow","auto")):t==="auto"&&(i=0,this.headers.next().each(function(){i=Math.max(i,c(this).css("height","").height())}).height(i))},_activate:function(e){var t=this._findActive(e)[0];if(t===this.active[0])return;t=t||this.active[0],this._eventHandler({target:t,currentTarget:t,preventDefault:c.noop})},_findActive:function(e){return typeof e=="number"?this.headers.eq(e):c()},_setupEvents:function(e){var i={};if(!e)return;c.each(e.split(" "),function(e,t){i[t]="_eventHandler"}),this._on(this.headers,i)},_eventHandler:function(e){var t=this.options,i=this.active,n=c(e.currentTarget),r=n[0]===i[0],o=r&&t.collapsible,s=o?c():n.next(),a=i.next(),l={oldHeader:i,oldPanel:a,newHeader:o?c():n,newPanel:s};e.preventDefault();if(r&&!t.collapsible||this._trigger("beforeActivate",e,l)===!1)return;t.active=o?!1:this.headers.index(n),this.active=r?c():n,this._toggle(l),i.removeClass("ui-accordion-header-active ui-state-active"),t.icons&&i.children(".ui-accordion-header-icon").removeClass(t.icons.activeHeader).addClass(t.icons.header),r||(n.removeClass("ui-corner-all").addClass("ui-accordion-header-active ui-state-active ui-corner-top"),t.icons&&n.children(".ui-accordion-header-icon").removeClass(t.icons.header).addClass(t.icons.activeHeader),n.next().addClass("ui-accordion-content-active"))},_toggle:function(e){var t=e.newPanel,i=this.prevShow.length?this.prevShow:e.oldPanel;this.prevShow.add(this.prevHide).stop(!0,!0),this.prevShow=t,this.prevHide=i,this.options.animate?this._animate(t,i,e):(i.hide(),t.show(),this._toggleComplete(e)),i.attr({"aria-expanded":"false","aria-hidden":"true"}),i.prev().attr("aria-selected","false"),t.length&&i.length?i.prev().attr("tabIndex",-1):t.length&&this.headers.filter(function(){return c(this).attr("tabIndex")===0}).attr("tabIndex",-1),t.attr({"aria-expanded":"true","aria-hidden":"false"}).prev().attr({"aria-selected":"true",tabIndex:0})},_animate:function(e,i,t){var n,r,o,s=this,a=0,l=e.length&&(!i.length||e.index()<i.index()),c=this.options.animate||{},u=l&&c.down||c,d=function(){s._toggleComplete(t)};typeof u=="number"&&(o=u),typeof u=="string"&&(r=u),r=r||u.easing||c.easing,o=o||u.duration||c.duration;if(!i.length)return e.animate(h,o,r,d);if(!e.length)return i.animate(f,o,r,d);n=e.show().outerHeight(),i.animate(f,{duration:o,easing:r,step:function(e,t){t.now=Math.round(e)}}),e.hide().animate(h,{duration:o,easing:r,complete:d,step:function(e,t){t.now=Math.round(e),t.prop!=="height"?a+=t.now:s.options.heightStyle!=="content"&&(t.now=Math.round(n-i.outerHeight()-a),a=0)}})},_toggleComplete:function(e){var t=e.oldPanel;t.removeClass("ui-accordion-content-active").prev().removeClass("ui-corner-top").addClass("ui-corner-all"),t.length&&(t.parent()[0].className=t.parent()[0].className),this._trigger("activate",null,e)}}),c.uiBackCompat!==!1&&(function(r,e){r.extend(e.options,{navigation:!1,navigationFilter:function(){return this.href.toLowerCase()===location.href.toLowerCase()}});var o=e._create;e._create=function(){if(this.options.navigation){var t=this,e=this.element.find(this.options.header),i=e.next(),n=e.add(i).find("a").filter(this.options.navigationFilter)[0];n&&e.add(i).each(function(e){if(r.contains(this,n))return t.options.active=Math.floor(e/2),!1})}o.call(this)}}(jQuery,jQuery.ui.accordion.prototype),function(e,t){e.extend(t.options,{heightStyle:null,autoHeight:!0,clearStyle:!1,fillSpace:!1});var i=t._create,n=t._setOption;e.extend(t,{_create:function(){this.options.heightStyle=this.options.heightStyle||this._mergeHeightStyle(),i.call(this)},_setOption:function(e){if(e==="autoHeight"||e==="clearStyle"||e==="fillSpace")this.options.heightStyle=this._mergeHeightStyle();n.apply(this,arguments)},_mergeHeightStyle:function(){var e=this.options;if(e.fillSpace)return"fill";if(e.clearStyle)return"content";if(e.autoHeight)return"auto"}})}(jQuery,jQuery.ui.accordion.prototype),function(e,t){e.extend(t.options.icons,{activeHeader:null,headerSelected:"ui-icon-triangle-1-s"});var i=t._createIcons;t._createIcons=function(){this.options.icons&&(this.options.icons.activeHeader=this.options.icons.activeHeader||this.options.icons.headerSelected),i.call(this)}}(jQuery,jQuery.ui.accordion.prototype),function(e,t){t.activate=t._activate;var i=t._findActive;t._findActive=function(e){return e===-1&&(e=!1),e&&typeof e!="number"&&(e=this.headers.index(this.headers.filter(e)),e===-1&&(e=!1)),i.call(this,e)}}(jQuery,jQuery.ui.accordion.prototype),jQuery.ui.accordion.prototype.resize=jQuery.ui.accordion.prototype.refresh,function(e,t){e.extend(t.options,{change:null,changestart:null});var r=t._trigger;t._trigger=function(e,t,i){var n=r.apply(this,arguments);return n?(e==="beforeActivate"?n=r.call(this,"changestart",t,{oldHeader:i.oldHeader,oldContent:i.oldPanel,newHeader:i.newHeader,newContent:i.newPanel}):e==="activate"&&(n=r.call(this,"change",t,{oldHeader:i.oldHeader,oldContent:i.oldPanel,newHeader:i.newHeader,newContent:i.newPanel})),n):!1}}(jQuery,jQuery.ui.accordion.prototype),function(e,t){e.extend(t.options,{animate:null,animated:"slide"});var i=t._create;t._create=function(){var e=this.options;e.animate===null&&(e.animated?e.animated==="slide"?e.animate=300:e.animated==="bounceslide"?e.animate={duration:200,down:{easing:"easeOutBounce",duration:1e3}}:e.animate=e.animated:e.animate=!1),i.call(this)}}(jQuery,jQuery.ui.accordion.prototype))})(jQuery);(function(o,e){var n=0;o.widget("ui.autocomplete",{version:"1.9.2",defaultElement:"<input>",options:{appendTo:"body",autoFocus:!1,delay:300,minLength:1,position:{my:"left top",at:"left bottom",collision:"none"},source:null,change:null,close:null,focus:null,open:null,response:null,search:null,select:null},pending:0,_create:function(){var i,n,r;this.isMultiLine=this._isMultiLine(),this.valueMethod=this.element[this.element.is("input,textarea")?"val":"text"],this.isNewMenu=!0,this.element.addClass("ui-autocomplete-input").attr("autocomplete","off"),this._on(this.element,{keydown:function(e){if(this.element.prop("readOnly")){i=!0,r=!0,n=!0;return}i=!1,r=!1,n=!1;var t=o.ui.keyCode;switch(e.keyCode){case t.PAGE_UP:i=!0,this._move("previousPage",e);break;case t.PAGE_DOWN:i=!0,this._move("nextPage",e);break;case t.UP:i=!0,this._keyEvent("previous",e);break;case t.DOWN:i=!0,this._keyEvent("next",e);break;case t.ENTER:case t.NUMPAD_ENTER:this.menu.active&&(i=!0,e.preventDefault(),this.menu.select(e));break;case t.TAB:this.menu.active&&this.menu.select(e);break;case t.ESCAPE:this.menu.element.is(":visible")&&(this._value(this.term),this.close(e),e.preventDefault());break;default:n=!0,this._searchTimeout(e)}},keypress:function(e){if(i){i=!1,e.preventDefault();return}if(n)return;var t=o.ui.keyCode;switch(e.keyCode){case t.PAGE_UP:this._move("previousPage",e);break;case t.PAGE_DOWN:this._move("nextPage",e);break;case t.UP:this._keyEvent("previous",e);break;case t.DOWN:this._keyEvent("next",e)}},input:function(e){if(r){r=!1,e.preventDefault();return}this._searchTimeout(e)},focus:function(){this.selectedItem=null,this.previous=this._value()},blur:function(e){if(this.cancelBlur){delete this.cancelBlur;return}clearTimeout(this.searching),this.close(e),this._change(e)}}),this._initSource(),this.menu=o("<ul>").addClass("ui-autocomplete").appendTo(this.document.find(this.options.appendTo||"body")[0]).menu({input:o(),role:null}).zIndex(this.element.zIndex()+1).hide().data("menu"),this._on(this.menu.element,{mousedown:function(e){e.preventDefault(),this.cancelBlur=!0,this._delay(function(){delete this.cancelBlur});var i=this.menu.element[0];o(e.target).closest(".ui-menu-item").length||this._delay(function(){var t=this;this.document.one("mousedown",function(e){e.target!==t.element[0]&&e.target!==i&&!o.contains(i,e.target)&&t.close()})})},menufocus:function(e,t){if(this.isNewMenu){this.isNewMenu=!1;if(e.originalEvent&&/^mouse/.test(e.originalEvent.type)){this.menu.blur(),this.document.one("mousemove",function(){o(e.target).trigger(e.originalEvent)});return}}var i=t.item.data("ui-autocomplete-item")||t.item.data("item.autocomplete");!1!==this._trigger("focus",e,{item:i})?e.originalEvent&&/^key/.test(e.originalEvent.type)&&this._value(i.value):this.liveRegion.text(i.value)},menuselect:function(e,t){var i=t.item.data("ui-autocomplete-item")||t.item.data("item.autocomplete"),n=this.previous;this.element[0]!==this.document[0].activeElement&&(this.element.focus(),this.previous=n,this._delay(function(){this.previous=n,this.selectedItem=i})),!1!==this._trigger("select",e,{item:i})&&this._value(i.value),this.term=this._value(),this.close(e),this.selectedItem=i}}),this.liveRegion=o("<span>",{role:"status","aria-live":"polite"}).addClass("ui-helper-hidden-accessible").insertAfter(this.element),o.fn.bgiframe&&this.menu.element.bgiframe(),this._on(this.window,{beforeunload:function(){this.element.removeAttr("autocomplete")}})},_destroy:function(){clearTimeout(this.searching),this.element.removeClass("ui-autocomplete-input").removeAttr("autocomplete"),this.menu.element.remove(),this.liveRegion.remove()},_setOption:function(e,t){this._super(e,t),e==="source"&&this._initSource(),e==="appendTo"&&this.menu.element.appendTo(this.document.find(t||"body")[0]),e==="disabled"&&t&&this.xhr&&this.xhr.abort()},_isMultiLine:function(){return this.element.is("textarea")?!0:this.element.is("input")?!1:this.element.prop("isContentEditable")},_initSource:function(){var i,n,r=this;o.isArray(this.options.source)?(i=this.options.source,this.source=function(e,t){t(o.ui.autocomplete.filter(i,e.term))}):typeof this.options.source=="string"?(n=this.options.source,this.source=function(e,t){r.xhr&&r.xhr.abort(),r.xhr=o.ajax({url:n,data:e,dataType:"json",success:function(e){t(e)},error:function(){t([])}})}):this.source=this.options.source},_searchTimeout:function(e){clearTimeout(this.searching),this.searching=this._delay(function(){this.term!==this._value()&&(this.selectedItem=null,this.search(null,e))},this.options.delay)},search:function(e,t){e=e!=null?e:this._value(),this.term=this._value();if(e.length<this.options.minLength)return this.close(t);if(this._trigger("search",t)===!1)return;return this._search(e)},_search:function(e){this.pending++,this.element.addClass("ui-autocomplete-loading"),this.cancelSearch=!1,this.source({term:e},this._response())},_response:function(){var t=this,i=++n;return function(e){i===n&&t.__response(e),t.pending--,t.pending||t.element.removeClass("ui-autocomplete-loading")}},__response:function(e){e&&(e=this._normalize(e)),this._trigger("response",null,{content:e}),!this.options.disabled&&e&&e.length&&!this.cancelSearch?(this._suggest(e),this._trigger("open")):this._close()},close:function(e){this.cancelSearch=!0,this._close(e)},_close:function(e){this.menu.element.is(":visible")&&(this.menu.element.hide(),this.menu.blur(),this.isNewMenu=!0,this._trigger("close",e))},_change:function(e){this.previous!==this._value()&&this._trigger("change",e,{item:this.selectedItem})},_normalize:function(e){return e.length&&e[0].label&&e[0].value?e:o.map(e,function(e){return typeof e=="string"?{label:e,value:e}:o.extend({label:e.label||e.value,value:e.value||e.label},e)})},_suggest:function(e){var t=this.menu.element.empty().zIndex(this.element.zIndex()+1);this._renderMenu(t,e),this.menu.refresh(),t.show(),this._resizeMenu(),t.position(o.extend({of:this.element},this.options.position)),this.options.autoFocus&&this.menu.next()},_resizeMenu:function(){var e=this.menu.element;e.outerWidth(Math.max(e.width("").outerWidth()+1,this.element.outerWidth()))},_renderMenu:function(i,e){var n=this;o.each(e,function(e,t){n._renderItemData(i,t)})},_renderItemData:function(e,t){return this._renderItem(e,t).data("ui-autocomplete-item",t)},_renderItem:function(e,t){return o("<li>").append(o("<a>").text(t.label)).appendTo(e)},_move:function(e,t){if(!this.menu.element.is(":visible")){this.search(null,t);return}if(this.menu.isFirstItem()&&/^previous/.test(e)||this.menu.isLastItem()&&/^next/.test(e)){this._value(this.term),this.menu.blur();return}this.menu[e](t)},widget:function(){return this.menu.element},_value:function(){return this.valueMethod.apply(this.element,arguments)},_keyEvent:function(e,t){if(!this.isMultiLine||this.menu.element.is(":visible"))this._move(e,t),t.preventDefault()}}),o.extend(o.ui.autocomplete,{escapeRegex:function(e){return e.replace(/[\-\[\]{}()*+?.,\\\^$|#\s]/g,"\\$&")},filter:function(e,t){var i=new RegExp(o.ui.autocomplete.escapeRegex(t),"i");return o.grep(e,function(e){return i.test(e.label||e.value||e)})}}),o.widget("ui.autocomplete",o.ui.autocomplete,{options:{messages:{noResults:"No search results.",results:function(e){return e+(e>1?" results are":" result is")+" available, use up and down arrow keys to navigate."}}},__response:function(e){var t;this._superApply(arguments);if(this.options.disabled||this.cancelSearch)return;e&&e.length?t=this.options.messages.results(e.length):t=this.options.messages.noResults,this.liveRegion.text(t)}})})(jQuery);(function(o,e){var s,a,l,c,u="ui-button ui-widget ui-state-default ui-corner-all",t="ui-state-hover ui-state-active ",d="ui-button-icons-only ui-button-icon-only ui-button-text-icons ui-button-text-icon-primary ui-button-text-icon-secondary ui-button-text-only",f=function(){var e=o(this).find(":ui-button");setTimeout(function(){e.button("refresh")},1)},h=function(e){var t=e.name,i=e.form,n=o([]);return t&&(i?n=o(i).find("[name='"+t+"']"):n=o("[name='"+t+"']",e.ownerDocument).filter(function(){return!this.form})),n};o.widget("ui.button",{version:"1.9.2",defaultElement:"<button>",options:{disabled:null,text:!0,label:null,icons:{primary:null,secondary:null}},_create:function(){this.element.closest("form").unbind("reset"+this.eventNamespace).bind("reset"+this.eventNamespace,f),typeof this.options.disabled!="boolean"?this.options.disabled=!!this.element.prop("disabled"):this.element.prop("disabled",this.options.disabled),this._determineButtonType(),this.hasTitle=!!this.buttonElement.attr("title");var t=this,i=this.options,e=this.type==="checkbox"||this.type==="radio",n=e?"":"ui-state-active",r="ui-state-focus";i.label===null&&(i.label=this.type==="input"?this.buttonElement.val():this.buttonElement.html()),this._hoverable(this.buttonElement),this.buttonElement.addClass(u).attr("role","button").bind("mouseenter"+this.eventNamespace,function(){if(i.disabled)return;this===s&&o(this).addClass("ui-state-active")}).bind("mouseleave"+this.eventNamespace,function(){if(i.disabled)return;o(this).removeClass(n)}).bind("click"+this.eventNamespace,function(e){i.disabled&&(e.preventDefault(),e.stopImmediatePropagation())}),this.element.bind("focus"+this.eventNamespace,function(){t.buttonElement.addClass(r)}).bind("blur"+this.eventNamespace,function(){t.buttonElement.removeClass(r)}),e&&(this.element.bind("change"+this.eventNamespace,function(){if(c)return;t.refresh()}),this.buttonElement.bind("mousedown"+this.eventNamespace,function(e){if(i.disabled)return;c=!1,a=e.pageX,l=e.pageY}).bind("mouseup"+this.eventNamespace,function(e){if(i.disabled)return;if(a!==e.pageX||l!==e.pageY)c=!0})),this.type==="checkbox"?this.buttonElement.bind("click"+this.eventNamespace,function(){if(i.disabled||c)return!1;o(this).toggleClass("ui-state-active"),t.buttonElement.attr("aria-pressed",t.element[0].checked)}):this.type==="radio"?this.buttonElement.bind("click"+this.eventNamespace,function(){if(i.disabled||c)return!1;o(this).addClass("ui-state-active"),t.buttonElement.attr("aria-pressed","true");var e=t.element[0];h(e).not(e).map(function(){return o(this).button("widget")[0]}).removeClass("ui-state-active").attr("aria-pressed","false")}):(this.buttonElement.bind("mousedown"+this.eventNamespace,function(){if(i.disabled)return!1;o(this).addClass("ui-state-active"),s=this,t.document.one("mouseup",function(){s=null})}).bind("mouseup"+this.eventNamespace,function(){if(i.disabled)return!1;o(this).removeClass("ui-state-active")}).bind("keydown"+this.eventNamespace,function(e){if(i.disabled)return!1;(e.keyCode===o.ui.keyCode.SPACE||e.keyCode===o.ui.keyCode.ENTER)&&o(this).addClass("ui-state-active")}).bind("keyup"+this.eventNamespace,function(){o(this).removeClass("ui-state-active")}),this.buttonElement.is("a")&&this.buttonElement.keyup(function(e){e.keyCode===o.ui.keyCode.SPACE&&o(this).click()})),this._setOption("disabled",i.disabled),this._resetButton()},_determineButtonType:function(){var e,t,i;this.element.is("[type=checkbox]")?this.type="checkbox":this.element.is("[type=radio]")?this.type="radio":this.element.is("input")?this.type="input":this.type="button",this.type==="checkbox"||this.type==="radio"?(e=this.element.parents().last(),t="label[for='"+this.element.attr("id")+"']",this.buttonElement=e.find(t),this.buttonElement.length||(e=e.length?e.siblings():this.element.siblings(),this.buttonElement=e.filter(t),this.buttonElement.length||(this.buttonElement=e.find(t))),this.element.addClass("ui-helper-hidden-accessible"),i=this.element.is(":checked"),i&&this.buttonElement.addClass("ui-state-active"),this.buttonElement.prop("aria-pressed",i)):this.buttonElement=this.element},widget:function(){return this.buttonElement},_destroy:function(){this.element.removeClass("ui-helper-hidden-accessible"),this.buttonElement.removeClass(u+" "+t+" "+d).removeAttr("role").removeAttr("aria-pressed").html(this.buttonElement.find(".ui-button-text").html()),this.hasTitle||this.buttonElement.removeAttr("title")},_setOption:function(e,t){this._super(e,t);if(e==="disabled"){t?this.element.prop("disabled",!0):this.element.prop("disabled",!1);return}this._resetButton()},refresh:function(){var e=this.element.is("input, button")?this.element.is(":disabled"):this.element.hasClass("ui-button-disabled");e!==this.options.disabled&&this._setOption("disabled",e),this.type==="radio"?h(this.element[0]).each(function(){o(this).is(":checked")?o(this).button("widget").addClass("ui-state-active").attr("aria-pressed","true"):o(this).button("widget").removeClass("ui-state-active").attr("aria-pressed","false")}):this.type==="checkbox"&&(this.element.is(":checked")?this.buttonElement.addClass("ui-state-active").attr("aria-pressed","true"):this.buttonElement.removeClass("ui-state-active").attr("aria-pressed","false"))},_resetButton:function(){if(this.type==="input"){this.options.label&&this.element.val(this.options.label);return}var e=this.buttonElement.removeClass(d),t=o("<span></span>",this.document[0]).addClass("ui-button-text").html(this.options.label).appendTo(e.empty()).text(),i=this.options.icons,n=i.primary&&i.secondary,r=[];i.primary||i.secondary?(this.options.text&&r.push("ui-button-text-icon"+(n?"s":i.primary?"-primary":"-secondary")),i.primary&&e.prepend("<span class='ui-button-icon-primary ui-icon "+i.primary+"'></span>"),i.secondary&&e.append("<span class='ui-button-icon-secondary ui-icon "+i.secondary+"'></span>"),this.options.text||(r.push(n?"ui-button-icons-only":"ui-button-icon-only"),this.hasTitle||e.attr("title",o.trim(t)))):r.push("ui-button-text-only"),e.addClass(r.join(" "))}}),o.widget("ui.buttonset",{version:"1.9.2",options:{items:"button, input[type=button], input[type=submit], input[type=reset], input[type=checkbox], input[type=radio], a, :data(button)"},_create:function(){this.element.addClass("ui-buttonset")},_init:function(){this.refresh()},_setOption:function(e,t){e==="disabled"&&this.buttons.button("option",e,t),this._super(e,t)},refresh:function(){var e=this.element.css("direction")==="rtl";this.buttons=this.element.find(this.options.items).filter(":ui-button").button("refresh").end().not(":ui-button").button().end().map(function(){return o(this).button("widget")[0]}).removeClass("ui-corner-all ui-corner-left ui-corner-right").filter(":first").addClass(e?"ui-corner-right":"ui-corner-left").end().filter(":last").addClass(e?"ui-corner-left":"ui-corner-right").end().end()},_destroy:function(){this.element.removeClass("ui-buttonset"),this.buttons.map(function(){return o(this).button("widget")[0]}).removeClass("ui-corner-left ui-corner-right").end().button("destroy")}})})(jQuery);(function($,undefined){function Datepicker(){this.debug=!1,this._curInst=null,this._keyEvent=!1,this._disabledInputs=[],this._datepickerShowing=!1,this._inDialog=!1,this._mainDivId="ui-datepicker-div",this._inlineClass="ui-datepicker-inline",this._appendClass="ui-datepicker-append",this._triggerClass="ui-datepicker-trigger",this._dialogClass="ui-datepicker-dialog",this._disableClass="ui-datepicker-disabled",this._unselectableClass="ui-datepicker-unselectable",this._currentClass="ui-datepicker-current-day",this._dayOverClass="ui-datepicker-days-cell-over",this.regional=[],this.regional[""]={closeText:"Done",prevText:"Prev",nextText:"Next",currentText:"Today",monthNames:["January","February","March","April","May","June","July","August","September","October","November","December"],monthNamesShort:["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"],dayNames:["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],dayNamesShort:["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],dayNamesMin:["Su","Mo","Tu","We","Th","Fr","Sa"],weekHeader:"Wk",dateFormat:"mm/dd/yy",firstDay:0,isRTL:!1,showMonthAfterYear:!1,yearSuffix:""},this._defaults={showOn:"focus",showAnim:"fadeIn",showOptions:{},defaultDate:null,appendText:"",buttonText:"...",buttonImage:"",buttonImageOnly:!1,hideIfNoPrevNext:!1,navigationAsDateFormat:!1,gotoCurrent:!1,changeMonth:!1,changeYear:!1,yearRange:"c-10:c+10",showOtherMonths:!1,selectOtherMonths:!1,showWeek:!1,calculateWeek:this.iso8601Week,shortYearCutoff:"+10",minDate:null,maxDate:null,duration:"fast",beforeShowDay:null,beforeShow:null,onSelect:null,onChangeMonthYear:null,onClose:null,numberOfMonths:1,showCurrentAtPos:0,stepMonths:1,stepBigMonths:12,altField:"",altFormat:"",constrainInput:!0,showButtonPanel:!1,autoSize:!1,disabled:!1},$.extend(this._defaults,this.regional[""]),this.dpDiv=bindHover($('<div id="'+this._mainDivId+'" class="ui-datepicker ui-widget ui-widget-content ui-helper-clearfix ui-corner-all"></div>'))}function bindHover(e){var t="button, .ui-datepicker-prev, .ui-datepicker-next, .ui-datepicker-calendar td a";return e.delegate(t,"mouseout",function(){$(this).removeClass("ui-state-hover"),this.className.indexOf("ui-datepicker-prev")!=-1&&$(this).removeClass("ui-datepicker-prev-hover"),this.className.indexOf("ui-datepicker-next")!=-1&&$(this).removeClass("ui-datepicker-next-hover")}).delegate(t,"mouseover",function(){$.datepicker._isDisabledDatepicker(instActive.inline?e.parent()[0]:instActive.input[0])||($(this).parents(".ui-datepicker-calendar").find("a").removeClass("ui-state-hover"),$(this).addClass("ui-state-hover"),this.className.indexOf("ui-datepicker-prev")!=-1&&$(this).addClass("ui-datepicker-prev-hover"),this.className.indexOf("ui-datepicker-next")!=-1&&$(this).addClass("ui-datepicker-next-hover"))})}function extendRemove(e,t){$.extend(e,t);for(var i in t)if(t[i]==null||t[i]==undefined)e[i]=t[i];return e}$.extend($.ui,{datepicker:{version:"1.9.2"}});var PROP_NAME="datepicker",dpuuid=(new Date).getTime(),instActive;$.extend(Datepicker.prototype,{markerClassName:"hasDatepicker",maxRows:4,log:function(){this.debug&&console.log.apply("",arguments)},_widgetDatepicker:function(){return this.dpDiv},setDefaults:function(e){return extendRemove(this._defaults,e||{}),this},_attachDatepicker:function(target,settings){var inlineSettings=null;for(var attrName in this._defaults){var attrValue=target.getAttribute("date:"+attrName);if(attrValue){inlineSettings=inlineSettings||{};try{inlineSettings[attrName]=eval(attrValue)}catch(err){inlineSettings[attrName]=attrValue}}}var nodeName=target.nodeName.toLowerCase(),inline=nodeName=="div"||nodeName=="span";target.id||(this.uuid+=1,target.id="dp"+this.uuid);var inst=this._newInst($(target),inline);inst.settings=$.extend({},settings||{},inlineSettings||{}),nodeName=="input"?this._connectDatepicker(target,inst):inline&&this._inlineDatepicker(target,inst)},_newInst:function(e,t){var i=e[0].id.replace(/([^A-Za-z0-9_-])/g,"\\\\$1");return{id:i,input:e,selectedDay:0,selectedMonth:0,selectedYear:0,drawMonth:0,drawYear:0,inline:t,dpDiv:t?bindHover($('<div class="'+this._inlineClass+' ui-datepicker ui-widget ui-widget-content ui-helper-clearfix ui-corner-all"></div>')):this.dpDiv}},_connectDatepicker:function(e,n){var t=$(e);n.append=$([]),n.trigger=$([]);if(t.hasClass(this.markerClassName))return;this._attachments(t,n),t.addClass(this.markerClassName).keydown(this._doKeyDown).keypress(this._doKeyPress).keyup(this._doKeyUp).bind("setData.datepicker",function(e,t,i){n.settings[t]=i}).bind("getData.datepicker",function(e,t){return this._get(n,t)}),this._autoSize(n),$.data(e,PROP_NAME,n),n.settings.disabled&&this._disableDatepicker(e)},_attachments:function(e,t){var i=this._get(t,"appendText"),n=this._get(t,"isRTL");t.append&&t.append.remove(),i&&(t.append=$('<span class="'+this._appendClass+'">'+i+"</span>"),e[n?"before":"after"](t.append)),e.unbind("focus",this._showDatepicker),t.trigger&&t.trigger.remove();var r=this._get(t,"showOn");(r=="focus"||r=="both")&&e.focus(this._showDatepicker);if(r=="button"||r=="both"){var o=this._get(t,"buttonText"),s=this._get(t,"buttonImage");t.trigger=$(this._get(t,"buttonImageOnly")?$("<img/>").addClass(this._triggerClass).attr({src:s,alt:o,title:o}):$('<button type="button"></button>').addClass(this._triggerClass).html(s==""?o:$("<img/>").attr({src:s,alt:o,title:o}))),e[n?"before":"after"](t.trigger),t.trigger.click(function(){return $.datepicker._datepickerShowing&&$.datepicker._lastInput==e[0]?$.datepicker._hideDatepicker():$.datepicker._datepickerShowing&&$.datepicker._lastInput!=e[0]?($.datepicker._hideDatepicker(),$.datepicker._showDatepicker(e[0])):$.datepicker._showDatepicker(e[0]),!1})}},_autoSize:function(e){if(this._get(e,"autoSize")&&!e.inline){var t=new Date(2009,11,20),i=this._get(e,"dateFormat");if(i.match(/[DM]/)){var n=function(e){var t=0,i=0;for(var n=0;n<e.length;n++)e[n].length>t&&(t=e[n].length,i=n);return i};t.setMonth(n(this._get(e,i.match(/MM/)?"monthNames":"monthNamesShort"))),t.setDate(n(this._get(e,i.match(/DD/)?"dayNames":"dayNamesShort"))+20-t.getDay())}e.input.attr("size",this._formatDate(e,t).length)}},_inlineDatepicker:function(e,n){var t=$(e);if(t.hasClass(this.markerClassName))return;t.addClass(this.markerClassName).append(n.dpDiv).bind("setData.datepicker",function(e,t,i){n.settings[t]=i}).bind("getData.datepicker",function(e,t){return this._get(n,t)}),$.data(e,PROP_NAME,n),this._setDate(n,this._getDefaultDate(n),!0),this._updateDatepicker(n),this._updateAlternate(n),n.settings.disabled&&this._disableDatepicker(e),n.dpDiv.css("display","block")},_dialogDatepicker:function(e,t,i,n,r){var o=this._dialogInst;if(!o){this.uuid+=1;var s="dp"+this.uuid;this._dialogInput=$('<input type="text" id="'+s+'" style="position: absolute; top: -100px; width: 0px;"/>'),this._dialogInput.keydown(this._doKeyDown),$("body").append(this._dialogInput),o=this._dialogInst=this._newInst(this._dialogInput,!1),o.settings={},$.data(this._dialogInput[0],PROP_NAME,o)}extendRemove(o.settings,n||{}),t=t&&t.constructor==Date?this._formatDate(o,t):t,this._dialogInput.val(t),this._pos=r?r.length?r:[r.pageX,r.pageY]:null;if(!this._pos){var a=document.documentElement.clientWidth,l=document.documentElement.clientHeight,c=document.documentElement.scrollLeft||document.body.scrollLeft,u=document.documentElement.scrollTop||document.body.scrollTop;this._pos=[a/2-100+c,l/2-150+u]}return this._dialogInput.css("left",this._pos[0]+20+"px").css("top",this._pos[1]+"px"),o.settings.onSelect=i,this._inDialog=!0,this.dpDiv.addClass(this._dialogClass),this._showDatepicker(this._dialogInput[0]),$.blockUI&&$.blockUI(this.dpDiv),$.data(this._dialogInput[0],PROP_NAME,o),this},_destroyDatepicker:function(e){var t=$(e),i=$.data(e,PROP_NAME);if(!t.hasClass(this.markerClassName))return;var n=e.nodeName.toLowerCase();$.removeData(e,PROP_NAME),n=="input"?(i.append.remove(),i.trigger.remove(),t.removeClass(this.markerClassName).unbind("focus",this._showDatepicker).unbind("keydown",this._doKeyDown).unbind("keypress",this._doKeyPress).unbind("keyup",this._doKeyUp)):(n=="div"||n=="span")&&t.removeClass(this.markerClassName).empty()},_enableDatepicker:function(t){var e=$(t),i=$.data(t,PROP_NAME);if(!e.hasClass(this.markerClassName))return;var n=t.nodeName.toLowerCase();if(n=="input")t.disabled=!1,i.trigger.filter("button").each(function(){this.disabled=!1}).end().filter("img").css({opacity:"1.0",cursor:""});else if(n=="div"||n=="span"){var r=e.children("."+this._inlineClass);r.children().removeClass("ui-state-disabled"),r.find("select.ui-datepicker-month, select.ui-datepicker-year").prop("disabled",!1)}this._disabledInputs=$.map(this._disabledInputs,function(e){return e==t?null:e})},_disableDatepicker:function(t){var e=$(t),i=$.data(t,PROP_NAME);if(!e.hasClass(this.markerClassName))return;var n=t.nodeName.toLowerCase();if(n=="input")t.disabled=!0,i.trigger.filter("button").each(function(){this.disabled=!0}).end().filter("img").css({opacity:"0.5",cursor:"default"});else if(n=="div"||n=="span"){var r=e.children("."+this._inlineClass);r.children().addClass("ui-state-disabled"),r.find("select.ui-datepicker-month, select.ui-datepicker-year").prop("disabled",!0)}this._disabledInputs=$.map(this._disabledInputs,function(e){return e==t?null:e}),this._disabledInputs[this._disabledInputs.length]=t},_isDisabledDatepicker:function(e){if(!e)return!1;for(var t=0;t<this._disabledInputs.length;t++)if(this._disabledInputs[t]==e)return!0;return!1},_getInst:function(e){try{return $.data(e,PROP_NAME)}catch(e){throw"Missing instance data for this datepicker"}},_optionDatepicker:function(e,t,i){var n=this._getInst(e);if(arguments.length==2&&typeof t=="string")return t=="defaults"?$.extend({},$.datepicker._defaults):n?t=="all"?$.extend({},n.settings):this._get(n,t):null;var r=t||{};typeof t=="string"&&(r={},r[t]=i);if(n){this._curInst==n&&this._hideDatepicker();var o=this._getDateDatepicker(e,!0),s=this._getMinMaxDate(n,"min"),a=this._getMinMaxDate(n,"max");extendRemove(n.settings,r),s!==null&&r.dateFormat!==undefined&&r.minDate===undefined&&(n.settings.minDate=this._formatDate(n,s)),a!==null&&r.dateFormat!==undefined&&r.maxDate===undefined&&(n.settings.maxDate=this._formatDate(n,a)),this._attachments($(e),n),this._autoSize(n),this._setDate(n,o),this._updateAlternate(n),this._updateDatepicker(n)}},_changeDatepicker:function(e,t,i){this._optionDatepicker(e,t,i)},_refreshDatepicker:function(e){var t=this._getInst(e);t&&this._updateDatepicker(t)},_setDateDatepicker:function(e,t){var i=this._getInst(e);i&&(this._setDate(i,t),this._updateDatepicker(i),this._updateAlternate(i))},_getDateDatepicker:function(e,t){var i=this._getInst(e);return i&&!i.inline&&this._setDateFromField(i,t),i?this._getDate(i):null},_doKeyDown:function(e){var t=$.datepicker._getInst(e.target),i=!0,n=t.dpDiv.is(".ui-datepicker-rtl");t._keyEvent=!0;if($.datepicker._datepickerShowing)switch(e.keyCode){case 9:$.datepicker._hideDatepicker(),i=!1;break;case 13:var r=$("td."+$.datepicker._dayOverClass+":not(."+$.datepicker._currentClass+")",t.dpDiv);r[0]&&$.datepicker._selectDay(e.target,t.selectedMonth,t.selectedYear,r[0]);var o=$.datepicker._get(t,"onSelect");if(o){var s=$.datepicker._formatDate(t);o.apply(t.input?t.input[0]:null,[s,t])}else $.datepicker._hideDatepicker();return!1;case 27:$.datepicker._hideDatepicker();break;case 33:$.datepicker._adjustDate(e.target,e.ctrlKey?-$.datepicker._get(t,"stepBigMonths"):-$.datepicker._get(t,"stepMonths"),"M");break;case 34:$.datepicker._adjustDate(e.target,e.ctrlKey?+$.datepicker._get(t,"stepBigMonths"):+$.datepicker._get(t,"stepMonths"),"M");break;case 35:(e.ctrlKey||e.metaKey)&&$.datepicker._clearDate(e.target),i=e.ctrlKey||e.metaKey;break;case 36:(e.ctrlKey||e.metaKey)&&$.datepicker._gotoToday(e.target),i=e.ctrlKey||e.metaKey;break;case 37:(e.ctrlKey||e.metaKey)&&$.datepicker._adjustDate(e.target,n?1:-1,"D"),i=e.ctrlKey||e.metaKey,e.originalEvent.altKey&&$.datepicker._adjustDate(e.target,e.ctrlKey?-$.datepicker._get(t,"stepBigMonths"):-$.datepicker._get(t,"stepMonths"),"M");break;case 38:(e.ctrlKey||e.metaKey)&&$.datepicker._adjustDate(e.target,-7,"D"),i=e.ctrlKey||e.metaKey;break;case 39:(e.ctrlKey||e.metaKey)&&$.datepicker._adjustDate(e.target,n?-1:1,"D"),i=e.ctrlKey||e.metaKey,e.originalEvent.altKey&&$.datepicker._adjustDate(e.target,e.ctrlKey?+$.datepicker._get(t,"stepBigMonths"):+$.datepicker._get(t,"stepMonths"),"M");break;case 40:(e.ctrlKey||e.metaKey)&&$.datepicker._adjustDate(e.target,7,"D"),i=e.ctrlKey||e.metaKey;break;default:i=!1}else e.keyCode==36&&e.ctrlKey?$.datepicker._showDatepicker(this):i=!1;i&&(e.preventDefault(),e.stopPropagation())},_doKeyPress:function(e){var t=$.datepicker._getInst(e.target);if($.datepicker._get(t,"constrainInput")){var i=$.datepicker._possibleChars($.datepicker._get(t,"dateFormat")),n=String.fromCharCode(e.charCode==undefined?e.keyCode:e.charCode);return e.ctrlKey||e.metaKey||n<" "||!i||i.indexOf(n)>-1}},_doKeyUp:function(e){var t=$.datepicker._getInst(e.target);if(t.input.val()!=t.lastVal)try{var i=$.datepicker.parseDate($.datepicker._get(t,"dateFormat"),t.input?t.input.val():null,$.datepicker._getFormatConfig(t));i&&($.datepicker._setDateFromField(t),$.datepicker._updateAlternate(t),$.datepicker._updateDatepicker(t))}catch(e){$.datepicker.log(e)}return!0},_showDatepicker:function(e){e=e.target||e,e.nodeName.toLowerCase()!="input"&&(e=$("input",e.parentNode)[0]);if($.datepicker._isDisabledDatepicker(e)||$.datepicker._lastInput==e)return;var i=$.datepicker._getInst(e);$.datepicker._curInst&&$.datepicker._curInst!=i&&($.datepicker._curInst.dpDiv.stop(!0,!0),i&&$.datepicker._datepickerShowing&&$.datepicker._hideDatepicker($.datepicker._curInst.input[0]));var t=$.datepicker._get(i,"beforeShow"),n=t?t.apply(e,[e,i]):{};if(n===!1)return;extendRemove(i.settings,n),i.lastVal=null,$.datepicker._lastInput=e,$.datepicker._setDateFromField(i),$.datepicker._inDialog&&(e.value=""),$.datepicker._pos||($.datepicker._pos=$.datepicker._findPos(e),$.datepicker._pos[1]+=e.offsetHeight);var r=!1;$(e).parents().each(function(){return r|=$(this).css("position")=="fixed",!r});var o={left:$.datepicker._pos[0],top:$.datepicker._pos[1]};$.datepicker._pos=null,i.dpDiv.empty(),i.dpDiv.css({position:"absolute",display:"block",top:"-1000px"}),$.datepicker._updateDatepicker(i),o=$.datepicker._checkOffset(i,o,r),i.dpDiv.css({position:$.datepicker._inDialog&&$.blockUI?"static":r?"fixed":"absolute",display:"none",left:o.left+"px",top:o.top+"px"});if(!i.inline){var s=$.datepicker._get(i,"showAnim"),a=$.datepicker._get(i,"duration"),l=function(){var e=i.dpDiv.find("iframe.ui-datepicker-cover");if(!!e.length){var t=$.datepicker._getBorders(i.dpDiv);e.css({left:-t[0],top:-t[1],width:i.dpDiv.outerWidth(),height:i.dpDiv.outerHeight()})}};i.dpDiv.zIndex($(e).zIndex()+1),$.datepicker._datepickerShowing=!0,$.effects&&($.effects.effect[s]||$.effects[s])?i.dpDiv.show(s,$.datepicker._get(i,"showOptions"),a,l):i.dpDiv[s||"show"](s?a:null,l),(!s||!a)&&l(),i.input.is(":visible")&&!i.input.is(":disabled")&&i.input.focus(),$.datepicker._curInst=i}},_updateDatepicker:function(e){this.maxRows=4;var t=$.datepicker._getBorders(e.dpDiv);instActive=e,e.dpDiv.empty().append(this._generateHTML(e)),this._attachHandlers(e);var i=e.dpDiv.find("iframe.ui-datepicker-cover");!i.length||i.css({left:-t[0],top:-t[1],width:e.dpDiv.outerWidth(),height:e.dpDiv.outerHeight()}),e.dpDiv.find("."+this._dayOverClass+" a").mouseover();var n=this._getNumberOfMonths(e),r=n[1],o=17;e.dpDiv.removeClass("ui-datepicker-multi-2 ui-datepicker-multi-3 ui-datepicker-multi-4").width(""),r>1&&e.dpDiv.addClass("ui-datepicker-multi-"+r).css("width",o*r+"em"),e.dpDiv[(n[0]!=1||n[1]!=1?"add":"remove")+"Class"]("ui-datepicker-multi"),e.dpDiv[(this._get(e,"isRTL")?"add":"remove")+"Class"]("ui-datepicker-rtl"),e==$.datepicker._curInst&&$.datepicker._datepickerShowing&&e.input&&e.input.is(":visible")&&!e.input.is(":disabled")&&e.input[0]!=document.activeElement&&e.input.focus();if(e.yearshtml){var s=e.yearshtml;setTimeout(function(){s===e.yearshtml&&e.yearshtml&&e.dpDiv.find("select.ui-datepicker-year:first").replaceWith(e.yearshtml),s=e.yearshtml=null},0)}},_getBorders:function(e){var t=function(e){return{thin:1,medium:2,thick:3}[e]||e};return[parseFloat(t(e.css("border-left-width"))),parseFloat(t(e.css("border-top-width")))]},_checkOffset:function(e,t,i){var n=e.dpDiv.outerWidth(),r=e.dpDiv.outerHeight(),o=e.input?e.input.outerWidth():0,s=e.input?e.input.outerHeight():0,a=document.documentElement.clientWidth+(i?0:$(document).scrollLeft()),l=document.documentElement.clientHeight+(i?0:$(document).scrollTop());return t.left-=this._get(e,"isRTL")?n-o:0,t.left-=i&&t.left==e.input.offset().left?$(document).scrollLeft():0,t.top-=i&&t.top==e.input.offset().top+s?$(document).scrollTop():0,t.left-=Math.min(t.left,t.left+n>a&&a>n?Math.abs(t.left+n-a):0),t.top-=Math.min(t.top,t.top+r>l&&l>r?Math.abs(r+s):0),t},_findPos:function(e){var t=this._getInst(e),i=this._get(t,"isRTL");while(e&&(e.type=="hidden"||e.nodeType!=1||$.expr.filters.hidden(e)))e=e[i?"previousSibling":"nextSibling"];var n=$(e).offset();return[n.left,n.top]},_hideDatepicker:function(e){var t=this._curInst;if(!t||e&&t!=$.data(e,PROP_NAME))return;if(this._datepickerShowing){var i=this._get(t,"showAnim"),n=this._get(t,"duration"),r=function(){$.datepicker._tidyDialog(t)};$.effects&&($.effects.effect[i]||$.effects[i])?t.dpDiv.hide(i,$.datepicker._get(t,"showOptions"),n,r):t.dpDiv[i=="slideDown"?"slideUp":i=="fadeIn"?"fadeOut":"hide"](i?n:null,r),i||r(),this._datepickerShowing=!1;var o=this._get(t,"onClose");o&&o.apply(t.input?t.input[0]:null,[t.input?t.input.val():"",t]),this._lastInput=null,this._inDialog&&(this._dialogInput.css({position:"absolute",left:"0",top:"-100px"}),$.blockUI&&($.unblockUI(),$("body").append(this.dpDiv))),this._inDialog=!1}},_tidyDialog:function(e){e.dpDiv.removeClass(this._dialogClass).unbind(".ui-datepicker-calendar")},_checkExternalClick:function(e){if(!$.datepicker._curInst)return;var t=$(e.target),i=$.datepicker._getInst(t[0]);(t[0].id!=$.datepicker._mainDivId&&t.parents("#"+$.datepicker._mainDivId).length==0&&!t.hasClass($.datepicker.markerClassName)&&!t.closest("."+$.datepicker._triggerClass).length&&$.datepicker._datepickerShowing&&(!$.datepicker._inDialog||!$.blockUI)||t.hasClass($.datepicker.markerClassName)&&$.datepicker._curInst!=i)&&$.datepicker._hideDatepicker()},_adjustDate:function(e,t,i){var n=$(e),r=this._getInst(n[0]);if(this._isDisabledDatepicker(n[0]))return;this._adjustInstDate(r,t+(i=="M"?this._get(r,"showCurrentAtPos"):0),i),this._updateDatepicker(r)},_gotoToday:function(e){var t=$(e),i=this._getInst(t[0]);if(this._get(i,"gotoCurrent")&&i.currentDay)i.selectedDay=i.currentDay,i.drawMonth=i.selectedMonth=i.currentMonth,i.drawYear=i.selectedYear=i.currentYear;else{var n=new Date;i.selectedDay=n.getDate(),i.drawMonth=i.selectedMonth=n.getMonth(),i.drawYear=i.selectedYear=n.getFullYear()}this._notifyChange(i),this._adjustDate(t)},_selectMonthYear:function(e,t,i){var n=$(e),r=this._getInst(n[0]);r["selected"+(i=="M"?"Month":"Year")]=r["draw"+(i=="M"?"Month":"Year")]=parseInt(t.options[t.selectedIndex].value,10),this._notifyChange(r),this._adjustDate(n)},_selectDay:function(e,t,i,n){var r=$(e);if($(n).hasClass(this._unselectableClass)||this._isDisabledDatepicker(r[0]))return;var o=this._getInst(r[0]);o.selectedDay=o.currentDay=$("a",n).html(),o.selectedMonth=o.currentMonth=t,o.selectedYear=o.currentYear=i,this._selectDate(e,this._formatDate(o,o.currentDay,o.currentMonth,o.currentYear))},_clearDate:function(e){var t=$(e),i=this._getInst(t[0]);this._selectDate(t,"")},_selectDate:function(e,t){var i=$(e),n=this._getInst(i[0]);t=t!=null?t:this._formatDate(n),n.input&&n.input.val(t),this._updateAlternate(n);var r=this._get(n,"onSelect");r?r.apply(n.input?n.input[0]:null,[t,n]):n.input&&n.input.trigger("change"),n.inline?this._updateDatepicker(n):(this._hideDatepicker(),this._lastInput=n.input[0],typeof n.input[0]!="object"&&n.input.focus(),this._lastInput=null)},_updateAlternate:function(e){var t=this._get(e,"altField");if(t){var i=this._get(e,"altFormat")||this._get(e,"dateFormat"),n=this._getDate(e),r=this.formatDate(i,n,this._getFormatConfig(e));$(t).each(function(){$(this).val(r)})}},noWeekends:function(e){var t=e.getDay();return[t>0&&t<6,""]},iso8601Week:function(e){var t=new Date(e.getTime());t.setDate(t.getDate()+4-(t.getDay()||7));var i=t.getTime();return t.setMonth(0),t.setDate(1),Math.floor(Math.round((i-t)/864e5)/7)+1},parseDate:function(i,o,e){if(i==null||o==null)throw"Invalid arguments";o=typeof o=="object"?o.toString():o+"";if(o=="")return null;var t=(e?e.shortYearCutoff:null)||this._defaults.shortYearCutoff;t=typeof t!="string"?t:(new Date).getFullYear()%100+parseInt(t,10);var n=(e?e.dayNamesShort:null)||this._defaults.dayNamesShort,r=(e?e.dayNames:null)||this._defaults.dayNames,s=(e?e.monthNamesShort:null)||this._defaults.monthNamesShort,a=(e?e.monthNames:null)||this._defaults.monthNames,l=-1,c=-1,u=-1,d=-1,f=!1,h=function(e){var t=y+1<i.length&&i.charAt(y+1)==e;return t&&y++,t},p=function(e){var t=h(e),i=e=="@"?14:e=="!"?20:e=="y"&&t?4:e=="o"?3:2,n=new RegExp("^\\d{1,"+i+"}"),r=o.substring(v).match(n);if(!r)throw"Missing number at position "+v;return v+=r[0].length,parseInt(r[0],10)},g=function(e,t,i){var n=$.map(h(e)?i:t,function(e,t){return[[t,e]]}).sort(function(e,t){return-(e[1].length-t[1].length)}),r=-1;$.each(n,function(e,t){var i=t[1];if(o.substr(v,i.length).toLowerCase()==i.toLowerCase())return r=t[0],v+=i.length,!1});if(r!=-1)return r+1;throw"Unknown name at position "+v},m=function(){if(o.charAt(v)!=i.charAt(y))throw"Unexpected literal at position "+v;v++},v=0;for(var y=0;y<i.length;y++)if(f)i.charAt(y)=="'"&&!h("'")?f=!1:m();else switch(i.charAt(y)){case"d":u=p("d");break;case"D":g("D",n,r);break;case"o":d=p("o");break;case"m":c=p("m");break;case"M":c=g("M",s,a);break;case"y":l=p("y");break;case"@":var _=new Date(p("@"));l=_.getFullYear(),c=_.getMonth()+1,u=_.getDate();break;case"!":var _=new Date((p("!")-this._ticksTo1970)/1e4);l=_.getFullYear(),c=_.getMonth()+1,u=_.getDate();break;case"'":h("'")?m():f=!0;break;default:m()}if(v<o.length){var b=o.substr(v);if(!/^\s+/.test(b))throw"Extra/unparsed characters found in date: "+b}l==-1?l=(new Date).getFullYear():l<100&&(l+=(new Date).getFullYear()-(new Date).getFullYear()%100+(l<=t?0:-100));if(d>-1){c=1,u=d;do{var w=this._getDaysInMonth(l,c-1);if(u<=w)break;c++,u-=w}while(!0)}var _=this._daylightSavingAdjust(new Date(l,c-1,u));if(_.getFullYear()!=l||_.getMonth()+1!=c||_.getDate()!=u)throw"Invalid date";return _},ATOM:"yy-mm-dd",COOKIE:"D, dd M yy",ISO_8601:"yy-mm-dd",RFC_822:"D, d M y",RFC_850:"DD, dd-M-y",RFC_1036:"D, d M y",RFC_1123:"D, d M yy",RFC_2822:"D, d M yy",RSS:"D, d M y",TICKS:"!",TIMESTAMP:"@",W3C:"yy-mm-dd",_ticksTo1970:(718685+Math.floor(492.5)-Math.floor(19.7)+Math.floor(4.925))*24*60*60*1e7,formatDate:function(i,e,t){if(!e)return"";var n=(t?t.dayNamesShort:null)||this._defaults.dayNamesShort,r=(t?t.dayNames:null)||this._defaults.dayNames,o=(t?t.monthNamesShort:null)||this._defaults.monthNamesShort,s=(t?t.monthNames:null)||this._defaults.monthNames,a=function(e){var t=f+1<i.length&&i.charAt(f+1)==e;return t&&f++,t},l=function(e,t,i){var n=""+t;if(a(e))while(n.length<i)n="0"+n;return n},c=function(e,t,i,n){return a(e)?n[t]:i[t]},u="",d=!1;if(e)for(var f=0;f<i.length;f++)if(d)i.charAt(f)=="'"&&!a("'")?d=!1:u+=i.charAt(f);else switch(i.charAt(f)){case"d":u+=l("d",e.getDate(),2);break;case"D":u+=c("D",e.getDay(),n,r);break;case"o":u+=l("o",Math.round((new Date(e.getFullYear(),e.getMonth(),e.getDate()).getTime()-new Date(e.getFullYear(),0,0).getTime())/864e5),3);break;case"m":u+=l("m",e.getMonth()+1,2);break;case"M":u+=c("M",e.getMonth(),o,s);break;case"y":u+=a("y")?e.getFullYear():(e.getYear()%100<10?"0":"")+e.getYear()%100;break;case"@":u+=e.getTime();break;case"!":u+=e.getTime()*1e4+this._ticksTo1970;break;case"'":a("'")?u+="'":d=!0;break;default:u+=i.charAt(f)}return u},_possibleChars:function(i){var e="",t=!1,n=function(e){var t=r+1<i.length&&i.charAt(r+1)==e;return t&&r++,t};for(var r=0;r<i.length;r++)if(t)i.charAt(r)=="'"&&!n("'")?t=!1:e+=i.charAt(r);else switch(i.charAt(r)){case"d":case"m":case"y":case"@":e+="0123456789";break;case"D":case"M":return null;case"'":n("'")?e+="'":t=!0;break;default:e+=i.charAt(r)}return e},_get:function(e,t){return e.settings[t]!==undefined?e.settings[t]:this._defaults[t]},_setDateFromField:function(e,t){if(e.input.val()==e.lastVal)return;var i=this._get(e,"dateFormat"),n=e.lastVal=e.input?e.input.val():null,r,o;r=o=this._getDefaultDate(e);var s=this._getFormatConfig(e);try{r=this.parseDate(i,n,s)||o}catch(e){this.log(e),n=t?"":n}e.selectedDay=r.getDate(),e.drawMonth=e.selectedMonth=r.getMonth(),e.drawYear=e.selectedYear=r.getFullYear(),e.currentDay=n?r.getDate():0,e.currentMonth=n?r.getMonth():0,e.currentYear=n?r.getFullYear():0,this._adjustInstDate(e)},_getDefaultDate:function(e){return this._restrictMinMax(e,this._determineDate(e,this._get(e,"defaultDate"),new Date))},_determineDate:function(a,e,t){var i=function(e){var t=new Date;return t.setDate(t.getDate()+e),t},n=function(e){try{return $.datepicker.parseDate($.datepicker._get(a,"dateFormat"),e,$.datepicker._getFormatConfig(a))}catch(e){}var t=(e.toLowerCase().match(/^c/)?$.datepicker._getDate(a):null)||new Date,i=t.getFullYear(),n=t.getMonth(),r=t.getDate(),o=/([+-]?[0-9]+)\s*(d|D|w|W|m|M|y|Y)?/g,s=o.exec(e);while(s){switch(s[2]||"d"){case"d":case"D":r+=parseInt(s[1],10);break;case"w":case"W":r+=parseInt(s[1],10)*7;break;case"m":case"M":n+=parseInt(s[1],10),r=Math.min(r,$.datepicker._getDaysInMonth(i,n));break;case"y":case"Y":i+=parseInt(s[1],10),r=Math.min(r,$.datepicker._getDaysInMonth(i,n))}s=o.exec(e)}return new Date(i,n,r)},r=e==null||e===""?t:typeof e=="string"?n(e):typeof e=="number"?isNaN(e)?t:i(e):new Date(e.getTime());return r=r&&r.toString()=="Invalid Date"?t:r,r&&(r.setHours(0),r.setMinutes(0),r.setSeconds(0),r.setMilliseconds(0)),this._daylightSavingAdjust(r)},_daylightSavingAdjust:function(e){return e?(e.setHours(e.getHours()>12?e.getHours()+2:0),e):null},_setDate:function(e,t,i){var n=!t,r=e.selectedMonth,o=e.selectedYear,s=this._restrictMinMax(e,this._determineDate(e,t,new Date));e.selectedDay=e.currentDay=s.getDate(),e.drawMonth=e.selectedMonth=e.currentMonth=s.getMonth(),e.drawYear=e.selectedYear=e.currentYear=s.getFullYear(),(r!=e.selectedMonth||o!=e.selectedYear)&&!i&&this._notifyChange(e),this._adjustInstDate(e),e.input&&e.input.val(n?"":this._formatDate(e))},_getDate:function(e){var t=!e.currentYear||e.input&&e.input.val()==""?null:this._daylightSavingAdjust(new Date(e.currentYear,e.currentMonth,e.currentDay));return t},_attachHandlers:function(e){var t=this._get(e,"stepMonths"),i="#"+e.id.replace(/\\\\/g,"\\");e.dpDiv.find("[data-handler]").map(function(){var e={prev:function(){window["DP_jQuery_"+dpuuid].datepicker._adjustDate(i,-t,"M")},next:function(){window["DP_jQuery_"+dpuuid].datepicker._adjustDate(i,+t,"M")},hide:function(){window["DP_jQuery_"+dpuuid].datepicker._hideDatepicker()},today:function(){window["DP_jQuery_"+dpuuid].datepicker._gotoToday(i)},selectDay:function(){return window["DP_jQuery_"+dpuuid].datepicker._selectDay(i,+this.getAttribute("data-month"),+this.getAttribute("data-year"),this),!1},selectMonth:function(){return window["DP_jQuery_"+dpuuid].datepicker._selectMonthYear(i,this,"M"),!1},selectYear:function(){return window["DP_jQuery_"+dpuuid].datepicker._selectMonthYear(i,this,"Y"),!1}};$(this).bind(this.getAttribute("data-event"),e[this.getAttribute("data-handler")])})},_generateHTML:function(e){var t=new Date;t=this._daylightSavingAdjust(new Date(t.getFullYear(),t.getMonth(),t.getDate()));var i=this._get(e,"isRTL"),n=this._get(e,"showButtonPanel"),r=this._get(e,"hideIfNoPrevNext"),o=this._get(e,"navigationAsDateFormat"),s=this._getNumberOfMonths(e),a=this._get(e,"showCurrentAtPos"),l=this._get(e,"stepMonths"),c=s[0]!=1||s[1]!=1,u=this._daylightSavingAdjust(e.currentDay?new Date(e.currentYear,e.currentMonth,e.currentDay):new Date(9999,9,9)),d=this._getMinMaxDate(e,"min"),f=this._getMinMaxDate(e,"max"),h=e.drawMonth-a,p=e.drawYear;h<0&&(h+=12,p--);if(f){var g=this._daylightSavingAdjust(new Date(f.getFullYear(),f.getMonth()-s[0]*s[1]+1,f.getDate()));g=d&&g<d?d:g;while(this._daylightSavingAdjust(new Date(p,h,1))>g)h--,h<0&&(h=11,p--)}e.drawMonth=h,e.drawYear=p;var m=this._get(e,"prevText");m=o?this.formatDate(m,this._daylightSavingAdjust(new Date(p,h-l,1)),this._getFormatConfig(e)):m;var v=this._canAdjustMonth(e,-1,p,h)?'<a class="ui-datepicker-prev ui-corner-all" data-handler="prev" data-event="click" title="'+m+'"><span class="ui-icon ui-icon-circle-triangle-'+(i?"e":"w")+'">'+m+"</span></a>":r?"":'<a class="ui-datepicker-prev ui-corner-all ui-state-disabled" title="'+m+'"><span class="ui-icon ui-icon-circle-triangle-'+(i?"e":"w")+'">'+m+"</span></a>",y=this._get(e,"nextText");y=o?this.formatDate(y,this._daylightSavingAdjust(new Date(p,h+l,1)),this._getFormatConfig(e)):y;var _=this._canAdjustMonth(e,1,p,h)?'<a class="ui-datepicker-next ui-corner-all" data-handler="next" data-event="click" title="'+y+'"><span class="ui-icon ui-icon-circle-triangle-'+(i?"w":"e")+'">'+y+"</span></a>":r?"":'<a class="ui-datepicker-next ui-corner-all ui-state-disabled" title="'+y+'"><span class="ui-icon ui-icon-circle-triangle-'+(i?"w":"e")+'">'+y+"</span></a>",b=this._get(e,"currentText"),w=this._get(e,"gotoCurrent")&&e.currentDay?u:t;b=o?this.formatDate(b,w,this._getFormatConfig(e)):b;var x=e.inline?"":'<button type="button" class="ui-datepicker-close ui-state-default ui-priority-primary ui-corner-all" data-handler="hide" data-event="click">'+this._get(e,"closeText")+"</button>",k=n?'<div class="ui-datepicker-buttonpane ui-widget-content">'+(i?x:"")+(this._isInRange(e,w)?'<button type="button" class="ui-datepicker-current ui-state-default ui-priority-secondary ui-corner-all" data-handler="today" data-event="click">'+b+"</button>":"")+(i?"":x)+"</div>":"",C=parseInt(this._get(e,"firstDay"),10);C=isNaN(C)?0:C;var L=this._get(e,"showWeek"),T=this._get(e,"dayNames"),j=this._get(e,"dayNamesShort"),M=this._get(e,"dayNamesMin"),I=this._get(e,"monthNames"),D=this._get(e,"monthNamesShort"),S=this._get(e,"beforeShowDay"),P=this._get(e,"showOtherMonths"),E=this._get(e,"selectOtherMonths"),O=this._get(e,"calculateWeek")||this.iso8601Week,A=this._getDefaultDate(e),N="";for(var R=0;R<s[0];R++){var z="";this.maxRows=4;for(var H=0;H<s[1];H++){var F=this._daylightSavingAdjust(new Date(p,h,e.selectedDay)),W=" ui-corner-all",B="";if(c){B+='<div class="ui-datepicker-group';if(s[1]>1)switch(H){case 0:B+=" ui-datepicker-group-first",W=" ui-corner-"+(i?"right":"left");break;case s[1]-1:B+=" ui-datepicker-group-last",W=" ui-corner-"+(i?"left":"right");break;default:B+=" ui-datepicker-group-middle",W=""}B+='">'}B+='<div class="ui-datepicker-header ui-widget-header ui-helper-clearfix'+W+'">'+(/all|left/.test(W)&&R==0?i?_:v:"")+(/all|right/.test(W)&&R==0?i?v:_:"")+this._generateMonthYearHeader(e,h,p,d,f,R>0||H>0,I,D)+'</div><table class="ui-datepicker-calendar"><thead>'+"<tr>";var G=L?'<th class="ui-datepicker-week-col">'+this._get(e,"weekHeader")+"</th>":"";for(var q=0;q<7;q++){var U=(q+C)%7;G+="<th"+((q+C+6)%7>=5?' class="ui-datepicker-week-end"':"")+">"+'<span title="'+T[U]+'">'+M[U]+"</span></th>"}B+=G+"</tr></thead><tbody>";var V=this._getDaysInMonth(p,h);p==e.selectedYear&&h==e.selectedMonth&&(e.selectedDay=Math.min(e.selectedDay,V));var Y=(this._getFirstDayOfMonth(p,h)-C+7)%7,Z=Math.ceil((Y+V)/7),X=c?this.maxRows>Z?this.maxRows:Z:Z;this.maxRows=X;var J=this._daylightSavingAdjust(new Date(p,h,1-Y));for(var Q=0;Q<X;Q++){B+="<tr>";var K=L?'<td class="ui-datepicker-week-col">'+this._get(e,"calculateWeek")(J)+"</td>":"";for(var q=0;q<7;q++){var ee=S?S.apply(e.input?e.input[0]:null,[J]):[!0,""],te=J.getMonth()!=h,ie=te&&!E||!ee[0]||d&&J<d||f&&J>f;K+='<td class="'+((q+C+6)%7>=5?" ui-datepicker-week-end":"")+(te?" ui-datepicker-other-month":"")+(J.getTime()==F.getTime()&&h==e.selectedMonth&&e._keyEvent||A.getTime()==J.getTime()&&A.getTime()==F.getTime()?" "+this._dayOverClass:"")+(ie?" "+this._unselectableClass+" ui-state-disabled":"")+(te&&!P?"":" "+ee[1]+(J.getTime()==u.getTime()?" "+this._currentClass:"")+(J.getTime()==t.getTime()?" ui-datepicker-today":""))+'"'+((!te||P)&&ee[2]?' title="'+ee[2]+'"':"")+(ie?"":' data-handler="selectDay" data-event="click" data-month="'+J.getMonth()+'" data-year="'+J.getFullYear()+'"')+">"+(te&&!P?"&#xa0;":ie?'<span class="ui-state-default">'+J.getDate()+"</span>":'<a class="ui-state-default'+(J.getTime()==t.getTime()?" ui-state-highlight":"")+(J.getTime()==u.getTime()?" ui-state-active":"")+(te?" ui-priority-secondary":"")+'" href="#">'+J.getDate()+"</a>")+"</td>",J.setDate(J.getDate()+1),J=this._daylightSavingAdjust(J)}B+=K+"</tr>"}h++,h>11&&(h=0,p++),B+="</tbody></table>"+(c?"</div>"+(s[0]>0&&H==s[1]-1?'<div class="ui-datepicker-row-break"></div>':""):""),z+=B}N+=z}return N+=k+($.ui.ie6&&!e.inline?'<iframe src="javascript:false;" class="ui-datepicker-cover" frameborder="0"></iframe>':""),e._keyEvent=!1,N},_generateMonthYearHeader:function(e,t,i,n,r,o,s,a){var l=this._get(e,"changeMonth"),c=this._get(e,"changeYear"),u=this._get(e,"showMonthAfterYear"),d='<div class="ui-datepicker-title">',f="";if(o||!l)f+='<span class="ui-datepicker-month">'+s[t]+"</span>";else{var h=n&&n.getFullYear()==i,p=r&&r.getFullYear()==i;f+='<select class="ui-datepicker-month" data-handler="selectMonth" data-event="change">';for(var g=0;g<12;g++)(!h||g>=n.getMonth())&&(!p||g<=r.getMonth())&&(f+='<option value="'+g+'"'+(g==t?' selected="selected"':"")+">"+a[g]+"</option>");f+="</select>"}u||(d+=f+(o||!l||!c?"&#xa0;":""));if(!e.yearshtml){e.yearshtml="";if(o||!c)d+='<span class="ui-datepicker-year">'+i+"</span>";else{var m=this._get(e,"yearRange").split(":"),v=(new Date).getFullYear(),y=function(e){var t=e.match(/c[+-].*/)?i+parseInt(e.substring(1),10):e.match(/[+-].*/)?v+parseInt(e,10):parseInt(e,10);return isNaN(t)?v:t},_=y(m[0]),b=Math.max(_,y(m[1]||""));_=n?Math.max(_,n.getFullYear()):_,b=r?Math.min(b,r.getFullYear()):b,e.yearshtml+='<select class="ui-datepicker-year" data-handler="selectYear" data-event="change">';for(;_<=b;_++)e.yearshtml+='<option value="'+_+'"'+(_==i?' selected="selected"':"")+">"+_+"</option>";e.yearshtml+="</select>",d+=e.yearshtml,e.yearshtml=null}}return d+=this._get(e,"yearSuffix"),u&&(d+=(o||!l||!c?"&#xa0;":"")+f),d+="</div>",d},_adjustInstDate:function(e,t,i){var n=e.drawYear+(i=="Y"?t:0),r=e.drawMonth+(i=="M"?t:0),o=Math.min(e.selectedDay,this._getDaysInMonth(n,r))+(i=="D"?t:0),s=this._restrictMinMax(e,this._daylightSavingAdjust(new Date(n,r,o)));e.selectedDay=s.getDate(),e.drawMonth=e.selectedMonth=s.getMonth(),e.drawYear=e.selectedYear=s.getFullYear(),(i=="M"||i=="Y")&&this._notifyChange(e)},_restrictMinMax:function(e,t){var i=this._getMinMaxDate(e,"min"),n=this._getMinMaxDate(e,"max"),r=i&&t<i?i:t;return r=n&&r>n?n:r,r},_notifyChange:function(e){var t=this._get(e,"onChangeMonthYear");t&&t.apply(e.input?e.input[0]:null,[e.selectedYear,e.selectedMonth+1,e])},_getNumberOfMonths:function(e){var t=this._get(e,"numberOfMonths");return t==null?[1,1]:typeof t=="number"?[1,t]:t},_getMinMaxDate:function(e,t){return this._determineDate(e,this._get(e,t+"Date"),null)},_getDaysInMonth:function(e,t){return 32-this._daylightSavingAdjust(new Date(e,t,32)).getDate()},_getFirstDayOfMonth:function(e,t){return new Date(e,t,1).getDay()},_canAdjustMonth:function(e,t,i,n){var r=this._getNumberOfMonths(e),o=this._daylightSavingAdjust(new Date(i,n+(t<0?t:r[0]*r[1]),1));return t<0&&o.setDate(this._getDaysInMonth(o.getFullYear(),o.getMonth())),this._isInRange(e,o)},_isInRange:function(e,t){var i=this._getMinMaxDate(e,"min"),n=this._getMinMaxDate(e,"max");return(!i||t.getTime()>=i.getTime())&&(!n||t.getTime()<=n.getTime())},_getFormatConfig:function(e){var t=this._get(e,"shortYearCutoff");return t=typeof t!="string"?t:(new Date).getFullYear()%100+parseInt(t,10),{shortYearCutoff:t,dayNamesShort:this._get(e,"dayNamesShort"),dayNames:this._get(e,"dayNames"),monthNamesShort:this._get(e,"monthNamesShort"),monthNames:this._get(e,"monthNames")}},_formatDate:function(e,t,i,n){t||(e.currentDay=e.selectedDay,e.currentMonth=e.selectedMonth,e.currentYear=e.selectedYear);var r=t?typeof t=="object"?t:this._daylightSavingAdjust(new Date(n,i,t)):this._daylightSavingAdjust(new Date(e.currentYear,e.currentMonth,e.currentDay));return this.formatDate(this._get(e,"dateFormat"),r,this._getFormatConfig(e))}}),$.fn.datepicker=function(e){if(!this.length)return this;$.datepicker.initialized||($(document).mousedown($.datepicker._checkExternalClick).find(document.body).append($.datepicker.dpDiv),$.datepicker.initialized=!0);var t=Array.prototype.slice.call(arguments,1);return typeof e!="string"||e!="isDisabled"&&e!="getDate"&&e!="widget"?e=="option"&&arguments.length==2&&typeof arguments[1]=="string"?$.datepicker["_"+e+"Datepicker"].apply($.datepicker,[this[0]].concat(t)):this.each(function(){typeof e=="string"?$.datepicker["_"+e+"Datepicker"].apply($.datepicker,[this].concat(t)):$.datepicker._attachDatepicker(this,e)}):$.datepicker["_"+e+"Datepicker"].apply($.datepicker,[this[0]].concat(t))},$.datepicker=new Datepicker,$.datepicker.initialized=!1,$.datepicker.uuid=(new Date).getTime(),$.datepicker.version="1.9.2",window["DP_jQuery_"+dpuuid]=$})(jQuery);(function(l,s){var c="ui-dialog ui-widget ui-widget-content ui-corner-all ",o={buttons:!0,height:!0,maxHeight:!0,maxWidth:!0,minHeight:!0,minWidth:!0,width:!0},a={maxHeight:!0,maxWidth:!0,minHeight:!0,minWidth:!0};l.widget("ui.dialog",{version:"1.9.2",options:{autoOpen:!0,buttons:{},closeOnEscape:!0,closeText:"close",dialogClass:"",draggable:!0,hide:null,height:"auto",maxHeight:!1,maxWidth:!1,minHeight:150,minWidth:150,modal:!1,position:{my:"center",at:"center",of:window,collision:"fit",using:function(e){var t=l(this).css(e).offset().top;t<0&&l(this).css("top",e.top-t)}},resizable:!0,show:null,stack:!0,title:"",width:300,zIndex:1e3},_create:function(){this.originalTitle=this.element.attr("title"),typeof this.originalTitle!="string"&&(this.originalTitle=""),this.oldPosition={parent:this.element.parent(),index:this.element.parent().children().index(this.element)},this.options.title=this.options.title||this.originalTitle;var t=this,r=this.options,e=r.title||"&#160;",o,i,n,s,a;o=(this.uiDialog=l("<div>")).addClass(c+r.dialogClass).css({display:"none",outline:0,zIndex:r.zIndex}).attr("tabIndex",-1).keydown(function(e){r.closeOnEscape&&!e.isDefaultPrevented()&&e.keyCode&&e.keyCode===l.ui.keyCode.ESCAPE&&(t.close(e),e.preventDefault())}).mousedown(function(e){t.moveToTop(!1,e)}).appendTo("body"),this.element.show().removeAttr("title").addClass("ui-dialog-content ui-widget-content").appendTo(o),i=(this.uiDialogTitlebar=l("<div>")).addClass("ui-dialog-titlebar  ui-widget-header  ui-corner-all  ui-helper-clearfix").bind("mousedown",function(){o.focus()}).prependTo(o),n=l("<a href='#'></a>").addClass("ui-dialog-titlebar-close  ui-corner-all").attr("role","button").click(function(e){e.preventDefault(),t.close(e)}).appendTo(i),(this.uiDialogTitlebarCloseText=l("<span>")).addClass("ui-icon ui-icon-closethick").text(r.closeText).appendTo(n),s=l("<span>").uniqueId().addClass("ui-dialog-title").html(e).prependTo(i),a=(this.uiDialogButtonPane=l("<div>")).addClass("ui-dialog-buttonpane ui-widget-content ui-helper-clearfix"),(this.uiButtonSet=l("<div>")).addClass("ui-dialog-buttonset").appendTo(a),o.attr({role:"dialog","aria-labelledby":s.attr("id")}),i.find("*").add(i).disableSelection(),this._hoverable(n),this._focusable(n),r.draggable&&l.fn.draggable&&this._makeDraggable(),r.resizable&&l.fn.resizable&&this._makeResizable(),this._createButtons(r.buttons),this._isOpen=!1,l.fn.bgiframe&&o.bgiframe(),this._on(o,{keydown:function(e){if(!r.modal||e.keyCode!==l.ui.keyCode.TAB)return;var t=l(":tabbable",o),i=t.filter(":first"),n=t.filter(":last");if(e.target===n[0]&&!e.shiftKey)return i.focus(1),!1;if(e.target===i[0]&&e.shiftKey)return n.focus(1),!1}})},_init:function(){this.options.autoOpen&&this.open()},_destroy:function(){var e,t=this.oldPosition;this.overlay&&this.overlay.destroy(),this.uiDialog.hide(),this.element.removeClass("ui-dialog-content ui-widget-content").hide().appendTo("body"),this.uiDialog.remove(),this.originalTitle&&this.element.attr("title",this.originalTitle),e=t.parent.children().eq(t.index),e.length&&e[0]!==this.element[0]?e.before(this.element):t.parent.append(this.element)},widget:function(){return this.uiDialog},close:function(e){var t=this,i,n;if(!this._isOpen)return;if(!1===this._trigger("beforeClose",e))return;return this._isOpen=!1,this.overlay&&this.overlay.destroy(),this.options.hide?this._hide(this.uiDialog,this.options.hide,function(){t._trigger("close",e)}):(this.uiDialog.hide(),this._trigger("close",e)),l.ui.dialog.overlay.resize(),this.options.modal&&(i=0,l(".ui-dialog").each(function(){this!==t.uiDialog[0]&&(n=l(this).css("z-index"),isNaN(n)||(i=Math.max(i,n)))}),l.ui.dialog.maxZ=i),this},isOpen:function(){return this._isOpen},moveToTop:function(e,t){var i=this.options,n;return i.modal&&!e||!i.stack&&!i.modal?this._trigger("focus",t):(i.zIndex>l.ui.dialog.maxZ&&(l.ui.dialog.maxZ=i.zIndex),this.overlay&&(l.ui.dialog.maxZ+=1,l.ui.dialog.overlay.maxZ=l.ui.dialog.maxZ,this.overlay.$el.css("z-index",l.ui.dialog.overlay.maxZ)),n={scrollTop:this.element.scrollTop(),scrollLeft:this.element.scrollLeft()},l.ui.dialog.maxZ+=1,this.uiDialog.css("z-index",l.ui.dialog.maxZ),this.element.attr(n),this._trigger("focus",t),this)},open:function(){if(this._isOpen)return;var e,t=this.options,i=this.uiDialog;return this._size(),this._position(t.position),i.show(t.show),this.overlay=t.modal?new l.ui.dialog.overlay(this):null,this.moveToTop(!0),e=this.element.find(":tabbable"),e.length||(e=this.uiDialogButtonPane.find(":tabbable"),e.length||(e=i)),e.eq(0).focus(),this._isOpen=!0,this._trigger("open"),this},_createButtons:function(e){var r=this,t=!1;this.uiDialogButtonPane.remove(),this.uiButtonSet.empty(),typeof e=="object"&&e!==null&&l.each(e,function(){return!(t=!0)}),t?(l.each(e,function(e,t){var i,n;t=l.isFunction(t)?{click:t,text:e}:t,t=l.extend({type:"button"},t),n=t.click,t.click=function(){n.apply(r.element[0],arguments)},i=l("<button></button>",t).appendTo(r.uiButtonSet),l.fn.button&&i.button()}),this.uiDialog.addClass("ui-dialog-buttons"),this.uiDialogButtonPane.appendTo(this.uiDialog)):this.uiDialog.removeClass("ui-dialog-buttons")},_makeDraggable:function(){function i(e){return{position:e.position,offset:e.offset}}var n=this,r=this.options;this.uiDialog.draggable({cancel:".ui-dialog-content, .ui-dialog-titlebar-close",handle:".ui-dialog-titlebar",containment:"document",start:function(e,t){l(this).addClass("ui-dialog-dragging"),n._trigger("dragStart",e,i(t))},drag:function(e,t){n._trigger("drag",e,i(t))},stop:function(e,t){r.position=[t.position.left-n.document.scrollLeft(),t.position.top-n.document.scrollTop()],l(this).removeClass("ui-dialog-dragging"),n._trigger("dragStop",e,i(t)),l.ui.dialog.overlay.resize()}})},_makeResizable:function(e){function i(e){return{originalPosition:e.originalPosition,originalSize:e.originalSize,position:e.position,size:e.size}}e=e===s?this.options.resizable:e;var n=this,r=this.options,t=this.uiDialog.css("position"),o=typeof e=="string"?e:"n,e,s,w,se,sw,ne,nw";this.uiDialog.resizable({cancel:".ui-dialog-content",containment:"document",alsoResize:this.element,maxWidth:r.maxWidth,maxHeight:r.maxHeight,minWidth:r.minWidth,minHeight:this._minHeight(),handles:o,start:function(e,t){l(this).addClass("ui-dialog-resizing"),n._trigger("resizeStart",e,i(t))},resize:function(e,t){n._trigger("resize",e,i(t))},stop:function(e,t){l(this).removeClass("ui-dialog-resizing"),r.height=l(this).height(),r.width=l(this).width(),n._trigger("resizeStop",e,i(t)),l.ui.dialog.overlay.resize()}}).css("position",t).find(".ui-resizable-se").addClass("ui-icon ui-icon-grip-diagonal-se")},_minHeight:function(){var e=this.options;return e.height==="auto"?e.minHeight:Math.min(e.minHeight,e.height)},_position:function(e){var i=[],n=[0,0],t;if(e){if(typeof e=="string"||typeof e=="object"&&"0"in e)i=e.split?e.split(" "):[e[0],e[1]],i.length===1&&(i[1]=i[0]),l.each(["left","top"],function(e,t){+i[e]===i[e]&&(n[e]=i[e],i[e]=t)}),e={my:i[0]+(n[0]<0?n[0]:"+"+n[0])+" "+i[1]+(n[1]<0?n[1]:"+"+n[1]),at:i.join(" ")};e=l.extend({},l.ui.dialog.prototype.options.position,e)}else e=l.ui.dialog.prototype.options.position;t=this.uiDialog.is(":visible"),t||this.uiDialog.show(),this.uiDialog.position(e),t||this.uiDialog.hide()},_setOptions:function(e){var i=this,n={},r=!1;l.each(e,function(e,t){i._setOption(e,t),e in o&&(r=!0),e in a&&(n[e]=t)}),r&&this._size(),this.uiDialog.is(":data(resizable)")&&this.uiDialog.resizable("option",n)},_setOption:function(e,t){var i,n,r=this.uiDialog;switch(e){case"buttons":this._createButtons(t);break;case"closeText":this.uiDialogTitlebarCloseText.text(""+t);break;case"dialogClass":r.removeClass(this.options.dialogClass).addClass(c+t);break;case"disabled":t?r.addClass("ui-dialog-disabled"):r.removeClass("ui-dialog-disabled");break;case"draggable":i=r.is(":data(draggable)"),i&&!t&&r.draggable("destroy"),!i&&t&&this._makeDraggable();break;case"position":this._position(t);break;case"resizable":n=r.is(":data(resizable)"),n&&!t&&r.resizable("destroy"),n&&typeof t=="string"&&r.resizable("option","handles",t),!n&&t!==!1&&this._makeResizable(t);break;case"title":l(".ui-dialog-title",this.uiDialogTitlebar).html(""+(t||"&#160;"))}this._super(e,t)},_size:function(){var e,t,i,n=this.options,r=this.uiDialog.is(":visible");this.element.show().css({width:"auto",minHeight:0,height:0}),n.minWidth>n.width&&(n.width=n.minWidth),e=this.uiDialog.css({height:"auto",width:n.width}).outerHeight(),t=Math.max(0,n.minHeight-e),n.height==="auto"?l.support.minHeight?this.element.css({minHeight:t,height:"auto"}):(this.uiDialog.show(),i=this.element.css("height","auto").height(),r||this.uiDialog.hide(),this.element.height(Math.max(i,t))):this.element.height(Math.max(n.height-e,0)),this.uiDialog.is(":data(resizable)")&&this.uiDialog.resizable("option","minHeight",this._minHeight())}}),l.extend(l.ui.dialog,{uuid:0,maxZ:0,getTitleId:function(e){var t=e.attr("id");return t||(this.uuid+=1,t=this.uuid),"ui-dialog-title-"+t},overlay:function(e){this.$el=l.ui.dialog.overlay.create(e)}}),l.extend(l.ui.dialog.overlay,{instances:[],oldInstances:[],maxZ:0,events:l.map("focus,mousedown,mouseup,keydown,keypress,click".split(","),function(e){return e+".dialog-overlay"}).join(" "),create:function(i){this.instances.length===0&&(setTimeout(function(){l.ui.dialog.overlay.instances.length&&l(document).bind(l.ui.dialog.overlay.events,function(e){if(l(e.target).zIndex()<l.ui.dialog.overlay.maxZ)return!1})},1),l(window).bind("resize.dialog-overlay",l.ui.dialog.overlay.resize));var n=this.oldInstances.pop()||l("<div>").addClass("ui-widget-overlay");return l(document).bind("keydown.dialog-overlay",function(e){var t=l.ui.dialog.overlay.instances;t.length!==0&&t[t.length-1]===n&&i.options.closeOnEscape&&!e.isDefaultPrevented()&&e.keyCode&&e.keyCode===l.ui.keyCode.ESCAPE&&(i.close(e),e.preventDefault())}),n.appendTo(document.body).css({width:this.width(),height:this.height()}),l.fn.bgiframe&&n.bgiframe(),this.instances.push(n),n},destroy:function(e){var t=l.inArray(e,this.instances),i=0;t!==-1&&this.oldInstances.push(this.instances.splice(t,1)[0]),this.instances.length===0&&l([document,window]).unbind(".dialog-overlay"),e.height(0).width(0).remove(),l.each(this.instances,function(){i=Math.max(i,this.css("z-index"))}),this.maxZ=i},height:function(){var e,t;return l.ui.ie?(e=Math.max(document.documentElement.scrollHeight,document.body.scrollHeight),t=Math.max(document.documentElement.offsetHeight,document.body.offsetHeight),e<t?l(window).height()+"px":e+"px"):l(document).height()+"px"},width:function(){var e,t;return l.ui.ie?(e=Math.max(document.documentElement.scrollWidth,document.body.scrollWidth),t=Math.max(document.documentElement.offsetWidth,document.body.offsetWidth),e<t?l(window).width()+"px":e+"px"):l(document).width()+"px"},resize:function(){var e=l([]);l.each(l.ui.dialog.overlay.instances,function(){e=e.add(this)}),e.css({width:0,height:0}).css({width:l.ui.dialog.overlay.width(),height:l.ui.dialog.overlay.height()})}}),l.extend(l.ui.dialog.overlay.prototype,{destroy:function(){l.ui.dialog.overlay.destroy(this.$el)}})})(jQuery);(function(l,e){var i=!1;l.widget("ui.menu",{version:"1.9.2",defaultElement:"<ul>",delay:300,options:{icons:{submenu:"ui-icon-carat-1-e"},menus:"ul",position:{my:"left top",at:"right top"},role:"menu",blur:null,focus:null,select:null},_create:function(){this.activeMenu=this.element,this.element.uniqueId().addClass("ui-menu ui-widget ui-widget-content ui-corner-all").toggleClass("ui-menu-icons",!!this.element.find(".ui-icon").length).attr({role:this.options.role,tabIndex:0}).bind("click"+this.eventNamespace,l.proxy(function(e){this.options.disabled&&e.preventDefault()},this)),this.options.disabled&&this.element.addClass("ui-state-disabled").attr("aria-disabled","true"),this._on({"mousedown .ui-menu-item > a":function(e){e.preventDefault()},"click .ui-state-disabled > a":function(e){e.preventDefault()},"click .ui-menu-item:has(a)":function(e){var t=l(e.target).closest(".ui-menu-item");!i&&t.not(".ui-state-disabled").length&&(i=!0,this.select(e),t.has(".ui-menu").length?this.expand(e):this.element.is(":focus")||(this.element.trigger("focus",[!0]),this.active&&this.active.parents(".ui-menu").length===1&&clearTimeout(this.timer)))},"mouseenter .ui-menu-item":function(e){var t=l(e.currentTarget);t.siblings().children(".ui-state-active").removeClass("ui-state-active"),this.focus(e,t)},mouseleave:"collapseAll","mouseleave .ui-menu":"collapseAll",focus:function(e,t){var i=this.active||this.element.children(".ui-menu-item").eq(0);t||this.focus(e,i)},blur:function(e){this._delay(function(){l.contains(this.element[0],this.document[0].activeElement)||this.collapseAll(e)})},keydown:"_keydown"}),this.refresh(),this._on(this.document,{click:function(e){l(e.target).closest(".ui-menu").length||this.collapseAll(e),i=!1}})},_destroy:function(){this.element.removeAttr("aria-activedescendant").find(".ui-menu").andSelf().removeClass("ui-menu ui-widget ui-widget-content ui-corner-all ui-menu-icons").removeAttr("role").removeAttr("tabIndex").removeAttr("aria-labelledby").removeAttr("aria-expanded").removeAttr("aria-hidden").removeAttr("aria-disabled").removeUniqueId().show(),this.element.find(".ui-menu-item").removeClass("ui-menu-item").removeAttr("role").removeAttr("aria-disabled").children("a").removeUniqueId().removeClass("ui-corner-all ui-state-hover").removeAttr("tabIndex").removeAttr("role").removeAttr("aria-haspopup").children().each(function(){var e=l(this);e.data("ui-menu-submenu-carat")&&e.remove()}),this.element.find(".ui-menu-divider").removeClass("ui-menu-divider ui-widget-content")},_keydown:function(e){function t(e){return e.replace(/[\-\[\]{}()*+?.,\\\^$|#\s]/g,"\\$&")}var i,n,r,o,s,a=!0;switch(e.keyCode){case l.ui.keyCode.PAGE_UP:this.previousPage(e);break;case l.ui.keyCode.PAGE_DOWN:this.nextPage(e);break;case l.ui.keyCode.HOME:this._move("first","first",e);break;case l.ui.keyCode.END:this._move("last","last",e);break;case l.ui.keyCode.UP:this.previous(e);break;case l.ui.keyCode.DOWN:this.next(e);break;case l.ui.keyCode.LEFT:this.collapse(e);break;case l.ui.keyCode.RIGHT:this.active&&!this.active.is(".ui-state-disabled")&&this.expand(e);break;case l.ui.keyCode.ENTER:case l.ui.keyCode.SPACE:this._activate(e);break;case l.ui.keyCode.ESCAPE:this.collapse(e);break;default:a=!1,n=this.previousFilter||"",r=String.fromCharCode(e.keyCode),o=!1,clearTimeout(this.filterTimer),r===n?o=!0:r=n+r,s=new RegExp("^"+t(r),"i"),i=this.activeMenu.children(".ui-menu-item").filter(function(){return s.test(l(this).children("a").text())}),i=o&&i.index(this.active.next())!==-1?this.active.nextAll(".ui-menu-item"):i,i.length||(r=String.fromCharCode(e.keyCode),s=new RegExp("^"+t(r),"i"),i=this.activeMenu.children(".ui-menu-item").filter(function(){return s.test(l(this).children("a").text())})),i.length?(this.focus(e,i),i.length>1?(this.previousFilter=r,this.filterTimer=this._delay(function(){delete this.previousFilter},1e3)):delete this.previousFilter):delete this.previousFilter}a&&e.preventDefault()},_activate:function(e){this.active.is(".ui-state-disabled")||(this.active.children("a[aria-haspopup='true']").length?this.expand(e):this.select(e))},refresh:function(){var e,n=this.options.icons.submenu,t=this.element.find(this.options.menus);t.filter(":not(.ui-menu)").addClass("ui-menu ui-widget ui-widget-content ui-corner-all").hide().attr({role:this.options.role,"aria-hidden":"true","aria-expanded":"false"}).each(function(){var e=l(this),t=e.prev("a"),i=l("<span>").addClass("ui-menu-icon ui-icon "+n).data("ui-menu-submenu-carat",!0);t.attr("aria-haspopup","true").prepend(i),e.attr("aria-labelledby",t.attr("id"))}),e=t.add(this.element),e.children(":not(.ui-menu-item):has(a)").addClass("ui-menu-item").attr("role","presentation").children("a").uniqueId().addClass("ui-corner-all").attr({tabIndex:-1,role:this._itemRole()}),e.children(":not(.ui-menu-item)").each(function(){var e=l(this);/[^\-—–\s]/.test(e.text())||e.addClass("ui-widget-content ui-menu-divider")}),e.children(".ui-state-disabled").attr("aria-disabled","true"),this.active&&!l.contains(this.element[0],this.active[0])&&this.blur()},_itemRole:function(){return{menu:"menuitem",listbox:"option"}[this.options.role]},focus:function(e,t){var i,n;this.blur(e,e&&e.type==="focus"),this._scrollIntoView(t),this.active=t.first(),n=this.active.children("a").addClass("ui-state-focus"),this.options.role&&this.element.attr("aria-activedescendant",n.attr("id")),this.active.parent().closest(".ui-menu-item").children("a:first").addClass("ui-state-active"),e&&e.type==="keydown"?this._close():this.timer=this._delay(function(){this._close()},this.delay),i=t.children(".ui-menu"),i.length&&/^mouse/.test(e.type)&&this._startOpening(i),this.activeMenu=t.parent(),this._trigger("focus",e,{item:t})},_scrollIntoView:function(e){var t,i,n,r,o,s;this._hasScroll()&&(t=parseFloat(l.css(this.activeMenu[0],"borderTopWidth"))||0,i=parseFloat(l.css(this.activeMenu[0],"paddingTop"))||0,n=e.offset().top-this.activeMenu.offset().top-t-i,r=this.activeMenu.scrollTop(),o=this.activeMenu.height(),s=e.height(),n<0?this.activeMenu.scrollTop(r+n):n+s>o&&this.activeMenu.scrollTop(r+n-o+s))},blur:function(e,t){t||clearTimeout(this.timer);if(!this.active)return;this.active.children("a").removeClass("ui-state-focus"),this.active=null,this._trigger("blur",e,{item:this.active})},_startOpening:function(e){clearTimeout(this.timer);if(e.attr("aria-hidden")!=="true")return;this.timer=this._delay(function(){this._close(),this._open(e)},this.delay)},_open:function(e){var t=l.extend({of:this.active},this.options.position);clearTimeout(this.timer),this.element.find(".ui-menu").not(e.parents(".ui-menu")).hide().attr("aria-hidden","true"),e.show().removeAttr("aria-hidden").attr("aria-expanded","true").position(t)},collapseAll:function(t,i){clearTimeout(this.timer),this.timer=this._delay(function(){var e=i?this.element:l(t&&t.target).closest(this.element.find(".ui-menu"));e.length||(e=this.element),this._close(e),this.blur(t),this.activeMenu=e},this.delay)},_close:function(e){e||(e=this.active?this.active.parent():this.element),e.find(".ui-menu").hide().attr("aria-hidden","true").attr("aria-expanded","false").end().find("a.ui-state-active").removeClass("ui-state-active")},collapse:function(e){var t=this.active&&this.active.parent().closest(".ui-menu-item",this.element);t&&t.length&&(this._close(),this.focus(e,t))},expand:function(e){var t=this.active&&this.active.children(".ui-menu ").children(".ui-menu-item").first();t&&t.length&&(this._open(t.parent()),this._delay(function(){this.focus(e,t)}))},next:function(e){this._move("next","first",e)},previous:function(e){this._move("prev","last",e)},isFirstItem:function(){return this.active&&!this.active.prevAll(".ui-menu-item").length},isLastItem:function(){return this.active&&!this.active.nextAll(".ui-menu-item").length},_move:function(e,t,i){var n;this.active&&(e==="first"||e==="last"?n=this.active[e==="first"?"prevAll":"nextAll"](".ui-menu-item").eq(-1):n=this.active[e+"All"](".ui-menu-item").eq(0));if(!n||!n.length||!this.active)n=this.activeMenu.children(".ui-menu-item")[t]();this.focus(i,n)},nextPage:function(e){var t,i,n;if(!this.active){this.next(e);return}if(this.isLastItem())return;this._hasScroll()?(i=this.active.offset().top,n=this.element.height(),this.active.nextAll(".ui-menu-item").each(function(){return t=l(this),t.offset().top-i-n<0}),this.focus(e,t)):this.focus(e,this.activeMenu.children(".ui-menu-item")[this.active?"last":"first"]())},previousPage:function(e){var t,i,n;if(!this.active){this.next(e);return}if(this.isFirstItem())return;this._hasScroll()?(i=this.active.offset().top,n=this.element.height(),this.active.prevAll(".ui-menu-item").each(function(){return t=l(this),t.offset().top-i+n>0}),this.focus(e,t)):this.focus(e,this.activeMenu.children(".ui-menu-item").first())},_hasScroll:function(){return this.element.outerHeight()<this.element.prop("scrollHeight")},select:function(e){this.active=this.active||l(e.target).closest(".ui-menu-item");var t={item:this.active};this.active.has(".ui-menu").length||this.collapseAll(e,!0),this._trigger("select",e,t)}})})(jQuery);(function(e,t){e.widget("ui.progressbar",{version:"1.9.2",options:{value:0,max:100},min:0,_create:function(){this.element.addClass("ui-progressbar ui-widget ui-widget-content ui-corner-all").attr({role:"progressbar","aria-valuemin":this.min,"aria-valuemax":this.options.max,"aria-valuenow":this._value()}),this.valueDiv=e("<div class='ui-progressbar-value ui-widget-header ui-corner-left'></div>").appendTo(this.element),this.oldValue=this._value(),this._refreshValue()},_destroy:function(){this.element.removeClass("ui-progressbar ui-widget ui-widget-content ui-corner-all").removeAttr("role").removeAttr("aria-valuemin").removeAttr("aria-valuemax").removeAttr("aria-valuenow"),this.valueDiv.remove()},value:function(e){return e===t?this._value():(this._setOption("value",e),this)},_setOption:function(e,t){e==="value"&&(this.options.value=t,this._refreshValue(),this._value()===this.options.max&&this._trigger("complete")),this._super(e,t)},_value:function(){var e=this.options.value;return typeof e!="number"&&(e=0),Math.min(this.options.max,Math.max(this.min,e))},_percentage:function(){return 100*this._value()/this.options.max},_refreshValue:function(){var e=this.value(),t=this._percentage();this.oldValue!==e&&(this.oldValue=e,this._trigger("change")),this.valueDiv.toggle(e>this.min).toggleClass("ui-corner-right",e===this.options.max).width(t.toFixed(0)+"%"),this.element.attr("aria-valuenow",e)}})})(jQuery);(function(d,e){var s=5;d.widget("ui.slider",d.ui.mouse,{version:"1.9.2",widgetEventPrefix:"slide",options:{animate:!1,distance:0,max:100,min:0,orientation:"horizontal",range:!1,step:1,value:0,values:null},_create:function(){var e,t,i=this.options,n=this.element.find(".ui-slider-handle").addClass("ui-state-default ui-corner-all"),r="<a class='ui-slider-handle ui-state-default ui-corner-all' href='#'></a>",o=[];this._keySliding=!1,this._mouseSliding=!1,this._animateOff=!0,this._handleIndex=null,this._detectOrientation(),this._mouseInit(),this.element.addClass("ui-slider ui-slider-"+this.orientation+" ui-widget"+" ui-widget-content"+" ui-corner-all"+(i.disabled?" ui-slider-disabled ui-disabled":"")),this.range=d([]),i.range&&(i.range===!0&&(i.values||(i.values=[this._valueMin(),this._valueMin()]),i.values.length&&i.values.length!==2&&(i.values=[i.values[0],i.values[0]])),this.range=d("<div></div>").appendTo(this.element).addClass("ui-slider-range ui-widget-header"+(i.range==="min"||i.range==="max"?" ui-slider-range-"+i.range:""))),t=i.values&&i.values.length||1;for(e=n.length;e<t;e++)o.push(r);this.handles=n.add(d(o.join("")).appendTo(this.element)),this.handle=this.handles.eq(0),this.handles.add(this.range).filter("a").click(function(e){e.preventDefault()}).mouseenter(function(){i.disabled||d(this).addClass("ui-state-hover")}).mouseleave(function(){d(this).removeClass("ui-state-hover")}).focus(function(){i.disabled?d(this).blur():(d(".ui-slider .ui-state-focus").removeClass("ui-state-focus"),d(this).addClass("ui-state-focus"))}).blur(function(){d(this).removeClass("ui-state-focus")}),this.handles.each(function(e){d(this).data("ui-slider-handle-index",e)}),this._on(this.handles,{keydown:function(e){var t,i,n,r,o=d(e.target).data("ui-slider-handle-index");switch(e.keyCode){case d.ui.keyCode.HOME:case d.ui.keyCode.END:case d.ui.keyCode.PAGE_UP:case d.ui.keyCode.PAGE_DOWN:case d.ui.keyCode.UP:case d.ui.keyCode.RIGHT:case d.ui.keyCode.DOWN:case d.ui.keyCode.LEFT:e.preventDefault();if(!this._keySliding){this._keySliding=!0,d(e.target).addClass("ui-state-active"),t=this._start(e,o);if(t===!1)return}}r=this.options.step,this.options.values&&this.options.values.length?i=n=this.values(o):i=n=this.value();switch(e.keyCode){case d.ui.keyCode.HOME:n=this._valueMin();break;case d.ui.keyCode.END:n=this._valueMax();break;case d.ui.keyCode.PAGE_UP:n=this._trimAlignValue(i+(this._valueMax()-this._valueMin())/s);break;case d.ui.keyCode.PAGE_DOWN:n=this._trimAlignValue(i-(this._valueMax()-this._valueMin())/s);break;case d.ui.keyCode.UP:case d.ui.keyCode.RIGHT:if(i===this._valueMax())return;n=this._trimAlignValue(i+r);break;case d.ui.keyCode.DOWN:case d.ui.keyCode.LEFT:if(i===this._valueMin())return;n=this._trimAlignValue(i-r)}this._slide(e,o,n)},keyup:function(e){var t=d(e.target).data("ui-slider-handle-index");this._keySliding&&(this._keySliding=!1,this._stop(e,t),this._change(e,t),d(e.target).removeClass("ui-state-active"))}}),this._refreshValue(),this._animateOff=!1},_destroy:function(){this.handles.remove(),this.range.remove(),this.element.removeClass("ui-slider ui-slider-horizontal ui-slider-vertical ui-slider-disabled ui-widget ui-widget-content ui-corner-all"),this._mouseDestroy()},_mouseCapture:function(e){var t,i,n,r,o,s,a,l,c=this,u=this.options;return u.disabled?!1:(this.elementSize={width:this.element.outerWidth(),height:this.element.outerHeight()},this.elementOffset=this.element.offset(),t={x:e.pageX,y:e.pageY},i=this._normValueFromMouse(t),n=this._valueMax()-this._valueMin()+1,this.handles.each(function(e){var t=Math.abs(i-c.values(e));n>t&&(n=t,r=d(this),o=e)}),u.range===!0&&this.values(1)===u.min&&(o+=1,r=d(this.handles[o])),s=this._start(e,o),s===!1?!1:(this._mouseSliding=!0,this._handleIndex=o,r.addClass("ui-state-active").focus(),a=r.offset(),l=!d(e.target).parents().andSelf().is(".ui-slider-handle"),this._clickOffset=l?{left:0,top:0}:{left:e.pageX-a.left-r.width()/2,top:e.pageY-a.top-r.height()/2-(parseInt(r.css("borderTopWidth"),10)||0)-(parseInt(r.css("borderBottomWidth"),10)||0)+(parseInt(r.css("marginTop"),10)||0)},this.handles.hasClass("ui-state-hover")||this._slide(e,o,i),this._animateOff=!0,!0))},_mouseStart:function(){return!0},_mouseDrag:function(e){var t={x:e.pageX,y:e.pageY},i=this._normValueFromMouse(t);return this._slide(e,this._handleIndex,i),!1},_mouseStop:function(e){return this.handles.removeClass("ui-state-active"),this._mouseSliding=!1,this._stop(e,this._handleIndex),this._change(e,this._handleIndex),this._handleIndex=null,this._clickOffset=null,this._animateOff=!1,!1},_detectOrientation:function(){this.orientation=this.options.orientation==="vertical"?"vertical":"horizontal"},_normValueFromMouse:function(e){var t,i,n,r,o;return this.orientation==="horizontal"?(t=this.elementSize.width,i=e.x-this.elementOffset.left-(this._clickOffset?this._clickOffset.left:0)):(t=this.elementSize.height,i=e.y-this.elementOffset.top-(this._clickOffset?this._clickOffset.top:0)),n=i/t,n>1&&(n=1),n<0&&(n=0),this.orientation==="vertical"&&(n=1-n),r=this._valueMax()-this._valueMin(),o=this._valueMin()+n*r,this._trimAlignValue(o)},_start:function(e,t){var i={handle:this.handles[t],value:this.value()};return this.options.values&&this.options.values.length&&(i.value=this.values(t),i.values=this.values()),this._trigger("start",e,i)},_slide:function(e,t,i){var n,r,o;this.options.values&&this.options.values.length?(n=this.values(t?0:1),this.options.values.length===2&&this.options.range===!0&&(t===0&&i>n||t===1&&i<n)&&(i=n),i!==this.values(t)&&(r=this.values(),r[t]=i,o=this._trigger("slide",e,{handle:this.handles[t],value:i,values:r}),n=this.values(t?0:1),o!==!1&&this.values(t,i,!0))):i!==this.value()&&(o=this._trigger("slide",e,{handle:this.handles[t],value:i}),o!==!1&&this.value(i))},_stop:function(e,t){var i={handle:this.handles[t],value:this.value()};this.options.values&&this.options.values.length&&(i.value=this.values(t),i.values=this.values()),this._trigger("stop",e,i)},_change:function(e,t){if(!this._keySliding&&!this._mouseSliding){var i={handle:this.handles[t],value:this.value()};this.options.values&&this.options.values.length&&(i.value=this.values(t),i.values=this.values()),this._trigger("change",e,i)}},value:function(e){if(arguments.length){this.options.value=this._trimAlignValue(e),this._refreshValue(),this._change(null,0);return}return this._value()},values:function(e,t){var i,n,r;if(arguments.length>1){this.options.values[e]=this._trimAlignValue(t),this._refreshValue(),this._change(null,e);return}if(!arguments.length)return this._values();if(!d.isArray(arguments[0]))return this.options.values&&this.options.values.length?this._values(e):this.value();i=this.options.values,n=arguments[0];for(r=0;r<i.length;r+=1)i[r]=this._trimAlignValue(n[r]),this._change(null,r);this._refreshValue()},_setOption:function(e,t){var i,n=0;d.isArray(this.options.values)&&(n=this.options.values.length),d.Widget.prototype._setOption.apply(this,arguments);switch(e){case"disabled":t?(this.handles.filter(".ui-state-focus").blur(),this.handles.removeClass("ui-state-hover"),this.handles.prop("disabled",!0),this.element.addClass("ui-disabled")):(this.handles.prop("disabled",!1),this.element.removeClass("ui-disabled"));break;case"orientation":this._detectOrientation(),this.element.removeClass("ui-slider-horizontal ui-slider-vertical").addClass("ui-slider-"+this.orientation),this._refreshValue();break;case"value":this._animateOff=!0,this._refreshValue(),this._change(null,0),this._animateOff=!1;break;case"values":this._animateOff=!0,this._refreshValue();for(i=0;i<n;i+=1)this._change(null,i);this._animateOff=!1;break;case"min":case"max":this._animateOff=!0,this._refreshValue(),this._animateOff=!1}},_value:function(){var e=this.options.value;return e=this._trimAlignValue(e),e},_values:function(e){var t,i,n;if(arguments.length)return t=this.options.values[e],t=this._trimAlignValue(t),t;i=this.options.values.slice();for(n=0;n<i.length;n+=1)i[n]=this._trimAlignValue(i[n]);return i},_trimAlignValue:function(e){if(e<=this._valueMin())return this._valueMin();if(e>=this._valueMax())return this._valueMax();var t=this.options.step>0?this.options.step:1,i=(e-this._valueMin())%t,n=e-i;return Math.abs(i)*2>=t&&(n+=i>0?t:-t),parseFloat(n.toFixed(5))},_valueMin:function(){return this.options.min},_valueMax:function(){return this.options.max},_refreshValue:function(){var t,i,e,n,r,o=this.options.range,s=this.options,a=this,l=this._animateOff?!1:s.animate,c={};this.options.values&&this.options.values.length?this.handles.each(function(e){i=(a.values(e)-a._valueMin())/(a._valueMax()-a._valueMin())*100,c[a.orientation==="horizontal"?"left":"bottom"]=i+"%",d(this).stop(1,1)[l?"animate":"css"](c,s.animate),a.options.range===!0&&(a.orientation==="horizontal"?(e===0&&a.range.stop(1,1)[l?"animate":"css"]({left:i+"%"},s.animate),e===1&&a.range[l?"animate":"css"]({width:i-t+"%"},{queue:!1,duration:s.animate})):(e===0&&a.range.stop(1,1)[l?"animate":"css"]({bottom:i+"%"},s.animate),e===1&&a.range[l?"animate":"css"]({height:i-t+"%"},{queue:!1,duration:s.animate}))),t=i}):(e=this.value(),n=this._valueMin(),r=this._valueMax(),i=r!==n?(e-n)/(r-n)*100:0,c[this.orientation==="horizontal"?"left":"bottom"]=i+"%",this.handle.stop(1,1)[l?"animate":"css"](c,s.animate),o==="min"&&this.orientation==="horizontal"&&this.range.stop(1,1)[l?"animate":"css"]({width:i+"%"},s.animate),o==="max"&&this.orientation==="horizontal"&&this.range[l?"animate":"css"]({width:100-i+"%"},{queue:!1,duration:s.animate}),o==="min"&&this.orientation==="vertical"&&this.range.stop(1,1)[l?"animate":"css"]({height:i+"%"},s.animate),o==="max"&&this.orientation==="vertical"&&this.range[l?"animate":"css"]({height:100-i+"%"},{queue:!1,duration:s.animate}))}})})(jQuery);(function(o){function t(t){return function(){var e=this.element.val();t.apply(this,arguments),this._refresh(),e!==this.element.val()&&this._trigger("change")}}o.widget("ui.spinner",{version:"1.9.2",defaultElement:"<input>",widgetEventPrefix:"spin",options:{culture:null,icons:{down:"ui-icon-triangle-1-s",up:"ui-icon-triangle-1-n"},incremental:!0,max:null,min:null,numberFormat:null,page:10,step:1,change:null,spin:null,start:null,stop:null},_create:function(){this._setOption("max",this.options.max),this._setOption("min",this.options.min),this._setOption("step",this.options.step),this._value(this.element.val(),!0),this._draw(),this._on(this._events),this._refresh(),this._on(this.window,{beforeunload:function(){this.element.removeAttr("autocomplete")}})},_getCreateOptions:function(){var n={},r=this.element;return o.each(["min","max","step"],function(e,t){var i=r.attr(t);i!==undefined&&i.length&&(n[t]=i)}),n},_events:{keydown:function(e){this._start(e)&&this._keydown(e)&&e.preventDefault()},keyup:"_stop",focus:function(){this.previous=this.element.val()},blur:function(e){if(this.cancelBlur){delete this.cancelBlur;return}this._refresh(),this.previous!==this.element.val()&&this._trigger("change",e)},mousewheel:function(e,t){if(!t)return;if(!this.spinning&&!this._start(e))return!1;this._spin((t>0?1:-1)*this.options.step,e),clearTimeout(this.mousewheelTimer),this.mousewheelTimer=this._delay(function(){this.spinning&&this._stop(e)},100),e.preventDefault()},"mousedown .ui-spinner-button":function(e){function t(){var e=this.element[0]===this.document[0].activeElement;e||(this.element.focus(),this.previous=i,this._delay(function(){this.previous=i}))}var i;i=this.element[0]===this.document[0].activeElement?this.previous:this.element.val(),e.preventDefault(),t.call(this),this.cancelBlur=!0,this._delay(function(){delete this.cancelBlur,t.call(this)});if(this._start(e)===!1)return;this._repeat(null,o(e.currentTarget).hasClass("ui-spinner-up")?1:-1,e)},"mouseup .ui-spinner-button":"_stop","mouseenter .ui-spinner-button":function(e){if(!o(e.currentTarget).hasClass("ui-state-active"))return;if(this._start(e)===!1)return!1;this._repeat(null,o(e.currentTarget).hasClass("ui-spinner-up")?1:-1,e)},"mouseleave .ui-spinner-button":"_stop"},_draw:function(){var e=this.uiSpinner=this.element.addClass("ui-spinner-input").attr("autocomplete","off").wrap(this._uiSpinnerHtml()).parent().append(this._buttonHtml());this.element.attr("role","spinbutton"),this.buttons=e.find(".ui-spinner-button").attr("tabIndex",-1).button().removeClass("ui-corner-all"),this.buttons.height()>Math.ceil(e.height()*.5)&&e.height()>0&&e.height(e.height()),this.options.disabled&&this.disable()},_keydown:function(e){var t=this.options,i=o.ui.keyCode;switch(e.keyCode){case i.UP:return this._repeat(null,1,e),!0;case i.DOWN:return this._repeat(null,-1,e),!0;case i.PAGE_UP:return this._repeat(null,t.page,e),!0;case i.PAGE_DOWN:return this._repeat(null,-t.page,e),!0}return!1},_uiSpinnerHtml:function(){return"<span class='ui-spinner ui-widget ui-widget-content ui-corner-all'></span>"},_buttonHtml:function(){return"<a class='ui-spinner-button ui-spinner-up ui-corner-tr'><span class='ui-icon "+this.options.icons.up+"'>&#9650;</span>"+"</a>"+"<a class='ui-spinner-button ui-spinner-down ui-corner-br'>"+"<span class='ui-icon "+this.options.icons.down+"'>&#9660;</span>"+"</a>"},_start:function(e){return!this.spinning&&this._trigger("start",e)===!1?!1:(this.counter||(this.counter=1),this.spinning=!0,!0)},_repeat:function(e,t,i){e=e||500,clearTimeout(this.timer),this.timer=this._delay(function(){this._repeat(40,t,i)},e),this._spin(t*this.options.step,i)},_spin:function(e,t){var i=this.value()||0;this.counter||(this.counter=1),i=this._adjustValue(i+e*this._increment(this.counter));if(!this.spinning||this._trigger("spin",t,{value:i})!==!1)this._value(i),this.counter++},_increment:function(e){var t=this.options.incremental;return t?o.isFunction(t)?t(e):Math.floor(e*e*e/5e4-e*e/500+17*e/200+1):1},_precision:function(){var e=this._precisionOf(this.options.step);return this.options.min!==null&&(e=Math.max(e,this._precisionOf(this.options.min))),e},_precisionOf:function(e){var t=e.toString(),i=t.indexOf(".");return i===-1?0:t.length-i-1},_adjustValue:function(e){var t,i,n=this.options;return t=n.min!==null?n.min:0,i=e-t,i=Math.round(i/n.step)*n.step,e=t+i,e=parseFloat(e.toFixed(this._precision())),n.max!==null&&e>n.max?n.max:n.min!==null&&e<n.min?n.min:e},_stop:function(e){if(!this.spinning)return;clearTimeout(this.timer),clearTimeout(this.mousewheelTimer),this.counter=0,this.spinning=!1,this._trigger("stop",e)},_setOption:function(e,t){if(e==="culture"||e==="numberFormat"){var i=this._parse(this.element.val());this.options[e]=t,this.element.val(this._format(i));return}(e==="max"||e==="min"||e==="step")&&typeof t=="string"&&(t=this._parse(t)),this._super(e,t),e==="disabled"&&(t?(this.element.prop("disabled",!0),this.buttons.button("disable")):(this.element.prop("disabled",!1),this.buttons.button("enable")))},_setOptions:t(function(e){this._super(e),this._value(this.element.val())}),_parse:function(e){return typeof e=="string"&&e!==""&&(e=window.Globalize&&this.options.numberFormat?Globalize.parseFloat(e,10,this.options.culture):+e),e===""||isNaN(e)?null:e},_format:function(e){return e===""?"":window.Globalize&&this.options.numberFormat?Globalize.format(e,this.options.numberFormat,this.options.culture):e},_refresh:function(){this.element.attr({"aria-valuemin":this.options.min,"aria-valuemax":this.options.max,"aria-valuenow":this._parse(this.element.val())})},_value:function(e,t){var i;e!==""&&(i=this._parse(e),i!==null&&(t||(i=this._adjustValue(i)),e=this._format(i))),this.element.val(e),this._refresh()},_destroy:function(){this.element.removeClass("ui-spinner-input").prop("disabled",!1).removeAttr("autocomplete").removeAttr("role").removeAttr("aria-valuemin").removeAttr("aria-valuemax").removeAttr("aria-valuenow"),this.uiSpinner.replaceWith(this.element)},stepUp:t(function(e){this._stepUp(e)}),_stepUp:function(e){this._spin((e||1)*this.options.step)},stepDown:t(function(e){this._stepDown(e)}),_stepDown:function(e){this._spin((e||1)*-this.options.step)},pageUp:t(function(e){this._stepUp((e||1)*this.options.page)}),pageDown:t(function(e){this._stepDown((e||1)*this.options.page)}),value:function(e){if(!arguments.length)return this._parse(this.element.val());t(this._value).call(this,e)},widget:function(){return this.uiSpinner}})})(jQuery);(function(u,l){function i(){return++e}function c(e){return e.hash.length>1&&e.href.replace(t,"")===location.href.replace(t,"").replace(/\s/g,"%20")}var e=0,t=/#.*$/;u.widget("ui.tabs",{version:"1.9.2",delay:300,options:{active:null,collapsible:!1,event:"click",heightStyle:"content",hide:null,show:null,activate:null,beforeActivate:null,beforeLoad:null,load:null},_create:function(){var t=this,e=this.options,i=e.active,n=location.hash.substring(1);this.running=!1,this.element.addClass("ui-tabs ui-widget ui-widget-content ui-corner-all").toggleClass("ui-tabs-collapsible",e.collapsible).delegate(".ui-tabs-nav > li","mousedown"+this.eventNamespace,function(e){u(this).is(".ui-state-disabled")&&e.preventDefault()}).delegate(".ui-tabs-anchor","focus"+this.eventNamespace,function(){u(this).closest("li").is(".ui-state-disabled")&&this.blur()}),this._processTabs();if(i===null){n&&this.tabs.each(function(e,t){if(u(t).attr("aria-controls")===n)return i=e,!1}),i===null&&(i=this.tabs.index(this.tabs.filter(".ui-tabs-active")));if(i===null||i===-1)i=this.tabs.length?0:!1}i!==!1&&(i=this.tabs.index(this.tabs.eq(i)),i===-1&&(i=e.collapsible?!1:0)),e.active=i,!e.collapsible&&e.active===!1&&this.anchors.length&&(e.active=0),u.isArray(e.disabled)&&(e.disabled=u.unique(e.disabled.concat(u.map(this.tabs.filter(".ui-state-disabled"),function(e){return t.tabs.index(e)}))).sort()),this.options.active!==!1&&this.anchors.length?this.active=this._findActive(this.options.active):this.active=u(),this._refresh(),this.active.length&&this.load(e.active)},_getCreateEventData:function(){return{tab:this.active,panel:this.active.length?this._getPanelForTab(this.active):u()}},_tabKeydown:function(e){var t=u(this.document[0].activeElement).closest("li"),i=this.tabs.index(t),n=!0;if(this._handlePageNav(e))return;switch(e.keyCode){case u.ui.keyCode.RIGHT:case u.ui.keyCode.DOWN:i++;break;case u.ui.keyCode.UP:case u.ui.keyCode.LEFT:n=!1,i--;break;case u.ui.keyCode.END:i=this.anchors.length-1;break;case u.ui.keyCode.HOME:i=0;break;case u.ui.keyCode.SPACE:e.preventDefault(),clearTimeout(this.activating),this._activate(i);return;case u.ui.keyCode.ENTER:e.preventDefault(),clearTimeout(this.activating),this._activate(i===this.options.active?!1:i);return;default:return}e.preventDefault(),clearTimeout(this.activating),i=this._focusNextTab(i,n),e.ctrlKey||(t.attr("aria-selected","false"),this.tabs.eq(i).attr("aria-selected","true"),this.activating=this._delay(function(){this.option("active",i)},this.delay))},_panelKeydown:function(e){if(this._handlePageNav(e))return;e.ctrlKey&&e.keyCode===u.ui.keyCode.UP&&(e.preventDefault(),this.active.focus())},_handlePageNav:function(e){if(e.altKey&&e.keyCode===u.ui.keyCode.PAGE_UP)return this._activate(this._focusNextTab(this.options.active-1,!1)),!0;if(e.altKey&&e.keyCode===u.ui.keyCode.PAGE_DOWN)return this._activate(this._focusNextTab(this.options.active+1,!0)),!0},_findNextTab:function(e,t){function i(){return e>n&&(e=0),e<0&&(e=n),e}var n=this.tabs.length-1;while(u.inArray(i(),this.options.disabled)!==-1)e=t?e+1:e-1;return e},_focusNextTab:function(e,t){return e=this._findNextTab(e,t),this.tabs.eq(e).focus(),e},_setOption:function(e,t){if(e==="active"){this._activate(t);return}if(e==="disabled"){this._setupDisabled(t);return}this._super(e,t),e==="collapsible"&&(this.element.toggleClass("ui-tabs-collapsible",t),!t&&this.options.active===!1&&this._activate(0)),e==="event"&&this._setupEvents(t),e==="heightStyle"&&this._setupHeightStyle(t)},_tabId:function(e){return e.attr("aria-controls")||"ui-tabs-"+i()},_sanitizeSelector:function(e){return e?e.replace(/[!"$%&'()*+,.\/:;<=>?@\[\]\^`{|}~]/g,"\\$&"):""},refresh:function(){var e=this.options,t=this.tablist.children(":has(a[href])");e.disabled=u.map(t.filter(".ui-state-disabled"),function(e){return t.index(e)}),this._processTabs(),e.active===!1||!this.anchors.length?(e.active=!1,this.active=u()):this.active.length&&!u.contains(this.tablist[0],this.active[0])?this.tabs.length===e.disabled.length?(e.active=!1,this.active=u()):this._activate(this._findNextTab(Math.max(0,e.active-1),!1)):e.active=this.tabs.index(this.active),this._refresh()},_refresh:function(){this._setupDisabled(this.options.disabled),this._setupEvents(this.options.event),this._setupHeightStyle(this.options.heightStyle),this.tabs.not(this.active).attr({"aria-selected":"false",tabIndex:-1}),this.panels.not(this._getPanelForTab(this.active)).hide().attr({"aria-expanded":"false","aria-hidden":"true"}),this.active.length?(this.active.addClass("ui-tabs-active ui-state-active").attr({"aria-selected":"true",tabIndex:0}),this._getPanelForTab(this.active).show().attr({"aria-expanded":"true","aria-hidden":"false"})):this.tabs.eq(0).attr("tabIndex",0)},_processTabs:function(){var l=this;this.tablist=this._getList().addClass("ui-tabs-nav ui-helper-reset ui-helper-clearfix ui-widget-header ui-corner-all").attr("role","tablist"),this.tabs=this.tablist.find("> li:has(a[href])").addClass("ui-state-default ui-corner-top").attr({role:"tab",tabIndex:-1}),this.anchors=this.tabs.map(function(){return u("a",this)[0]}).addClass("ui-tabs-anchor").attr({role:"presentation",tabIndex:-1}),this.panels=u(),this.anchors.each(function(e,t){var i,n,r,o=u(t).uniqueId().attr("id"),s=u(t).closest("li"),a=s.attr("aria-controls");c(t)?(i=t.hash,n=l.element.find(l._sanitizeSelector(i))):(r=l._tabId(s),i="#"+r,n=l.element.find(i),n.length||(n=l._createPanel(r),n.insertAfter(l.panels[e-1]||l.tablist)),n.attr("aria-live","polite")),n.length&&(l.panels=l.panels.add(n)),a&&s.data("ui-tabs-aria-controls",a),s.attr({"aria-controls":i.substring(1),"aria-labelledby":o}),n.attr("aria-labelledby",o)}),this.panels.addClass("ui-tabs-panel ui-widget-content ui-corner-bottom").attr("role","tabpanel")},_getList:function(){return this.element.find("ol,ul").eq(0)},_createPanel:function(e){return u("<div>").attr("id",e).addClass("ui-tabs-panel ui-widget-content ui-corner-bottom").data("ui-tabs-destroy",!0)},_setupDisabled:function(e){u.isArray(e)&&(e.length?e.length===this.anchors.length&&(e=!0):e=!1);for(var t=0,i;i=this.tabs[t];t++)e===!0||u.inArray(t,e)!==-1?u(i).addClass("ui-state-disabled").attr("aria-disabled","true"):u(i).removeClass("ui-state-disabled").removeAttr("aria-disabled");this.options.disabled=e},_setupEvents:function(e){var i={click:function(e){e.preventDefault()}};e&&u.each(e.split(" "),function(e,t){i[t]="_eventHandler"}),this._off(this.anchors.add(this.tabs).add(this.panels)),this._on(this.anchors,i),this._on(this.tabs,{keydown:"_tabKeydown"}),this._on(this.panels,{keydown:"_panelKeydown"}),this._focusable(this.tabs),this._hoverable(this.tabs)},_setupHeightStyle:function(e){var i,t,n=this.element.parent();e==="fill"?(u.support.minHeight||(t=n.css("overflow"),n.css("overflow","hidden")),i=n.height(),this.element.siblings(":visible").each(function(){var e=u(this),t=e.css("position");if(t==="absolute"||t==="fixed")return;i-=e.outerHeight(!0)}),t&&n.css("overflow",t),this.element.children().not(this.panels).each(function(){i-=u(this).outerHeight(!0)}),this.panels.each(function(){u(this).height(Math.max(0,i-u(this).innerHeight()+u(this).height()))}).css("overflow","auto")):e==="auto"&&(i=0,this.panels.each(function(){i=Math.max(i,u(this).height("").height())}).height(i))},_eventHandler:function(e){var t=this.options,i=this.active,n=u(e.currentTarget),r=n.closest("li"),o=r[0]===i[0],s=o&&t.collapsible,a=s?u():this._getPanelForTab(r),l=i.length?this._getPanelForTab(i):u(),c={oldTab:i,oldPanel:l,newTab:s?u():r,newPanel:a};e.preventDefault();if(r.hasClass("ui-state-disabled")||r.hasClass("ui-tabs-loading")||this.running||o&&!t.collapsible||this._trigger("beforeActivate",e,c)===!1)return;t.active=s?!1:this.tabs.index(r),this.active=o?u():r,this.xhr&&this.xhr.abort(),!l.length&&!a.length&&u.error("jQuery UI Tabs: Mismatching fragment identifier."),a.length&&this.load(this.tabs.index(r),e),this._toggle(e,c)},_toggle:function(e,t){function i(){r.running=!1,r._trigger("activate",e,t)}function n(){t.newTab.closest("li").addClass("ui-tabs-active ui-state-active"),o.length&&r.options.show?r._show(o,r.options.show,i):(o.show(),i())}var r=this,o=t.newPanel,s=t.oldPanel;this.running=!0,s.length&&this.options.hide?this._hide(s,this.options.hide,function(){t.oldTab.closest("li").removeClass("ui-tabs-active ui-state-active"),n()}):(t.oldTab.closest("li").removeClass("ui-tabs-active ui-state-active"),s.hide(),n()),s.attr({"aria-expanded":"false","aria-hidden":"true"}),t.oldTab.attr("aria-selected","false"),o.length&&s.length?t.oldTab.attr("tabIndex",-1):o.length&&this.tabs.filter(function(){return u(this).attr("tabIndex")===0}).attr("tabIndex",-1),o.attr({"aria-expanded":"true","aria-hidden":"false"}),t.newTab.attr({"aria-selected":"true",tabIndex:0})},_activate:function(e){var t,i=this._findActive(e);if(i[0]===this.active[0])return;i.length||(i=this.active),t=i.find(".ui-tabs-anchor")[0],this._eventHandler({target:t,currentTarget:t,preventDefault:u.noop})},_findActive:function(e){return e===!1?u():this.tabs.eq(e)},_getIndex:function(e){return typeof e=="string"&&(e=this.anchors.index(this.anchors.filter("[href$='"+e+"']"))),e},_destroy:function(){this.xhr&&this.xhr.abort(),this.element.removeClass("ui-tabs ui-widget ui-widget-content ui-corner-all ui-tabs-collapsible"),this.tablist.removeClass("ui-tabs-nav ui-helper-reset ui-helper-clearfix ui-widget-header ui-corner-all").removeAttr("role"),this.anchors.removeClass("ui-tabs-anchor").removeAttr("role").removeAttr("tabIndex").removeData("href.tabs").removeData("load.tabs").removeUniqueId(),this.tabs.add(this.panels).each(function(){u.data(this,"ui-tabs-destroy")?u(this).remove():u(this).removeClass("ui-state-default ui-state-active ui-state-disabled ui-corner-top ui-corner-bottom ui-widget-content ui-tabs-active ui-tabs-panel").removeAttr("tabIndex").removeAttr("aria-live").removeAttr("aria-busy").removeAttr("aria-selected").removeAttr("aria-labelledby").removeAttr("aria-hidden").removeAttr("aria-expanded").removeAttr("role")}),this.tabs.each(function(){var e=u(this),t=e.data("ui-tabs-aria-controls");t?e.attr("aria-controls",t):e.removeAttr("aria-controls")}),this.panels.show(),this.options.heightStyle!=="content"&&this.panels.css("height","")},enable:function(i){var e=this.options.disabled;if(e===!1)return;i===l?e=!1:(i=this._getIndex(i),u.isArray(e)?e=u.map(e,function(e){return e!==i?e:null}):e=u.map(this.tabs,function(e,t){return t!==i?t:null})),this._setupDisabled(e)},disable:function(e){var t=this.options.disabled;if(t===!0)return;if(e===l)t=!0;else{e=this._getIndex(e);if(u.inArray(e,t)!==-1)return;u.isArray(t)?t=u.merge([e],t).sort():t=[e]}this._setupDisabled(t)},load:function(e,t){e=this._getIndex(e);var i=this,n=this.tabs.eq(e),r=n.find(".ui-tabs-anchor"),o=this._getPanelForTab(n),s={tab:n,panel:o};if(c(r[0]))return;this.xhr=u.ajax(this._ajaxSettings(r,t,s)),this.xhr&&this.xhr.statusText!=="canceled"&&(n.addClass("ui-tabs-loading"),o.attr("aria-busy","true"),this.xhr.success(function(e){setTimeout(function(){o.html(e),i._trigger("load",t,s)},1)}).complete(function(e,t){setTimeout(function(){t==="abort"&&i.panels.stop(!1,!0),n.removeClass("ui-tabs-loading"),o.removeAttr("aria-busy"),e===i.xhr&&delete i.xhr},1)}))},_ajaxSettings:function(e,i,n){var r=this;return{url:e.attr("href"),beforeSend:function(e,t){return r._trigger("beforeLoad",i,u.extend({jqXHR:e,ajaxSettings:t},n))}}},_getPanelForTab:function(e){var t=u(e).attr("aria-controls");return this.element.find(this._sanitizeSelector("#"+t))}}),u.uiBackCompat!==!1&&(u.ui.tabs.prototype._ui=function(e,t){return{tab:e,panel:t,index:this.anchors.index(e)}},u.widget("ui.tabs",u.ui.tabs,{url:function(e,t){this.anchors.eq(e).attr("href",t)}}),u.widget("ui.tabs",u.ui.tabs,{options:{ajaxOptions:null,cache:!1},_create:function(){this._super();var i=this;this._on({tabsbeforeload:function(e,t){if(u.data(t.tab[0],"cache.tabs")){e.preventDefault();return}t.jqXHR.success(function(){i.options.cache&&u.data(t.tab[0],"cache.tabs",!0)})}})},_ajaxSettings:function(e,t,i){var n=this.options.ajaxOptions;return u.extend({},n,{error:function(e,t){try{n.error(e,t,i.tab.closest("li").index(),i.tab[0])}catch(e){}}},this._superApply(arguments))},_setOption:function(e,t){e==="cache"&&t===!1&&this.anchors.removeData("cache.tabs"),this._super(e,t)},_destroy:function(){this.anchors.removeData("cache.tabs"),this._super()},url:function(e){this.anchors.eq(e).removeData("cache.tabs"),this._superApply(arguments)}}),u.widget("ui.tabs",u.ui.tabs,{abort:function(){this.xhr&&this.xhr.abort()}}),u.widget("ui.tabs",u.ui.tabs,{options:{spinner:"<em>Loading&#8230;</em>"},_create:function(){this._super(),this._on({tabsbeforeload:function(e,t){if(e.target!==this.element[0]||!this.options.spinner)return;var i=t.tab.find("span"),n=i.html();i.html(this.options.spinner),t.jqXHR.complete(function(){i.html(n)})}})}}),u.widget("ui.tabs",u.ui.tabs,{options:{enable:null,disable:null},enable:function(e){var t=this.options,i;if(e&&t.disabled===!0||u.isArray(t.disabled)&&u.inArray(e,t.disabled)!==-1)i=!0;this._superApply(arguments),i&&this._trigger("enable",null,this._ui(this.anchors[e],this.panels[e]))},disable:function(e){var t=this.options,i;if(e&&t.disabled===!1||u.isArray(t.disabled)&&u.inArray(e,t.disabled)===-1)i=!0;this._superApply(arguments),i&&this._trigger("disable",null,this._ui(this.anchors[e],this.panels[e]))}}),u.widget("ui.tabs",u.ui.tabs,{options:{add:null,remove:null,tabTemplate:"<li><a href='#{href}'><span>#{label}</span></a></li>"},add:function(e,t,i){i===l&&(i=this.anchors.length);var n,r,o=this.options,s=u(o.tabTemplate.replace(/#\{href\}/g,e).replace(/#\{label\}/g,t)),a=e.indexOf("#")?this._tabId(s):e.replace("#","");return s.addClass("ui-state-default ui-corner-top").data("ui-tabs-destroy",!0),s.attr("aria-controls",a),n=i>=this.tabs.length,r=this.element.find("#"+a),r.length||(r=this._createPanel(a),n?i>0?r.insertAfter(this.panels.eq(-1)):r.appendTo(this.element):r.insertBefore(this.panels[i])),r.addClass("ui-tabs-panel ui-widget-content ui-corner-bottom").hide(),n?s.appendTo(this.tablist):s.insertBefore(this.tabs[i]),o.disabled=u.map(o.disabled,function(e){return e>=i?++e:e}),this.refresh(),this.tabs.length===1&&o.active===!1&&this.option("active",0),this._trigger("add",null,this._ui(this.anchors[i],this.panels[i])),this},remove:function(t){t=this._getIndex(t);var e=this.options,i=this.tabs.eq(t).remove(),n=this._getPanelForTab(i).remove();return i.hasClass("ui-tabs-active")&&this.anchors.length>2&&this._activate(t+(t+1<this.anchors.length?1:-1)),e.disabled=u.map(u.grep(e.disabled,function(e){return e!==t}),function(e){return e>=t?--e:e}),this.refresh(),this._trigger("remove",null,this._ui(i.find("a")[0],n[0])),this}}),u.widget("ui.tabs",u.ui.tabs,{length:function(){return this.anchors.length}}),u.widget("ui.tabs",u.ui.tabs,{options:{idPrefix:"ui-tabs-"},_tabId:function(e){var t=e.is("li")?e.find("a[href]"):e;return t=t[0],u(t).closest("li").attr("aria-controls")||t.title&&t.title.replace(/\s/g,"_").replace(/[^\w\u00c0-\uFFFF\-]/g,"")||this.options.idPrefix+i()}}),u.widget("ui.tabs",u.ui.tabs,{options:{panelTemplate:"<div></div>"},_createPanel:function(e){return u(this.options.panelTemplate).attr("id",e).addClass("ui-tabs-panel ui-widget-content ui-corner-bottom").data("ui-tabs-destroy",!0)}}),u.widget("ui.tabs",u.ui.tabs,{_create:function(){var e=this.options;e.active===null&&e.selected!==l&&(e.active=e.selected===-1?!1:e.selected),this._super(),e.selected=e.active,e.selected===!1&&(e.selected=-1)},_setOption:function(e,t){if(e!=="selected")return this._super(e,t);var i=this.options;this._super("active",t===-1?!1:t),i.selected=i.active,i.selected===!1&&(i.selected=-1)},_eventHandler:function(){this._superApply(arguments),this.options.selected=this.options.active,this.options.selected===!1&&(this.options.selected=-1)}}),u.widget("ui.tabs",u.ui.tabs,{options:{show:null,select:null},_create:function(){this._super(),this.options.active!==!1&&this._trigger("show",null,this._ui(this.active.find(".ui-tabs-anchor")[0],this._getPanelForTab(this.active)[0]))},_trigger:function(e,t,i){var n,r,o=this._superApply(arguments);return o?(e==="beforeActivate"?(n=i.newTab.length?i.newTab:i.oldTab,r=i.newPanel.length?i.newPanel:i.oldPanel,o=this._super("select",t,{tab:n.find(".ui-tabs-anchor")[0],panel:r[0],index:n.closest("li").index()})):e==="activate"&&i.newTab.length&&(o=this._super("show",t,{tab:i.newTab.find(".ui-tabs-anchor")[0],panel:i.newPanel[0],index:i.newTab.closest("li").index()})),o):!1}}),u.widget("ui.tabs",u.ui.tabs,{select:function(e){e=this._getIndex(e);if(e===-1){if(!this.options.collapsible||this.options.selected===-1)return;e=this.options.selected}this.anchors.eq(e).trigger(this.options.event+this.eventNamespace)}}),function(){var i=0;u.widget("ui.tabs",u.ui.tabs,{options:{cookie:null},_create:function(){var e=this.options,t;e.active==null&&e.cookie&&(t=parseInt(this._cookie(),10),t===-1&&(t=!1),e.active=t),this._super()},_cookie:function(e){var t=[this.cookie||(this.cookie=this.options.cookie.name||"ui-tabs-"+ ++i)];return arguments.length&&(t.push(e===!1?-1:e),t.push(this.options.cookie)),u.cookie.apply(null,t)},_refresh:function(){this._super(),this.options.cookie&&this._cookie(this.options.active,this.options.cookie)},_eventHandler:function(){this._superApply(arguments),this.options.cookie&&this._cookie(this.options.active,this.options.cookie)},_destroy:function(){this._super(),this.options.cookie&&this._cookie(null,this.options.cookie)}})}(),u.widget("ui.tabs",u.ui.tabs,{_trigger:function(e,t,i){var n=u.extend({},i);return e==="load"&&(n.panel=n.panel[0],n.tab=n.tab.find(".ui-tabs-anchor")[0]),this._super(e,t,n)}}),u.widget("ui.tabs",u.ui.tabs,{options:{fx:null},_getFx:function(){var e,t,i=this.options.fx;return i&&(u.isArray(i)?(e=i[0],t=i[1]):e=t=i),i?{show:t,hide:e}:null},_toggle:function(e,t){function i(){r.running=!1,r._trigger("activate",e,t)}function n(){t.newTab.closest("li").addClass("ui-tabs-active ui-state-active"),o.length&&a.show?o.animate(a.show,a.show.duration,function(){i()}):(o.show(),i())}var r=this,o=t.newPanel,s=t.oldPanel,a=this._getFx();if(!a)return this._super(e,t);r.running=!0,s.length&&a.hide?s.animate(a.hide,a.hide.duration,function(){t.oldTab.closest("li").removeClass("ui-tabs-active ui-state-active"),n()}):(t.oldTab.closest("li").removeClass("ui-tabs-active ui-state-active"),s.hide(),n())}}))})(jQuery);(function(l){function c(e,t){var i=(e.attr("aria-describedby")||"").split(/\s+/);i.push(t),e.data("ui-tooltip-id",t).attr("aria-describedby",l.trim(i.join(" ")))}function r(e){var t=e.data("ui-tooltip-id"),i=(e.attr("aria-describedby")||"").split(/\s+/),n=l.inArray(t,i);n!==-1&&i.splice(n,1),e.removeData("ui-tooltip-id"),i=l.trim(i.join(" ")),i?e.attr("aria-describedby",i):e.removeAttr("aria-describedby")}var n=0;l.widget("ui.tooltip",{version:"1.9.2",options:{content:function(){return l(this).attr("title")},hide:!0,items:"[title]:not([disabled])",position:{my:"left top+15",at:"left bottom",collision:"flipfit flip"},show:!0,tooltipClass:null,track:!1,close:null,open:null},_create:function(){this._on({mouseover:"open",focusin:"open"}),this.tooltips={},this.parents={},this.options.disabled&&this._disable()},_setOption:function(e,t){var i=this;if(e==="disabled"){this[t?"_disable":"_enable"](),this.options[e]=t;return}this._super(e,t),e==="content"&&l.each(this.tooltips,function(e,t){i._updateContent(t)})},_disable:function(){var n=this;l.each(this.tooltips,function(e,t){var i=l.Event("blur");i.target=i.currentTarget=t[0],n.close(i,!0)}),this.element.find(this.options.items).andSelf().each(function(){var e=l(this);e.is("[title]")&&e.data("ui-tooltip-title",e.attr("title")).attr("title","")})},_enable:function(){this.element.find(this.options.items).andSelf().each(function(){var e=l(this);e.data("ui-tooltip-title")&&e.attr("title",e.data("ui-tooltip-title"))})},open:function(e){var i=this,t=l(e?e.target:this.element).closest(this.options.items);if(!t.length||t.data("ui-tooltip-id"))return;t.attr("title")&&t.data("ui-tooltip-title",t.attr("title")),t.data("ui-tooltip-open",!0),e&&e.type==="mouseover"&&t.parents().each(function(){var e=l(this),t;e.data("ui-tooltip-open")&&(t=l.Event("blur"),t.target=t.currentTarget=this,i.close(t,!0)),e.attr("title")&&(e.uniqueId(),i.parents[this.id]={element:this,title:e.attr("title")},e.attr("title",""))}),this._updateContent(t,e)},_updateContent:function(t,i){var e,n=this.options.content,r=this,o=i?i.type:null;if(typeof n=="string")return this._open(i,t,n);e=n.call(t[0],function(e){if(!t.data("ui-tooltip-open"))return;r._delay(function(){i&&(i.type=o),this._open(i,t,e)})}),e&&this._open(i,t,e)},_open:function(e,i,t){function n(e){a.of=e;if(r.is(":hidden"))return;r.position(a)}var r,o,s,a=l.extend({},this.options.position);if(!t)return;r=this._find(i);if(r.length){r.find(".ui-tooltip-content").html(t);return}i.is("[title]")&&(e&&e.type==="mouseover"?i.attr("title",""):i.removeAttr("title")),r=this._tooltip(i),c(i,r.attr("id")),r.find(".ui-tooltip-content").html(t),this.options.track&&e&&/^mouse/.test(e.type)?(this._on(this.document,{mousemove:n}),n(e)):r.position(l.extend({of:i},this.options.position)),r.hide(),this._show(r,this.options.show),this.options.show&&this.options.show.delay&&(s=setInterval(function(){r.is(":visible")&&(n(a.of),clearInterval(s))},l.fx.interval)),this._trigger("open",e,{tooltip:r}),o={keyup:function(e){if(e.keyCode===l.ui.keyCode.ESCAPE){var t=l.Event(e);t.currentTarget=i[0],this.close(t,!0)}},remove:function(){this._removeTooltip(r)}};if(!e||e.type==="mouseover")o.mouseleave="close";if(!e||e.type==="focusin")o.focusout="close";this._on(!0,i,o)},close:function(e){var i=this,t=l(e?e.currentTarget:this.element),n=this._find(t);if(this.closing)return;t.data("ui-tooltip-title")&&t.attr("title",t.data("ui-tooltip-title")),r(t),n.stop(!0),this._hide(n,this.options.hide,function(){i._removeTooltip(l(this))}),t.removeData("ui-tooltip-open"),this._off(t,"mouseleave focusout keyup"),t[0]!==this.element[0]&&this._off(t,"remove"),this._off(this.document,"mousemove"),e&&e.type==="mouseleave"&&l.each(this.parents,function(e,t){l(t.element).attr("title",t.title),delete i.parents[e]}),this.closing=!0,this._trigger("close",e,{tooltip:n}),this.closing=!1},_tooltip:function(e){var t="ui-tooltip-"+n++,i=l("<div>").attr({id:t,role:"tooltip"}).addClass("ui-tooltip ui-widget ui-corner-all ui-widget-content "+(this.options.tooltipClass||""));return l("<div>").addClass("ui-tooltip-content").appendTo(i),i.appendTo(this.document[0].body),l.fn.bgiframe&&i.bgiframe(),this.tooltips[t]=e,i},_find:function(e){var t=e.data("ui-tooltip-id");return t?l("#"+t):l()},_removeTooltip:function(e){e.remove(),delete this.tooltips[e.attr("id")]},_destroy:function(){var n=this;l.each(this.tooltips,function(e,t){var i=l.Event("blur");i.target=i.currentTarget=t[0],n.close(i,!0),l("#"+e).remove(),t.data("ui-tooltip-title")&&(t.attr("title",t.data("ui-tooltip-title")),t.removeData("ui-tooltip-title"))})}})})(jQuery);jQuery.effects||function(y,c){var a=y.uiBackCompat!==!1,o="ui-effects-";y.effects={effect:{}},function(u,d){function f(e,t,i){var n=m[t.type]||{};return e==null?i||!t.def?null:t.def:(e=n.floor?~~e:parseFloat(e),isNaN(e)?t.def:n.mod?(e+n.mod)%n.mod:0>e?0:n.max<e?n.max:e)}function a(s){var a=p(),l=a._rgba=[];return s=s.toLowerCase(),v(t,function(e,t){var i,n=t.re.exec(s),r=n&&t.parse(n),o=t.space||"rgba";if(r)return i=a[o](r),a[g[o].cache]=i[g[o].cache],l=a._rgba=i._rgba,!1}),l.length?(l.join()==="0,0,0,0"&&u.extend(l,c.transparent),a):c[s]}function l(e,t,i){return i=(i+1)%1,i*6<1?e+(t-e)*i*6:i*2<1?t:i*3<2?e+(t-e)*(2/3-i)*6:e}var e="backgroundColor borderBottomColor borderLeftColor borderRightColor borderTopColor color columnRuleColor outlineColor textDecorationColor textEmphasisColor".split(" "),h=/^([\-+])=\s*(\d+\.?\d*)/,t=[{re:/rgba?\(\s*(\d{1,3})\s*,\s*(\d{1,3})\s*,\s*(\d{1,3})\s*(?:,\s*(\d+(?:\.\d+)?)\s*)?\)/,parse:function(e){return[e[1],e[2],e[3],e[4]]}},{re:/rgba?\(\s*(\d+(?:\.\d+)?)\%\s*,\s*(\d+(?:\.\d+)?)\%\s*,\s*(\d+(?:\.\d+)?)\%\s*(?:,\s*(\d+(?:\.\d+)?)\s*)?\)/,parse:function(e){return[e[1]*2.55,e[2]*2.55,e[3]*2.55,e[4]]}},{re:/#([a-f0-9]{2})([a-f0-9]{2})([a-f0-9]{2})/,parse:function(e){return[parseInt(e[1],16),parseInt(e[2],16),parseInt(e[3],16)]}},{re:/#([a-f0-9])([a-f0-9])([a-f0-9])/,parse:function(e){return[parseInt(e[1]+e[1],16),parseInt(e[2]+e[2],16),parseInt(e[3]+e[3],16)]}},{re:/hsla?\(\s*(\d+(?:\.\d+)?)\s*,\s*(\d+(?:\.\d+)?)\%\s*,\s*(\d+(?:\.\d+)?)\%\s*(?:,\s*(\d+(?:\.\d+)?)\s*)?\)/,space:"hsla",parse:function(e){return[e[1],e[2]/100,e[3]/100,e[4]]}}],p=u.Color=function(e,t,i,n){return new u.Color.fn.parse(e,t,i,n)},g={rgba:{props:{red:{idx:0,type:"byte"},green:{idx:1,type:"byte"},blue:{idx:2,type:"byte"}}},hsla:{props:{hue:{idx:0,type:"degrees"},saturation:{idx:1,type:"percent"},lightness:{idx:2,type:"percent"}}}},m={byte:{floor:!0,max:255},percent:{max:1},degrees:{mod:360,floor:!0}},s=p.support={},i=u("<p>")[0],c,v=u.each;i.style.cssText="background-color:rgba(1,1,1,.5)",s.rgba=i.style.backgroundColor.indexOf("rgba")>-1,v(g,function(e,t){t.cache="_"+e,t.props.alpha={idx:3,type:"percent",def:1}}),p.fn=u.extend(p.prototype,{parse:function(r,e,t,i){if(r===d)return this._rgba=[null,null,null,null],this;if(r.jquery||r.nodeType)r=u(r).css(e),e=d;var o=this,n=u.type(r),s=this._rgba=[];e!==d&&(r=[r,e,t,i],n="array");if(n==="string")return this.parse(a(r)||c._default);if(n==="array")return v(g.rgba.props,function(e,t){s[t.idx]=f(r[t.idx],t)}),this;if(n==="object")return r instanceof p?v(g,function(e,t){r[t.cache]&&(o[t.cache]=r[t.cache].slice())}):v(g,function(e,i){var n=i.cache;v(i.props,function(e,t){if(!o[n]&&i.to){if(e==="alpha"||r[e]==null)return;o[n]=i.to(o._rgba)}o[n][t.idx]=f(r[e],t,!0)}),o[n]&&y.inArray(null,o[n].slice(0,3))<0&&(o[n][3]=1,i.from&&(o._rgba=i.from(o[n])))}),this},is:function(e){var r=p(e),o=!0,s=this;return v(g,function(e,t){var i,n=r[t.cache];return n&&(i=s[t.cache]||t.to&&t.to(s._rgba)||[],v(t.props,function(e,t){if(n[t.idx]!=null)return o=n[t.idx]===i[t.idx],o})),o}),o},_space:function(){var i=[],n=this;return v(g,function(e,t){n[t.cache]&&i.push(e)}),i.pop()},transition:function(e,s){var a=p(e),t=a._space(),i=g[t],n=this.alpha()===0?p("transparent"):this,l=n[i.cache]||i.to(n._rgba),c=l.slice();return a=a[i.cache],v(i.props,function(e,t){var i=t.idx,n=l[i],r=a[i],o=m[t.type]||{};if(r===null)return;n===null?c[i]=r:(o.mod&&(r-n>o.mod/2?n+=o.mod:n-r>o.mod/2&&(n-=o.mod)),c[i]=f((r-n)*s+n,t))}),this[t](c)},blend:function(e){if(this._rgba[3]===1)return this;var t=this._rgba.slice(),i=t.pop(),n=p(e)._rgba;return p(u.map(t,function(e,t){return(1-i)*n[t]+i*e}))},toRgbaString:function(){var e="rgba(",t=u.map(this._rgba,function(e,t){return e==null?t>2?1:0:e});return t[3]===1&&(t.pop(),e="rgb("),e+t.join()+")"},toHslaString:function(){var e="hsla(",t=u.map(this.hsla(),function(e,t){return e==null&&(e=t>2?1:0),t&&t<3&&(e=Math.round(e*100)+"%"),e});return t[3]===1&&(t.pop(),e="hsl("),e+t.join()+")"},toHexString:function(e){var t=this._rgba.slice(),i=t.pop();return e&&t.push(~~(i*255)),"#"+u.map(t,function(e){return e=(e||0).toString(16),e.length===1?"0"+e:e}).join("")},toString:function(){return this._rgba[3]===0?"transparent":this.toRgbaString()}}),p.fn.parse.prototype=p.fn,g.hsla.to=function(e){if(e[0]==null||e[1]==null||e[2]==null)return[null,null,null,e[3]];var t=e[0]/255,i=e[1]/255,n=e[2]/255,r=e[3],o=Math.max(t,i,n),s=Math.min(t,i,n),a=o-s,l=o+s,c=l*.5,u,d;return s===o?u=0:t===o?u=60*(i-n)/a+360:i===o?u=60*(n-t)/a+120:u=60*(t-i)/a+240,c===0||c===1?d=c:c<=.5?d=a/l:d=a/(2-l),[Math.round(u)%360,d,c,r==null?1:r]},g.hsla.from=function(e){if(e[0]==null||e[1]==null||e[2]==null)return[null,null,null,e[3]];var t=e[0]/360,i=e[1],n=e[2],r=e[3],o=n<=.5?n*(1+i):n+i-n*i,s=2*n-o;return[Math.round(l(s,o,t+1/3)*255),Math.round(l(s,o,t)*255),Math.round(l(s,o,t-1/3)*255),r]},v(g,function(l,e){var i=e.props,s=e.cache,a=e.to,c=e.from;p.fn[l]=function(e){a&&!this[s]&&(this[s]=a(this._rgba));if(e===d)return this[s].slice();var t,n=u.type(e),r=n==="array"||n==="object"?e:arguments,o=this[s].slice();return v(i,function(e,t){var i=r[n==="object"?e:t.idx];i==null&&(i=o[t.idx]),o[t.idx]=f(i,t)}),c?(t=p(c(o)),t[s]=o,t):p(o)},v(i,function(s,a){if(p.fn[s])return;p.fn[s]=function(e){var t=u.type(e),i=s==="alpha"?this._hsla?"hsla":"rgba":l,n=this[i](),r=n[a.idx],o;return t==="undefined"?r:(t==="function"&&(e=e.call(this,r),t=u.type(e)),e==null&&a.empty?this:(t==="string"&&(o=h.exec(e),o&&(e=r+parseFloat(o[2])*(o[1]==="+"?1:-1))),n[a.idx]=e,this[i](n)))}})}),v(e,function(e,o){u.cssHooks[o]={set:function(e,t){var i,n,r="";if(u.type(t)!=="string"||(i=a(t))){t=p(i||t);if(!s.rgba&&t._rgba[3]!==1){n=o==="backgroundColor"?e.parentNode:e;while((r===""||r==="transparent")&&n&&n.style)try{r=u.css(n,"backgroundColor"),n=n.parentNode}catch(e){}t=t.blend(r&&r!=="transparent"?r:"_default")}t=t.toRgbaString()}try{e.style[o]=t}catch(e){}}},u.fx.step[o]=function(e){e.colorInit||(e.start=p(e.elem,o),e.end=p(e.end),e.colorInit=!0),u.cssHooks[o].set(e.elem,e.start.transition(e.end,e.pos))}}),u.cssHooks.borderColor={expand:function(i){var n={};return v(["Top","Right","Bottom","Left"],function(e,t){n["border"+t+"Color"]=i}),n}},c=u.Color.names={aqua:"#00ffff",black:"#000000",blue:"#0000ff",fuchsia:"#ff00ff",gray:"#808080",green:"#008000",lime:"#00ff00",maroon:"#800000",navy:"#000080",olive:"#808000",purple:"#800080",red:"#ff0000",silver:"#c0c0c0",teal:"#008080",white:"#ffffff",yellow:"#ffff00",transparent:[null,null,null,0],_default:"#ffffff"}}(jQuery),function(){function s(){var e=this.ownerDocument.defaultView?this.ownerDocument.defaultView.getComputedStyle(this,null):this.currentStyle,t={},i,n;if(e&&e.length&&e[0]&&e[e[0]]){n=e.length;while(n--)i=e[n],typeof e[i]=="string"&&(t[y.camelCase(i)]=e[i])}else for(i in e)typeof e[i]=="string"&&(t[i]=e[i]);return t}function a(e,t){var i={},n,r;for(n in t)r=t[n],e[n]!==r&&!o[n]&&(y.fx.step[n]||!isNaN(parseFloat(r)))&&(i[n]=r);return i}var l=["add","remove","toggle"],o={border:1,borderBottom:1,borderColor:1,borderLeft:1,borderRight:1,borderTop:1,borderWidth:1,margin:1,padding:1};y.each(["borderLeftStyle","borderRightStyle","borderBottomStyle","borderTopStyle"],function(e,t){y.fx.step[t]=function(e){if(e.end!=="none"&&!e.setAttr||e.pos===1&&!e.setAttr)jQuery.style(e.elem,t,e.end),e.setAttr=!0}}),y.effects.animateClass=function(r,e,t,i){var o=y.speed(e,t,i);return this.queue(function(){var i=y(this),e=i.attr("class")||"",t,n=o.children?i.find("*").andSelf():i;n=n.map(function(){var e=y(this);return{el:e,start:s.call(this)}}),t=function(){y.each(l,function(e,t){r[t]&&i[t+"Class"](r[t])})},t(),n=n.map(function(){return this.end=s.call(this.el[0]),this.diff=a(this.start,this.end),this}),i.attr("class",e),n=n.map(function(){var e=this,t=y.Deferred(),i=jQuery.extend({},o,{queue:!1,complete:function(){t.resolve(e)}});return this.el.animate(this.diff,i),t.promise()}),y.when.apply(y,n.get()).done(function(){t(),y.each(arguments,function(){var t=this.el;y.each(this.diff,function(e){t.css(e,"")})}),o.complete.call(i[0])})})},y.fn.extend({_addClass:y.fn.addClass,addClass:function(e,t,i,n){return t?y.effects.animateClass.call(this,{add:e},t,i,n):this._addClass(e)},_removeClass:y.fn.removeClass,removeClass:function(e,t,i,n){return t?y.effects.animateClass.call(this,{remove:e},t,i,n):this._removeClass(e)},_toggleClass:y.fn.toggleClass,toggleClass:function(e,t,i,n,r){return typeof t=="boolean"||t===c?i?y.effects.animateClass.call(this,t?{add:e}:{remove:e},i,n,r):this._toggleClass(e,t):y.effects.animateClass.call(this,{toggle:e},t,i,n)},switchClass:function(e,t,i,n,r){return y.effects.animateClass.call(this,{add:t,remove:e},i,n,r)}})}(),function(){function r(e,t,i,n){y.isPlainObject(e)&&(t=e,e=e.effect),e={effect:e},t==null&&(t={}),y.isFunction(t)&&(n=t,i=null,t={});if(typeof t=="number"||y.fx.speeds[t])n=i,i=t,t={};return y.isFunction(i)&&(n=i,i=null),t&&y.extend(e,t),i=i||t.duration,e.duration=y.fx.off?0:typeof i=="number"?i:i in y.fx.speeds?y.fx.speeds[i]:y.fx.speeds._default,e.complete=n||t.complete,e}function i(e){return!e||typeof e=="number"||y.fx.speeds[e]?!0:typeof e=="string"&&!y.effects.effect[e]?a&&y.effects[e]?!1:!0:!1}y.extend(y.effects,{version:"1.9.2",save:function(e,t){for(var i=0;i<t.length;i++)t[i]!==null&&e.data(o+t[i],e[0].style[t[i]])},restore:function(e,t){var i,n;for(n=0;n<t.length;n++)t[n]!==null&&(i=e.data(o+t[n]),i===c&&(i=""),e.css(t[n],i))},setMode:function(e,t){return t==="toggle"&&(t=e.is(":hidden")?"show":"hide"),t},getBaseline:function(e,t){var i,n;switch(e[0]){case"top":i=0;break;case"middle":i=.5;break;case"bottom":i=1;break;default:i=e[0]/t.height}switch(e[1]){case"left":n=0;break;case"center":n=.5;break;case"right":n=1;break;default:n=e[1]/t.width}return{x:n,y:i}},createWrapper:function(i){if(i.parent().is(".ui-effects-wrapper"))return i.parent();var n={width:i.outerWidth(!0),height:i.outerHeight(!0),float:i.css("float")},e=y("<div></div>").addClass("ui-effects-wrapper").css({fontSize:"100%",background:"transparent",border:"none",margin:0,padding:0}),t={width:i.width(),height:i.height()},r=document.activeElement;try{r.id}catch(e){r=document.body}return i.wrap(e),(i[0]===r||y.contains(i[0],r))&&y(r).focus(),e=i.parent(),i.css("position")==="static"?(e.css({position:"relative"}),i.css({position:"relative"})):(y.extend(n,{position:i.css("position"),zIndex:i.css("z-index")}),y.each(["top","left","bottom","right"],function(e,t){n[t]=i.css(t),isNaN(parseInt(n[t],10))&&(n[t]="auto")}),i.css({position:"relative",top:0,left:0,right:"auto",bottom:"auto"})),i.css(t),e.css(n).show()},removeWrapper:function(e){var t=document.activeElement;return e.parent().is(".ui-effects-wrapper")&&(e.parent().replaceWith(e),(e[0]===t||y.contains(e[0],t))&&y(t).focus()),e},setTransition:function(n,e,r,o){return o=o||{},y.each(e,function(e,t){var i=n.cssUnit(t);i[0]>0&&(o[t]=i[0]*r+i[1])}),o}}),y.fn.extend({effect:function(){function e(e){function t(){y.isFunction(n)&&n.call(i[0]),y.isFunction(e)&&e()}var i=y(this),n=o.complete,r=o.mode;(i.is(":hidden")?r==="hide":r==="show")?t():s.call(i[0],o,t)}var o=r.apply(this,arguments),t=o.mode,i=o.queue,s=y.effects.effect[o.effect],n=!s&&a&&y.effects[o.effect];return y.fx.off||!s&&!n?t?this[t](o.duration,o.complete):this.each(function(){o.complete&&o.complete.call(this)}):s?i===!1?this.each(e):this.queue(i||"fx",e):n.call(this,{options:o,duration:o.duration,callback:o.complete,mode:o.mode})},_show:y.fn.show,show:function(e){if(i(e))return this._show.apply(this,arguments);var t=r.apply(this,arguments);return t.mode="show",this.effect.call(this,t)},_hide:y.fn.hide,hide:function(e){if(i(e))return this._hide.apply(this,arguments);var t=r.apply(this,arguments);return t.mode="hide",this.effect.call(this,t)},__toggle:y.fn.toggle,toggle:function(e){if(i(e)||typeof e=="boolean"||y.isFunction(e))return this.__toggle.apply(this,arguments);var t=r.apply(this,arguments);return t.mode="toggle",this.effect.call(this,t)},cssUnit:function(e){var i=this.css(e),n=[];return y.each(["em","px","%","pt"],function(e,t){i.indexOf(t)>0&&(n=[parseFloat(i),t])}),n}})}(),function(){var i={};y.each(["Quad","Cubic","Quart","Quint","Expo"],function(t,e){i[e]=function(e){return Math.pow(e,t+2)}}),y.extend(i,{Sine:function(e){return 1-Math.cos(e*Math.PI/2)},Circ:function(e){return 1-Math.sqrt(1-e*e)},Elastic:function(e){return e===0||e===1?e:-Math.pow(2,8*(e-1))*Math.sin(((e-1)*80-7.5)*Math.PI/15)},Back:function(e){return e*e*(3*e-2)},Bounce:function(e){var t,i=4;while(e<((t=Math.pow(2,--i))-1)/11);return 1/Math.pow(4,3-i)-7.5625*Math.pow((t*3-2)/22-e,2)}}),y.each(i,function(e,t){y.easing["easeIn"+e]=t,y.easing["easeOut"+e]=function(e){return 1-t(1-e)},y.easing["easeInOut"+e]=function(e){return e<.5?t(e*2)/2:1-t(e*-2+2)/2}})}()}(jQuery);(function(g,e){var m=/up|down|vertical/,v=/up|left|vertical|horizontal/;g.effects.effect.blind=function(e,t){var i=g(this),n=["position","top","bottom","left","right","height","width"],r=g.effects.setMode(i,e.mode||"hide"),o=e.direction||"up",s=m.test(o),a=s?"height":"width",l=s?"top":"left",c=v.test(o),u={},d=r==="show",f,h,p;i.parent().is(".ui-effects-wrapper")?g.effects.save(i.parent(),n):g.effects.save(i,n),i.show(),f=g.effects.createWrapper(i).css({overflow:"hidden"}),h=f[a](),p=parseFloat(f.css(l))||0,u[a]=d?h:0,c||(i.css(s?"bottom":"right",0).css(s?"top":"left","auto").css({position:"absolute"}),u[l]=d?p:h+p),d&&(f.css(a,0),c||f.css(l,p+h)),f.animate(u,{duration:e.duration,easing:e.easing,queue:!1,complete:function(){r==="hide"&&i.hide(),g.effects.restore(i,n),g.effects.removeWrapper(i),t()}})}})(jQuery);(function(b,e){b.effects.effect.bounce=function(e,t){var i=b(this),n=["position","top","bottom","left","right","height","width"],r=b.effects.setMode(i,e.mode||"effect"),o=r==="hide",s=r==="show",a=e.direction||"up",l=e.distance,c=e.times||5,u=c*2+(s||o?1:0),d=e.duration/u,f=e.easing,h=a==="up"||a==="down"?"top":"left",p=a==="up"||a==="left",g,m,v,y=i.queue(),_=y.length;(s||o)&&n.push("opacity"),b.effects.save(i,n),i.show(),b.effects.createWrapper(i),l||(l=i[h==="top"?"outerHeight":"outerWidth"]()/3),s&&(v={opacity:1},v[h]=0,i.css("opacity",0).css(h,p?-l*2:l*2).animate(v,d,f)),o&&(l/=Math.pow(2,c-1)),v={},v[h]=0;for(g=0;g<c;g++)m={},m[h]=(p?"-=":"+=")+l,i.animate(m,d,f).animate(v,d,f),l=o?l*2:l/2;o&&(m={opacity:0},m[h]=(p?"-=":"+=")+l,i.animate(m,d,f)),i.queue(function(){o&&i.hide(),b.effects.restore(i,n),b.effects.removeWrapper(i),t()}),_>1&&y.splice.apply(y,[1,0].concat(y.splice(_,u+1))),i.dequeue()}})(jQuery);(function(p,e){p.effects.effect.clip=function(e,t){var i=p(this),n=["position","top","bottom","left","right","height","width"],r=p.effects.setMode(i,e.mode||"hide"),o=r==="show",s=e.direction||"vertical",a=s==="vertical",l=a?"height":"width",c=a?"top":"left",u={},d,f,h;p.effects.save(i,n),i.show(),d=p.effects.createWrapper(i).css({overflow:"hidden"}),f=i[0].tagName==="IMG"?d:i,h=f[l](),o&&(f.css(l,0),f.css(c,h/2)),u[l]=o?h:0,u[c]=o?0:h/2,f.animate(u,{queue:!1,duration:e.duration,easing:e.easing,complete:function(){o||i.hide(),p.effects.restore(i,n),p.effects.removeWrapper(i),t()}})}})(jQuery);(function(d,e){d.effects.effect.drop=function(e,t){var i=d(this),n=["position","top","bottom","left","right","opacity","height","width"],r=d.effects.setMode(i,e.mode||"hide"),o=r==="show",s=e.direction||"left",a=s==="up"||s==="down"?"top":"left",l=s==="up"||s==="left"?"pos":"neg",c={opacity:o?1:0},u;d.effects.save(i,n),i.show(),d.effects.createWrapper(i),u=e.distance||i[a==="top"?"outerHeight":"outerWidth"](!0)/2,o&&i.css("opacity",0).css(a,l==="pos"?-u:u),c[a]=(o?l==="pos"?"+=":"-=":l==="pos"?"-=":"+=")+u,i.animate(c,{queue:!1,duration:e.duration,easing:e.easing,complete:function(){r==="hide"&&i.hide(),d.effects.restore(i,n),d.effects.removeWrapper(i),t()}})}})(jQuery);(function(_,e){_.effects.effect.explode=function(e,t){function i(){f.push(this),f.length===r*o&&n()}function n(){s.css({visibility:"visible"}),_(f).remove(),l||s.hide(),t()}var r=e.pieces?Math.round(Math.sqrt(e.pieces)):3,o=r,s=_(this),a=_.effects.setMode(s,e.mode||"hide"),l=a==="show",c=s.show().css("visibility","hidden").offset(),u=Math.ceil(s.outerWidth()/o),d=Math.ceil(s.outerHeight()/r),f=[],h,p,g,m,v,y;for(h=0;h<r;h++){m=c.top+h*d,y=h-(r-1)/2;for(p=0;p<o;p++)g=c.left+p*u,v=p-(o-1)/2,s.clone().appendTo("body").wrap("<div></div>").css({position:"absolute",visibility:"visible",left:-p*u,top:-h*d}).parent().addClass("ui-effects-explode").css({position:"absolute",overflow:"hidden",width:u,height:d,left:g+(l?v*u:0),top:m+(l?y*d:0),opacity:l?0:1}).animate({left:g+(l?0:v*u),top:m+(l?0:y*d),opacity:l?1:0},e.duration||500,e.easing,i)}}})(jQuery);(function(r,e){r.effects.effect.fade=function(e,t){var i=r(this),n=r.effects.setMode(i,e.mode||"toggle");i.animate({opacity:n},{queue:!1,duration:e.duration,easing:e.easing,complete:t})}})(jQuery);(function(v,e){v.effects.effect.fold=function(e,t){var i=v(this),n=["position","top","bottom","left","right","height","width"],r=v.effects.setMode(i,e.mode||"hide"),o=r==="show",s=r==="hide",a=e.size||15,l=/([0-9]+)%/.exec(a),c=!!e.horizFirst,u=o!==c,d=u?["width","height"]:["height","width"],f=e.duration/2,h,p,g={},m={};v.effects.save(i,n),i.show(),h=v.effects.createWrapper(i).css({overflow:"hidden"}),p=u?[h.width(),h.height()]:[h.height(),h.width()],l&&(a=parseInt(l[1],10)/100*p[s?0:1]),o&&h.css(c?{height:0,width:a}:{height:a,width:0}),g[d[0]]=o?p[0]:a,m[d[1]]=o?p[1]:0,h.animate(g,f,e.easing).animate(m,f,e.easing,function(){s&&i.hide(),v.effects.restore(i,n),v.effects.removeWrapper(i),t()})}})(jQuery);(function(s,e){s.effects.effect.highlight=function(e,t){var i=s(this),n=["backgroundImage","backgroundColor","opacity"],r=s.effects.setMode(i,e.mode||"show"),o={backgroundColor:i.css("backgroundColor")};r==="hide"&&(o.opacity=0),s.effects.save(i,n),i.show().css({backgroundImage:"none",backgroundColor:e.color||"#ffff99"}).animate(o,{queue:!1,duration:e.duration,easing:e.easing,complete:function(){r==="hide"&&i.hide(),s.effects.restore(i,n),t()}})}})(jQuery);(function(h,e){h.effects.effect.pulsate=function(e,t){var i=h(this),n=h.effects.setMode(i,e.mode||"show"),r=n==="show",o=n==="hide",s=r||n==="hide",a=(e.times||5)*2+(s?1:0),l=e.duration/a,c=0,u=i.queue(),d=u.length,f;if(r||!i.is(":visible"))i.css("opacity",0).show(),c=1;for(f=1;f<a;f++)i.animate({opacity:c},l,e.easing),c=1-c;i.animate({opacity:c},l,e.easing),i.queue(function(){o&&i.hide(),t()}),d>1&&u.splice.apply(u,[1,0].concat(u.splice(d,a+1))),i.dequeue()}})(jQuery);(function(_,e){_.effects.effect.puff=function(e,t){var i=_(this),n=_.effects.setMode(i,e.mode||"hide"),r=n==="hide",o=parseInt(e.percent,10)||150,s=o/100,a={height:i.height(),width:i.width(),outerHeight:i.outerHeight(),outerWidth:i.outerWidth()};_.extend(e,{effect:"scale",queue:!1,fade:!0,mode:n,complete:t,percent:r?o:100,from:r?a:{height:a.height*s,width:a.width*s,outerHeight:a.outerHeight*s,outerWidth:a.outerWidth*s}}),i.effect(e)},_.effects.effect.scale=function(e,t){var i=_(this),n=_.extend(!0,{},e),r=_.effects.setMode(i,e.mode||"effect"),o=parseInt(e.percent,10)||(parseInt(e.percent,10)===0?0:r==="hide"?0:100),s=e.direction||"both",a=e.origin,l={height:i.height(),width:i.width(),outerHeight:i.outerHeight(),outerWidth:i.outerWidth()},c={y:s!=="horizontal"?o/100:1,x:s!=="vertical"?o/100:1};n.effect="size",n.queue=!1,n.complete=t,r!=="effect"&&(n.origin=a||["middle","center"],n.restore=!0),n.from=e.from||(r==="show"?{height:0,width:0,outerHeight:0,outerWidth:0}:l),n.to={height:l.height*c.y,width:l.width*c.x,outerHeight:l.outerHeight*c.y,outerWidth:l.outerWidth*c.x},n.fade&&(r==="show"&&(n.from.opacity=0,n.to.opacity=1),r==="hide"&&(n.from.opacity=1,n.to.opacity=0)),i.effect(n)},_.effects.effect.size=function(i,e){var t,n,r,o=_(this),s=["position","top","bottom","left","right","width","height","overflow","opacity"],a=["position","top","bottom","left","right","overflow","opacity"],l=["width","height","overflow"],c=["fontSize"],u=["borderTopWidth","borderBottomWidth","paddingTop","paddingBottom"],d=["borderLeftWidth","borderRightWidth","paddingLeft","paddingRight"],f=_.effects.setMode(o,i.mode||"effect"),h=i.restore||f!=="effect",p=i.scale||"both",g=i.origin||["middle","center"],m=o.css("position"),v=h?s:a,y={height:0,width:0,outerHeight:0,outerWidth:0};f==="show"&&o.show(),t={height:o.height(),width:o.width(),outerHeight:o.outerHeight(),outerWidth:o.outerWidth()},i.mode==="toggle"&&f==="show"?(o.from=i.to||y,o.to=i.from||t):(o.from=i.from||(f==="show"?y:t),o.to=i.to||(f==="hide"?y:t)),r={from:{y:o.from.height/t.height,x:o.from.width/t.width},to:{y:o.to.height/t.height,x:o.to.width/t.width}};if(p==="box"||p==="both")r.from.y!==r.to.y&&(v=v.concat(u),o.from=_.effects.setTransition(o,u,r.from.y,o.from),o.to=_.effects.setTransition(o,u,r.to.y,o.to)),r.from.x!==r.to.x&&(v=v.concat(d),o.from=_.effects.setTransition(o,d,r.from.x,o.from),o.to=_.effects.setTransition(o,d,r.to.x,o.to));(p==="content"||p==="both")&&r.from.y!==r.to.y&&(v=v.concat(c).concat(l),o.from=_.effects.setTransition(o,c,r.from.y,o.from),o.to=_.effects.setTransition(o,c,r.to.y,o.to)),_.effects.save(o,v),o.show(),_.effects.createWrapper(o),o.css("overflow","hidden").css(o.from),g&&(n=_.effects.getBaseline(g,t),o.from.top=(t.outerHeight-o.outerHeight())*n.y,o.from.left=(t.outerWidth-o.outerWidth())*n.x,o.to.top=(t.outerHeight-o.to.outerHeight)*n.y,o.to.left=(t.outerWidth-o.to.outerWidth)*n.x),o.css(o.from);if(p==="content"||p==="both")u=u.concat(["marginTop","marginBottom"]).concat(c),d=d.concat(["marginLeft","marginRight"]),l=s.concat(u).concat(d),o.find("*[width]").each(function(){var e=_(this),t={height:e.height(),width:e.width(),outerHeight:e.outerHeight(),outerWidth:e.outerWidth()};h&&_.effects.save(e,l),e.from={height:t.height*r.from.y,width:t.width*r.from.x,outerHeight:t.outerHeight*r.from.y,outerWidth:t.outerWidth*r.from.x},e.to={height:t.height*r.to.y,width:t.width*r.to.x,outerHeight:t.height*r.to.y,outerWidth:t.width*r.to.x},r.from.y!==r.to.y&&(e.from=_.effects.setTransition(e,u,r.from.y,e.from),e.to=_.effects.setTransition(e,u,r.to.y,e.to)),r.from.x!==r.to.x&&(e.from=_.effects.setTransition(e,d,r.from.x,e.from),e.to=_.effects.setTransition(e,d,r.to.x,e.to)),e.css(e.from),e.animate(e.to,i.duration,i.easing,function(){h&&_.effects.restore(e,l)})});o.animate(o.to,{queue:!1,duration:i.duration,easing:i.easing,complete:function(){o.to.opacity===0&&o.css("opacity",o.from.opacity),f==="hide"&&o.hide(),_.effects.restore(o,v),h||(m==="static"?o.css({position:"relative",top:o.to.top,left:o.to.left}):_.each(["top","left"],function(r,e){o.css(e,function(e,t){var i=parseInt(t,10),n=r?o.to.left:o.to.top;return t==="auto"?n+"px":i+n+"px"})})),_.effects.removeWrapper(o),e()}})}})(jQuery);(function(y,e){y.effects.effect.shake=function(e,t){var i=y(this),n=["position","top","bottom","left","right","height","width"],r=y.effects.setMode(i,e.mode||"effect"),o=e.direction||"left",s=e.distance||20,a=e.times||3,l=a*2+1,c=Math.round(e.duration/l),u=o==="up"||o==="down"?"top":"left",d=o==="up"||o==="left",f={},h={},p={},g,m=i.queue(),v=m.length;y.effects.save(i,n),i.show(),y.effects.createWrapper(i),f[u]=(d?"-=":"+=")+s,h[u]=(d?"+=":"-=")+s*2,p[u]=(d?"-=":"+=")+s*2,i.animate(f,c,e.easing);for(g=1;g<a;g++)i.animate(h,c,e.easing).animate(p,c,e.easing);i.animate(h,c,e.easing).animate(f,c/2,e.easing).queue(function(){r==="hide"&&i.hide(),y.effects.restore(i,n),y.effects.removeWrapper(i),t()}),v>1&&m.splice.apply(m,[1,0].concat(m.splice(v,l+1))),i.dequeue()}})(jQuery);(function(d,e){d.effects.effect.slide=function(e,t){var i=d(this),n=["position","top","bottom","left","right","width","height"],r=d.effects.setMode(i,e.mode||"show"),o=r==="show",s=e.direction||"left",a=s==="up"||s==="down"?"top":"left",l=s==="up"||s==="left",c,u={};d.effects.save(i,n),i.show(),c=e.distance||i[a==="top"?"outerHeight":"outerWidth"](!0),d.effects.createWrapper(i).css({overflow:"hidden"}),o&&i.css(a,l?isNaN(c)?"-"+c:-c:c),u[a]=(o?l?"+=":"-=":l?"-=":"+=")+c,i.animate(u,{queue:!1,duration:e.duration,easing:e.easing,complete:function(){r==="hide"&&i.hide(),d.effects.restore(i,n),d.effects.removeWrapper(i),t()}})}})(jQuery);(function(f,e){f.effects.effect.transfer=function(e,t){var i=f(this),n=f(e.to),r=n.css("position")==="fixed",o=f("body"),s=r?o.scrollTop():0,a=r?o.scrollLeft():0,l=n.offset(),c={top:l.top-s,left:l.left-a,height:n.innerHeight(),width:n.innerWidth()},u=i.offset(),d=f('<div class="ui-effects-transfer"></div>').appendTo(document.body).addClass(e.className).css({top:u.top-s,left:u.left-a,height:i.innerHeight(),width:i.innerWidth(),position:r?"fixed":"absolute"}).animate(c,e.duration,e.easing,function(){d.remove(),t()})}})(jQuery);(function(e){if(e&&window.XDomainRequest){e.ajaxTransport(function(i){if(i.crossDomain&&i.async){if(i.timeout){i.xdrTimeout=i.timeout;delete i.timeout}var o;return{send:function(e,r){function t(e,t,i,n){o.onload=o.onerror=o.ontimeout=function(){};o=undefined;r(e,t,i,n)}o=new XDomainRequest;o.open(i.type,i.url);o.onload=function(){t(200,"OK",{text:o.responseText},"Content-Type: "+o.contentType)};o.onerror=function(){t(404,"Not Found")};o.ontimeout=function(){t(0,"timeout")};if(i.xdrTimeout){o.timeout=i.xdrTimeout}else{o.timeout=5e3}o.onprogress=function(){};o.send(i.hasContent&&i.data||null)},abort:function(){if(o){o.onerror=e.noop;o.abort()}}}}})}})(jQuery);(function(n){function r(e){this.options=n.extend({},r.defaults,e)}r.instances=[];r.repositionAll=function(){for(var e=0;e<r.instances.length;e++){if(!r.instances[e])continue;var t=r.instances[e].options;new r(t).positionImg(n(r.instances[e].target),n.data(r.instances[e].target,"busy"),t.position)}};r.prototype.hide=function(e){e.each(function(){var e=n.data(this,"busy");if(e)e.remove();n(this).css("visibility","");n.data(this,"busy",null);for(var t=0;t<r.instances.length;t++)if(r.instances[t]!=null&&r.instances[t].target==this)r.instances[t]=null})};r.prototype.show=function(e){var i=this;e.each(function(){if(n.data(this,"busy"))return;var e=n(this);var t=i.buildImg();t.css("visibility","hidden");t.load(function(){i.positionImg(e,t,i.options.position);t.css("visibility","")});n("body").append(t);if(i.options.hide)e.css("visibility","hidden");n.data(this,"busy",t);r.instances.push({target:this,options:i.options})})};r.prototype.preload=function(){var e=this.buildImg();e.css("visibility","hidden");e.load(function(){n(this).remove()});n("body").append(e)};r.prototype.buildImg=function(){var e="<img src='"+this.options.img+"' alt='"+this.options.alt+"' title='"+this.options.title+"'";if(this.options.width)e+=" width='"+this.options.width+"'";if(this.options.height)e+=" height='"+this.options.height+"'";e+=" />";return n(e)};r.prototype.positionImg=function(e,t,i){var n=e.offset();var r=e.outerWidth();var o=e.outerHeight();var s=t.outerWidth();var a=t.outerHeight();if(i=="left"){var l=n.left-s-this.options.offset}else if(i=="right"){var l=n.left+r+this.options.offset}else{var l=n.left+(r-s)/2}var c=n.top+(o-a)/2;t.css("position","absolute");t.css("left",l+"px");t.css("top",c+"px")};r.defaults={img:"busy.gif",alt:"Please wait...",title:"Please wait...",hide:true,position:"center",zIndex:1001,width:null,height:null,offset:10};n.fn.busy=function(e,t){if(n.inArray(e,["clear","hide","remove"])!=-1){new r(e).hide(n(this))}else if(e=="defaults"){n.extend(r.defaults,t||{})}else if(e=="preload"){new r(e).preload()}else if(e=="reposition"){r.repositionAll()}else{new r(e).show(n(this));return n(this)}}})(jQuery);(function(n){function i(e){this.options=n.extend({},i.defaults,e)}i.prototype.hide=function(e){e.each(function(){var e=n.data(this,"loader");if(e)e.remove();n.data(this,"loader",null)})};i.prototype.show=function(e){var t=this;e.each(function(){if(n.data(this,"loader"))return;var e=e?e:"Loading...";var t=n("<div style='width:100%; text-align:center;' class='loader' ></div> ");t.html('<div style=\'margin:5px auto;\'><div class="loading" style="margin:0 auto;width:16px;height:16px" alt=\''+e+"'></div></div>");var i=n(this);t.appendTo(i);n.data(this,"loader",t)})};n.fn.loader=function(e,t){if(n.inArray(e,["clear","hide","remove"])!=-1){new i(e).hide(n(this));return n(this)}else{new i(e).show(n(this));return n(this)}}})(window.jQuery||giscloud.exposeJQuery());(function(n){"use strict";var r={},o={},s={},a={},l={},c=null;function u(e,t){if(e.height()&&e.width()){clearInterval(o[t]);clearTimeout(s[t]);delete o[t];delete s[t];delete a[t];r[t].resolveWith(e,[e[0]])}}function d(e){console.log("timeout",e);if(o[e]){clearInterval(o[e]);delete o[e];delete s[e];delete l[e];r[e].reject()}}function f(e,t){var i=new n.Deferred;a[t]=function(){u(e,t)};l[t]=function(){d(t)};o[t]=setInterval(a[t],100);s[t]=setTimeout(l[t],5e3);e.load(a[t]);r[t]=i;return r[t]}function h(){return n("<div/>",{id:"a"+Math.floor(Math.random()*1e3),css:{width:"1px",height:"1px",position:"absolute",top:"-5000px",left:"-5000px",overflow:"hidden"}}).appendTo("body")}function t(e){var t,i=e&&e.replace&&e.replace(/[\W]+/g,"_");if(!i){return null}if(r[i]){return r[i].promise()}if(!c){c=h()}t=n("<img/>",{src:e}).appendTo(c);return f(t,i).promise()}n.loadImage=t;n.fn.loadImage=function(e){if(!this.is("img")){return null}return t(this.attr("src")||e)}})(jQuery);(function(e){"use strict";if(typeof define==="function"&&define.amd){define(["jquery"],e)}else if(typeof exports==="object"){e(require("jquery"))}else{e(jQuery)}})(function(C,y){"use strict";if(C.jstree){return}var r=0,o=false,s=false,a=false,n=[],e=C("script:last").attr("src"),t=document,m=t.createElement("LI"),i,l;m.setAttribute("role","treeitem");i=t.createElement("I");i.className="jstree-icon jstree-ocl";m.appendChild(i);i=t.createElement("A");i.className="jstree-anchor";i.setAttribute("href","#");l=t.createElement("I");l.className="jstree-icon jstree-themeicon";i.appendChild(l);m.appendChild(i);i=l=null;C.jstree={version:"3.0.0",defaults:{plugins:[]},plugins:{},path:e&&e.indexOf("/")!==-1?e.replace(/\/[^\/]+$/,""):"",idregex:/[\\:&'".,=\- \/]/g};C.jstree.create=function(e,i){var n=new C.jstree.core(++r),t=i;i=C.extend(true,{},C.jstree.defaults,i);if(t&&t.plugins){i.plugins=t.plugins}C.each(i.plugins,function(e,t){if(e!=="core"){n=n.plugin(t,i[t])}});n.init(e,i);return n};C.jstree.core=function(e){this._id=e;this._cnt=0;this._data={core:{themes:{name:false,dots:false,icons:false},selected:[],last_error:{}}}};C.jstree.reference=function(t){var i=null,e=null;if(t&&t.id){t=t.id}if(!e||!e.length){try{e=C(t)}catch(e){}}if(!e||!e.length){try{e=C("#"+t.replace(C.jstree.idregex,"\\$&"))}catch(e){}}if(e&&e.length&&(e=e.closest(".jstree")).length&&(e=e.data("jstree"))){i=e}else{C(".jstree").each(function(){var e=C(this).data("jstree");if(e&&e._model.data[t]){i=e;return false}})}return i};C.fn.jstree=function(i){var n=typeof i==="string",r=Array.prototype.slice.call(arguments,1),o=null;this.each(function(){var e=C.jstree.reference(this),t=n&&e?e[i]:null;o=n&&t?t.apply(e,r):null;if(!e&&!n&&(i===y||C.isPlainObject(i))){C(this).data("jstree",new C.jstree.create(this,i))}if(e&&!n||i===true){o=e||false}if(o!==null&&o!==y){return false}});return o!==null&&o!==y?o:this};C.expr[":"].jstree=C.expr.createPseudo(function(e){return function(e){return C(e).hasClass("jstree")&&C(e).data("jstree")!==y}});C.jstree.defaults.core={data:false,strings:false,check_callback:false,error:C.noop,animation:200,multiple:true,themes:{name:false,url:false,dir:false,dots:true,icons:true,stripes:false,variant:false,responsive:true},expand_selected_onload:true};C.jstree.core.prototype={plugin:function(e,t){var i=C.jstree.plugins[e];if(i){this._data[e]={};i.prototype=this;return new i(t,this)}return this},init:function(e,t){this._model={data:{"#":{id:"#",parent:null,parents:[],children:[],children_d:[],state:{loaded:false}}},changed:[],force_full_redraw:false,redraw_timeout:false,default_state:{loaded:true,opened:false,selected:false,disabled:false}};this.element=C(e).addClass("jstree jstree-"+this._id);this.settings=t;this.element.bind("destroyed",C.proxy(this.teardown,this));this._data.core.ready=false;this._data.core.loaded=false;this._data.core.rtl=this.element.css("direction")==="rtl";this.element[this._data.core.rtl?"addClass":"removeClass"]("jstree-rtl");this.element.attr("role","tree");this.bind();this.trigger("init");this._data.core.original_container_html=this.element.find(" > ul > li").clone(true);this._data.core.original_container_html.find("li").addBack().contents().filter(function(){return this.nodeType===3&&(!this.nodeValue||/^\s+$/.test(this.nodeValue))}).remove();this.element.html("<"+"ul class='jstree-container-ul jstree-children'><"+"li class='jstree-initial-node jstree-loading jstree-leaf jstree-last'><i class='jstree-icon jstree-ocl'></i><"+"a class='jstree-anchor' href='#'><i class='jstree-icon jstree-themeicon-hidden'></i>"+this.get_string("Loading ...")+"</a></li></ul>");this._data.core.li_height=this.get_container_ul().children("li:eq(0)").height()||18;this.trigger("loading");this.load_node("#")},destroy:function(){this.element.unbind("destroyed",this.teardown);this.teardown()},teardown:function(){this.unbind();this.element.removeClass("jstree").removeData("jstree").find("[class^='jstree']").addBack().attr("class",function(){return this.className.replace(/jstree[^ ]*|$/gi,"")});this.element=null},bind:function(){this.element.on("dblclick.jstree",function(){if(document.selection&&document.selection.empty){document.selection.empty()}else{if(window.getSelection){var e=window.getSelection();try{e.removeAllRanges();e.collapse()}catch(e){}}}}).on("click.jstree",".jstree-ocl",C.proxy(function(e){this.toggle_node(e.target)},this)).on("click.jstree",".jstree-anchor",C.proxy(function(e){e.preventDefault();C(e.currentTarget).focus();this.activate_node(e.currentTarget,e)},this)).on("keydown.jstree",".jstree-anchor",C.proxy(function(e){if(e.target.tagName==="INPUT"){return true}var t=null;switch(e.which){case 13:case 32:e.type="click";C(e.currentTarget).trigger(e);break;case 37:e.preventDefault();if(this.is_open(e.currentTarget)){this.close_node(e.currentTarget)}else{t=this.get_prev_dom(e.currentTarget);if(t&&t.length){t.children(".jstree-anchor").focus()}}break;case 38:e.preventDefault();t=this.get_prev_dom(e.currentTarget);if(t&&t.length){t.children(".jstree-anchor").focus()}break;case 39:e.preventDefault();if(this.is_closed(e.currentTarget)){this.open_node(e.currentTarget,function(e){this.get_node(e,true).children(".jstree-anchor").focus()})}else{t=this.get_next_dom(e.currentTarget);if(t&&t.length){t.children(".jstree-anchor").focus()}}break;case 40:e.preventDefault();t=this.get_next_dom(e.currentTarget);if(t&&t.length){t.children(".jstree-anchor").focus()}break;case 46:e.preventDefault();t=this.get_node(e.currentTarget);if(t&&t.id&&t.id!=="#"){t=this.is_selected(t)?this.get_selected():t}break;case 113:e.preventDefault();t=this.get_node(e.currentTarget);break;default:break}},this)).on("load_node.jstree",C.proxy(function(e,t){if(t.status){if(t.node.id==="#"&&!this._data.core.loaded){this._data.core.loaded=true;this.trigger("loaded")}if(!this._data.core.ready&&!this.get_container_ul().find(".jstree-loading:eq(0)").length){this._data.core.ready=true;if(this._data.core.selected.length){if(this.settings.core.expand_selected_onload){var i=[],n,r;for(n=0,r=this._data.core.selected.length;n<r;n++){i=i.concat(this._model.data[this._data.core.selected[n]].parents)}i=C.vakata.array_unique(i);for(n=0,r=i.length;n<r;n++){this.open_node(i[n],false,0)}}this.trigger("changed",{action:"ready",selected:this._data.core.selected})}setTimeout(C.proxy(function(){this.trigger("ready")},this),0)}}},this)).on("init.jstree",C.proxy(function(){var e=this.settings.core.themes;this._data.core.themes.dots=e.dots;this._data.core.themes.stripes=e.stripes;this._data.core.themes.icons=e.icons;this.set_theme(e.name||"default",e.url);this.set_theme_variant(e.variant)},this)).on("loading.jstree",C.proxy(function(){this[this._data.core.themes.dots?"show_dots":"hide_dots"]();this[this._data.core.themes.icons?"show_icons":"hide_icons"]();this[this._data.core.themes.stripes?"show_stripes":"hide_stripes"]()},this)).on("focus.jstree",".jstree-anchor",C.proxy(function(e){this.element.find(".jstree-hovered").not(e.currentTarget).mouseleave();C(e.currentTarget).mouseenter()},this)).on("mouseenter.jstree",".jstree-anchor",C.proxy(function(e){this.hover_node(e.currentTarget)},this)).on("mouseleave.jstree",".jstree-anchor",C.proxy(function(e){this.dehover_node(e.currentTarget)},this))},unbind:function(){this.element.off(".jstree");C(document).off(".jstree-"+this._id)},trigger:function(e,t){if(!t){t={}}t.instance=this;this.element&&this.element.triggerHandler(e.replace(".jstree","")+".jstree",t)},get_container:function(){return this.element},get_container_ul:function(){return this.element.children(".jstree-children:eq(0)")},get_string:function(e){var t=this.settings.core.strings;if(C.isFunction(t)){return t.call(this,e)}if(t&&t[e]){return t[e]}return e},_firstChild:function(e){e=e?e.firstChild:null;while(e!==null&&e.nodeType!==1){e=e.nextSibling}return e},_nextSibling:function(e){e=e?e.nextSibling:null;while(e!==null&&e.nodeType!==1){e=e.nextSibling}return e},_previousSibling:function(e){e=e?e.previousSibling:null;while(e!==null&&e.nodeType!==1){e=e.previousSibling}return e},get_node:function(e,t){if(e&&e.id){e=e.id}var i;try{if(this._model.data[e]){e=this._model.data[e]}else if(((i=C(e,this.element)).length||(i=C("#"+e.replace(C.jstree.idregex,"\\$&"),this.element)).length)&&this._model.data[i.closest(".jstree-node").attr("id")]){e=this._model.data[i.closest(".jstree-node").attr("id")]}else if((i=C(e,this.element)).length&&i.hasClass("jstree")){e=this._model.data["#"]}else{return false}if(t){e=e.id==="#"?this.element:C("#"+e.id.replace(C.jstree.idregex,"\\$&"),this.element)}return e}catch(e){return false}},get_path:function(e,t,i){e=e.parents?e:this.get_node(e);if(!e||e.id==="#"||!e.parents){return false}var n,r,o=[];o.push(i?e.id:e.text);for(n=0,r=e.parents.length;n<r;n++){o.push(i?e.parents[n]:this.get_text(e.parents[n]))}o=o.reverse().slice(1);return t?o.join(t):o},get_next_dom:function(e,t){var i;e=this.get_node(e,true);if(e[0]===this.element[0]){i=this._firstChild(this.get_container_ul()[0]);return i?C(i):false}if(!e||!e.length){return false}if(t){i=this._nextSibling(e[0]);return i?C(i):false}if(e.hasClass("jstree-open")){i=this._firstChild(e.children(".jstree-children")[0]);return i?C(i):false}if((i=this._nextSibling(e[0]))!==null){return C(i)}return e.parentsUntil(".jstree",".jstree-node").next(".jstree-node").eq(0)},get_prev_dom:function(e,t){var i;e=this.get_node(e,true);if(e[0]===this.element[0]){i=this.get_container_ul()[0].lastChild;return i?C(i):false}if(!e||!e.length){return false}if(t){i=this._previousSibling(e[0]);return i?C(i):false}if((i=this._previousSibling(e[0]))!==null){e=C(i);while(e.hasClass("jstree-open")){e=e.children(".jstree-children:eq(0)").children(".jstree-node:last")}return e}i=e[0].parentNode.parentNode;return i&&i.className&&i.className.indexOf("jstree-node")!==-1?C(i):false},get_parent:function(e){e=this.get_node(e);if(!e||e.id==="#"){return false}return e.parent},get_children_dom:function(e){e=this.get_node(e,true);if(e[0]===this.element[0]){return this.get_container_ul().children(".jstree-node")}if(!e||!e.length){return false}return e.children(".jstree-children").children(".jstree-node")},is_parent:function(e){e=this.get_node(e);return e&&(e.state.loaded===false||e.children.length>0)},is_loaded:function(e){e=this.get_node(e);return e&&e.state.loaded},is_loading:function(e){e=this.get_node(e);return e&&e.state&&e.state.loading},is_open:function(e){e=this.get_node(e);return e&&e.state.opened},is_closed:function(e){e=this.get_node(e);return e&&this.is_parent(e)&&!e.state.opened},is_leaf:function(e){return!this.is_parent(e)},load_node:function(i,n){var e,t,r,o,s,a,l;if(C.isArray(i)){i=i.slice();for(e=0,t=i.length;e<t;e++){this.load_node(i[e],n)}return true}i=this.get_node(i);if(!i){if(n){n.call(this,i,false)}return false}if(i.state.loaded){i.state.loaded=false;for(r=0,o=i.children_d.length;r<o;r++){for(s=0,a=i.parents.length;s<a;s++){this._model.data[i.parents[s]].children_d=C.vakata.array_remove_item(this._model.data[i.parents[s]].children_d,i.children_d[r])}if(this._model.data[i.children_d[r]].state.selected){l=true;this._data.core.selected=C.vakata.array_remove_item(this._data.core.selected,i.children_d[r])}delete this._model.data[i.children_d[r]]}i.children=[];i.children_d=[];if(l){this.trigger("changed",{action:"load_node",node:i,selected:this._data.core.selected})}}i.state.loading=true;this.get_node(i,true).addClass("jstree-loading");this._load_node(i,C.proxy(function(e){i.state.loading=false;i.state.loaded=e;var t=this.get_node(i,true);if(i.state.loaded&&!i.children.length&&t&&t.length&&!t.hasClass("jstree-leaf")){t.removeClass("jstree-closed jstree-open").addClass("jstree-leaf")}t.removeClass("jstree-loading");this.trigger("load_node",{node:i,status:e});if(n){n.call(this,i,e)}},this));return true},_load_nodes:function(e,t,i){var n=true,r=function(){this._load_nodes(e,t,true)},o=this._model.data,s,a;for(s=0,a=e.length;s<a;s++){if(o[e[s]]&&(!o[e[s]].state.loaded||!i)){if(!this.is_loading(e[s])){this.load_node(e[s],r)}n=false}}if(n){if(!t.done){t.call(this,e);t.done=true}}},_load_node:function(r,o){var e=this.settings.core.data,t;if(!e){return o.call(this,r.id==="#"?this._append_html_data(r,this._data.core.original_container_html.clone(true)):false)}if(C.isFunction(e)){return e.call(this,r,C.proxy(function(e){return e===false?o.call(this,false):o.call(this,this[typeof e==="string"?"_append_html_data":"_append_json_data"](r,typeof e==="string"?C(e):e))},this))}if(typeof e==="object"){if(e.url){e=C.extend(true,{},e);if(C.isFunction(e.url)){e.url=e.url.call(this,r)}if(C.isFunction(e.data)){e.data=e.data.call(this,r)}return C.ajax(e).done(C.proxy(function(e,t,i){var n=i.getResponseHeader("Content-Type");if(n.indexOf("json")!==-1||typeof e==="object"){return o.call(this,this._append_json_data(r,e))}if(n.indexOf("html")!==-1||typeof e==="string"){return o.call(this,this._append_html_data(r,C(e)))}this._data.core.last_error={error:"ajax",plugin:"core",id:"core_04",reason:"Could not load node",data:JSON.stringify({id:r.id,xhr:i})};return o.call(this,false)},this)).fail(C.proxy(function(e){o.call(this,false);this._data.core.last_error={error:"ajax",plugin:"core",id:"core_04",reason:"Could not load node",data:JSON.stringify({id:r.id,xhr:e})};this.settings.core.error.call(this,this._data.core.last_error)},this))}t=C.isArray(e)||C.isPlainObject(e)?JSON.parse(JSON.stringify(e)):e;if(r.id!=="#"){this._data.core.last_error={error:"nodata",plugin:"core",id:"core_05",reason:"Could not load node",data:JSON.stringify({id:r.id})}}return o.call(this,r.id==="#"?this._append_json_data(r,t):false)}if(typeof e==="string"){if(r.id!=="#"){this._data.core.last_error={error:"nodata",plugin:"core",id:"core_06",reason:"Could not load node",data:JSON.stringify({id:r.id})}}return o.call(this,r.id==="#"?this._append_html_data(r,C(e)):false)}return o.call(this,false)},_node_changed:function(e){e=this.get_node(e);if(e){this._model.changed.push(e.id)}},_append_html_data:function(e,t){e=this.get_node(e);e.children=[];e.children_d=[];var i=t.is("ul")?t.children():t,n=e.id,r=[],o=[],s=this._model.data,a=s[n],l=this._data.core.selected.length,c,u,d;i.each(C.proxy(function(e,t){c=this._parse_model_from_html(C(t),n,a.parents.concat());if(c){r.push(c);o.push(c);if(s[c].children_d.length){o=o.concat(s[c].children_d)}}},this));a.children=r;a.children_d=o;for(u=0,d=a.parents.length;u<d;u++){s[a.parents[u]].children_d=s[a.parents[u]].children_d.concat(o)}this.trigger("model",{nodes:o,parent:n});if(n!=="#"){this._node_changed(n);this.redraw()}else{this.get_container_ul().children(".jstree-initial-node").remove();this.redraw(true)}if(this._data.core.selected.length!==l){this.trigger("changed",{action:"model",selected:this._data.core.selected})}return true},_append_json_data:function(e,t){e=this.get_node(e);e.children=[];e.children_d=[];var i=t,n=e.id,r=[],o=[],s=this._model.data,a=s[n],l=this._data.core.selected.length,c,u,d;if(i.d){i=i.d;if(typeof i==="string"){i=JSON.parse(i)}}if(!C.isArray(i)){i=[i]}if(i.length&&i[0].id!==y&&i[0].parent!==y){for(u=0,d=i.length;u<d;u++){if(!i[u].children){i[u].children=[]}s[i[u].id.toString()]=i[u]}for(u=0,d=i.length;u<d;u++){s[i[u].parent.toString()].children.push(i[u].id.toString());a.children_d.push(i[u].id.toString())}for(u=0,d=a.children.length;u<d;u++){c=this._parse_model_from_flat_json(s[a.children[u]],n,a.parents.concat());o.push(c);if(s[c].children_d.length){o=o.concat(s[c].children_d)}}}else{for(u=0,d=i.length;u<d;u++){c=this._parse_model_from_json(i[u],n,a.parents.concat());if(c){r.push(c);o.push(c);if(s[c].children_d.length){o=o.concat(s[c].children_d)}}}a.children=r;a.children_d=o;for(u=0,d=a.parents.length;u<d;u++){s[a.parents[u]].children_d=s[a.parents[u]].children_d.concat(o)}}this.trigger("model",{nodes:o,parent:n});if(n!=="#"){this._node_changed(n);this.redraw()}else{this.redraw(true)}if(this._data.core.selected.length!==l){this.trigger("changed",{action:"model",selected:this._data.core.selected})}return true},_parse_model_from_html:function(e,t,i){if(!i){i=[]}else{i=[].concat(i)}if(t){i.unshift(t)}var n,r,o=this._model.data,s={id:false,text:false,icon:true,parent:t,parents:i,children:[],children_d:[],data:null,state:{},li_attr:{id:false},a_attr:{href:"#"},original:false},a,l,c;for(a in this._model.default_state){if(this._model.default_state.hasOwnProperty(a)){s.state[a]=this._model.default_state[a]}}l=C.vakata.attributes(e,true);C.each(l,function(e,t){t=C.trim(t);if(!t.length){return true}s.li_attr[e]=t;if(e==="id"){s.id=t.toString()}});l=e.children("a").eq(0);if(l.length){l=C.vakata.attributes(l,true);C.each(l,function(e,t){t=C.trim(t);if(t.length){s.a_attr[e]=t}})}l=e.children("a:eq(0)").length?e.children("a:eq(0)").clone():e.clone();l.children("ins, i, ul").remove();l=l.html();l=C("<div />").html(l);s.text=l.html();l=e.data();s.data=l?C.extend(true,{},l):null;s.state.opened=e.hasClass("jstree-open");s.state.selected=e.children("a").hasClass("jstree-clicked");s.state.disabled=e.children("a").hasClass("jstree-disabled");if(s.data&&s.data.jstree){for(a in s.data.jstree){if(s.data.jstree.hasOwnProperty(a)){s.state[a]=s.data.jstree[a]}}}l=e.children("a").children(".jstree-themeicon");if(l.length){s.icon=l.hasClass("jstree-themeicon-hidden")?false:l.attr("rel")}if(s.state.icon){s.icon=s.state.icon}l=e.children("ul").children("li");do{c="j"+this._id+"_"+ ++this._cnt}while(o[c]);s.id=s.li_attr.id?s.li_attr.id.toString():c;if(l.length){l.each(C.proxy(function(e,t){n=this._parse_model_from_html(C(t),s.id,i);r=this._model.data[n];s.children.push(n);if(r.children_d.length){s.children_d=s.children_d.concat(r.children_d)}},this));s.children_d=s.children_d.concat(s.children)}else{if(e.hasClass("jstree-closed")){s.state.loaded=false}}if(s.li_attr["class"]){s.li_attr["class"]=s.li_attr["class"].replace("jstree-closed","").replace("jstree-open","")}if(s.a_attr["class"]){s.a_attr["class"]=s.a_attr["class"].replace("jstree-clicked","").replace("jstree-disabled","")}o[s.id]=s;if(s.state.selected){this._data.core.selected.push(s.id)}return s.id},_parse_model_from_flat_json:function(e,t,i){if(!i){i=[]}else{i=i.concat()}if(t){i.unshift(t)}var n=e.id.toString(),r=this._model.data,o=this._model.default_state,s,a,l,c,u={id:n,text:e.text||"",icon:e.icon!==y?e.icon:true,parent:t,parents:i,children:e.children||[],children_d:e.children_d||[],data:e.data,state:{},li_attr:{id:false},a_attr:{href:"#"},original:false};for(s in o){if(o.hasOwnProperty(s)){u.state[s]=o[s]}}if(e&&e.data&&e.data.jstree&&e.data.jstree.icon){u.icon=e.data.jstree.icon}if(e&&e.data){u.data=e.data;if(e.data.jstree){for(s in e.data.jstree){if(e.data.jstree.hasOwnProperty(s)){u.state[s]=e.data.jstree[s]}}}}if(e&&typeof e.state==="object"){for(s in e.state){if(e.state.hasOwnProperty(s)){u.state[s]=e.state[s]}}}if(e&&typeof e.li_attr==="object"){for(s in e.li_attr){if(e.li_attr.hasOwnProperty(s)){u.li_attr[s]=e.li_attr[s]}}}if(!u.li_attr.id){u.li_attr.id=n}if(e&&typeof e.a_attr==="object"){for(s in e.a_attr){if(e.a_attr.hasOwnProperty(s)){u.a_attr[s]=e.a_attr[s]}}}if(e&&e.children&&e.children===true){u.state.loaded=false;u.children=[];u.children_d=[]}r[u.id]=u;for(s=0,a=u.children.length;s<a;s++){l=this._parse_model_from_flat_json(r[u.children[s]],u.id,i);c=r[l];u.children_d.push(l);if(c.children_d.length){u.children_d=u.children_d.concat(c.children_d)}}delete e.data;delete e.children;r[u.id].original=e;if(u.state.selected){this._data.core.selected.push(u.id)}return u.id},_parse_model_from_json:function(e,t,i){if(!i){i=[]}else{i=i.concat()}if(t){i.unshift(t)}var n=false,r,o,s,a,l=this._model.data,c=this._model.default_state,u;do{n="j"+this._id+"_"+ ++this._cnt}while(l[n]);u={id:false,text:typeof e==="string"?e:"",icon:typeof e==="object"&&e.icon!==y?e.icon:true,parent:t,parents:i,children:[],children_d:[],data:null,state:{},li_attr:{id:false},a_attr:{href:"#"},original:false};for(r in c){if(c.hasOwnProperty(r)){u.state[r]=c[r]}}if(e&&e.id){u.id=e.id.toString()}if(e&&e.text){u.text=e.text}if(e&&e.data&&e.data.jstree&&e.data.jstree.icon){u.icon=e.data.jstree.icon}if(e&&e.data){u.data=e.data;if(e.data.jstree){for(r in e.data.jstree){if(e.data.jstree.hasOwnProperty(r)){u.state[r]=e.data.jstree[r]}}}}if(e&&typeof e.state==="object"){for(r in e.state){if(e.state.hasOwnProperty(r)){u.state[r]=e.state[r]}}}if(e&&typeof e.li_attr==="object"){for(r in e.li_attr){if(e.li_attr.hasOwnProperty(r)){u.li_attr[r]=e.li_attr[r]}}}if(u.li_attr.id&&!u.id){u.id=u.li_attr.id.toString()}if(!u.id){u.id=n}if(!u.li_attr.id){u.li_attr.id=u.id}if(e&&typeof e.a_attr==="object"){for(r in e.a_attr){if(e.a_attr.hasOwnProperty(r)){u.a_attr[r]=e.a_attr[r]}}}if(e&&e.children&&e.children.length){for(r=0,o=e.children.length;r<o;r++){s=this._parse_model_from_json(e.children[r],u.id,i);a=l[s];u.children.push(s);if(a.children_d.length){u.children_d=u.children_d.concat(a.children_d)}}u.children_d=u.children_d.concat(u.children)}if(e&&e.children&&e.children===true){u.state.loaded=false;u.children=[];u.children_d=[]}delete e.data;delete e.children;u.original=e;l[u.id]=u;if(u.state.selected){this._data.core.selected.push(u.id)}return u.id},_redraw:function(){var e=this._model.force_full_redraw?this._model.data["#"].children.concat([]):this._model.changed.concat([]),t=document.createElement("UL"),i,n,r;for(n=0,r=e.length;n<r;n++){i=this.redraw_node(e[n],true,this._model.force_full_redraw);if(i&&this._model.force_full_redraw){t.appendChild(i)}}if(this._model.force_full_redraw){t.className=this.get_container_ul()[0].className;this.element.empty().append(t)}this._model.force_full_redraw=false;this._model.changed=[];this.trigger("redraw",{nodes:e})},redraw:function(e){if(e){this._model.force_full_redraw=true}this._redraw()},redraw_node:function(e,t,i){var n=this.get_node(e),r=false,o=false,s=false,a=false,l=false,c=false,u="",d=document,f=this._model.data,h=false,p=false,g=null;if(!n){return false}if(n.id==="#"){return this.redraw(true)}t=t||n.children.length===0;e=!document.querySelector?document.getElementById(n.id):this.element[0].querySelector("#"+("0123456789".indexOf(n.id[0])!==-1?"\\3"+n.id[0]+" "+n.id.substr(1).replace(C.jstree.idregex,"\\$&"):n.id.replace(C.jstree.idregex,"\\$&")));if(!e){t=true;if(!i){r=n.parent!=="#"?C("#"+n.parent.replace(C.jstree.idregex,"\\$&"),this.element)[0]:null;if(r!==null&&(!r||!f[n.parent].state.opened)){return false}o=C.inArray(n.id,r===null?f["#"].children:f[n.parent].children)}}else{e=C(e);if(!i){r=e.parent().parent()[0];if(r===this.element[0]){r=null}o=e.index()}if(!t&&n.children.length&&!e.children(".jstree-children").length){t=true}if(!t){s=e.children(".jstree-children")[0]}p=e.attr("aria-selected");h=e.children(".jstree-anchor")[0]===document.activeElement;e.remove()}e=m.cloneNode(true);u="jstree-node ";for(a in n.li_attr){if(n.li_attr.hasOwnProperty(a)){if(a==="id"){continue}if(a!=="class"){e.setAttribute(a,n.li_attr[a])}else{u+=n.li_attr[a]}}}if(p&&p!=="false"){e.setAttribute("aria-selected",true)}if(n.state.loaded&&!n.children.length){u+=" jstree-leaf"}else{u+=n.state.opened&&n.state.loaded?" jstree-open":" jstree-closed";e.setAttribute("aria-expanded",n.state.opened&&n.state.loaded)}if(n.parent!==null&&f[n.parent].children[f[n.parent].children.length-1]===n.id){u+=" jstree-last"}e.id=n.id;e.className=u;u=(n.state.selected?" jstree-clicked":"")+(n.state.disabled?" jstree-disabled":"");for(l in n.a_attr){if(n.a_attr.hasOwnProperty(l)){if(l==="href"&&n.a_attr[l]==="#"){continue}if(l!=="class"){e.childNodes[1].setAttribute(l,n.a_attr[l])}else{u+=" "+n.a_attr[l]}}}if(u.length){e.childNodes[1].className="jstree-anchor "+u}if(n.icon&&n.icon!==true||n.icon===false){if(n.icon===false){e.childNodes[1].childNodes[0].className+=" jstree-themeicon-hidden"}else if(n.icon.indexOf("/")===-1&&n.icon.indexOf(".")===-1){e.childNodes[1].childNodes[0].className+=" "+n.icon+" jstree-themeicon-custom"}else{e.childNodes[1].childNodes[0].style.backgroundImage="url("+n.icon+")";e.childNodes[1].childNodes[0].style.backgroundPosition="center center";e.childNodes[1].childNodes[0].style.backgroundSize="auto";e.childNodes[1].childNodes[0].className+=" jstree-themeicon-custom"}}e.childNodes[1].innerHTML+=n.text;if(t&&n.children.length&&n.state.opened&&n.state.loaded){c=d.createElement("UL");c.setAttribute("role","group");c.className="jstree-children";for(a=0,l=n.children.length;a<l;a++){c.appendChild(this.redraw_node(n.children[a],t,true))}e.appendChild(c)}if(s){e.appendChild(s)}if(!i){if(!r){r=this.element[0]}for(a=0,l=r.childNodes.length;a<l;a++){if(r.childNodes[a]&&r.childNodes[a].className&&r.childNodes[a].className.indexOf("jstree-children")!==-1){g=r.childNodes[a];break}}if(!g){g=d.createElement("UL");g.setAttribute("role","group");g.className="jstree-children";r.appendChild(g)}r=g;if(o<r.childNodes.length){r.insertBefore(e,r.childNodes[o])}else{r.appendChild(e)}if(h){e.childNodes[1].focus()}}if(n.state.opened&&!n.state.loaded){n.state.opened=false;setTimeout(C.proxy(function(){this.open_node(n.id,false,0)},this),0)}return e},open_node:function(e,i,n){var t,r,o,s;if(C.isArray(e)){e=e.slice();for(t=0,r=e.length;t<r;t++){this.open_node(e[t],i,n)}return true}e=this.get_node(e);if(!e||e.id==="#"){return false}n=n===y?this.settings.core.animation:n;if(!this.is_closed(e)){if(i){i.call(this,e,false)}return false}if(!this.is_loaded(e)){if(this.is_loading(e)){return setTimeout(C.proxy(function(){this.open_node(e,i,n)},this),500)}this.load_node(e,function(e,t){return t?this.open_node(e,i,n):i?i.call(this,e,false):false})}else{o=this.get_node(e,true);s=this;if(o.length){if(e.children.length&&!this._firstChild(o.children(".jstree-children")[0])){e.state.opened=true;this.redraw_node(e,true);o=this.get_node(e,true)}if(!n){this.trigger("before_open",{node:e});o[0].className=o[0].className.replace("jstree-closed","jstree-open");o[0].setAttribute("aria-expanded",true)}else{this.trigger("before_open",{node:e});o.children(".jstree-children").css("display","none").end().removeClass("jstree-closed").addClass("jstree-open").attr("aria-expanded",true).children(".jstree-children").stop(true,true).slideDown(n,function(){this.style.display="";s.trigger("after_open",{node:e})})}}e.state.opened=true;if(i){i.call(this,e,true)}if(!o.length){this.trigger("before_open",{node:e})}this.trigger("open_node",{node:e});if(!n||!o.length){this.trigger("after_open",{node:e})}}},_open_to:function(e){e=this.get_node(e);if(!e||e.id==="#"){return false}var t,i,n=e.parents;for(t=0,i=n.length;t<i;t+=1){if(t!=="#"){this.open_node(n[t],false,0)}}return C("#"+e.id.replace(C.jstree.idregex,"\\$&"),this.element)},close_node:function(e,t){var i,n,r,o;if(C.isArray(e)){e=e.slice();for(i=0,n=e.length;i<n;i++){this.close_node(e[i],t)}return true}e=this.get_node(e);if(!e||e.id==="#"){return false}if(this.is_closed(e)){return false}t=t===y?this.settings.core.animation:t;r=this;o=this.get_node(e,true);if(o.length){if(!t){o[0].className=o[0].className.replace("jstree-open","jstree-closed");o.attr("aria-expanded",false).children(".jstree-children").remove()}else{o.children(".jstree-children").attr("style","display:block !important").end().removeClass("jstree-open").addClass("jstree-closed").attr("aria-expanded",false).children(".jstree-children").stop(true,true).slideUp(t,function(){this.style.display="";o.children(".jstree-children").remove();r.trigger("after_close",{node:e})})}}e.state.opened=false;this.trigger("close_node",{node:e});if(!t||!o.length){this.trigger("after_close",{node:e})}},toggle_node:function(e){var t,i;if(C.isArray(e)){e=e.slice();for(t=0,i=e.length;t<i;t++){this.toggle_node(e[t])}return true}if(this.is_closed(e)){return this.open_node(e)}if(this.is_open(e)){return this.close_node(e)}},open_all:function(e,i,n){if(!e){e="#"}e=this.get_node(e);if(!e){return false}var t=e.id==="#"?this.get_container_ul():this.get_node(e,true),r,o,s;if(!t.length){for(r=0,o=e.children_d.length;r<o;r++){if(this.is_closed(this._model.data[e.children_d[r]])){this._model.data[e.children_d[r]].state.opened=true}}return this.trigger("open_all",{node:e})}n=n||t;s=this;t=this.is_closed(e)?t.find(".jstree-closed").addBack():t.find(".jstree-closed");t.each(function(){s.open_node(this,function(e,t){if(t&&this.is_parent(e)){this.open_all(e,i,n)}},i||0)});if(n.find(".jstree-closed").length===0){this.trigger("open_all",{node:this.get_node(n)})}},close_all:function(e,t){if(!e){e="#"}e=this.get_node(e);if(!e){return false}var i=e.id==="#"?this.get_container_ul():this.get_node(e,true),n=this,r,o;if(!i.length){for(r=0,o=e.children_d.length;r<o;r++){this._model.data[e.children_d[r]].state.opened=false}return this.trigger("close_all",{node:e})}i=this.is_open(e)?i.find(".jstree-open").addBack():i.find(".jstree-open");C(i.get().reverse()).each(function(){n.close_node(this,t||0)});this.trigger("close_all",{node:e})},is_disabled:function(e){e=this.get_node(e);return e&&e.state&&e.state.disabled},enable_node:function(e){var t,i;if(C.isArray(e)){e=e.slice();for(t=0,i=e.length;t<i;t++){this.enable_node(e[t])}return true}e=this.get_node(e);if(!e||e.id==="#"){return false}e.state.disabled=false;this.get_node(e,true).children(".jstree-anchor").removeClass("jstree-disabled");this.trigger("enable_node",{node:e})},disable_node:function(e){var t,i;if(C.isArray(e)){e=e.slice();for(t=0,i=e.length;t<i;t++){this.disable_node(e[t])}return true}e=this.get_node(e);if(!e||e.id==="#"){return false}e.state.disabled=true;this.get_node(e,true).children(".jstree-anchor").addClass("jstree-disabled");this.trigger("disable_node",{node:e})},activate_node:function(e,t){if(this.is_disabled(e)){return false}this._data.core.last_clicked=this._data.core.last_clicked&&this._data.core.last_clicked.id!==y?this.get_node(this._data.core.last_clicked.id):null;if(this._data.core.last_clicked&&!this._data.core.last_clicked.state.selected){this._data.core.last_clicked=null}if(!this._data.core.last_clicked&&this._data.core.selected.length){this._data.core.last_clicked=this.get_node(this._data.core.selected[this._data.core.selected.length-1])}if(!this.settings.core.multiple||!t.metaKey&&!t.ctrlKey&&!t.shiftKey||t.shiftKey&&(!this._data.core.last_clicked||!this.get_parent(e)||this.get_parent(e)!==this._data.core.last_clicked.parent)){if(!this.settings.core.multiple&&(t.metaKey||t.ctrlKey||t.shiftKey)&&this.is_selected(e)){this.deselect_node(e,false,false,t)}else{this.deselect_all(true);this.select_node(e,false,false,t);this._data.core.last_clicked=this.get_node(e)}}else{if(t.shiftKey){var i=this.get_node(e).id,n=this._data.core.last_clicked.id,r=this.get_node(this._data.core.last_clicked.parent).children,o=false,s,a;for(s=0,a=r.length;s<a;s+=1){if(r[s]===i){o=!o}if(r[s]===n){o=!o}if(o||r[s]===i||r[s]===n){this.select_node(r[s],false,false,t)}else{this.deselect_node(r[s],false,false,t)}}}else{if(!this.is_selected(e)){this.select_node(e,false,false,t)}else{this.deselect_node(e,false,false,t)}}}this.trigger("activate_node",{node:this.get_node(e)})},hover_node:function(e){e=this.get_node(e,true);if(!e||!e.length||e.children(".jstree-hovered").length){return false}var t=this.element.find(".jstree-hovered"),i=this.element;if(t&&t.length){this.dehover_node(t)}e.children(".jstree-anchor").addClass("jstree-hovered");this.trigger("hover_node",{node:this.get_node(e)});setTimeout(function(){i.attr("aria-activedescendant",e[0].id);e.attr("aria-selected",true)},0)},dehover_node:function(e){e=this.get_node(e,true);if(!e||!e.length||!e.children(".jstree-hovered").length){return false}e.attr("aria-selected",false).children(".jstree-anchor").removeClass("jstree-hovered");this.trigger("dehover_node",{node:this.get_node(e)})},select_node:function(e,t,i,n){var r,o,s,a;if(C.isArray(e)){e=e.slice();for(o=0,s=e.length;o<s;o++){this.select_node(e[o],t,i,n)}return true}e=this.get_node(e);if(!e||e.id==="#"){return false}r=this.get_node(e,true);if(!e.state.selected){e.state.selected=true;this._data.core.selected.push(e.id);if(!i){r=this._open_to(e)}if(r&&r.length){r.children(".jstree-anchor").addClass("jstree-clicked")}this.trigger("select_node",{node:e,selected:this._data.core.selected,event:n});if(!t){this.trigger("changed",{action:"select_node",node:e,selected:this._data.core.selected,event:n})}}},deselect_node:function(e,t,i){var n,r,o;if(C.isArray(e)){e=e.slice();for(n=0,r=e.length;n<r;n++){this.deselect_node(e[n],t,i)}return true}e=this.get_node(e);if(!e||e.id==="#"){return false}o=this.get_node(e,true);if(e.state.selected){e.state.selected=false;this._data.core.selected=C.vakata.array_remove_item(this._data.core.selected,e.id);if(o.length){o.children(".jstree-anchor").removeClass("jstree-clicked")}this.trigger("deselect_node",{node:e,selected:this._data.core.selected,event:i});if(!t){this.trigger("changed",{action:"deselect_node",node:e,selected:this._data.core.selected,event:i})}}},select_all:function(e){var t=this._data.core.selected.concat([]),i,n;this._data.core.selected=this._model.data["#"].children_d.concat();for(i=0,n=this._data.core.selected.length;i<n;i++){if(this._model.data[this._data.core.selected[i]]){this._model.data[this._data.core.selected[i]].state.selected=true}}this.redraw(true);this.trigger("select_all",{selected:this._data.core.selected});if(!e){this.trigger("changed",{action:"select_all",selected:this._data.core.selected,old_selection:t})}},deselect_all:function(e){var t=this._data.core.selected.concat([]),i,n;for(i=0,n=this._data.core.selected.length;i<n;i++){if(this._model.data[this._data.core.selected[i]]){this._model.data[this._data.core.selected[i]].state.selected=false}}this._data.core.selected=[];this.element.find(".jstree-clicked").removeClass("jstree-clicked");this.trigger("deselect_all",{selected:this._data.core.selected,node:t});if(!e){this.trigger("changed",{action:"deselect_all",selected:this._data.core.selected,old_selection:t})}},is_selected:function(e){e=this.get_node(e);if(!e||e.id==="#"){return false}return e.state.selected},get_selected:function(e){return e?C.map(this._data.core.selected,C.proxy(function(e){return this.get_node(e)},this)):this._data.core.selected},get_top_selected:function(e){var t=this.get_selected(true),i={},n,r,o,s;for(n=0,r=t.length;n<r;n++){i[t[n].id]=t[n]}for(n=0,r=t.length;n<r;n++){for(o=0,s=t[n].children_d.length;o<s;o++){if(i[t[n].children_d[o]]){delete i[t[n].children_d[o]]}}}t=[];for(n in i){if(i.hasOwnProperty(n)){t.push(n)}}return e?C.map(t,C.proxy(function(e){return this.get_node(e)},this)):t},get_bottom_selected:function(e){var t=this.get_selected(true),i=[],n,r;for(n=0,r=t.length;n<r;n++){if(!t[n].children.length){i.push(t[n].id)}}return e?C.map(i,C.proxy(function(e){return this.get_node(e)},this)):i},get_state:function(){var e={core:{open:[],scroll:{left:this.element.scrollLeft(),top:this.element.scrollTop()},selected:[]}},t;for(t in this._model.data){if(this._model.data.hasOwnProperty(t)){if(t!=="#"){if(this._model.data[t].state.opened){e.core.open.push(t)}if(this._model.data[t].state.selected){e.core.selected.push(t)}}}}return e},set_state:function(i,n){if(i){if(i.core){var r,o,s,a;if(i.core.open){if(!C.isArray(i.core.open)){delete i.core.open;this.set_state(i,n);return false}r=true;o=false;s=this;C.each(i.core.open.concat([]),function(e,t){o=s.get_node(t);if(o){if(s.is_loaded(t)){if(s.is_closed(t)){s.open_node(t,false,0)}if(i&&i.core&&i.core.open){C.vakata.array_remove_item(i.core.open,t)}}else{if(!s.is_loading(t)){s.open_node(t,C.proxy(function(e,t){if(!t&&i&&i.core&&i.core.open){C.vakata.array_remove_item(i.core.open,e.id)}this.set_state(i,n)},s),0)}r=false}}});if(r){delete i.core.open;this.set_state(i,n)}return false}if(i.core.scroll){if(i.core.scroll&&i.core.scroll.left!==y){this.element.scrollLeft(i.core.scroll.left)}if(i.core.scroll&&i.core.scroll.top!==y){this.element.scrollTop(i.core.scroll.top)}delete i.core.scroll;this.set_state(i,n);return false}if(i.core.selected){a=this;this.deselect_all();C.each(i.core.selected,function(e,t){a.select_node(t)});delete i.core.selected;this.set_state(i,n);return false}if(C.isEmptyObject(i.core)){delete i.core;this.set_state(i,n);return false}}if(C.isEmptyObject(i)){i=null;if(n){n.call(this)}this.trigger("set_state");return false}return true}return false},refresh:function(e){this._data.core.state=this.get_state();this._cnt=0;this._model.data={"#":{id:"#",parent:null,parents:[],children:[],children_d:[],state:{loaded:false}}};var i=this.get_container_ul()[0].className;if(!e){this.element.html("<"+"ul class='jstree-container-ul jstree-children'><"+"li class='jstree-initial-node jstree-loading jstree-leaf jstree-last'><i class='jstree-icon jstree-ocl'></i><"+"a class='jstree-anchor' href='#'><i class='jstree-icon jstree-themeicon-hidden'></i>"+this.get_string("Loading ...")+"</a></li></ul>")}this.load_node("#",function(e,t){if(t){this.get_container_ul()[0].className=i;this.set_state(C.extend(true,{},this._data.core.state),function(){this.trigger("refresh")})}this._data.core.state=null})},refresh_node:function(t){t=this.get_node(t);if(!t||t.id==="#"){return false}var e=[],i=this._data.core.selected.concat([]);if(t.state.opened===true){e.push(t.id)}this.get_node(t,true).find(".jstree-open").each(function(){e.push(this.id)});this._load_nodes(e,C.proxy(function(e){this.open_node(e,false,0);this.select_node(this._data.core.selected);this.trigger("refresh_node",{node:t,nodes:e})},this))},set_id:function(e,t){e=this.get_node(e);if(!e||e.id==="#"){return false}var i,n,r=this._model.data;t=t.toString();r[e.parent].children[C.inArray(e.id,r[e.parent].children)]=t;for(i=0,n=e.parents.length;i<n;i++){r[e.parents[i]].children_d[C.inArray(e.id,r[e.parents[i]].children_d)]=t}for(i=0,n=e.children.length;i<n;i++){r[e.children[i]].parent=t}for(i=0,n=e.children_d.length;i<n;i++){r[e.children_d[i]].parents[C.inArray(e.id,r[e.children_d[i]].parents)]=t}i=C.inArray(e.id,this._data.core.selected);if(i!==-1){this._data.core.selected[i]=t}i=this.get_node(e.id,true);if(i){i.attr("id",t)}delete r[e.id];e.id=t;r[t]=e;return true},get_text:function(e){e=this.get_node(e);return!e||e.id==="#"?false:e.text},set_text:function(e,t){var i,n,r,o;if(C.isArray(e)){e=e.slice();for(i=0,n=e.length;i<n;i++){this.set_text(e[i],t)}return true}e=this.get_node(e);if(!e||e.id==="#"){return false}e.text=t;r=this.get_node(e,true);if(r.length){r=r.children(".jstree-anchor:eq(0)");o=r.children("I").clone();r.html(t).prepend(o);this.trigger("set_text",{obj:e,text:t})}return true},get_json:function(e,t,i){e=this.get_node(e||"#");if(!e){return false}if(t&&t.flat&&!i){i=[]}var n={id:e.id,text:e.text,icon:this.get_icon(e),li_attr:e.li_attr,a_attr:e.a_attr,state:{},data:t&&t.no_data?false:e.data},r,o;if(t&&t.flat){n.parent=e.parent}else{n.children=[]}if(!t||!t.no_state){for(r in e.state){if(e.state.hasOwnProperty(r)){n.state[r]=e.state[r]}}}if(t&&t.no_id){delete n.id;if(n.li_attr&&n.li_attr.id){delete n.li_attr.id}}if(t&&t.flat&&e.id!=="#"){i.push(n)}if(!t||!t.no_children){for(r=0,o=e.children.length;r<o;r++){if(t&&t.flat){this.get_json(e.children[r],t,i)}else{n.children.push(this.get_json(e.children[r],t))}}}return t&&t.flat?i:e.id==="#"?n.children:n},create_node:function(e,t,i,n,r){if(e===null){e="#"}e=this.get_node(e);if(!e){return false}i=i===y?"last":i;if(!i.toString().match(/^(before|after)$/)&&!r&&!this.is_loaded(e)){return this.load_node(e,function(){this.create_node(e,t,i,n,true)})}if(!t){t={text:this.get_string("New node")}}if(t.text===y){t.text=this.get_string("New node")}var o,s,a,l;if(e.id==="#"){if(i==="before"){i="first"}if(i==="after"){i="last"}}switch(i){case"before":o=this.get_node(e.parent);i=C.inArray(e.id,o.children);e=o;break;case"after":o=this.get_node(e.parent);i=C.inArray(e.id,o.children)+1;e=o;break;case"inside":case"first":i=0;break;case"last":i=e.children.length;break;default:if(!i){i=0}break}if(i>e.children.length){i=e.children.length}if(!t.id){t.id=true}if(!this.check("create_node",t,e,i)){this.settings.core.error.call(this,this._data.core.last_error);return false}if(t.id===true){delete t.id}t=this._parse_model_from_json(t,e.id,e.parents.concat());if(!t){return false}o=this.get_node(t);s=[];s.push(t);s=s.concat(o.children_d);this.trigger("model",{nodes:s,parent:e.id});e.children_d=e.children_d.concat(s);for(a=0,l=e.parents.length;a<l;a++){this._model.data[e.parents[a]].children_d=this._model.data[e.parents[a]].children_d.concat(s)}t=o;o=[];for(a=0,l=e.children.length;a<l;a++){o[a>=i?a+1:a]=e.children[a]}o[i]=t.id;e.children=o;this.redraw_node(e,true);if(n){n.call(this,this.get_node(t))}this.trigger("create_node",{node:this.get_node(t),parent:e.id,position:i});return t.id},rename_node:function(e,t){var i,n,r;if(C.isArray(e)){e=e.slice();for(i=0,n=e.length;i<n;i++){this.rename_node(e[i],t)}return true}e=this.get_node(e);if(!e||e.id==="#"){return false}r=e.text;if(!this.check("rename_node",e,this.get_parent(e),t)){this.settings.core.error.call(this,this._data.core.last_error);return false}this.set_text(e,t);this.trigger("rename_node",{node:e,text:t,old:r});return true},delete_node:function(e){var t,i,n,r,o,s,a,l,c,u;if(C.isArray(e)){e=e.slice();for(t=0,i=e.length;t<i;t++){this.delete_node(e[t])}return true}e=this.get_node(e);if(!e||e.id==="#"){return false}n=this.get_node(e.parent);r=C.inArray(e.id,n.children);u=false;if(!this.check("delete_node",e,n,r)){this.settings.core.error.call(this,this._data.core.last_error);return false}if(r!==-1){n.children=C.vakata.array_remove(n.children,r)}o=e.children_d.concat([]);o.push(e.id);for(l=0,c=o.length;l<c;l++){for(s=0,a=e.parents.length;s<a;s++){r=C.inArray(o[l],this._model.data[e.parents[s]].children_d);if(r!==-1){this._model.data[e.parents[s]].children_d=C.vakata.array_remove(this._model.data[e.parents[s]].children_d,r)}}if(this._model.data[o[l]].state.selected){u=true;r=C.inArray(o[l],this._data.core.selected);if(r!==-1){this._data.core.selected=C.vakata.array_remove(this._data.core.selected,r)}}}this.trigger("delete_node",{node:e,parent:n.id});if(u){this.trigger("changed",{action:"delete_node",node:e,selected:this._data.core.selected,parent:n.id})}for(l=0,c=o.length;l<c;l++){delete this._model.data[o[l]]}this.redraw_node(n,true);return true},check:function(e,t,i,n,r){t=t&&t.id?t:this.get_node(t);i=i&&i.id?i:this.get_node(i);var o=e.match(/^move_node|copy_node|create_node$/i)?i:t,s=this.settings.core.check_callback;if(e==="move_node"||e==="copy_node"){if((!r||!r.is_multi)&&(t.id===i.id||C.inArray(t.id,i.children)===n||C.inArray(i.id,t.children_d)!==-1)){this._data.core.last_error={error:"check",plugin:"core",id:"core_01",reason:"Moving parent inside child",data:JSON.stringify({chk:e,pos:n,obj:t&&t.id?t.id:false,par:i&&i.id?i.id:false})};return false}}if(o&&o.data){o=o.data}if(o&&o.functions&&(o.functions[e]===false||o.functions[e]===true)){if(o.functions[e]===false){this._data.core.last_error={error:"check",plugin:"core",id:"core_02",reason:"Node data prevents function: "+e,data:JSON.stringify({chk:e,pos:n,obj:t&&t.id?t.id:false,par:i&&i.id?i.id:false})}}return o.functions[e]}if(s===false||C.isFunction(s)&&s.call(this,e,t,i,n,r)===false||s&&s[e]===false){this._data.core.last_error={error:"check",plugin:"core",id:"core_03",reason:"User config for core.check_callback prevents function: "+e,data:JSON.stringify({chk:e,pos:n,obj:t&&t.id?t.id:false,par:i&&i.id?i.id:false})};return false}return true},last_error:function(){return this._data.core.last_error},move_node:function(e,t,i,n,r){var o,s,a,l,c,u,d,f,h,p,g,m,v;if(C.isArray(e)){e=e.reverse().slice();for(o=0,s=e.length;o<s;o++){this.move_node(e[o],t,i,n,r)}return true}e=e&&e.id?e:this.get_node(e);t=this.get_node(t);i=i===y?0:i;if(!t||!e||e.id==="#"){return false}if(!i.toString().match(/^(before|after)$/)&&!r&&!this.is_loaded(t)){return this.load_node(t,function(){this.move_node(e,t,i,n,true)})}a=(e.parent||"#").toString();l=!i.toString().match(/^(before|after)$/)||t.id==="#"?t:this.get_node(t.parent);c=e.instance?e.instance:this._model.data[e.id]?this:C.jstree.reference(e.id);u=!c||!c._id||this._id!==c._id;if(u){if(this.copy_node(e,t,i,n,r)){if(c){c.delete_node(e)}return true}return false}if(l.id==="#"){if(i==="before"){i="first"}if(i==="after"){i="last"}}switch(i){case"before":i=C.inArray(t.id,l.children);break;case"after":i=C.inArray(t.id,l.children)+1;break;case"inside":case"first":i=0;break;case"last":i=l.children.length;break;default:if(!i){i=0}break}if(i>l.children.length){i=l.children.length}if(!this.check("move_node",e,l,i,{core:true,is_multi:c&&c._id&&c._id!==this._id,is_foreign:!c||!c._id})){this.settings.core.error.call(this,this._data.core.last_error);return false}if(e.parent===l.id){d=l.children.concat();f=C.inArray(e.id,d);if(f!==-1){d=C.vakata.array_remove(d,f);if(i>f){i--}}f=[];for(h=0,p=d.length;h<p;h++){f[h>=i?h+1:h]=d[h]}f[i]=e.id;l.children=f;this._node_changed(l.id);this.redraw(l.id==="#")}else{f=e.children_d.concat();f.push(e.id);for(h=0,p=e.parents.length;h<p;h++){d=[];v=c._model.data[e.parents[h]].children_d;for(g=0,m=v.length;g<m;g++){if(C.inArray(v[g],f)===-1){d.push(v[g])}}c._model.data[e.parents[h]].children_d=d}c._model.data[a].children=C.vakata.array_remove_item(c._model.data[a].children,e.id);for(h=0,p=l.parents.length;h<p;h++){this._model.data[l.parents[h]].children_d=this._model.data[l.parents[h]].children_d.concat(f)}d=[];for(h=0,p=l.children.length;h<p;h++){d[h>=i?h+1:h]=l.children[h]}d[i]=e.id;l.children=d;l.children_d.push(e.id);l.children_d=l.children_d.concat(e.children_d);e.parent=l.id;f=l.parents.concat();f.unshift(l.id);v=e.parents.length;e.parents=f;f=f.concat();for(h=0,p=e.children_d.length;h<p;h++){this._model.data[e.children_d[h]].parents=this._model.data[e.children_d[h]].parents.slice(0,v*-1);Array.prototype.push.apply(this._model.data[e.children_d[h]].parents,f)}this._node_changed(a);this._node_changed(l.id);this.redraw(a==="#"||l.id==="#")}if(n){n.call(this,e,l,i)}this.trigger("move_node",{node:e,parent:l.id,position:i,old_parent:a,is_multi:c&&c._id&&c._id!==this._id,is_foreign:!c||!c._id,old_instance:c,new_instance:this});return true},copy_node:function(e,t,i,n,r){var o,s,a,l,c,u,d,f,h,p,g;if(C.isArray(e)){e=e.reverse().slice();for(o=0,s=e.length;o<s;o++){this.copy_node(e[o],t,i,n,r)}return true}e=e&&e.id?e:this.get_node(e);t=this.get_node(t);i=i===y?0:i;if(!t||!e||e.id==="#"){return false}if(!i.toString().match(/^(before|after)$/)&&!r&&!this.is_loaded(t)){return this.load_node(t,function(){this.copy_node(e,t,i,n,true)})}f=(e.parent||"#").toString();h=!i.toString().match(/^(before|after)$/)||t.id==="#"?t:this.get_node(t.parent);p=e.instance?e.instance:this._model.data[e.id]?this:C.jstree.reference(e.id);g=!p||!p._id||this._id!==p._id;if(h.id==="#"){if(i==="before"){i="first"}if(i==="after"){i="last"}}switch(i){case"before":i=C.inArray(t.id,h.children);break;case"after":i=C.inArray(t.id,h.children)+1;break;case"inside":case"first":i=0;break;case"last":i=h.children.length;break;default:if(!i){i=0}break}if(i>h.children.length){i=h.children.length}if(!this.check("copy_node",e,h,i,{core:true,is_multi:p&&p._id&&p._id!==this._id,is_foreign:!p||!p._id})){this.settings.core.error.call(this,this._data.core.last_error);return false}d=p?p.get_json(e,{no_id:true,no_data:true,no_state:true}):e;if(!d){return false}if(d.id===true){delete d.id}d=this._parse_model_from_json(d,h.id,h.parents.concat());if(!d){return false}l=this.get_node(d);if(e&&e.state&&e.state.loaded===false){l.state.loaded=false}a=[];a.push(d);a=a.concat(l.children_d);this.trigger("model",{nodes:a,parent:h.id});for(c=0,u=h.parents.length;c<u;c++){this._model.data[h.parents[c]].children_d=this._model.data[h.parents[c]].children_d.concat(a)}a=[];for(c=0,u=h.children.length;c<u;c++){a[c>=i?c+1:c]=h.children[c]}a[i]=l.id;h.children=a;h.children_d.push(l.id);h.children_d=h.children_d.concat(l.children_d);this._node_changed(h.id);this.redraw(h.id==="#");if(n){n.call(this,l,h,i)}this.trigger("copy_node",{node:l,original:e,parent:h.id,position:i,old_parent:f,is_multi:p&&p._id&&p._id!==this._id,is_foreign:!p||!p._id,old_instance:p,new_instance:this});return l.id},cut:function(e){if(!e){e=this._data.core.selected.concat()}if(!C.isArray(e)){e=[e]}if(!e.length){return false}var t=[],i,n,r;for(n=0,r=e.length;n<r;n++){i=this.get_node(e[n]);if(i&&i.id&&i.id!=="#"){t.push(i)}}if(!t.length){return false}o=t;a=this;s="move_node";this.trigger("cut",{node:e})},copy:function(e){if(!e){e=this._data.core.selected.concat()}if(!C.isArray(e)){e=[e]}if(!e.length){return false}var t=[],i,n,r;for(n=0,r=e.length;n<r;n++){i=this.get_node(e[n]);if(i&&i.id&&i.id!=="#"){t.push(i)}}if(!t.length){return false}o=t;a=this;s="copy_node";this.trigger("copy",{node:e})},get_buffer:function(){return{mode:s,node:o,inst:a}},can_paste:function(){return s!==false&&o!==false},paste:function(e,t){e=this.get_node(e);if(!e||!s||!s.match(/^(copy_node|move_node)$/)||!o){return false}if(this[s](o,e,t)){this.trigger("paste",{parent:e.id,node:o,mode:s})}o=false;s=false;a=false},edit:function(i,e){i=this._open_to(i);if(!i||!i.length){return false}var t=this._data.core.rtl,n=this.element.width(),r=i.children(".jstree-anchor"),o=C("<span>"),s=typeof e==="string"?e:this.get_text(i),a=C("<"+"div />",{css:{position:"absolute",top:"-200px",left:t?"0px":"-1000px",visibility:"hidden"}}).appendTo("body"),l=C("<"+"input />",{value:s,class:"jstree-rename-input",css:{padding:"0",border:"1px solid silver","box-sizing":"border-box",display:"inline-block",height:this._data.core.li_height+"px",lineHeight:this._data.core.li_height+"px",width:"150px"},blur:C.proxy(function(){var e=o.children(".jstree-rename-input"),t=e.val();if(t===""){t=s}a.remove();o.replaceWith(r);o.remove();this.set_text(i,s);if(this.rename_node(i,t)===false){this.set_text(i,s)}},this),keydown:function(e){var t=e.which;if(t===27){this.value=s}if(t===27||t===13||t===37||t===38||t===39||t===40||t===32){e.stopImmediatePropagation()}if(t===27||t===13){e.preventDefault();this.blur()}},click:function(e){e.stopImmediatePropagation()},mousedown:function(e){e.stopImmediatePropagation()},keyup:function(e){l.width(Math.min(a.text("pW"+this.value).width(),n))},keypress:function(e){if(e.which===13){return false}}}),c={fontFamily:r.css("fontFamily")||"",fontSize:r.css("fontSize")||"",fontWeight:r.css("fontWeight")||"",fontStyle:r.css("fontStyle")||"",fontStretch:r.css("fontStretch")||"",fontVariant:r.css("fontVariant")||"",letterSpacing:r.css("letterSpacing")||"",wordSpacing:r.css("wordSpacing")||""};this.set_text(i,"");o.attr("class",r.attr("class")).append(r.contents().clone()).append(l);r.replaceWith(o);a.css(c);l.css(c).width(Math.min(a.text("pW"+l[0].value).width(),n))[0].select()},set_theme:function(e,t){if(!e){return false}if(t===true){var i=this.settings.core.themes.dir;if(!i){i=C.jstree.path+"/themes"}t=i+"/"+e+"/style.css"}if(t&&C.inArray(t,n)===-1){C("head").append("<"+'link rel="stylesheet" href="'+t+'" type="text/css" />');n.push(t)}if(this._data.core.themes.name){this.element.removeClass("jstree-"+this._data.core.themes.name)}this._data.core.themes.name=e;this.element.addClass("jstree-"+e);this.element[this.settings.core.themes.responsive?"addClass":"removeClass"]("jstree-"+e+"-responsive");this.trigger("set_theme",{theme:e})},get_theme:function(){return this._data.core.themes.name},set_theme_variant:function(e){if(this._data.core.themes.variant){this.element.removeClass("jstree-"+this._data.core.themes.name+"-"+this._data.core.themes.variant)}this._data.core.themes.variant=e;if(e){this.element.addClass("jstree-"+this._data.core.themes.name+"-"+this._data.core.themes.variant)}},get_theme_variant:function(){return this._data.core.themes.variant},show_stripes:function(){this._data.core.themes.stripes=true;this.get_container_ul().addClass("jstree-striped")},hide_stripes:function(){this._data.core.themes.stripes=false;this.get_container_ul().removeClass("jstree-striped")},toggle_stripes:function(){if(this._data.core.themes.stripes){this.hide_stripes()}else{this.show_stripes()}},show_dots:function(){this._data.core.themes.dots=true;this.get_container_ul().removeClass("jstree-no-dots")},hide_dots:function(){this._data.core.themes.dots=false;this.get_container_ul().addClass("jstree-no-dots")},toggle_dots:function(){if(this._data.core.themes.dots){this.hide_dots()}else{this.show_dots()}},show_icons:function(){this._data.core.themes.icons=true;this.get_container_ul().removeClass("jstree-no-icons")},hide_icons:function(){this._data.core.themes.icons=false;this.get_container_ul().addClass("jstree-no-icons")},toggle_icons:function(){if(this._data.core.themes.icons){this.hide_icons()}else{this.show_icons()}},set_icon:function(e,t){var i,n,r,o;if(C.isArray(e)){e=e.slice();for(i=0,n=e.length;i<n;i++){this.set_icon(e[i],t)}return true}e=this.get_node(e);if(!e||e.id==="#"){return false}o=e.icon;e.icon=t;r=this.get_node(e,true).children(".jstree-anchor").children(".jstree-themeicon");if(t===false){this.hide_icon(e)}else if(t===true){r.removeClass("jstree-themeicon-custom "+o).css("background","").removeAttr("rel")}else if(t.indexOf("/")===-1&&t.indexOf(".")===-1){r.removeClass(o).css("background","");r.addClass(t+" jstree-themeicon-custom").attr("rel",t)}else{r.removeClass(o).css("background","");r.addClass("jstree-themeicon-custom").css("background","url('"+t+"') center center no-repeat").attr("rel",t)}return true},get_icon:function(e){e=this.get_node(e);return!e||e.id==="#"?false:e.icon},hide_icon:function(e){var t,i;if(C.isArray(e)){e=e.slice();for(t=0,i=e.length;t<i;t++){this.hide_icon(e[t])}return true}e=this.get_node(e);if(!e||e==="#"){return false}e.icon=false;this.get_node(e,true).children(".jstree-anchor").children(".jstree-themeicon").addClass("jstree-themeicon-hidden");return true},show_icon:function(e){var t,i,n;if(C.isArray(e)){e=e.slice();for(t=0,i=e.length;t<i;t++){this.show_icon(e[t])}return true}e=this.get_node(e);if(!e||e==="#"){return false}n=this.get_node(e,true);e.icon=n.length?n.children(".jstree-anchor").children(".jstree-themeicon").attr("rel"):true;if(!e.icon){e.icon=true}n.children(".jstree-anchor").children(".jstree-themeicon").removeClass("jstree-themeicon-hidden");return true}};C.vakata={};C.vakata.attributes=function(e,i){e=C(e)[0];var n=i?{}:[];if(e&&e.attributes){C.each(e.attributes,function(e,t){if(C.inArray(t.nodeName.toLowerCase(),["style","contenteditable","hasfocus","tabindex"])!==-1){return}if(t.nodeValue!==null&&C.trim(t.nodeValue)!==""){if(i){n[t.nodeName]=t.nodeValue}else{n.push(t.nodeName)}}})}return n};C.vakata.array_unique=function(e){var t=[],i,n,r;for(i=0,r=e.length;i<r;i++){for(n=0;n<=i;n++){if(e[i]===e[n]){break}}if(n===i){t.push(e[i])}}return t};C.vakata.array_remove=function(e,t,i){var n=e.slice((i||t)+1||e.length);e.length=t<0?e.length+t:t;e.push.apply(e,n);return e};C.vakata.array_remove_item=function(e,t){var i=C.inArray(t,e);return i!==-1?C.vakata.array_remove(e,i):e};(function(){var e={},t=function(e){e=e.toLowerCase();var t=/(chrome)[ \/]([\w.]+)/.exec(e)||/(webkit)[ \/]([\w.]+)/.exec(e)||/(opera)(?:.*version|)[ \/]([\w.]+)/.exec(e)||/(msie) ([\w.]+)/.exec(e)||e.indexOf("compatible")<0&&/(mozilla)(?:.*? rv:([\w.]+)|)/.exec(e)||[];return{browser:t[1]||"",version:t[2]||"0"}},i=t(window.navigator.userAgent);if(i.browser){e[i.browser]=true;e.version=i.version}if(e.chrome){e.webkit=true}else if(e.webkit){e.safari=true}C.vakata.browser=e})();if(C.vakata.browser.msie&&C.vakata.browser.version<8){C.jstree.defaults.core.animation=0}var c=document.createElement("I");c.className="jstree-icon jstree-checkbox";C.jstree.defaults.checkbox={visible:true,three_state:true,whole_node:true,keep_selected_style:true};C.jstree.plugins.checkbox=function(e,s){this.bind=function(){s.bind.call(this);this._data.checkbox.uto=false;this.element.on("init.jstree",C.proxy(function(){this._data.checkbox.visible=this.settings.checkbox.visible;if(!this.settings.checkbox.keep_selected_style){this.element.addClass("jstree-checkbox-no-clicked")}},this)).on("loading.jstree",C.proxy(function(){this[this._data.checkbox.visible?"show_checkboxes":"hide_checkboxes"]()},this));if(this.settings.checkbox.three_state){this.element.on("changed.jstree move_node.jstree copy_node.jstree redraw.jstree open_node.jstree",C.proxy(function(){if(this._data.checkbox.uto){clearTimeout(this._data.checkbox.uto)}this._data.checkbox.uto=setTimeout(C.proxy(this._undetermined,this),50)},this)).on("model.jstree",C.proxy(function(e,t){var i=this._model.data,n=i[t.parent],r=t.nodes,o=[],s,a,l,c,u,d;if(n.state.selected){for(a=0,l=r.length;a<l;a++){i[r[a]].state.selected=true}this._data.core.selected=this._data.core.selected.concat(r)}else{for(a=0,l=r.length;a<l;a++){if(i[r[a]].state.selected){for(c=0,u=i[r[a]].children_d.length;c<u;c++){i[i[r[a]].children_d[c]].state.selected=true}this._data.core.selected=this._data.core.selected.concat(i[r[a]].children_d)}}}for(a=0,l=n.children_d.length;a<l;a++){if(!i[n.children_d[a]].children.length){o.push(i[n.children_d[a]].parent)}}o=C.vakata.array_unique(o);for(c=0,u=o.length;c<u;c++){n=i[o[c]];while(n&&n.id!=="#"){s=0;for(a=0,l=n.children.length;a<l;a++){s+=i[n.children[a]].state.selected}if(s===l){n.state.selected=true;this._data.core.selected.push(n.id);d=this.get_node(n,true);if(d&&d.length){d.children(".jstree-anchor").addClass("jstree-clicked")}}else{break}n=this.get_node(n.parent)}}this._data.core.selected=C.vakata.array_unique(this._data.core.selected)},this)).on("select_node.jstree",C.proxy(function(e,t){var i=t.node,n=this._model.data,r=this.get_node(i.parent),o=this.get_node(i,true),s,a,l,c;this._data.core.selected=C.vakata.array_unique(this._data.core.selected.concat(i.children_d));for(s=0,a=i.children_d.length;s<a;s++){c=n[i.children_d[s]];c.state.selected=true;if(c&&c.original&&c.original.state&&c.original.state.undetermined){c.original.state.undetermined=false}}while(r&&r.id!=="#"){l=0;for(s=0,a=r.children.length;s<a;s++){l+=n[r.children[s]].state.selected}if(l===a){r.state.selected=true;this._data.core.selected.push(r.id);c=this.get_node(r,true);if(c&&c.length){c.children(".jstree-anchor").addClass("jstree-clicked")}}else{break}r=this.get_node(r.parent)}if(o.length){o.find(".jstree-anchor").addClass("jstree-clicked")}},this)).on("deselect_all.jstree",C.proxy(function(e,t){var i=this.get_node("#"),n=this._model.data,r,o,s;for(r=0,o=i.children_d.length;r<o;r++){s=n[i.children_d[r]];if(s&&s.original&&s.original.state&&s.original.state.undetermined){s.original.state.undetermined=false}}},this)).on("deselect_node.jstree",C.proxy(function(e,t){var i=t.node,n=this.get_node(i,true),r,o,s;if(i&&i.original&&i.original.state&&i.original.state.undetermined){i.original.state.undetermined=false}for(r=0,o=i.children_d.length;r<o;r++){s=this._model.data[i.children_d[r]];s.state.selected=false;if(s&&s.original&&s.original.state&&s.original.state.undetermined){s.original.state.undetermined=false}}for(r=0,o=i.parents.length;r<o;r++){s=this._model.data[i.parents[r]];s.state.selected=false;if(s&&s.original&&s.original.state&&s.original.state.undetermined){s.original.state.undetermined=false}s=this.get_node(i.parents[r],true);if(s&&s.length){s.children(".jstree-anchor").removeClass("jstree-clicked")}}s=[];for(r=0,o=this._data.core.selected.length;r<o;r++){if(C.inArray(this._data.core.selected[r],i.children_d)===-1&&C.inArray(this._data.core.selected[r],i.parents)===-1){s.push(this._data.core.selected[r])}}this._data.core.selected=C.vakata.array_unique(s);if(n.length){n.find(".jstree-anchor").removeClass("jstree-clicked")}},this)).on("delete_node.jstree",C.proxy(function(e,t){var i=this.get_node(t.parent),n=this._model.data,r,o,s,a;while(i&&i.id!=="#"){s=0;for(r=0,o=i.children.length;r<o;r++){s+=n[i.children[r]].state.selected}if(s===o){i.state.selected=true;this._data.core.selected.push(i.id);a=this.get_node(i,true);if(a&&a.length){a.children(".jstree-anchor").addClass("jstree-clicked")}}else{break}i=this.get_node(i.parent)}},this)).on("move_node.jstree",C.proxy(function(e,t){var i=t.is_multi,n=t.old_parent,r=this.get_node(t.parent),o=this._model.data,s,a,l,c,u;if(!i){s=this.get_node(n);while(s&&s.id!=="#"){a=0;for(l=0,c=s.children.length;l<c;l++){a+=o[s.children[l]].state.selected}if(a===c){s.state.selected=true;this._data.core.selected.push(s.id);u=this.get_node(s,true);if(u&&u.length){u.children(".jstree-anchor").addClass("jstree-clicked")}}else{break}s=this.get_node(s.parent)}}s=r;while(s&&s.id!=="#"){a=0;for(l=0,c=s.children.length;l<c;l++){a+=o[s.children[l]].state.selected}if(a===c){if(!s.state.selected){s.state.selected=true;this._data.core.selected.push(s.id);u=this.get_node(s,true);if(u&&u.length){u.children(".jstree-anchor").addClass("jstree-clicked")}}}else{if(s.state.selected){s.state.selected=false;this._data.core.selected=C.vakata.array_remove_item(this._data.core.selected,s.id);u=this.get_node(s,true);if(u&&u.length){u.children(".jstree-anchor").removeClass("jstree-clicked")}}else{break}}s=this.get_node(s.parent)}},this))}};this._undetermined=function(){var i,n,r=this._model.data,e=this._data.core.selected,o=[],s=this;for(i=0,n=e.length;i<n;i++){if(r[e[i]]&&r[e[i]].parents){o=o.concat(r[e[i]].parents)}}this.element.find(".jstree-closed").not(":has(.jstree-children)").each(function(){var e=s.get_node(this),t;if(!e.state.loaded){if(e.original&&e.original.state&&e.original.state.undetermined&&e.original.state.undetermined===true){o.push(e.id);o=o.concat(e.parents)}}else{for(i=0,n=e.children_d.length;i<n;i++){t=r[e.children_d[i]];if(!t.state.loaded&&t.original&&t.original.state&&t.original.state.undetermined&&t.original.state.undetermined===true){o.push(t.id);o=o.concat(t.parents)}}}});o=C.vakata.array_unique(o);o=C.vakata.array_remove_item(o,"#");this.element.find(".jstree-undetermined").removeClass("jstree-undetermined");for(i=0,n=o.length;i<n;i++){if(!r[o[i]].state.selected){e=this.get_node(o[i],true);if(e&&e.length){e.children(".jstree-anchor").children(".jstree-checkbox").addClass("jstree-undetermined")}}}};this.redraw_node=function(e,t,i){e=s.redraw_node.call(this,e,t,i);if(e){var n,r,o=null;for(n=0,r=e.childNodes.length;n<r;n++){if(e.childNodes[n]&&e.childNodes[n].className&&e.childNodes[n].className.indexOf("jstree-anchor")!==-1){o=e.childNodes[n];break}}if(o){o.insertBefore(c.cloneNode(false),o.childNodes[0])}}if(!i&&this.settings.checkbox.three_state){if(this._data.checkbox.uto){clearTimeout(this._data.checkbox.uto)}this._data.checkbox.uto=setTimeout(C.proxy(this._undetermined,this),50)}return e};this.activate_node=function(e,t){if(this.settings.checkbox.whole_node||C(t.target).hasClass("jstree-checkbox")){t.ctrlKey=true}return s.activate_node.call(this,e,t)};this.show_checkboxes=function(){this._data.core.themes.checkboxes=true;this.get_container_ul().removeClass("jstree-no-checkboxes")};this.hide_checkboxes=function(){this._data.core.themes.checkboxes=false;this.get_container_ul().addClass("jstree-no-checkboxes")};this.toggle_checkboxes=function(){if(this._data.core.themes.checkboxes){this.hide_checkboxes()}else{this.show_checkboxes()}}};C.jstree.defaults.contextmenu={select_node:true,show_at_node:true,items:function(e,t){return{create:{separator_before:false,separator_after:true,_disabled:false,label:"Create",action:function(e){var t=C.jstree.reference(e.reference),i=t.get_node(e.reference);t.create_node(i,{},"last",function(e){setTimeout(function(){t.edit(e)},0)})}},rename:{separator_before:false,separator_after:false,_disabled:false,label:"Rename",action:function(e){var t=C.jstree.reference(e.reference),i=t.get_node(e.reference);t.edit(i)}},remove:{separator_before:false,icon:false,separator_after:false,_disabled:false,label:"Delete",action:function(e){var t=C.jstree.reference(e.reference),i=t.get_node(e.reference);if(t.is_selected(i)){t.delete_node(t.get_selected())}else{t.delete_node(i)}}},ccp:{separator_before:true,icon:false,separator_after:false,label:"Edit",action:false,submenu:{cut:{separator_before:false,separator_after:false,label:"Cut",action:function(e){var t=C.jstree.reference(e.reference),i=t.get_node(e.reference);if(t.is_selected(i)){t.cut(t.get_selected())}else{t.cut(i)}}},copy:{separator_before:false,icon:false,separator_after:false,label:"Copy",action:function(e){var t=C.jstree.reference(e.reference),i=t.get_node(e.reference);if(t.is_selected(i)){t.copy(t.get_selected())}else{t.copy(i)}}},paste:{separator_before:false,icon:false,_disabled:function(e){return!C.jstree.reference(e.reference).can_paste()},separator_after:false,label:"Paste",action:function(e){var t=C.jstree.reference(e.reference),i=t.get_node(e.reference);t.paste(i)}}}}}}};C.jstree.plugins.contextmenu=function(e,i){this.bind=function(){i.bind.call(this);var t=0;this.element.on("contextmenu.jstree",".jstree-anchor",C.proxy(function(e){e.preventDefault();t=e.ctrlKey?e.timeStamp:0;if(!this.is_loading(e.currentTarget)){this.show_contextmenu(e.currentTarget,e.pageX,e.pageY,e)}},this)).on("click.jstree",".jstree-anchor",C.proxy(function(e){if(this._data.contextmenu.visible&&(!t||e.timeStamp-t>250)){C.vakata.context.hide()}},this));C(document).on("context_hide.vakata",C.proxy(function(){this._data.contextmenu.visible=false},this))};this.teardown=function(){if(this._data.contextmenu.visible){C.vakata.context.hide()}i.teardown.call(this)};this.show_contextmenu=function(t,i,n,e){t=this.get_node(t);if(!t||t.id==="#"){return false}var r=this.settings.contextmenu,o=this.get_node(t,true),s=o.children(".jstree-anchor"),a=false,l=false;if(r.show_at_node||i===y||n===y){a=s.offset();i=a.left;n=a.top+this._data.core.li_height}if(this.settings.contextmenu.select_node&&!this.is_selected(t)){this.deselect_all();this.select_node(t,false,false,e)}l=r.items;if(C.isFunction(l)){l=l.call(this,t,C.proxy(function(e){this._show_contextmenu(t,i,n,e)},this))}if(C.isPlainObject(l)){this._show_contextmenu(t,i,n,l)}};this._show_contextmenu=function(e,t,i,n){var r=this.get_node(e,true),o=r.children(".jstree-anchor");C(document).one("context_show.vakata",C.proxy(function(e,t){var i="jstree-contextmenu jstree-"+this.get_theme()+"-contextmenu";C(t.element).addClass(i)},this));this._data.contextmenu.visible=true;C.vakata.context.show(o,{x:t,y:i},n);this.trigger("show_contextmenu",{node:e,x:t,y:i})}};(function(f){var h=false,p={element:false,reference:false,position_x:0,position_y:0,items:[],html:"",is_visible:false};f.vakata.context={settings:{hide_onmouseleave:0,icons:true},_trigger:function(e){f(document).triggerHandler("context_"+e+".vakata",{reference:p.reference,element:p.element,position:{x:p.position_x,y:p.position_y}})},_execute:function(e){e=p.items[e];return e&&(!e._disabled||f.isFunction(e._disabled)&&!e._disabled({item:e,reference:p.reference,element:p.element}))&&e.action?e.action.call(null,{item:e,reference:p.reference,element:p.element,position:{x:p.position_x,y:p.position_y}}):false},_parse:function(e,t){if(!e){return false}if(!t){p.html="";p.items=[]}var i="",n=false,r;if(t){i+="<"+"ul>"}f.each(e,function(e,t){if(!t){return true}p.items.push(t);if(!n&&t.separator_before){i+="<"+"li class='vakata-context-separator'><"+"a href='#' "+(f.vakata.context.settings.icons?"":'style="margin-left:0px;"')+">&#160;<"+"/a><"+"/li>"}n=false;i+="<"+"li class='"+(t._class||"")+(t._disabled===true||f.isFunction(t._disabled)&&t._disabled({item:t,reference:p.reference,element:p.element})?" vakata-contextmenu-disabled ":"")+"' "+(t.shortcut?" data-shortcut='"+t.shortcut+"' ":"")+">";i+="<"+"a href='#' rel='"+(p.items.length-1)+"'>";if(f.vakata.context.settings.icons){i+="<"+"i ";if(t.icon){if(t.icon.indexOf("/")!==-1||t.icon.indexOf(".")!==-1){i+=" style='background:url(\""+t.icon+"\") center center no-repeat' "}else{i+=" class='"+t.icon+"' "}}i+="><"+"/i><"+"span class='vakata-contextmenu-sep'>&#160;<"+"/span>"}i+=(f.isFunction(t.label)?t.label({item:e,reference:p.reference,element:p.element}):t.label)+(t.shortcut?' <span class="vakata-contextmenu-shortcut vakata-contextmenu-shortcut-'+t.shortcut+'">'+(t.shortcut_label||"")+"</span>":"")+"<"+"/a>";if(t.submenu){r=f.vakata.context._parse(t.submenu,true);if(r){i+=r}}i+="<"+"/li>";if(t.separator_after){i+="<"+"li class='vakata-context-separator'><"+"a href='#' "+(f.vakata.context.settings.icons?"":'style="margin-left:0px;"')+">&#160;<"+"/a><"+"/li>";n=true}});i=i.replace(/<li class\='vakata-context-separator'\><\/li\>$/,"");if(t){i+="</ul>"}if(!t){p.html=i;f.vakata.context._trigger("parse")}return i.length>10?i:false},_show_submenu:function(e){e=f(e);if(!e.length||!e.children("ul").length){return}var t=e.children("ul"),i=e.offset().left+e.outerWidth(),n=e.offset().top,r=t.width(),o=t.height(),s=f(window).width()+f(window).scrollLeft(),a=f(window).height()+f(window).scrollTop();if(h){e[i-(r+10+e.outerWidth())<0?"addClass":"removeClass"]("vakata-context-left")}else{e[i+r+10>s?"addClass":"removeClass"]("vakata-context-right")}if(n+o+10>a){t.css("bottom","-1px")}t.show()},show:function(e,t,i){var n,r,o,s,a,l,c,u,d=true;if(p.element&&p.element.length){p.element.width("")}switch(d){case!t&&!e:return false;case!!t&&!!e:p.reference=e;p.position_x=t.x;p.position_y=t.y;break;case!t&&!!e:p.reference=e;n=e.offset();p.position_x=n.left+e.outerHeight();p.position_y=n.top;break;case!!t&&!e:p.position_x=t.x;p.position_y=t.y;break}if(!!e&&!i&&f(e).data("vakata_contextmenu")){i=f(e).data("vakata_contextmenu")}if(f.vakata.context._parse(i)){p.element.html(p.html)}if(p.items.length){r=p.element;o=p.position_x;s=p.position_y;a=r.width();l=r.height();c=f(window).width()+f(window).scrollLeft();u=f(window).height()+f(window).scrollTop();if(h){o-=r.outerWidth();if(o<f(window).scrollLeft()+20){o=f(window).scrollLeft()+20}}if(o+a+20>c){o=c-(a+20)}if(s+l+20>u){s=u-(l+20)}p.element.css({left:o,top:s}).show().find("a:eq(0)").focus().parent().addClass("vakata-context-hover");p.is_visible=true;f.vakata.context._trigger("show")}},hide:function(){if(p.is_visible){p.element.hide().find("ul").hide().end().find(":focus").blur();p.is_visible=false;f.vakata.context._trigger("hide")}}};f(function(){h=f("body").css("direction")==="rtl";var t=false;p.element=f("<ul class='vakata-context'></ul>");p.element.on("mouseenter","li",function(e){e.stopImmediatePropagation();if(f.contains(this,e.relatedTarget)){return}if(t){clearTimeout(t)}p.element.find(".vakata-context-hover").removeClass("vakata-context-hover").end();f(this).siblings().find("ul").hide().end().end().parentsUntil(".vakata-context","li").addBack().addClass("vakata-context-hover");f.vakata.context._show_submenu(this)}).on("mouseleave","li",function(e){if(f.contains(this,e.relatedTarget)){return}f(this).find(".vakata-context-hover").addBack().removeClass("vakata-context-hover")}).on("mouseleave",function(e){f(this).find(".vakata-context-hover").removeClass("vakata-context-hover");if(f.vakata.context.settings.hide_onmouseleave){t=setTimeout(function(e){return function(){f.vakata.context.hide()}}(this),f.vakata.context.settings.hide_onmouseleave)}}).on("click","a",function(e){e.preventDefault()}).on("mouseup","a",function(e){if(!f(this).blur().parent().hasClass("vakata-context-disabled")&&f.vakata.context._execute(f(this).attr("rel"))!==false){f.vakata.context.hide()}}).on("keydown","a",function(e){var t=null;switch(e.which){case 13:case 32:e.type="mouseup";e.preventDefault();f(e.currentTarget).trigger(e);break;case 37:if(p.is_visible){p.element.find(".vakata-context-hover").last().parents("li:eq(0)").find("ul").hide().find(".vakata-context-hover").removeClass("vakata-context-hover").end().end().children("a").focus();e.stopImmediatePropagation();e.preventDefault()}break;case 38:if(p.is_visible){t=p.element.find("ul:visible").addBack().last().children(".vakata-context-hover").removeClass("vakata-context-hover").prevAll("li:not(.vakata-context-separator)").first();if(!t.length){t=p.element.find("ul:visible").addBack().last().children("li:not(.vakata-context-separator)").last()}t.addClass("vakata-context-hover").children("a").focus();e.stopImmediatePropagation();e.preventDefault()}break;case 39:if(p.is_visible){p.element.find(".vakata-context-hover").last().children("ul").show().children("li:not(.vakata-context-separator)").removeClass("vakata-context-hover").first().addClass("vakata-context-hover").children("a").focus();e.stopImmediatePropagation();e.preventDefault()}break;case 40:if(p.is_visible){t=p.element.find("ul:visible").addBack().last().children(".vakata-context-hover").removeClass("vakata-context-hover").nextAll("li:not(.vakata-context-separator)").first();if(!t.length){t=p.element.find("ul:visible").addBack().last().children("li:not(.vakata-context-separator)").first()}t.addClass("vakata-context-hover").children("a").focus();e.stopImmediatePropagation();e.preventDefault()}break;case 27:f.vakata.context.hide();e.preventDefault();break;default:break}}).on("keydown",function(e){e.preventDefault();var t=p.element.find(".vakata-contextmenu-shortcut-"+e.which).parent();if(t.parent().not(".vakata-context-disabled")){t.mouseup()}}).appendTo("body");f(document).on("mousedown",function(e){if(p.is_visible&&!f.contains(p.element[0],e.target)){f.vakata.context.hide()}}).on("context_show.vakata",function(e,t){p.element.find("li:has(ul)").children("a").addClass("vakata-context-parent");if(h){p.element.addClass("vakata-context-rtl").css("direction","rtl")}p.element.find("ul").hide().end()})})})(C);C.jstree.defaults.dnd={copy:true,open_timeout:500,is_draggable:true,check_while_dragging:true,always_copy:false};C.jstree.plugins.dnd=function(e,t){this.bind=function(){t.bind.call(this);this.element.on("mousedown.jstree touchstart.jstree",".jstree-anchor",C.proxy(function(e){var t=this.get_node(e.target),i=this.is_selected(t)?this.get_selected().length:1;if(t&&t.id&&t.id!=="#"&&(e.which===1||e.type==="touchstart")&&(this.settings.dnd.is_draggable===true||C.isFunction(this.settings.dnd.is_draggable)&&this.settings.dnd.is_draggable.call(this,i>1?this.get_selected(true):[t]))){this.element.trigger("mousedown.jstree");return C.vakata.dnd.start(e,{jstree:true,origin:this,obj:this.get_node(t,true),nodes:i>1?this.get_selected():[t.id]},'<div id="jstree-dnd" class="jstree-'+this.get_theme()+'"><i class="jstree-icon jstree-er"></i>'+(i>1?i+" "+this.get_string("nodes"):this.get_text(e.currentTarget,true))+'<ins class="jstree-copy" style="display:none;">+</ins></div>')}},this))}};C(function(){var b=false,w=false,x=false,k=C('<div id="jstree-marker">&#160;</div>').hide().appendTo("body");C(document).bind("dnd_start.vakata",function(e,t){b=false}).bind("dnd_move.vakata",function(e,i){if(x){clearTimeout(x)}if(!i.data.jstree){return}C(".jstree-container-ul li.jstree-node").removeClass("highlight-li top-border bottom-border");if(i.event.target.id&&i.event.target.id==="jstree-marker"){return}var n=C.jstree.reference(i.event.target),r=false,o=false,t=false,s,a,l,c,u,d,f,h,p,g,m,v,y,_;if(n&&n._data&&n._data.dnd){k.attr("class","jstree-"+n.get_theme());i.helper.children().attr("class","jstree-"+n.get_theme()).find(".jstree-copy:eq(0)")[i.data.origin&&(i.data.origin.settings.dnd.always_copy||i.data.origin.settings.dnd.copy&&(i.event.metaKey||i.event.ctrlKey))?"show":"hide"]();if((i.event.target===n.element[0]||i.event.target===n.get_container_ul()[0])&&n.get_container_ul().children().length===0){p=true;for(g=0,m=i.data.nodes.length;g<m;g++){p=p&&n.check(i.data.origin&&(i.data.origin.settings.dnd.always_copy||i.data.origin.settings.dnd.copy&&(i.event.metaKey||i.event.ctrlKey))?"copy_node":"move_node",i.data.origin&&i.data.origin!==n?i.data.origin.get_node(i.data.nodes[g]):i.data.nodes[g],"#","last",{dnd:true,ref:n.get_node("#"),pos:"i",is_multi:i.data.origin&&i.data.origin!==n,is_foreign:!i.data.origin});if(!p){break}}if(p){b={ins:n,par:"#",pos:"last"};k.hide();i.helper.find(".jstree-icon:eq(0)").removeClass("jstree-er").addClass("jstree-ok");return}}else{r=C(i.event.target).closest(".jstree-anchor");if(r&&r.length&&r.parent().is(".jstree-closed, .jstree-open, .jstree-leaf")){o=r.offset();t=i.event.pageY-o.top;u=r.height(),a=r.closest("li.jstree-node"),s=a.attr("rel");if(t<u/3){a.addClass("top-border");h=["b","i","a"]}else if(t>u-u/3){a.addClass("bottom-border");h=["a","i","b"]}else{if(s==="folder")a.addClass("highlight-li");h=t>u/2?["i","a","b"]:["i","b","a"]}C.each(h,function(e,t){switch(t){case"b":l=o.left-6;c=o.top-5;d=n.get_parent(r);f=r.parent().index();break;case"i":l=o.left-2;c=o.top-5+u/2+1;d=n.get_node(r.parent()).id;f=0;break;case"a":l=o.left-6;c=o.top-5+u;d=n.get_parent(r);f=r.parent().index()+1;break}p=true;for(g=0,m=i.data.nodes.length;g<m;g++){v=i.data.origin&&(i.data.origin.settings.dnd.always_copy||i.data.origin.settings.dnd.copy&&(i.event.metaKey||i.event.ctrlKey))?"copy_node":"move_node";y=f;if(v==="move_node"&&t==="a"&&(i.data.origin&&i.data.origin===n)&&d===n.get_parent(i.data.nodes[g])){_=n.get_node(d);if(y>C.inArray(i.data.nodes[g],_.children)){y-=1}}p=p&&(n&&n.settings&&n.settings.dnd&&n.settings.dnd.check_while_dragging===false||n.check(v,i.data.origin&&i.data.origin!==n?i.data.origin.get_node(i.data.nodes[g]):i.data.nodes[g],d,y,{dnd:true,ref:n.get_node(r.parent()),pos:t,is_multi:i.data.origin&&i.data.origin!==n,is_foreign:!i.data.origin}));if(!p){if(n&&n.last_error){w=n.last_error()}break}}if(p){if(t==="i"&&r.parent().is(".jstree-closed")&&n.settings.dnd.open_timeout){x=setTimeout(function(e,t){return function(){e.open_node(t)}}(n,r),n.settings.dnd.open_timeout)}b={ins:n,par:d,pos:f};k.css({left:l+"px",top:c+"px"}).show();i.helper.find(".jstree-icon:eq(0)").removeClass("jstree-er").addClass("jstree-ok");w={};h=true;return false}});if(h===true){return}}}}b=false;i.helper.find(".jstree-icon").removeClass("jstree-ok").addClass("jstree-er");k.hide()}).bind("dnd_scroll.vakata",function(e,t){if(!t.data.jstree){return}k.hide();b=false;t.helper.find(".jstree-icon:eq(0)").removeClass("jstree-ok").addClass("jstree-er")}).bind("dnd_stop.vakata",function(e,t){if(x){clearTimeout(x)}if(!t.data.jstree){return}k.hide();var i,n,r=[];if(b){for(i=0,n=t.data.nodes.length;i<n;i++){r[i]=t.data.origin?t.data.origin.get_node(t.data.nodes[i]):t.data.nodes[i];if(t.data.origin){r[i].instance=t.data.origin}}b.ins[t.data.origin&&(t.data.origin.settings.dnd.always_copy||t.data.origin.settings.dnd.copy&&(t.event.metaKey||t.event.ctrlKey))?"copy_node":"move_node"](r,b.par,b.pos)}else{i=C(t.event.target).closest(".jstree");if(i.length&&w&&w.error&&w.error==="check"){i=i.jstree(true);if(i){i.settings.core.error.call(this,w)}}}}).bind("keyup keydown",function(e,t){t=C.vakata.dnd._get();if(t.data&&t.data.jstree){t.helper.find(".jstree-copy:eq(0)")[t.data.origin&&(t.data.origin.settings.dnd.always_copy||t.data.origin.settings.dnd.copy&&(e.metaKey||e.ctrlKey))?"show":"hide"]()}})});(function(d){var f={element:false,is_down:false,is_drag:false,helper:false,helper_w:0,data:false,init_x:0,init_y:0,scroll_l:0,scroll_t:0,scroll_e:false,scroll_i:false};d.vakata.dnd={settings:{scroll_speed:10,scroll_proximity:20,helper_left:5,helper_top:10,threshold:5},_trigger:function(e,t){var i=d.vakata.dnd._get();i.event=t;d(document).triggerHandler("dnd_"+e+".vakata",i)},_get:function(){return{data:f.data,element:f.element,helper:f.helper}},_clean:function(){if(f.helper){f.helper.remove()}if(f.scroll_i){clearInterval(f.scroll_i);f.scroll_i=false}f={element:false,is_down:false,is_drag:false,helper:false,helper_w:0,data:false,init_x:0,init_y:0,scroll_l:0,scroll_t:0,scroll_e:false,scroll_i:false};d(document).off("mousemove touchmove",d.vakata.dnd.drag);d(document).off("mouseup touchend",d.vakata.dnd.stop)},_scroll:function(e){if(!f.scroll_e||!f.scroll_l&&!f.scroll_t){if(f.scroll_i){clearInterval(f.scroll_i);f.scroll_i=false}return false}if(!f.scroll_i){f.scroll_i=setInterval(d.vakata.dnd._scroll,100);return false}if(e===true){return false}var t=f.scroll_e.scrollTop(),i=f.scroll_e.scrollLeft();f.scroll_e.scrollTop(t+f.scroll_t*d.vakata.dnd.settings.scroll_speed);f.scroll_e.scrollLeft(i+f.scroll_l*d.vakata.dnd.settings.scroll_speed);if(t!==f.scroll_e.scrollTop()||i!==f.scroll_e.scrollLeft()){d.vakata.dnd._trigger("scroll",f.scroll_e)}},start:function(e,t,i){if(e.type==="touchstart"&&e.originalEvent&&e.originalEvent.changedTouches&&e.originalEvent.changedTouches[0]){e.pageX=e.originalEvent.changedTouches[0].pageX;e.pageY=e.originalEvent.changedTouches[0].pageY;e.target=document.elementFromPoint(e.originalEvent.changedTouches[0].pageX-window.pageXOffset,e.originalEvent.changedTouches[0].pageY-window.pageYOffset)}if(f.is_drag){d.vakata.dnd.stop({})}try{e.currentTarget.unselectable="on";e.currentTarget.onselectstart=function(){return false};if(e.currentTarget.style){e.currentTarget.style.MozUserSelect="none"}}catch(e){}f.init_x=e.pageX;f.init_y=e.pageY;f.data=t;f.is_down=true;f.element=e.currentTarget;if(i!==false){f.helper=d("<div id='vakata-dnd'></div>").html(i).css({display:"block",margin:"0",padding:"0",position:"absolute",top:"-2000px",lineHeight:"16px",zIndex:"10000"})}d(document).bind("mousemove touchmove",d.vakata.dnd.drag);d(document).bind("mouseup touchend",d.vakata.dnd.stop);return false},drag:function(i){if(i.type==="touchmove"&&i.originalEvent&&i.originalEvent.changedTouches&&i.originalEvent.changedTouches[0]){i.pageX=i.originalEvent.changedTouches[0].pageX;i.pageY=i.originalEvent.changedTouches[0].pageY;i.target=document.elementFromPoint(i.originalEvent.changedTouches[0].pageX-window.pageXOffset,i.originalEvent.changedTouches[0].pageY-window.pageYOffset)}if(!f.is_down){return}if(!f.is_drag){if(Math.abs(i.pageX-f.init_x)>d.vakata.dnd.settings.threshold||Math.abs(i.pageY-f.init_y)>d.vakata.dnd.settings.threshold){if(f.helper){f.helper.appendTo("body");f.helper_w=f.helper.outerWidth()}f.is_drag=true;d.vakata.dnd._trigger("start",i)}else{return}}var e=false,t=false,n=false,r=false,o=false,s=false,a=false,l=false,c=false,u=false;f.scroll_t=0;f.scroll_l=0;f.scroll_e=false;d(d(i.target).parentsUntil("body").addBack().get().reverse()).filter(function(){return/^auto|scroll$/.test(d(this).css("overflow"))&&(this.scrollHeight>this.offsetHeight||this.scrollWidth>this.offsetWidth)}).each(function(){var e=d(this),t=e.offset();if(this.scrollHeight>this.offsetHeight){if(t.top+e.height()-i.pageY<d.vakata.dnd.settings.scroll_proximity){f.scroll_t=1}if(i.pageY-t.top<d.vakata.dnd.settings.scroll_proximity){f.scroll_t=-1}}if(this.scrollWidth>this.offsetWidth){if(t.left+e.width()-i.pageX<d.vakata.dnd.settings.scroll_proximity){f.scroll_l=1}if(i.pageX-t.left<d.vakata.dnd.settings.scroll_proximity){f.scroll_l=-1}}if(f.scroll_t||f.scroll_l){f.scroll_e=d(this);return false}});if(!f.scroll_e){e=d(document);t=d(window);n=e.height();r=t.height();o=e.width();s=t.width();a=e.scrollTop();l=e.scrollLeft();if(n>r&&i.pageY-a<d.vakata.dnd.settings.scroll_proximity){f.scroll_t=-1}if(n>r&&r-(i.pageY-a)<d.vakata.dnd.settings.scroll_proximity){f.scroll_t=1}if(o>s&&i.pageX-l<d.vakata.dnd.settings.scroll_proximity){f.scroll_l=-1}if(o>s&&s-(i.pageX-l)<d.vakata.dnd.settings.scroll_proximity){f.scroll_l=1}if(f.scroll_t||f.scroll_l){f.scroll_e=e}}if(f.scroll_e){d.vakata.dnd._scroll(true)}if(f.helper){c=parseInt(i.pageY+d.vakata.dnd.settings.helper_top,10);u=parseInt(i.pageX+d.vakata.dnd.settings.helper_left,10);if(n&&c+25>n){c=n-50}if(o&&u+f.helper_w>o){u=o-(f.helper_w+2)}f.helper.css({left:u+"px",top:c+"px"})}d.vakata.dnd._trigger("move",i)},stop:function(e){if(e.type==="touchend"&&e.originalEvent&&e.originalEvent.changedTouches&&e.originalEvent.changedTouches[0]){e.pageX=e.originalEvent.changedTouches[0].pageX;e.pageY=e.originalEvent.changedTouches[0].pageY;e.target=document.elementFromPoint(e.originalEvent.changedTouches[0].pageX-window.pageXOffset,e.originalEvent.changedTouches[0].pageY-window.pageYOffset)}if(f.is_drag){d.vakata.dnd._trigger("stop",e)}d.vakata.dnd._clean()}}})(jQuery);C.jstree.defaults.search={ajax:false,fuzzy:true,case_sensitive:false,show_only_matches:false,close_opened_onclear:true,search_leaves_only:false};C.jstree.plugins.search=function(e,t){this.bind=function(){t.bind.call(this);this._data.search.str="";this._data.search.dom=C();this._data.search.res=[];this._data.search.opn=[];this.element.on("before_open.jstree",C.proxy(function(e,t){var i,n,r,o=this._data.search.res,s=[],a=C();if(o&&o.length){this._data.search.dom=C();for(i=0,n=o.length;i<n;i++){s=s.concat(this.get_node(o[i]).parents);r=this.get_node(o[i],true);if(r){this._data.search.dom=this._data.search.dom.add(r)}}s=C.vakata.array_unique(s);for(i=0,n=s.length;i<n;i++){if(s[i]==="#"){continue}r=this.get_node(s[i],true);if(r){a=a.add(r)}}this._data.search.dom.children(".jstree-anchor").addClass("jstree-search");if(this.settings.search.show_only_matches&&this._data.search.res.length){this.element.find(".jstree-node").hide().filter(".jstree-last").filter(function(){return this.nextSibling}).removeClass("jstree-last");a=a.add(this._data.search.dom);a.parentsUntil(".jstree").addBack().show().filter(".jstree-children").each(function(){C(this).children(".jstree-node:visible").eq(-1).addClass("jstree-last")})}}},this));if(this.settings.search.show_only_matches){this.element.on("search.jstree",function(e,t){if(t.nodes.length){C(this).find(".jstree-node").hide().filter(".jstree-last").filter(function(){return this.nextSibling}).removeClass("jstree-last");t.nodes.parentsUntil(".jstree").addBack().show().filter(".jstree-children").each(function(){C(this).children(".jstree-node:visible").eq(-1).addClass("jstree-last")})}}).on("clear_search.jstree",function(e,t){if(t.nodes.length){C(this).find(".jstree-node").css("display","").filter(".jstree-last").filter(function(){return this.nextSibling}).removeClass("jstree-last")}})}};this.search=function(t,e){if(t===false||C.trim(t)===""){return this.clear_search()}var i=this.settings.search,n=i.ajax?i.ajax:false,r=null,o=[],s=[],a,l;if(this._data.search.res.length){this.clear_search()}if(!e&&n!==false){if(C.isFunction(n)){return n.call(this,t,C.proxy(function(e){if(e&&e.d){e=e.d}this._load_nodes(!C.isArray(e)?[]:e,function(){this.search(t,true)})},this))}else{n=C.extend({},n);if(!n.data){n.data={}}n.data.str=t;return C.ajax(n).fail(C.proxy(function(){this._data.core.last_error={error:"ajax",plugin:"search",id:"search_01",reason:"Could not load search parents",data:JSON.stringify(n)};this.settings.core.error.call(this,this._data.core.last_error)},this)).done(C.proxy(function(e){if(e&&e.d){e=e.d}this._load_nodes(!C.isArray(e)?[]:e,function(){this.search(t,true)})},this))}}this._data.search.str=t;this._data.search.dom=C();this._data.search.res=[];this._data.search.opn=[];r=new C.vakata.search(t,true,{caseSensitive:i.case_sensitive,fuzzy:i.fuzzy});C.each(this._model.data,function(e,t){if(t.text&&r.search(t.text).isMatch&&(!i.search_leaves_only||t.state.loaded&&t.children.length===0)){o.push(e);s=s.concat(t.parents)}});if(o.length){s=C.vakata.array_unique(s);this._search_open(s);for(a=0,l=o.length;a<l;a++){r=this.get_node(o[a],true);if(r){this._data.search.dom=this._data.search.dom.add(r)}}this._data.search.res=o;this._data.search.dom.children(".jstree-anchor").addClass("jstree-search")}this.trigger("search",{nodes:this._data.search.dom,str:t,res:this._data.search.res})};this.clear_search=function(){this._data.search.dom.children(".jstree-anchor").removeClass("jstree-search");if(this.settings.search.close_opened_onclear){this.close_node(this._data.search.opn,0)}this.trigger("clear_search",{nodes:this._data.search.dom,str:this._data.search.str,res:this._data.search.res});this._data.search.str="";this._data.search.res=[];this._data.search.opn=[];this._data.search.dom=C()};this._search_open=function(i){var n=this;C.each(i.concat([]),function(e,t){if(t==="#"){return true}try{t=C("#"+t.replace(C.jstree.idregex,"\\$&"),n.element)}catch(e){}if(t&&t.length){if(n.is_closed(t)){n._data.search.opn.push(t[0].id);n.open_node(t,function(){n._search_open(i)},0)}}})}};(function(e){e.vakata.search=function(m,e,v){v=v||{};if(v.fuzzy!==false){v.fuzzy=true}m=v.caseSensitive?m:m.toLowerCase();var y=v.location||0,r=v.distance||100,_=v.threshold||.6,b=m.length,w,x,k,t;if(b>32){v.fuzzy=false}if(v.fuzzy){w=1<<b-1;x=function(){var e={},t=0;for(t=0;t<b;t++){e[m.charAt(t)]=0}for(t=0;t<b;t++){e[m.charAt(t)]|=1<<b-t-1}return e}();k=function(e,t){var i=e/b,n=Math.abs(y-t);if(!r){return n?1:i}return i+n/r}}t=function(e){e=v.caseSensitive?e:e.toLowerCase();if(m===e||e.indexOf(m)!==-1){return{isMatch:true,score:0}}if(!v.fuzzy){return{isMatch:false,score:1}}var t,i,n=e.length,r=_,o=e.indexOf(m,y),s,a,l=b+n,c,u,d,f,h,p=1,g=[];if(o!==-1){r=Math.min(k(0,o),r);o=e.lastIndexOf(m,y+b);if(o!==-1){r=Math.min(k(0,o),r)}}o=-1;for(t=0;t<b;t++){s=0;a=l;while(s<a){if(k(t,y+a)<=r){s=a}else{l=a}a=Math.floor((l-s)/2+s)}l=a;u=Math.max(1,y-a+1);d=Math.min(y+a,n)+b;f=new Array(d+2);f[d+1]=(1<<t)-1;for(i=d;i>=u;i--){h=x[e.charAt(i-1)];if(t===0){f[i]=(f[i+1]<<1|1)&h}else{f[i]=(f[i+1]<<1|1)&h|((c[i+1]|c[i])<<1|1)|c[i+1]}if(f[i]&w){p=k(t,i-1);if(p<=r){r=p;o=i-1;g.push(o);if(o>y){u=Math.max(1,2*y-o)}else{break}}}}if(k(t+1,y)>r){break}c=f}return{isMatch:o>=0,score:p}};return e===true?{search:t}:t(e)}})(jQuery);C.jstree.defaults.sort=function(e,t){return this.get_text(e)>this.get_text(t)?1:-1};C.jstree.plugins.sort=function(e,t){this.bind=function(){t.bind.call(this);this.element.on("model.jstree",C.proxy(function(e,t){this.sort(t.parent,true)},this)).on("rename_node.jstree create_node.jstree",C.proxy(function(e,t){this.sort(t.parent||t.node.parent,false);this.redraw_node(t.parent||t.node.parent,true)},this)).on("move_node.jstree copy_node.jstree",C.proxy(function(e,t){this.sort(t.parent,false);this.redraw_node(t.parent,true)},this))};this.sort=function(e,t){var i,n;e=this.get_node(e);if(e&&e.children&&e.children.length){e.children.sort(C.proxy(this.settings.sort,this));if(t){for(i=0,n=e.children_d.length;i<n;i++){this.sort(e.children_d[i],false)}}}}};var u=false;C.jstree.defaults.state={key:"jstree",events:"changed.jstree open_node.jstree close_node.jstree",ttl:false,filter:false};C.jstree.plugins.state=function(e,t){this.bind=function(){t.bind.call(this);var i=C.proxy(function(){this.element.on(this.settings.state.events,C.proxy(function(){if(u){clearTimeout(u)}u=setTimeout(C.proxy(function(){this.save_state()},this),100)},this))},this);this.element.on("ready.jstree",C.proxy(function(e,t){this.element.one("restore_state.jstree",i);if(!this.restore_state()){i()}},this))};this.save_state=function(){var e={state:this.get_state(),ttl:this.settings.state.ttl,sec:+new Date};C.vakata.storage.set(this.settings.state.key,JSON.stringify(e))};this.restore_state=function(){var i=C.vakata.storage.get(this.settings.state.key);if(!!i){try{i=JSON.parse(i)}catch(e){return false}}if(!!i&&i.ttl&&i.sec&&+new Date-i.sec>i.ttl){return false}if(!!i&&i.state){i=i.state}if(!!i&&C.isFunction(this.settings.state.filter)){i=this.settings.state.filter.call(this,i)}if(!!i){this.element.one("set_state.jstree",function(e,t){t.instance.trigger("restore_state",{state:C.extend(true,{},i)})});this.set_state(i);return true}return false};this.clear_state=function(){return C.vakata.storage.del(this.settings.state.key)}};(function(e,t){e.vakata.storage={set:function(e,t){return window.localStorage.setItem(e,t)},get:function(e){return window.localStorage.getItem(e)},del:function(e){return window.localStorage.removeItem(e)}}})(jQuery);C.jstree.defaults.types={"#":{},default:{}};C.jstree.plugins.types=function(e,u){this.init=function(e,t){var i,n;if(t&&t.types&&t.types["default"]){for(i in t.types){if(i!=="default"&&i!=="#"&&t.types.hasOwnProperty(i)){for(n in t.types["default"]){if(t.types["default"].hasOwnProperty(n)&&t.types[i][n]===y){t.types[i][n]=t.types["default"][n]}}}}}u.init.call(this,e,t);this._model.data["#"].type="#"};this.refresh=function(e){u.refresh.call(this,e);this._model.data["#"].type="#"};this.bind=function(){this.element.on("model.jstree",C.proxy(function(e,t){var i=this._model.data,n=t.nodes,r=this.settings.types,o,s,a="default";for(o=0,s=n.length;o<s;o++){a="default";if(i[n[o]].original&&i[n[o]].original.type&&r[i[n[o]].original.type]){a=i[n[o]].original.type}if(i[n[o]].data&&i[n[o]].data.jstree&&i[n[o]].data.jstree.type&&r[i[n[o]].data.jstree.type]){a=i[n[o]].data.jstree.type}i[n[o]].type=a;if(i[n[o]].icon===true&&r[a].icon!==y){i[n[o]].icon=r[a].icon}}},this));u.bind.call(this)};this.get_json=function(e,t,i){var n,r,o=this._model.data,s=t?C.extend(true,{},t,{no_id:false}):{},a=u.get_json.call(this,e,s,i);if(a===false){return false}if(C.isArray(a)){for(n=0,r=a.length;n<r;n++){a[n].type=a[n].id&&o[a[n].id]&&o[a[n].id].type?o[a[n].id].type:"default";if(t&&t.no_id){delete a[n].id;if(a[n].li_attr&&a[n].li_attr.id){delete a[n].li_attr.id}}}}else{a.type=a.id&&o[a.id]&&o[a.id].type?o[a.id].type:"default";if(t&&t.no_id){a=this._delete_ids(a)}}return a};this._delete_ids=function(e){if(C.isArray(e)){for(var t=0,i=e.length;t<i;t++){e[t]=this._delete_ids(e[t])}return e}delete e.id;if(e.li_attr&&e.li_attr.id){delete e.li_attr.id}if(e.children&&C.isArray(e.children)){e.children=this._delete_ids(e.children)}return e};this.check=function(e,t,i,n,r){if(u.check.call(this,e,t,i,n,r)===false){return false}t=t&&t.id?t:this.get_node(t);i=i&&i.id?i:this.get_node(i);var o=t&&t.id?C.jstree.reference(t.id):null,s,a,l,c;o=o&&o._model&&o._model.data?o._model.data:null;switch(e){case"create_node":case"move_node":case"copy_node":if(e!=="move_node"||C.inArray(t.id,i.children)===-1){s=this.get_rules(i);if(s.max_children!==y&&s.max_children!==-1&&s.max_children===i.children.length){this._data.core.last_error={error:"check",plugin:"types",id:"types_01",reason:"max_children prevents function: "+e,data:JSON.stringify({chk:e,pos:n,obj:t&&t.id?t.id:false,par:i&&i.id?i.id:false})};return false}if(s.valid_children!==y&&s.valid_children!==-1&&C.inArray(t.type,s.valid_children)===-1){this._data.core.last_error={error:"check",plugin:"types",id:"types_02",reason:"valid_children prevents function: "+e,data:JSON.stringify({chk:e,pos:n,obj:t&&t.id?t.id:false,par:i&&i.id?i.id:false})};return false}if(o&&t.children_d&&t.parents){a=0;for(l=0,c=t.children_d.length;l<c;l++){a=Math.max(a,o[t.children_d[l]].parents.length)}a=a-t.parents.length+1}if(a<=0||a===y){a=1}do{if(s.max_depth!==y&&s.max_depth!==-1&&s.max_depth<a){this._data.core.last_error={error:"check",plugin:"types",id:"types_03",reason:"max_depth prevents function: "+e,data:JSON.stringify({chk:e,pos:n,obj:t&&t.id?t.id:false,par:i&&i.id?i.id:false})};return false}i=this.get_node(i.parent);s=this.get_rules(i);a++}while(i)}break}return true};this.get_rules=function(e){e=this.get_node(e);if(!e){return false}var t=this.get_type(e,true);if(t.max_depth===y){t.max_depth=-1}if(t.max_children===y){t.max_children=-1}if(t.valid_children===y){t.valid_children=-1}return t};this.get_type=function(e,t){e=this.get_node(e);return!e?false:t?C.extend({type:e.type},this.settings.types[e.type]):e.type};this.set_type=function(e,t){var i,n,r,o,s;if(C.isArray(e)){e=e.slice();for(n=0,r=e.length;n<r;n++){this.set_type(e[n],t)}return true}i=this.settings.types;e=this.get_node(e);if(!i[t]||!e){return false}o=e.type;s=this.get_icon(e);e.type=t;if(s===true||i[o]&&i[o].icon&&s===i[o].icon){this.set_icon(e,i[t].icon!==y?i[t].icon:true)}return true}};C.jstree.plugins.unique=function(e,u){this.check=function(e,t,i,n,r){if(u.check.call(this,e,t,i,n,r)===false){return false}t=t&&t.id?t:this.get_node(t);i=i&&i.id?i:this.get_node(i);if(!i||!i.children){return true}var o=e==="rename_node"?n:t.text,s=[],a=this._model.data,l,c;for(l=0,c=i.children.length;l<c;l++){s.push(a[i.children[l]].text)}switch(e){case"delete_node":return true;case"rename_node":case"copy_node":l=C.inArray(o,s)===-1;if(!l){this._data.core.last_error={error:"check",plugin:"unique",id:"unique_01",reason:"Child with name "+o+" already exists. Preventing: "+e,data:JSON.stringify({chk:e,pos:n,obj:t&&t.id?t.id:false,par:i&&i.id?i.id:false})}}return l;case"move_node":l=t.parent===i.id||C.inArray(o,s)===-1;if(!l){this._data.core.last_error={error:"check",plugin:"unique",id:"unique_01",reason:"Child with name "+o+" already exists. Preventing: "+e,data:JSON.stringify({chk:e,pos:n,obj:t&&t.id?t.id:false,par:i&&i.id?i.id:false})}}return l}return true}};var d=document.createElement("DIV");d.setAttribute("unselectable","on");d.className="jstree-wholerow";d.innerHTML="&#160;";C.jstree.plugins.wholerow=function(e,r){this.bind=function(){r.bind.call(this);this.element.on("loading",C.proxy(function(){d.style.height=this._data.core.li_height+"px"},this)).on("ready.jstree set_state.jstree",C.proxy(function(){this.hide_dots()},this)).on("ready.jstree",C.proxy(function(){this.get_container_ul().addClass("jstree-wholerow-ul")},this)).on("deselect_all.jstree",C.proxy(function(e,t){this.element.find(".jstree-wholerow-clicked").removeClass("jstree-wholerow-clicked")},this)).on("changed.jstree",C.proxy(function(e,t){this.element.find(".jstree-wholerow-clicked").removeClass("jstree-wholerow-clicked");var i=false,n,r;for(n=0,r=t.selected.length;n<r;n++){i=this.get_node(t.selected[n],true);if(i&&i.length){i.children(".jstree-wholerow").addClass("jstree-wholerow-clicked")}}},this)).on("open_node.jstree",C.proxy(function(e,t){this.get_node(t.node,true).find(".jstree-clicked").parent().children(".jstree-wholerow").addClass("jstree-wholerow-clicked")},this)).on("hover_node.jstree dehover_node.jstree",C.proxy(function(e,t){this.get_node(t.node,true).children(".jstree-wholerow")[e.type==="hover_node"?"addClass":"removeClass"]("jstree-wholerow-hovered")},this)).on("contextmenu.jstree",".jstree-wholerow",C.proxy(function(e){e.preventDefault();var t=C.Event("contextmenu",{metaKey:e.metaKey,ctrlKey:e.ctrlKey,altKey:e.altKey,shiftKey:e.shiftKey,pageX:e.pageX,pageY:e.pageY});C(e.currentTarget).closest(".jstree-node").children(".jstree-anchor:eq(0)").trigger(t)},this)).on("click.jstree",".jstree-wholerow",function(e){e.stopImmediatePropagation();var t=C.Event("click",{metaKey:e.metaKey,ctrlKey:e.ctrlKey,altKey:e.altKey,shiftKey:e.shiftKey});C(e.currentTarget).closest(".jstree-node").children(".jstree-anchor:eq(0)").trigger(t).focus()}).on("click.jstree",".jstree-leaf > .jstree-ocl",C.proxy(function(e){e.stopImmediatePropagation();var t=C.Event("click",{metaKey:e.metaKey,ctrlKey:e.ctrlKey,altKey:e.altKey,shiftKey:e.shiftKey});C(e.currentTarget).closest(".jstree-node").children(".jstree-anchor:eq(0)").trigger(t).focus()},this)).on("mouseover.jstree",".jstree-wholerow, .jstree-icon",C.proxy(function(e){e.stopImmediatePropagation();this.hover_node(e.currentTarget);return false},this)).on("mouseleave.jstree",".jstree-node",C.proxy(function(e){this.dehover_node(e.currentTarget)},this))};this.teardown=function(){if(this.settings.wholerow){this.element.find(".jstree-wholerow").remove()}r.teardown.call(this)};this.redraw_node=function(e,t,i){e=r.redraw_node.call(this,e,t,i);if(e){var n=d.cloneNode(true);if(C.inArray(e.id,this._data.core.selected)!==-1){n.className+=" jstree-wholerow-clicked"}e.insertBefore(n,e.childNodes[0])}return e}}});(function(e,t){if(typeof define==="function"&&define.amd){define(t)}else{e.Dragdealer=t()}})(this,function(){var e=function(e,t){this.bindMethods();this.options=this.applyDefaults(t||{});this.wrapper=this.getWrapperElement(e);if(!this.wrapper){return}this.handle=this.getHandleElement(this.wrapper,this.options.handleClass);if(!this.handle){return}this.init();this.bindEventListeners()};e.prototype={defaults:{disabled:false,horizontal:true,vertical:false,slide:true,steps:0,snap:false,loose:false,speed:.1,xPrecision:0,yPrecision:0,handleClass:"handle",css3:true,requestAnimationFrame:false,activeClass:"active",tapping:true},init:function(){if(this.options.css3){u(this.handle)}this.value={prev:[-1,-1],current:[this.options.x||0,this.options.y||0],target:[this.options.x||0,this.options.y||0]};this.offset={wrapper:[0,0],mouse:[0,0],prev:[-999999,-999999],current:[0,0],target:[0,0]};this.change=[0,0];this.stepRatios=this.calculateStepRatios();this.activity=false;this.dragging=false;this.tapping=false;this.reflow();if(this.options.disabled){this.disable()}},applyDefaults:function(e){for(var t in this.defaults){if(!e.hasOwnProperty(t)){e[t]=this.defaults[t]}}return e},getWrapperElement:function(e){if(typeof e=="string"){return document.getElementById(e)}else{return e}},getHandleElement:function(e,t){var i,n,r;if(e.getElementsByClassName){i=e.getElementsByClassName(t);if(i.length>0){return i[0]}}else{n=new RegExp("(^|\\s)"+t+"(\\s|$)");i=e.getElementsByTagName("*");for(r=0;r<i.length;r++){if(n.test(i[r].className)){return i[r]}}}},calculateStepRatios:function(){var e=[];if(this.options.steps>1){for(var t=0;t<=this.options.steps-1;t++){e[t]=t/(this.options.steps-1)}}return e},setWrapperOffset:function(){this.offset.wrapper=a.get(this.wrapper)},calculateBounds:function(){var e={top:this.options.top||0,bottom:-(this.options.bottom||0)+this.wrapper.offsetHeight,left:this.options.left||0,right:-(this.options.right||0)+this.wrapper.offsetWidth};e.availWidth=e.right-e.left-this.handle.offsetWidth;e.availHeight=e.bottom-e.top-this.handle.offsetHeight;return e},calculateValuePrecision:function(){var e=this.options.xPrecision||Math.abs(this.bounds.availWidth),t=this.options.yPrecision||Math.abs(this.bounds.availHeight);return[e?1/e:0,t?1/t:0]},bindMethods:function(){this.animateWithRequestAnimationFrame=t(this.animateWithRequestAnimationFrame,this);this.animate=t(this.animate,this);this.onHandleMouseDown=t(this.onHandleMouseDown,this);this.onHandleTouchStart=t(this.onHandleTouchStart,this);this.onDocumentMouseMove=t(this.onDocumentMouseMove,this);this.onWrapperTouchMove=t(this.onWrapperTouchMove,this);this.onWrapperMouseDown=t(this.onWrapperMouseDown,this);this.onWrapperTouchStart=t(this.onWrapperTouchStart,this);this.onDocumentMouseUp=t(this.onDocumentMouseUp,this);this.onDocumentTouchEnd=t(this.onDocumentTouchEnd,this);this.onHandleClick=t(this.onHandleClick,this);this.onWindowResize=t(this.onWindowResize,this)},bindEventListeners:function(){i(this.handle,"mousedown",this.onHandleMouseDown);i(this.handle,"touchstart",this.onHandleTouchStart);i(document,"mousemove",this.onDocumentMouseMove);i(this.wrapper,"touchmove",this.onWrapperTouchMove);i(this.wrapper,"mousedown",this.onWrapperMouseDown);i(this.wrapper,"touchstart",this.onWrapperTouchStart);i(document,"mouseup",this.onDocumentMouseUp);i(document,"touchend",this.onDocumentTouchEnd);i(this.handle,"click",this.onHandleClick);i(window,"resize",this.onWindowResize);this.animate(false,true);if(this.options.requestAnimationFrame){this.interval=f(this.animateWithRequestAnimationFrame)}else{this.timeOffset=25;this.interval=setInterval(this.animate,this.timeOffset)}},unbindEventListeners:function(){n(this.handle,"mousedown",this.onHandleMouseDown);n(this.handle,"touchstart",this.onHandleTouchStart);n(document,"mousemove",this.onDocumentMouseMove);n(this.wrapper,"touchmove",this.onWrapperTouchMove);n(this.wrapper,"mousedown",this.onWrapperMouseDown);n(this.wrapper,"touchstart",this.onWrapperTouchStart);n(document,"mouseup",this.onDocumentMouseUp);n(document,"touchend",this.onDocumentTouchEnd);n(this.handle,"click",this.onHandleClick);n(window,"resize",this.onWindowResize);if(this.options.requestAnimationFrame){h(this.interval)}else{clearInterval(this.interval)}},onHandleMouseDown:function(e){s.refresh(e);r(e);o(e);this.activity=false;this.startDrag()},onHandleTouchStart:function(e){s.refresh(e);o(e);this.activity=false;this.startDrag()},onDocumentMouseMove:function(e){s.refresh(e);if(this.dragging){this.activity=true}},onWrapperTouchMove:function(e){s.refresh(e);if(!this.activity&&this.draggingOnDisabledAxis()){if(this.dragging){this.stopDrag()}return}r(e);this.activity=true},onWrapperMouseDown:function(e){s.refresh(e);r(e);this.startTap()},onWrapperTouchStart:function(e){s.refresh(e);r(e);this.startTap()},onDocumentMouseUp:function(e){this.stopDrag();this.stopTap()},onDocumentTouchEnd:function(e){this.stopDrag();this.stopTap()},onHandleClick:function(e){if(this.activity){r(e);o(e)}},onWindowResize:function(e){this.reflow()},enable:function(){this.disabled=false;this.handle.className=this.handle.className.replace(/\s?disabled/g,"")},disable:function(){this.disabled=true;this.handle.className+=" disabled"},reflow:function(){this.setWrapperOffset();this.bounds=this.calculateBounds();this.valuePrecision=this.calculateValuePrecision();this.updateOffsetFromValue()},getStep:function(){return[this.getStepNumber(this.value.target[0]),this.getStepNumber(this.value.target[1])]},getValue:function(){return this.value.target},setStep:function(e,t,i){this.setValue(this.options.steps&&e>1?(e-1)/(this.options.steps-1):0,this.options.steps&&t>1?(t-1)/(this.options.steps-1):0,i)},setValue:function(e,t,i){this.setTargetValue([e,t||0]);if(i){this.groupCopy(this.value.current,this.value.target);this.updateOffsetFromValue();this.callAnimationCallback()}},startTap:function(){if(this.disabled||!this.options.tapping){return}this.tapping=true;this.setWrapperOffset();this.setTargetValueByOffset([s.x-this.offset.wrapper[0]-this.handle.offsetWidth/2,s.y-this.offset.wrapper[1]-this.handle.offsetHeight/2])},stopTap:function(){if(this.disabled||!this.tapping){return}this.tapping=false;this.setTargetValue(this.value.current)},startDrag:function(){if(this.disabled){return}this.dragging=true;this.setWrapperOffset();this.offset.mouse=[s.x-a.get(this.handle)[0],s.y-a.get(this.handle)[1]];if(!this.wrapper.className.match(this.options.activeClass)){this.wrapper.className+=" "+this.options.activeClass}},stopDrag:function(){if(this.disabled||!this.dragging){return}this.dragging=false;var e=this.groupClone(this.value.current);if(this.options.slide){var t=this.change;e[0]+=t[0]*4;e[1]+=t[1]*4}this.setTargetValue(e);this.wrapper.className=this.wrapper.className.replace(" "+this.options.activeClass,"")},callAnimationCallback:function(){var e=this.value.current;if(this.options.snap&&this.options.steps>1){e=this.getClosestSteps(e)}if(!this.groupCompare(e,this.value.prev)){if(typeof this.options.animationCallback=="function"){this.options.animationCallback.call(this,e[0],e[1])}this.groupCopy(this.value.prev,e)}},callTargetCallback:function(){if(typeof this.options.callback=="function"){this.options.callback.call(this,this.value.target[0],this.value.target[1])}},animateWithRequestAnimationFrame:function(e){if(e){this.timeOffset=this.timeStamp?e-this.timeStamp:0;this.timeStamp=e}else{this.timeOffset=25}this.animate();this.interval=f(this.animateWithRequestAnimationFrame)},animate:function(e,t){if(e&&!this.dragging){return}if(this.dragging){var i=this.groupClone(this.value.target);var n=[s.x-this.offset.wrapper[0]-this.offset.mouse[0],s.y-this.offset.wrapper[1]-this.offset.mouse[1]];this.setTargetValueByOffset(n,this.options.loose);this.change=[this.value.target[0]-i[0],this.value.target[1]-i[1]]}if(this.dragging||t){this.groupCopy(this.value.current,this.value.target)}if(this.dragging||this.glide()||t){this.updateOffsetFromValue();this.callAnimationCallback()}},glide:function(){var e=[this.value.target[0]-this.value.current[0],this.value.target[1]-this.value.current[1]];if(!e[0]&&!e[1]){return false}if(Math.abs(e[0])>this.valuePrecision[0]||Math.abs(e[1])>this.valuePrecision[1]){this.value.current[0]+=e[0]*this.options.speed*this.timeOffset/25;this.value.current[1]+=e[1]*this.options.speed*this.timeOffset/25}else{this.groupCopy(this.value.current,this.value.target)}return true},updateOffsetFromValue:function(){if(!this.options.snap){this.offset.current=this.getOffsetsByRatios(this.value.current)}else{this.offset.current=this.getOffsetsByRatios(this.getClosestSteps(this.value.current))}if(!this.groupCompare(this.offset.current,this.offset.prev)){this.renderHandlePosition();this.groupCopy(this.offset.prev,this.offset.current)}},renderHandlePosition:function(){var e="";if(this.options.css3&&l.transform){if(this.options.horizontal){e+="translateX("+this.offset.current[0]+"px)"}if(this.options.vertical){e+=" translateY("+this.offset.current[1]+"px)"}this.handle.style[l.transform]=e;return}if(this.options.horizontal){this.handle.style.left=this.offset.current[0]+"px"}if(this.options.vertical){this.handle.style.top=this.offset.current[1]+"px"}},setTargetValue:function(e,t){var i=t?this.getLooseValue(e):this.getProperValue(e);this.groupCopy(this.value.target,i);this.offset.target=this.getOffsetsByRatios(i);this.callTargetCallback()},setTargetValueByOffset:function(e,t){var i=this.getRatiosByOffsets(e);var n=t?this.getLooseValue(i):this.getProperValue(i);this.groupCopy(this.value.target,n);this.offset.target=this.getOffsetsByRatios(n)},getLooseValue:function(e){var t=this.getProperValue(e);return[t[0]+(e[0]-t[0])/4,t[1]+(e[1]-t[1])/4]},getProperValue:function(e){var t=this.groupClone(e);t[0]=Math.max(t[0],0);t[1]=Math.max(t[1],0);t[0]=Math.min(t[0],1);t[1]=Math.min(t[1],1);if(!this.dragging&&!this.tapping||this.options.snap){if(this.options.steps>1){t=this.getClosestSteps(t)}}return t},getRatiosByOffsets:function(e){return[this.getRatioByOffset(e[0],this.bounds.availWidth,this.bounds.left),this.getRatioByOffset(e[1],this.bounds.availHeight,this.bounds.top)]},getRatioByOffset:function(e,t,i){return t?(e-i)/t:0},getOffsetsByRatios:function(e){return[this.getOffsetByRatio(e[0],this.bounds.availWidth,this.bounds.left),this.getOffsetByRatio(e[1],this.bounds.availHeight,this.bounds.top)]},getOffsetByRatio:function(e,t,i){return Math.round(e*t)+i},getStepNumber:function(e){return this.getClosestStep(e)*(this.options.steps-1)+1},getClosestSteps:function(e){return[this.getClosestStep(e[0]),this.getClosestStep(e[1])]},getClosestStep:function(e){var t=0;var i=1;for(var n=0;n<=this.options.steps-1;n++){if(Math.abs(this.stepRatios[n]-e)<i){i=Math.abs(this.stepRatios[n]-e);t=n}}return this.stepRatios[t]},groupCompare:function(e,t){return e[0]==t[0]&&e[1]==t[1]},groupCopy:function(e,t){e[0]=t[0];e[1]=t[1]},groupClone:function(e){return[e[0],e[1]]},draggingOnDisabledAxis:function(){return!this.options.horizontal&&s.xDiff>s.yDiff||!this.options.vertical&&s.yDiff>s.xDiff}};var t=function(e,t){return function(){return e.apply(t,arguments)}};var i=function(e,t,i){if(e.addEventListener){e.addEventListener(t,i,false)}else if(e.attachEvent){e.attachEvent("on"+t,i)}};var n=function(e,t,i){if(e.removeEventListener){e.removeEventListener(t,i,false)}else if(e.detachEvent){e.detachEvent("on"+t,i)}};var r=function(e){if(!e){e=window.event}if(e.preventDefault){e.preventDefault()}e.returnValue=false};var o=function(e){if(!e){e=window.event}if(e.stopPropagation){e.stopPropagation()}e.cancelBubble=true};var s={x:0,y:0,xDiff:0,yDiff:0,refresh:function(e){if(!e){e=window.event}if(e.type=="mousemove"){this.set(e)}else if(e.touches){this.set(e.touches[0])}},set:function(e){var t=this.x,i=this.y;if(e.clientX||e.clientY){this.x=e.clientX;this.y=e.clientY}else if(e.pageX||e.pageY){this.x=e.pageX-document.body.scrollLeft-document.documentElement.scrollLeft;this.y=e.pageY-document.body.scrollTop-document.documentElement.scrollTop}this.xDiff=Math.abs(this.x-t);this.yDiff=Math.abs(this.y-i)}};var a={get:function(e){var t={left:0,top:0};if(e.getBoundingClientRect!==undefined){t=e.getBoundingClientRect()}return[t.left,t.top]}};var l={transform:c("transform"),perspective:c("perspective"),backfaceVisibility:c("backfaceVisibility")};function c(e){var t="Webkit Moz ms O".split(" "),i=document.documentElement.style;if(i[e]!==undefined)return e;e=e.charAt(0).toUpperCase()+e.substr(1);for(var n=0;n<t.length;n++){if(i[t[n]+e]!==undefined){return t[n]+e}}}function u(e){if(l.backfaceVisibility&&l.perspective){e.style[l.perspective]="1000px";e.style[l.backfaceVisibility]="hidden"}}var d=["webkit","moz"];var f=window.requestAnimationFrame;var h=window.cancelAnimationFrame;for(var p=0;p<d.length&&!f;++p){f=window[d[p]+"RequestAnimationFrame"];h=window[d[p]+"CancelAnimationFrame"]||window[d[p]+"CancelRequestAnimationFrame"]}if(!f){f=function(e){return setTimeout(e,25)};h=clearTimeout}return e});window.giscloudNamespace="giscloud";(function(e){var t,i,n;t=["assert","count","debug","dir","dirxml","error","exception","group","groupCollapsed","groupEnd","info","log","markTimeline","profile","profileEnd","time","timeEnd","trace","warn"];i=function(){};do{n=t.pop();if(!e[n]){e[n]=i}}while(t.length>0);window.console=e})(window.console||{});(function(window){var namespace=window.giscloudNamespace,giscloud=window[namespace]={};delete window.giscloudNamespace;(function(){var S,r,c,P,a,s,v,g,u,d,f,l,re,E,h,n,e,i,t,oe,y,o,O,p,m,_,b,se,w,x,k,C,L,T,j,M,I,D,A,N,R,z,H,F,W,B,G,ae,q,$,le,U,V,Y,Z,ce,X,J,Q,K,ee,te,ie,ne,ue,de,fe,he,pe,ge,me,ve,ye,_e,be,we,xe,ke,Ce,Le,Te,je,Me=[].slice;ke=function(){var i,e,t,n,r;for(i={},r="Boolean Number String Function Array Date RegExp Undefined Null".split(" "),n=0,e=r.length;n<e;n++)t=r[n],i["[object "+t+"]"]=t.toLowerCase();return function(e){var t;return t=Object.prototype.toString.call(e),i[t]||"object"}}(),G=function(e,t,i){return null==t&&(t=0),null==i&&(i=1),e<t&&(e=t),e>i&&(e=i),e},Ce=function(e){return e.length>=3?Array.prototype.slice.call(e):e[0]},y=function(e){var t,i;for(e._clipped=!1,e._unclipped=e.slice(0),t=i=0;i<3;t=++i)t<3?((e[t]<0||e[t]>255)&&(e._clipped=!0),e[t]<0&&(e[t]=0),e[t]>255&&(e[t]=255)):3===t&&(e[t]<0&&(e[t]=0),e[t]>1&&(e[t]=1));return e._clipped||delete e._unclipped,e},P=Math.PI,ye=Math.round,O=Math.cos,se=Math.floor,ce=Math.pow,ae=Math.log,be=Math.sin,we=Math.sqrt,E=Math.atan2,le=Math.max,re=Math.abs,v=2*P,a=P/3,r=P/180,s=180/P,oe=function(){return arguments[0]instanceof S?arguments[0]:function(e,t,i){i.prototype=e.prototype;var n=new i,r=e.apply(n,t);return Object(r)===r?r:n}(S,arguments,function(){})},oe.default=oe,l=[],"undefined"!=typeof module&&null!==module&&null!=module.exports&&(module.exports=oe),"function"==typeof define&&define.amd?define([],function(){return oe}):(ve="undefined"!=typeof exports&&null!==exports?exports:this,ve.chroma=oe),oe.version="1.4.1",f={},u=[],d=!1,S=function(){function e(){var e,t,i,n,r,o,s,a,l;for(o=this,t=[],a=0,n=arguments.length;a<n;a++)null!=(e=arguments[a])&&t.push(e);if(t.length>1&&(s=t[t.length-1]),null!=f[s])o._rgb=y(f[s](Ce(t.slice(0,-1))));else{for(d||(u=u.sort(function(e,t){return t.p-e.p}),d=!0),l=0,r=u.length;l<r&&(i=u[l],!(s=i.test.apply(i,t)));l++);s&&(o._rgb=y(f[s].apply(f,t)))}null==o._rgb&&console.warn("unknown format: "+t),null==o._rgb&&(o._rgb=[0,0,0]),3===o._rgb.length&&o._rgb.push(1)}return e.prototype.toString=function(){return this.hex()},e}(),oe._input=f,oe.brewer=i={OrRd:["#fff7ec","#fee8c8","#fdd49e","#fdbb84","#fc8d59","#ef6548","#d7301f","#b30000","#7f0000"],PuBu:["#fff7fb","#ece7f2","#d0d1e6","#a6bddb","#74a9cf","#3690c0","#0570b0","#045a8d","#023858"],BuPu:["#f7fcfd","#e0ecf4","#bfd3e6","#9ebcda","#8c96c6","#8c6bb1","#88419d","#810f7c","#4d004b"],Oranges:["#fff5eb","#fee6ce","#fdd0a2","#fdae6b","#fd8d3c","#f16913","#d94801","#a63603","#7f2704"],BuGn:["#f7fcfd","#e5f5f9","#ccece6","#99d8c9","#66c2a4","#41ae76","#238b45","#006d2c","#00441b"],YlOrBr:["#ffffe5","#fff7bc","#fee391","#fec44f","#fe9929","#ec7014","#cc4c02","#993404","#662506"],YlGn:["#ffffe5","#f7fcb9","#d9f0a3","#addd8e","#78c679","#41ab5d","#238443","#006837","#004529"],Reds:["#fff5f0","#fee0d2","#fcbba1","#fc9272","#fb6a4a","#ef3b2c","#cb181d","#a50f15","#67000d"],RdPu:["#fff7f3","#fde0dd","#fcc5c0","#fa9fb5","#f768a1","#dd3497","#ae017e","#7a0177","#49006a"],Greens:["#f7fcf5","#e5f5e0","#c7e9c0","#a1d99b","#74c476","#41ab5d","#238b45","#006d2c","#00441b"],YlGnBu:["#ffffd9","#edf8b1","#c7e9b4","#7fcdbb","#41b6c4","#1d91c0","#225ea8","#253494","#081d58"],Purples:["#fcfbfd","#efedf5","#dadaeb","#bcbddc","#9e9ac8","#807dba","#6a51a3","#54278f","#3f007d"],GnBu:["#f7fcf0","#e0f3db","#ccebc5","#a8ddb5","#7bccc4","#4eb3d3","#2b8cbe","#0868ac","#084081"],Greys:["#ffffff","#f0f0f0","#d9d9d9","#bdbdbd","#969696","#737373","#525252","#252525","#000000"],YlOrRd:["#ffffcc","#ffeda0","#fed976","#feb24c","#fd8d3c","#fc4e2a","#e31a1c","#bd0026","#800026"],PuRd:["#f7f4f9","#e7e1ef","#d4b9da","#c994c7","#df65b0","#e7298a","#ce1256","#980043","#67001f"],Blues:["#f7fbff","#deebf7","#c6dbef","#9ecae1","#6baed6","#4292c6","#2171b5","#08519c","#08306b"],PuBuGn:["#fff7fb","#ece2f0","#d0d1e6","#a6bddb","#67a9cf","#3690c0","#02818a","#016c59","#014636"],Viridis:["#440154","#482777","#3f4a8a","#31678e","#26838f","#1f9d8a","#6cce5a","#b6de2b","#fee825"],Spectral:["#9e0142","#d53e4f","#f46d43","#fdae61","#fee08b","#ffffbf","#e6f598","#abdda4","#66c2a5","#3288bd","#5e4fa2"],RdYlGn:["#a50026","#d73027","#f46d43","#fdae61","#fee08b","#ffffbf","#d9ef8b","#a6d96a","#66bd63","#1a9850","#006837"],RdBu:["#67001f","#b2182b","#d6604d","#f4a582","#fddbc7","#f7f7f7","#d1e5f0","#92c5de","#4393c3","#2166ac","#053061"],PiYG:["#8e0152","#c51b7d","#de77ae","#f1b6da","#fde0ef","#f7f7f7","#e6f5d0","#b8e186","#7fbc41","#4d9221","#276419"],PRGn:["#40004b","#762a83","#9970ab","#c2a5cf","#e7d4e8","#f7f7f7","#d9f0d3","#a6dba0","#5aae61","#1b7837","#00441b"],RdYlBu:["#a50026","#d73027","#f46d43","#fdae61","#fee090","#ffffbf","#e0f3f8","#abd9e9","#74add1","#4575b4","#313695"],BrBG:["#543005","#8c510a","#bf812d","#dfc27d","#f6e8c3","#f5f5f5","#c7eae5","#80cdc1","#35978f","#01665e","#003c30"],RdGy:["#67001f","#b2182b","#d6604d","#f4a582","#fddbc7","#ffffff","#e0e0e0","#bababa","#878787","#4d4d4d","#1a1a1a"],PuOr:["#7f3b08","#b35806","#e08214","#fdb863","#fee0b6","#f7f7f7","#d8daeb","#b2abd2","#8073ac","#542788","#2d004b"],Set2:["#66c2a5","#fc8d62","#8da0cb","#e78ac3","#a6d854","#ffd92f","#e5c494","#b3b3b3"],Accent:["#7fc97f","#beaed4","#fdc086","#ffff99","#386cb0","#f0027f","#bf5b17","#666666"],Set1:["#e41a1c","#377eb8","#4daf4a","#984ea3","#ff7f00","#ffff33","#a65628","#f781bf","#999999"],Set3:["#8dd3c7","#ffffb3","#bebada","#fb8072","#80b1d3","#fdb462","#b3de69","#fccde5","#d9d9d9","#bc80bd","#ccebc5","#ffed6f"],Dark2:["#1b9e77","#d95f02","#7570b3","#e7298a","#66a61e","#e6ab02","#a6761d","#666666"],Paired:["#a6cee3","#1f78b4","#b2df8a","#33a02c","#fb9a99","#e31a1c","#fdbf6f","#ff7f00","#cab2d6","#6a3d9a","#ffff99","#b15928"],Pastel2:["#b3e2cd","#fdcdac","#cbd5e8","#f4cae4","#e6f5c9","#fff2ae","#f1e2cc","#cccccc"],Pastel1:["#fbb4ae","#b3cde3","#ccebc5","#decbe4","#fed9a6","#ffffcc","#e5d8bd","#fddaec","#f2f2f2"]},function(){var e,t;t=[];for(e in i)t.push(i[e.toLowerCase()]=i[e])}(),Le={aliceblue:"#f0f8ff",antiquewhite:"#faebd7",aqua:"#00ffff",aquamarine:"#7fffd4",azure:"#f0ffff",beige:"#f5f5dc",bisque:"#ffe4c4",black:"#000000",blanchedalmond:"#ffebcd",blue:"#0000ff",blueviolet:"#8a2be2",brown:"#a52a2a",burlywood:"#deb887",cadetblue:"#5f9ea0",chartreuse:"#7fff00",chocolate:"#d2691e",coral:"#ff7f50",cornflower:"#6495ed",cornflowerblue:"#6495ed",cornsilk:"#fff8dc",crimson:"#dc143c",cyan:"#00ffff",darkblue:"#00008b",darkcyan:"#008b8b",darkgoldenrod:"#b8860b",darkgray:"#a9a9a9",darkgreen:"#006400",darkgrey:"#a9a9a9",darkkhaki:"#bdb76b",darkmagenta:"#8b008b",darkolivegreen:"#556b2f",darkorange:"#ff8c00",darkorchid:"#9932cc",darkred:"#8b0000",darksalmon:"#e9967a",darkseagreen:"#8fbc8f",darkslateblue:"#483d8b",darkslategray:"#2f4f4f",darkslategrey:"#2f4f4f",darkturquoise:"#00ced1",darkviolet:"#9400d3",deeppink:"#ff1493",deepskyblue:"#00bfff",dimgray:"#696969",dimgrey:"#696969",dodgerblue:"#1e90ff",firebrick:"#b22222",floralwhite:"#fffaf0",forestgreen:"#228b22",fuchsia:"#ff00ff",gainsboro:"#dcdcdc",ghostwhite:"#f8f8ff",gold:"#ffd700",goldenrod:"#daa520",gray:"#808080",green:"#008000",greenyellow:"#adff2f",grey:"#808080",honeydew:"#f0fff0",hotpink:"#ff69b4",indianred:"#cd5c5c",indigo:"#4b0082",ivory:"#fffff0",khaki:"#f0e68c",laserlemon:"#ffff54",lavender:"#e6e6fa",lavenderblush:"#fff0f5",lawngreen:"#7cfc00",lemonchiffon:"#fffacd",lightblue:"#add8e6",lightcoral:"#f08080",lightcyan:"#e0ffff",lightgoldenrod:"#fafad2",lightgoldenrodyellow:"#fafad2",lightgray:"#d3d3d3",lightgreen:"#90ee90",lightgrey:"#d3d3d3",lightpink:"#ffb6c1",lightsalmon:"#ffa07a",lightseagreen:"#20b2aa",lightskyblue:"#87cefa",lightslategray:"#778899",lightslategrey:"#778899",lightsteelblue:"#b0c4de",lightyellow:"#ffffe0",lime:"#00ff00",limegreen:"#32cd32",linen:"#faf0e6",magenta:"#ff00ff",maroon:"#800000",maroon2:"#7f0000",maroon3:"#b03060",mediumaquamarine:"#66cdaa",mediumblue:"#0000cd",mediumorchid:"#ba55d3",mediumpurple:"#9370db",mediumseagreen:"#3cb371",mediumslateblue:"#7b68ee",mediumspringgreen:"#00fa9a",mediumturquoise:"#48d1cc",mediumvioletred:"#c71585",midnightblue:"#191970",mintcream:"#f5fffa",mistyrose:"#ffe4e1",moccasin:"#ffe4b5",navajowhite:"#ffdead",navy:"#000080",oldlace:"#fdf5e6",olive:"#808000",olivedrab:"#6b8e23",orange:"#ffa500",orangered:"#ff4500",orchid:"#da70d6",palegoldenrod:"#eee8aa",palegreen:"#98fb98",paleturquoise:"#afeeee",palevioletred:"#db7093",papayawhip:"#ffefd5",peachpuff:"#ffdab9",peru:"#cd853f",pink:"#ffc0cb",plum:"#dda0dd",powderblue:"#b0e0e6",purple:"#800080",purple2:"#7f007f",purple3:"#a020f0",rebeccapurple:"#663399",red:"#ff0000",rosybrown:"#bc8f8f",royalblue:"#4169e1",saddlebrown:"#8b4513",salmon:"#fa8072",sandybrown:"#f4a460",seagreen:"#2e8b57",seashell:"#fff5ee",sienna:"#a0522d",silver:"#c0c0c0",skyblue:"#87ceeb",slateblue:"#6a5acd",slategray:"#708090",slategrey:"#708090",snow:"#fffafa",springgreen:"#00ff7f",steelblue:"#4682b4",tan:"#d2b48c",teal:"#008080",thistle:"#d8bfd8",tomato:"#ff6347",turquoise:"#40e0d0",violet:"#ee82ee",wheat:"#f5deb3",white:"#ffffff",whitesmoke:"#f5f5f5",yellow:"#ffff00",yellowgreen:"#9acd32"},oe.colors=Le,z=function(){var e,t,i,n,r,o,s,a,l;return t=Ce(arguments),r=t[0],e=t[1],i=t[2],a=(r+16)/116,s=isNaN(e)?a:a+e/500,l=isNaN(i)?a:a-i/200,a=c.Yn*H(a),s=c.Xn*H(s),l=c.Zn*H(l),o=je(3.2404542*s-1.5371385*a-.4985314*l),n=je(-.969266*s+1.8760108*a+.041556*l),i=je(.0556434*s-.2040259*a+1.0572252*l),[o,n,i,t.length>3?t[3]:1]},je=function(e){return 255*(e<=.00304?12.92*e:1.055*ce(e,1/2.4)-.055)},H=function(e){return e>c.t1?e*e*e:c.t2*(e-c.t0)},c={Kn:18,Xn:.95047,Yn:1,Zn:1.08883,t0:.137931034,t1:.206896552,t2:.12841855,t3:.008856452},ne=function(){var e,t,i,n,r,o,s,a;return n=Ce(arguments),i=n[0],t=n[1],e=n[2],r=pe(i,t,e),o=r[0],s=r[1],a=r[2],[116*s-16,500*(o-s),200*(s-a)]},ge=function(e){return(e/=255)<=.04045?e/12.92:ce((e+.055)/1.055,2.4)},Te=function(e){return e>c.t3?ce(e,1/3):e/c.t2+c.t0},pe=function(){var e,t,i,n,r,o,s;return n=Ce(arguments),i=n[0],t=n[1],e=n[2],i=ge(i),t=ge(t),e=ge(e),r=Te((.4124564*i+.3575761*t+.1804375*e)/c.Xn),o=Te((.2126729*i+.7151522*t+.072175*e)/c.Yn),s=Te((.0193339*i+.119192*t+.9503041*e)/c.Zn),[r,o,s]},oe.lab=function(){return function(e,t,i){i.prototype=e.prototype;var n=new i,r=e.apply(n,t);return Object(r)===r?r:n}(S,Me.call(arguments).concat(["lab"]),function(){})},f.lab=z,S.prototype.lab=function(){return ne(this._rgb)},h=function(n){var e,t,i,r,o,s,a,l,c,u,d;return n=function(){var e,t,i;for(i=[],t=0,e=n.length;t<e;t++)r=n[t],i.push(oe(r));return i}(),2===n.length?(c=function(){var e,t,i;for(i=[],t=0,e=n.length;t<e;t++)r=n[t],i.push(r.lab());return i}(),o=c[0],s=c[1],e=function(i){var n,e;return e=function(){var e,t;for(t=[],n=e=0;e<=2;n=++e)t.push(o[n]+i*(s[n]-o[n]));return t}(),oe.lab.apply(oe,e)}):3===n.length?(u=function(){var e,t,i;for(i=[],t=0,e=n.length;t<e;t++)r=n[t],i.push(r.lab());return i}(),o=u[0],s=u[1],a=u[2],e=function(i){var n,e;return e=function(){var e,t;for(t=[],n=e=0;e<=2;n=++e)t.push((1-i)*(1-i)*o[n]+2*(1-i)*i*s[n]+i*i*a[n]);return t}(),oe.lab.apply(oe,e)}):4===n.length?(d=function(){var e,t,i;for(i=[],t=0,e=n.length;t<e;t++)r=n[t],i.push(r.lab());return i}(),o=d[0],s=d[1],a=d[2],l=d[3],e=function(i){var n,e;return e=function(){var e,t;for(t=[],n=e=0;e<=2;n=++e)t.push((1-i)*(1-i)*(1-i)*o[n]+3*(1-i)*(1-i)*i*s[n]+3*(1-i)*i*i*a[n]+i*i*i*l[n]);return t}(),oe.lab.apply(oe,e)}):5===n.length&&(t=h(n.slice(0,3)),i=h(n.slice(2,5)),e=function(e){return e<.5?t(2*e):i(2*(e-.5))}),e},oe.bezier=function(e){var t;return t=h(e),t.scale=function(){return oe.scale(t)},t},oe.cubehelix=function(u,d,f,h,p){var g,m,t;return null==u&&(u=300),null==d&&(d=-1.5),null==f&&(f=1),null==h&&(h=1),null==p&&(p=[0,1]),g=0,"array"===ke(p)?m=p[1]-p[0]:(m=0,p=[p,p]),t=function(e){var t,i,n,r,o,s,a,l,c;return t=v*((u+120)/360+d*e),a=ce(p[0]+m*e,h),s=0!==g?f[0]+e*g:f,i=s*a*(1-a)/2,r=O(t),c=be(t),l=a+i*(-.14861*r+1.78277*c),o=a+i*(-.29227*r-.90649*c),n=a+i*(1.97294*r),oe(y([255*l,255*o,255*n,1]))},t.start=function(e){return null==e?u:(u=e,t)},t.rotations=function(e){return null==e?d:(d=e,t)},t.gamma=function(e){return null==e?h:(h=e,t)},t.hue=function(e){return null==e?f:(f=e,"array"===ke(f)?0===(g=f[1]-f[0])&&(f=f[1]):g=0,t)},t.lightness=function(e){return null==e?p:("array"===ke(e)?(p=e,m=e[1]-e[0]):(p=[e,e],m=0),t)},t.scale=function(){return oe.scale(t)},t.hue(f),t},oe.random=function(){var e,t,i;for(t="0123456789abcdef",e="#",i=0;i<6;++i)e+=t.charAt(se(16*Math.random()));return new S(e)},l=[],j=function(e,t,i,n){var r,o,s,a;for(null==i&&(i=.5),null==n&&(n="rgb"),"object"!==ke(e)&&(e=oe(e)),"object"!==ke(t)&&(t=oe(t)),s=0,o=l.length;s<o;s++)if(r=l[s],n===r[0]){a=r[1](e,t,i,n);break}if(null==a)throw"color mode "+n+" is not supported";return a.alpha(e.alpha()+i*(t.alpha()-e.alpha()))},oe.interpolate=j,S.prototype.interpolate=function(e,t,i){return j(this,e,t,i)},oe.mix=j,S.prototype.mix=S.prototype.interpolate,f.rgb=function(){var e,t,i,n;t=Ce(arguments),i=[];for(e in t)n=t[e],i.push(n);return i},oe.rgb=function(){return function(e,t,i){i.prototype=e.prototype;var n=new i,r=e.apply(n,t);return Object(r)===r?r:n}(S,Me.call(arguments).concat(["rgb"]),function(){})},S.prototype.rgb=function(e){return null==e&&(e=!0),e?this._rgb.map(Math.round).slice(0,3):this._rgb.slice(0,3)},S.prototype.rgba=function(e){return null==e&&(e=!0),e?[Math.round(this._rgb[0]),Math.round(this._rgb[1]),Math.round(this._rgb[2]),this._rgb[3]]:this._rgb.slice(0)},u.push({p:3,test:function(e){var t;return t=Ce(arguments),"array"===ke(t)&&3===t.length?"rgb":4===t.length&&"number"===ke(t[3])&&t[3]>=0&&t[3]<=1?"rgb":void 0}}),f.lrgb=f.rgb,D=function(e,t,i,n){var r,o;return r=e._rgb,o=t._rgb,new S(we(ce(r[0],2)*(1-i)+ce(o[0],2)*i),we(ce(r[1],2)*(1-i)+ce(o[1],2)*i),we(ce(r[2],2)*(1-i)+ce(o[2],2)*i),n)},g=function(e){var t,i,n,r,o,s;for(i=1/e.length,s=[0,0,0,0],r=0,n=e.length;r<n;r++)t=e[r],o=t._rgb,s[0]+=ce(o[0],2)*i,s[1]+=ce(o[1],2)*i,s[2]+=ce(o[2],2)*i,s[3]+=o[3]*i;return s[0]=we(s[0]),s[1]=we(s[1]),s[2]=we(s[2]),s[3]>1&&(s[3]=1),new S(y(s))},l.push(["lrgb",D]),oe.average=function(e,t){var i,n,r,o,s,a,l,c,u,d,f,h,p;if(null==t&&(t="rgb"),u=e.length,e=e.map(function(e){return oe(e)}),l=e.splice(0,1)[0],"lrgb"===t)return g(e);h=l.get(t),o=[],s=0,a=0;for(c in h)h[c]=h[c]||0,o.push(isNaN(h[c])?0:1),"h"!==t.charAt(c)||isNaN(h[c])||(i=h[c]/180*P,s+=O(i),a+=be(i));for(n=l.alpha(),f=0,d=e.length;f<d;f++){r=e[f],p=r.get(t),n+=r.alpha();for(c in h)isNaN(p[c])||(o[c]+=1,"h"===t.charAt(c)?(i=p[c]/180*P,s+=O(i),a+=be(i)):h[c]+=p[c])}for(c in h)if("h"===t.charAt(c)){for(i=E(a/o[c],s/o[c])/P*180;i<0;)i+=360;for(;i>=360;)i-=360;h[c]=i}else h[c]=h[c]/o[c];return oe(h,t).alpha(n/u)},x=function(e){var t,i,n,r,o,s;if(e.match(/^#?([A-Fa-f0-9]{6}|[A-Fa-f0-9]{3})$/))return 4!==e.length&&7!==e.length||(e=e.substr(1)),3===e.length&&(e=e.split(""),e=e[0]+e[0]+e[1]+e[1]+e[2]+e[2]),s=parseInt(e,16),r=s>>16,n=s>>8&255,i=255&s,[r,n,i,1];if(e.match(/^#?([A-Fa-f0-9]{8})$/))return 9===e.length&&(e=e.substr(1)),s=parseInt(e,16),r=s>>24&255,n=s>>16&255,i=s>>8&255,t=ye((255&s)/255*100)/100,[r,n,i,t];if(null!=f.css&&(o=f.css(e)))return o;throw"unknown color: "+e},K=function(e,t){var i,n,r,o,s,a,l;return null==t&&(t="auto"),s=e[0],r=e[1],n=e[2],i=e[3],"auto"===t&&(t=i<1?"rgba":"rgb"),s=Math.round(s),r=Math.round(r),n=Math.round(n),l=s<<16|r<<8|n,a="000000"+l.toString(16),a=a.substr(a.length-6),o="0"+ye(255*i).toString(16),o=o.substr(o.length-2),"#"+function(){switch(t.toLowerCase()){case"rgba":return a+o;case"argb":return o+a;default:return a}}()},f.hex=function(e){return x(e)},oe.hex=function(){return function(e,t,i){i.prototype=e.prototype;var n=new i,r=e.apply(n,t);return Object(r)===r?r:n}(S,Me.call(arguments).concat(["hex"]),function(){})},S.prototype.hex=function(e){return null==e&&(e="auto"),K(this._rgb,e)},u.push({p:4,test:function(e){if(1===arguments.length&&"string"===ke(e))return"hex"}}),L=function(){var e,t,i,n,r,o,s,a,l,c,u,d,f,h;if(e=Ce(arguments),r=e[0],u=e[1],s=e[2],0===u)l=n=t=255*s;else{for(h=[0,0,0],i=[0,0,0],f=s<.5?s*(1+u):s+u-s*u,d=2*s-f,r/=360,h[0]=r+1/3,h[1]=r,h[2]=r-1/3,o=a=0;a<=2;o=++a)h[o]<0&&(h[o]+=1),h[o]>1&&(h[o]-=1),6*h[o]<1?i[o]=d+6*(f-d)*h[o]:2*h[o]<1?i[o]=f:3*h[o]<2?i[o]=d+(f-d)*(2/3-h[o])*6:i[o]=d;c=[ye(255*i[0]),ye(255*i[1]),ye(255*i[2])],l=c[0],n=c[1],t=c[2]}return e.length>3?[l,n,t,e[3]]:[l,n,t]},te=function(e,t,i){var n,r,o,s,a;return void 0!==e&&e.length>=3&&(s=e,e=s[0],t=s[1],i=s[2]),e/=255,t/=255,i/=255,o=Math.min(e,t,i),le=Math.max(e,t,i),r=(le+o)/2,le===o?(a=0,n=Number.NaN):a=r<.5?(le-o)/(le+o):(le-o)/(2-le-o),e===le?n=(t-i)/(le-o):t===le?n=2+(i-e)/(le-o):i===le&&(n=4+(e-t)/(le-o)),n*=60,n<0&&(n+=360),[n,a,r]},oe.hsl=function(){return function(e,t,i){i.prototype=e.prototype;var n=new i,r=e.apply(n,t);return Object(r)===r?r:n}(S,Me.call(arguments).concat(["hsl"]),function(){})},f.hsl=L,S.prototype.hsl=function(){return te(this._rgb)},T=function(){var e,t,i,n,r,o,s,a,l,c,u,d,f,h,p,g,m,v;if(e=Ce(arguments),r=e[0],g=e[1],v=e[2],v*=255,0===g)l=n=t=v;else switch(360===r&&(r=0),r>360&&(r-=360),r<0&&(r+=360),r/=60,o=se(r),i=r-o,s=v*(1-g),a=v*(1-g*i),m=v*(1-g*(1-i)),o){case 0:c=[v,m,s],l=c[0],n=c[1],t=c[2];break;case 1:u=[a,v,s],l=u[0],n=u[1],t=u[2];break;case 2:d=[s,v,m],l=d[0],n=d[1],t=d[2];break;case 3:f=[s,a,v],l=f[0],n=f[1],t=f[2];break;case 4:h=[m,s,v],l=h[0],n=h[1],t=h[2];break;case 5:p=[v,s,a],l=p[0],n=p[1],t=p[2]}return[l,n,t,e.length>3?e[3]:1]},ie=function(){var e,t,i,n,r,o,s,a,l;return s=Ce(arguments),o=s[0],i=s[1],e=s[2],r=Math.min(o,i,e),le=Math.max(o,i,e),t=le-r,l=le/255,0===le?(n=Number.NaN,a=0):(a=t/le,o===le&&(n=(i-e)/t),i===le&&(n=2+(e-o)/t),e===le&&(n=4+(o-i)/t),(n*=60)<0&&(n+=360)),[n,a,l]},oe.hsv=function(){return function(e,t,i){i.prototype=e.prototype;var n=new i,r=e.apply(n,t);return Object(r)===r?r:n}(S,Me.call(arguments).concat(["hsv"]),function(){})},f.hsv=T,S.prototype.hsv=function(){return ie(this._rgb)},Y=function(e){var t,i,n;return"number"===ke(e)&&e>=0&&e<=16777215?(n=e>>16,i=e>>8&255,t=255&e,[n,i,t,1]):(console.warn("unknown num color: "+e),[0,0,0,1])},fe=function(){var e,t,i,n;return n=Ce(arguments),i=n[0],t=n[1],e=n[2],(i<<16)+(t<<8)+e},oe.num=function(e){return new S(e,"num")},S.prototype.num=function(e){return null==e&&(e="rgb"),fe(this._rgb,e)},f.num=Y,u.push({p:1,test:function(e){if(1===arguments.length&&"number"===ke(e)&&e>=0&&e<=16777215)return"num"}}),w=function(){var e,t,i,n,r,o,s,a,l,c,u,d,f,h,p,g,m,v,y,_;if(i=Ce(arguments),a=i[0],r=i[1],t=i[2],r/=100,s=s/100*255,e=255*r,0===r)d=s=n=t;else switch(360===a&&(a=0),a>360&&(a-=360),a<0&&(a+=360),a/=60,l=se(a),o=a-l,c=t*(1-r),u=c+e*(1-o),y=c+e*o,_=c+e,l){case 0:f=[_,y,c],d=f[0],s=f[1],n=f[2];break;case 1:h=[u,_,c],d=h[0],s=h[1],n=h[2];break;case 2:p=[c,_,y],d=p[0],s=p[1],n=p[2];break;case 3:g=[c,u,_],d=g[0],s=g[1],n=g[2];break;case 4:m=[y,c,_],d=m[0],s=m[1],n=m[2];break;case 5:v=[_,c,u],d=v[0],s=v[1],n=v[2]}return[d,s,n,i.length>3?i[3]:1]},Q=function(){var e,t,i,n,r,o,s,a,l;return l=Ce(arguments),a=l[0],r=l[1],t=l[2],s=Math.min(a,r,t),le=Math.max(a,r,t),n=le-s,i=100*n/255,e=s/(255-n)*100,0===n?o=Number.NaN:(a===le&&(o=(r-t)/n),r===le&&(o=2+(t-a)/n),t===le&&(o=4+(a-r)/n),(o*=60)<0&&(o+=360)),[o,i,e]},oe.hcg=function(){return function(e,t,i){i.prototype=e.prototype;var n=new i,r=e.apply(n,t);return Object(r)===r?r:n}(S,Me.call(arguments).concat(["hcg"]),function(){})},f.hcg=w,S.prototype.hcg=function(){return Q(this._rgb)},p=function(e){var t,i,n,r,o,s,a,l;if(e=e.toLowerCase(),null!=oe.colors&&oe.colors[e])return x(oe.colors[e]);if(o=e.match(/rgb\(\s*(\-?\d+),\s*(\-?\d+)\s*,\s*(\-?\d+)\s*\)/)){for(a=o.slice(1,4),r=s=0;s<=2;r=++s)a[r]=+a[r];a[3]=1}else if(o=e.match(/rgba\(\s*(\-?\d+),\s*(\-?\d+)\s*,\s*(\-?\d+)\s*,\s*([01]|[01]?\.\d+)\)/))for(a=o.slice(1,5),r=l=0;l<=3;r=++l)a[r]=+a[r];else if(o=e.match(/rgb\(\s*(\-?\d+(?:\.\d+)?)%,\s*(\-?\d+(?:\.\d+)?)%\s*,\s*(\-?\d+(?:\.\d+)?)%\s*\)/)){for(a=o.slice(1,4),r=t=0;t<=2;r=++t)a[r]=ye(2.55*a[r]);a[3]=1}else if(o=e.match(/rgba\(\s*(\-?\d+(?:\.\d+)?)%,\s*(\-?\d+(?:\.\d+)?)%\s*,\s*(\-?\d+(?:\.\d+)?)%\s*,\s*([01]|[01]?\.\d+)\)/)){for(a=o.slice(1,5),r=i=0;i<=2;r=++i)a[r]=ye(2.55*a[r]);a[3]=+a[3]}else(o=e.match(/hsl\(\s*(\-?\d+(?:\.\d+)?),\s*(\-?\d+(?:\.\d+)?)%\s*,\s*(\-?\d+(?:\.\d+)?)%\s*\)/))?(n=o.slice(1,4),n[1]*=.01,n[2]*=.01,a=L(n),a[3]=1):(o=e.match(/hsla\(\s*(\-?\d+(?:\.\d+)?),\s*(\-?\d+(?:\.\d+)?)%\s*,\s*(\-?\d+(?:\.\d+)?)%\s*,\s*([01]|[01]?\.\d+)\)/))&&(n=o.slice(1,4),n[1]*=.01,n[2]*=.01,a=L(n),a[3]=+o[4]);return a},J=function(e){var t;return t=e[3]<1?"rgba":"rgb","rgb"===t?t+"("+e.slice(0,3).map(ye).join(",")+")":"rgba"===t?t+"("+e.slice(0,3).map(ye).join(",")+","+e[3]+")":void 0},me=function(e){return ye(100*e)/100},C=function(e,t){var i;return i=t<1?"hsla":"hsl",e[0]=me(e[0]||0),e[1]=me(100*e[1])+"%",e[2]=me(100*e[2])+"%","hsla"===i&&(e[3]=t),i+"("+e.join(",")+")"},f.css=function(e){return p(e)},oe.css=function(){return function(e,t,i){i.prototype=e.prototype;var n=new i,r=e.apply(n,t);return Object(r)===r?r:n}(S,Me.call(arguments).concat(["css"]),function(){})},S.prototype.css=function(e){return null==e&&(e="rgb"),"rgb"===e.slice(0,3)?J(this._rgb):"hsl"===e.slice(0,3)?C(this.hsl(),this.alpha()):void 0},f.named=function(e){return x(Le[e])},u.push({p:5,test:function(e){if(1===arguments.length&&null!=Le[e])return"named"}}),S.prototype.name=function(e){var t,i;arguments.length&&(Le[e]&&(this._rgb=x(Le[e])),this._rgb[3]=1),t=this.hex("rgb");for(i in Le)if(t===Le[i])return i;return t},F=function(){var e,t,i,n;return n=Ce(arguments),i=n[0],e=n[1],t=n[2],t*=r,[i,O(t)*e,be(t)*e]},W=function(){var e,t,i,n,r,o,s,a,l,c,u;return i=Ce(arguments),a=i[0],r=i[1],s=i[2],c=F(a,r,s),e=c[0],t=c[1],n=c[2],u=z(e,t,n),l=u[0],o=u[1],n=u[2],[l,o,n,i.length>3?i[3]:1]},R=function(){var e,t,i,n,r,o;return o=Ce(arguments),r=o[0],e=o[1],t=o[2],i=we(e*e+t*t),n=(E(t,e)*s+360)%360,0===ye(1e4*i)&&(n=Number.NaN),[r,i,n]},ue=function(){var e,t,i,n,r,o,s;return o=Ce(arguments),r=o[0],i=o[1],t=o[2],s=ne(r,i,t),n=s[0],e=s[1],t=s[2],R(n,e,t)},oe.lch=function(){var e;return e=Ce(arguments),new S(e,"lch")},oe.hcl=function(){var e;return e=Ce(arguments),new S(e,"hcl")},f.lch=W,f.hcl=function(){var e,t,i,n;return n=Ce(arguments),t=n[0],e=n[1],i=n[2],W([i,e,t])},S.prototype.lch=function(){return ue(this._rgb)},S.prototype.hcl=function(){return ue(this._rgb).reverse()},X=function(e){var t,i,n,r,o,s,a,l,c;return null==e&&(e="rgb"),l=Ce(arguments),a=l[0],r=l[1],t=l[2],a/=255,r/=255,t/=255,o=1-Math.max(a,Math.max(r,t)),n=o<1?1/(1-o):0,i=(1-a-o)*n,s=(1-r-o)*n,c=(1-t-o)*n,[i,s,c,o]},o=function(){var e,t,i,n,r,o,s,a,l;return t=Ce(arguments),n=t[0],s=t[1],l=t[2],o=t[3],e=t.length>4?t[4]:1,1===o?[0,0,0,e]:(a=n>=1?0:255*(1-n)*(1-o),r=s>=1?0:255*(1-s)*(1-o),i=l>=1?0:255*(1-l)*(1-o),[a,r,i,e])},f.cmyk=function(){return o(Ce(arguments))},oe.cmyk=function(){return function(e,t,i){i.prototype=e.prototype;var n=new i,r=e.apply(n,t);return Object(r)===r?r:n}(S,Me.call(arguments).concat(["cmyk"]),function(){})},S.prototype.cmyk=function(){return X(this._rgb)},f.gl=function(){var e,i,t,n,r;for(n=function(){var e,t;e=Ce(arguments),t=[];for(i in e)r=e[i],t.push(r);return t}.apply(this,arguments),e=t=0;t<=2;e=++t)n[e]*=255;return n},oe.gl=function(){return function(e,t,i){i.prototype=e.prototype;var n=new i,r=e.apply(n,t);return Object(r)===r?r:n}(S,Me.call(arguments).concat(["gl"]),function(){})},S.prototype.gl=function(){var e;return e=this._rgb,[e[0]/255,e[1]/255,e[2]/255,e[3]]},de=function(e,t,i){var n;return n=Ce(arguments),e=n[0],t=n[1],i=n[2],e=q(e),t=q(t),i=q(i),.2126*e+.7152*t+.0722*i},q=function(e){return e/=255,e<=.03928?e/12.92:ce((e+.055)/1.055,2.4)},N=function(e,t,i,n){var r,o;return r=e._rgb,o=t._rgb,new S(r[0]+i*(o[0]-r[0]),r[1]+i*(o[1]-r[1]),r[2]+i*(o[2]-r[2]),n)},l.push(["rgb",N]),S.prototype.luminance=function(r,o){var e,s,a,t,l;return null==o&&(o="rgb"),arguments.length?(t=this._rgb,0===r?t=[0,0,0,this._rgb[3]]:1===r?t=[255,255,255,this[3]]:(e=de(this._rgb),s=1e-7,a=20,l=function(e,t){var i,n;return n=e.interpolate(t,.5,o),i=n.luminance(),Math.abs(r-i)<s||!a--?n:i>r?l(e,n):l(n,t)},t=e>r?l(oe("black"),this).rgba():l(this,oe("white")).rgba()),oe(t).alpha(this.alpha())):de(this._rgb)},xe=function(e){var t,i,n,r;return r=e/100,r<66?(n=255,i=-155.25485562709179-.44596950469579133*(i=r-2)+104.49216199393888*ae(i),t=r<20?0:.8274096064007395*(t=r-10)-254.76935184120902+115.67994401066147*ae(t)):(n=351.97690566805693+.114206453784165*(n=r-55)-40.25366309332127*ae(n),i=325.4494125711974+.07943456536662342*(i=r-50)-28.0852963507957*ae(i),t=255),[n,i,t]},he=function(){var e,t,i,n,r,o,s,a;for(o=Ce(arguments),r=o[0],o[1],e=o[2],n=1e3,i=4e4,t=.4;i-n>t;)a=.5*(i+n),s=xe(a),s[2]/s[0]>=e/r?i=a:n=a;return ye(a)},oe.temperature=oe.kelvin=function(){return function(e,t,i){i.prototype=e.prototype;var n=new i,r=e.apply(n,t);return Object(r)===r?r:n}(S,Me.call(arguments).concat(["temperature"]),function(){})},f.temperature=f.kelvin=f.K=xe,S.prototype.temperature=function(){return he(this._rgb)},S.prototype.kelvin=S.prototype.temperature,oe.contrast=function(e,t){var i,n,r,o;return"string"!==(r=ke(e))&&"number"!==r||(e=new S(e)),"string"!==(o=ke(t))&&"number"!==o||(t=new S(t)),i=e.luminance(),n=t.luminance(),i>n?(i+.05)/(n+.05):(n+.05)/(i+.05)},oe.distance=function(e,t,i){var n,r,o,s,a,l,c;null==i&&(i="lab"),"string"!==(a=ke(e))&&"number"!==a||(e=new S(e)),"string"!==(l=ke(t))&&"number"!==l||(t=new S(t)),o=e.get(i),s=t.get(i),c=0;for(r in o)n=(o[r]||0)-(s[r]||0),c+=n*n;return Math.sqrt(c)},oe.deltaE=function(e,t,i,n){var r,o,s,a,l,c,u,d,f,h,p,g,m,v,y,_,b,w,x,k,C,L,T,j,M,I,D;for(null==i&&(i=1),null==n&&(n=1),"string"!==(b=ke(e))&&"number"!==b||(e=new S(e)),"string"!==(w=ke(t))&&"number"!==w||(t=new S(t)),x=e.lab(),r=x[0],s=x[1],l=x[2],k=t.lab(),o=k[0],a=k[1],c=k[2],u=we(s*s+l*l),d=we(a*a+c*c),T=r<16?.511:.040975*r/(1+.01765*r),C=.0638*u/(1+.0131*u)+.638,_=u<1e-6?0:180*E(l,s)/P;_<0;)_+=360;for(;_>=360;)_-=360;return j=_>=164&&_<=345?.56+re(.2*O(P*(_+168)/180)):.36+re(.4*O(P*(_+35)/180)),f=u*u*u*u,y=we(f/(f+1900)),L=C*(y*j+1-y),v=r-o,m=u-d,p=s-a,g=l-c,h=p*p+g*g-m*m,M=v/(i*T),I=m/(n*C),D=L,we(M*M+I*I+h/(D*D))},S.prototype.get=function(e){var t,i,n,r,o,s;return n=this,o=e.split("."),r=o[0],t=o[1],s=n[r](),t?(i=r.indexOf(t),i>-1?s[i]:console.warn("unknown channel "+t+" in mode "+r)):s},S.prototype.set=function(e,t){var i,n,r,o,s,a;if(r=this,s=e.split("."),o=s[0],i=s[1],i)if(a=r[o](),(n=o.indexOf(i))>-1)if("string"===ke(t))switch(t.charAt(0)){case"+":case"-":a[n]+=+t;break;case"*":a[n]*=+t.substr(1);break;case"/":a[n]/=+t.substr(1);break;default:a[n]=+t}else a[n]=t;else console.warn("unknown channel "+i+" in mode "+o);else a=t;return oe(a,o).alpha(r.alpha())},S.prototype.clipped=function(){return this._rgb._clipped||!1},S.prototype.alpha=function(e){return arguments.length?oe.rgb([this._rgb[0],this._rgb[1],this._rgb[2],e]):this._rgb[3]},S.prototype.darken=function(e){var t,i;return null==e&&(e=1),i=this,t=i.lab(),t[0]-=c.Kn*e,oe.lab(t).alpha(i.alpha())},S.prototype.brighten=function(e){return null==e&&(e=1),this.darken(-e)},S.prototype.darker=S.prototype.darken,S.prototype.brighter=S.prototype.brighten,S.prototype.saturate=function(e){var t,i;return null==e&&(e=1),i=this,t=i.lch(),t[1]+=e*c.Kn,t[1]<0&&(t[1]=0),oe.lch(t).alpha(i.alpha())},S.prototype.desaturate=function(e){return null==e&&(e=1),this.saturate(-e)},S.prototype.premultiply=function(){var e,t;return t=this.rgb(),e=this.alpha(),oe(t[0]*e,t[1]*e,t[2]*e,e)},n=function(e,t,i){if(!n[i])throw"unknown blend mode "+i;return n[i](e,t)},e=function(r){return function(e,t){var i,n;return i=oe(t).rgb(),n=oe(e).rgb(),oe(r(i,n),"rgb")}},b=function(o){return function(e,t){var i,n,r;for(r=[],i=n=0;n<=3;i=++n)r[i]=o(e[i],t[i]);return r}},V=function(e,t){return e},U=function(e,t){return e*t/255},m=function(e,t){return e>t?t:e},B=function(e,t){return e>t?e:t},_e=function(e,t){return 255*(1-(1-e/255)*(1-t/255))},Z=function(e,t){return t<128?2*e*t/255:255*(1-2*(1-e/255)*(1-t/255))},t=function(e,t){return 255*(1-(1-t/255)/(e/255))},_=function(e,t){return 255===e?255:(e=t/255*255/(1-e/255),e>255?255:e)},n.normal=e(b(V)),n.multiply=e(b(U)),n.screen=e(b(_e)),n.overlay=e(b(Z)),n.darken=e(b(m)),n.lighten=e(b(B)),n.dodge=e(b(_)),n.burn=e(b(t)),oe.blend=n,oe.analyze=function(e){var t,i,n,r;for(n={min:Number.MAX_VALUE,max:-1*Number.MAX_VALUE,sum:0,values:[],count:0},i=0,t=e.length;i<t;i++)null==(r=e[i])||isNaN(r)||(n.values.push(r),n.sum+=r,r<n.min&&(n.min=r),r>n.max&&(n.max=r),n.count+=1);return n.domain=[n.min,n.max],n.limits=function(e,t){return oe.limits(n,e,t)},n},oe.scale=function(u,e){var d,f,h,t,p,g,m,v,y,_,i,b,w,s,x,k,C,L,a,n,T;return y="rgb",_=oe("#ccc"),s=0,!1,p=[0,1],w=[],b=[0,0],d=!1,h=[],i=!1,v=0,m=1,t=!1,f={},x=!0,g=1,n=function(e){var t,i,n,r,o,s;if(null==e&&(e=["#fff","#000"]),null!=e&&"string"===ke(e)&&null!=oe.brewer&&(e=oe.brewer[e]||oe.brewer[e.toLowerCase()]||e),"array"===ke(e)){for(1===e.length&&(e=[e[0],e[0]]),e=e.slice(0),t=n=0,r=e.length-1;0<=r?n<=r:n>=r;t=0<=r?++n:--n)i=e[t],"string"===ke(i)&&(e[t]=oe(i));for(w.length=0,t=s=0,o=e.length-1;0<=o?s<=o:s>=o;t=0<=o?++s:--s)w.push(t/(e.length-1))}return a(),h=e},C=function(e){var t,i;if(null!=d){for(i=d.length-1,t=0;t<i&&e>=d[t];)t++;return t-1}return 0},T=function(e){return e},function(e){var t,i,n,r,o;return o=e,d.length>2&&(r=d.length-1,t=C(e),n=d[0]+(d[1]-d[0])*(0+.5*s),i=d[r-1]+(d[r]-d[r-1])*(1-.5*s),o=v+(d[t]+.5*(d[t+1]-d[t])-n)/(i-n)*(m-v)),o},L=function(e,t){var i,n,r,o,s,a,l,c;if(null==t&&(t=!1),isNaN(e)||null===e)return _;if(t?c=e:d&&d.length>2?(i=C(e),c=i/(d.length-2)):c=m!==v?(e-v)/(m-v):1,t||(c=T(c)),1!==g&&(c=ce(c,g)),c=b[0]+c*(1-b[0]-b[1]),c=Math.min(1,Math.max(0,c)),o=Math.floor(1e4*c),x&&f[o])n=f[o];else{if("array"===ke(h))for(r=s=0,l=w.length-1;0<=l?s<=l:s>=l;r=0<=l?++s:--s){if(a=w[r],c<=a){n=h[r];break}if(c>=a&&r===w.length-1){n=h[r];break}if(c>a&&c<w[r+1]){c=(c-a)/(w[r+1]-a),n=oe.interpolate(h[r],h[r+1],c,y);break}}else"function"===ke(h)&&(n=h(c));x&&(f[o]=n)}return n},a=function(){return f={}},n(u),k=function(e){var t;return t=oe(L(e)),i&&t[i]?t[i]():t},k.classes=function(e){var t;return null!=e?("array"===ke(e)?(d=e,p=[e[0],e[e.length-1]]):(t=oe.analyze(p),d=0===e?[t.min,t.max]:oe.limits(t,"e",e)),k):d},k.domain=function(e){var t,i,n,r,o,s,a;if(!arguments.length)return p;if(v=e[0],m=e[e.length-1],w=[],n=h.length,e.length===n&&v!==m)for(o=0,r=e.length;o<r;o++)i=e[o],w.push((i-v)/(m-v));else for(t=a=0,s=n-1;0<=s?a<=s:a>=s;t=0<=s?++a:--a)w.push(t/(n-1));return p=[v,m],k},k.mode=function(e){return arguments.length?(y=e,a(),k):y},k.range=function(e,t){return n(e,t),k},k.out=function(e){return i=e,k},k.spread=function(e){return arguments.length?(s=e,k):s},k.correctLightness=function(e){return null==e&&(e=!0),t=e,a(),T=t?function(e){var t,i,n,r,o,s,a,l,c;for(t=L(0,!0).lab()[0],i=L(1,!0).lab()[0],a=t>i,n=L(e,!0).lab()[0],o=t+(i-t)*e,r=n-o,l=0,c=1,s=20;Math.abs(r)>.01&&s-- >0;)!function(){a&&(r*=-1),r<0?(l=e,e+=.5*(c-e)):(c=e,e+=.5*(l-e)),n=L(e,!0).lab()[0],r=n-o}();return e}:function(e){return e},k},k.padding=function(e){return null!=e?("number"===ke(e)&&(e=[e,e]),b=e,k):b},k.colors=function(t,i){var n,r,e,o,s,a,l,c;if(arguments.length<2&&(i="hex"),s=[],0===arguments.length)s=h.slice(0);else if(1===t)s=[k(.5)];else if(t>1)r=p[0],n=p[1]-r,s=function(){a=[];for(var e=0;0<=t?e<t:e>t;0<=t?e++:e--)a.push(e);return a}.apply(this).map(function(e){return k(r+e/(t-1)*n)});else{if(u=[],l=[],d&&d.length>2)for(e=c=1,o=d.length;1<=o?c<o:c>o;e=1<=o?++c:--c)l.push(.5*(d[e-1]+d[e]));else l=p;s=l.map(function(e){return k(e)})}return oe[i]&&(s=s.map(function(e){return e[i]()})),s},k.cache=function(e){return null!=e?(x=e,k):x},k.gamma=function(e){return null!=e?(g=e,k):g},k.nodata=function(e){return null!=e?(_=oe(e),k):_},k},null==oe.scales&&(oe.scales={}),oe.scales.cool=function(){return oe.scale([oe.hsl(180,1,.9),oe.hsl(250,.7,.4)])},oe.scales.hot=function(){return oe.scale(["#000","#f00","#ff0","#fff"],[0,.25,.75,1]).mode("rgb")},oe.analyze=function(e,i,n){var r,t,o,s,a,l,c;if(a={min:Number.MAX_VALUE,max:-1*Number.MAX_VALUE,sum:0,values:[],count:0},null==n&&(n=function(){return!0}),r=function(e){null==e||isNaN(e)||(a.values.push(e),a.sum+=e,e<a.min&&(a.min=e),e>a.max&&(a.max=e),a.count+=1)},c=function(e,t){if(n(e,t))return r(null!=i&&"function"===ke(i)?i(e):null!=i&&"string"===ke(i)||"number"===ke(i)?e[i]:e)},"array"===ke(e))for(s=0,o=e.length;s<o;s++)l=e[s],c(l);else for(t in e)l=e[t],c(l,t);return a.domain=[a.min,a.max],a.limits=function(e,t){return oe.limits(a,e,t)},a},oe.limits=function(e,t,i){var n,r,o,s,a,l,c,u,d,f,h,p,g,m,v,y,_,b,w,x,k,C,L,T,j,M,I,D,S,P,E,O,A,N,R,z,H,F,W,B,G,q,$,U,V,Y,Z,X,J,Q,K,ee,te,ie,ne;if(null==t&&(t="equal"),null==i&&(i=7),"array"===ke(e)&&(e=oe.analyze(e)),j=e.min,le=e.max,e.sum,ie=e.values.sort(function(e,t){return e-t}),1===i)return[j,le];if(L=[],"c"===t.substr(0,1)&&(L.push(j),L.push(le)),"e"===t.substr(0,1)){for(L.push(j),x=E=1,R=i-1;1<=R?E<=R:E>=R;x=1<=R?++E:--E)L.push(j+x/i*(le-j));L.push(le)}else if("l"===t.substr(0,1)){if(j<=0)throw"Logarithmic scales are only possible for values > 0";for(M=Math.LOG10E*ae(j),T=Math.LOG10E*ae(le),L.push(j),x=ne=1,z=i-1;1<=z?ne<=z:ne>=z;x=1<=z?++ne:--ne)L.push(ce(10,M+x/i*(T-M)));L.push(le)}else if("q"===t.substr(0,1)){for(L.push(j),x=n=1,q=i-1;1<=q?n<=q:n>=q;x=1<=q?++n:--n)O=(ie.length-1)*x/i,A=se(O),A===O?L.push(ie[A]):(N=O-A,L.push(ie[A]*(1-N)+ie[A+1]*N));L.push(le)}else if("k"===t.substr(0,1)){for(D=ie.length,m=new Array(D),b=new Array(i),Q=!0,S=0,y=null,y=[],y.push(j),x=r=1,$=i-1;1<=$?r<=$:r>=$;x=1<=$?++r:--r)y.push(j+x/i*(le-j));for(y.push(le);Q;){for(k=o=0,U=i-1;0<=U?o<=U:o>=U;k=0<=U?++o:--o)b[k]=0;for(x=s=0,V=D-1;0<=V?s<=V:s>=V;x=0<=V?++s:--s){for(te=ie[x],I=Number.MAX_VALUE,k=a=0,Y=i-1;0<=Y?a<=Y:a>=Y;k=0<=Y?++a:--a)(w=re(y[k]-te))<I&&(I=w,v=k);b[v]++,m[x]=v}for(P=new Array(i),k=l=0,Z=i-1;0<=Z?l<=Z:l>=Z;k=0<=Z?++l:--l)P[k]=null;for(x=c=0,X=D-1;0<=X?c<=X:c>=X;x=0<=X?++c:--c)_=m[x],null===P[_]?P[_]=ie[x]:P[_]+=ie[x];for(k=u=0,J=i-1;0<=J?u<=J:u>=J;k=0<=J?++u:--u)P[k]*=1/b[k];for(Q=!1,k=d=0,H=i-1;0<=H?d<=H:d>=H;k=0<=H?++d:--d)if(P[k]!==y[x]){Q=!0;break}y=P,S++,S>200&&(Q=!1)}for(C={},k=f=0,F=i-1;0<=F?f<=F:f>=F;k=0<=F?++f:--f)C[k]=[];for(x=h=0,W=D-1;0<=W?h<=W:h>=W;x=0<=W?++h:--h)_=m[x],C[_].push(ie[x]);for(K=[],k=p=0,B=i-1;0<=B?p<=B:p>=B;k=0<=B?++p:--p)K.push(C[k][0]),K.push(C[k][C[k].length-1]);for(K=K.sort(function(e,t){return e-t}),L.push(K[0]),x=g=1,G=K.length-1;g<=G;x=g+=2)ee=K[x],isNaN(ee)||-1!==L.indexOf(ee)||L.push(ee)}return L},k=function(e,t,i){var n,r,o,s;return n=Ce(arguments),e=n[0],t=n[1],i=n[2],isNaN(e)&&(e=0),e/=360,e<1/3?(r=(1-t)/3,s=(1+t*O(v*e)/O(a-v*e))/3,o=1-(r+s)):e<2/3?(e-=1/3,s=(1-t)/3,o=(1+t*O(v*e)/O(a-v*e))/3,r=1-(s+o)):(e-=2/3,o=(1-t)/3,r=(1+t*O(v*e)/O(a-v*e))/3,s=1-(o+r)),s=G(i*s*3),o=G(i*o*3),r=G(i*r*3),[255*s,255*o,255*r,n.length>3?n[3]:1]},ee=function(){var e,t,i,n,r,o,s,a;return s=Ce(arguments),o=s[0],t=s[1],e=s[2],v=2*Math.PI,o/=255,t/=255,e/=255,r=Math.min(o,t,e),n=(o+t+e)/3,a=1-r/n,0===a?i=0:(i=(o-t+(o-e))/2,i/=Math.sqrt((o-t)*(o-t)+(o-e)*(t-e)),i=Math.acos(i),e>t&&(i=v-i),i/=v),[360*i,a,n]},oe.hsi=function(){return function(e,t,i){i.prototype=e.prototype;var n=new i,r=e.apply(n,t);return Object(r)===r?r:n}(S,Me.call(arguments).concat(["hsi"]),function(){})},f.hsi=k,S.prototype.hsi=function(){return ee(this._rgb)},M=function(e,t,i,n){var r,o,s,a,l,c,u,d,f,h,p,g;return"hsl"===n?(p=e.hsl(),g=t.hsl()):"hsv"===n?(p=e.hsv(),g=t.hsv()):"hcg"===n?(p=e.hcg(),g=t.hcg()):"hsi"===n?(p=e.hsi(),g=t.hsi()):"lch"!==n&&"hcl"!==n||(n="hcl",p=e.hcl(),g=t.hcl()),"h"===n.substr(0,1)&&(s=p[0],f=p[1],c=p[2],a=g[0],h=g[1],u=g[2]),isNaN(s)||isNaN(a)?isNaN(s)?isNaN(a)?o=Number.NaN:(o=a,1!==c&&0!==c||"hsv"===n||(d=h)):(o=s,1!==u&&0!==u||"hsv"===n||(d=f)):(r=a>s&&a-s>180?a-(s+360):a<s&&s-a>180?a+360-s:a-s,o=s+i*r),null==d&&(d=f+i*(h-f)),l=c+i*(u-c),oe[n](o,d,l)},l=l.concat(function(){var e,t,i,n;for(i=["hsv","hsl","hsi","hcl","lch","hcg"],n=[],t=0,e=i.length;t<e;t++)$=i[t],n.push([$,M]);return n}()),A=function(e,t,i,n){var r,o;return r=e.num(),o=t.num(),oe.num(r+(o-r)*i,"num")},l.push(["num",A]),I=function(e,t,i,n){var r,o;return r=e.lab(),o=t.lab(),new S(r[0]+i*(o[0]-r[0]),r[1]+i*(o[1]-r[1]),r[2]+i*(o[2]-r[2]),n)},l.push(["lab",I])}).call(this);(function(p,f,g,l){var t=new p.Deferred,i=false,n=/([!"#$%&'()*+,.\/:;<=>?@\[\\\]^`{|}~])/g,e=new p.Deferred,h,r,o,s;p(function(){if(g.oauth2&&!g.oauth2.thisIsOauthFrame()){t.resolveWith(g,[g])}});g=p.extend(g,{exposeJQuery:function(){return p},ready:function(e){if(arguments.length===0){return t.promise()}if(typeof e==="function"){t.done(e)}return this},includeCss:function(e,t){var i=new p.Deferred,n=f.document.getElementsByTagName("head")[0],r=document.createElement("link"),o=function(){if(typeof t==="function"&&i.state()==="pending"){t()}i.resolve()};e+=(e.indexOf("?")>-1?"&":"?")+"_nch="+giscloud_config.nch;r.setAttribute("rel","stylesheet");r.setAttribute("type","text/css");r.setAttribute("href",e);r.onreadystatechange=function(){if(r.readyState==="complete"||r.readyState==="loaded"){o()}};if(r.addEventListener){r.addEventListener("load",function(){o()},false)}r.onload=function(){o()};n.appendChild(r);return i.promise()},includeJs:function(e,t,i){var n=new p.Deferred,r=document.getElementsByTagName("head")[0],o=document.createElement("script"),s=function(){if(typeof t==="function"&&n.state()==="pending"){t()}n.resolve()};if(!i){e+=(e.indexOf("?")>-1?"&":"?")+"_nch="+giscloud_config.nch}o.setAttribute("type","text/javascript");o.setAttribute("src",e);o.onreadystatechange=function(){if(o.readyState==="complete"||o.readyState==="loaded"){s()}};if(o.addEventListener){o.addEventListener("load",function(){s()},false)}o.onload=function(){s()};r.appendChild(o);return n.promise()},prefetchAsset:function(e,t){var i=document.createElement("link");i.href=t+(t.indexOf("?")>-1?"&":"?")+"_nch="+giscloud_config.nch;i.rel="prefetch";i.as=e;document.head.appendChild(i)},formats:{IFRAME:"iframe",HTML:"iframe",PNG:"png",JPEG:"jpg",SHAPEFILE:"shp",GPX:"gpx",MIF:"mif",GML:"gml",exportFormats:{SHAPEFILE:"shp",GPX:"gpx",MIF:"mif",GML:"gml"},renderFormats:{IFRAME:"iframe",PNG:"png",JPEG:"jpg"}},toMeterRatios:{km:1e3,m:1,meter:1,dm:1/10,cm:1/100,mm:1/1e3,kmi:1852,in:.0254,inch:.0254,ft:.3048,foot:.3048,feet:.3048,yd:.9144,yard:.9144,mi:1609.344,mile:1609.344,fath:1.8288,fathom:1.8288,ch:20.1168,link:.201168,"us-in":1/39.37,"inch us":1/39.37,"us-ft":.304800609601219,foot_us:.304800609601219,"us-yd":.914401828803658,"us-ch":20.11684023368047,"us-mi":1609.347218694437,"ind-yd":.91439523,"ind-ft":.30479841,"ind-ch":20.11669506},toSqMeterRatio:{acre:24711e-8,ha:1e-4,hectare:1e-4},fromSquareMeter:function(e,t){var i=g.toSqMeterRatio[e];var n=e&&i;var r;if(!n){console.log("Unknown unit.");return null}return t*i},toMeters:function(e,t,i){var n=g.toMeterRatios[e];var r=e&&n;var o;if(!r){console.log("Unknown unit.");return null}return t*(i?Math.pow(n,2):n)},fromMeters:function(e,t,i){var n=g.toMeters(e,1/t,i);return n&&1/n||null},apiKey:function(e){if(typeof e=="string"){o=e;return this}else{return o}},appInstanceId:function(e){if(typeof e=="number"){s=e;return this}else{return s}},logDeferredResults:function(t,i,n,r){var e,o=function(){console.log("DONE",arguments)},s=function(){console.log("FAIL",arguments)},a=function(){console.log("PROGRESS",arguments)};try{if(p.isFunction(t.done)&&p.isFunction(t.fail)){if(i!=null&&n==null&&r==null){r=i;i=null}e=t}else{if(n===l){n=f}if(i==null){i=[]}else if(!p.isArray(i)){i=[i]}e=t.apply(n,i)}if(p.isFunction(e.done)&&p.isFunction(e.fail)){e.done(o);e.fail(s);e.progress(a);if(r){e.done(function(e){if(typeof r=="string"){f[r]=e}else{r=e}})}}else{console.log("NOT DEFERRED",e)}}catch(e){console.log("ERROR",e,t,i,n)}},browserSupportsGL:function(){return h.supportedMapbox()},common:function(){return h}});g.sessid=function(){var e=document.cookie,t=e&&e.match&&e.match(/PHPSESSID=([^ ;]+)/);return t&&t[1]||null};g.construct=function(e,t){var i={};if(t){if(p.isArray(t)){p.each(t,function(e,t){p.extend(i,t)})}else{p.extend(i,t)}}i.higher=i;e.prototype=i;return e};h={restHost:function(){return giscloud_config.restHost()},apiHost:function(){return giscloud_config.apiHost()},authHost:function(){return giscloud_config.authHost()},liveSite:function(){return giscloud_config.liveSite()},assetsSite:function(){return giscloud_config.assetsSite()},tileSite:function(){return giscloud_config.tileSite()},https:function(){return giscloud_config.https},isMobileBrowser:/android.+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od|ad)|iris|kindle|lge |maemo|midp|mmp|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i.test(navigator.userAgent)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|e\-|e\/|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(di|rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|xda(\-|2|g)|yas\-|your|zeto|zte\-/i.test(navigator.userAgent.substr(0,4)),clone:function(e){var t=function(){};p.extend(true,t.prototype,e);return new t},bindFirst:function(e,t,i){var n,r;e.on(t,i);e.each(function(){n=p._data(this,"events")[t.split(".")[0]];r=n.pop();n.splice(0,0,r)});return e},oid:function(){var e=Math.random,t=Math.ceil,i=(p.now().toString()+t(e()*1e5)).substr(3),n=t(e()*15);return i.substr(n)+i.substr(0,n)},setError:function(e,t,i){if(e.errors===l){e.errors=[]}e.errors.push({time:new Date,src:t,msg:i})},__:function(e){var t;if(!f.gclang)return e;t=e.replace(/[ ,.?!;:'\\+\-()]/g,"_");t=t.replace(/\&/g,"and");return t in gclang?gclang[t]:e},getMapHighlightColor:function(e){var t=e.parent&&e.parent.options,i=t&&t["HIGHLIGHT_COLOR"];return i?parseInt(i,16):null},getLayerHighlightColor:function(e,t){var i=e.parent&&e.parent.layerById(t),n=i&&i.options||[],r,o,s,a;for(s=0,a=n.length;s<a;s++){o=n[s];if(o.option_name==="HIGHLIGHT_COLOR"){r=parseInt(o.option_value,16);break}}return isNaN(r)?null:r},highlight:function(e,t,i,n){var r=i&&this.getLayerHighlightColor(e,i)||this.getMapHighlightColor(e)||"selectcolor";e.modifyObject(t.toString(),{color:r,alpha:100,from_color:13421772,glow:{color:65280,strength:2,blurX:10,blurY:10}},i===null?"":"layer"+i+"||",n)},highlightMultiple:function(e,t,i,n){var r=i&&this.getLayerHighlightColor(e,i)||this.getMapHighlightColor(e)||"selectcolor";e.modifyObject(t.join(),{color:r,alpha:100,from_color:13421772,glow:{color:65280,strength:2,blurX:10,blurY:10}},i===null?"":"layer"+i+"||",n)},getHighlightAndSelectColors:function(e){var t;if(e&&e.length){t=g.Color.fromString(e);return[t.brighter(15).hex(),"#C9FFE5"]}return null},deferreds:{},refs:{},toXml:function(e,t){var i="",n,r,o;if(t===null||t===l||t===""){return"<"+e+"/>"}else if(typeof t==="object"){i+="<"+e+">";if(p.isArray(t)){if(e[e.length-1]==="s"){o=e.substr(0,e.length-1)}else{o=e}for(n=0,r=t.length;n<r;n++){i+=this.toXml(o,t[n])}}else{for(n in t){if(t.hasOwnProperty(n)){i+=this.toXml(n,t[n])}}}i+="</"+e+">"}else{i+="<"+e+">"+t.toString().replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/&/g,"&amp;")+"</"+e+">"}return i},debounce:function e(i,n,r,o){var s,t;r=r||f;o=p.isArray(o)?o:o==null?[]:[o];t=function(){var e,t;if(s){clearTimeout(s)}if(p.isFunction(Function.prototype.bind)){e=[r].concat(Array.prototype.slice.apply(arguments),o);s=setTimeout(i.bind.apply(i,e),n)}else{t=function(){i.apply(r,Array.prototype.slice.apply(arguments).concat(o))};t.name=(i.name||"")+"wrapped";s=setTimeout(t,n)}};t.name=(i.name||"")+"debounced";return t},haversine:function(e,t,i,n,r){var o=Math.PI/180,s=(i-e)*o,a=(n-t)*o,l=Math.sin(s/2)*Math.sin(s/2)+Math.cos(e*o)*Math.cos(i*o)*Math.sin(a/2)*Math.sin(a/2),c=2*Math.atan2(Math.sqrt(l),Math.sqrt(1-l));r=r||6371e3;return r*c},zoomToBounds:function(e,t){var i=1300,n,r,o;r=e.instance.getLayer(0);if(r){o=r.getCurrentLevel()}if(t.isPoint()){if(o>10){e.center(t.center())}else{n=e.bounds().clone().center(t.center()).width(i,true)}}else{n=t}e.bounds(n,true)},viewerShowFeatureInfo:function(){function f(n){var r,e=n.meta&&n.meta.columns;if(!e){return n.data}r={};p.each(e,function(e,t){var i=t.alias||t.field;if(t.field==="FID"){r[i]=n.id}else if(t.field==="OWNER"){r[i]=n.owner||""}else if(t.field==="CREATED"){r[i]=n.created.toLocaleString()}else if(t.field==="MODIFIED"){r[i]=n.created.toLocaleString()}else{r[i]=n.data[i]}});return r}function h(e,t){var i=/^(((\S+)?)(@|mailto\:|(news|(ht|f)tp(s?))\:\/\/)\S+)$/i,n=/^<a href=['"]javascript:;['"] onclick=['"]fn\.showMedia\(\{url:\[['"][\w:\/.]+['"]\][\w, :]+\}\);return false;["']\s+>[\w<> ='"-\/]+<\/a>$/;e=e==null?"null":e;if(g.ui.map&&n.test(e)){return p("<tr/>").append(p("<td/>",{class:"gc-info-key-cell",title:t}).text(t),p("<td/>",{class:"gc-info-value-cell"}).append(p(e)))}if(i.test(e)){return p("<tr/>").append(p("<td/>",{class:"gc-info-key-cell",title:t}).text(t),p("<td/>",{class:"gc-info-value-cell"}).append(p("<a/>",{href:e,target:"_blank"}).html(e)))}return p("<tr/>").append(p("<td/>",{class:"gc-info-key-cell",title:t}).text(t),p("<td/>",{class:"gc-info-value-cell",title:e}).html(e))}return function e(l,c,t,i,u){var d=this,n;if(!(l instanceof g.Viewer))throw"Invalid viewer param";if(!c)throw"No layerId param.";if(!t)throw"No feature param.";if(typeof t==="object")n=p.Deferred().resolve(t);else n=g.features.byId(c,t,{format:true});n.done(function(e){var t,i,n,r,o=p(d).data("marker"),s=p(d).data("lastLonLat"),a=s||e.bounds.center();if(o){l.removeMarker(o)}t=p("<div/>");r=l.layerById(c);p("<table/>",{class:"gc-info-popup-content-table"}).append(e.meta&&e.meta.columns?p.map(f(e),h):p.map(e.data,h)).appendTo(t);i=r&&r.name||"";n=t.html();if(p.isFunction(u)){n=u.call(t,{feature:e,layer:r,content:n,position:a})}o=new g.FlagMarker(a,i,n);l.addMarker(o);p(d).data("marker",o)})}}(),rest:function(){var d=function(e){var t=e||{};if(t.sort){if(typeof t.sort==="string"||t.sort.length===l){t.order_by=t.sort}else{t.order_by=t.sort.join()}delete t.sort}if(t.page||t.perPage){t.page=t.page||1;t.perpage=t.perPage||10;delete t.perPage}if(t.field&&t.field.length&&t.value&&t.value.length){t.where=t.field+"='"+t.value+"'";delete t.field;delete t.value}if(t.expand&&p.isArray(t.expand)){t.expand=t.expand.join(",")}return t};this.url=function(e){var t=document.location,i=t.protocol+"//"+t.host,n=h.liveSite().indexOf(i)===0,r=h.liveSite().indexOf(h.apiHost())===0,o=h.liveSite().indexOf(h.restHost())===0,s;if(n&&!r&&!o){s=h.liveSite()+"rest/1/"}else if(r){s=h.apiHost()+"/1/"}else{s=h.restHost()+"/1/"}if(g.offlineMode()){s=s.replace(/http.?:\/\//,"giscloud://")}if(typeof e==="string"){return s+e}else{return s}};this.local=function(e,t,i,n,r,o,s){var a,l,c={};l=this.url(i);a=new p.Deferred;if(s&&h.https()){if(l.indexOf("https:")!==0){l=l.replace("http:","https:")}if(n.api_key||o){c["API-key"]=n.api_key||o;delete n.api_key}else if(!n.oauth_token&&r){n.oauth_token=r}else{c["API-sessid"]=g.sessid()}}if(e==="get"||e==="GET"){if(g.offlineMode()){var u=l.split(",");giscloudOffline.getRest([l],function(){var t=Array.prototype.slice.apply(arguments);if(t[0]===""){a.reject.apply(a,["Response is empty."])}else{try{t[0]=f.JSON.parse(t[0]);a.resolve.apply(a,t)}catch(e){a.reject.apply(a,[e].concat(t))}}},function(){var e=Array.prototype.slice.apply(arguments);a.reject.apply(a,e)})}else{p.ajax({url:l,type:"GET",cache:false,dataType:"json",data:n,headers:c}).done(function(){var e=Array.prototype.slice.apply(arguments);a.resolve.apply(a,e)}).fail(function(){var e=Array.prototype.slice.apply(arguments);a.reject.apply(a,e)})}}else{if(t==="application/json"&&p.isPlainObject(n)){n=JSON.stringify(n)}p.ajax({url:l,type:e,cache:false,dataType:"json",accept:"application/json",contentType:t||"application/x-www-form-urlencoded",data:n,headers:c}).success(function(e,t,i){a.resolve(e,i.getResponseHeader("Location"))}).error(function(e,t,i){var n,r,o,s;if(e.responseText===""&&(e.status===201||e.status===204)){a.resolve(null,e.getResponseHeader("Location"));return}if(e.getResponseHeader("Content-Type")==="application/json"){n=JSON.parse(e.responseText);r=n.code;o=n.msg;s=n.nested}else if(/\/xml$/i.test(e.getResponseHeader("Content-Type"))){n=p(e.responseText);r=n.find("code").text();o=n.find("msg").text();s=n.find("nested").text()}a.reject(e.status,t,i,r,o,s)})}return a.promise()};this.call=function(e,t,i,n,r){var o,s,a,l,c,u;i=d(i);u=g.appInstanceId();if(u){i.app_instance_id=u}a=g.oauth2.token();if(a){i.oauth_token=a}l=g.apiKey();if(l){i.api_key=l}r=!!(r||a||l);return this.local(e,n,t,i,a,l,r)};this.get=function(e,t){var i,n,r,o,s,a=false;t=d(t);r=g.oauth2.token();if(r){t.oauth_token=r}o=g.appInstanceId();if(o){t.app_instance_id=o}s=g.apiKey();if(s){t.api_key=s}if(t&&(t.forceSecure||t.api_key||t.oauth_token)){a=true}return this.local("GET",null,e,t,null,null,a)};return this}.apply({})};if(p.fn.busy){p().busy("defaults",{img:h.apiHost()+"/assets/api/1/images/busy.gif"})}g.Promise=function(e){e=e||new p.Deferred;return e.promise()};g.xssSafe=function(e){if(!e){return e}return p("<div/>",{text:e}).html()};g.escapeSelector=function(e){if(!e||!e.replace){return e}return e.replace(n,"\\$1")};g.offlineMode=function(e){if(e==null){return i&&!!f.giscloudOffline}i=e};g=g;f.out=function e(){console.log(arguments)};f.out.id=function(t){return function e(){console.log(t,arguments)}}})(jQuery.noConflict(true),window,giscloud||{});(function(r,e){"use strict";e.addEventsInterface=function e(t,i){var n;if(i==null){n=r({})}else{n=i}function o(e,t){if(typeof e==="string"){return new r.Event(e,{instance:t})}if(e instanceof r.Event){if(!e.instance){e.instance=t}return e}return null}function s(e){if(r.isFunction(n)){return r(n.call(e,e))}return r(n)}r.extend(t,{trigger:function e(t){var i=o(t,this),n=s(this),r;if(!i){throw"No event defined."}r=[i].concat(Array.prototype.slice.call(arguments,1));n.trigger.apply(n,r);return this},triggerHandler:function e(t){var i=o(t,this),n=s(this),r;if(!i){throw"No event defined."}r=[i].concat(Array.prototype.slice.call(arguments,1));n.triggerHandler.apply(n,r);return this},on:function e(){var t=s(this);t.on.apply(t,Array.prototype.slice.call(arguments));return this},off:function e(){var t=s(this);t.off.apply(t,Array.prototype.slice.call(arguments));return this},one:function e(){var t=s(this);t.one.apply(t,Array.prototype.slice.call(arguments));return this},bind:function e(){return this.on.apply(this,Array.prototype.slice.call(arguments))},unbind:function e(){return this.on.apply(this,Array.prototype.slice.call(arguments))}})}})(giscloud.exposeJQuery(),giscloud.common());(function(e,t,i,n){function s(e){var t=Array.prototype.slice.call(arguments,1),i,n,r,o;for(n=0,r=t.length;n<r;n++){o=t[n]||{};for(i in o){if(o.hasOwnProperty(i)){e[i]=o[i]}}}return e}i.LayerClassSetOptions=function(e,t){e.options=s({},e.options,t);return e.options};i.LayerClass=function(){};i.LayerClass.extend=function(e){var t=function(){if(this.initialize){this.initialize.apply(this,arguments)}if(this._initHooks){this.callInitHooks()}};var i=function(){};i.prototype=this.prototype;var n=new i;n.constructor=t;t.prototype=n;for(var r in this){if(this.hasOwnProperty(r)&&r!=="prototype"){t[r]=this[r]}}if(e.statics){s(t,e.statics);delete e.statics}if(e.includes){s.apply(null,[n].concat(e.includes));delete e.includes}if(e.options&&n.options){e.options=s({},n.options,e.options)}s(n,e);n._initHooks=[];var o=this;n.callInitHooks=function(){if(this._initHooksCalled){return}if(o.prototype.callInitHooks){o.prototype.callInitHooks.call(this)}this._initHooksCalled=true;for(var e=0,t=n._initHooks.length;e<t;e++){n._initHooks[e].call(this)}};return t}})(window,giscloud.exposeJQuery(),giscloud.common());(function(window,giscloud,gcCommon){window.createFlashnavigator=function createFlashnavigator(){var flashnavigator,flashnavigator2;var fnCanvas2=function(u){"use strict";var l=giscloud.exposeJQuery(),a=[],s=0,c={handlers:[]},n=false,o=false,d=false,f=false,r=1.1.toLocaleString().match(/\D/)[0],h=null,p="",g=6371e3,m=true,v={},y={},_={},b=[],e,w;function x(e){return typeof e=="string"&&parseInt(e.replace(/s(\d+)/,"$1"),10)}function k(e){return"s"+e}function i(e){if(e!=null){return giscloud.Color.fromHex(e).hex()}return null}function C(e){this.id=e;this.attributes={};this.removed=false;this.clear=function(){this.removed=true};this.wkt=function(){var e=w.currentShapeGeometry();if(!e)return null;return D(e.currentlyDrawing,e.points,true)};this.edit=function(){}}function t(){var e=a.length;a.push(new C(k(e)));s++;return e}function L(e){var t=a[e],i;if(t instanceof C){a.splice(e,1);s--}i=t.attributes;return i}function T(e,t){var i,n,r;n=e.geometries||e.polygons||e.rings||e.lines||e.points||null;if(n===null){return u.toInternalCoords(e.x,e.y,e.z,t,true)}r=[];for(i in n){if(n.hasOwnProperty(i)){r.push(T(n[i],t))}}return r}function j(e,t,i,n){var r=T(e,i);return u.getViewerGeometry(e,t,r,n)}function M(e,t){var i=t&&t.points&&t.points.length;if(e!=null&&i){e.points=t.points.map(function(e){return u.toInternalCoords(e.x,e.y,e.z,undefined,true)});e.draw()}}function I(e){if(e._snapPoint){if(e._snapPoint.z!=null){return new giscloud.geometry.Point(e._snapPoint.x,e._snapPoint.y,e._snapPoint.z)}return new giscloud.geometry.Point(e._snapPoint.x,e._snapPoint.y)}return u.fromInternalCoords(e,true)}function D(e,t,i){var n,r;if(t.length){switch(e){case"point":r=I(t[0]);n=new giscloud.geometry.Point(r.x,r.y);break;case"line":r=l.map(t,function(e){var t=I(e);return new giscloud.geometry.Point(t.x,t.y)});n=new giscloud.geometry.Line(r);break;case"polygon":r=l.map(t,function(e){var t=I(e);return new giscloud.geometry.Point(t.x,t.y)});n=new giscloud.geometry.Polygon([new giscloud.geometry.Line(r)]);break}}if(!n){return null}return i?n.toOGC():n}function S(e){l(c).triggerHandler(e.type+".fnCanvas2",[{id:this.id,type:e.type}])}function P(e,t){if(!e.on)return;e.on("click dblclick mousedown mouseover mouseout",S,t)}function E(e,t){this.id=e;this.color=i(t.color)||"#000000";this.fill=i(t.fill)||"#ffffff";this.alpha=t.alpha!=null?t.alpha:1;this.width=t.width!=null?t.width:8;this.border=t.border!=null?t.border:1;this.borderRadius=t.shape==="circle"?this.width+this.border:0;this.cursor=null;this.point=null;if(this.alpha>1){this.alpha=this.alpha/100}}E.prototype={draw:function(){this.point=u.newViewerGeometry("Point",this.cursor,{color:this.color,opacity:this.alpha,weight:this.width,width:this.width,fill:this.fill,border:this.border,borderRadius:this.borderRadius,parentShape:this},this.visibility!==false);P(this.point,this)},clear:function(){u.removeGeom(this.point);this.point=null;this.cursor=null},edit:function(e){u.enableGeometryEdit(this,e)},geom:function(){var e=this.point.isMarker?this.cursor:this.point;if(e){var t=u.fromViewerGeometry(e,this.hasZ);return t}return null},wkt:function(){var e=this.point.isMarker?this.cursor:this.point,t;if(e){t=u.fromViewerGeometry(e,this.hasZ);return t?t.toOGC():""}return null},redraw:function(){var e=this.cursor;this.clear();this.cursor=e;this.draw()}};function O(e,t){this.id=e;this.color=i(t.color)||"#ff0088";this.alpha=t.alpha!=null?t.alpha:1;this.width=t.width!=null?t.width:1;this.cursor=null;this.lines=[];this.points=[];if(this.alpha>1){this.alpha=this.alpha/100}}O.prototype={currentLine:function(){return this.lines[this.lines.length-1]},draw:function(){var e=u.newViewerGeometry("LineString",this.points,{color:this.color,opacity:this.alpha,weight:this.width},this.visibility!==false);this.lines.push(e)},addLine:function(){var e=u.newViewerGeometry("LineString",[this.cursor],{color:this.color,opacity:this.alpha,weight:this.width},this.visibility!==false);this.lines.push(e);P(e,this)},extendLine:function(){var e=this.currentLine();if(e){u.extendLineGeometry(e,this.cursor)}},edit:function(e){var t=this.currentLine();u.enableGeometryEdit(t,e)},geom:function(){var e=this.currentLine();if(e){return u.fromViewerGeometry(e,this.hasZ)}return null},wkt:function(){var e=this.currentLine(),t;if(e){t=u.fromViewerGeometry(e,this.hasZ);return t?t.toOGC():""}return null},redraw:function(){var e=this.points;this.clear();this.points=e;this.draw()},clear:function(){var e,t;for(e=0,t=this.lines.length;e<t;e++){u.removeGeom(this.lines[e]);this.lines[e]=null}this.lines=[];this.cursor=null;this.points=null}};function A(e,t){this.id=e;this.color=i(t.color)||"#ff0088";this.alpha=t.alpha!=null?t.alpha:1;this.width=t.width!=null?t.width:1;this.ring=null;this.polygon=null;if(this.alpha>1){this.alpha=this.alpha/100}}A.prototype={draw:function(){this.polygon=u.newViewerGeometry("Polygon",this.ring,{color:this.color,opacity:this.alpha,weight:this.width},this.visibility!==false);P(this.polygon,this)},clear:function(){u.removeGeom(this.polygon);this.polygon=null;this.ring=null},edit:function(e){u.enableGeometryEdit(this,e)},geom:function(){var e=this.ring,t;if(e){t=u.fromViewerGeometry(this.polygon,this.hasZ);return t}return null},wkt:function(){var e=this.ring,t;if(e){t=u.fromViewerGeometry(this.polygon,this.hasZ);return t?t.toOGC():""}return null},redraw:function(){var e=this.ring;this.clear();this.ring=e;this.draw()}};function N(e,t){this.id=e;this.color=i(t.color)||"#ff0088";this.alpha=t.alpha!=null?t.alpha:1;this.width=t.width!=null?t.width:1;this.shapes=null;this.featureGroup=null;this.type="multi";this.multiType="";if(t.geom){if(t.geom instanceof giscloud.geometry.Multipoint){this.multiType="MultiPoint"}if(t.geom instanceof giscloud.geometry.Multiline){this.multiType="MultiLineString"}if(t.geom instanceof giscloud.geometry.Multipolygon){this.multiType="MultiPolygon"}}if(this.alpha>1){this.alpha=this.alpha/100}}N.prototype={draw:function(){this.featureGroup=u.newViewerGeometry(this.multiType,this.shapes,{color:this.color,opacity:this.alpha,weight:this.width,isMulti:true},this.visibility!==false);P(this.featureGroup,this)},clear:function(){u.removeGeom(this.featureGroup);this.shapes=null;this.featureGroup=null},edit:function(e){u.enableGeometryEdit(this,e)},redraw:function(){var e=this.shapes;this.clear();this.shapes=e;this.draw()},geom:function(){var e=this.featureGroup.hasGeom?this.featureGroup:this.shapes;var t=u.fromViewerGeometry(e,this.hasZ);if(!t){return null}else if(t instanceof giscloud.geometry.Multipoint||t instanceof giscloud.geometry.Multiline||t instanceof giscloud.geometry.Multipolygon){return t}else if(t.length===1&&t[0]instanceof giscloud.geometry.Multipoint||t[0]instanceof giscloud.geometry.Multiline||t[0]instanceof giscloud.geometry.Multipolygon){return t[0]}switch(this.type){case"point":if(!Array.isArray(t)){t=[t]}return new giscloud.geometry.Multipoint(t);case"line":return new giscloud.geometry.Multiline(t);case"polygon":return new giscloud.geometry.Multipolygon(t);default:return new giscloud.geometry.GeometryCollection(t)}},wkt:function(){var e=this.featureGroup.hasGeom?this.featureGroup:this.shapes;var t=u.fromViewerGeometry(e,this.hasZ);if(!t){return null}else if(t instanceof giscloud.geometry.Multipoint||t instanceof giscloud.geometry.Multiline||t instanceof giscloud.geometry.Multipolygon){return t.toOGC()}else if(t.length===1&&t[0]instanceof giscloud.geometry.Multipoint||t[0]instanceof giscloud.geometry.Multiline||t[0]instanceof giscloud.geometry.Multipolygon){return t[0].toOGC()}switch(this.type){case"point":return new giscloud.geometry.Multipoint(t).toOGC();case"line":return new giscloud.geometry.Multiline(t).toOGC();case"polygon":return new giscloud.geometry.Multipolygon(t).toOGC();default:return new giscloud.geometry.GeometryCollection(t).toOGC()}}};this.fn=u;function R(e){var t=w.currentlyDrawing();if((e.shiftKey||e.metaKey)&&t==="polygon"){w.rectangleMode(true);l(document).one("keyup",function e(t){if(!t.ctrlKey&&!t.metaKey){w.rectangleMode(false);l(document).one("keydown",R)}else{l(document).one("keyup",e)}});e.preventDefault()}else if(f&&e.which===8){e.preventDefault();z(e);l(document).one("keydown",R)}else{l(document).one("keydown",R)}}function z(e){var t,i;var n=w.currentlyDrawing();if(!n||n==="point"||n==="rectangle"||!(e.which===8||e.which===46||e.which===190||e.which===44||e.which===188||e.which===110||e.which===r.charCodeAt(0)||e.which>=48&&e.which<=57))return;if(!w.getPoint(-2)){return}f=true;if(e.which===8){if(p.length){p=p.slice(0,-1)}}else if(e.which===46||e.which===44||e.which===r.charCodeAt(0)){t=p+r}else{i=String.fromCharCode(e.which);t=p+i}if(!isNaN(parseFloat(t))){p=t}w.handleNumericKeypress();if(!p){F()}else{H(p)}}function H(e){var t,i,n,r;if(!f)return;if(!h){h=u.newMarker(null,{icon:{className:"gc-map-tip gc-input-label",type:"div"},clickable:false}),u.addComponentToMap(h)}t=l(h._icon).find(".gc-map-tip-mock-input");i=w.getPoint(-2);n=w.getPoint(-1);r={lat:(n.lat+i.lat)/2,lng:(n.lng+i.lng)/2};if(e==null){e=p}if(!t.length){t=l("<span/>",{class:"gc-map-tip-mock-input",text:e});h.html(t[0])}else{t.text(e)}h.setLatLng(r)}function F(){if(!h)return;h.remove();h=null;f=false;p=""}function W(e){if(e.which===27){if(f){F();f=false}else{w.cancel()}}else if(e.which===13){if(f){w.addPoint(true);f=false;F()}else{w.end()}}else{return true}e.preventDefault();e.stopPropagation()}var B=this;function G(){var e=w.currentShapeGeometry();if(f){H();B.hideMeasureMarker()}else if(o&&(e&&e.points.length>=1)){F()}else{F();B.hideMeasureMarker(1)}if(!o){return}if(!e){return}if(e.currentlyDrawing==="rectangle"){var t=w.getPoint(0);var i=w.getPoint(1);var n=w.getPoint(3);var r=w.getPoint(4);if(!t||!i||!n||!r){return}B.showMeasureMarker(1,t,i);B.showMeasureMarker(2,n,r)}else{var t=w.getPoint(-2);var i=w.getPoint(-1);if(t&&i){B.showMeasureMarker(1,t,i)}}}this.getInputValue=function(){if(f){var e=parseFloat(p.replace(r,"."));if(!isNaN(e)){return e}}return null};this.getOverridenPoint=function(e){var t;if(this.snapping()){t=this.checkForSnapping(e)}else{t=e}var i=w.getPoint(-3);var n=w.getPoint(-2);if(i&&n&&d){t=closestPerpendicular(i,n,t)}var r=this.getInputValue();if(r!==null){if(u.epsg==="900913"||u.epsg==="3857"){t=$(n,t,r,u.measureUnit)}else{t=q(n,t,r)}}return t};function q(e,t,i){var n,r,o,s,a,l;n=u.fromInternalCoords(e);r=u.fromInternalCoords(t);o=new giscloud.geometry.Point(r.x-n.x,r.y-n.y);s=Math.sqrt(o.x*o.x+o.y*o.y);a=new giscloud.geometry.Point(i*o.x/s,i*o.y/s);l=new giscloud.geometry.Point(n.x+a.x,n.y+a.y);return u.toInternalCoords(l.x,l.y)}function $(e,t,i,n){var r=giscloud.fromMeters(n,g),o=Math.PI/180,s=e.lat*o,a=t.lat*o,l=e.lng*o,c=t.lng*o,u=Math.sin(c-l)*Math.cos(a),d=Math.cos(s)*Math.sin(a)-Math.sin(s)*Math.cos(a)*Math.cos(c-l),f=Math.atan2(u,d),h,p;h=Math.asin(Math.sin(s)*Math.cos(i/g)+Math.cos(s)*Math.sin(i/g)*Math.cos(f));p=l+Math.atan2(Math.sin(f)*Math.sin(i/g)*Math.cos(s),Math.cos(i/g)-Math.sin(s)*Math.sin(h));return{lat:h/o,lng:p/o}}this.add=function(n){var r=t(),o=k(r),s=this;V();J();this.init();l(document).one("keydown",R);l(document).keypress(z);l(document).keyup(W);u.on("mousemove",G);w.start(n).always(function(){s.hideMeasureMarker()}).progress(function(e,t,i){if(!i){F()}l(c).triggerHandler("draw.fnCanvas2",[D(e,t),i])}).done(l.proxy(function(e,t){s.hideMeasureMarker();var i=D(n,e,true);if(i){this.deserializeGeometryOpenGISSimple({geom:i},o);if(!t){l(c).triggerHandler("add.fnCanvas2",[{id:o,geom:i,gtype:n}])}}else{if(a[r]instanceof C){L(r)}}},this)).fail(l.proxy(function(e){s.hideMeasureMarker();L(r);if(!e){l(c).triggerHandler("add.fnCanvas2",[{id:null,geom:null,gtype:n}])}},this));return o};this.endDraw=function(e){if(e&&e.cancel){w.cancel()}else if(e&&e.noEvent){w.end(true)}else{w.end()}ne()};this.addEventListener=function(e,t){var i=function(){var e=Array.prototype.slice.call(arguments,1);return t.apply(this,e)};l(c).on(e+".fnCanvas2",i);c.handlers.push({original:t,wrapped:i})};this.removeEventListener=function(e,i){var n,r;l.each(c.handlers,function(e,t){if(t.original===i){r=e;n=t.wrapped}});if(r==null||c.handlers[r]==null){return}l(c).off(e+".fnCanvas2",n);delete c.handlers[r].wrapped;c.handlers.splice(r,1)};this.setAttributeGeometry=function(e,t,i,n){var r=a[x(e)];if(r){if(r instanceof C){r.attributes[t]=i}else{r[t]=i;if(!n){r.redraw()}}}return e};this.getAttributeGeometry=function(e,t){var i=a[x(e)];if(!i){return null}return i[t]};this.getGeometry=function(e){var t=a[x(e)];if(!t){return null}return t.geom()};this.setGeometryVisible=function(e,t){var i=a[x(e)],n;if(i){if(i instanceof C){i.attributes[attribute]=value}else{i.visibility=t;i.redraw()}}return e};this.newShape=function(e,t){var i,n,r,o;this.init();if(t!=null){n=x(t);r=a[n];if(r instanceof C){o={};l.extend(o,r.attributes,e);i=t;a[n]=new O(t,o);if(r.removed){this.remove(t)}}else{throw"Invalid ID for a reserved shape slot."}}else{i=k(s);a.push(new O(t,e));s++}return i};this.newLineShape=this.newShape;this.newPointShape=function(e,t){var i,n,r,o;if(t!=null){n=x(t);r=a[n];if(r instanceof C){o={};l.extend(o,r.attributes,e);i=t;a[n]=new E(t,e);if(r.removed){this.remove(t)}}else{throw"Invalid ID for a reserved shape slot."}}else{i=k(s);a.push(new E(t,e));s++}return i};this.newPolygonShape=function(e,t){var i,n,r,o;if(t!=null){n=x(t);r=a[n];if(r instanceof C){o={};l.extend(o,r.attributes,e);i=t;a[n]=new A(t,e);if(r.removed){this.remove(t)}}else{throw"Invalid ID for a reserved shape slot."}}else{i=k(s);a.push(new A(t,e));s++}return i};this.newMultiShape=function(e,t){var i,n,r,o;if(t!=null){n=x(t);r=a[n];if(r instanceof C){o={};l.extend(o,r.attributes,e);i=t;a[n]=new N(t,e);if(r.removed){this.remove(t)}}else{throw"Invalid ID for a reserved shape slot."}}else{i=k(s);a.push(new N(t,e));s++}return i};this.moveTo=function(e,t,i,n){var r=a[x(e)];if(r){n=n!=null?n:r.hasZ?0:null;r.cursor=this.fn.toInternalCoords(t,i,n,undefined,true);r.addLine();return e}};this.lineTo=function(e,t,i,n){var r=a[x(e)];if(r){n=n!=null?n:r.hasZ?0:null;r.cursor=this.fn.toInternalCoords(t,i,n,undefined,true);r.extendLine();return e}};this.remove=function(e){var t=x(e),i=a[t];if(i){i.clear();a[t]=null;return e}};this.removeAll=function(){var e,t;for(e=0,t=a.length;e<t;e++){this.remove(k(e))}};this.clear=this.removeAll;this.editGeometry=function(e){var t=a[x(e)];var i=this;if(t){this.init();V();J();w.initEdit();if(t instanceof E&&t.point.isMarker){t.point.on("drag",function(){if(n)t.point.setLatLng(i.checkForSnapping(t.point._latlng))}).on("dragend",function(){if(n)u.parent.hideTip()})}t.edit();return e}return null};this.editGeometryEnd=function(e){var t=a[x(e)];if(t){if(this.snapping())w.endSnapping();t.edit(false);this.measureDisplay(false);return e}return null};this.redrawGeometry=function(e){var t=a[x(e)];if(t){t.redraw()}};this.addShape=function(e,t,i){var n=e.geom,r,o,s;this.init();if(n instanceof giscloud.geometry.Point){r=this.newPointShape(e,t);s=x(r);o=a[s];o.cursor=this.fn.toInternalCoords(n.x,n.y,n.z,i,true);o.hasZ=n.hasZ();o.draw()}else if(n instanceof giscloud.geometry.Multipoint){r=this.newMultiShape(e,t);s=x(r);o=a[s];o.shapes=j(n,{color:o.color,opacity:o.alpha>1?o.alpha/100:o.alpha,weight:o.width},i,true);o.type="point";o.hasZ=n.hasZ();o.draw()}else if(n instanceof giscloud.geometry.Line){r=this.newLineShape(e,t);s=x(r);o=a[s];o.hasZ=n.hasZ();M(o,n)}else if(n instanceof giscloud.geometry.Multiline){r=this.newMultiShape(e,t);s=x(r);o=a[s];o.shapes=j(n,{color:o.color,opacity:o.alpha>1?o.alpha/100:o.alpha,weight:o.width},i,true);o.type="line";o.hasZ=n.hasZ();o.draw()}else if(n instanceof giscloud.geometry.Polygon){r=this.newPolygonShape(e,t);s=x(r);o=a[s];o.ring=n.rings[0].points.map(function(e){return u.toInternalCoords(e.x,e.y,e.z,i,true)});o.hasZ=n.hasZ();o.draw()}else if(n instanceof giscloud.geometry.Multipolygon){r=this.newMultiShape(e,t);s=x(r);o=a[s];o.shapes=j(n,{color:o.color,opacity:o.alpha>1?o.alpha/100:o.alpha,weight:o.width},i,true);o.type="polygon";o.hasZ=n.hasZ();o.draw()}else if(n instanceof giscloud.geometry.Multipoint){r=this.newMultiShape(e,t);s=x(r);o=a[s];o.shapes=j(n,{color:o.color,opacity:o.alpha>1?o.alpha/100:o.alpha,weight:o.width},i,true);o.type="point";o.hasZ=n.hasZ();o.draw()}else if(n instanceof giscloud.geometry.GeometryCollection){r=this.newMultiShape(e,t);s=x(r);o=a[s];o.shapes=l.map(n.geometries,function(e){return j(e,{color:o.color,opacity:o.alpha>1?o.alpha/100:o.alpha,weight:o.width},i)});o.hasZ=n.hasZ();o.draw()}else{throw{error:"Unknown giscloud geometry type.",data:e}}if(t==null&&o&&o.id==null&&r!=null){a[s].id=r}return r};this.serializeGeometryOpenGIS=function(e){var t=a[x(e)];if(t){return t.wkt()}return null};this.deserializeGeometryOpenGISSimple=function(e,t,i){var n=e&&e.geom,r=n&&giscloud.geometry.fromOGC(n);if(!r){throw"Cannot deserialize from OGC, unknown giscloud geometry type."}e.geom=r;return this.addShape(e,t,i)};this.measureDisplay=function(e){if(e==null){return o}o=!!e;if(!o)this.hideMeasureMarker();return this};var U={};this.showMeasureMarker=function(e,t,i){if(!this.measureDisplay())return;if(!e){e=1}var n=U[e],r,o;if(!n){U[e]=this.fn.newMarker(null,{icon:{className:"gc-map-tip",type:"div"},clickable:false});n=U[e];this.fn.addComponentToMap(n)}r={lat:(i.lat+t.lat)/2,lng:(i.lng+t.lng)/2};o=this.fn.calculateDistance(t.lat,t.lng,i.lat,i.lng);n.setLatLng(r);n.text(this.fn.measureLabelFunction(o))};this.hideMeasureMarker=function(e){if(!e){this.hideMeasureMarker(1);this.hideMeasureMarker(2);return}var t=U[e];if(!t)return;t.remove();U[e]=null};this.cleanUp=function(){f=false;p="";l(document).off("keyup",W);l(document).off("keypress",z);u.off("mousemove",G);F()};this.init=function(){u.initDrawing(w)};this.initDrawingController=function(e){w=u.getDrawingController(this)};this.initDrawingController();this.deserializeGeometryOpenGIS=this.deserializeGeometryOpenGISSimple;this.snapping=function(e){if(e==null){return n}n=!!e;if(n){J()}else{this.fn.parent.hideTip()}return this};this.snappingLayers=function(e){if(e==null){return v}for(var t in e){if(!e[t])_[t]=null}v=e;return this};this.canSnap=function(e){if(e==null){return m}m=e};this.setSnappingLayerFids=function(e,t){y[e]=t};function V(){w.initSnapping();u.parent.scaleChange(Q);u.parent.dragEnd(Q);var e=u.parent.layers;for(var t in e){if(e[t].instance&&!e[t].instance.isGroupLayer){e[t].instance.on("tileload",Z)}}}var Y;function Z(){clearTimeout(Y);Y=window.setTimeout(X,50)}function X(){if(giscloud.ui&&giscloud.ui.edit)giscloud.ui.edit.enableDisableSnapping();Q()}function J(){var e=u.parent.layers,t=u,i=u&&u.epsg,n,r,o=u.parent.bounds().toString();if(!t)return;b=[];if(!m)return;for(var s,a=0;a<e.length;a++){s=e[a];if(!v[s.id.toString()]||!s.visible()){continue}if(s.type&&l.inArray(s.type,["tile","wms","wfs","wmts","raster","folder"])>-1){continue}n={geometry:"wkt",epsg:i,requestByPost:true,noattrib:true,layerName:s.name};if(y[s.id]){r=te(s.id);if(r.length===0)continue;n.fids=r.join(",")}giscloud.features.byBounds(s.id,o,n).done(ee)}}function Q(){window.clearTimeout(e);e=window.setTimeout(J,500)}function K(e,t,i){var n,r;r=e.geometries||e.polygons||e.rings||e.lines||e.points||null;if(r===null){t.push({x:e.x,y:e.y,z:e.z,layerName:i})}for(n in r){if(r.hasOwnProperty(n)){K(r[n],t,i)}}}function ee(e,t,i,n){if(!_[i]){_[i]={layerName:n.layerName,geom:{}}}var r,o=_[i].geom;l.map(e,function(e){r=giscloud.geometry.fromOGC(e.geometry);K(r,b,n.layerName);o[e.id]=r})}function te(e){var t=_[e],i=y[e];if(!t)return i;var n,r=i.length,o=[],s=t.layerName,a=t.geom;for(n=0;n<r;n++){if(a[i[n]]){K(a[i[n]],b,s)}else{o.push(i[n])}}return o}function ie(e,t){return Math.sqrt((e.x-t.x)*(e.x-t.x)+(e.y-t.y)*(e.y-t.y))}this.hideSnappingTooltip=function(){u.parent.hideTip()};this.checkForSnapping=function(e){var t=u.fromInternalCoords(e);var i=u.parent.scale();var n=7/u.calculateScaleZoom(i);var r=null;var o=null;var s;var a=t.hasZ();for(var l=0,c=b.length;l<c;l++){s=ie(t,b[l]);if(s<n){n=s;o=b[l];r=u.toInternalCoords(o.x,o.y,a?o.z:null,true);r._snapPoint=o}}if(r){e=r;u.parent.showTip(["<span class='gc-map-tip-snap-icon'>",o.layerName.replace(/ /g,"&nbsp;"),"</span>"].join(""),true)}else{u.parent.hideTip()}return e};function ne(){w.endSnapping();u.parent.unbind("scaleChange",Q);u.parent.unbind("dragEnd",Q);u.parent.hideTip();var e=u.parent.layers;for(var t in e){if(e[t].instance&&!e[t].instance.isGroupLayer){e[t].instance.off("tileload",Z)}}_={};y={}}};var fnMarker2=function(h){"use strict";var g=giscloud.exposeJQuery(),a={},m={},v={},s={bottom:{x:1,y:0},top:{x:1,y:2},left:{x:2,y:1},right:{x:0,y:1},center:{x:1,y:1}},y=0;this.fn=h;this.markers={};function l(e,t,i){var n,r={x:e/2,y:t/2},o;if(i){o=i.split("-");while(i=o.pop()){n=s[i]?s[i]:s["center"];r.x*=n.x;r.y*=n.y}}return r}function p(n,e,t,r){var o=giscloud.md5(n+"_"+r);if(!a[o]){a[o]={loading:new g.Deferred,icon:null};if(e!=null&&t!=null){a[o].icon={iconUrl:n,shadowUrl:null,iconSize:{x:e,y:t},iconAnchor:l(e,t,r),labelAnchor:{x:Math.max(e,t)*1.5+5,y:0},wrapperAnchor:{x:e,y:t}};a[o].loading.resolve(a[o])}else if(!n&&0){a[o].loading.resolve(a[o])}else{var s=new Image;s.onload=function(){var e,t=s.width,i=s.height;if(t===1&&i===1){if(s.naturalWidth!=null){t=s.naturalWidth;i=s.naturalHeight}else{e=new Image;e.src=s.src;t=e.width||0;i=e.height||0}}a[o].icon={iconUrl:n,shadowUrl:null,iconSize:{x:t,y:i},iconAnchor:l(t,i,r),labelAnchor:{x:Math.max(t,i)*1.5+5,y:0},wrapperAnchor:{x:t,y:i}};a[o].loading.resolve(a[o])};s.src=n}}return a[o]}function _(e){var t=e.title,i=e.content,n=e.color,r=e.open,o=new giscloud.Color.fromHex(n),s="";if(t!=null){s+='<p class="gc-info-popup-title" style="background-color: '+n+"; color: "+(o.hsl()[2]>85?"black":"white")+';">'+t+"</p>"}if(r&&i!=null){s+='<div class="gc-info-popup-content">'+i+"</div>"}return s}this.add=function(e,t,i,n,r,o,s){var a,l,c,u,d,f,h,p=this;if(e.x&&e.y){o=e.icon;n=e.title;r=e.content;i=e.color;s=e.open;t=e.y;e=e.x}s=!!s;if(i==null){i="#0092E4"}else{if(i instanceof giscloud.Color){i=i.hex()}else{i=giscloud.Color.fromHex(i).hex()}}a=this.fn.toInternalCoords(e,t);l=this.fn.newPopup({className:"gc-info-popup",minWidth:180,closeButton:true});l._fnMarker={x:e,y:t,color:i,title:n,content:r,icon:o,open:s};c=_(l._fnMarker);l.move(a);l.setContent(c);u="m"+y;y++;this.fn.addComponentToMap(l);l.on("click",function(){g(p).triggerHandler("click",{id:u,data:v[u]})});this.markers[u]=l;m[u]=new g.Deferred;m[u].resolve(l);l.on("mousemove mouseup",function(e){e.stopPropagation()}).on("click",".gc-info-popup-title",function(){p.toggle(u)}).on("click",".gc-info-edit-link",function(e){e.stopPropagation();if(window.checkIfUserExceedsStorageLimits&&window.checkIfUserExceedsStorageLimits()){return window.showStorageForbiddenMsg()}var t=g(this).parent(),i=t.find("[name=edit-layer-id]").val(),n=t.find("[name=edit-feature-id]").val();if((!i||!n)&&(g(this).attr("featureId")&&g(this).attr("layerId"))){i=g(this).attr("layerId");n=g(this).attr("featureId");gcapp.selo.clearSelection();gcapp.selo.selectOnMap({lid:i,fids:[n]});giscloud.features.byId(i,n).done(function(e){gcapp.selo.showRecordInfo(e)}).fail(function(e){console.log(e)});return}g(p).triggerHandler("gc-info-popup-edit-click",{layerId:i,featureId:n})});return u};this.setTitle=function(e,t){var i=this.markers[e],n;if(i){i._fnMarker.title=t;n=_(i._fnMarker);i.setContent(n)}return this};this.setContent=function(e,t){var i=this.markers[e],n;if(i){i._fnMarker.content=t;n=_(i._fnMarker);i.setContent(n)}return this};this.toggle=function(e){var t=this.markers[e],i;if(t){t._fnMarker.open=!t._fnMarker.open;i=_(t._fnMarker);t.setContent(i);t.fire("toggle",[e,t._fnMarker.open])}return this};this.remove=function(e){var t=this.markers[e];if(t){t.remove();delete this.markers[e];delete m[e]}};this.removeAll=function(){var e;for(e in this.markers){this.remove(e)}};this.closeAll=function(){var e;for(e in this.markers){if(this.markers[e]._type==="popup"){this.remove(e)}}};this.clear=this.closeAll;this.loadPoi=function(a,l,e,c,u,t,i,n,r){var o,d,f,s;d=this;o=new g.Deferred;f="m"+y;m[f]=new g.Deferred;v[f]=c;y++;s=p(e,t,i,r);s.loading.done(function(e){var t,i,n,r,o;var s={clickable:u};if(e.icon){s.icon=e.icon}if(c.hoverText){s.title=c.hoverText}t=d.fn.toInternalCoords(a,l);i=h.newMarker(t,s);h.addComponentToMap(i);if(c.popupContent){i.bindPopup(c.popupContent,{className:"gc-info-popup",autoPan:false})}i.on("click",function(){g(d).triggerHandler("click",{id:f,data:v[f]})});d.markers[f]=i;if(c.popupContent&&c.popupVisible){i.openPopup()}m[f].resolve(i)});return f};this.move=function(e,i,n,r){var o,t;t=m[e];if(t){o=this;t.done(function(e){var t;if(e&&e.setLatLng){t=o.fn.toInternalCoords(i,n);e.setLatLng(t);if(e.setRotation&&r){e.setRotation(r)}}})}};this.attachLabel=function(t){var e=m[t.marker];if(e){e.done(function(e){e.setLabel(t.data)})}};this.getObject=function(e){return this.markers[e]};this.ready=function(e){return m[e]}};var fnTooltip2=function(r){"use strict";var s=giscloud.exposeJQuery(),a=true,i=false,l=false,t={className:"gc-map-tip",type:"div"},c={},n,u;function e(e){if(e){r=e}n=r.newMarker(null,{icon:t,clickable:false});r.addEventListener("load",p);r.addEventListener("reload",p);r.addEventListener("object_over",d);r.addEventListener("object_out",f);r.off("mousemove",v).on("mousemove",v)}function o(){r.removeEventListener("load",p);r.removeEventListener("reload",p);r.removeEventListener("object_over",d);r.removeEventListener("object_out",f);r.off("mousemove",v);h()}function d(e){var t,i,n,r,o;if(!a||l){return}t=e.id.split("||");i=t[0].substr(5);n=c[i];r=e.object.attributes||e.object.data;if(!n||!r){return h()}o=n.split(",");u=s.map(o,function(e){return giscloud.xssSafe(r[e])});return m(u.join("<br/>"),true)}function f(){if(l){return}u=null;h()}function h(){if(i){n.remove();i=false}}function p(){var e,t,i,n;c={};for(e=0,t=r.getLayerCount();e<t;e++){i=r.getLayer(e);n=parseInt(i.id.substr(5),10);if(i&&i.options){c[n]=i.options.tooltip}}}function g(e,t){if(!e){h()}if(n){if(t){n.html(e)}else{n.text(e)}}}function m(e,t){if(!a){return}if(!i){r.addComponentToMap(n);i=true}g(e,t)}function v(e){if(i){n.move(e)}}this.show=function e(t,i){m(t,i);l=true};this.hide=function e(){h();l=false};this.enable=function e(){a=true};this.disable=function e(){a=false;h()};e();this.init=e;this.deinit=o};var fnAgent2=function(e){this.setData=function(e){};this.setZoom=function(e){}};(function(window,$,common,undefined){var lv,initialized,bounds,unitFactor,unit,units,unit_label,sources_map,enabled_dragging,loaded,tileLayerCount,internalViewers={},viewerContainer,labelLayer,LabelLayer,fnLayerBasic,fnLayer2,fnTileLayer,fnTileLayerGroup,fnBasemapLayer,fnRasterLayer,fnQuadLayer,fnWmsLayer;tileLayerCount=0;initialized=0;loaded=false;enabled_dragging=1;var giscloud_tile_url=common.tileSite();function init(){if(initialized)return;initialized=1;fnLayerBasic={options:{minZoom:0,maxZoom:18,tileSize:256,subdomains:"abc",errorTileUrl:"",attribution:"",zoomOffset:0,opacity:1},initialize:function(e,t){t=common.LayerClassSetOptions(this,t);if(typeof e==="string"){this._url=[e]}else{this._url=e}this._tiles={};var i=this.options.subdomains;if(typeof i==="string"){this.options.subdomains=i.split("")}},addToMap:function(){this.viewerLayer.addToMap()},removeFromMap:function(){this.viewerLayer.removeFromMap()},getId:function(){return this.id},loaded:function(){return this.viewerLayer&&this.viewerLayer.loaded()},disable:function(){this.visible=false;this.options.visible=false;if(this.viewerLayer){this.viewerLayer.setVisible(false)}},enable:function(){this.visible=true;this.options.visible=true;if(this.viewerLayer){this.viewerLayer.setVisible(true)}},getAlpha:function(){return Math.round(this.options.opacity*100)},setAlpha:function(e){if(flashnavigator.hasCanvas){this.setOpacity(e/100)}},update:function(){if(this.viewerLayer){this.viewerLayer.update()}},setZIndex:function(e){if(this.viewerLayer){this.viewerLayer.setZIndex(e)}},setOpacity:function(e){this.options.opacity=e;if(this.viewerLayer){this.viewerLayer.setOpacity(e)}},getCurrentLevel:function(){return lv.map._zoom},setSelectable:function(e){this._selectable=e;return 0},getSelectable:function(){return this._selectable},getVisibility:function(){return this.visible},getBound:function(e){return{xMin:this.source.xmin,xMax:this.source.xmax,yMin:this.source.ymin,yMax:this.source.ymax}},getData:function(e){return this.source},_loadTile:function(e,t){this._processTile(e,t,t.z)},_processTile:function(e,t){e.src=this.getTileUrl(t)},redraw:function(e){if(this.gcmap){this.gcmap.redraw(0,e)}},getRules:function(){return this.features},setRule:function(e,t){this.features[e]=t},resetRules:function(){this.features=[];for(var e=0;e<this.features_original.length;e++){var t={};for(var i in this.features_original[e]){t[i]=this.features_original[e][i]}this.features[e]=t}},setDynamicMode:function(e){if(this.gcmap)this.gcmap.url=this.gcmap.url_prefix+"/dyn,"+e+"/"},reload:function(){if(this.gcmap)this.gcmap.reload()},getFeatureIds:function(e){if(this.gcmap){return this.gcmap.getFeatureIds(e)}else{e(this.id,[])}},calculateFeatureVisibility:function(){if(this.features){this.featuresVisibility=this.features.map(function(e){return e.visible?"1":"0"}).join()}},_tileShouldBeVisible:function(e){return this.viewerLayer&&this.viewerLayer.tileShouldBeVisible(e)},_tileShouldBeLoaded:function(e,t,i,n){var r=t||this;if(r.layer_info&&(r.layer_info.fromlevel&&r.layer_info.fromlevel>e.z||r.layer_info.tolevel&&r.layer_info.tolevel<e.z)){return false}if(!r.options.visible||r.useForDEM||!i&&!t&&!n&&!this.viewerLayer.tileShouldBeLoaded(e)){return false}if(r.group){for(var o=0;o<r.group.length;o++){if(this._tileShouldBeLoaded(e,r.group[o],true)){return true}}return false}this._calculateLayerBounds(r,e.z);if(e.x>=r.tileIndexXMin&&e.x<=r.tileIndexXMax&&e.y>=r.tileIndexYMin&&e.y<=r.tileIndexYMax){return true}return false},_calculateLayerBounds:function(e,t){e=e||this;if(e.calculatedLayersBoundsAtZoom===t){return}e.calculatedLayersBoundsAtZoom=t;var i=1<<t;e.tileIndexXMinFloat=(e.source.xmin-bounds.xmin)/bounds.max*i;e.tileIndexXMaxFloat=(e.source.xmax-bounds.xmin)/bounds.max*i;e.tileIndexYMinFloat=(bounds.ymax-e.source.ymax)/bounds.max*i;e.tileIndexYMaxFloat=(bounds.ymax-e.source.ymin)/bounds.max*i;if(!e.isImage){e.tileIndexXMinFloat--;e.tileIndexXMaxFloat++;e.tileIndexYMinFloat--;e.tileIndexYMaxFloat++}e.tileIndexXMin=Math.floor(e.tileIndexXMinFloat);e.tileIndexXMax=Math.floor(e.tileIndexXMaxFloat);e.tileIndexYMin=Math.floor(e.tileIndexYMinFloat);e.tileIndexYMax=Math.floor(e.tileIndexYMaxFloat)},clipTile:function(e,t){var i=false;var n,r,o,s;n=s="0px";o=r="256px";if(t.x==this.tileIndexXMin){n=Math.round((this.tileIndexXMinFloat-this.tileIndexXMin)*256)+"px";i=true}if(t.y==this.tileIndexYMin){s=Math.round((this.tileIndexYMinFloat-this.tileIndexYMin)*256)+"px";i=true}if(t.x==this.tileIndexXMax){r=Math.round((this.tileIndexXMaxFloat-this.tileIndexXMax)*256)+"px";i=true}if(t.y==this.tileIndexYMax){o=Math.round((this.tileIndexYMaxFloat-this.tileIndexYMax)*256)+"px";i=true}if(i)e.style.clip="rect("+s+","+r+","+o+","+n+")"}};fnLayer2=common.LayerClass.extend(fnLayerBasic);var n=0;fnTileLayerGroup=function(e,i){this.options=e;this.id=e.id;this.visible=e.visible;this.id=e.id;this.source=e.source;this.isGroupLayer=true;this.feature_filter=null;this.legacyHtml5Map=i;var t=e.group;this.groupId=t;this.groupIdIndex=0;fnTileLayerGroup.theTileLayer=fnTileLayerGroup.theTileLayer||{};this.setUniqueId=function(){this.uniqueId=n++};this.setFeatureFilter=function(e){var t,i,n={},r=[],o=this.tileLayer.group;this.feature_filter=e&&e.filter?e:null;for(t=0;t<o.length;t++){i=o[t].feature_filter;if(i&&i.filter&&i.attributes){n[o[t].feature_filter.attributes]=1}for(t in n){r.push(t)}}if(r.length==0){this.tileLayer.feature_filter=null}else{this.tileLayer.feature_filter={filter:true,attributes:r.join(",")}}this.tileLayer.gcmap.setupAttributes();if(flashnavigator.offscreenRendering){this.tileLayer.gcmap.workerLayerSetFilter(this.id,this.feature_filter)}};this.newTileLayer=function(){var e;var t=this.options;e=fnTileLayerGroup.theTileLayer[this.groupId]=this.tileLayer=new fnTileLayer(t,i);e.source={};e.options.visible=true;e.visible=true;e.options.opacity=1;e.id=e.options.id=this.groupId;e.isTileLayer=true;this.isRootLayer=true;e.gcmap.tileLayer=e;e.group=[];return e};this.unloadFromTiles=function(){for(var e in this.tileLayer._tiles){var t=this.tileLayer._tiles[e];if(t.gc_state.by_layer[this.id]){t.gc_state.by_layer[this.id]=null}}};this.cleanUpOnRemove=function(e,t){var i=[],n;if(!t){this.disable(true)}if(!flashnavigator.offscreenRendering){for(n in this.tileLayer._tiles){this.tileLayer.gcmap.unloadTile(this.tileLayer._tiles[n],[this.id])}}for(var r=0;r<this.tileLayer.group.length;r++){if(this.tileLayer.group[r]!==this){i.push(this.tileLayer.group[r])}}this.tileLayer.group=i;this.tileLayer._resetGroup();if(i.length==0){delete fnTileLayerGroup.theTileLayer[this.tileLayer.id];this.tileLayer.cleanUpOnRemove();this.viewer.internalViewer.removeLayer(this.tileLayer)}};this.setSelectable=function(e){this._selectable=e;if(flashnavigator.offscreenRendering){this.tileLayer.gcmap.workerLayerUpdate(this.id,{_selectable:e})}return 0};this.getSelectable=function(e){return this._selectable};this.disable=function(e){if(this.visible){var t=this;this.visible=false;this.options.visible=false;if(this.useForDEM){t.tileLayer.viewer.reloadTerrain();return}this.tileLayer.neighbour_tile_data={};var i=this.tileLayer._tiles;for(var n in i){var r=i[n];if(!flashnavigator.offscreenRendering){this.tileLayer.gcmap.unloadTile(r,[this.id])}if(r.gc_state.by_layer[this.id]){r.gc_state.by_layer[this.id]=null}}if(flashnavigator.offscreenRendering){this.tileLayer.gcmap.workerLayerUpdate(this.id,{visible:false})}if(!this.tileLayer.loaded()){this.tileLayer._resetGroup();return}this.tileLayer.resetCache();if(flashnavigator.offscreenRendering){this.tileLayer.gcmap.workerUnloadTiles(this.id);this.tileLayer._resetGroup();if(!e)this.redraw(false,-1);return}if(e)return;if(this.tileLayer._delayedGroupUpdate){clearTimeout(this.tileLayer._delayedGroupUpdate)}this.tileLayer._delayedGroupUpdate=window.setTimeout(function(){t.tileLayer._delayedGroupUpdate=null;t.tileLayer._resetGroup();t.redraw()},0)}};this.enable=function(){if(!this.visible){var e=this;this.visible=true;this.options.visible=true;if(this.useForDEM){e.tileLayer.viewer.reloadTerrain();return}if(flashnavigator.offscreenRendering){this.tileLayer.gcmap.workerLayerUpdate(this.id,{visible:true})}this.setUniqueId();this.tileLayer.gcmap.activeLayer=null;if(!this.tileLayer.loaded()){this.tileLayer._resetGroup();return}this.tileLayer.resetCache();if(!this.tileLayer._partialGroup){this.tileLayer._partialGroup=[]}this.tileLayer._partialGroup.push(this);if(this.tileLayer._delayedGroupUpdate){clearTimeout(this.tileLayer._delayedGroupUpdate)}this.tileLayer._delayedGroupUpdate=window.setTimeout(function(){e.tileLayer._delayedGroupUpdate=null;e.tileLayer._reloadGroupPartialy()},0)}};this.getAlpha=function(e){return Math.round(this.options.opacity*100)};this.setAlpha=function(e){if(e/100==this.options.opacity){return}this.options.opacity=e/100;this.tileLayer.resetCache();if(flashnavigator.offscreenRendering){this.tileLayer.gcmap.workerLayerUpdate(this.id,{opacity:this.options.opacity});this.redraw(false,-1)}else{this.redraw(false,100)}};this.redraw=function(e,t){var i=this;if(!e)e=false;if(!t)t=0;this.tileLayer.gcmap.activeLayer=this;if(t>=0){if(this.tileLayer._redrawDelay){clearTimeout(this.tileLayer._redrawDelay)}this.tileLayer._redrawDelay=window.setTimeout(function(){i.tileLayer._redrawDelay=null;i.tileLayer.redraw(e)},t)}else{i.tileLayer.redraw(e)}};this.setZIndex=function(e){if(this.tileLayer._zIndexOffset==null){this.tileLayer.setZIndex(e);this.tileLayer._zIndexOffset=e-this.tileLayer.group.length}var t=e-1-this.tileLayer._zIndexOffset;this.tileLayer._shouldRedrawDueSort=this.tileLayer.group[t]!=this;this.tileLayer.group[t]=this};this.getFeatureIds=function(e){return this.tileLayer.gcmap.getFeatureIds(e,this.id)},this.setUniqueId()};for(var e in fnLayerBasic){fnTileLayerGroup.prototype[e]=fnLayerBasic[e]}fnTileLayer=fnLayer2.extend({initialize:function(e,t){e=common.LayerClassSetOptions(this,e);this._tiles={};this.visible=e.visible;this.id=e.id;this.source=e.source;this.dontLoad=e.dontLoad;this.legacyHtml5Map=t;this.gcmap=new t.Html5Map(e,this);this.gcmap.setBounds(bounds);this.gcmap.selectablePoly(0);this.canvases_for_release=[];if(e.modifier){this.gcmap.modifier=e.modifier;if(!this.gcmap.modifier_layers){this.gcmap.modifier_layers={}}this.gcmap.modifier_layers[this.id]=1;this.gcmap.has_modifier=true}this.feature_filter=null;this.neighbour_tile_data={};var i=this;this.gcmap.reinitCanvases=function(){var t,e=Object.keys(i._tiles);e.forEach(function(e){t=i._tiles[e];i._initTile(t)})};this.abortTileRequest=function(e){this.viewer.decreaseTileCounter(e);this.gcmap.abortRequest(e)};this.onStopLoadingTiles=function(){i.gcmap.resetLoaders()};this._unloadTile=function(e){var t=e.tile;if(!t||!t.gc_state){return}if(t.transferToAnotherViewer){return}delete this._tiles[t.gc_state._tileIndex];if(flashnavigator.offscreenRendering){this.gcmap.workerUnloadTile(this.id,t.gc_state._tileIndex,t.gc_state._cacheId)}this.gcmap.unloadTile(t);if(e.imidiateRelease){if(t.getContext){this.gcmap.releaseCanvasToPool(t)}}else{this.canvases_for_release.push(t)}};this.cleanUpCanvasPool=function(){var e;while(e=i.canvases_for_release.pop()){i.viewerLayer.cleanTileCss(e);i.gcmap.releaseCanvasToPool(e)}if(flashnavigator.offscreenRendering){i.gcmap.workerCanvasPoolCleanUp()}i.gcmap.canvasPoolCleanUp()};this.onTileError=function(e){this.viewer.decreaseTileCounter(e)};this.resetCache=function(){if(this.viewerLayer){this.viewerLayer.resetCache()}};this.onZoomChange=function(){i.gcmap.resetCache();i.neighbour_tile_data={};if(i.group){i.group.forEach(function(e){if(e._img_tiles){e._img_tiles={}}})}if(flashnavigator.offscreenRendering){i.gcmap.workerLayerUpdate(i.id,{_tiles:{},neighbour_tile_data:{}})}};if(this.dontLoad){this._addTile=function(){}}e.noWrap=true},_initTile:function(e){var t=this.options.tileSize*flashnavigator.scaleRatio;e.width=t;e.height=t;e.style.width=this.options.tileSize+"px";e.style.height=this.options.tileSize+"px"},_createTile:function(e){var t=this.options.tileSize*flashnavigator.scaleRatio,i=e?{style:{}}:this.gcmap.getCanvasFromPool(t,t,true);this._initTile(i);i.gc_state={by_layer:{},_tiles_to_redraw:{}};i.ontileload=function(e){if(!this.gc_state){return}var t=this.gc_state.gc_layer;this.complete=true;if(e===undefined)e=this.gc_state.number_of_image_requests;if(e>0){return}t.viewerLayer.tileOnLoad(this);t.viewer.decreaseTileCounter(this)};return i},_loadTile:function(e,t,i){var n=e.gc_state;if(i===undefined){i=0}n.gc_layer=this;n._tileIndexX=t.x;n._tileIndexY=t.y;n._tileIndexZ=t.z;n._tileIndexWrap=i;n._tileIndex=this.gcmap.getTileKey(n._tileIndexX,n._tileIndexY,n._tileIndexZ,n._tileIndexWrap);n._xmin=0;n._ymin=0;n._tileSize=256*flashnavigator.scaleRatio;n._xmax=n._tileSize;n._ymax=n._tileSize;n._width=n._tileSize;n._height=n._tileSize;n.number_of_image_requests=0;this._tiles[n._tileIndex]=e;return this._processTile(e,t,t.z)},_processTile:function(e,t,i){e.gc_state.gc_layer=this;e.gc_state._tiles_to_redraw={};if(e.transferToAnotherViewer){delete e.transferToAnotherViewer;e.coord=t;e.zoom=i;e.complete=true}else{if(this.visible){return this.gcmap.loadTile(e,t,i)}}},redraw:function(e){this.gcmap.redraw(0,e)},render:function(e,t,i,n,r){return this.viewerLayer.render(e,t,i,n,r)},setFeatureFilter:function(e){this.feature_filter=e;this.gcmap.setupAttributes();if(flashnavigator.offscreenRendering){this.gcmap.workerLayerSetFilter(this.id,e)}},getFeature:function(e){return this.gcmap.getFeature(e)},setSelectable:function(e){this._selectable=e;if(flashnavigator.offscreenRendering){this.gcmap.workerLayerUpdate(this.id,{_selectable:e})}return 0},cleanUpOnRemove:function(){var e;for(e in this._tiles){if(this._tiles[e].getContext){this.gcmap.releaseCanvasToPool(this._tiles[e])}}},_resetGroup:function(){if(!this.group){return}var e=this.group,t=[],i=[],n={},r,o,s,a,l,c,u,d,f,h,p=false;if(e.length>0){for(f=0;f<e.length;f++){if(!p){r=e[f].source.xmin;o=e[f].source.ymin;s=e[f].source.xmax;a=e[f].source.ymax;l=e[f].tileIndexXMin;c=e[f].tileIndexYMin;u=e[f].tileIndexXMax;d=e[f].tileIndexYMax;p=true}h=e[f].source;if(!(h.xmin==0&&h.xmax==0&&h.ymin==0&&h.ymax==0)){r=h.xmin<r?h.xmin:r;o=h.ymin<o?h.ymin:o;s=h.xmax>s?h.xmax:s;a=h.ymax>a?h.ymax:a;if(e[f].visible){t.push(e[f].options.modified);i.push(e[f].options.id)}n[e[f].options.id]=1}if(e[f].tileIndexXMin<l)l=e[f].tileIndexXMin;if(e[f].tileIndexYMin<c)c=e[f].tileIndexYMin;if(e[f].tileIndexXMax>u)u=e[f].tileIndexXMax;if(e[f].tileIndexYMax>d)d=e[f].tileIndexYMax}this.source.xmin=r;this.source.ymin=o;this.source.xmax=s;this.source.ymax=a;this.tileIndexXMin=l;this.tileIndexXMax=u;this.tileIndexYMin=c;this.tileIndexYMax=d}this.gcmap.modified=t.join(",");this.gcmap.lid=i.join(",");this.gcmap.lid_map=n;this.gcmap.activeLayer=null;if(flashnavigator.offscreenRendering){var e=this.group.map(function(e){return e.id});this.gcmap.workerResetGroup(this.id,e)}},_reloadGroupPartialy:function(){if(this._toBeLoaded){this._partialGroup=null;this._toBeLoaded=false;return}var e=this.group;this.group=this._partialGroup;this._partialGroup=null;this._resetGroup();this.reload();this.viewerLayer.repaint();this.group=e;this._resetGroup()},tileXYToQuadKey:function(e,t,i){return o(e,t,i)},tilesToLoad:function(){return this.viewerLayer.tilesToLoad()}});fnTileLayerGroup.theTileLayer=null;function t(e,t){if(e.xmax<t.xmin||e.xmin>t.xmax||e.ymax<t.ymin||e.ymin>t.ymax){return false}return true}function i(e,t){if(e>t)return e;return t}function r(e,t){if(e<t)return e;return t}fnBasemapLayer=fnLayer2.extend({initialize:function(e,t){this.zoomThreshold=t.maxZoom;this.isBaseMapLayer=true;t.maxZoom=Infinity;this.options.tileScaleFactor=1;this.originallUrl=e.replace("{s}","a");this.initialize2(e,t)},_getBasemapTileUrl:function(e,t){return this.viewerLayer.getTileUrl(e,t)},_processTile:function(t,e,i,n,r){var o,s,a,l=0,c=0,u=tileSize=256*this.options.tileScaleFactor,d=e.x,f=e.y;if(!r){r=this;n=i}if(i>r.zoomThreshold){do{e.x=Math.floor(e.x/2);e.y=Math.floor(e.y/2);u/=2}while(--i>r.zoomThreshold);l=d*u-e.x*tileSize;c=f*u-e.y*tileSize}o=r._getBasemapTileUrl(e,i);s=new Image;s.onload=function(){var e=t.getContext("2d",flashnavigator.canvasOptions);e.drawImage(this,l,c,u,u,0,0,tileSize,tileSize);r.viewerLayer.onTileLoad(t,this.src)};s.onerror=function(){var e;if(i>0){e=r.zoomThreshold;r.zoomThreshold=i-1;r._processTile(t,{x:d,y:f},n,n,r);r.zoomThreshold=e;return}r.viewerLayer.onTileError(t,this.src)};if(giscloud.offlineMode()){a=r.options.src+"/"+o.split("/").slice(3).join("/");a=a.replace(/\?.+$/i,"").replace(/(mapbox.+?)(?:@2x)?\.(png|jpg)/,"$1@2x.$2").replace(/(tilejson)(.+?)(?:@2x)?\.(png|jpg)/,"$1/maps/streets/256$2@2x.$3");o="file://"+giscloudOffline.documentDirectory+"basemaps/"+a}s.src=o}});fnBasemapLayer.prototype.initialize2=fnLayer2.prototype.initialize;fnRasterLayer=fnLayer2.extend({_processTile:function(e,t,i){this.clipTile(e,t);e.src=this.viewerLayer.getTileUrl(t,i)},isImage:true});function o(e,t,i){var n="";for(var r=i;r>0;r--){var o="0";var s=1<<r-1;if((e&s)!=0){o++}if((t&s)!=0){o++;o++}n+=o}return n}fnQuadLayer=fnBasemapLayer.extend({_getBasemapTileUrl:function(e,t){var i=this.options.subdomains,n=this.options.subdomains[(e.x+e.y)%i.length];return this._url[(e.x+e.y)%this._url.length].replace("{s}",n).replace("{q}",o(e.x,e.y,t))}});fnWmsLayer=fnLayer2.extend({_processTile:function(t,e,i,n,r){var o,s,a,l,c,u,d=0,f=0,h=tileSize=256*(this.options.tileScaleFactor?this.options.tileScaleFactor:1),p=e.x,g=e.y;if(!r){r=this;n=i}if(r.zoomThreshold===undefined){r.zoomThreshold=r.options.maxZoom}t._layer=r;if(i>r.zoomThreshold){do{e.x=Math.floor(e.x/2);e.y=Math.floor(e.y/2);h/=2}while(--i>r.zoomThreshold);d=p*h-e.x*tileSize;f=g*h-e.y*tileSize}if(this.options.gctms){e.y=this._getWrapTileNum()-e.y-1}if(bounds.zoomOffset){i+=bounds.zoomOffset}o=bounds.max/(1<<i);s=bounds.xmin+o*e.x;a=bounds.ymax-o*e.y;l=this._url[(e.x+e.y)%this._url.length].replace("$x1",s).replace("$y1",a-o).replace("$x2",s+o).replace("$y2",a).replace("{z}",i).replace("{x}",e.x).replace("{y}",e.y).replace("$id",i).replace("$nx",e.x).replace("$ny",e.y);c=giscloud_config.tileSite().indexOf("https:")===0&&l.indexOf("https:")!==0||!!l.match(/:\/\/(.*):(.*)@/);if(c){l=giscloud_config.tileImageProxySite().replace("{url}",encodeURIComponent(l)).replace("{mid}",this.viewer._mid.replace("map",""))}t.onload=function(){var e=tileSize/h;Object.assign(t.style,{backgroundImage:"url("+t.src+")",backgroundSize:tileSize*e+"px",backgroundRepeat:"no-repeat",objectPosition:tileSize+"px",backgroundPosition:"left "+-d*e+"px "+" top "+-f*e+"px"});r.viewerLayer.onTileLoad(t,this.src)};t.onerror=function(){var e;if(i>0){e=r.zoomThreshold;r.zoomThreshold=i-1;r._processTile(t,{x:p,y:g},n,n,r);r.zoomThreshold=e;return}r.viewerLayer.onTileError(t,this.src)};if(giscloud.offlineMode()){u=r.options.srcName+"/"+l.split("/").slice(3).join("/");u=u.replace(/\?.+$/i,"").replace(/(mapbox.+?)(?:@2x)?\.(png|jpg)/,"$1@2x.$2").replace(/(tilejson)(.+?)(?:@2x)?\.(png|jpg)/,"$1/maps/streets/256$2@2x.$3");l="file://"+giscloudOffline.documentDirectory+"basemaps/"+u}this.clipTile(t,e);t.src=l}});common.giscloudToolbar={options:{viewer:null,position:"topleft",title:"Toolbar",mobile:window.fno&&fno.mobilebrowser},initControl:function(){var e=$("<div>",{class:"leaflet-control-toolbar"});this.ul=$("<ul>",{class:"gc-toolbar-menu"});e.append(this.ul);this.container=e[0]},empty:function(){this.ul.empty()},_createMenu:function(){var e=[{tool:"Layer list",className:"fa-list-ul"},{tool:"Info",className:"fa-info"},{tool:"more"},{tool:"Zoom in",className:"fa-plus",position:"extended"},{tool:"Zoom out",className:"fa-minus",position:"extended"},{tool:"Zoom area",className:"fa-search-plus",position:"extended"},{tool:"Show all",className:"fa-globe",position:"extended"},{tool:"Current location",className:"fa-crosshairs",position:"extended"},{tool:"Select",className:"fa-hand-o-up",position:"extended"},{tool:"Print",className:"fa-print",position:"extended"},{tool:"Coordinates reprojection",className:"fa-bullseye",position:"extended"},{tool:"Area Measure",className:"fa-crop",position:"extended"},{tool:"Measure",className:"fa-expand",position:"extended"},{tool:"Refresh",className:"fa-refresh",position:"extended"},{tool:"Azimuth",className:"fa-compass",position:"extended"},{tool:"scale",position:"extended"},{tool:"coordinates",position:"extended"},{tool:"Setting",className:"fa-cog",position:"extended"}];for(var t=0;t<e.length;t++){this.add(e[t])}},add:function(e){var t=$("<li>",{class:"gc-toolbar-item"}),i,n;if(e.position=="first")this.ul.prepend(t);else this.ul.append(t);if(e.tool=="Info"){t.addClass("gc-tool-active")}if(e.tool=="viewerswitch"){t.addClass("gc-location-toolbar-viewerswitch")}if(e.id){t.attr("id",e.id)}if(e.tool=="scale"){t.addClass("gc-toolbar-scale");t.append($("<div>"))}else if(e.tool=="numofselected"){t.addClass("gc-toolbar-numofselected");t.append($("<div>",{class:"numselfeatures"}))}else if(e.tool=="more"){i=$("<i>",{class:"fa fa-angle-double-left"});t.append(i);t.attr("title",e.title)}else if(e.tool=="coordinates"){t.addClass("gc-toolbar-coordinates");i=$("<i>",{class:"fa fa-ellipsis-v"});t.append(i);t.append($("<div>"))}else{e.className+=e.className.indexOf("fa-")>=0?" fa":"";i=$("<i>",{class:e.className});t.append(i);t.attr("title",e.title)}if(e.position=="extended"){t.addClass("gc-tool-extended")}if(e.text){if(e.textOnlyResponsive&&!this.options.mobile)return t;n=$("<span>");t.append(n);n.text(e.text);t.addClass("gc-toolbar-text")}t.click(function(e){e.stopPropagation()}).dblclick(function(e){e.stopPropagation()}).mousedown(function(e){e.stopPropagation()});return t},_createButton:function(e){var t=$("<a>").html("&nbsp;").attr("href","#").attr("title",this.options.title).click(function(e){e.stopPropagation()}).dblclick(function(e){e.stopPropagation()}).mousedown(function(e){e.stopPropagation()});$(e).append(t);return t}};common.LocationToolbar={options:{viewer:null,position:"verticalcenterright",title:"Location toolbar",mobile:window.fno&&fno.mobilebrowser},initControl:function(){var e=$("<div>",{class:"leaflet-control-location-toolbar"});this.ul=$("<ul>",{class:"gc-toolbar-menu -vertical"});e.append(this.ul);this.container=e[0]},empty:function(){$(this.ul).empty()},add:function(i){var n=$("<li>",{class:"gc-toolbar-item"}),e,t;if(i.position=="first")this.ul.prepend(n);else this.ul.append(n);if(i.id){n.attr("id",i.id)}n.addClass("gc-location-toolbar-"+i.tool);i.className+=i.className.indexOf("fa-")>=0?" fa":"";e=$("<i>",{class:i.className});n.append(e);n.attr("title",i.title);if(i.text){if(i.textOnlyResponsive&&!this.options.mobile)return n;t=$("<span>");t.text(i.text);n.append(t);n.addClass("gc-toolbar-text");if($(window).width()>800){t.parent().css("display","inline-flex").css("whiteSpace","nowrap").css("width","auto");t.css("marginTop","6px")}}if(i.tool=="viewerrotate"){var r,o,s;i.compassDirection=function(e){if(!r){return}r.css({"-webkit-transform":"rotate("+e+"deg)","-moz-transform":"rotate("+e+"deg)","-ms-transform":"rotate("+e+"deg)",transform:"rotate("+e+"deg)"})};n.load(common.assetsSite()+"assets/images/toolbar/compass.svg?_nch="+giscloud_config.nch,function(){r=n.find(".compass-direction");giscloud.ui.map.instance.on("rotate",function(){i.compassDirection(-giscloud.ui.map.instance.getBearing())});function e(e){var t=t=giscloud.ui.map.instance.getBearing();if(o){clearInterval(o);o=null}if(s>20){t=giscloud.ui.map.instance.getBearing();s=0}else{t+=e;t=Math.round(t/e)*e}giscloud.ui.map.instance.setLocation(undefined,undefined,undefined,t,undefined)}function t(t){if(o){clearInterval(o);o=null}s=0;o=setInterval(function(){var e=giscloud.ui.map.instance.getBearing()+t;giscloud.ui.map.instance.setLocation(undefined,undefined,undefined,e);s++},10)}n.find(".compass-arrow-left").on("mousedown",function(){t(75);$(document).one("mouseup",function(){e(90)})});n.find(".compass-arrow-right").on("mousedown",function(){t(-75);$(document).one("mouseup",function(){e(-90)})});r.on("click",function(){giscloud.ui.map.instance.setLocation(undefined,undefined,undefined,0,0)})});if(giscloud.ui.map.getMode()==="3D"){n.show()}else{n.hide()}}n.click(function(e){e.stopPropagation()}).dblclick(function(e){e.stopPropagation()}).mousedown(function(e){e.stopPropagation()});return n}};if(flashnavigator.ready)flashnavigator.ready()}var fnViewer2=function(e,t,i){var O,o,s,c={},n=0,r={},v;O=[];layers_feature_filter=[];v=true;this.internalViewer=lv;this.disableAnimation=function(){};this.setQuality=function(){};this.demodifyObjectsColor=function(){};this.modifyObject=function(e,t,i,n,r,o){var s,a;var l={};for(a in O){s=O[a].tileLayer||O[a];if(s&&s.gcmap&&!l[s.id]){s.gcmap.modifyObject(e,t,i,n,r,o);l[s.id]=1}}};var k=this;this.disablePanWithMiddleButton=function(){};this.enablePanWithMiddleButton=function(){};this.enableSelection=function(){k.parent.html5Map.Html5MapSetSelection(true);this.selectionEnabled=v=true};this.disableSelection=function(){k.parent.html5Map.Html5MapSetSelection(false);this.selectionEnabled=v=false};this.fireSelectAreaEvent=function(e,t,i){lv.fireSelectAreaEvent(e,t,i,y)};this.fireSelectAreaToolEvent=function(e,t,i){lv.fireSelectAreaToolEvent(e,t,i)};this.setCursor=function(e){lv.setCursor(e)};this.reloadTerrain=function(){lv.reloadTerrain()};this.setTool=function(e){var t;this.setCursor("");if(e=="SelectAreaTool"){t=this.fireSelectAreaToolEvent}if(e=="AreaSelection"){t=this.fireSelectAreaEvent}if(e=="MeasureTool"){if(this._currentTool!=e){this.parent.distanceMeasure.activate()}}else{if(this._currentTool=="MeasureTool"){this.parent.distanceMeasure.deactivate()}}e=lv.setTool(e,this._currentTool,y,t);this._currentTool=e;if(e=="SelectAreaTool"||e=="AreaSelection"||e=="MeasureTool"||e=="streetview"){this.setCursor("crosshair")}};this.src=function(){};this.enableAnimation=function(){};this.convertScale=function(e){return unitFactor/e};this.unload=function(){var e=[],t;this._reloadBound=null;while(l=O.pop()){if(l._updateLayerCount)l._updateLayerCount(true);if(l.cleanUpOnRemove)l.cleanUpOnRemove(lv.map,true);if(!l.isGroupLayer)lv.removeLayer(l);if(flashnavigator.offscreenRendering){if(l.isRootLayer)e.push(l.tileLayer);t=l.tileLayer?l.tileLayer.gcmap:l.gcmap;t.workerLayerRemove(l.id)}}e.forEach(function(e){e.gcmap.workerLayerRemove(e.id)});if(this.cleanUpLabelRendering)this.cleanUpLabelRendering();tileLayerCount=0;n=0;r={};loaded=false;lv.unload()};this.reload=function(e,t,i){if(O.length>0){this._reloadBound=this.getViewBound()}this.load(e||o,true,t,i)};this.setLayerFeatureFilter=function(e,t){layers_feature_filter[e]=t;var i=this.getLayerByName(e);if(i&&i.setFeatureFilter){i.setFeatureFilter(t)}};this.getLayerByName=function(e){for(var t=0;t<O.length;t++){if(O[t].id===e)return O[t]}return 0};this.getLayerById=this.getLayerByName;this.getLayerCount=function(){return O.length};this.getLayer=function(e){return O[e]};this.setLayersOrder=function(e){h(e,this);p();k.parent.html5Map.Html5SendRequests()};this.removeLayer=function(t){var i=[],e;O=O.filter(function(e){if(e.id.indexOf(t)!==-1){i.push(e);return false}return true});i.forEach(function(e){if(e.isTileLayer){tileLayerCount--}if(e._updateLayerCount){e._updateLayerCount(true)}if(e.cleanUpOnRemove)e.cleanUpOnRemove(lv.map);if(!e.isGroupLayer){lv.removeLayer(e)}if(flashnavigator.offscreenRendering&&e.isTileLayer){var t=e.tileLayer?e.tileLayer.gcmap:e.gcmap;t.workerLayerRemove(e.id)}});e=i.reduce(function(e,t){if(e){return e}if(t.id.indexOf("llayer")===-1){e=t}return e},null);y("layerRemoved",e)};this.getViewBound=function(){return lv.getViewBound()};this.setViewUsingInternalCoords=function(e,t){lv.setViewUsingInternalCoords(e,t)};this.setViewBound=function(e,t,i,n,r,o,s){if(!O[0])return;e*=1;i*=1;t*=1;n*=1;if(!r)r=1;if(isNaN(e)||isNaN(t)||isNaN(i)||isNaN(n)){if(this._startBound&&!isNaN(this._startBound.xMin)&&!isNaN(this._startBound.xMax)&&!isNaN(this._startBound.yMin)&&!isNaN(this._startBound.yMax)){e=this._startBound.xMin;t=this._startBound.yMin;i=this._startBound.xMax;n=this._startBound.yMax}else{e=bounds.xmin;t=bounds.ymin;i=bounds.xmax;n=bounds.ymax}}lv.setViewBound(e,t,i,n,r,o,s)};this.setViewBoundAnim=this.setViewBound;this.setScale=function(e){lv.setScale(e)};this.getScale=function(){return lv.getScale()};this.setBearing=function(e){lv.setBearing(e)};this.getBearing=function(){return lv.getBearing()};this.setPitch=function(e){lv.setPitch(e)};this.getPitch=function(){return lv.getPitch()};this.toInternalCoords=function(e,t,i,n,r){return lv.toInternalCoords(e,t,i,n,r)};this.fromInternalCoords=function(e,t){return lv.fromInternalCoords(e,t)};this.toLeafletCoords=this.toInternalCoords;this.fromLeafletCoords=this.fromInternalCoords;this.setLocation=function(e,t,i,n,r){if(e-1===e||t-1===e){console.warn("setLocation: these seem like invalid coordinates.",[e,t]);try{window.dispatchEvent(new CustomEvent("invalidCoordinatesError",{detail:[e,t]}))}catch(e){}return false}lv.setLocation(e,t,i,n,r)};this.getCenter=function(){return lv.getCenter()};this.on=function(e,t){if(!c[e]){c[e]=[]}else{var i=c[e].indexOf(t);if(i>-1){return}}c[e].push(t);lv.on(e,t);return this};this.off=function(e,t,i){if(c[e]&&!i){var n=c[e].indexOf(t);if(n>-1){c[e].splice(n,1)}}lv.off(e,t);return this};this.increaseTileCounter=function(e){var t=e&&e.gc_state?e.gc_state._tileIndex:null;if(!t||r[t]){return}r[t]=1;n++};this.decreaseTileCounter=function(e){var t=e&&e.gc_state?e.gc_state._tileIndex:null;if(!t||!r[t]){return}delete r[t];n--;if(n==0){y("mapTilesReady")}};this.addControl=function(e){var t=this._controls[e.options.position],i={},n;for(n in e){i[n]=e[n]}i.initControl();$(i.container).addClass("gc-viewer-control-container");$(i.container).appendTo(t);return i};this.addControlPlaceholders=function(){this._controls={};this._controls["topleft"]=$("<div/>",{class:"gc-viewer-control gc-top gc-left"}).appendTo(viewerContainer);this._controls["bottomright"]=$("<div/>",{class:"gc-viewer-control gc-bottom gc-right"}).appendTo(viewerContainer);this._controls["verticalcenterright"]=$("<div/>",{class:"gc-viewer-control gc-top gc-right gc-verticalcenter"}).appendTo(viewerContainer);this._controls["verticalcenterleft"]=$("<div/>",{class:"gc-viewer-control gc-top gc-left gc-verticalcenter"}).appendTo(viewerContainer)};this.addAttributionControl=function(){var e=this._controls["bottomright"];this.attributionControl=$("<div/>",{class:"gc-viewer-attribution"}).appendTo(e)};this.addAttribution=function(e){if(!e)return;this.currentAtrribution+=" — "+e;this.attributionControl.html(this.currentAtrribution)};this.resetAttribution=function(){this.currentAtrribution=lv.attribution||"";this.attributionControl.html(this.currentAtrribution)};this.addScaleControl=function(){lv.addScaleControl()};this.addComponentToMap=function(e){lv.addComponentToMap(e)};this.newPopup=function(e){var t=lv.newPopup(e);t._type="popup";return t};this.newMarker=function(e,t,i){var n=lv.newMarker(e,t,i);n._type="marker";return n};this.removeGeom=function(e){return lv.removeGeom(e)};this.fromViewerGeometry=function(e,t){return lv.fromViewerGeometry(e,t)};this.getViewerGeometry=function(e,t,i,n){return lv.getViewerGeometry(e,t,i,n)};this.newViewerGeometry=function(e,t,i,n){return lv.newViewerGeometry(e,t,i,n)};this.enableGeometryEdit=function(e,t){e=e.point||e.polygon||e;return lv.enableGeometryEdit(e,t)};this.extendLineGeometry=function(e,t){lv.extendLineGeometry(e,t)};this.initDrawing=function(e){lv.initDrawing(e)};this.setUpMeasureTool=function(e,i){this.calculateDistance=function(e,t,i,n){var r,o=giscloud.proj4.defs("GC_MAP_CURRENT");if(o&&o.a){if(o.b){r=(o.a+o.b)/2}else{r=o.a}}return common.haversine(e,t,i,n,r)};if(!i||i.indexOf("degree")===0){i="meter"}if(i==="meter"){this.measureLabelFunction=function(e){var t=e/1e3;if(t>1e3){return Math.round(t)+" km"}else if(t>100){return(Math.round(t*10)/10).toFixed(1)+" km"}else if(t>10){return(Math.round(t*100)/100).toFixed(2)+" km"}else if(t>1){return(Math.round(t*2e3)/2).toFixed(1)+" m"}else if(t>.1){return(Math.round(t*2e4)/20).toFixed(2)+" m"}else{return(Math.round(t*1e5)/100).toFixed(2)+" m"}}}else{this.measureLabelFunction=function(e){var t;t=giscloud.fromMeters(i,e);if(t===null)t=0;if(t>1e3){t=Math.round(t)}else if(t>100){t=(Math.round(t*10)/10).toFixed(1)}else if(t>10){t=(Math.round(t*100)/100).toFixed(2)}else{t=(Math.round(t*1e3)/1e3).toFixed(3)}switch(i){case"foot":case"us survey foot":case"foot_us":return t+" ft";case"mile":return t+" mi";case"inch":return t+" in";case"yard":return t+" yd";default:return t+" "+i}}}};this.dragging={enable:function(){lv.dragging.enable()},disable:function(){lv.dragging.disable()},enabled:function(){return lv.dragging.enabled()}};this.doubleClickZoom={enable:function(){lv.doubleClickZoom.enable()},disable:function(){lv.doubleClickZoom.disable()},enabled:function(){return lv.doubleClickZoom.enabled()}};this.selectExtentTool=function(e){return lv._control.selectExtent(e)};this.exposeLeaflet=function(){console.warn("warning: exposeLeaflet() method will be deprecated");return lv.map};this.getDrawingController=function(e){return lv.getDrawingController(this,e)};this.invalidateSize=function(){lv.invalidateSize()};this.getMode=function(){return lv.modeId};this.changeMode=function(e,t){var i={previousViewer:lv,layersToRemove:[],zoom:lv.getScale(),minZoom:lv.getMinZoom(),callback:t,mode:e},n=lv,r=this,o=i.zoom,s=n.getBackgroundColor(),a;if(e===this.viewerMode){return}this.viewerMode=e;n.toggleInteractions(false);if(r.plugins.tooltip){r.plugins.tooltip.deinit()}for(a in c){c[a].forEach(function(e){n.off(a,e,true)})}this.parent.graphic.cancelDraw();if(r.plugins.canvas){r.plugins.canvas.clear()}flashnavigator.initViewer(e,this.parent,this.parent.containerId,function(){r.internalViewer=lv;lv.initialize();lv.setMinZoom(i.minZoom);lv.exaggeration=n.exaggeration;lv.demMaxZoom=n.demMaxZoom;if(lv.initOnLayerAdd)lv.initOnLayerAdd();if(s){lv.setBackgroundColor(s)}if(r.plugins.canvas){r.plugins.canvas.initDrawingController(true)}if(r.plugins.tooltip){r.plugins.tooltip.init(r)}n.resetZoomBearingPitch(o,function(){r.deactivateOldMode(i,function(){r.activateNewMode(i)})})})};this.deactivateOldMode=function(e,t){var i=e.previousViewer,n,r=e.zoom,o,s,a;i.uninitialize();a=i.getCenter();for(var o in c){c[o].forEach(function(e){lv.on(o,e)})}lv.map.gc_bounds=i.map.gc_bounds;lv.map.layersMaxLevel=i.map.layersMaxLevel;lv.map.unitFactor=i.map.unitFactor;lv.setZIndex(1);lv.show();lv.invalidateSize();lv.setLocation(a.x,a.y,r,0,0,0,null,"jumpTo");s=i.extractLayer();if(s){lv.whenIdle(t);do{n=s.viewerLayer;n.fnLayer=s;n.switching=true;e.layersToRemove.push(n);lv.addLayer(s,true)}while(s=i.extractLayer())}else{t()}};this.activateNewMode=function(e){var t=e.previousViewer,i,n,r,o,s;t.hide();t.setZIndex(1);lv.setZIndex(2);lv.toggleInteractions(true);while(i=e.layersToRemove.pop()){r=i.fnLayer._tiles;for(s in r){if(r[s].transferToAnotherViewer){delete r[s].transferToAnotherViewer;i.fnLayer._unloadTile({tile:r[s],imidiateRelease:true});delete r[s]}}while(n=i.fnLayer._tilesToRemove.pop()){i.fnLayer.gcmap.releaseCanvasToPool(n)}i.removeFromMap()}o=e.zoom*5;if(o>60){o=60}lv.setLocation(undefined,undefined,e.zoom,0,o,undefined,e.callback,"easeTo")};this.isSrcBasemap=function(e){return e=="osm"||e=="croatianq"||e=="gmaps"||e=="gmaps_traffic"||e=="mapbox.streets"||e=="mapbox.light"||e=="mapbox.dark"||e=="mapbox.satellite"||e=="mapbox.satellite-streets"||e=="gmaps_sat"||e=="gmaps_terr"||e=="gmaps_hybrid"||e=="bing"||e=="bing_sat"||e=="bing_hyb"||e=="grajs"||e=="maps_for_free_relief"||e=="mapquest-osm"||e=="mapquest-oarial"||e=="cloudmade_gray"||e=="cloudmade_night"||e=="tilejson"||e=="here.satellite"||e=="here.streets"};this.setMinZoom=function(e){lv.setMinZoom(e)};this.getMinZoom=function(){return lv.getMinZoom()};function a(){k._layersForUpdateCount=tileLayerCount}this.on("move",a);this.on("moveend",a);this.on("viewreset",a);this.on("mousedown",function(e){if(e.originalEvent.ctrlKey){giscloud.log.push("mouse_down_with_ctrl")}});this.on("zoomstart",function(e){giscloud.util.mediator.publish("zoomstart",e)});this.on("zoomend",function(e){giscloud.util.mediator.publish("zoomend",e)});function A(e){var t,i;if(typeof e==="string"){e=$.parseXML(e).childNodes||[]}else{e=e.childNodes}for(t=0,i=e.length;t<i;t++){if(e[t].nodeType==1)return e[t]}return null}var N=[];var u=0;function d(e,t){if(giscloud.offlineMode()&&giscloudOffline.documentDirectory){return"file://"+giscloudOffline.documentDirectory+"assets/"+t}return t}function R(t){u=N.length;if(u==0){g(t);return}var e,i,n;while(e=N.pop()){e.img.onerror=e.img.onload=function(e){if(e.type==="error"){this.feature.icon_image=null}else{if(!this.generated){this.width=this.width*flashnavigator.scaleRatio;this.height=this.height*flashnavigator.scaleRatio}this.img_width=this.width;this.img_height=this.height;this.feature.iready=true}this.feature.predominantColor=this.feature.fillcolor;u--;if(u==0)g(t)};if(window.cordova){n=e.url&&e.url.match(/https?:\/\/(?:[^\.]+\.)*giscloud\.com\/.*[&?]p=(https?:[^&]+)/);if(n&&n[1]){i=unescape(n[1]).replace("http:","https:").replace("#","%23");if(i==="/icons/defaulticon.png"){i=e.url}}else{i=e.url}e.img.src=d(t,i)}else{loadSymbol(e.img,d(t,e.url))}}}this.load=function(e,t,i,n){if(!t&&this.cleanUpLabelRendering)this.cleanUpLabelRendering();var r,E=this;o=e;this._is_reload=t;this.reloadCallback=i;this.overrideStartBound=n;if(giscloud.offlineMode()){r=function(t){giscloudOffline.getMapXml([t.url],function(e){t.success.bind(t.context)(e)})}}else{r=$.ajax}r({url:e+(e.indexOf("?")>-1?"&":"?")+"t="+(new Date).getTime()+(t?"&reload=1":""),context:this,error:function e(t,i,n){console.error("Error loading map XML",t,i,n);y(this._is_reload?"reload":"load",{id:this._mid});y("error")},success:function(e){var t="";var i="";var n="";var r=null;var o=A(e);var s=o.childNodes.length;var a=100;var l;if(o.attributes){for(l=0;l<o.attributes.length;l++){if(o.attributes[l].name=="id"){t=o.attributes[l].value}else if(o.attributes[l].name=="unit"){this.unit=i=o.attributes[l].value;unitFactor=units[i]}else if(o.attributes[l].name=="measure_unit"){this.measureUnit=n=o.attributes[l].value}else if(o.attributes[l].name=="maxzoom"){a=parseInt(o.attributes[l].value,10)}}}this._mid=t;flashnavigator.map_id=t;var c=[];var u={};var d=this.parent.options={};var f=false;var h=null;this.copyright="";this.backgroundcolor=null;var p="";for(var g=0;g<s;g++){if(o.childNodes[g].tagName=="copyright"){this.copyright=giscloud.xssSafe(o.childNodes[g].text||o.childNodes[g].childNodes[1].textContent);p="&copy; "+this.copyright}else if(o.childNodes[g].tagName=="sources"){F(o.childNodes[g].childNodes,u,c)}else if(o.childNodes[g].tagName=="options"){B(o.childNodes[g].childNodes,d)}else if(o.childNodes[g].tagName=="bound"){var m=o.childNodes[g].attributes;r={};for(l=0;l<m.length;l++){if(m[l].name=="xmin")r.xMin=parseFloat(m[l].value);else if(m[l].name=="ymin")r.yMin=parseFloat(m[l].value);else if(m[l].name=="xmax")r.xMax=parseFloat(m[l].value);else if(m[l].name=="ymax")r.yMax=parseFloat(m[l].value)}f=true}else if(o.childNodes[g].tagName=="tile0"){h={};var v=o.childNodes[g].attributes;for(l=0;l<v.length;l++){if(v[l].name=="originx")h.originx=parseFloat(v[l].value);else if(v[l].name=="originy")h.originy=parseFloat(v[l].value);else if(v[l].name=="resolution")h.resolution=parseFloat(v[l].value);else if(v[l].name=="wmts")h.wmts=v[l].value=="true"}}else if(o.childNodes[g].tagName=="projection"){this.projection=o.childNodes[g].getAttribute("value")}else if(o.childNodes[g].tagName=="epsg"){this.epsg=o.childNodes[g].getAttribute("value")}else if(o.childNodes[g].tagName=="background"){this.backgroundcolor=o.childNodes[g].getAttribute("value")+"";if(this.backgroundcolor)this.backgroundcolor=this.backgroundcolor.replace("0x","#")}else if(o.childNodes[g].tagName=="token"){giscloud.tile_token=o.childNodes[g].getAttribute("value")}}lv.initialize();this.resetAttribution();if(p){this.addAttribution(p)}flashnavigator.newLabelingMode=giscloud.offlineMode()||this.parent&&this.parent.options&&this.parent.options.LABEL_ENGINE_MODE=="2";z.call(this,i,n);H.call(this,i,n);lv.setBackgroundColor(this.backgroundcolor);if(!f)r={};var y={};var _;if(h&&!isNaN(h.originx)&&!isNaN(h.originy)&&!isNaN(h.resolution)){_=h.resolution*256*(unitFactor/3779.527559055);if(h.wmts){if(h.originx==-180&&h.originy==90){_=180*2;y.zoomOffset=-1}else _*=1.14687998/4096;y.ymin=h.originy-_;y.ymax=h.originy}else{y.ymin=h.originy;y.ymax=h.originy+_}y.xmin=h.originx;y.xmax=h.originx+_;y.max=_}else{if(Math.abs(unitFactor-420735083.313146)<1e-5){_=180}else{_=20037508.3427892*(unitFactor/3779.527559055)}y.xmin=-_;y.ymin=-_;y.xmax=_;y.ymax=_;var b=y.xmax-y.xmin;var w=y.ymax-y.ymin;if(w>b)b=w;y.max=b}var x=false;var k=["osm","bing","bing_sat","bing_hyb","gmaps","gmaps_traffic","gmaps_sat","gmaps_terr","gmaps_hybrid","mapquest-osm","mapquest-oarial","cloudmade_gray","maps_for_free_relief","mapbox.streets","mapbox.light","mapbox.dark","mapbox.satellite","mapbox.satellite-streets","cloudmade_night","tilejson","croatianq","mapbox.streets"];for(var g=0;g<c.length;g++){if($.inArray(c[g].src,k)==-1)x=true}var C=Math.floor(Math.log(unitFactor/(256/y.max)/a)/Math.log(2));if(!this._is_reload||!bounds||bounds.xmin!=y.xmin||bounds.ymin!=y.ymin||bounds.xmax!=y.xmax||bounds.ymax!=y.ymax){this._reloadBound=null}bounds=y;for(var g=0;g<s;g++){if(o.childNodes[g].tagName=="layers"){U(o.childNodes[g].childNodes,u,t,O,C)}}for(var g=0;g<G.length;g++){if(G[g].features){var L=G[g].features;for(var T=0;T<L.length;T++){var j=L[T];if(j.icon){j.icon_image=new Image;j.icon_image.feature=j;N.push({img:j.icon_image,url:j.icon})}if(j.type=="polygon"){if(!j.linewidth){j.linewidth=1}if(j.fillcolor){j.predominantColor=j.fillcolor}else{j.predominantColor=j.strokecolor}}else{if(j.innerstrokecolor&&j.innerlinewidth>0){G[g].has_inner_line=true}}if(!j.predominantColor){if(j.strokecolor){j.predominantColor=j.strokecolor}else if(j.color){j.predominantColor=j.color}else{j.predominantColor="#000000"}}var M=common.getHighlightAndSelectColors(j.predominantColor);j.highlightcolor=M[0];j.selectcolor=M[1];if(j.linewidth)j.linewidth*=flashnavigator.scaleRatio;if(j.innerlinewidth)j.innerlinewidth*=flashnavigator.scaleRatio;if(j.dashed)j.dashed=j.dashed.map(function(e){return e*flashnavigator.scaleRatio})}}}Y(E,t,O,C,u);for(var g=0;g<c.length;g++){W(c[g]);if(!c[g].visible||$.inArray(c[g].src,k)>-1&&x||f){continue}var I=parseFloat(c[g].xmin);var D=parseFloat(c[g].ymin);var S=parseFloat(c[g].xmax);var P=parseFloat(c[g].ymax);if(I==0&&D==0&&S==0&&P==0){continue}if(r.xMin==undefined||I<r.xMin){r.xMin=I}if(r.yMin==undefined||D<r.yMin){r.yMin=D}if(r.xMax==undefined||S>r.xMax){r.xMax=S}if(r.yMax==undefined||P>r.yMax){r.yMax=P}}this._startBound=r;R(this);giscloud.util.mediator.publish("labels/rerender")}})};function f(e){if(typeof e!=="string"){return null}if(!giscloud.toMeterRatios[e]){return null}return e}this.MeasureUnit=function(e){if(e!==undefined&&f(e)){this.measureUnit=e;z.call(this,e,this.measureUnit)}return this.measureUnit};function h(e,t){var i=[],n,r=null,o=0,s,a,l;if(flashnavigator.newLabelingMode){e=e.filter(function(e){return e});s=[labelLayer]}else{s=e.map(function(i){return O.reduce(function(e,t){if(e){return e}else{if(t.id==="llayer"+i){return[i,t]}}},null)}).reduce(function(e,t){if(t){e[t[0]]=t[1]}return e},{})}a=e.map(function(n){return O.reduce(function(e,t){var i;if(e){return e}else{i=window.parseInt(t.id.replace("layer","").replace("_group_",""),10);if(i===n){return[n,t]}}return e},null)}).reduce(function(e,t){if(t){e[t[0]]=t[1]}return e},{});s=Object.keys(s).reduce(function(e,t){e.push(s[t]);return e},[]);a=e.reduce(function(e,t){e.push(a[t]);return e},[]);l=Array.prototype.concat.apply(s,a);if(flashnavigator.isUsingMapEngineGroupedLayers){var c=false,u=null,d=null,n=null,f,h,p=0,g=0,m,v,y,_,b,w=1,x=3;if(labelLayer){l.shift()}fnTileLayerGroup.theTileLayer=fnTileLayerGroup.theTileLayer||[];for(b=0;b<l.length;b++){y=l[b];_=y.layer_info.type&&y.layer_info.type==="raster"?0:y.options.minZoom;if(y.isGroupLayer)continue;if(!y.options.modified){y.options.modified=1}f=new fnTileLayerGroup({id:y.id,visible:y.options.visible,opacity:y.options.opacity,minZoom:_,maxZoom:y.options.maxZoom,subdomains:y.options.subdomains,gctms:y.options.gctms,mid:flashnavigator.map_id,modified:y.options.modified,attribution:y.options.attribution?y.options.attribution:""},t.parent.html5Map);f.mid=flashnavigator.map_id;f.source=y.source;f.isImage=true;f.isRasterLayer=y instanceof fnRasterLayer;f.shouldBeLoaded=true;f.layer_info=y.layer_info;f.layer_info.fnLayer=f;f.viewer=t;f.features=[];f._url=y._url;f.zoomThreshold=y.zoomThreshold;f.useForDEM=y.useForDEM;if((y instanceof fnWmsLayer||y instanceof fnBasemapLayer)&&y._url){f.proxyServerAvailable=giscloud_config.tileImageProxySite();y._url.forEach(function(e){var t=giscloud_config.tileSite().indexOf("https:")===0&&e.indexOf("https:")!==0||!!e.match(/:\/\/(.*):(.*)@/);if(t){f.proxyServer=f.proxyServerAvailable;return}})}l[b]=f}Object.keys(fnTileLayerGroup.theTileLayer).forEach(function(e){fnTileLayerGroup.theTileLayer[e]._zIndexOffset=null});tileLayerCount=0;h=l.map(function(e){m=x;if(!v){v=m}if(e.isGroupLayer){if(v!==m){p++}v=m;if(e.groupId!=="g"+p&&!e.shouldBeLoaded&&e.tileLayer){e.unloadFromTiles();if(e.tileLayer.gcmap.modifier){e.copy_modifier={};for(var t in e.tileLayer.gcmap.modifier){var i=t.split("_");if(i.length===2&&i[0]==e.id){e.copy_modifier[t]=e.tileLayer.gcmap.modifier[t];delete e.tileLayer.gcmap.modifier[t]}}}e.shouldBeLoaded=true}return{group:"g"+p,layer:e,type:m}}else{if(v!==w){g++}v=m;return{group:"break"+g,layer:e,type:m}}}).filter(function(e){return e.group.indexOf("break")===-1}).reduce(function(e,t){if(!e.some(function(e){return e[0]===t.group})){e.push([t.group,[]])}e[e.length-1][1].push(t.layer);return e},[]).map(function(i){var n=null,r={id:i[0],group:null,layers:i[1]};r.layers.map(function(e){if(e.tileLayer){e.isRootLayer=false;if(n&&n!==e.tileLayer&&e.tileLayer._map){e.tileLayer._map.removeLayer(e.tileLayer);return}n=e.tileLayer}});r.group=i[1].reduce(function(e,t){t.groupId=i[0];t.options.group=i[0];if(e){return e}if(n){t.tileLayer=n;t.isRootLayer=true}else{t.newTileLayer()}t.tileLayer.options.tooltip=[];t.tileLayer._partialGroup=r.layers;t.tileLayer.options.maxZoom=undefined;t.tileLayer.group=r.layers.map(function(e){e.tileLayer=t.tileLayer;if(e.options.tooltip){t.tileLayer.options.tooltip.push(e.options.tooltip)}if(t.tileLayer.options.maxZoom===undefined||e.options.maxZoom>t.tileLayer.options.maxZoom){t.tileLayer.options.maxZoom=e.options.maxZoom}return e});t.tileLayer.options.tooltip=t.tileLayer.options.tooltip.join(",");t.visible=t.options.visible;t.setUniqueId();e=t;return e},null);tileLayerCount++;return r});if(labelLayer){l.unshift(labelLayer)}}else{tileLayerCount=O.filter(function(e){return e instanceof fnTileLayer}).length}l.forEach(function(e,t){e.orderIndex=O.length-t;if(e.isGroupLayer){e.setZIndex(e.orderIndex)}});O=l;flashnavigator.layers=O;if(flashnavigator.offscreenRendering){k.parent.html5Map.workerSyncLayers()}if(h){h.forEach(function(e){e.group.tileLayer._resetGroup()})}}function p(){O.forEach(function(e){e.setZIndex(e.orderIndex)});if(fnTileLayerGroup.theTileLayer){Object.keys(fnTileLayerGroup.theTileLayer).forEach(function(e){var i;i=fnTileLayerGroup.theTileLayer[e];var t=i.group.filter(function(e){if(e.options.modifier){i.gcmap.has_modifier=true;if(!i.gcmap.modifier){i.gcmap.modifier={}}if(!i.gcmap.modifier_layers){i.gcmap.modifier_layers={}}i.gcmap.modifier_layers[e.id]=1;for(var t in e.options.modifier){i.gcmap.modifier[t]=e.options.modifier[t]}}if(e.copy_modifier){if(!i.gcmap.modifier){i.gcmap.modifier={}}for(var t in e.copy_modifier){i.gcmap.modifier[t]=e.copy_modifier[t]}delete e.copy_modifier}if(e.shouldBeLoaded){e.shouldBeLoaded=false;return true}return false});i.gcmap.setupAttributes();if(!i.viewer){i.viewer=i.group[0].viewer;i._toBeLoaded=true;lv.addLayer(i);i._reloadGroupPartialy()}else{if(t.length>0){i._partialGroup=t;i._reloadGroupPartialy()}else{window.setTimeout(function(){i.redraw()},0)}}})}if(flashnavigator.newLabelingMode){order.unshift(0)}giscloud.util.mediator.publish("labels/rerender")}function g(e){var t=[],i=[],n=false;if(e.parent&&e.parent.options&&e.parent.options.MAP_ENGINE_MODE=="3"){flashnavigator.hasCanvas=false}else{flashnavigator.hasCanvas=flashnavigator.hasCanvasInitialValue}if(e.parent&&e.parent.options&&e.parent.options.DEM_EXAGGERATION!==undefined){var r=+e.parent.options.DEM_EXAGGERATION;if(lv.exaggeration!==r){lv.exaggeration=r;n=true}}else{lv.exaggeration=1.5}if(e.parent&&e.parent.options&&e.parent.options.DEM_MAX_ZOOM!==undefined){var o=+e.parent.options.DEM_MAX_ZOOM;if(lv.demMaxZoom!==o){lv.demMaxZoom=o;n=true}}else{lv.demMaxZoom=14}if(n){lv.reloadTerrain()}e._layersForUpdateCount=0;lv.invalidateSize();if(!e._reloadBound){var s=e.overrideStartBound||e._startBound,a=window.fno&&fno.view&&JSON.parse(fno.view.params);if(a){e.setLocation(a.center.split(",")[0],a.center.split(",")[1],a.scale)}else{e.setViewBound(s.xMin,s.yMin,s.xMax,s.yMax,null,true)}}t=O.reduce(function(e,t){if(t.id.indexOf("llayer")===-1){e.push(window.parseInt(t.id.replace("layer","").replace("_group_",""),10))}return e},[]).reverse();if(lv.isLoaded()){h(t,e)}if(e._is_reload){y("reload",{id:e._mid})}else{y("load",{id:e._mid})}for(var l=0;l<O.length;l++){if(O[l].filterToInitOnLoad){O[l].setFeatureFilter(O[l].filterToInitOnLoad);O[l].filterToInitOnLoad=null}if(O[l].gcmap){O[l].gcmap.setupAttributes()}if(O[l].should_add){O[l].should_add=false;if(!O[l].isGroupLayer){lv.addLayer(O[l])}if(O[l].features){O[l].features_original=[];for(var c=0;c<O[l].features.length;c++){var u={};for(var d in O[l].features[c]){u[d]=O[l].features[c][d]}O[l].features_original[c]=u}O[l].calculateFeatureVisibility()}}else{if(O[l].gcmap){O[l].gcmap.checkAttributesAndReload()}if(O[l].options||O[l].options.attribution){if(O[l].options.attribution&&e.currentAtrribution&&e.currentAtrribution.match(O[l].options.attribution)){continue}e.addAttribution(O[l].options.attribution)}}}loaded=true;if(lv.isLoaded()){p()}if(e.reloadCallback){e.reloadCallback();e.reloadCallback=null}e.parent.html5Map.Html5SendRequests()}function z(e,t){k.setUpMeasureTool(e,t)}function H(r,o){return;var l=lv.map,c=l.measure.options.calculateDistance,e=l.scaleControl,t=this,s;if(!e)return;e.setPosition("bottomleft");if(r==="degree"){e._update=e.original_update;e._updateScales=e.original_updateScales;e.options.metric=o==="meter";e.options.imperial=o!=="meter"}else{e.options.metric=true;e.options.imperial=false;e._update=function(){var e=l.getPixelBounds(),t=e.max.x-e.min.x||1,i=l.getBounds(),n=i._southWest.lat,r=i._northEast.lng,o=i._southWest.lng,s=c(n,r,n,o),a=s/t*this.options.maxWidth;this._updateScales(a)};if(!o||o.indexOf("degree")===0){o="meter"}if(o===r){if(o==="meter"){e._updateScales=function(e){var t=this._getRoundNum(e);this._mScale.style.width=this._getScaleWidth(t/e)+"px";this._mScale.innerHTML=t<1e3?t+" m":t/1e3+" km"}}else{switch(o){case"foot":case"us survey foot":case"foot_us":s=" ft";break;case"mile":s=" mi";break;case"inch":s=" in";break;case"yard":s=" yd";break;default:s=" "+o}e._updateScales=function(e){var t=this._getRoundNum(e);this._mScale.style.width=this._getScaleWidth(t/e)+"px";this._mScale.innerHTML=t+s}}}else{if(o==="meter"){e._updateScales=function(e){var t=giscloud.toMeters(r,e),i=this._getRoundNum(t);this._mScale.style.width=this._getScaleWidth(i/t)+"px";this._mScale.innerHTML=i<1e3?i+" m":i/1e3+" km"}}else{switch(o){case"foot":case"us survey foot":case"foot_us":s=" ft";break;case"mile":s=" mi";break;case"inch":s=" in";break;case"yard":s=" yd";break;default:s=" "+o}e._updateScales=function(e){var t=giscloud.toMeters(r,e),i=giscloud.fromMeters(o,t),n=this._getRoundNum(i);this._mScale.style.width=this._getScaleWidth(n/i)+"px";this._mScale.innerHTML=n+s}}}}t.parent.loading.done(function(){try{l.removeControl(e)}catch(e){}})}function F(e,t,i){for(var n=e.length-1;n>=0;n--){var r=e[n];if(r.tagName=="source"){var o="";var s={};for(var a=0;a<r.attributes.length;a++){var l=r.attributes[a].name;if(l=="id")o=r.attributes[a].value;if(l=="xmin"||l=="xmax"||l=="ymin"||l=="ymax")s[l]=parseFloat(r.attributes[a].value);else s[l]=r.attributes[a].value}t[o]=s;t[o].tileservers=[];for(var c=r.childNodes.length-1;c>=0;c--){if(r.childNodes[c].tagName=="tileservers"){var u=r.childNodes[c];if(u.attributes){for(var a=0;a<u.attributes.length;a++){if(u.attributes[a].name=="maxzoom"){t[o].maxzoom=parseInt(u.attributes[a].value)}if(u.attributes[a].name=="minzoom"){t[o].minzoom=parseInt(u.attributes[a].value)}if(u.attributes[a].name=="attribution"){t[o].attribution=u.attributes[a].value}}}for(var d=r.childNodes[c].childNodes.length-1;d>=0;d--){var u=r.childNodes[c].childNodes[d];if(u.attributes){for(var a=0;a<u.attributes.length;a++){if(u.attributes[a].name=="value"){t[o].tileservers.push(u.attributes[a].value)}if(u.attributes[a].name=="zoomoffset"){t[o].zoomOffset=parseInt(u.attributes[a].value)}}}}}if(r.childNodes[c].tagName=="tilepath"){var u=r.childNodes[c];if(u.attributes){for(var a=0;a<u.attributes.length;a++){if(u.attributes[a].name=="value"){t[o].tilepath=u.attributes[a].value}}}}}i.push(t[o])}}}function W(t){var i,n=1e-6;["xmin","ymin","xmax","ymax"].forEach(function(e){i=(t[e]-bounds[e])/bounds[e];if(i>=0&&i<n||i===Infinity){t[e]=(1-n)*bounds[e]}})}function B(e,t){for(var i=e.length-1;i>=0;i--){var n=e[i];if(n.tagName=="option"){var r="";for(var o=0;o<n.attributes.length;o++){var s=n.attributes[o].name;if(s=="name")r=n.attributes[o].value;if(s=="value")t[r]=n.attributes[o].value}}}}var G;var q=1;function U(e,t,i,n,r){var o,s,a,l,c;G=[];for(s=e.length-1;s>=0;s--){l=e[s];if(l.tagName=="layer"){c={id:"",alpha:1,visible:true};if(l.attributes){for(a=0;a<l.attributes.length;a++){if(l.attributes[a].name==="id"){c.id=l.attributes[a].value}else if(l.attributes[a].name==="src"){c.src=l.attributes[a].value}else if(l.attributes[a].name==="timestamp"){c.timestamp=l.attributes[a].value}else if(l.attributes[a].name==="offset"){c.offset=l.attributes[a].value}else if(l.attributes[a].name==="precision"){c.precision=l.attributes[a].value*1}else if(l.attributes[a].name==="dynamic"){c.dynamic=l.attributes[a].value*1}else if(l.attributes[a].name==="visible"){c.visible=l.attributes[a].value==="true"}else if(l.attributes[a].name==="alpha"){c.alpha=parseInt(l.attributes[a].value)/100}else if(l.attributes[a].name==="type"){c.type=l.attributes[a].value}else if(l.attributes[a].name==="format"){c.format=l.attributes[a].value}else if(l.attributes[a].name==="level"){c.level=parseInt(l.attributes[a].value)}else if(l.attributes[a].name==="fromlevel"){c.fromlevel=parseInt(l.attributes[a].value)}else if(l.attributes[a].name==="tolevel"){c.tolevel=parseInt(l.attributes[a].value)}else if(l.attributes[a].name==="tooltip"){c.tooltip=l.attributes[a].value}else if(l.attributes[a].name==="hidegeometry"){c.hiddenGeometry=true}else if(l.attributes[a].name==="isDem"){c.useForDEM=l.attributes[a].value=="true"}}}c.features=[];for(a=0;a<l.childNodes.length;a++){if(l.childNodes[a].tagName=="features"){m(l.childNodes[a].childNodes,c)}}if(!t[c.src]){continue}c.xmin=t[c.src].xmin;c.ymin=t[c.src].ymin;c.xmax=t[c.src].xmax;c.ymax=t[c.src].ymax;G.push(c)}}if(flashnavigator.newLabelingMode){o={};G=G.filter(function(e){if(e.id.indexOf("ll")!==-1){o[e.id.replace("ll","l")]=e;return false}return true})}if(o){labelLayerKeys=Object.keys(o);for(s=0;s<labelLayerKeys.length;++s){for(a=0;a<G.length;++a){if(labelLayerKeys[s]!==G[a].id){continue}else{G[a].labelLayerData=o[labelLayerKeys[s]];G[a].styles=o[labelLayerKeys[s]].features;G[a].attribute=o[labelLayerKeys[s]].labels;G[a].timestamp=o[labelLayerKeys[s]].timestamp;break}}}}}function V(e,t){if(t.id==="layer0"&&e.id===t.id){return true}if(t.id===e.id){if(t.timestamp!==e.timestamp||t.xmin!==e.xmin||t.xmax!==e.xmax||t.ymin!==e.ymin||t.ymax!==e.ymax||t.hiddenGeometry!==e.hiddenGeometry||t.features.length!==e.features.length){giscloud.util.mediator.publish("renderer/dropCache");giscloud.util.mediator.publish("labels/clear",t.id)}}if(t.id!==e.id||t.timestamp!==e.timestamp||t.xmin!==e.xmin||t.xmax!==e.xmax||t.ymin!==e.ymin||t.ymax!==e.ymax||t.hiddenGeometry!==e.hiddenGeometry||t.features.length!==e.features.length){return false}return true}function Y(e,t,i,n,r){var o,s,a,l,c,u,d,f={},h,p,g,m,v,y,_,b,w=0,x;if(!i.length){labelLayer=null}for(o=0;o<G.length;o++){G[o].oldLayer=null}if(flashnavigator.newLabelingMode&&labelLayer&&i.length){G.push(labelLayer)}b=flashnavigator.hasCanvas&&!(e&&e.parent&&e.parent.options&&e.parent.options.MAP_ENGINE_MODE=="1");flashnavigator.isUsingMapEngineGroupedLayers=b;for(o=0;o<i.length;o++){u=i[o];d=true;for(s=0;s<G.length;s++){a=G[s];if(V(a,u.layer_info)){d=false;a.oldLayer=u;a.fnLayer=u;u.options.tooltip=a.tooltip;break}}if(d){if(u.isTileLayer){tileLayerCount--}if(u._updateLayerCount){u._updateLayerCount(true)}var k=u.tileLayer?u.tileLayer.gcmap:u.gcmap;if(k&&k.has_modifier){var C={};for(var o in k.modifier){var L=o.split("_");if(L.length===2&&L[0]==u.id&&k.modifier[o].color==="selectcolor"){C[o]=k.modifier[o]}}if(Object.keys(C).length>0){f[u.id]=C}}if(u.cleanUpOnRemove)u.cleanUpOnRemove(lv.map);if(!u.isGroupLayer)lv.removeLayer(u);if(flashnavigator.offscreenRenderings&&k){k.workerLayerRemove(u.id)}}}i.length=0;h=0;if(e.layersDEM){delete e.layersDEM}for(o=0;o<G.length;o++){a=G[o];if(a.useForDEM){if(!e.layersDEM){e.layersDEM=[]}e.layersDEM.push(a)}if(!a.dontLoad){if(a.oldLayer){i[h]=a.oldLayer;h++}else{i[h++]=null}}}h=0;if(flashnavigator.newLabelingMode){if(!labelLayer){labelLayer=new LabelLayer({id:"layer0"});labelLayer.viewer=e;giscloud.util.mediator.deleteChannel("tile/loaded");giscloud.util.mediator.makeChannel("tile/loaded",true);giscloud.util.mediator.subscribe("tile/loaded",labelLayer.onTileLoaded.bind(labelLayer));giscloud.util.mediator.deleteChannel("labels/hide");giscloud.util.mediator.makeChannel("labels/hide",true);giscloud.util.mediator.subscribe("labels/hide",labelLayer.hideLabels.bind(labelLayer));giscloud.util.mediator.deleteChannel("labels/show");giscloud.util.mediator.makeChannel("labels/show",true);giscloud.util.mediator.subscribe("labels/show",labelLayer.showLabels.bind(labelLayer));giscloud.util.mediator.deleteChannel("labels/rerender");giscloud.util.mediator.makeChannel("labels/rerender",true);giscloud.util.mediator.subscribe("labels/rerender",labelLayer.rerender.bind(labelLayer));giscloud.util.mediator.deleteChannel("labels/clear");giscloud.util.mediator.makeChannel("labels/clear",true);giscloud.util.mediator.subscribe("labels/clear",labelLayer.clear.bind(labelLayer));i.push(labelLayer)}}p=false;g=false;m=0;v={};h=0;var T=window.location.protocol==="https:"?"https:":"http:";for(o=0;o<G.length;o++){l=G[o];if(l.id==="layer0"){continue}if(l.visible){r[l.src].visible=true}if(!flashnavigator.hasCanvas){l.alpha=100}c=r[l.src].src;if(e.isSrcBasemap(c)){p=true}var j=r[l.src].src_name;if(c==="wmts"&&j&&j.indexOf("mapbox.")===0){p=true}if(i[h]){g=i[h].isGroupLayer;h++;continue}var M="bMXIdiBbYTCR4O14WSlN";var I="PRnjzWuHGMCagCLGWURjAQ";var D="pk.eyJ1IjoiZ2lzLWNsb3VkIiwiYSI6ImNpcWF4enZwdjAwOHZpNm0yZGwzNDl2eTkifQ.2nnP_6MoDn0Ig-H4Ovrgug";var S="pk.eyJ1IjoiZ2lzLWNsb3VkIiwiYSI6ImNpcWF4emwxeDAwODNoeG5zcXV6MmRudXUifQ.HVmcXtwpFADw_8GV9vRdhA";var P="pk.eyJ1IjoiZ2lzLWNsb3VkIiwiYSI6ImNpcjJtZm1ycTAwMDRpNG05M2EzNHlkNHYifQ.F2Ewzr375JuR0qKVtgTXYQ";var E="pk.eyJ1IjoiZ2lzLWNsb3VkIiwiYSI6ImNpcWNhcmxhZjAwNXdpMm5odjN2Y2xjd3oifQ.Xkm-8IqET75Nbv6pJdcCyg";var O="pk.eyJ1IjoiZ2lzLWNsb3VkIiwiYSI6ImNpcWNhczBhNDAwNXhpMm5oYW9sNWNkM2sifQ.PgE89DHu-8GqOvQyOMg3oQ";if(l.type=="raster"){y={noWrap:true,visible:l.visible,opacity:l.alpha,maxZoom:n,modified:l.timestamp};if(!l.format){l.format="jpg"}if(l.level){y.minZoom=y.maxZoom=l.level}if(l.fromlevel){y.minZoom=l.fromlevel}if(l.tolevel&&l.tolevel<n){y.maxZoom=l.tolevel}var A=giscloud.tile_token+":";A="";_=new fnRasterLayer(giscloud_tile_url+"r/"+A+l.timestamp+"/"+t+"/"+l.id+"/{z}/{x}/{y}."+l.format,y);_.id=l.id;_.source=r[l.src];_.useForDEM=l.useForDEM}else if(c=="osm"){_=new fnBasemapLayer((window.location.protocol==="https:"?"https:":"http:")+"//{s}.tile.openstreetmap.org/{z}/{x}/{y}.png",{maxZoom:19,src:c,noWrap:true,visible:l.visible,opacity:l.alpha,attribution:l.visible?"<a href='http://www.openstreetmap.org/' target='_blank' rel='noopener noreferrer'>OpenStreetMap</a>":""});_.id=l.id;_.source=r[l.src]}else if(c=="cloudmade_night"){_=new fnBasemapLayer("http://{s}.tile.cloudmade.com/{key}/65053/256/{z}/{x}/{y}.png",{maxZoom:18,noWrap:true,visible:l.visible,opacity:l.alpha,attribution:l.visible?"Map data &copy; 2011 OpenStreetMap contributors, Imagery &copy; 2011 CloudMade":"",key:"d962ac9332ae40b29b77f41aa3b67ca9"});_.id=l.id;_.source=r[l.src]}else if(c=="mapbox.streets"||c=="mapquest-osm"){_=new fnBasemapLayer(T+"//api.mapbox.com/v4/mapbox.streets/{z}/{x}/{y}[scale].png?access_token="+D,{maxZoom:20,src:c,noWrap:true,visible:l.visible,opacity:l.alpha,attribution:l.visible?"&copy; <a href='https://www.mapbox.com/about/maps/' target='_blank' rel='noopener noreferrer'>Mapbox</a> "+"&copy; <a href='http://www.openstreetmap.org/copyright' target='_blank' rel='noopener noreferrer'>OpenStreetMap</a>":""});_.id=l.id;if(window.devicePixelRatio===1){_._url[0]=_._url[0].replace("[scale]","");if(giscloud.offlineMode()){_.options.tileScaleFactor=2}}else{_._url[0]=_._url[0].replace("[scale]","@2x");_.options.tileScaleFactor=2}_.source=r[l.src]}else if(c=="tilejson"&&giscloud.offlineMode()&&r[l.src].attribution.indexOf("MapTiler")>-1){_=new fnBasemapLayer((window.location.protocol==="https:"?"https:":"http:")+"//{s}.tile.openstreetmap.org/{z}/{x}/{y}.png",{maxZoom:18,src:c,noWrap:true,visible:l.visible,opacity:l.alpha,attribution:r[l.src].attribution});_.id=l.id;_.source=r[l.src];if(window.devicePixelRatio===1){_._url[0]=_._url[0].replace("[scale]","");if(giscloud.offlineMode()){_.options.tileScaleFactor=2}}else{_._url[0]=_._url[0].replace("[scale]","@2x");_.options.tileScaleFactor=2}_.source=r[l.src]}else if(c=="mapbox.light"){_=new fnBasemapLayer(T+"//api.mapbox.com/v4/mapbox.light/{z}/{x}/{y}[scale].png?access_token="+S,{maxZoom:20,src:c,noWrap:true,visible:l.visible,opacity:l.alpha,attribution:l.visible?"&copy; <a href='https://www.mapbox.com/about/maps/' target='_blank' rel='noopener noreferrer'>Mapbox</a> "+"&copy; <a href='http://www.openstreetmap.org/copyright' target='_blank' rel='noopener noreferrer'>OpenStreetMap</a>":""});_.id=l.id;if(window.devicePixelRatio===1){_._url[0]=_._url[0].replace("[scale]","");if(giscloud.offlineMode()){_.options.tileScaleFactor=2}}else{_._url[0]=_._url[0].replace("[scale]","@2x");_.options.tileScaleFactor=2}_.source=r[l.src]}else if(c=="mapbox.dark"){_=new fnBasemapLayer(T+"//api.mapbox.com/v4/mapbox.dark/{z}/{x}/{y}[scale].png?access_token="+P,{maxZoom:20,src:c,noWrap:true,visible:l.visible,opacity:l.alpha,attribution:l.visible?"&copy; <a href='https://www.mapbox.com/about/maps/' target='_blank' rel='noopener noreferrer'>Mapbox</a> "+"&copy; <a href='http://www.openstreetmap.org/copyright' target='_blank' rel='noopener noreferrer'>OpenStreetMap</a>":""});_.id=l.id;if(window.devicePixelRatio===1){_._url[0]=_._url[0].replace("[scale]","");if(giscloud.offlineMode()){_.options.tileScaleFactor=2}}else{_._url[0]=_._url[0].replace("[scale]","@2x");_.options.tileScaleFactor=2}_.source=r[l.src]}else if(c=="mapbox.satellite"||c=="mapquest-oarial"){_=new fnBasemapLayer(T+"//api.mapbox.com/v4/mapbox.satellite/{z}/{x}/{y}[scale].jpg?access_token="+E,{maxZoom:20,src:c,noWrap:true,visible:l.visible,opacity:l.alpha,attribution:l.visible?"&copy; <a href='https://www.mapbox.com/about/maps/' target='_blank' rel='noopener noreferrer'>Mapbox</a> "+"&copy; <a href='http://www.openstreetmap.org/copyright' target='_blank' rel='noopener noreferrer'>OpenStreetMap</a>":""});_.id=l.id;if(window.devicePixelRatio===1){_._url[0]=_._url[0].replace("[scale]","");if(giscloud.offlineMode()){_.options.tileScaleFactor=2}}else{_._url[0]=_._url[0].replace("[scale]","@2x");_.options.tileScaleFactor=2}_.source=r[l.src]}else if(c=="mapbox.satellite-streets"){_=new fnBasemapLayer(T+"//api.mapbox.com/v4/mapbox.streets-satellite/{z}/{x}/{y}[scale].jpg?access_token="+O,{maxZoom:20,src:c,noWrap:true,visible:l.visible,opacity:l.alpha,attribution:l.visible?"&copy; <a href='https://www.mapbox.com/about/maps/' target='_blank' rel='noopener noreferrer'>Mapbox</a> "+"&copy; <a href='http://www.openstreetmap.org/copyright' target='_blank' rel='noopener noreferrer'>OpenStreetMap</a>":""});_.id=l.id;if(window.devicePixelRatio===1){_._url[0]=_._url[0].replace("[scale]","");if(giscloud.offlineMode()){_.options.tileScaleFactor=2}}else{_._url[0]=_._url[0].replace("[scale]","@2x");_.options.tileScaleFactor=2}_.source=r[l.src]}else if(c=="here.satellite"){_=new fnBasemapLayer(T+"//2.aerial.maps.cit.api.here.com/maptile/2.1/maptile/newest/satellite.day/{z}/{x}/{y}/256/png8?app_id="+M+"&app_code="+I,{maxZoom:20,noWrap:true,visible:l.visible,opacity:l.alpha,attribution:l.visible?"&copy; <a href='https://developer.here.com/' target='_blank' rel='noopener noreferrer'>HERE</a> ":""});_.id=l.id;_.source=r[l.src]}else if(c=="here.streets"){_=new fnBasemapLayer(T+"//1.base.maps.cit.api.here.com/maptile/2.1/maptile/newest/normal.day/{z}/{x}/{y}/256/png8?app_id="+M+"&app_code="+I,{maxZoom:20,noWrap:true,visible:l.visible,opacity:l.alpha,attribution:l.visible?"&copy; <a href='https://developer.here.com/' target='_blank' rel='noopener noreferrer'>HERE</a> ":""});_.id=l.id;_.source=r[l.src]}else if(c=="croatianq"){_=new fnBasemapLayer("http://dhwov6czq254q.cloudfront.net/gettile.php?t=tilestache88/{z}/{x}/{y}.png?v=1",{maxZoom:18,noWrap:true,visible:l.visible,opacity:l.alpha,attribution:l.visible?" &copy; <a href='http://www.navteq.com' target='_blank' rel='noopener noreferrer'>NAVTEQ</a>":""});_.id=l.id;_.source=r[l.src]}else if(c=="italia"){_=new fnBasemapLayer("http://webgis.regione.sardegna.it/tms/ortofoto2006_EPSG3003/{z}/{x}/{y}.jpg",{maxZoom:18,noWrap:true,visible:l.visible,opacity:l.alpha,continuousWorld:true,attribution:l.visible?" &copy; <a href='http://www.italia' target='_blank' rel='noopener noreferrer'>NAVTEQ</a>":""});_.id=l.id;_.source=r[l.src]}else if(c=="grajs"){_=new fnBasemapLayer("http://dhwov6czq254q.cloudfront.net/gettile.php?t=tilestache17403/{z}/{x}/{y}.png",{maxZoom:18,noWrap:true,visible:l.visible,opacity:l.alpha,attribution:l.visible?" &copy; <a href='http://www.grajsmape.com' target='_blank' rel='noopener noreferrer'>Grajs Mape</a>":""});_.id=l.id;_.source=r[l.src]}else if(c=="maps_for_free_relief"){_=new fnBasemapLayer("https://maps-for-free.com/layer/relief/z{z}/row{y}/{z}_{x}-{y}.jpg",{maxZoom:11,noWrap:true,visible:l.visible,opacity:l.alpha,attribution:l.visible?" <a href='https://www.maps-for-free.com/html/about.html' target='_blank' rel='noopener noreferrer'>Maps-For-Free Relief</a>":""});_.id=l.id;_.source=r[l.src]}else if(c=="bing"){_=new fnQuadLayer(window.location.protocol=="https:"?"https://t{s}.ssl.ak.dynamic.tiles.virtualearth.net/comp/ch/{q}?mkt=en-us&it=G,VE,BX,L,LA&shading=hill&n=z":"http://ecn.t{s}.tiles.virtualearth.net/tiles/r{q}?g=811&mkt=en-us&lbl=l1&stl=h&shading=hill&n=z",{minZoom:1,maxZoom:19,noWrap:true,visible:l.visible,subdomains:"0123",opacity:l.alpha,attribution:l.visible?"<a href='http://maps.bing.com/' target='_blank' rel='noopener noreferrer'>Bing Maps</a>"+"&nbsp;&copy; NAVTEQ, &copy; Microsoft Corporation":""});_.id=l.id;_.source=r[l.src]}else if(c=="bing_sat"){_=new fnQuadLayer(window.location.protocol=="https:"?"https://t{s}.ssl.ak.dynamic.tiles.virtualearth.net/comp/ch/{q}?mkt=en-us&it=A&shading=hill&n=z":"http://ak.t{s}.tiles.virtualearth.net/tiles/a{q}?g=1457&n=z",{minZoom:1,maxZoom:19,noWrap:true,visible:l.visible,subdomains:"0123",opacity:l.alpha,attribution:l.visible?"<a href='http://maps.bing.com/' target='_blank' rel='noopener noreferrer'>Bing Maps Satellite</a>"+"&nbsp;&copy; Microsoft Corporation":""});_.id=l.id;_.source=r[l.src]}else if(c=="bing_hyb"){_=new fnQuadLayer(window.location.protocol=="https:"?"https://ecn.t{s}.tiles.virtualearth.net/tiles/h{q}?g=1457&n=z":"http://ak.t{s}.tiles.virtualearth.net/tiles/h{q}?g=1457&n=z",{minZoom:1,maxZoom:19,noWrap:true,visible:l.visible,subdomains:"0123",opacity:l.alpha,attribution:l.visible?"<a href='http://maps.bing.com/' target='_blank' rel='noopener noreferrer'>Bing Maps Hybrid</a>"+"&nbsp;&copy; Microsoft Corporation":""});_.id=l.id;_.source=r[l.src]}else if(c=="wms"||(r[l.src].tilepath||r[l.src].tilepath=="")){_=new fnWmsLayer(r[l.src].tilepath==""?r[l.src].tileservers:r[l.src].tileservers[0]+r[l.src].tilepath,{maxZoom:n,noWrap:true,visible:l.visible,subdomains:"0123",opacity:l.alpha,gctms:r[l.src].src==="tms",attribution:r[l.src].attribution,srcName:r[l.src].src_name});_.id=l.id;_.source=r[l.src];if(_.options.srcName&&(_.options.srcName==="mapbox.streets"||_.options.srcName==="mapbox.light"||_.options.srcName==="mapbox.dark"||_.options.srcName==="mapbox.satellite"||_.options.srcName==="mapbox.satellite-streets")){_.options.attribution="&copy; <a href='https://www.mapbox.com/about/maps/' target='_blank' rel='noopener noreferrer'>Mapbox</a> "+"&copy; <a href='http://www.openstreetmap.org/copyright' target='_blank' rel='noopener noreferrer'>OpenStreetMap</a>"}if(_._url&&_._url.length>0&&(_._url[0].match("api.maptiler.com/maps/streets")||_._url[0].match("api.maptiler.com/maps/darkmatter")||_._url[0].match("api.maptiler.com/maps/bright"))){_.options.attribution="&copy; <a href='http://www.openstreetmap.org/copyright' target='_blank' rel='noopener noreferrer'>OpenStreetMap</a>"}}else if(c=="tilejson"){var N=r[l.src];_=new fnLayer(N.tileservers,{maxZoom:N.maxzoom,noWrap:true,visible:l.visible,opacity:l.alpha,attribution:N.attribution});_.id=l.id;_.source=N}else{var R;e.isUsingMapEngineGroupedLayers=b;if(flashnavigator.newLabelingMode&&l.labels&&l.dontLoad&&l.id.substr(0,2)=="ll"){v[l.id.substr(1)]={attribute:l.labels,type:l.labelsType,features:l.features};continue}R={mid:t,id:l.id,modified:l.timestamp,lmap:lv.map,maxZoom:n,offset:l.offset,visible:l.visible,precision:l.precision,cluster:l.cluster,dynamic:l.dynamic,opacity:l.alpha,tooltip:l.tooltip,dontLoad:l.dontLoad,source:r[l.src],modifier:f[l.id]};if(b){_=new fnTileLayerGroup(R,e.parent.html5Map);_.shouldBeLoaded=true}else{_=new fnTileLayer(R,e.parent.html5Map)}_.labelData=l;_.has_inner_line=l.has_inner_line;if(labelLayer){labelLayer.updateLayerDescriptor(_.id,l)}if(layers_feature_filter[l.id]&&_.setFeatureFilter){_.filterToInitOnLoad=layers_feature_filter[l.id]}if(!_.tileLayer){_.isTileLayer=true}}l.fnLayer=_;_.features=l.features;_.has_icon=l.has_icon;_.layer_info=l;_.should_add=true;_.viewer=e;i[h++]=_;g=_.isRootLayer}if(p){lv.setProjection(3857)}else{lv.setProjection(4326)}lv.map.gc_bounds=bounds;lv.map.layersMaxLevel=n;lv.map.unitFactor=unitFactor;for(o=0;o<i.length;o++){if(v[i[o].id]){i[o].labels=v[i[o].id]}if(i[o].options.maxZoom>n){i[o].options.maxZoom=n}if(i[o].options.minZoom>w&&i[o].layer_info.type!=="raster"){w=i[o].options.minZoom}}e.setMinZoom(w);if(labelLayer){labelLayer.layers=i.filter(function(e){return e.id!=="layer0"}).reduce(function(e,t){e[t.id]=t;return e},{});giscloud.util.mediator.publish("labelRenderer/dropCache");giscloud.util.mediator.publish("labels/rerender")}q=n}function m(e,t){t.features=[];for(var i=0;i<e.length;i++){var n=e[i];if(n.tagName!="feature")continue;var r={};if(n.attributes){for(var o=0;o<n.attributes.length;o++){if(n.attributes[o].name=="icon"||n.attributes[o].name=="hatchurl"||n.attributes[o].name=="hatchgalleryurl"){r.icon=n.attributes[o].value;t.has_icon=true}else if(n.attributes[o].name=="outline"){r.outline=n.attributes[o].value}else if(n.attributes[o].name=="color"){r.color=n.attributes[o].value}else if(n.attributes[o].name=="strokecolor"){r.strokecolor=n.attributes[o].value;r.strokecolorRGB=giscloud.Color.hexToRgb(r.strokecolor)}else if(n.attributes[o].name=="innerstrokecolor"){r.innerstrokecolor=n.attributes[o].value}else if(n.attributes[o].name=="fillcolor"){r.fillcolor=n.attributes[o].value;r.fillcolorRGB=giscloud.Color.hexToRgb(r.fillcolor)}else if(n.attributes[o].name=="linewidth"){r.linewidth=n.attributes[o].value*1}else if(n.attributes[o].name=="innerlinewidth"){r.innerlinewidth=n.attributes[o].value*1}else if(n.attributes[o].name=="width"){r.width=n.attributes[o].value*1}else if(n.attributes[o].name=="anchor"){r.anchor=n.attributes[o].value}else if(n.attributes[o].name=="dx"){r.dx=n.attributes[o].value*1}else if(n.attributes[o].name=="dy"){r.dy=n.attributes[o].value*1}else if(n.attributes[o].name=="type"){r.type=n.attributes[o].value}else if(n.attributes[o].name=="visible"){r.visible=n.attributes[o].value==="1"}else if(n.attributes[o].name=="text"||n.attributes[o].name=="label"){if(flashnavigator.newLabelingMode){r.label=n.attributes[o].value.toLowerCase();t.labels=t.labels||{};t.labels[r.label]=1;t.labelsType=n.attributes[o].name;t.dontLoad=true}}else if(n.attributes[o].name=="clustering"){r.clustering=parseInt(n.attributes[o].value)}else if(n.attributes[o].name=="fontname"){r.fontname=n.attributes[o].value}else if(n.attributes[o].name=="query"){r.expression=n.attributes[o].value}else if(n.attributes[o].name=="querylabel"){r.expressionLabel=n.attributes[o].value}else if(n.attributes[o].name=="fontsize"){r.fontsize=parseInt(n.attributes[o].value)}else if(n.attributes[o].name=="dashed"){r.dashed=n.attributes[o].value;if(r.dashed){r.dashed=r.dashed.split(",");for(var s=0;s<r.dashed.length;s++){r.dashed[s]*=1}}}else if(n.attributes[o].name==="style"){r.styleName=n.attributes[o].value}}}if(r.label)t.labelsType=r.type;t.features.unshift(r)}if(t.labels){var a=[];for(var s in t.labels){a.push(s)}t.labels=a.join(",")}}s=[];function y(e,t){if(!s[e])return;for(var i=0;i<s[e].length;i++){s[e][i](t)}}var _=0;this.on("dragstart",function(){_=1});this.on("dragend",function(){_=0});function b(t,i,n,r){if(!loaded||!O||O.length==0)return 0;var e,o,s,a,l,c,u,d,f,h,p=t.z,g;e=Math.floor(t.mapX);o=Math.floor(t.mapY);t.offsetX=256*(t.mapX-e);t.offsetY=256*(t.mapY-o);t.showMousePointer=0;s=false;for(u=0;u<O.length;++u){c=O[u].tileLayer||O[u];if(c.tilesToLoad&&c.tilesToLoad()){s=true;break}}g=k.parent.html5Map.getTileKey(e,o,p);if(flashnavigator.offscreenRendering){k.parent.html5Map.workerProcessMousePosition(t,g,x,v,i);return}t.hoveredObject=null;var m=function(e){h=e?g+"W"+e:g;if(!c._tiles[h]||!c._tiles[h].gc_state){return false}a=c._tiles[h];l=a.gc_state.obj;t.currentTile=a;d=l.parent;a.gc_state.layer=O[u].id;a.gc_state.curLayerObj=O[u];f=l.onMouseMove(t,n,r,O[u]);l.parent=d;t.currentTile=null;if(f){f.coord=a.coord;t.hoveredObject=f;t.showMousePointer=1;if(!(x&&f.c===x.c)){i(t)}return true}return false};for(u=0;u<O.length;++u){c=O[u].tileLayer||O[u];if(c._tiles&&O[u].options.visible&&c.isTileLayer){if(m()){return}if(m(1)){return}if(m(-1)){return}}}if(!s){i(t)}}function w(e,t){var i=x;if(i&&s[t]){var n=1<<lv.getScale();var r={id:i.c?i.c.replace("_","||"):"",object:i};if(e){r.x=e.x;r.y=e.y;if(i.coord){r.bounds={xmin:bounds.xmin+(r.object.b.xmin/flashnavigator.tileSize+i.coord.x)*bounds.max/n,xmax:bounds.xmin+(r.object.b.xmax/flashnavigator.tileSize+i.coord.x)*bounds.max/n,ymin:bounds.ymax-(r.object.b.ymax/flashnavigator.tileSize+i.coord.y)*bounds.max/n,ymax:bounds.ymax-(r.object.b.ymin/flashnavigator.tileSize+i.coord.y)*bounds.max/n}}}if(e&&(e.ctrlKey||e.originalEvent&&e.originalEvent.ctrlKey||e.originalEvent&&e.originalEvent.metaKey)){r.key=17}y(t,r);return}}var x=null;var C;var L;var T;var j=null;function M(){b(T,function(e){if(e.hoveredObject){x={};x.c=e.hoveredObject.c;x.attributes=e.hoveredObject.attributes;x.data=e.hoveredObject.data;x.cl=e.hoveredObject.cl;x.coord=e.hoveredObject.coord;x.b=e.hoveredObject.b}else{x=null}j=e;w(e,"object_click")},true,10*flashnavigator.scaleRatio)}this.on("touchstart",function(e){if(e.originalEvent.targetTouches.length!=1)return;var t=e.originalEvent.targetTouches[0];T=e;L={x:t.pageX,y:t.pageY};window.clearTimeout(C);C=window.setTimeout(M,200);y("mousemove",{x:e.x,y:e.y})});this.on("touchend",function(e){window.clearTimeout(C);if(T)M()});this.on("touchmove",function(e){if(!L)return;var t=e.originalEvent.targetTouches[0];var i=Math.abs(t.pageX-L.x);var n=Math.abs(t.pageY-L.y);if(i>2||n>2){T=null;window.clearTimeout(C)}});if(!common.isMobileBrowser){this.on("mousemove",function(e){var t={x:e.x,y:e.y,z:e.z,mapX:e.mapX,mapY:e.mapY,ctrlKey:e.ctrlKey};if(e.originalEvent){t.originalEvent={ctrlKey:e.originalEvent.ctrlKey,metaKey:e.originalEvent.metaKey}}if(!v){if(j){b(t,function(){});w(j,"object_out");j=null;x=null}return 0}if(!bounds||_)return 0;b(t,function(e){if(e.showMousePointer){lv.setCursor("pointer");if(e.hoveredObject){x={};x.c=e.hoveredObject.c;x.attributes=e.hoveredObject.attributes;x.data=e.hoveredObject.data;x.cl=e.hoveredObject.cl;x.coord=e.hoveredObject.coord;x.b=e.hoveredObject.b}else{x=null}j=e;w(e,"object_over")}else{if(!flashnavigator.hasCanvas&&(k._currentTool=="InfoTool"||k._currentTool=="SelectTool")){lv.setCursor("default")}else{lv.setCursor("")}if(j){w(j,"object_out");j=null;x=null}}});if(s["mousemove"]){y("mousemove",{x:e.x,y:e.y})}});this.on("dblclick",function(e){w(e,"object_dblclick")});this.on("click",function(e){w(e,"object_click")})}this.on("mousedown",function(e){b(e,function(e){if(s["mousedown"]){y("mousedown",{x:e.x,y:e.y})}})});this.on("dblclick",function(e){b(e,function(e){if(s["doubleClick"]){y("doubleClick",{x:e.x,y:e.y})}})});this.on("mouseup",function(e){b(e,function(e){if(s["mouseup"]){y("mouseup",{x:e.x,y:e.y})}})});this.on("dragend",function(e){if(s["dragend"]){y("dragend",{})}});this.calculateScaleZoom=function(e){if(bounds&&bounds.max)return Math.pow(2,e)*256/bounds.max;else return 0};this.addEventListener=function(e,t){if(e=="scalechange"){if(!s["scalechange"]){s["scalechange"]=new Array;this.on("zoomend",function(e){var t=new Object;if(bounds&&bounds.max)t.zoom=k.calculateScaleZoom(lv.getScale());y("scalechange",t)})}}else if(e=="boundschange"){if(!s["boundschange"]){s["boundschange"]=new Array;this.on("move",function(e){var t={bounds:k.getViewBound()};y("boundschange",t)})}}else{if(!s[e])s[e]=new Array}s[e].push(t)};this.removeEventListener=function(e,t){var i,n,r=s[e];if(r){for(i=0,n=r.length;i<n;i++){if(r[i]===t){r.splice(i,1);i--;n--}}}}};giscloud.Html5MapRefreshUrls=function(){giscloud_tile_url=giscloud_config.tileSite()};var is_edge_android=window.navigator.userAgent.indexOf("EdgA/")>-1;common.LegacyHtml5Map=function LegacyHtml5Map(flashnavigator){var isWebKit=navigator.userAgent.indexOf("WebKit")>0;var isMouseDown;var fields;var _selectablePoly;var bounds;var selectionEnabled=false;var laycount=0;var loader_id=0;var active_loaders={};var tile_request={};var tile_req=[];var tile_req_seq=0;var text_data={};var outerSendRequests;flashnavigator.scaleRatio=window.devicePixelRatio?Math.ceil(window.devicePixelRatio):1;flashnavigator.tileSize=256*flashnavigator.scaleRatio;flashnavigator.canvasOptions={};var Html5SendRequests=this.Html5SendRequests=function(){if(outerSendRequests&&outerSendRequests.call){outerSendRequests()}else{console.warn("no sendRequests()")}};this.Html5MapSetSelection=function(e){selectionEnabled=e};this.workerSyncLayers=function(){workerSyncLayers()};this.workerProcessMousePosition=function(e,t,i,n,r){workerProcessMousePosition(e,t,i,n,r)};this.getTileKey=function(e,t,i,n,r){return getTileKey(e,t,i,n,r)};this.Html5Map=function(e,t){_init(e,this);this.parent=t;this._layer=e;laycount++;var i=this;var n=flashnavigator.scaleRatio;window.addEventListener("resize",function(){flashnavigator.scaleRatio=window.devicePixelRatio?Math.ceil(window.devicePixelRatio):1;flashnavigator.tileSize=256*flashnavigator.scaleRatio;if(n!=flashnavigator.scaleRatio){if(flashnavigator.offscreenRendering){workerHandlerUpdateScaleRatio()}else{initTileCache()}i.redraw(false,true);n=flashnavigator.scaleRatio}},true);outerSendRequests=sendRequests;this.Html5SendRequests=Html5SendRequests;this.getCanvasFromPool=function(e,t,i){return getCanvasFromPool(e,t,i)};this.releaseCanvasToPool=function(e){releaseCanvasToPool(e)};this.canvasPoolCleanUp=function(){canvasPoolCleanUp()};this.resetCache=function(){resetTileCache()};this._loadTile=_loadTile;this.setFields=function(e){fields=e};this.getTile=function(e,t,i){return _getTile(e,t,i,this)};this.loadTile=function(e,t,i){return _loadTile(e,t,i,this)};this.unloadTile=function(e,t){unloadTile(e,t)};this.selectablePoly=function(e){_selectablePoly=e};this.setBounds=function(e){bounds=e};this.onMouseMove=function(e,t,i,n){if(n._selectable)return checkForEvent(e,t,i);else return false};this.onMouseUp=function(e){};this.onMouseDown=function(e){};this.modifyObject=function(e,t,i,n,r,o){if(flashnavigator.offscreenRendering){workerModifyObject(this.parent.id,e,t,i,n,r,o);return}modifyObject(this,e,t,i,n,r,o)};this.redraw=function(e,t,i){redraw(this.parent,e,t,i)};this.redrawSingleTile=function(e){redrawSingleTile(this.parent,e,null,true)};this.redrawNeighbourTiles=function(e){redrawNeighbourTiles(e)};this.restoreTileFromCache=function(e){if(flashnavigator.offscreenRendering){workerRestoreTileFromCache(this.parent.id,e.gc_state._tileIndex,e.gc_state._cacheId,e.gc_state._tileIndexWrap)}else{this.redrawSingleTile(e)}};this.storeTileToCache=function(e){if(flashnavigator.offscreenRendering){workerStoreTileToCache(this.parent.id,e.gc_state._tileIndex,e.gc_state._cacheId)}};this.getTileKey=function(e,t,i,n,r){return getTileKey(e,t,i,n,r)};this.reload=function(e){var t=this,i={},n=this.parent._tiles,r;if(e)this.reinitCanvases();this.parent.resetCache();if(Object.keys(n).length===0){this.parent.update();return}for(r in n){if(n[r].coord||n[r].gc_state){n[r].styles=null;if(!_loadTile(n[r],n[r].coord,n[r].zoom,this)){i[r]=true}}}setTimeout(function(){t.parent.update();if(Object.keys(i).length>0){t.redraw(undefined,undefined,i)}},0)};this.resetLoaders=function(){resetLoaders()};this.abortRequest=function(e){if(!e||!e.gc_state){return}if(flashnavigator.offscreenRendering){workerAbortRequest(e);return}for(var t=0,i=tile_req.length;t<i;t++){if(tile_req[t].gc_state===e.gc_state){tile_req[t].tile=null}}abortRequest(e)};this.getFeature=function(e){var t=e.replace("||","_");var i=this.parent._tiles;for(var n in i){if(i[n].fields&&i[n].fields[t]){return i[n].fields[t]}}};this.getFeatureIds=function(e,t){var i=this.parent._tiles,n=[],r;if(!e)return;if(!t){t=this.parent.id}for(r in i){if(this.parent._tileShouldBeVisible(i[r].coord)){n.push(r)}}if(flashnavigator.offscreenRendering){workerGetFeatureIds(t,this.parent.id,n,e)}else{e(t,getFeatureIdsInTiles(t,n,this.parent._tiles))}};this.renderLabels=function(e,t){renderLabelTile(e,t)};this.checkAttributesAndReload=function(){checkAttributesAndReload(this.parent)};this.setupAttributes=function(){var e="";if(this.parent.feature_filter){e=i.parent.feature_filter.attributes}if(this.parent.labels){if(e){e+=","}e+=this.parent.labels.attribute}if(this.parent.labelData&&this.parent.labelData.attribute){if(e){e+=","}e+=this.parent.labelData.attribute}if(this.parent.options.tooltip){if(e){e+=","}e+=this.parent.options.tooltip}this.feature_attributes=unique_array(e.split(",")).join(",")};this.removeTileFromCache=function(e){removeTileFromCache(e)};this.workerLayerUpdate=function(e,t){workerLayerUpdate(e,t)};this.workerUnloadTiles=function(e){workerUnloadTiles(e)};this.workerUnloadTile=function(e,t,i){workerUnloadTile(e,t,i)};this.workerLayerRemove=function(e){workerLayerRemove(e)};this.workerResetGroup=function(e,t){workerResetGroup(e,t)};this.workerLayerSetFilter=function(e,t){workerLayerSetFilter(e,t)};this.workerCanvasPoolCleanUp=function(){workerCanvasPoolCleanUp()};this.workerWrapTiles=function(e,t){workerWrapTiles(e,t)};return this};(function e(){if(!self.performance){var t=Date.now();self.performance={now:function e(){return Date.now()-t}}}})();(function(){"use strict";if(!giscloud){giscloud={math:{}}}else if(!giscloud.math){giscloud.math={}}(function(){"use strict";var e=giscloud.math;function t(){function s(e,t){if(!this){throw new Error("[giscloud.math.Vector2] is a constructor and must be invoked with `new`")}if(Array.isArray(e)){this.x=e[0]||0;this.y=e[1]||0}else if(e instanceof s){this.x=e.x;this.y=e.y}else if(typeof e==="number"){if(typeof t==="number"){this.x=e;this.y=t}else{this.x=e;this.y=e}}else{this.x=0;this.y=0}}s.prototype.length=function(){return Math.sqrt(this.x*this.x+this.y*this.y)};s.prototype.lengthSquared=function(){return this.x*this.x+this.y*this.y};s.prototype.angle=function(){return Math.atan2(this.y,this.x)};s.prototype.add=function(e,t){var i=new s(e,t);i.x+=this.x;i.y+=this.y;return i};s.prototype.subtract=function(e,t){var i=new s(e,t);i.x=this.x-i.x;i.y=this.y-i.y;return i};s.prototype.dot=function(e,t){var i=new s(e,t);return this.x*i.x+this.y*i.y};s.prototype.scale=function(e){return new s(this.x*e,this.y*e)};s.prototype.cross=function(){return new s(this.y,-this.x)};s.prototype.distanceTo=function(e,t){var i=new s(e,t);i.x-=this.x;i.y-=this.y;return i.length()};s.prototype.distanceToSquared=function(e,t){var i=new s(e,t);i.x-=this.x;i.y-=this.y;return i.lengthSquared()};s.lerp=function(e,t,i){i=Math.min(Math.max(i,0),1);var n=1-i,r=new s(e),o=new s(t);return new s(r.x*n+o.x*i,r.y*n+o.y*i)};e.Vector2=s}t();e.Vector2.define=t})();(function(){"use strict";var s=giscloud.math;function e(){function n(e,t,i,n){if(!this){throw new Error("[giscloud.math.Matrix2] is a constructor and must be invoked with `new`")}if(typeof e==="number"&&typeof t==="number"&&typeof i==="number"&&typeof n==="number"){this.x=new s.Vector2(e,t);this.y=new s.Vector2(i,n)}else if(e instanceof s.Vector2&&t instanceof s.Vector2){this.x=new s.Vector2(e);this.y=new s.Vector2(t)}else if(Array.isArray(e)&&Array.isArray(e[0])&&Array.isArray(e[1])){this.x=new s.Vector2(e[0][0],e[0][1]);this.x=new s.Vector2(e[1][0],e[1][1])}else{this.x=new s.Vector2(1,0);this.y=new s.Vector2(0,1)}}n.prototype.transform=function(e){if(e instanceof s.Vector2){return new s.Vector2(this.x.x*e.x+this.x.y*e.y,this.y.x*e.x+this.y.y*e.y)}else if(e instanceof giscloud.math.Rect){var t=e.center(),i=e.min.subtract(t),n=new s.Vector2(e.max.x,e.min.y).subtract(t),r=e.max.subtract(t),o=new s.Vector2(e.max.x,e.max.y).subtract(t);i=this.transform(i).add(t);n=this.transform(n).add(t);r=this.transform(r).add(t);o=this.transform(o).add(t);return new giscloud.math.Rect(t,t).extend(i).extend(n).extend(r).extend(o)}};n.prototype.mul=function(e){return new n(this.x.x*e.x.x+this.x.y*vec2.y.x,this.x.x*e.x.y+this.x.y*vec2.y.y,this.y.x*e.x.x+this.y.y*vec2.y.x,this.y.x*e.x.y+this.y.y*vec2.y.y)};n.prototype.scale=function(e,t){return new n(this.x.scale(e),this.y.scale(e))};n.prototype.rotate=function(e){return this.mul(n.Rotation(e))};n.Scale=function(e,t){return new n(e,0,0,t)};n.Identity=function(){return new n};n.Rotation=function(e){var t=Math.sin(e),i=Math.cos(e);return new n(i,-t,t,i)};s.Matrix2=n}e();s.Matrix2.define=e})();(function(){"use strict";var g=giscloud.math;function e(){function o(e,t,i,n){if(!this){throw new Error("[giscloud.math.Rect] is a constructor and must be invoked with `new`")}if(e instanceof o){this.min=new g.Vector2(e.min);this.max=new g.Vector2(e.max)}else if(Array.isArray(e)&&Array.isArray(t)){this.min=new g.Vector2(e);this.max=new g.Vector2(t)}else if(e instanceof g.Vector2&&t instanceof g.Vector2){this.min=new g.Vector2(e);this.max=new g.Vector2(t)}else if(typeof e==="number"&&typeof t==="number"&&typeof i==="number"&&typeof n==="number"){this.min=new g.Vector2(e,t);this.max=new g.Vector2(i,n)}else{this.min=new g.Vector2(0,0);this.max=new g.Vector2(0,0)}}o.prototype.position=function(){return this.min};o.prototype.size=function(){return this.max.subtract(this.min)};o.prototype.left=function(){return this.min.x};o.prototype.top=function(){return this.min.y};o.prototype.right=function(){return this.max.x};o.prototype.bottom=function(){return this.max.y};o.prototype.area=function(){var e=this.size();return e.x*e.y};o.prototype.equals=function(e){if(!(e instanceof o)){throw new Error("[giscloud.math.Rect#equals] rect argument must be an instance of giscloud.math.Rect")}else{return this.min.x===e.min.x&&this.min.y===e.min.y&&this.max.x===e.max.x&&this.max.y===e.max.y}return false};o.prototype.center=function(){return new g.Vector2(.5*(this.min.x+this.max.x),.5*(this.min.y+this.max.y))};o.prototype.translate=function(e,t){var i=new g.Vector2(e,t);return new o(this.min.add(i),this.max.add(i))};o.prototype.contains=function(e){if(e instanceof g.Vector2){return e.x>=this.min.x&&e.x<=this.max.x&&(e.y>=this.min.y&&e.y<=this.max.y)}else if(e instanceof o){return this.contains(e.min)&&this.contains(e.max)}else{throw new Error("[giscloud.math.Rect#contains] Invalid argument supplied, "+"must be instance of giscloud.math.self.Vector2 or giscloud.math.Rect")}};o.prototype.intersects=function(e,t,i,n){var r=new o(e,t,i,n);return!(r.min.x>this.max.x)&&!(r.max.x<this.min.x)&&!(r.min.y>this.max.y)&&!(r.max.y<this.min.y)};o.prototype.intersection=function(e,t,i,n){var r=new o(e,t,i,n);if(this.intersects(r)){r.min.x=Math.max(this.min.x,r.min.x);r.min.y=Math.max(this.min.y,r.min.y);r.max.x=Math.min(this.max.x,r.max.x);r.max.y=Math.min(this.max.y,r.max.y);return r}else{return null}};o.prototype.extend=function(e,t){var i=new g.Vector2(e,t);return new o(Math.min(i.x,this.min.x),Math.min(i.y,this.min.y),Math.max(i.x,this.max.x),Math.max(i.y,this.max.y))};o.fromArrayPolygon=function(e){var t=new g.Vector2,i=new g.Vector2,n;for(n=0;n<e.length;n+=2){t.x=Math.min(t.x,e[0]);t.y=Math.min(t.x,e[1]);i.x=Math.max(i.x,e[0]);i.y=Math.max(i.x,e[1])}return new o(t,i)};o.nearestNonIntersectingOffset=function(e,t){var i,n=.5;i=intersectBounds(e,t);if(!i){return null}if(e.contains(t.min)&&!e.contains([t.max.x,t.min.y])&&!e.contains(t.max)&&!e.contains([t.min.x,t.max.y])||!t.contains(e.min)&&!t.contains([e.max.x,e.min.y])&&t.contains(e.max)&&!t.contains([e.min.x,e.max.y])){offset=i.min.subtract(i.max).scale(n);if(Math.abs(offset.x)<Math.abs(offset.y)){offset.y=0}else{offset.x=0}}else if(!e.contains(t.min)&&!e.contains([t.max.x,t.min.y])&&e.contains(t.max)&&!e.contains([t.min.x,t.max.y])||t.contains(e.min)&&!t.contains([e.max.x,e.min.y])&&!t.contains(e.max)&&!t.contains([e.min.x,e.max.y])){offset=i.max.subtract(i.min).scale(n);if(Math.abs(offset.x)<Math.abs(offset.y)){offset.y=0}else{offset.x=0}}else if(!e.contains(t.min)&&e.contains([t.max.x,t.min.y])&&!e.contains(t.max)&&!e.contains([t.min.x,t.max.y])||!t.contains(e.min)&&!t.contains([e.max.x,e.min.y])&&!t.contains(e.max)&&t.contains([e.min.x,e.max.y])){offset=i.max.subtract(i.min).scale(n);if(Math.abs(offset.x)<Math.abs(offset.y)){offset.y=0}else{offset.x=0}}else if(!e.contains(t.min)&&!e.contains([t.max.x,t.min.y])&&!e.contains(t.max)&&e.contains([t.min.x,t.max.y])||!t.contains(e.min)&&t.contains([e.max.x,e.min.y])&&!t.contains(e.max)&&!t.contains([e.min.x,e.max.y])){offset=i.min.subtract(i.max).scale(n);if(Math.abs(offset.x)<Math.abs(offset.y)){offset.y=0}else{offset.x=0}}else if(e.contains(t.min)&&e.contains([t.max.x,t.min.y])&&!e.contains(t.max)&&!e.contains([t.min.x,t.max.y])||!t.contains(e.min)&&!t.contains([e.max.x,e.min.y])&&t.contains(e.max)&&t.contains([e.min.x,e.max.y])){offset=new g.Vector2(0,-(i.max.y-i.min.y)*n)}else if(!e.contains(t.min)&&!e.contains([t.max.x,t.min.y])&&e.contains(t.max)&&e.contains([t.min.x,t.max.y])||t.contains(e.min)&&t.contains([e.max.x,e.min.y])&&!t.contains(e.max)&&!t.contains([e.min.x,e.max.y])){offset=new g.Vector2(0,(i.max.y-i.min.y)*n)}else if(e.contains(t.min)&&!e.contains([t.max.x,t.min.y])&&!e.contains(t.max)&&e.contains([t.min.x,t.max.y])||!t.contains(e.min)&&t.contains([e.max.x,e.min.y])&&t.contains(e.max)&&!t.contains([e.min.x,e.max.y])){offset=new g.Vector2(-(i.max.x-i.min.x)*n,0)}else if(!e.contains(t.min)&&e.contains([t.max.x,t.min.y])&&e.contains(t.max)&&!e.contains([t.min.x,t.max.y])||t.contains(e.min)&&!t.contains([e.max.x,e.min.y])&&!t.contains(e.max)&&t.contains([e.min.x,e.max.y])){offset=new g.Vector2((i.max.x-i.min.x)*n,0)}else if(e.contains(t)||t.contains(e)){offset=new g.Vector2(0,(i.max.y-i.min.y)*n)}else{offset=new g.Vector2(0,-(i.max.y-i.min.y)*n)}return offset};var n=0,u=1,d=2,f=4,h=8;function p(e,t){var i=n;if(e.x<t.min.x){i|=u}else if(e.x>t.max.x){i|=d}if(e.y>t.max.y){i|=f}else if(e.y<t.min.y){i|=h}return i}o.prototype.clipLine=function(e,t){var i=new g.Vector2(e),n=new g.Vector2(t),r,o,s,a=p(i,this),l=p(n,this),c=false;while(true){if(!(a|l)){c=true;break}else if(a&l){break}else{s=a?a:l;if(s&h){r=i.x+(n.x-i.x)*(this.min.y-i.y)/(n.y-i.y);o=this.min.y}else if(s&f){r=i.x+(n.x-i.x)*(this.max.y-i.y)/(n.y-i.y);o=this.max.y}else if(s&d){o=i.y+(n.y-i.y)*(this.max.x-i.x)/(n.x-i.x);r=this.max.x}else if(s&u){o=i.y+(n.y-i.y)*(this.min.x-i.x)/(n.x-i.x);r=this.min.x}if(s===a){i.x=r;i.y=o;a=p(i,this)}else{n.x=r;n.y=o;l=p(n,this)}}}if(c&&i.distanceTo(n)>0){return[i,n]}return null};g.Rect=o}e();g.Rect.define=e})();(function(){"use strict";var a=giscloud.math;function e(){function n(e,t,i,n){this.bounds=t;this.center=this.bounds.center();this.maxObjects=i;this.children=[];this.objects=[];if(!e){this.level=n}else{this.parent=e;this.level=e.level-1}}n.prototype.split=function(){this.children[0]=new n(this,new a.Rect(this.center.x,this.bounds.min.y,this.bounds.max.x,this.center.y),this.maxObjects);this.children[1]=new n(this,new a.Rect(this.bounds.min.x,this.bounds.min.y,this.center.x,this.center.y),this.maxObjects);this.children[2]=new n(this,new a.Rect(this.bounds.min.x,this.center.y,this.center.x,this.bounds.max.y),this.maxObjects);this.children[3]=new n(this,new a.Rect(this.center.x,this.center.y,this.bounds.max.x,this.bounds.max.y),this.maxObjects)};function r(e,i){return e.children.reduce(function(e,t){if(!e&&t.bounds.contains(i)){return t}return e},null)}n.prototype.insert=function(e){var t;if(this.children.length){t=r(this,e.bounds);if(t){t.insert(e);return}}this.objects.push(e);if(this.objects.length>this.maxObjects&&this.level){if(!this.children.length){this.split()}this.objects=this.objects.filter(function(e){t=r(this,e.bounds);if(t){t.insert(e);return false}return true}.bind(this))}};n.prototype.remove=function(e){var t,i=[];for(t=0;t<this.children.length;++t){i=this.children[t].remove(e)}for(t=0;t<this.objects.length;++t){if(e(this.objects[t])){i.push(this.objects[t]);this.objects=this.objects.slice(0,t).concat(this.objects.slice(t+1))}}if(this.children.every(function(e){return!e.children.length})){if(this.children.reduce(function(e,t){return e+t.objects.length},this.objects.length)<=this.maxObjects){this.objects=this.objects.concat(this.children.reduce(function(e,t){return e.concat(t.objects)},[]));this.children=[]}}return i};n.prototype.test=function(t){var e,i;e=r(this,t);i=this.objects;if(this.children.length){if(e){i=i.concat(e.test(t))}else{this.children.forEach(function(e){i=i.concat(e.test(t))})}}return i};function e(e,t,i){if(!this){throw new Error("[giscloud.math.QuadTree] is a constructor and must be invoked with `new`")}this.bounds=new a.Rect(e);this.maxDepth=t||8;this.maxObjects=i||8;this.top=new n(null,this.bounds,this.maxObjects,this.maxDepth)}e.prototype.test=function(e){return this.top.test(e)};e.prototype.insert=function(e,t){if(!e||!t){throw new Error("[giscloud.math.QuadTree#insert] must have `bounds` and `object` arguments present")}this.top.insert({obj:t,bounds:e})};e.prototype.remove=function(e){this.top.remove(e)};function o(e,t){var i,n=[];for(i=0;i<e.objects.length;++i){n.push(t(e.objects[i]))}for(i=0;i<e.children.length;++i){Array.prototype.concat.apply(n,o(e.children[i],t))}return n}e.prototype.walk=function(e){return o(this.top,e)};function s(e,t){var i,n,r,o;t.strokeStyle="rgba(128, 255, 128, 1.0)";e.objects.forEach(function(e){i=e.bounds.min.x;n=e.bounds.min.y;r=e.bounds.max.x-i;o=e.bounds.max.y-n;t.strokeRect(i,n,r,o)});i=e.bounds.min.x;n=e.bounds.min.y;r=e.bounds.max.x-i;o=e.bounds.max.y-n;t.strokeStyle="rgba(0, 0, 0, 0.5)";t.strokeRect(i,n,r,o);e.children.forEach(function(e){s(e,t)})}e.prototype.draw=function(e){s(this.top,e)};e.prototype.clear=function(){this.top=new n(null,this.bounds,this.maxObjects,this.maxDepth)};a.QuadTree=e}e();a.QuadTree.define=e})();(function(){"use strict";var s=giscloud.math;function e(){function e(e,t){this.width=e;this.height=t;this.grid=new Array(e*t);this.stored=0}e.prototype.insert=function(e,t){var i=new s.Vector2(e),n,r,o;i.x=Math.floor(i.x);i.y=Math.floor(i.y);if(i.x%2){n=i.add(.5,.75).distanceToSquared(e)}else{n=i.add(.5,.25).distanceToSquared(e)}if(i.x>=this.width||i.y>=this.height||i.x<0||i.y<0){return null}i=this.width*i.y+i.x;if(!this.grid[i]){this.grid[i]={score:n,object:t};this.stored++;return null}else{if(this.grid[i].object.score()<t.score()||t.score()===this.grid[i].object.score()&&(this.grid[i].score&&this.grid[i].score>n)){o=this.grid[i];this.grid[i]={score:n,object:t};return o}}return null};e.prototype.walk=function(e){var t,i,n=[];for(t=0;t<this.grid.length;++t){i=this.grid[t];if(i!==undefined){n.push(e(i.object,i.score))}}return n};e.prototype.remove=function(e){var t,i;for(t=0;t<this.grid.length;++t){i=this.grid[t];if(i!==undefined&&e(i.object)){this.grid[t]=undefined;this.stored--}}};e.prototype.clear=function(){this.grid=new Array(this.width*this.height)};e.prototype.full=function(e){return Math.min(Math.max(e,0),1)*this.width*this.height<this.stored};s.Grid=e}e();s.Grid.define=e})();(function(){"use strict";function d(e,t,i){return Math.min(Math.max(e,t),i)}function e(e,t,i){return e>=t&&e<=i}function t(e,t){var i=e.length/2,n=false,r,o;for(r=0,o=i-1;r<i;o=r++){if(e[r*2+1]>=t.y!==e[o*2+1]>=t.y&&t.x<=(e[o*2]-e[r*2])*(t.y-e[r*2+1])/(e[o*2+1]-e[r*2+1])+e[r*2]){n=!n}}return n}function h(e,t,i){var n,r,o,s;o=[t[0]-e[0],t[1]-e[1]];s=[i[0]-e[0],i[1]-e[1]];r=o[0]*o[0]+o[1]*o[1];n=o[0]*s[0]+o[1]*s[1];return n>0&&n<r}function n(e,t,i){var n,r,o,s,a,l,c,u,d,f;r=t.x;o=t.y;for(n=0;n<(e.length>>1)-1;n++){s=e[(n+0<<1)+0];a=e[(n+0<<1)+1];l=e[(n+1<<1)+0];c=e[(n+1<<1)+1];if(h([s,a],[l,c],[r,o])){u=l-s;d=c-a;f=Math.abs(d*r-u*o+l*a-c*s)/Math.sqrt(d*d+u*u);if(f<i){return true}}}return false}function r(e,t,i){var n,r,o=0,s=e.length-2,a={x:null,y:null,area:null},l={x:d(t.x+e[0],i.xmin,i.xmax),y:d(t.y+e[1],i.ymin,i.ymax)},c={x:null,y:null},u={x:null,y:null};for(n=2;n<s;n+=2){c.x=d(t.x+e[n],i.xmin,i.xmax);c.y=d(t.y+e[n+1],i.ymin,i.ymax);u.x=d(t.x+e[n+2],i.xmin,i.xmax);u.y=d(t.y+e[n+3],i.ymin,i.ymax);r=(c.x-l.x)*(u.y-l.y)-(u.x-l.x)*(c.y-l.y);a.x+=r*(l.x+c.x+u.x);a.x+=r*(l.y+c.y+u.y);o+=r}a.area=o;return a}function o(e,t){var i,n,r=0,o=e.length-2,s={x:null,y:null,area:null},a={x:t.x+e[0],y:t.y+e[1]},l={x:null,y:null},c={x:null,y:null};for(i=2;i<o;i+=2){l.x=t.x+e[i];l.y=t.y+e[i+1];c.x=t.x+e[i+2];c.y=t.y+e[i+3];n=(l.x-a.x)*(c.y-a.y)-(c.x-a.x)*(l.y-a.y);s.x+=n*(a.x+l.x+c.x);s.x+=n*(a.y+l.y+c.y);r+=n}s.area=r;return s}function s(e,t,i){t=t||{x:0,y:0};return i?r(e,t,i):o(e,t)}function a(e,t){var n=0,r=0,o=0,s,a;for(i=0;i<e.length;++i){s=e[j].p[0].b;a=e[j].p[0];if(!s.c||s.xmin<t.xmin||s.xmax>t.xmax||s.ymin<t.ymin||s.ymax>t.ymax){s.c=findCG(a.p,a.cx,a.cy,t)}n+=s.c[0];r+=s.c[1];o+=b.c[2]}n/=3*o;r/=3*o;return{x:n,y:r}}function l(e){var t=0,i,n,r={x:0,y:0},o,s,a=e.length,l=a-1;for(n=0;n<a;n++){o=e[l];s=e[n];i=o.x*s.y-s.x*o.y;r.x+=(o.x+s.x)*i;r.y+=(o.y+s.y)*i;t+=i;l=n}r.x/=t*3;r.y/=t*3;return{area:Math.abs(t/2),centroid:r}}giscloud.math.util={clamp:d,between:e,calculatePolygonAreaAndCentroid:l,isPointInsidePolygon:t,isPointTouchingPath:n,findCentroidOfPolygon:a,findCenterOfGravity:s}})()})();(function(){"use strict";if(!giscloud){giscloud={util:{}}}else if(!giscloud.util){giscloud.util={}}(function(){"use strict";var t=false,n={},r=[];function e(e,t,i){if(i){r.push({timeRemaining:i,key:e})}window.localStorage.setItem(e,JSON.stringify(t))}function i(e,t){var i;i=window.localStorage.getItem(e);if(i===undefined){return t}return JSON.parse(i)}function o(t){r.filter(function(e){return e.key!==t});window.localStorage.removeItem(t)}function s(){r=[];window.localStorage.clear()}function a(e,t,i){if(i){r.push({timeRemaining:i,key:e})}n[e]=t}function l(e,t){var i;i=n[e];if(i===undefined){return t}return i}function c(t){r.filter(function(e){return e.key!==t});if(n[t]){delete n[t]}}function u(){r=[];n={}}giscloud.util.storage={};try{t=!window.localStorage}catch(e){t=true}if(t){giscloud.util.storage.store=a;giscloud.util.storage.fetch=l;giscloud.util.storage.clear=c;giscloud.util.storage.drop=u}else{giscloud.util.storage.store=e;giscloud.util.storage.fetch=i;giscloud.util.storage.clear=o;giscloud.util.storage.drop=s}window.setInterval(function(){var e;for(e=0;e<r.length;++e){r[e].timeRemaining--;if(r[e].timeRemaining<0){giscloud.util.storage.clear(r[e].key)}}r=r.filter(function(e){return!(e.timeRemaining<0)})},1e3)})();(function(){var e=giscloud.util;function t(){function i(t){if(typeof t==="function"||typeof t==="boolean"||typeof t==="number"){return t.toString()}if(typeof t==="string"){return'"'+t+'"'}if(t instanceof Date){return'"'+t.toISOString()+'"'}if(Array.isArray(t)){return"["+t.map(function(e){return i(e)}).join(",")+"]"}return"{"+Object.keys(t).map(function(e){return t.hasOwnProperty(e)?e+":"+i(t[e]):""})+"}"}e.encode={string:{marshal:i}}}t();e.encode.define=t})();(function(o){"use strict";var s={};function e(e,t){if(typeof e!=="string"){throw new TypeError("[giscloud.util.mediator.makeChannel] `channel` argument must be of type `string`")}if(t!==undefined){if(typeof t!=="boolean"){throw new TypeError("[giscloud.util.mediator.makeChannel] `hasHistory` argument must be of type `boolean` if present")}}if(!s[e]){s[e]=[];if(t){s[e].hasHistory=t;s[e].history=[]}}else{console.warn("[gislcoud.mediator.makeChannel] chanel with name '"+e+"' already exists")}}function r(e){if(typeof e!=="string"){throw new TypeError("[giscloud.util.mediator.deleteChannel] `channel` argument must be of type `string`")}var t=s[e],i;if(t){if(t.hasHistory){for(i=0;i<t.length;++i){delete t[i].lastMessageIndex}}delete s[e]}}function t(e,t){if(typeof e!=="string"){throw new TypeError("[giscloud.util.mediator.subscribe] `channel` argument must be of type `string`")}if(typeof t!=="function"){throw new TypeError("[giscloud.util.mediator.subscribe] `handler` argument must be of type `function`")}var i=s[e],n;if(!i){s[e]=[t]}else{for(n=0;n<i.length;++n){if(i[n]===t){console.warn("[giscloud.util.mediator.subscribe] trying to subscribe to a channel '"+e+"' with a handler that is already registered");return}}i.push(t);if(i.hasHistory){if(!t.lastMessageIndex){t.lastMessageIndex=0}for(n=t.lastMessageIndex;n<i.history.length;++n){t.apply(null,i.history[n]);++t.lastMessageIndex}}}}function i(e){if(typeof e!=="string"){throw new TypeError("[giscloud.util.mediator.publish] `channel` argument must be of type `string`")}var t=s[e],i=arguments.length,n=new Array(i),r;if(t){if(o.debug){console.debug("[giscloud.util.mediator.publish] publishing to channel '"+e+"'")}for(r=1;r<i;++r){n[r-1]=arguments[r]}if(t.hasHistory){t.history.push(n)}for(r=0;r<t.length;++r){t[r].apply(null,n);if(t.hasHistory){++t[r].lastMessageIndex}}}else if(o.debug){console.debug("[giscloud.util.mediator.publish] publishing to channel '"+e+"' with no handlers")}}function n(e,t){if(typeof e!=="string"){throw new TypeError("[giscloud.util.mediator.subscribe] `channel` argument must be of type `string`")}if(typeof t!=="function"){throw new TypeError("[giscloud.util.mediator.subscribe] `handler` argument must be of type `function`")}var i,n;n=s[e];if(n){for(i=0;i<n.length;++i){if(n[i]===t){n.splice(i,1);break}}}if(!n.length){r(e)}}giscloud.util.mediator={};giscloud.util.mediator.makeChannel=e;giscloud.util.mediator.deleteChannel=r;giscloud.util.mediator.publish=i;giscloud.util.mediator.subscribe=t;giscloud.util.mediator.unsubscribe=n})({debug:false});(function(){"use strict";var o=giscloud.exposeJQuery(),s;function e(){self.onmessage=function(e){self.postMessage(self.op(e.data))}}s=e.toString();function t(e){this.data=e;this.globals=[];this.scope={}}t.prototype.run=function(e){var t,i,n,r=new o.Deferred;t=["("+s+")();\n\n","op = "+e.toString()+";\n\n"].concat(this.globals.map(function(e){return e+";\n\n"}.bind(this)),Object.keys(this.scope).map(function(e){return e+" = "+this.scope[e]+";\n\n"}.bind(this)));i=new window.Blob(t);n=window.URL.createObjectURL(i);this.job=new window.Worker(n);window.URL.revokeObjectURL(n);this.job.onmessage=function(e){this.terminate();r.resolve(e.data)};this.job.onerror=function(e){r.reject(e.data);this.terminate()};this.job.postMessage(this.data);this.deferred=r;return this.deferred.promise()};t.prototype.terminate=function(){this.job.terminate();this.deferred.reject("Job terminated")};t.prototype.require=function(t,e){var i,n,r;if(typeof t==="function"){i=t.toString();n=i.match("");if(!n||e){this.globals.push("("+i+")()")}else{this.globals.push(i)}}else{Object.keys(t).forEach(function(e){if(this.scope[e]){throw new Error("[giscloud.util.ThreadPool#require] Scope value `"+e+"` already defined")}else{this.scope[e]=giscloud.util.encode.string.marshal(t[e])}}.bind(this))}return this};giscloud.util.Job=t})();(function(){var o=0,r=giscloud.exposeJQuery(),s,a=giscloud.util;function e(){a.onerror=function(e){a.postMessage({status:"ERROR",message:"Ane error occured",error:e.toString()})};a.onmessage=function(e){var t=e.data.data,i,n;try{i=a.eval("op = "+e.data.op)}catch(e){i=null;a.postMessage({status:"ERROR",message:"Unable to deserialize operation function",error:e.toString()});return}try{t=i(t)}catch(e){t=null;a.postMessage({status:"ERROR",message:"Error while processing data",error:e.toString()});return}n={status:"OK",data:t};a.postMessage(n)}}s=e.toString();function t(e){if(!this){throw new Error("[giscloud.util.ThreadPool] is a constructor and must be invoked with `new`")}this.size=e||8;this.scope={};this.globals=[];this.usedPool=[];this.freePool=[];this.queue=[]}t.prototype.require=function(t,e){var i,n,r;if(typeof t==="function"){i=t.toString();n=i.match("");if(!n||e){this.globals.push("("+i+")()")}else{this.globals.push(i)}}else{Object.keys(t).forEach(function(e){if(this.scope[e]){throw new Error("[giscloud.util.ThreadPool#require] Scope value `"+e+"` already defined")}else{this.scope[e]=a.encode.string.marshal(t[e])}}.bind(this))}return this};function l(t){var i,e;i=this.freePool.pop();i.onmessage=function(e){i.onmessage=undefined;this.usedPool=this.usedPool.filter(function(e){return e.id!==i.id});this.freePool.push(i);if(e.data.status==="ERROR"){t.deferred.reject({message:e.data.message,error:e.data.error})}else{t.deferred.resolve(e.data.data)}if(this.queue.length){l.call(this,this.queue.pop())}}.bind(this);this.usedPool.push(i);e={data:t.data,op:t.op};i.postMessage(e)}t.prototype.enqueue=function(e,t){var i=new r.Deferred,n={data:e,op:t.toString(),deferred:i};this.queue.push(n);while(this.freePool.length&&this.queue.length){n=this.queue.pop();l.call(this,n)}return i.promise()};t.prototype.terminate=function(){this.usedPool.forEach(function(e){e.terminate()});this.freePool.forEach(function(e){e.terminate()});this.usedPool=[];this.freePool=[]};t.prototype.start=function(){var e,t,i,n,r;n=["("+s+")();\n\n"].concat(this.globals.map(function(e){return e+";\n\n"}.bind(this)),Object.keys(this.scope).map(function(e){return e+" = "+this.scope[e]+";\n\n"}.bind(this)));t=new window.Blob(n);i=window.URL.createObjectURL(t);for(e=0;e<this.size;++e){r=new window.Worker(i);r.id=o++;this.freePool.push(r)}while(this.freePool.length&&this.queue.length){l.call(this,this.queue.pop())}window.URL.revokeObjectURL(i)};giscloud.util.ThreadPool=t})()})();function _init(e,t){if(e.map){t.gmap=1;t.tileSize=new google.maps.Size(256,256)}t.modifier={};t.hoverStyle={fill:"rgba(255,0,0,0.8)",stroke:"rgba(255,0,0,0.8)"};t.mid=e.mid;t.timestamp=e.timestamp;t.lid=e.id;t.lid_map={};t.lid_map[e.id]=1;t.lmap=e.lmap;fields="";t.map=e.map;if(e.tooltip){t.tooltip=document.createElement("div");t.tooltip.style.position="absolute";t.tooltip.style.top="-5px";t.tooltip.style.left="-5px";t.tooltip.className="gc-map-tooltip";t.tooltip.style.padding="1px";t.tooltip.style.border="1px solid #CCC";t.tooltip.style.backgroundColor="#FAF3A9";t.tooltip.style.zIndex=1e3;document.body.appendChild(t.tooltip);giscloud.Html5MapTooltip=t.tooltip}_selectablePoly=0;$(document).mousedown(function(e){isMouseDown=true});$(document).mouseup(function(e){isMouseDown=false});getTimestamp(t,e)}function checkForEvent(e,t,i){if(!t&&isMouseDown)return;var n=e.currentTile;var r,o;if(e.offsetX>=0){r=e.offsetX;o=e.offsetY}else{r=e.layerX;o=e.layerY}r*=flashnavigator.scaleRatio;o*=flashnavigator.scaleRatio;if(flashnavigator.offscreenRendering){workerCheckEvents(n,r,o,e,i);return}if(!n.gc_state.by_layer[n.gc_state.layer])return;return handleEvent(n,r,o,e,i)}var hoverModifier={};function handleEvent(e,t,i,n,r){var o=e.gc_state.by_layer[e.gc_state.layer];if(!o.type=="text"){return false}var s=0;var a=e.gc_state.layer;var l=e.gc_state.curLayerObj;s=o.features;if(!s){return false}if(selectionEnabled){var c=r?r:o.type!=="point"?4*flashnavigator.scaleRatio:0;var u=t+c;var d=t-c;var f=i-c;var h=i+c;var p=1e5;var g=-1;var m=null;var v=null;var y;var _;var b=e.gc_state.obj;for(_=s.length-1;_>=0;_--){if(s[_].visible&&u>=s[_].b.xmin&&d<=s[_].b.xmax&&h>=s[_].b.ymin&&f<=s[_].b.ymax&&(s[_].ispoint||s[_].ispoly&&!s[_].ispoint&&giscloud.math.util.isPointInsidePolygon(s[_].p,{x:t,y:i})||!s[_].ispoly&&!s[_].ispoint&&giscloud.math.util.isPointTouchingPath(s[_].p,{x:t,y:i},c))){if(s[_].ispoint){var w=pointDistance(s[_].x,s[_].y,t,i);if(w<p){g=_;p=w}}else{if(v!==s[_].s){m=null}y=s[_].c;if(s[_].curs&&s[_].curs.type==="line"){if(m)break}else{if(y==m){g=-1;m=null;continue}else{if(m)break}}g=_;m=y;v=s[_].s}}}if(g>=0){var x=null;var k=g;x=s[g];var C=s[k];if(flashnavigator.hasCanvas){if(hoverModifier.isset){if(b._hoveredElement===C.c&&a===hoverModifier.layer){if(e.gc_state.fields&&e.gc_state.fields[x.c])x.attributes=e.gc_state.fields[x.c];return x}clearHover()}if(!b.modifier[C.c]){var L=0;if(C.ispoint)L=C.i;else L=C.s;if(l.features){hoverModifier.isset=true;hoverModifier.color=l.features[L].highlightcolor;hoverModifier.hover=true;hoverModifier.orig=b.modifier[C.c];hoverModifier.orig_obj=b;hoverModifier.orig_key=C.c;hoverModifier.layer=a;hoverModifier.layerObj=l;b.modifier[C.c]=hoverModifier;b._hoveredElement=C.c;drawAcrossTiles(b,true)}}else{b._hoverModifier=null}}if(e.fields&&e.fields[x.c])x.attributes=e.fields[x.c];return x}}if(flashnavigator.hasCanvas&&hoverModifier.isset&&e.gc_state.layer===hoverModifier.layer){clearHover()}return false}var tile_cache={tiles:{}};function initTileCache(){tile_cache.max=common.isMobileBrowser?0:Math.round(800/Math.pow(flashnavigator.scaleRatio,2));resetTileCache()}function resetTileCache(){for(var e in tile_cache.tiles){tile_cache.tiles[e].inCache=false;releaseCanvasToPool(tile_cache.tiles[e])}tile_cache.tiles={};tile_cache.count=0;tile_cache.min=Infinity;tile_cache.min_index=null}function removeTileFromCache(e,t){var i=e.gc_state,n,r=false,o,s;if(tile_cache.max===0)return;if(t){o={};o[t]=1}else{o=i.by_layer}for(s in o){n=e.gc_state._tileIndex+":"+s;if(tile_cache.tiles[n]){tile_cache.tiles[n].inCache=false;releaseCanvasToPool(tile_cache.tiles[n]);delete tile_cache.tiles[n];tile_cache.count--;if(tile_cache.min_index===n){r=true}}}if(r){calculateCanvasCacheMin()}}function setupTile(e,t){if(!e.dyndata)return;var i=e.gc_state.curLayerObj;var n=t.geom;var r=0;var o;var s;var a=null;var l=0;if(t.tile){a=t.tile.l;l=a.length-1}var c=0;var u;for(var d=0,f=n.length;d<f;d++){var r=n[d].c.split("_")[1];if(e.dyndata[r])n[d].dyn=e.dyndata[r]}for(var d=0;d<l;d+=5){if(a[d]<0){u=-a[d];c=a[d+1];d++}else{u=a[d]}var h=a[d+1];var p=a[d+2];var g=a[d+3];var m=a[d+4];var v={p:[h,p,h+g,p+m],id:u,s:c,c:i.id+"_"+u,px:true};if(e.dyndata[v.id]>=0)v.dyn=e.dyndata[v.id];n.push(v)}t.geom.sort(function(e,t){return t.dyn-e.dyn});e.pixels2=null;if(t.tile)t.tile.pixels=null}function drawTile(e,t,i,n,r){var o=e.gc_state;o.layer=o.layer||o.obj.parent.id;o.curLayerObj=i;o.by_layer[o.layer]=o.by_layer[o.layer]||{};current_layer_tile_state=o.by_layer[o.layer];if(loader_id===o._loader_id||r){if(flashnavigator.hasCanvas&&!n){var s=e.getContext("2d",flashnavigator.canvasOptions);if(o._drawn){s.clearRect(0,0,e.width,e.height)}}o._drawn=true;if(o.curLayerObj.options.dynamic&&t[1]){e.dyndata=t[1];t=t[0]}if(flashnavigator.newLabelingMode){giscloud.util.mediator.publish("tile/loaded",e,t,i,renderLabelTile)}if(i.layer_info.hiddenGeometry){return}if(t.tile){if(t.tile.type=="text"){current_layer_tile_state.features=t.tile.data;o.fields=t.fields;var a={},l=current_layer_tile_state.features.length,c=current_layer_tile_state.features,u,d,f;for(u=0;u<l;u++){c[u].text=c[u].text.split("\n");for(d=0,f=c[u].p.length;d<f;d++){a[c[u].p[d][4]]=1}}current_layer_tile_state.feature_ids=a;var h=o.gc_layer.neighbour_tile_data;if(h[o._tileIndex]){var p=h[o._tileIndex][o.layer];if(p){p.forEach(function(e){if(e.item.id!==undefined&&a[e.item.id])return;current_layer_tile_state.features.push(e.item);if(e.field){if(!o.fields)o.fields={};o.fields[e.field.key]=e.field.value}});delete h[o._tileIndex][o.layer];if(Object.keys(h[o._tileIndex]).length==0){delete h[o._tileIndex]}}}drawText(e,n);t.geom=null}else if(t.tile.type=="point"){var g=t.tile.data;current_layer_tile_state.features=g;o.fields=t.fields;parsePoint(e,current_layer_tile_state,t);var h=o.gc_layer.neighbour_tile_data;if(h[o._tileIndex]){var p=h[o._tileIndex][o.layer];if(p){var m=current_layer_tile_state.features_by_id;p.forEach(function(e){if(m[e.c]){var t=false;var i=m[e.c];for(var n=0;n<i.length;n++){var r=g[i[n]];if(r.i==e.i&&r.x==e.x&&r.y==e.y){t=true;break}}if(t)return}if(!m[e.c])m[e.c]=[];m[e.c].push(g.length);g.push(e)});delete h[o._tileIndex][o.layer];if(Object.keys(h[o._tileIndex]).length==0){delete h[o._tileIndex]}}}g.sort(function(e,t){if(e.i<t.i)return 1;if(e.i>t.i)return-1;return e.fid>t.fid?1:-1});var m={};for(var u=0;u<g.length;u++){if(!m[g[u].c]){m[g[u].c]=[]}m[g[u].c].push(u)}current_layer_tile_state.features_by_id=m;drawPoint(e,n);t.geom=null}}if(t.geom){setupTile(e,t);drawGeom(e,t,n)}}t.tile=null;t.fields=null;t=null}function redrawSingleTileRect(e,t){rectCropWithTile(t,e.gc_state);if(t.width>0&&t.height>0){if(flashnavigator.inOffscreenRenderingWorker){e=setTileData(e,t)}redrawSingleTile(e.gc_state.obj.parent,e,t,true);if(flashnavigator.inOffscreenRenderingWorker){releaseCanvasToPool(e)}}}function redrawNeighbourTiles(e){var t,i,n,r=e.gc_state;for(t in r._tiles_to_redraw){i=r._tiles_to_redraw[t];n=i.gc_state._invalidateRectForCopy;i.gc_state._invalidateRectForCopy=null;redrawSingleTileRect(i,n)}r._tiles_to_redraw={}}function checkIfModifierInTile(e,t){if(!e.gc_state.by_layer[e.gc_state.layer])return;var o=e.gc_state;var i=o.by_layer[o.layer];var s=o.obj;var n=i.features_by_id;var a=o.curLayerObj.features;var l=i.features;var c=false;var u,d;for(u in s.modifier){if(!s.modifier[u]||!n||!n[u]||n[u].length==0)continue;n[u].forEach(function(e){var t=l[e];if(!t||!t.b)return;d=0;if(!t.ispoint){var i=overrideStyle(a[t.s],s.modifier[u]);d=0;if(giscloud.mapFeatureRenderer!=null&&giscloud.mapFeatureRendererHighlight){var n={};for(var r in i)n[r]=i[r];i=n;giscloud.mapFeatureRendererHighlight(t,i)}i.linewidth&&(d=i.linewidth);i.width&&(d+=i.width);d=Math.ceil(d)}if(!o._invalidateRect){o._invalidateRect={};rectAssign(o._invalidateRect,t.b,d)}else{rectUnion(o._invalidateRect,t.b,d)}c=true})}if(o._invalidateRect){if(o._rect)rectCropWithRect(o._invalidateRect,o._rect);else rectCropWithTile(o._invalidateRect,o)}return c}function checkIfImageCanBeDraw(e,t){var i=t.gc_state,n=e.tileLayer.group,r;for(r=n.length-1;r>=0;r--){if(n[r]===e)return true;if(n[r].visible&&n[r].isImage&&(!i.by_layer[n[r].id]||!i.by_layer[n[r].id].image)){return false}}return true}function redrawSingleTile(e,t,i,n){var r,o,s,a=!t.getContext,l,c;o=t.gc_state;s=o.layer;c=o.curLayerObj;if(!a&&!i&&!flashnavigator.inOffscreenRenderingWorker){r=t.getContext("2d",flashnavigator.canvasOptions);r.clearRect(0,0,t.width,t.height)}if(a){l=t;t=getCanvasFromPool(o._width,o._height);t.gc_state=o;t._layer=l._layer;t.isTileDirty=l.isTileDirty}o._entire_tile_draw=!i;o._rect=i?i:rectCreate(t.gc_state);o._isRedraw=n;o._invalidateRect=null;if(e.group){if(!o.obj.activeLayer||o.activeLayerId!=o.obj.activeLayer.uniqueId||!o.canvasCachePre||!o.canvasCachePost){if(o.obj.activeLayer){o.activeLayerId=o.obj.activeLayer.uniqueId}else{o.activeLayerId=null}e.group.forEach(function(e){if(e.visible&&!e.isImage){o.layer=e.id;o.curLayerObj=e;checkIfModifierInTile(t)}});e.group.forEach(function(e){if(e.visible){o.layer=e.id;o.curLayerObj=e;redrawTile(t)}})}}else{redrawTile(t)}renderTile(t);if(a){releaseCanvasToPool(t)}o.layer=s;o.curLayerObj=c;o._isRedraw=false;o._rect=null;return false}function redraw(i,e,n,r){var t,o,s,a;if(!flashnavigator.inOffscreenRenderingWorker){if(checkAttributesAndReload(i)){return}}if(flashnavigator.offscreenRendering){if(n){workerSyncLayers()}workerRedrawLayer(i,n,r);return}if(flashnavigator.inOffscreenRenderingWorker){o={};s=i._tiles;for(var l in s){if(r&&!r[l])continue;o[l]=setTileData(s[l],null)}}else{o=i._tiles}a=Object.keys(o);if(e){a.forEach(function(e){if(r&&!r[e])return;var t=o[e];count++;window.setTimeout(function(){count--;t.isTileDirty=n;redrawSingleTile(i,t,null,true);t.isTileDirty=false},0)})}else{a.forEach(function(e){if(r&&!r[e])return;t=o[e];t.isTileDirty=n;redrawSingleTile(i,t,null,true);t.isTileDirty=false})}if(flashnavigator.inOffscreenRenderingWorker){workerRenderTiles(i);for(var l in o){if(r&&!r[l])continue;releaseCanvasToPool(o[l])}}else{if(i.viewer.onRender){i.viewer.onRender()}}}function redrawTile(e){var t=e.gc_state;if(!t._drawn||!t.by_layer[t.layer])return;var i=t.by_layer[t.layer];var n=i.type;if(i.pixelsData&&t.curLayerObj.featuresVisibility!==i.pixelsVisibility){drawPixels(t,i,i.pixelsData)}if(n=="image"){drawImageInternal(e)}else if(n=="text"){drawText(e)}else if(n=="point"){drawPoint(e)}else{drawGeomInternal(e)}}function drawAcrossTiles(e,t){var i,n,r;var o=e.parent._tiles;if(e.parent.group){e.activeLayer=hoverModifier.isset?hoverModifier.layerObj:null;for(i in o){n=o[i];if(!n.gc_state)continue;if(t){clearTile(n)}r=n.gc_state;r._invalidateRect=null;if(r.obj.modifier&&Object.keys(r.obj.modifier).length>=0){var s=0;e.parent.group.forEach(function(e){if(e.visible){r.layer=e.id;r.curLayerObj=e;if(checkIfModifierInTile(n))s=1}});rect=n.gc_state._invalidateRect;if(s){redrawSingleTileRect(n,rect)}}}if(flashnavigator.inOffscreenRenderingWorker){workerRenderTiles(e.parent)}return true}for(i in o){n=o[i];if(!n.gc_state)continue;t&&clearTile(n);n.gc_state._invalidateRect=null;if(checkIfModifierInTile(n)){redrawSingleTileRect(n,n.gc_state._invalidateRect)}}if(flashnavigator.inOffscreenRenderingWorker){workerRenderTiles(e.parent)}return false}function clearTile(e){var t=e.gc_state;if(t._modified&&t._originalCanvasParts){restoreOriginalParts(t._originalCanvasParts,e);t._originalCanvasParts=null;t._modified=false}if(t._modified&&e.img&&t.by_layer[t.layer].type!="point"){if(e.img.src!=e.img_url)e.img.src=e.img_url;t._modified=false}}function drawTileUsingModifier(s,a){if(!s.gc_state.by_layer[s.gc_state.layer])return;var l,c,e,t,u,d,f,h;l=null;u=giscloud.mapFeatureRenderer!=null;var p=s.gc_state;var i=p.by_layer[p.layer].features_by_id;var n=null;var g=p._rect;p._path=null;if(!p._invalidateRect){checkIfModifierInTile(s);if(g&&p._invalidateRect){rectCropWithRect(p._invalidateRect,g)}}if(!p._invalidateRect||(p._invalidateRect.width<=0||p._invalidateRect.height<=0)){p._invalidateRect=null;return}for(c in a.modifier){if(!a.modifier[c]||!i||!i[c]||i[c].length==0)continue;t=i[c];d=c.split("_")[0];if(!p.by_layer[d])continue;h=p.curLayerObj.features;if(!l){rectCropWithRect(p._invalidateRect,g);p.current_canvas_state.overlay=createCanvas(s,false,p._invalidateRect);l=p.forceCtx||s.getContext("2d",flashnavigator.canvasOptions)}f=null;t.forEach(function(e){var t=p.by_layer[d].features[e];if(t&&t.b){if(g&&t.b&&(g.xmax<t.b.xmin||g.ymax<t.b.ymin||g.xmin>t.b.xmax||g.ymin>t.b.ymax)){return}p._modified=true;var i=0;if(t.ispoint)drawImage(s,a,l,t,null,null,a.modifier[c]);else{if(f!=t.c){finishPoly(s.gc_state,l);f=t.c}var n=overrideStyle(h[t.s],a.modifier[c]);i=0;if(u&&giscloud.mapFeatureRendererHighlight){var r={};for(var o in n)r[o]=n[o];n=r;giscloud.mapFeatureRendererHighlight(t,n)}n.linewidth&&(i=n.linewidth);n.width&&(i+=n.width);i=Math.ceil(i);drawCanvasPolygon(p,l,t.p,n,t.s,c,null,1,u)}}})}if(l){finishPoly(p,l)}}function clearHover(){var e=hoverModifier.orig_obj;if(e.modifier[hoverModifier.orig_key]&&e.modifier[hoverModifier.orig_key].hover){if(hoverModifier.orig){e.modifier[hoverModifier.orig_key]=hoverModifier.orig}else{delete e.modifier[hoverModifier.orig_key]}drawAcrossTiles(e,true)}hoverModifier.isset=false}function setupFiltersObject(e,t){if(!t.data){t.data={}}if(e.gc_state.feature_attributes_array){var i,n=e.gc_state.feature_attributes_array;for(i=0;i<n.length;i++){if(t.data[n[i]]===undefined){t.data[n[i]]=null}}}}function modifyObject(e,t,i,n,r,o,s){n=n?(n+"").split("||")[0]:"";if(n&&!e.lid_map[n])return;t=t?t+"":"";if(r&&!e.has_modifier&&!t)return;var a=null,l=null,c=false,u=intColor2hexColor(i.color),d,f;if(e.parent.group){f=t+u+n+r+o+s;if(this.modify_sign==f)return;e.modify_sign=f}if(r){a=e.modifier;l=e.modifier_layers;c=e.has_modifier;e.modifier={};e.has_modifier=false}if(e._hoveredElement){a=true;if(e.modifier[e._hoveredElement]){delete e.modifier[e._hoveredElement]}e._hoveredElement=null}e.modifier_layers={};if(t){t=t.split(",");i={color:u,linewidth:1};for(d=0;d<t.length;d++){if(t[d]==="")continue;e.modifier[n+"_"+t[d]]=i;e.modifier_layers[n]=1;e.has_modifier=true}}if(!e.parent.group){if(l){for(n in l){drawAcrossTiles(e,a,n)}}for(n in e.modifier_layers){drawAcrossTiles(e,a,n)}}else if(c||e.has_modifier){e.activeLayer=null;drawAcrossTiles(e,a)}a=null}function overrideStyle(e,t){var i={};if(t.color){var n;if(t.color==="selectcolor"){n=e.selectcolor}else{n=t.color}i.color=n;if(e.strokecolor){if(e.type!="polygon")i.strokecolor=n;else i.strokecolor=e.strokecolor}if(e.fillcolor)i.fillcolor=n}else{if(e.strokecolor&&t.strokecolor){i.strokecolor=t.strokecolor}else{i.strokecolor=e.strokecolor}if(e.fillcolor&&t.fillcolor){i.fillcolor=t.fillcolor}else{i.fillcolor=e.fillcolor}i.innerlinewidth=e.innerlinewidth}if(t.dashed)i.dashed=t.dashed;else i.dashed=e.dashed;i.linewidth=e.linewidth;i.type=e.type;i.visible=e.visible;return i}function drawGeom(e,t,i){var n=t.geom;var r=e.gc_state;var o=r.by_layer[r.layer];o.features=n;if(!o.features_by_id)o.features_by_id=[];o.type="geom";r.fields=t.fields;var s=o.features_by_id;var a=r.obj;var l=n.length;var c=-1;var u=null;var d,f;var h,p,g,m;var v=0;var y=0;var _=r.curLayerObj.features;var b=null;var w=0;if(r.curLayerObj.options.offset)v=r.curLayerObj.options.offset;if(r.curLayerObj.options.precision)y=r.curLayerObj.options.precision;if(t.tile&&t.tile.pixels){b=t.tile.pixels;t.tile.pixels=null}var x=0;if(t.fields){x=1}for(h=l-1;h>=0;h--){d=n[h];if(d.s>=0){c=d.s}else{d.s=c}m={};if(!s[d.c])s[d.c]=[];s[d.c].push(h);if(c!=-1){u=_[c];w=u.linewidth>0?u.linewidth/2+1:0}if(u.type=="polygon"){d.ispoly=1}if(!d.initialized){f=d.p;g=f.length;if(y>0){for(p=0;p<g;p++){f[p]/=y}}if(flashnavigator.scaleRatio>1){for(p=0;p<g;p++){f[p]*=flashnavigator.scaleRatio}}if(v>0)doOffset(d,v);f=d.p;m={};m.xmin=m.xmax=f[0];m.ymin=m.ymax=f[1];d.fid=+d.c.split("_")[1];for(p=2;p<g;p+=2){if(f[p]<m.xmin)m.xmin=f[p];else if(f[p]>m.xmax)m.xmax=f[p];if(f[p+1]<m.ymin)m.ymin=f[p+1];else if(f[p+1]>m.ymax)m.ymax=f[p+1]}m.xmin=Math.floor(m.xmin-w);m.ymin=Math.floor(m.ymin-w);m.xmax=Math.ceil(m.xmax+w);m.ymax=Math.ceil(m.ymax+w);d.initialized=true;d.b=m;d.visible=true;if(x){d.data=r.fields[d.c];setupFiltersObject(e,d)}else{d.data={}}}}n=null;t.geom=null;t.style=null;if(b){drawPixels(r,o,b)}if(!i)drawGeomInternal(e)}function drawGeomInternal(e){var t,n,r,o,a,l,c,u,d,f;f=e.gc_state;if(!f.by_layer[f.layer])return;t=f.by_layer[f.layer].features;d=f.curLayerObj.features;u=f.by_layer[f.layer].pixels;if(!t)return;var h=null;var p=null;if(f.curLayerObj.feature_filter&&f.curLayerObj.feature_filter.filter){h=f.curLayerObj.feature_filter.filter;p=f.curLayerObj.feature_filter.context}var g=f._rect;var m=f._tileIndex+":"+f.layer;if(e.getContext||f.forceCtx){if(!h){c=getCanvasFromCache(e,m,g,!f._entire_tile_draw);if(c){if(f.obj.modifier){drawTileUsingModifier(e,f.obj,g)}return}}n=f.forceCtx||e.getContext("2d",flashnavigator.canvasOptions);if(g){c=createCanvas(e,true);n=c.getContext("2d",flashnavigator.canvasOptions)}r=t.length;var v=performance.now();if(!h&&u){if(g){n.drawImage(u,g.xmin/flashnavigator.scaleRatio,g.ymin/flashnavigator.scaleRatio,g.width/flashnavigator.scaleRatio,g.height/flashnavigator.scaleRatio,g.xmin,g.ymin,g.width,g.height)}else{n.drawImage(u,0,0,256,256,0,0,256*flashnavigator.scaleRatio,256*flashnavigator.scaleRatio)}}o=giscloud.mapFeatureRenderer!=null;for(i=r-1;i>=0;i--){object=t[i];sindex=object.s;if(sindex!=-1){s=d[sindex]}if(g&&object.b&&(g.xmax<object.b.xmin||g.ymax<object.b.ymin||g.xmin>object.b.xmax||g.ymin>object.b.ymax)){object.curs=null;continue}if(o){var y={};for(var _ in s)y[_]=s[_];s=y;l=object.c.split("_");a={featureId:l[1]*1,layerId:parseInt(l[0].replace("layer","").replace("l","")),geometry:object.p,bounds:object.b,visible:object.visible};if(object.data)a.attributes=object.data;giscloud.mapFeatureRenderer(a,s);object.visible=a.visible}object.curs=s;if(!h||h(object.data,p)){object.visible=object.curs?object.curs.visible:true;drawCanvasPolygon(f,n,object.p,object.curs,object.s,f.lastP,null,1,o)}else{object.visible=false}}finishPoly(f,n);if(f.curLayerObj.has_inner_line){for(i=r-1;i>=0;i--){object=t[i];if(object.visible&&object.curs){drawCanvasPolygon(f,n,object.p,object.curs,object.s,f.lastP,null,2,o)}}finishPoly2(f,n)}if(c&&!h&&f._entire_tile_draw){c.timeToGenerate=performance.now()-v;storeCanvasToCache(c,m)}}if(f.obj.modifier){drawTileUsingModifier(e,f.obj,g)}}function drawCanvasPolygon(e,t,i,n,r,o,s,a,l){if(n.visible===false)return;var c,u;if(e.last_c&&e.last_c_index!=r||l){if(a!=2)finishPoly(e,t);else finishPoly2(e,t)}if(!e._path){if(s){t.globalCompositeOperation="destination-out"}t.lineCap="round";t.lineJoin="round";t.beginPath();e._path=1;e.last_c=n;e.last_c_index=r}c=i.length;t.moveTo(i[0],i[1]);for(u=2;u<c;u+=2){t.lineTo(i[u],i[u+1])}if(s){finishPoly(e,t);t.globalCompositeOperation="source-over"}e.lastP=o}function finishPoly(e,t){if(!e.last_c)return;var i=e.last_c;if(i.icon&&i.icon_image){if(!i.pattern)i.pattern=t.createPattern(i.icon_image,"repeat");t.fillStyle=i.pattern;t.fill()}else if(i.fillcolor){t.fillStyle=i.fillcolor;t.fill()}if(i.strokecolor&&i.linewidth>0){if(i.dashed){if(t.setLineDash)t.setLineDash(i.dashed);else{t.mozDash=i.dashed;t.webkitLineDash=i.dashed}}t.lineWidth=i.linewidth;if(!i.fillcolor&&i.color)t.strokeStyle=i.color;else t.strokeStyle=i.strokecolor;t.stroke();if(i.dashed){if(t.setLineDash)t.setLineDash([]);else{t.mozDash=[];t.webkitLineDash=[]}}}e.last_c=null;e.last_c_index=null;e._path=0}function finishPoly2(e,t){if(!e.last_c)return;var i=e.last_c;if(i.innerstrokecolor){if(i.dashed){if(t.setLineDash)t.setLineDash(i.dashed);else{t.mozDash=i.dashed;t.webkitLineDash=i.dashed}}t.strokeStyle=i.innerstrokecolor;t.lineWidth=i.innerlinewidth;t.stroke();if(i.dashed){if(t.setLineDash)t.setLineDash([]);else{t.mozDash=[];t.webkitLineDash=[]}}}e.last_c=null;e.last_c_index=null;e._path=0}function parsePoint(e,t,i){var n,r;var o=0;t.type="point";var s=t.features;if(!t.features_by_id)t.features_by_id=[];var a=t.features_by_id;var l=e.gc_state;if(i.fields){o=1}var c=bounds.max/Math.pow(2,l._tileIndexZ);var u=l._tileIndexX;var d=l._tileIndexY;for(n=0;n<s.length;n++){r=s[n];r.x=Math.round(((r.x-bounds.xmin)/c-u)*l._tileSize);r.y=Math.round(((bounds.ymax-r.y)/c-d)*l._tileSize);r.id=r.id.replace("||","_");r.c=r.id;r.fid=+r.id.split("_")[1];r.ispoint=true;if(o){r.data=i.fields[r.id];setupFiltersObject(e,r)}else{r.data={}}if(!a[r.c])a[r.c]=[];a[r.c].push(n)}}function drawPoint(e,t,i){var n,r,o,s,a,l,c;var u=0;var d=null;var f=null;var h=e.gc_state;var p=h._rect;var g=h.by_layer[h.layer];var m=h._tileIndex+":"+h.layer;if(h.curLayerObj.feature_filter&&h.curLayerObj.feature_filter.filter){d=h.curLayerObj.feature_filter.filter;f=h.curLayerObj.feature_filter.context}if(!t)u=h.forceCtx||e.getContext("2d",flashnavigator.canvasOptions);if(!t&&!d&&!g.isDirty){c=getCanvasFromCache(e,m,p,!h._entire_tile_draw);if(c){if(h.obj.modifier){drawTileUsingModifier(e,h.obj,p)}return}}l=g.features;if(!l){return}if(p&&!t){c=createCanvas(e,true);u=c.getContext("2d",flashnavigator.canvasOptions)}h.neighbour_tiles={};var v=performance.now();if(p){for(r=0;r<l.length;r++){n=l[r].b;if(n&&(p.xmax<n.xmin||p.ymax<n.ymin||p.xmin>n.xmax||p.ymin>n.ymax))continue;drawImage(e,h.obj,u,l[r],d,f)}}else{for(r=0;r<l.length;r++){drawImage(e,h.obj,u,l[r],d,f)}}if(c&&!d&&h._entire_tile_draw){g.isDirty=false;c.timeToGenerate=performance.now()-v;storeCanvasToCache(c,m)}if(h.obj.modifier){drawTileUsingModifier(e,h.obj,p)}for(r in h.neighbour_tiles){s=h.neighbour_tiles[r];a={};var y=s.gc_state.by_layer[h.layer];y.features.sort(function(e,t){if(e.i<t.i)return 1;if(e.i>t.i)return-1;return e.fid>t.fid?1:-1});l=y.features;for(o=0;o<l.length;o++){if(!a[l[o].c]){a[l[o].c]=[]}a[l[o].c].push(o)}y.features_by_id=a;y.isDirty=true;h._tiles_to_redraw[s.gc_state._tileIndex]=s}h.neighbour_tiles=null}function getImageOverlay(e,t,i){var n;var r=t.color;if(i.cl>0)r+="_cluster";if(e.icon_image_overlay&&e.icon_image_overlay[r]){n=e.icon_image_overlay[r]}else{if(flashnavigator.inOffscreenRenderingWorker){n=new OffscreenCanvas(i.b.xmax-i.b.xmin,i.b.ymax-i.b.ymin)}else{n=document.createElement("canvas");n.width=i.b.xmax-i.b.xmin;n.height=i.b.ymax-i.b.ymin}var o=n.getContext("2d",flashnavigator.canvasOptions);drawPointCanvas(null,o,i,e,0,0,true);o.globalAlpha=.7;var s=overrideStyle(e,t);o.fillStyle=s.color;o.beginPath();o.rect(0,0,n.width,n.height);o.globalCompositeOperation="source-in";o.fill();if(!e.icon_image_overlay)e.icon_image_overlay=[];e.icon_image_overlay[r]=n}return n}function drawImage(e,t,i,n,r,o,s){if(e.styles&&e.styles[n.i]&&e.styles[n.i].visible===false){n.visible=false;return 0}var a=e.gc_state.curLayerObj;if(!r){if(a.feature_filter&&a.feature_filter.filter){r=a.feature_filter.filter;o=a.feature_filter.context}}var l=a.features[n.i];var c;if(l.icon_image&&l.iready&&l.visible&&(!r||r(n.data,o))){c=l.icon_image;n.b={xmin:Math.floor(n.x-c.width/2),ymin:Math.floor(n.y-c.height/2),xmax:Math.ceil(n.x+c.width/2),ymax:Math.ceil(n.y+c.height/2)};if(s&&i){drawPointCanvas(e,i,n,l,undefined,undefined,false,true);var u=getImageOverlay(l,s,n);i.drawImage(u,n.b.xmin,n.b.ymin,n.b.xmax-n.b.xmin,n.b.ymax-n.b.ymin)}else{drawPointCanvas(e,i,n,l)}n.visible=true}else n.visible=false;return 1}function copyToNextTile(e,t,i,n,r,o,s,a){var l={xmin:i.b.xmin+s,ymin:i.b.ymin+a,xmax:i.b.xmax+s,ymax:i.b.ymax+a};var c={x:i.x+s,y:i.y+a,id:i.id,c:i.c,i:i.i,fid:i.fid,cl:i.cl,copied:true,b:l,ispoint:true,data:i.data};var u=e.gc_state.layer;var d=e.gc_state.gc_layer;var f=d._tiles[t];var h=f?f.gc_state:null;var p=h?h.by_layer[u]:null;if(p&&p._isEmpty){p._isEmpty=false;h.layer=u;f._layer=e._layer;h.gc_layer=d;drawTile(f,{tile:{type:"point",data:[]}},e.gc_state.curLayerObj,true,true)}if(p&&p.features){if(p.features_by_id){var g=p.features_by_id[c.c];if(g){var m=false;var v=p.features;for(var y=0;y<g.length;y++){var _=v[g[y]];if(_.i==c.i&&_.x==c.x&&_.y==c.y){m=true;break}}if(m)return}}if(!h._invalidateRectForCopy)h._invalidateRectForCopy={xmin:l.xmin,ymin:l.ymin,xmax:l.xmax,ymax:l.ymax};else{if(l.xmin<h._invalidateRectForCopy.xmin)h._invalidateRectForCopy.xmin=l.xmin;if(l.ymin<h._invalidateRectForCopy.ymin)h._invalidateRectForCopy.ymin=l.ymin;if(l.xmax>h._invalidateRectForCopy.xmax)h._invalidateRectForCopy.xmax=l.xmax;if(l.ymax>h._invalidateRectForCopy.ymax)h._invalidateRectForCopy.ymax=l.ymax}e.gc_state.neighbour_tiles[t]=f;if(!p.features_by_id[c.c])p.features_by_id[c.c]=[];p.features_by_id[c.c].push(p.features.length);p.features.push(c)}else{var b=d.neighbour_tile_data[t];if(!b){b=d.neighbour_tile_data[t]={}}var w=b[u];if(!w){w=b[u]=[]}w.push(c)}}function drawPointCanvas(e,t,i,n,r,o,s,a){if(!i.b)return;if(r==undefined)r=i.b.xmin;if(o==undefined)o=i.b.ymin;var l=n.icon_image,c,u,d,f=true;var h=giscloud.mapFeatureRenderer!=null;var p=i.b;var g=0;var m,v;if(i.cl&&n.clustering>0&&t){g=n.clustering*flashnavigator.scaleRatio;m=r+(p.xmax-p.xmin)/2;v=o+(p.ymax-p.ymin)/2;if(!s){if(l.width/2<g){p.xmin=Math.floor(m-g);p.xmax=Math.ceil(m+g)}if(l.height/2<g){p.ymin=Math.floor(v-g);p.ymax=Math.ceil(v+g)}}}if(!s||!i.cl||!n.clustering){if(h){u=i.c.split("_");d={featureId:u[1]*1,layerId:parseInt(u[0].replace("layer","").replace("l","")),geometry:[i.x,i.y],bounds:p,visible:f};if(i.data)d.attributes=i.data;c={icon:n.icon_image};giscloud.mapFeatureRenderer(d,c);l=c.icon;f=d.visible}if(f){if(e&&!e.gc_state._isRedraw&&!i.copied&&!a){var y=e.gc_state;var _=y._tileIndexX;var b=y._tileIndexY;var w=y._tileIndexZ;var x,k,C;if(p.xmin<0){_--}else if(p.xmax>y._tileSize){_++}if(p.ymin<0){b--}else if(p.ymax>y._tileSize){b++}k=y._tileIndexX-_;C=y._tileIndexY-b;var L=1<<w;if(_<0){_=L-1}else if(_===L){_=0}var T=y._tileIndexWrap;var j=[T];if(T){j.push(-T)}while((T=j.pop())!==undefined){if(k!=0&&C!=0){x=getTileKey(_,b,w,T);copyToNextTile(e,x,i,l,r,o,k*y._tileSize,C*y._tileSize)}if(k!=0){x=getTileKey(_,y._tileIndexY,w,T);copyToNextTile(e,x,i,l,r,o,k*y._tileSize,0)}if(C!=0){x=getTileKey(y._tileIndexX,b,w,T);copyToNextTile(e,x,i,l,r,o,0,C*y._tileSize)}}}if(t){t.drawImage(l,r,o,l.width,l.height)}}}if(i.cl&&n.clustering>0&&t){var M=i.cl+1;var I=2*flashnavigator.scaleRatio;t.save();t.textAlign="center";t.textBaseline="middle";t.beginPath();t.arc(m,v,g-I,0,2*Math.PI,false);t.fillStyle=n.predominantColor;t.fill();t.lineWidth=I;t.strokeStyle="#003300";t.stroke();if(!s){t.lineWidth=1*flashnavigator.scaleRatio;t.fillStyle="#fff";t.strokeStyle="#000";t.font=10*flashnavigator.scaleRatio+"px sans-serif";t.strokeText(M,m,v);t.fillText(M,m,v)}t.restore()}}var labelCache={},LEFT=1,RIGHT=2,BOTTOM=4,TOP=8,options={benchmark:true},bench={counter:{},perf:{}};bench.start=function(e){if(!options.benchmark){return}bench.perf[e]=performance.now()};bench.end=function(e){if(!options.benchmark){return}if(!bench.counter[e]){bench.counter[e]=0}bench.counter[e]+=performance.now()-bench.perf[e];delete bench.perf[e]};bench.collect=function(e){if(!options.benchmark){return}if(bench.perf[e]){bench.end(e)}console.debug("["+e+"] took "+bench.counter[e].toFixed(3)+"ms");delete bench.counter[e]};function dropCache(){labelCache={}}giscloud.util.mediator.deleteChannel("labelRenderer/dropCache");giscloud.util.mediator.makeChannel("labelRenderer/dropCache",true);giscloud.util.mediator.subscribe("labelRenderer/dropCache",dropCache);function prerenderLabel(e,t,i){bench.start("prerender label");var n,r,o,s,a,l,c,u,d,f,h,p,g,m,v,y,_,b,w;m=t.styleName;if(i!==undefined){m+="_"+i.toFixed(2)}if(!labelCache[m]){labelCache[m]={}}s=labelCache[m];n=s[e];if(n){return n}else{r=document.createElement("canvas");o=r.getContext("2d");b=4;w=4;u=t.fontsize||12;d=t.fontname||"Arial Black";f=t.outline?"#"+t.outline.substr(2):null;h=t.color?"#"+t.color.substr(2):null;c=""+u+"px '"+d+"'";o.font=c;a=w+Math.SQRT2*u;l=b+o.measureText(e).width;p=b>>1;g=Math.floor(a-(a-u)/2);if(i!==undefined){y=giscloud.math.Matrix2.Rotation(i);v=new giscloud.math.Rect(-(l>>1),-(a>>1),l>>1,a>>1);v=y.transform(v);r.width=Math.floor(v.max.x-v.min.x+8);r.height=Math.floor(v.max.y-v.min.y+8);o.font=c;p=Math.floor(-(l>>1)+p);g=Math.floor(-(a>>1)+g-4);o.save();o.translate(r.width>>1,r.height>>1);o.rotate(i)}else{r.width=l;r.height=a;o.font=c}if(f){o.fillStyle=f;o.fillText(e,p-1,g);o.fillText(e,p+1,g);o.fillText(e,p,g-1);o.fillText(e,p,g+1);o.fillText(e,p-1,g-1);o.fillText(e,p-1,g+1);o.fillText(e,p+1,g-1);o.fillText(e,p+1,g+1)}if(f&&!h){o.globalCompositeOperation="xor";o.fillStyle="#ffffff";o.fillText(e,p,g)}else{o.fillStyle=h;o.fillText(e,p,g)}if(i!==undefined){o.restore()}s[e]=r;return r}}function prepareFragments(t){var n,r;t.grid.walk(function(e){if(e.label.style){n=e.text();if(!n){return}r=prerenderLabel(n,e.label.style,e.angle);if(e.label.image!==r){e.label.image=r;i=e.label.image.width>>1;j=e.label.image.height>>1;e.label.rect=new giscloud.math.Rect(e.position[0]-i,e.position[1]-j,e.position[0]+i,e.position[1]+j)}if(!collides(t,e,e.label.rect)){if(t.qtree.top.bounds.contains(e.label.rect)){t.qtree.insert(e.label.rect,e);e.tile=t}else{neighbours=canInsertIntoNeighbours(t,e.label.rect,e);if(neighbours.length){e.originalTile=t;e.neighbours=neighbours;insertIntoNeighbours(neighbours,e);t.qtree.insert(e.label.rect,e);e.tile=t}}}}})}function drawTileLabels(e){var t=e.getContext("2d"),i;t.clearRect(0,0,256,256);e.qtree.walk(function(e){i=e.obj;t.drawImage(i.label.image,e.bounds.min.x,e.bounds.min.y)})}function drawGridCellCenters(e){var t,i,n,r,o=e.getContext("2d");o.strokeStyle="rgba(64, 64, 192, 0.8)";o.lineWidth=2;for(t=0;t<e.grid.width;++t){for(i=0;i<e.grid.height;++i){o.beginPath();if(t%2){n=(t+.5)*(256/e.grid.width);r=(i+.75)*(256/e.grid.height)}else{n=(t+.5)*(256/e.grid.width);r=(i+.25)*(256/e.grid.height)}o.arc(n,r,4,0,2*Math.PI);o.stroke()}}}function renderLabelTile(e,t){t.getContext("2d").clearRect(0,0,256,256);renderPointLabels(e,t);renderLineLabels(e,t);renderPolygonLabels(e,t);prepareFragments(t);drawTileLabels(t)}giscloud.util.mediator.deleteChannel("renderer/drawTile");giscloud.util.mediator.makeChannel("renderer/drawTile");giscloud.util.mediator.subscribe("renderer/drawTile",renderLabelTile);function clearLabelTile(e,t){t.grid.clear();t.qtree.clear()}giscloud.util.mediator.deleteChannel("renderer/clearTile");giscloud.util.mediator.makeChannel("renderer/clearTile");giscloud.util.mediator.subscribe("renderer/clearTile",clearLabelTile);function collides(e,t,i){var n,r,o,s,a=[],l,c,u,d;r=e.qtree.test(i);o=false;for(n=0;n<r.length;++n){if(r[n].bounds.intersects(i)){if(r[n].obj.score()<t.score()){a.push(r[n])}else{o=true;break}}}if(!o&&a.length){s=e.getContext("2d");s.clearRect(0,0,256,256);a.forEach(function(i){e.qtree.remove(function(e){return e.obj.id===i.obj.id});if(i.obj.tile){i.obj.tile.getContext("2d").clearRect(i.obj.label.rect.min.x-1,i.obj.label.rect.min.y-1,i.obj.label.image.width+2,i.obj.label.image.height+2)}if(i.obj.neighbours){i.obj.neighbours.forEach(function(t){t.tile.qtree.remove(function(e){if(e.obj===i.obj){s=t.tile.getContext("2d");u=t.rect.min.x-1;d=t.rect.min.y-1;l=t.rect.max.x-u+2;c=t.rect.max.y-d+2;s.clearRect(u,d,l,c);return true}return false})})}})}return o}function insertIntoNeighbours(e,t){for(i=0;i<e.length;++i){e[i].tile.qtree.insert(e[i].rect,t);drawTileLabels(e[i].tile)}}function canInsertIntoNeighbours(e,t,i){var n=[],r=[],o,s=0,a,l;o=e.qtree.top.bounds;if(t.min.x<o.min.x){s|=LEFT}if(t.max.x>o.max.x){s|=RIGHT}if(t.min.y<o.min.y){s|=TOP}if(t.max.y>o.max.y){s|=BOTTOM}if(s&LEFT){a=e._layer.getTile(new L.Point(e.coord.x-1,e.coord.y));l=t.translate(256,0);if(!collides(a,i,l)){n.push({tile:a,rect:l})}else{return[]}}if(s&TOP){a=e._layer.getTile(new L.Point(e.coord.x,e.coord.y-1));l=t.translate(0,256);if(!collides(a,i,l)){n.push({tile:a,rect:l})}else{return[]}}if(s&RIGHT){a=e._layer.getTile(new L.Point(e.coord.x+1,e.coord.y));l=t.translate(-256,0);if(!collides(a,i,l)){n.push({tile:a,rect:l})}else{return[]}}if(s&BOTTOM){a=e._layer.getTile(new L.Point(e.coord.x,e.coord.y+1));l=t.translate(0,-256);if(!collides(a,i,l)){n.push({tile:a,rect:l})}else{return[]}}if(!(s^(TOP|LEFT))){a=e._layer.getTile(new L.Point(e.coord.x-1,e.coord.y-1));l=t.translate(256,256);if(!collides(a,i,l)){n.push({tile:a,rect:l})}else{return[]}}if(!(s^(TOP|RIGHT))){a=e._layer.getTile(new L.Point(e.coord.x+1,e.coord.y-1));l=t.translate(-256,256);if(!collides(a,i,l)){n.push({tile:a,rect:l})}else{return[]}}if(!(s^(BOTTOM|LEFT))){a=e._layer.getTile(new L.Point(e.coord.x-1,e.coord.y+1));l=t.translate(256,-256);if(!collides(a,i,l)){n.push({tile:a,rect:l})}else{return[]}}if(!(s^(BOTTOM|RIGHT))){a=e._layer.getTile(new L.Point(e.coord.x+1,e.coord.y+1));l=t.translate(-256,-256);if(!collides(a,i,l)){n.push({tile:a,rect:l})}else{return[]}}return n}function renderPointLabels(a,e,t){var i,n,r,o,s,l,c,u,d,t,f,h,p;t=e.labelData.point;r=Object.keys(t);r=r.filter(function(e){return!t[e].hidden});for(i=0;i<r.length;++i){o=t[r[i]];s=Object.keys(o.geometry);for(n=0;n<s.length;++n){l=o.geometry[s[n]];u=l.position[0]*(e.grid.width/256);d=l.position[1]*(e.grid.height/256);h={id:l.id,position:[l.position[0],l.position[1]],label:{rect:null},score:function(e){return a.layers[e].orderIndex}.bind(null,l.layerId)};if(l.label.style!==null&&a.layers[l.layerId]&&a.layers[l.layerId].labelData&&a.layers[l.layerId].labelData.styles){p=a.layers[l.layerId].labelData.features[l.label.style]?a.layers[l.layerId].labelData.features[l.label.style].expression:"";if(p){h.label.style=a.layers[l.layerId].labelData.styles.reduce(function(e,t){if(e){return e}if(t.expression===p){e=t}return e},null)}else{h.label.style=a.layers[l.layerId].labelData.styles[l.label.style]}h.text=function(e,t,i,n){var r,o,s;r=n.label;if(!r){return""}o=a.getTile(i);if(!o){return""}s=o.labelData.point[e];if(!s){return""}if(s.attribute&&s.features[t]&&s.features[t][r]){return s.features[t][r]}else{return""}}.bind(null,l.layerId,l.id,e.coord,h.label.style);e.grid.insert([u,d],h)}}}}function renderPolygonLabels(a,e,t){var i,n,r,o,s,l,c,u,d,t,f,h;t=e.labelData.polygon;r=Object.keys(t);r=r.filter(function(e){return!t[e].hidden});for(i=0;i<r.length;++i){o=t[r[i]];s=Object.keys(o.geometry);for(n=0;n<s.length;++n){l=o.geometry[s[n]];u=l.position[0]*(e.grid.width/256);d=l.position[1]*(e.grid.height/256);h={id:l.id,position:[l.position[0],l.position[1]],label:{rect:null},score:function(e){return a.layers[e].orderIndex}.bind(null,l.layerId)};if(l.label.style!==null&&a.layers[l.layerId]&&a.layers[l.layerId].labelData&&a.layers[l.layerId].labelData.styles){expression=a.layers[l.layerId].labelData.features[l.label.style]?a.layers[l.layerId].labelData.features[l.label.style].expression:"";if(expression){h.label.style=a.layers[l.layerId].labelData.styles.reduce(function(e,t){if(e){return e}if(t.expression===expression){e=t}return e},null)}else{h.label.style=a.layers[l.layerId].labelData.styles[l.label.style]}h.text=function(e,t,i,n){var r,o,s;r=n.label;if(!r){return""}o=a.getTile(i);if(!o){return""}s=o.labelData.polygon[e];if(!s){return""}if(s.attribute&&s.features[t]&&s.features[t][r]){return s.features[t][r]}else{return""}}.bind(null,l.layerId,l.id,e.coord,h.label.style);e.grid.insert([u,d],h)}}}}function renderLineLabels(a,e){var t,i,n,r,o,s,l,c,u,d,f,h,p,g;h=e.labelData.line;r=Object.keys(h);r=r.filter(function(e){return!h[e].hidden});for(t=0;t<r.length;++t){o=h[r[t]];s=Object.keys(o.geometry);for(i=0;i<s.length;++i){l=o.geometry[s[i]];for(n=0;n<l.positions.length;++n){c={id:l.id,score:function(e){return a.layers[e].orderIndex}.bind(null,l.layerId)};d=l.positions[n].x;f=l.positions[n].y;c.angle=l.positions[n].angle;c.position=[d,f];c.label={rect:null};if(l.label.style!==null&&a.layers[l.layerId]&&a.layers[l.layerId].labelData&&a.layers[l.layerId].labelData.styles){g=a.layers[l.layerId].labelData.features[l.label.style]?a.layers[l.layerId].labelData.features[l.label.style].expression:"";if(g){c.label.style=a.layers[l.layerId].labelData.styles.reduce(function(e,t){if(e){return e}if(t.expression===g){e=t}return e},null)}else{c.label.style=a.layers[l.layerId].labelData.styles[l.label.style]}c.text=function(e,t,i,n){var r,o,s;r=n.label;if(!r){return""}o=a.getTile(i);if(!o){return""}s=o.labelData.line[e];if(!s){return""}if(s.attribute&&s.features[t]&&s.features[t][r]){return s.features[t][r]}else{return""}}.bind(null,l.layerId,l.id,e.coord,c.label.style);e.grid.insert([d*(e.grid.width/256),f*(e.grid.height/256)],c)}}}}}function drawText(e,t){var i=e.gc_state;var n=i.by_layer[i.layer];n.type="text";if(t){return}var r=null;var o=null;if(i.curLayerObj.feature_filter&&i.curLayerObj.feature_filter.filter){r=i.curLayerObj.feature_filter.filter;o=i.curLayerObj.feature_filter.context}var s=i.fields;var a=n.features;if(!a){return}var l=a.length;if(l<1){return}var c;var u=i._rect;var d=i._tileIndex+":"+i.layer;if(!r&&!n.isDirty){c=getCanvasFromCache(e,d,u,!i._entire_tile_draw);if(c){return}}var f=i.forceCtx||e.getContext("2d",flashnavigator.canvasOptions);f.lineWidth=3;f.lineCap="round";f.lineJoin="round";if(u){c=createCanvas(e,true);f=c.getContext("2d",flashnavigator.canvasOptions);f.lineWidth=3*flashnavigator.scaleRatio;f.lineCap="round";f.lineJoin="round"}var h=performance.now();var p=-1;var g,m,v,y,_;var b=0,w=0;for(var x=0;x<l;x++){if(p!=a[x].i&&a[x].i>=0){p=a[x].i;_=i.curLayerObj.features[a[x].i];if(_.outline)f.strokeStyle="#"+_.outline.substr(2);if(_.color)f.fillStyle="#"+_.color.substr(2);else f.fillStyle="rgba(255, 255, 255, 0)";g=0;m=0;_.dx&&(g=_.dx*flashnavigator.scaleRatio);_.dy&&(m=_.dy*flashnavigator.scaleRatio);f.textAlign="center";f.textBaseline="middle";b=.5;w=.5;var k=_.anchor;if(k){if(k=="TL"){f.textBaseline="top";f.textAlign="left";b=0;w=0}else if(k=="T"){f.textBaseline="top";w=0}else if(k=="TR"){f.textBaseline="top";f.textAlign="right";b=1;w=0}else if(k=="R"){f.textAlign="right";b=1}else if(k=="BR"){f.textBaseline="bottom";f.textAlign="right";b=1;w=1}else if(k=="B"){f.textBaseline="bottom";w=1}else if(k=="BL"){f.textBaseline="bottom";f.textAlign="left";b=0;w=1}else if(k=="L"){f.textAlign="left";b=0}}f.font=_.fontsize*flashnavigator.scaleRatio+"px "+(_.fontname?_.fontname:"arial");y=(_.fontsize*1+2)*flashnavigator.scaleRatio}if(_.visible===false){continue}var C=a[x].text;var L=C.length;var T=a[x].p;var j=T.length;var M,I,D;for(I=0;I<j;I++){if(r){var S={};if(s&&T[I][4]){S.data=s[T[I][4].replace("||","_")];setupFiltersObject(e,S)}else{S.data={}}if(!r(S.data,o))continue}if(!T[I][5]){T[I][5]=[]}for(M=0;M<L;M++){D=T[I][5][M];if(D){if(u&&(u.xmax<D.bounds.xmin||u.ymax<D.bounds.ymin||u.xmin>D.bounds.xmax||u.ymin>D.bounds.ymax))continue}else{var P,E,O,A;var N=T[I][2];var v=N/180*Math.PI;var R=f.measureText(C[M]);var z=R.width/256;if(z>1){wrapText(C,M,z);L=C.length;R=f.measureText(C[M])}var H=R.width*flashnavigator.scaleRatio;var F=y;var W=T[I][0]*flashnavigator.scaleRatio+g-Math.sin(v)*y*M;var B=T[I][1]*flashnavigator.scaleRatio+m+Math.cos(v)*y*M;if(N==0){P=Math.floor(W-H*b);E=Math.floor(B-F*w);O=Math.ceil(P+H);A=Math.ceil(E+F)}else{var G=Math.cos(v);var q=Math.sin(v);var $=F*G;var U=H*G;var V=F*q;var Y=H*q;var Z=W-U*b+V*w;var X=B-Y*b-$*w;if(N>0){if(N<90){E=Math.floor(X);A=Math.ceil(X+$+Y);P=Math.floor(Z-V);O=Math.ceil(Z+U)}else{E=Math.floor(X+$);A=Math.ceil(X+Y);P=Math.floor(Z-V+U);O=Math.ceil(Z)}}else{if(N>-90){E=Math.floor(X+Y);A=Math.ceil(X+$);P=Math.floor(Z);O=Math.ceil(Z+U-V)}else{E=Math.floor(X+Y+$);A=Math.ceil(X);P=Math.floor(Z+U);O=Math.ceil(Z-V)}}}D={x:W,y:B,angle:v,bounds:{xmin:P-1,ymin:E-1,xmax:O+1,ymax:A+1}};T[I][5][M]=D}if(e&&!i._isRedraw&&!a[x].copied){var J=i._tileIndexX;var Q=i._tileIndexY;var K=i._tileIndexZ;var ee;if(D.bounds.xmin<0){J--}else if(D.bounds.xmax>i._tileSize){J++}if(D.bounds.ymin<0){Q--}else if(D.bounds.ymax>i._tileSize){Q++}var te=i._tileIndexX-J;var ie=i._tileIndexY-Q;var ne=1<<K;if(J<0){J=ne-1}else if(J===ne){J=0}var re=i._tileIndexWrap;var oe=[re];if(re){oe.push(-re)}while((re=oe.pop())!==undefined){if(te!=0&&ie!=0){ee=getTileKey(J,Q,K,re);copyTextToNextTile(e,ee,T[I],C[M],p,D,te*i._tileSize,ie*i._tileSize)}if(te!=0){ee=getTileKey(J,i._tileIndexY,K,re);copyTextToNextTile(e,ee,T[I],C[M],p,D,te*i._tileSize,0)}if(ie!=0){ee=getTileKey(i._tileIndexX,Q,K,re);copyTextToNextTile(e,ee,T[I],C[M],p,D,0,ie*i._tileSize)}}}f.save();f.translate(D.x,D.y);f.rotate(D.angle);if(_.outline)f.strokeText(C[M],0,0);f.fillText(C[M],0,0);f.restore()}}}if(c&&!r&&i._entire_tile_draw){n.isDirty=false;c.timeToGenerate=performance.now()-h;storeCanvasToCache(c,d)}}function copyTextToNextTile(e,t,i,n,r,o,s,a){var l=[];l[0]=i[0]+s;l[1]=i[1]+a;l[2]=i[2];l[3]=i[3];l[4]=i[4];l[5]=[];var c={xmin:o.bounds.xmin+s,ymin:o.bounds.ymin+a,xmax:o.bounds.xmax+s,ymax:o.bounds.ymax+a};l[5][0]={x:o.x+s,y:o.y+a,bounds:c,angle:o.angle};var u={p:[l],text:[n],i:r,id:i[4],copied:true};var d,f;if(e.gc_state.fields&&i[4]){d=i[4].replace("||","_");f=e.gc_state.fields[d]}var h=e.gc_state.layer;var p=e.gc_state.gc_layer;var g=p._tiles[t];var m=g?g.gc_state:null;var v=m?m.by_layer[h]:null;if(v&&v._isEmpty){v._isEmpty=false;m.layer=h;g._layer=e._layer;g.gc_state.gc_layer=p;drawTile(g,{tile:{type:"text",data:[]}},e.gc_state.curLayerObj,true,true)}if(v&&v.features){if(u.id!==undefined&&v.feature_ids[u.id])return;if(!m._invalidateRectForCopy)m._invalidateRectForCopy={xmin:c.xmin,ymin:c.ymin,xmax:c.xmax,ymax:c.ymax};else{if(c.xmin<m._invalidateRectForCopy.xmin)m._invalidateRectForCopy.xmin=c.xmin;if(c.ymin<m._invalidateRectForCopy.ymin)m._invalidateRectForCopy.ymin=c.ymin;if(c.xmax>m._invalidateRectForCopy.xmax)m._invalidateRectForCopy.xmax=c.xmax;if(c.ymax>m._invalidateRectForCopy.ymax)m._invalidateRectForCopy.ymax=c.ymax}e.gc_state._tiles_to_redraw[t]=g;v.isDirty=true;v.features.push(u);if(d){if(!m.fields)m.fields={};m.fields[d]=f}}else{var y=p.neighbour_tile_data[t];if(!y){y=p.neighbour_tile_data[t]={}}var _=y[h];if(!_){_=y[h]=[]}var b={item:u};if(d){b.field={key:d,value:f}}_.push(b)}}function wrapText(e,t,i){var n=e[t].split(" "),r=Math.ceil(n.length/i),o=[],s,a=0,l=[];while(s=n.shift()){o.push(s);a++;if(a>r){l.push(o.join(" "));o=[];a=0}}if(a>0){l.push(o.join(" "))}e.splice.apply(e,[t,1].concat(l))}function drawPixels(e,t,i){var n,r,o,s=i.length,a,l,c,u,d,f,h=0,p=e.curLayerObj.features,g,m,v=0,y=0,_=0;if(t.pixels){releaseCanvasToPool(t.pixels)}n=getCanvasFromPool(256,256,true);r=n.getContext("2d",flashnavigator.canvasOptions);r.scale(flashnavigator.scaleRatio,flashnavigator.scaleRatio);o=r.createImageData(256,256);a=o.data;if(i[0]!==0){for(c=s-1;c>=0;c--){d=i[c];g=p[d[0]];if(!g||!g.visible){continue}m=g.strokecolorRGB?g.strokecolorRGB:g.fillcolorRGB;if(!m){continue}v=m[0];y=m[1];_=m[2];h=0;f=d.length;for(u=1;u<f;u+=2){h+=d[u]*4;l=d[u+1];while(l--){a[h++]=v;a[h++]=y;a[h++]=_;a[h++]=255}}}t.pixelsVisibility=e.curLayerObj.featuresVisibility;t.pixelsData=i}else{for(c=1;c<s;c++){if(i[c]<0){l=i[c];if(i[c+1]==0){c++;v=i[++c];y=i[++c];_=i[++c]}while(l++){a[h*4]=v;a[h*4+1]=y;a[h*4+2]=_;a[h*4+3]=255;h++}}else{h+=i[c]}}}r.putImageData(o,0,0);t.pixels=n}function drawTileImage(e,t,i,n){var r=e.gc_state,o,s,a=false;r.by_layer[t.id]=r.by_layer[t.id]||{};o=r.by_layer[t.id];r.layer=t.id;r.curLayerObj=t;if(!r.will_load_vectors){r._drawn=true}if(i){s=getCanvasFromPool(flashnavigator.tileSize,flashnavigator.tileSize,true);if(!n){n={x:0,y:0,width:i.width,height:i.height}}s.getContext("2d").drawImage(i,n.x,n.y,n.width,n.height,0,0,flashnavigator.tileSize,flashnavigator.tileSize);if(o.image){releaseCanvasToPool(o.image)}o.image=s;o.can_draw=checkIfImageCanBeDraw(t,e)}if(r._drawn&&(r.number_of_image_requests===0||o.can_draw)){redrawSingleTile(t.tileLayer,e,null,true);a=true}return a}function drawImageInternal(e){var t=e.gc_state,i,n,r,o;t.by_layer[t.layer]=t.by_layer[t.layer]||{};i=t.by_layer[t.layer];if(t.number_of_image_requests>0&&!i.can_draw||!i.image||!e.getContext&&!t.forceCtx){return}o=t._rect;n=t.forceCtx||e.getContext("2d",flashnavigator.canvasOptions);if(t.curLayerObj.isRasterLayer){o=getImageClipRect(o,i.clip)}if(o){if(o.width>0&&o.height>0){r=createCanvas(e,true);n=r.getContext("2d",flashnavigator.canvasOptions);n.drawImage(i.image,o.xmin,o.ymin,o.width,o.height,o.xmin,o.ymin,o.width,o.height)}}else{n.drawImage(i.image,0,0)}}function getImageClipRect(e,t){var i={},n;if(e){i.xmin=e.xmin;i.ymin=e.ymin;i.xmax=e.xmax;i.ymax=e.ymax}else{i.xmin=0;i.ymin=0;i.xmax=256*flashnavigator.scaleRatio;i.ymax=256*flashnavigator.scaleRatio}if(t.left>i.xmin){i.xmin=t.left}if(t.right<i.xmax){i.xmax=t.right}if(t.top>i.ymin){i.ymin=t.top}if(t.bottom<i.ymax){i.ymax=t.bottom}i.width=i.xmax-i.xmin;i.height=i.ymax-i.ymin;return i}function rectUnion(e,t,i){if(t.xmin-i<e.xmin)e.xmin=t.xmin-i;if(t.ymin-i<e.ymin)e.ymin=t.ymin-i;if(t.xmax+i>e.xmax)e.xmax=t.xmax+i;if(t.ymax+i>e.ymax)e.ymax=t.ymax+i;rectCalculateSizeAndId(e)}function rectCropWithTile(e,t){if(e.xmin<t._xmin)e.xmin=t._xmin;if(e.ymin<t._xmin)e.ymin=t._ymin;if(e.xmax>t._xmax)e.xmax=t._xmax;if(e.ymax>t._ymax)e.ymax=t._ymax;rectCalculateSizeAndId(e)}function rectCropWithRect(e,t){if(e.xmin<t.xmin)e.xmin=t.xmin;if(e.ymin<t.ymin)e.ymin=t.ymin;if(e.xmax>t.xmax)e.xmax=t.xmax;if(e.ymax>t.ymax)e.ymax=t.ymax;rectCalculateSizeAndId(e)}function rectAssign(e,t,i){e.xmin=t.xmin-i;e.ymin=t.ymin-i;e.xmax=t.xmax+i;e.ymax=t.ymax+i;rectCalculateSizeAndId(e)}function rectCreate(e){var t={xmin:e._xmin,ymin:e._ymin,xmax:e._xmax,ymax:e._ymax};rectCalculateSizeAndId(t);return t}function rectCalculateSizeAndId(e){e.width=e.xmax-e.xmin;e.height=e.ymax-e.ymin;e.id=e.xmin+"_"+e.xmax+"_"+e.ymin+"_"+e.ymax}function pointDistance(e,t,i,n){var r=e-i;var o=t-n;return Math.sqrt(r*r+o*o)}function vector(e,t){return{x:e,y:t}}function vectorAdd(e,t){return vector(e.x+t.x,e.y+t.y)}function scalarMul(e,t){return vector(e*t.x,e*t.y)}function length(e){return Math.sqrt(e.x*e.x+e.y*e.y)}function normalize(e){return scalarMul(1/length(e),e)}function offset(e,t,i){var n,r,o;n=scalarMul(e,normalize(vector(t.y-i.y,i.x-t.x)));r=vectorAdd(n,t);o=vectorAdd(n,i);return[r,o]}function intersectLines(e,t,i,n,r){var o=t.x-e.x;var s=n.x-i.x;var a=t.y-e.y;var l=n.y-i.y;var c=o*l-a*s;if(c<1e-4){return i}var u=(o*(e.y-i.y)-a*(e.x-i.x))/c;if(u*Math.sqrt(s*s+l*l)>r){return i}else{return{x:i.x+u*s,y:i.y+u*l}}}function doOffset(e,t){if(!e.px){var i=e.p;var n=i.length;var r=vector(i[0],i[1]);var o;var s=null;for(var a=2;a<n;a+=2){var l=r;var c=vector(i[a],i[a+1]);r=c;var u=offset(t/10,l,c);if(s){o=intersectLines(o,s,u[0],u[1],t)}else{o=u[0]}s=u[1];i[a-2]=Math.round(o.x*10)/10;i[a-1]=Math.round(o.y*10)/10;o=u[0]}i[n-2]=Math.round(s.x*10)/10;i[n-1]=Math.round(s.y*10)/10}}function removeDOM(e){if(!e.remove){e=$(e)}e.remove()}function initCanvas(e,t,i,n){var r=e.gc_state;r.forceCtx=t.getContext("2d",flashnavigator.canvasOptions);if(n&&(n.xmin!==0||n.ymin!==0)){r.forceCtx.translate(-n.xmin,-n.ymin)}if(i){if(!r.canvases_to_draw){r.canvases_to_draw=[]}r.current_canvas_state={canvas:t,layer:r.curLayerObj,rect:n};r.canvases_to_draw.push(r.current_canvas_state)}}function createCanvas(e,t,i){var n=e.gc_state,i=i?i:n._rect,r;var o=i?i.width:e.width;var s=i?i.height:e.height;r=getCanvasFromPool(o,s,n._width===o&&n._height===s);initCanvas(e,r,t,i);return r}function storeCanvasToCache(e,t){var i=tile_cache.tiles;if(tile_cache.max===0)return;if(i[t]||tile_cache.count<tile_cache.max){if(tile_cache.min_index==t){tile_cache.min=e.timeToGenerate;calculateCanvasCacheMin()}else if(e.timeToGenerate<tile_cache.min){tile_cache.min=e.timeToGenerate;tile_cache.min_index=t}if(i[t]){i[t].inCache=false;releaseCanvasToPool(i[t])}else{tile_cache.count++}e.inCache=true;e.activeCache=true;i[t]=e}else{if(e.timeToGenerate>tile_cache.min){var n=tile_cache.min_index;if(i[n].activeCache){n=null;for(var r in i){if(!i[r].activeCache&&e.timeToGenerate>i[r].timeToGenerate){n=r;break}}}if(n){i[n].inCache=false;releaseCanvasToPool(i[n]);delete i[n];e.inCache=true;e.activeCache=true;i[t]=e;if(n===tile_cache.min_index){calculateCanvasCacheMin()}}}}}function calculateCanvasCacheMin(){var e=tile_cache.tiles;tile_cache.min=Infinity;for(var t in e){if(e[t].timeToGenerate<tile_cache.min){tile_cache.min=e[t].timeToGenerate;tile_cache.min_index=t}}}function getCanvasFromCache(e,t,i,n){var r=tile_cache.tiles[t];if(tile_cache.max===0||!r||e.isTileDirty)return null;if(i&&n){var o=createCanvas(e,true);o.getContext("2d",flashnavigator.canvasOptions).drawImage(r,i.xmin,i.ymin,i.width,i.height,i.xmin,i.ymin,i.width,i.height);return o}initCanvas(e,r,true,i,n);r.activeCache=true;return r}function intColor2hexColor(e){if(isNaN(e))return e;var t=e.toString(16);return"#"+[0,0,0,0,0,0].slice(t.length).join("")+t}function getFeatureIdsInTiles(e,t,i){var n=[],r={},o,s,a,l,c;for(o=0,a=t.length;o<a;o++){var u=t[o];if(i[u].gc_state&&i[u].gc_state.by_layer&&i[u].gc_state.by_layer[e]&&i[u].gc_state.by_layer[e].features){l=i[u].gc_state.by_layer[e].features;c=l.length;for(s=0;s<c;s++){if(l[s].visible){r[l[s].fid]=l[s].fid}}}}for(o in r){n.push(r[o])}return n}function restoreOriginalParts(e,t){var i=null,n,r,o=t.gc_state,s=o.obj.parent,a,l;if(!o)return;if(!flashnavigator.inOffscreenRenderingWorker){a=!t.getContext;if(a){t=getCanvasFromPool(o._width,o._height);t.gc_state=o}i=t.getContext("2d",flashnavigator.canvasOptions)}for(l in e){n=e[l];if(!n){if(self.Muscula){Muscula.log.info("debug restoreOriginalParts "+Date.now(),{i:l,parts:JSON.stringify(e),canvas_pool:getCanvasPoolStats()})}continue}e[l]=null;r=n.rect;if(r.width>0&&r.height>0){if(flashnavigator.inOffscreenRenderingWorker){canvases_for_redraw.push({bitmap:n.canvas.transferToImageBitmap(),x:r.xmin,y:r.ymin,width:r.width,height:r.height,tileIndex:o._tileIndex,layer:o.obj.parent.id})}else{i.clearRect(r.xmin,r.ymin,r.width,r.height);i.drawImage(n.canvas,0,0,r.width,r.height,r.xmin,r.ymin,r.width,r.height);if(!flashnavigator.inOffscreenRenderingWorker){s.render(t,n.canvas,r)}}}releaseCanvasToPool(n.canvas);n.canvas=null}if(a){releaseCanvasToPool(t)}}function drawCanvasParts(e,t,i,n,r,o){e.forEach(function(e){o.globalAlpha=e.layer.isGroupLayer?e.layer.options.opacity:1;o.drawImage(e.canvas,t,i,n,r,0,0,n,r);o.globalAlpha=1})}function renderTile(t){var e=t.gc_state,i=e.obj.parent,n,r=e.canvases_to_draw||[],o,s,a,l;s=e._rect;if(e._rect&&e._invalidateRect){rectCropWithRect(e._invalidateRect,e._rect)}if(e._invalidateRect&&(e._invalidateRect.width<=0||e._invalidateRect.height<=0)){e._invalidateRect=null}o=e._invalidateRect;e._invalidateRect=null;if(o){var c,u=o.width,d=o.height;c=getCanvasFromPool(u,d);if(!e._originalCanvasParts){e._originalCanvasParts={}}if(e._originalCanvasParts[o.id]){if(e._originalCanvasParts[o.id].canvas){releaseCanvasToPool(e._originalCanvasParts[o.id].canvas)}}e._originalCanvasParts[o.id]={canvas:c,rect:o};a=c.getContext("2d",flashnavigator.canvasOptions);drawCanvasParts(r,o.xmin-s.xmin,o.ymin-s.ymin,u,d,a)}a=t.getContext("2d",flashnavigator.canvasOptions);if(!flashnavigator.inOffscreenRenderingWorker&&s){a.clearRect(s.xmin,s.ymin,s.width,s.height)}r.forEach(function(e){if(e.overlay){n=e.canvas;e.canvas=createCanvas(t,false,s);l=e.canvas.getContext("2d",flashnavigator.canvasOptions);l.drawImage(n,s.xmin,s.ymin);l.drawImage(e.overlay,0,0,o.width,o.height,o.xmin,o.ymin,o.width,o.height);releaseCanvasToPool(n);releaseCanvasToPool(e.overlay);n=null;e.overlay=null}a.globalAlpha=e.layer.isGroupLayer?e.layer.options.opacity:1;a.drawImage(e.canvas,0,0,s.width,s.height,s.xmin,s.ymin,s.width,s.height);releaseCanvasToPool(e.canvas);e.canvas=null});a.globalAlpha=1;if(flashnavigator.inOffscreenRenderingWorker){canvases_for_redraw.push({bitmap:t.transferToImageBitmap(),x:s.xmin,y:s.ymin,width:s.width,height:s.height,layer:e.obj.parent.id,tileIndex:e._tileIndex})}else{i.render(t,t,s,true)}e.canvases_to_draw=[];e._calculateInvalidateRect=false;e._rect=null;e._canvasRect=null;e.forceCtx=null}function unloadTileParts(e){var t,i;if(e.gc_state._originalCanvasParts){t=e.gc_state._originalCanvasParts;for(i in t){releaseCanvasToPool(t[i].canvas)}e.gc_state._originalCanvasParts=null}}function unloadTile(t,e){var i,n,r,o;if(!t)return;i=t.gc_state;for(o in active_loaders){if(active_loaders[o].tile===t){active_loaders[o].tile=null;r=active_loaders[o];if(r.abort){r.abort()}if(r.src){r.src=null}if(active_loaders[o]){delete active_loaders[o]}break}}if(!i)return;unloadTileParts(t);n=t.gc_state.by_layer;if(e){e.forEach(function(e){removeTileFromCache(t,e);if(n[e]&&n[e].pixels){releaseCanvasToPool(n[e].pixels);n[e].pixels=null;n[e].pixelsData=null;n[e].pixelsVisibility=null}if(n[e]&&n[e].image){releaseCanvasToPool(n[e].image);n[e].image=null}});return}removeTileFromCache(t);for(o in n){if(n[o]&&n[o].pixels){releaseCanvasToPool(n[o].pixels);n[o].pixels=null;n[o].pixelsData=null;n[o].pixelsVisibility=null}if(n[o]&&n[o].image){releaseCanvasToPool(n[o].image);n[o].image=null}}t.gc_state.reset=true;t.gc_state=null}function getTileKey(e,t,i,n,r){var o=e+":"+t+":"+i;if(r!==undefined&&r!==i){o+="O"+r}if(n){o+="W"+n}return o}function getTimestamp(e,t){if(e.lid){if(t.dynamic){e.url_prefix=giscloud_tile_url+"d/"+t.modified+"/"+e.mid+"/"+e.lid;var i=(new Date).getTime();e.url=giscloud_tile_url+"d/"+t.modified+"/"+e.mid+"/"+e.lid+"/dyn,"+i+"/";e.url3=giscloud_tile_url+"d/";e.t=i;e.modified=t.modified;e.dynamic=true}else{var n;if(giscloud.app&&giscloud.app.option("DISABLE_CORS"))n="dt/";else n="t2/";var r=","+giscloud.tile_token;r="";e.url=giscloud_tile_url+n+t.modified+"/"+e.mid+r+"/"+e.lid+"/";e.url2=giscloud_tile_url+n;e.modified=t.modified}}else{if(fields)e.url=giscloud_tile_url+"vt3/"+t.modified+"/"+e.mid+"/"+fields+"/";else e.url=giscloud_tile_url+"vt2/"+t.modified+"/"+e.mid+"/"}if(e.map)e.map.getDiv().firstChild.firstChild.firstChild.firstChild.style.zIndex=150}function jsonCanvas(e,t){var i=e.createElement("div");var n=e.createElement("canvas");i.appendChild(n);i.c=n;n.od=e;n.setAttribute("width",256);n.setAttribute("height",256);n.setAttribute("style","position:relative");n.style.position="relative";n.obj=t;if(window.G_vmlCanvasManager)G_vmlCanvasManager.initElement(n);google.maps.event.addDomListener(n,"mousemove",function(e){checkForEvent(e)});return i}function intersects(e,t){if(e.xmax<t.xmin||e.xmin>t.xmax||e.ymax<t.ymin||e.ymin>t.ymax){return false}return true}function findCG(e,t,i,n){var r,o,s=0,a=[],l=e.length-2,c=[],u=Math.min(Math.max(t+e[0],n.xmin),n.xmax),d=Math.min(Math.max(i+e[1],n.ymin),n.ymax),f,h,p,g;c[0]=0;c[1]=0;for(r=2;r<l;r+=2){f=Math.min(Math.max(t+e[r],n.xmin),n.xmax);h=Math.min(Math.max(i+e[r+1],n.ymin),n.ymax);p=Math.min(Math.max(t+e[r+2],n.xmin),n.xmax);g=Math.min(Math.max(i+e[r+3],n.ymin),n.ymax);o=(f-u)*(g-d)-(p-u)*(h-d);c[0]+=o*(u+f+p);c[1]+=o*(d+h+g);s+=o}c[2]=s;return c}function unique_array(e){return e.filter(function(e,t,i){return t==i.indexOf(e)}).sort()}var emptyImageUrl="data:image/gif;base64,R0lGODlhAQABAAD/ACwAAAAAAQABAAACADs=";function vectorTileLoader(request,dontUseWorker){var x,uri=request.uri,tile=request.tile,url=request.url;if(flashnavigator.offscreenRendering&&!dontUseWorker){if(tile_request[uri]){workerLoader({tile:tile,url:url,uri:uri,seq:tile_request[uri].seq});delete tile_request[uri]}return}if(!tile.gc_state){return}if(giscloud.offlineMode()){return offlineMapTileLoader(url,tile,uri)}x=self.XDomainRequest?new XDomainRequest:new XMLHttpRequest;if(self.XDomainRequest)x.xdomain=1;if(x){x.tile_request=tile_request[uri];delete tile_request[uri];x.tile=tile;assignLoader(tile.gc_state,uri,x);tile.gc_state.number_of_requests++;x.onreadystatechange=function(){if(this.xdomain||this.readyState==4){if(this.ignore){if(this.tile.gc_state){this.tile.gc_state.number_of_requests--}return}if(!checkTileReady(this.tile,this.uri))return;var d=0;if(this.xdomain||this.status==200){if(this.responseText&&this.responseText[0]!="<"&&this.responseText!="[0]"){if(self.JSON){d=self.JSON.parse(this.responseText)}else{d=eval("("+this.responseText+")")}}}else if(this.status===0&&this.responseText){try{d=self.JSON.parse(this.responseText)}catch(err){}}handleMapTileResponse(this,this.tile,d)}};if(x.xdomain){x.onerror=function(){if(this.ignore){if(this.tile.gc_state){this.tile.gc_state.number_of_requests--}return}if(active_loaders[this.uri]){delete active_loaders[this.uri]}};x.ontimeout=function(){if(active_loaders[this.uri]){delete active_loaders[this.uri]}};x.onprogress=function(){};x.onload=x.onreadystatechange}x.open("GET",url);x._url=url;x.send()}}function checkTileReady(e,t){if(!e){return false}if(active_loaders[t]){delete active_loaders[t]}else{if(flashnavigator.inOffscreenRenderingWorker&&e.gc_state){unloadTile(e);releaseCanvasToPool(e)}return false}if(!e.gc_state){return false}if(!e.gc_state.current_loading_uri[t]){return false}else{delete e.gc_state.current_loading_uri[t]}if(!e.gc_state.gc_layer._tiles[e.gc_state._tileIndex]||e.gc_state.gc_layer._tiles[e.gc_state._tileIndex].gc_state!==e.gc_state){unloadTile(e);releaseCanvasToPool(e);return false}if(e.gc_state.reset){unloadTile(e);releaseCanvasToPool(e);return false}return true}function calculateImageRect(e,t){var i={},n=Math.pow(2,e.zoom-e.original.zoom);i.width=t.width*n;i.height=t.height*n;i.x=i.width*e.original.x-t.width*Math.floor(e.original.x*n);i.y=i.height*e.original.y-t.height*Math.floor(e.original.y*n);e.rect=i}function renderImageTile(e,t,i,n,r){drawTileImage(e,t,n,r);if(!e||!e.gc_state){return}if(flashnavigator.inOffscreenRenderingWorker){workerRenderTiles(e.gc_state.gc_layer)}if(e.ontileload&&e.gc_state.number_of_requests===0){e.ontileload()}}function handleImageLoad(e,t,i,n,r,o){if(!checkTileReady(e,r.uri))return;e.gc_state.number_of_image_requests--;e.gc_state.number_of_requests--;if(o.original){if(t.zoomThreshold===undefined&&t.source.src!=="wms"&&!o.incompleteTileCoverage){t.zoomThreshold=o.zoom}calculateImageRect(o,n)}renderImageTile(e,t,o,n,o.rect)}function handleImageLoadError(e,t,i,n,r,o){if(n.ignore){e.gc_state.number_of_image_requests--;e.gc_state.number_of_requests--;return}if(!checkTileReady(e,n.uri))return;e.gc_state.number_of_image_requests--;e.gc_state.number_of_requests--;if(o){if(!r.original){r.original={zoom:r.zoom,x:r.coord.x,y:r.coord.y}}r.zoom--;if(r.zoom>=0){r.coord.x=Math.floor(r.coord.x/2);r.coord.y=Math.floor(r.coord.y/2);r.tile=e;generateTileImageUrl(r);imageTileLoader(r);return}}i.noImage=true;renderImageTile(e,t,r)}function imageTileLoader(n){var r,o,s=n.tile,e=n.uri,t=n.coord,a=n.layer,i=s.gc_state,l,c;if(!i){return}if(a.incompleteTileCoverage){n.incompleteTileCoverage=a.incompleteTileCoverage}l=i.by_layer[a.id];if(flashnavigator.offscreenRendering){n.isImage=true;n.layer=a.id;n.that=undefined;if(tile_request[e]){workerLoader(n);tile_request[e]=null}return}if(a.zoomThreshold&&n.zoom>a.zoomThreshold){n.original={x:t.x,y:t.y,zoom:n.zoom};t.x=Math.floor(t.x*Math.pow(2,a.zoomThreshold-n.zoom));t.y=Math.floor(t.y*Math.pow(2,a.zoomThreshold-n.zoom));n.zoom=a.zoomThreshold}n.hadPreviousSuccessfullRequest=a.hadPreviousSuccessfullRequest;generateTileImageUrl(n);if(!l){i.by_layer[a.id]={};l=i.by_layer[a.id]}l.lid=a.id;l.type="image";l.clip=n.clip;i.number_of_image_requests++;i.number_of_requests++;if(self.fetch&&self.AbortController){o=new AbortController;c={signal:o.signal,referrer:self.location.origin,referrerPolicy:"origin"};r=fetch(n.url,c).then(function(e){if(Math.round(e.status/100)===4){handleImageLoadError(s,a,l,o,n,true);return}a.hadPreviousSuccessfullRequest=true;e.blob().then(function(e){if(e.size==0){handleImageLoadError(s,a,l,o,n);return}if(self.createImageBitmap){createImageBitmap(e).then(function(e){handleImageLoad(s,a,l,e,o,n)}).catch(function(e){handleImageLoadError(s,a,l,o,n)})}else{if(!active_loaders[seq])return;var t=self.URL||self.webkitURL;var i=t.createObjectURL(e);r=new Image;r.tile=s;o=r;active_loaders[seq]=o;r.onload=function(){var e=this;t.revokeObjectURL(i);handleImageLoad(s,a,l,e,this,n)};r.onerror=function(){t.revokeObjectURL(i);handleImageLoadError(s,a,l,o,n)};r.src=i}}).catch(function(e){handleImageLoadError(s,a,l,o,n)})}).catch(function(e){var t=e instanceof TypeError;if(t&&!n.hadPreviousSuccessfullRequest&&!n.usingProxy&&a.proxyServerAvailable){a.proxyServer=a.proxyServerAvailable;if(s.gc_state){s.gc_state.number_of_image_requests--;s.gc_state.number_of_requests--}n.tile=s;imageTileLoader(n);return}handleImageLoadError(s,a,l,o,n,t)})}else{r=new Image;o=r;r.onload=function(){var e=r;handleImageLoad(s,a,l,e,o,n)};r.onerror=function(){handleImageLoadError(s,a,l,o,n)};r.src=n.url}if(tile_request[e]){o.tile_request=tile_request[e];delete tile_request[e]}o.tile=s;assignLoader(i,e,o)}function assignLoader(e,t,i){var n=e._tileIndex+":"+t;if(!e.current_loading_uri){e.current_loading_uri={}}e.current_loading_uri[n]=1;i.uri=n;if(active_loaders[n]){if(active_loaders[n].abort){active_loaders[n].ignore=true;active_loaders[n].abort()}}active_loaders[n]=i}function resetLoaders(){var e;for(e in active_loaders){resetLoader(e)}loader_id++;tile_req=[];tile_request={};if(flashnavigator.offscreenRendering){workerResetLoaders()}}function resetLoader(e){if(!active_loaders[e])return;if(active_loaders[e].tile){tile=active_loaders[e].tile;if(tile._layer._tileOnError){tile._layer._tileOnError.call(tile)}if(flashnavigator.inOffscreenRenderingWorker){if(tile.gc_state){workerHandleTileOnError(tile._layer.id,tile.gc_state._tileIndex);unloadTile(tile)}releaseCanvasToPool(tile);tile.gc_state=null;tile=null}}if(!active_loaders[e])return;active_loaders[e].tile=null;if(active_loaders[e].src){active_loaders[e].src=emptyImageUrl}if(active_loaders[e].abort){active_loaders[e].abort()}delete active_loaders[e]}function abortRequest(e){var t;if(!e.gc_state){return}var i=e.gc_state.current_loading_uri;e.gc_state.current_loading_uri=null;if(i){for(t in i){resetLoader(t)}}}function handleEmptyTile(e){var t=e.gc_state.obj;var i=t.parent;if(i.neighbour_tile_data&&i.neighbour_tile_data[e.gc_state._tileIndex]&&i.neighbour_tile_data[e.gc_state._tileIndex][i.id]){var n=i.features[0].type;if(n=="point"){drawTile(e,{tile:{type:"point",data:[]}},i)}if(n=="label"||n=="text"){drawTile(e,{tile:{type:"text",data:[]}},i)}}else{if(!e.gc_state.by_layer[i.id]){e.gc_state.by_layer[i.id]={}}e.gc_state.by_layer[i.id]._isEmpty=true}}function handleMapTileResponse(e,t,i){var n;if(i&&i.length&&!t.gc_state.obj.dynamic){var r,o,s=0,a,l,c=e.tile_request.tiles;for(o=0;o<c.length;o++){r=c[o];n=r.gc_state.obj;if(n){if(n.parent.group){s+=processGroupTiles(e.tile_request,i,o,s)}else{a=!r.getContext;if(a){l=r;r=getCanvasFromPool(state._width,state._height);r.gc_state=state;r._layer=l._layer}r.gc_state._rect=rectCreate(r.gc_state);if(i[o]){drawTile(r,i[o],n.parent)}else{handleEmptyTile(r)}renderTile(r);if(a){releaseCanvasToPool(r);r=l;a=false}redrawNeighbourTiles(r);if(flashnavigator.inOffscreenRenderingWorker){workerRenderTiles(n.parent)}}}r.gc_state.number_of_requests--;if(r&&r.ontileload&&r.gc_state.number_of_requests===0){r.ontileload()}}}else if(t){if(t.gc_state){n=t.gc_state.obj}if(n){if(n.parent.group){processGroupTiles(e.tile_request,i,0,0,true)}else{a=!r.getContext;if(a){l=t;t=getCanvasFromPool(state._width,state._height);t.gc_state=state;t._layer=l._layer}t.gc_state._rect=rectCreate(t.gc_state);if(i){drawTile(t,i,n.parent)}else{handleEmptyTile(t)}renderTile(t);if(a){releaseCanvasToPool(t);t=l}redrawNeighbourTiles(t);if(flashnavigator.inOffscreenRenderingWorker){workerRenderTiles(n.parent)}}}t.gc_state.number_of_requests--;if(t.ontileload&&t.gc_state.number_of_requests===0){t.ontileload()}}}function offlineMapTileLoader(url,tile,uri){var params,params_offset=0,fields=null,request;url=url.split("/");if(url.length==11){params_offset+=1;fields="&fields="+url[7]}params=[url[4],url[5],url[6],url[7+params_offset],url[8+params_offset],url[9+params_offset].replace(".json","")];if(fields)params.push(fields);request={tile_request:tile_request[uri]};delete tile_request[uri];giscloudOffline.getMapTile(params,function(tile_data){if(window.JSON){tile_data=window.JSON.parse(tile_data)}else{tile_data=eval("("+tile_data+")")}handleMapTileResponse(request,tile,tile_data)},function(){console.log("Error loading tile")})}function tileXYToQuadKey(e,t,i){var n="";for(var r=i;r>0;r--){var o="0";var s=1<<r-1;if((e&s)!=0){o++}if((t&s)!=0){o++;o++}n+=o}return n}function generateTileImageUrl(e){var t=e.original_url,i=e.coord,n=e.zoom,r=e.layer,o=e.subdomains,s=e.gctms,a=i.x,l=i.y,c,u,d=bounds.max/(1<<n);if(s){l=Math.pow(2,n)-l-1}if(bounds.zoomOffset){n+=bounds.zoomOffset}c=bounds.xmin+d*a,u=bounds.ymax-d*l;if(o){t=t[0].replace("{s}",o[(a+l)%o.length])}else{t=t[(i.x+i.y)%t.length]}t=t.replace(/{x}/g,a).replace(/{y}/g,l).replace(/{z}/g,n).replace(/\$x1/g,c).replace(/\$y1/g,u-d).replace(/\$x2/g,c+d).replace(/\$y2/g,u).replace(/\$id/g,n).replace(/\$nx/g,a).replace(/\$ny/g,l).replace(/{q}/g,tileXYToQuadKey(a,l,n));if(r.proxyServer){t=r.proxyServer.replace("{url}",encodeURIComponent(t)).replace("{mid}",e.map_id);e.usingProxy=true}e.url=t}function sendRequests(){var e,t;while(e=tile_req.shift()){if(!e.tile||!e.tile.gc_state||!tile_request[e.uri]){e.tile=null;if(tile_request[e.uri]){delete tile_request[e.uri]}continue}e.that.parent.viewer.increaseTileCounter(e.tile);if(e.isImage){imageTileLoader(e);e.tile=null;continue}t="";var i=giscloud.tile_token+":";i="";if(tile_request[e.uri].attribs.length>0){t=tile_request[e.uri].attribs.filter(function(e,t,i){return i.indexOf(e)==t});t=t.join(",")+"/"}if(e.that.url2){e.url=e.that.url2+i+tile_request[e.uri].timestamps.join(",")+"/"+e.that.mid+"/"+tile_request[e.uri].layers.join(",")+"/"+t+e.uri_for_request+".json";vectorTileLoader(e)}else if(e.that.url3){e.url=e.that.url3+i+tile_request[e.uri].timestamps.join(",")+"/"+e.that.mid+"/"+tile_request[e.uri].layers.join(",")+"/dyn,"+e.that.t+"/"+t+e.uri_for_request+".json";vectorTileLoader(e)}e.tile=null}}function _loadTile(e,t,i,n){var r="";var o=null;var s=e.gc_state;var a=n.parent;var l=false;s.feature_attributes="";if(n.feature_attributes||n.parent.labels||n.parent.labelData&&n.parent.labelData.attribute){s.feature_attributes=n.feature_attributes;o=n.feature_attributes.split(",")}else{if(flashnavigator.newLabelingMode){s.feature_attributes_array=null;if(n.parent.group){s.feature_attributes=n.parent.group.map(function(e){return e.labelData.attribute}).filter(function(e,t,i){return i.indexOf(e)===t}).filter(function(e){return!!e}).join(",")||""}if(s.feature_attributes&&s.feature_attributes.length>0){o=s.feature_attributes.split(",");s.feature_attributes_array=o}}else{s.feature_attributes=""}}s.uri_for_request=r+i+"/"+t.x+"/"+t.y;r+=s._tileIndex+"/"+n.mid;s.obj=n;e.zoom=i;e.coord=t;s._loader_id=loader_id;e.uri=r;s.number_of_requests=0;if(a.group){var c=[];var u=[];var d,f;for(var h=0;h<a.group.length;h++){d=a.group[h];if(a._tileShouldBeLoaded(t,d)){l=true;if(e.gc_state.by_layer[d.id])delete e.gc_state.by_layer[d.id];if(d.isImage){var p="image_layer/"+r+"/"+d.id;if((d.viewer.epsg==="3857"||d.viewer.epsg==="900913")&&d.source.zoomOffset){i-=d.source.zoomOffset}tile_req_seq++;tile_request[p]={seq:tile_req_seq,tiles:[e]};f={isImage:true,coord:{x:t.x,y:t.y},zoom:i,gctms:d.options.gctms,subdomains:d.options.subdomains,tile:e,gc_state:e.gc_state,that:n,original_url:d._url,uri:p,map_id:n.mid.replace("map",""),layer:d,clip:{}};if(t.x==d.tileIndexXMin){f.clip.left=Math.round((d.tileIndexXMinFloat-d.tileIndexXMin)*256*flashnavigator.scaleRatio)}if(t.y==d.tileIndexYMin){f.clip.top=Math.round((d.tileIndexYMinFloat-d.tileIndexYMin)*256*flashnavigator.scaleRatio)}if(t.x==d.tileIndexXMax){f.clip.right=Math.round((d.tileIndexXMaxFloat-d.tileIndexXMax)*256*flashnavigator.scaleRatio)}if(t.y==d.tileIndexYMax){f.clip.bottom=Math.round((d.tileIndexYMaxFloat-d.tileIndexYMax)*256*flashnavigator.scaleRatio)}tile_req.push(f)}else{c.push(d.options.id);u.push(d.options.modified)}}}if(c.length==0){s.will_load_vectors=false;return l}s.will_load_vectors=true;n.lid=c.join(",");n.modified=u.join(",")}else{l=true;e.gc_state.by_layer[n.lid]=null}if(!tile_request[r]){var g={coord:t,tile:e,gc_state:e.gc_state,that:n,uri:r,uri_for_request:e.gc_state.uri_for_request};tile_req_seq++;tile_request[r]={tiles:[],layers:[],timestamps:[],attribs:[],seq:tile_req_seq,present:{}};tile_req.push(g)}if(!tile_request[r].present[n.lid]){tile_request[r].tiles.push(e);tile_request[r].layers.push(n.lid);tile_request[r].timestamps.push(n.modified);tile_request[r].present[n.lid]=true;if(o){tile_request[r].attribs=o.concat(tile_request[r].attribs)}}return l}function checkAttributesAndReload(t){var i=false;var n;var r=t._tiles;var e=Object.keys(r);var o=t.gcmap.feature_attributes;e.forEach(function(e){n=r[e];if(o!==n.gc_state.feature_attributes){_loadTile(n,n.coord,n.zoom,t.gcmap);i=true}});if(i){t.gcmap.Html5SendRequests()}return i}function processGroupTiles(e,t,i,n,r){var o=e.tiles[i],s,a;if(!o){return 0}var l,c=o.gc_state.obj.parent,u,d,f,h=o.gc_state,p=r?[t]:t,g=[],m=e.layers[i].split(",");for(f=0;f<m.length;f++){g[m[f]]=p[n+f]}d=h._drawn;h._drawn=false;h._entire_tile_draw=true;h._rect=rectCreate(o.gc_state);if(!d){h._invalidateRect=null;h._calculateInvalidateRect=true;a=!o.getContext;if(a){s=o;o=getCanvasFromPool(h._width,h._height);o.gc_state=h;o._layer=s._layer}}for(f=0;f<c.group.length;f++){var v=c.group[f];if(v.isImage&&!d){h.layer=v.id;h.curLayerObj=v;drawImageInternal(o);h._drawn=false;continue}u=g[v.id];if(u===0){if(o._layer.neighbour_tile_data&&o._layer.neighbour_tile_data[h._tileIndex]&&o._layer.neighbour_tile_data[h._tileIndex][v.id]){var y=v.features[0].type;if(y=="point"){u={tile:{type:"point",data:[]}}}if(y=="label"||y=="text"){u={tile:{type:"text",data:[]}}}}else{if(!h.by_layer[v.id])h.by_layer[v.id]={};h.by_layer[v.id]._isEmpty=true}}if(u){h.layer=v.id;h.curLayerObj=v;drawTile(o,u,v,d);h._drawn=false}}h._drawn=true;if(d){redrawSingleTile(h.obj.parent,o,null,false)}else{renderTile(o)}if(a){releaseCanvasToPool(o);o=s}redrawNeighbourTiles(o);if(flashnavigator.inOffscreenRenderingWorker){workerRenderTiles(c)}return m.length}var worker=null;var layers_by_id={};function workerResetLoaders(e){worker.postMessage({msg:"tile_load_reset"})}function workerAbortRequest(e){worker.postMessage({msg:"tile_abort_request",tile_layer_id:e.gc_state.obj.tileLayer.id,tile_index:e.gc_state._tileIndex,loading_uri:e.gc_state.current_loading_uri})}function workerHandlerUpdateScaleRatio(){worker.postMessage({msg:"update_scale_ratio",scaleRatio:flashnavigator.scaleRatio})}function workerHandler(e){e.data.msg==="mouse_position_done"&&workerProcessMousePositionHandler(e);e.data.msg==="tile_load_done"&&workerHandlerTileLoad(e);e.data.msg==="tile_render"&&workerHandlerTileRender(e);e.data.msg==="tile_on_error"&&workerHandlerTileOnError(e);e.data.msg==="return_feature_ids"&&workerHandlerFeatureIds(e)}if(flashnavigator.offscreenRendering){var workerUrl=common.assetsSite()+"assets/api/1/offscreen_rendering_worker.js?nch="+giscloud_config.nch;var workerUrlObj=URL.createObjectURL(new Blob(["importScripts('"+workerUrl+"');"],{type:"text/javascript"}));worker=new Worker(workerUrlObj);URL.revokeObjectURL(workerUrlObj);worker.addEventListener("message",workerHandler)}function workerLoader(e){var t=tile_request[e.uri],i=t.tiles,n={},r=[],o=e.tile,s;i.forEach(function(e){prepareTileForTransfer(e,o,r)});for(s in t){n[s]=t[s]}n.tiles=[];var a=o.gc_state;if(!a.current_loading_uri){a.current_loading_uri={}}a.current_loading_uri[e.uri]=1;e.msg="tile_load";e.tile_request=n;e.tile_data=r;e.loading_uri=e.uri;e.gc_state=null;e.tile=null;worker.postMessage(e);tile_request[e.uri]=null}function workerImageLoader(e,t,i,n,r){var o;for(o in tile_request_for_uri){tile_request_transfer[o]=tile_request_for_uri[o]}tile_request_transfer.tiles=[];worker.postMessage({msg:"tile_image_load",url:t,tile_request:tile_request_transfer,uri:r});tile_request[r]=null}function prepareTileForTransfer(e,t,i){var n={},r=e.gc_state,o;for(o in r){n[o]=r[o]}n.obj=r.obj.parent.id;if(r.viewerTile){delete n.viewerTile;r.viewerTile.isLoaded=false}if(n._canvas){delete n._canvas}if(n.gc_layer){delete n.gc_layer}if(e===t)n.isDest=1;i.push(n)}function workerHandlerTileRender(e){var s=e.data.bitmaps,t=layers_by_id[e.data.layer_id],a=t.viewer;requestAnimationFrame(function(){var e,t,i,n,r,o=s.length;for(n=0;n<o;n++){t=s[n];r=layers_by_id[t.layer];e=r._tiles[t.tileIndex];if(!e||e.transferToAnotherViewer)continue;if(!r.render(e,t.bitmap,{xmin:t.x,ymin:t.y})){i=e.getContext("2d",flashnavigator.canvasOptions);i.clearRect(t.x,t.y,t.width,t.height);i.drawImage(t.bitmap,0,0,t.width,t.height,t.x,t.y,t.width,t.height)}}if(a&&a.onRender){a.onRender()}})}function workerHandlerTileLoad(e){var t=layers_by_id[e.data.layer]._tiles[e.data.tileIndex];if(t&&t.ontileload){requestAnimationFrame(function(){t.ontileload(e.data.number_of_image_requests)})}}function workerUnloadTile(e,t,i){worker.postMessage({msg:"remove_tiles",layer:e,tileIndex:t,cache_id:i})}function workerHandlerTileOnError(e){var t,i=layers_by_id[e.data.layer_id];if(!i)return;t=i._tiles[e.data.tile_index];if(t&&i.viewerLayer._layer._tileOnError){i.viewerLayer._layer._tileOnError.call(t)}}function workerModifyObject(e,t,i,n,r,o,s){worker.postMessage({msg:"modify_object",invoked_layer:e,feature_list:t,style:i,layer_id:n,clear:r,e:o,f:s})}var get_feature_ids_handlers={};var get_feature_ids_handlers_index=0;function workerGetFeatureIds(e,t,i,n){get_feature_ids_handlers[get_feature_ids_handlers_index]=n;worker.postMessage({msg:"get_feature_ids",layer_id:e,tile_layer_id:t,tile_indexes:i,handler_index:get_feature_ids_handlers_index});get_feature_ids_handlers_index++}function workerHandlerFeatureIds(e){if(get_feature_ids_handlers[e.data.handler_index]){get_feature_ids_handlers[e.data.handler_index](e.data.layer_id,e.data.fids);delete get_feature_ids_handlers[e.data.handler_index]}}function workerStoreTileToCache(e,t,i){worker.postMessage({msg:"store_tile_cache",layer_id:e,tile_index:t,cache_id:i})}function workerRestoreTileFromCache(e,t,i,n){worker.postMessage({msg:"restore_tile_cache",layer_id:e,tile_index:t,cache_id:i,wrap:n})}function workerWrapTiles(e,t){worker.postMessage({msg:"wrap_tiles",layer_id:e,wrapDelta:t})}function workerSyncLayers(){var e=[],t=prepareLayerDataForWorkers(flashnavigator.layers,e);worker.postMessage({msg:"init",layer_data:t,map_id:flashnavigator.map_id,bounds:bounds,offline_mode:giscloud.offlineMode(),isMobileBrowser:common.isMobileBrowser,canvasOptions:flashnavigator.canvasOptions,scaleRatio:flashnavigator.scaleRatio},e)}function prepareLayerDataForWorkers(e,t){var i={},n,r,o,s,a,l,c,u;layers_by_id={};e.forEach(function(e){if(!(e instanceof fnTileLayerGroup||e instanceof fnTileLayer))return;layers_by_id[e.id]=e;o=[];if(e.features){e.features.forEach(function(e){s={};for(u in e){s[u]=e[u]}if(s.icon_image){a=s.icon_image;l=new OffscreenCanvas(a.width,a.height);c=l.getContext("2d",flashnavigator.canvasOptions);c.drawImage(a,0,0,a.width,a.height);try{s.icon_image=l.transferToImageBitmap();t.push(s.icon_image)}catch(e){s.icon_image=null}}o.push(s)})}if(e.isRootLayer){n=e.tileLayer;r=n.group.map(function(e){return e.id});layers_by_id[n.id]=n;i[n.id]={id:n.id,gcmap:{activeLayer:null,lid_map:{},modifier:n.gcmap.modifier},group:r,neighbour_tile_data:{},options:{},layer_info:{}}}i[e.id]={id:e.id,isGroupLayer:e.isGroupLayer,isRasterLayer:e.isRasterLayer,isImage:e.isImage,source:{src:e.source.src},zoomThreshold:e.zoomThreshold,visible:e.visible,groupId:e.groupId,features:o,featuresVisibility:e.featuresVisibility,has_inner_line:e.has_inner_line,_selectable:e._selectable,neighbour_tile_data:{},proxyServer:e.proxyServer,proxyServerAvailable:e.proxyServerAvailable,options:{opacity:e.options.opacity,visible:e.options.visible},layer_info:{hiddenGeometry:e.layer_info&&e.layer_info.hiddenGeometry}};if(e.gcmap){i[e.id].gcmap={activeLayer:null,lid_map:{},modifier:e.gcmap.modifier}}});return i}function workerLayerSetFilter(e,t){var i={},n,r=null,o=null,s;for(s in t){i[s]=t[s]}if(i.filter){n=i.filter.toString();r=n.slice(n.indexOf("{")+1,n.lastIndexOf("}"));o=n.slice(n.indexOf("(")+1,n.indexOf(")")).split(",");i.filter=null}worker.postMessage({msg:"layer_set_filter",id:e,filter:i,func_body:r,func_args:o})}function workerRedrawLayer(e,t,i){worker.postMessage({msg:"layer_redraw",layer_id:e.id,reload_styles:t,tiles_filter:i})}function workerLayerUpdate(e,t){worker.postMessage({msg:"layer_update",id:e,params:t})}function workerResetGroup(e,t){worker.postMessage({msg:"reset_group",group:t,layer:e})}function workerUnloadTiles(e){worker.postMessage({msg:"layer_unload_tiles",layer:e})}function workerLayerRemove(e){worker.postMessage({msg:"layer_remove",layer_id:e})}function workerCanvasPoolCleanUp(){worker.postMessage({msg:"canvas_pool_cleanup"})}var mouse_events_handlers=[];function workerProcessMousePositionHandler(e){var t;while(t=mouse_events_handlers.shift()){t.event.showMousePointer=e.data.showMousePointer;t.event.hoveredObject=e.data.hoveredObject;t.callback(t.event)}}function workerProcessMousePosition(e,t,i,n,r){var o={showMousePointer:e.showMousePointer,offsetX:e.offsetX,offsetY:e.offsetY,layerX:e.layerX,layerY:e.layerY};mouse_events_handlers.push({event:e,callback:r});worker.postMessage({msg:"process_mouse_position",evt:o,tileIndex:t,selectionEnabled:n})}function workerCheckEvents(e,t,i,n,r){worker.postMessage({msg:"tile_check_events",x:t,y:i,delta:r,layer:e.layer,selectionEnabled:selectionEnabled,tileIndex:e._tileIndex})}initTileCache();this.html5ResetLoaders=resetLoaders};var canvas_pool=[];var canvas_create=0;var canvas_delete=0;var canvas_pool_size=0;var active_canvas=0;var same_size=0;var diff_size=0;function getCanvasPoolStats(){return"canvas_pool"+"\nactive\t\t\t"+active_canvas+"\nfree pool\t\t"+canvas_pool.length+"\ntotal pool\t\t"+canvas_pool_size+"\n% free\t\t\t"+Math.round(canvas_pool.length/canvas_pool_size*100)+"%"+"\ncreated\t\t\t"+canvas_create+"\ndeleted\t\t\t"+canvas_delete+"\nsame size\t\t"+same_size+"\ndiff size\t\t"+diff_size}function getCanvasFromPool(e,t,i){var n=canvas_pool.length,r;active_canvas++;if(n>0){var o=Infinity,s=0,a,l;for(l=n-1;l>=0;l--){r=canvas_pool[l];if(r.width===e&&r.height===t){canvas_pool.splice(l,1);r.reused=true;same_size++;canvas_pool_size--;r._inPool=false;return r}else{a=Math.abs(r.width-e)+Math.abs(r.height-t);if(a<o){o=a;s=l}}}diff_size++;r=canvas_pool.splice(s,1)[0];r.reused=false;r.width=e;r.height=t;canvas_pool_size--;r._inPool=false;return r}canvas_create++;if(self.flashnavigator&&flashnavigator.inOffscreenRenderingWorker){r=new OffscreenCanvas(e,t)}else{r=document.createElement("canvas");r.width=e;r.height=t}r.reused=i;r._inPool=false;return r}function releaseCanvasToPool(e){if(!e||e._inPool){return}if(e.inCache){e.activeCache=false;return}if(!e.reused&&0){e.width=0;e.height=0;delete e;e=null;active_canvas--;return}if(canvas_pool.length>200){canvasPoolCleanUp(200)}var t=e.getContext("2d");t.setTransform(1,0,0,1,0,0);t.clearRect(0,0,e.width,e.height);t=null;e._aborted=false;e.gc_state=null;e._inPool=true;canvas_pool.push(e);canvas_pool_size++;active_canvas--}function canvasPoolCleanUp(e){var t=canvas_pool.length,i,n,r;if(!e)e=25;if(t>e){i=Math.round(t*.25);r=0;while(r<t&&i>0){n=canvas_pool[r];if(!n.reused){n.width=0;n.height=0;delete n;n=null;canvas_pool.splice(r,1);canvas_pool_size--;i--;t--}else{r++}}while(i>0){canvas_delete++;n=canvas_pool.pop();n.width=0;n.height=0;delete n;n=null;canvas_pool_size--;i--}}}var fnPrinter2=function(e){};var fnBitmap2=function(e){};var fnSlider2=function(e){};flashnavigator2={};flashnavigator2.legacyObjects={fnLayer:{},fnMarker:{},fnAgent:{},fnCanvas:{},fnPrinter:{},fnBitmap:{},fnTooltip:{},fnSlider:{},fnKartehr:{},fnViewer:{}};flashnavigator2.html5=true;flashnavigator2.include=function(){};flashnavigator2.setOptions=function(e){flashnavigator2.extraOptions=e};flashnavigator2.initViewer=function(e,t,i,n){if(internalViewers[e]){lv=internalViewers[e];n();return}var r={maxZoom:25,zoom:0,latloncrs:true,center:new giscloud.LonLat(0,0),host:giscloud_tile_url,background:"#fff",attribution:{prefix:"Powered by <a href='https://www.giscloud.com/' target='_blank'>GIS Cloud</a>"}};if(flashnavigator2.extraOptions&&flashnavigator2.extraOptions.lockZoom){r.lockZoom=true}if(flashnavigator2.extraOptions&&flashnavigator2.extraOptions.hideZoomButtons){r.hideZoomButtons=true}if(e=="3D"){lv=new common.ViewerMapbox(t,i,r)}else if(e=="2D"){lv=new common.ViewerLeaflet(t,i,r)}internalViewers[e]=lv;lv.attribution=r.attribution.prefix;if(n){lv.init.done(n)}};flashnavigator2.container=function(e,t,i){viewerContainer=$("#"+t);if(["absolute","relative","fixed"].indexOf(viewerContainer.css("position"))===-1){viewerContainer.css("position","relative")}this.initViewer(e.mode,e,t);lv.onViewerLoad=i;lv.init.done(function(){lv.setZIndex(2);init();lv.onViewerLoad.onLoad()})};units=new Array;units_label=new Array;var mtopx=3779.527559055;units["meter"]=mtopx;units_label["meter"]="m";units["kilometer"]=mtopx*1e3;units_label["kilometer"]="km";units["centimeter"]=mtopx*.01;units_label["centimeter"]="cm";units["degree"]=mtopx*111319.49079327357;units_label["degree"]="°";units["foot"]=mtopx*.3048;units_label["foot"]="ft";units["foot_us"]=mtopx*.30480061;units_label["foot_us"]="ft";units["mile"]=mtopx*1609.344;units_label["mile"]="m";units["inch"]=mtopx*.0254;units_label["mile"]='"';units["yard"]=mtopx*.9144;units["link_ben"]=mtopx*.201167651;units["link_srs"]=mtopx*.201167651;units["ind_yard"]=mtopx*.914398554;units["srs_yard"]=mtopx*.914398415;units["fathom"]=mtopx*1.8288;unitFactor=units["meter"];unit="meter";function calculateImageColor(e){try{var t=e.icon_image;var i=document.createElement("canvas");i.width=t.width;i.height=t.height;var n=i.getContext("2d",flashnavigator.canvasOptions);n.drawImage(t,0,0);var r=n.getImageData(0,0,i.width,i.height);var o=r.data;var s=0,a=0,l=0;var c=0;for(var u=0,d=o.length;u<d;u+=4){if(o[u+3]>0){s+=o[u];a+=o[u+1];l+=o[u+2];c++}}return giscloud.Color.rgbToHex(Math.floor(s/c),Math.floor(a/c),Math.floor(l/c))}catch(e){return giscloud.Color.rgbToHex(255,255,255)}}function loadGeneratedSymbol(e,t){var i,n,r,o,s;s=parseInt(t.bw)*flashnavigator.scaleRatio;o=parseInt(t.size)*flashnavigator.scaleRatio;if(isNaN(s)){s=0}if(t.type==="circle")o+=4*flashnavigator.scaleRatio;else if(t.type==="box")o+=s*flashnavigator.scaleRatio;r=o+s*2;i=document.createElement("canvas");i.width=r;i.height=r;n=i.getContext("2d",flashnavigator.canvasOptions);n.beginPath();if(t.type==="circle"){n.arc(r/2,r/2,Math.ceil(o/2)+s/2-2,0,2*Math.PI,false)}else if(t.type==="box"){n.rect(s,s,o,o)}n.fillStyle="rgb("+t.color+")";n.fill();if(s>0){n.lineWidth=s;n.strokeStyle="rgb("+t.border+")";n.stroke()}e.generated=true;e.src=i.toDataURL()}function loadSymbol(e,t){var i,n=null,r;i=decodeURIComponent(t);if(i.match(/.*\/assets\/icon.php\?.*p=\/icons\/defaulticon.png/)){n={bw:1,size:7,type:"circle",color:"255, 51, 0",border:"0,0,0"}}else if(i.match(/.*\/assets\/icon.php\?.*type=.*size=/)){r=i.split("?")[1].split("&");n={};r.forEach(function(e){e=e.split("=");n[e[0]]=e[1]});if(n.type!=="circle"&&n.type!=="box"){n=null}}if(n){loadGeneratedSymbol(e,n)}else{e.crossOrigin="Anonymous";e.src=t}}flashnavigator=flashnavigator2;flashnavigator.html5Compatible=true;flashnavigator.hasCanvas=true;flashnavigator.hasCanvasInitialValue=flashnavigator.hasCanvas;flashnavigator.ready=function(){flashnavigator.legacyObjects.fnLayer=fnLayer2;flashnavigator.legacyObjects.fnMarker=fnMarker2;flashnavigator.legacyObjects.fnAgent=fnAgent2;flashnavigator.legacyObjects.fnCanvas=fnCanvas2;flashnavigator.legacyObjects.fnPrinter=fnPrinter2;flashnavigator.legacyObjects.fnBitmap=fnBitmap2;flashnavigator.legacyObjects.fnTooltip=fnTooltip2;flashnavigator.legacyObjects.fnSlider=fnSlider2;flashnavigator.legacyObjects.fnKartehr=function(){this.liveSite=function(){}}};flashnavigator.legacyObjects.fnViewer=fnViewer2;flashnavigator.html5Enabled=true;flashnavigator.exposeLegacyObjectsInto=function e(t){var i,n=t||{};for(i in this.legacyObjects){n[i]=this.legacyObjects[i]}return n}})(window,giscloud.exposeJQuery(),gcCommon());return flashnavigator}})(window,giscloud,giscloud.common);(function(e,t){giscloud.rest={get:e.proxy(t.rest.get,t.rest)}})(giscloud.exposeJQuery(),giscloud.common());(function(s,a,l,c){var e,u,d,f,h,p,n,g,r,m=false,o=false,t=false;try{t=s!==s.parent&&s.parent.giscloud&&s.parent.giscloud.oauth2&&s.name===s.parent.giscloud.oauth2.frameId()}catch(e){}if(t){if(document.location.search.indexOf("error=redirect_uri_mismatch")>-1){s.parent.giscloud.oauth2.uriMismatch(document.location)}else{e=document.location.href.match(/access_token=(\w+)/);u=e&&e[1];s.parent.giscloud.oauth2.setToken(u,document.location)}}else if(document.location.search.indexOf("error=redirect_uri_mismatch")>-1){s.parent.giscloud.oauth2.uriMismatch(document.location)}else{d=l.authHost();giscloud.oauth2={token:function(e){if(e){u=e;return this}else{return u}},frameId:function(){return g},authorize:function(e,t,i){var n,r,o=l.oid();f=t;if(!m){giscloud.includeCss(l.apiHost()+"/assets/api/1/auth.css");m=true}if(u===c||u===null){h="win_"+o;g="frame_"+h;r=(s.location.protocol=="https:"?"https:":"http:")+"//"+s.location.hostname+s.location.pathname;p=d+"/oauth/authorize?client_id="+e+"&redirect_uri="+r+"?nch="+Math.random()+"&response_type=token&fr="+g;n=a('<iframe name="'+g+'" id="'+g+'" style="position:absolute;visibility:hidden;width:1px;height:1px;"></iframe>');if(i!==c){n.one("load",i)}a("body").append(n);n.attr("src",p+"&authorize=true")}return this},signIn:function(e){var t,i;e=e||{};if(typeof e.template==="string"){i=p+"&template="+e.template}else{i=p}t="status=1, toolbar=1,  width=450, height=400";n=s.open(i,h,t)},signOut:function(e){var t,i;t=a("#"+g);i=new a.Deferred;if(typeof e=="function"){i.done(e)}u=null;t.one("load",function(){i.resolve()});t.attr("src",d+"/oauth/sign_out?redirect_uri="+s.location.href);return i.promise()},setToken:function(e,t){u=e;if(n){n.close();n=null}if(typeof f=="function"){f(u)}if(t){t.href=d+"/oauth/blank"}this.button(r)},uriMismatch:function(e){o=true;if(e){e.href=d+"/oauth/blank"}if(typeof f=="function"){f()}},thisIsOauthFrame:function(){return t},button:function(e,t){var i,n;r=e;i=a("<div/>",{class:"gc-auth-button"});if(o){i.addClass("gc-redirect-uri-mismatch");i.append("This is not a registered<br/>GIS Cloud app.")}else if(u){i.addClass("gc-authorized");i.append("You are signed in. <a href='#'>Sign out.</a>");i.click(function(e){giscloud.oauth2.signOut();e.preventDefault()})}else{i.click(function(e){giscloud.oauth2.signIn(t);e.preventDefault()})}if(e){n=a("#"+e);if(n.length){n.html("");n.append(i)}return this}else{return i}}}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(o){giscloud.LonLat=function(e,t){if(e instanceof giscloud.LonLat){this.lon=e.lon;this.lat=e.lat}else{this.lon=isNaN(e)?null:e;this.lat=isNaN(t)?null:t}};giscloud.LonLat.prototype={toArray:function(){return[this.lon,this.lat]},toString:function(e){var t;if(e!==undefined){t=Math.pow(10,e);return Math.round(this.lon*t)/t+", "+Math.round(this.lat*t)/t}else{return this.lon+", "+this.lat}},clone:function(){return new giscloud.LonLat(this)},transform:function(e,t){var i,n,r;if(!giscloud.proj4){console.warn("Proj4js library is missing.");return this}if(typeof e==="number"){n="EPSG:"+e}else{n=e}if(!n){console.warn("Source projection is not ready to use.",n);return this}if(typeof t==="number"){r="EPSG:"+t}else{r=t}if(!r){console.warn("Destination projection is not ready to use.",r);return this}i={x:this.lon,y:this.lat},i=giscloud.proj4(n,r,i);this.lon=i.x;this.lat=i.y;return this},toBounds:function(e){e=isNaN(e)||e===null?0:e;return new giscloud.Bounds(this.lon-e,this.lat-e,this.lon+e,this.lat+e)},equals:function(e){return e instanceof giscloud.LonLat&&this.lon===e.lon&&this.lat===e.lat},valid:function(){return!(isNaN(this.lon)||isNaN(this.lat))}};giscloud.LonLat.parse=function(e){var t;if(typeof e==="string"){t=e.split(",");if(t.length===2){return new giscloud.LonLat(parseFloat(t[0]),parseFloat(t[1]))}}return null};giscloud.Bounds=function(e,t,i,n){var r;if(e instanceof giscloud.Bounds){this.left=e.left;this.bottom=e.bottom;this.right=e.right;this.top=e.top}else if(o.isArray(e)&&e.length){r=giscloud.Bounds.fromBounds(e);if(!r.valid())return;this.left=r.left;this.bottom=r.bottom;this.right=r.right;this.top=r.top}else{this.left=typeof e==="number"?e:parseFloat(e);this.bottom=typeof t==="number"?t:parseFloat(t);this.right=typeof i==="number"?i:parseFloat(i);this.top=typeof n==="number"?n:parseFloat(n)}};giscloud.Bounds.prototype={width:function(e,t){var i,n,r;if(e==null){if(isFinite(this.left)&&isFinite(this.right)){return Math.abs(this.right-this.left)}else{return null}}if(isFinite(this.left)&&isFinite(this.right)){i=Math.abs(this.right-this.left);n=(e-i)/2;this.left=this.left-n;this.right=this.right+n;if(t){r=this.height();this.height(r*e/i)}}return this},height:function(e,t){var i,n,r;if(e==null){if(isFinite(this.top)&&isFinite(this.bottom)){return Math.abs(this.top-this.bottom)}else{return null}}if(isFinite(this.top)&&isFinite(this.bottom)){i=Math.abs(this.top-this.bottom);n=(e-i)/2;this.bottom=this.bottom-n;this.top=this.top+n;if(t){r=this.width();this.width(r*e/i)}}return this},center:function(e){var t,i,n,r,o;if(this.isPoint()){if(e==null){return new giscloud.LonLat(this.left,this.bottom)}else{this.left=this.right=e.lon;this.top=this.bottom=e.lat;return this}}else{t=this.width();i=this.height();n=new giscloud.LonLat(this.left+t/2,this.bottom+i/2);if(e==null){return n}else{r=e.lon-n.lon;o=e.lat-n.lat;this.left+=r;this.right+=r;this.top+=o;this.bottom+=o;return this}}},isPoint:function(){return this.left===this.right&&this.top===this.bottom},valid:function(){return!(isNaN(this.left)||isNaN(this.bottom)||isNaN(this.right)||isNaN(this.top))},include:function(e,t){t=isNaN(t)||t===null?0:t;if(e instanceof giscloud.LonLat){this.left=Math.min(e.lon-t,this.left);this.bottom=Math.min(e.lat-t,this.bottom);this.right=Math.max(e.lon+t,this.right);this.top=Math.max(e.lat+t,this.top)}else if(e instanceof giscloud.Bounds){this.left=Math.min(e.left-t,this.left);this.bottom=Math.min(e.bottom-t,this.bottom);this.right=Math.max(e.right+t,this.right);this.top=Math.max(e.top+t,this.top)}return this},clone:function(){return new giscloud.Bounds(this)},toArray:function(){return[this.left,this.bottom,this.right,this.top]},toString:function(e){var t;if(e!==undefined){t=Math.pow(10,e);return Math.round(this.left*t)/t+", "+Math.round(this.bottom*t)/t+Math.round(this.right*t)/t+", "+Math.round(this.top*t)/t}else{return this.left+", "+this.bottom+", "+this.right+", "+this.top}}};giscloud.Bounds.parse=function(e){var t;if(typeof e==="string"){t=e.split(",");if(t.length===4){return new giscloud.Bounds(parseFloat(t[0]),parseFloat(t[1]),parseFloat(t[2]),parseFloat(t[3]))}}return null};giscloud.Bounds.fromBounds=function(e){var t,i,n;if(!e)return new giscloud.Bounds;if(e instanceof giscloud.Bounds)return new giscloud.Bounds(e);if(o.isArray(e)){n=new giscloud.Bounds;for(t=0,i=e.length;t<i;t++){if(!n.valid()){n=new giscloud.Bounds(e[t])}else{n.left=Math.min(n.left,e[t].left);n.bottom=Math.min(n.bottom,e[t].bottom);n.right=Math.max(n.right,e[t].right);n.top=Math.max(n.top,e[t].top)}}return n}return new giscloud.Bounds(e.left,e.bottom,e.right,e.top)}})(giscloud.exposeJQuery());(function(){var e;giscloud.geometry={Point:function(e,t,i){this.x=e;this.y=t;if(i!=null){this.z=i}},Multipoint:function(e){this.points=e},Line:function(e){this.points=e},Multiline:function(e){this.lines=e},Polygon:function(e){this.rings=e},Multipolygon:function(e){this.polygons=e},GeometryCollection:function(e){this.geometries=e},hasZ:function(e){var t,i;if(e instanceof giscloud.geometry.Point&&e.x!=null&&e.y!=null){return e.z!=null}else if(e instanceof giscloud.geometry.Multipoint&&e.points!=null){for(t=0,i=e.points.length;t<i;t++){if(e.points[t].hasZ()){return true}}return false}else if(e instanceof giscloud.geometry.Line&&e.points!=null){for(t=0,i=e.points.length;t<i;t++){if(e.points[t].hasZ()){return true}}return false}else if(e instanceof giscloud.geometry.Multiline&&e.lines!=null){for(t=0,i=e.lines.length;t<i;t++){if(e.lines[t].hasZ()){return true}}return false}else if(e instanceof giscloud.geometry.Polygon&&e.rings!=null){for(t=0,i=e.rings.length;t<i;t++){if(e.rings[t].hasZ()){return true}}return false}else if(e instanceof giscloud.geometry.Multipolygon&&e.polygons!=null){for(t=0,i=e.polygons.length;t<i;t++){if(e.polygons[t].hasZ()){return true}}return false}else if(e instanceof giscloud.geometry.GeometryCollection&&e.geometries!=null){for(t=0,i=e.geometries.length;t<i;t++){if(e.geometries[t].hasZ()){return true}}return false}else{return null}},toOGC:function(e,t){var i,n,r,o,s,a,l,c,u,d,f,h;i=function(e){return t||e.z==null?e.x+" "+e.y:e.x+" "+e.y+" "+e.z};n=function(e){return e.join()};r=function(e){return e.join()};try{if(e instanceof giscloud.geometry.Point&&e.x!=null&&e.y!=null){return"POINT ("+i(e)+")"}else if(e instanceof giscloud.geometry.Multipoint&&e.points!=null){o=[];for(l=0,u=e.points.length;l<u;l++){o.push("("+i(e.points[l])+")")}return"MULTIPOINT ("+o.join()+")"}else if(e instanceof giscloud.geometry.Line&&e.points!=null){o=[];for(l=0,u=e.points.length;l<u;l++){o.push(i(e.points[l]))}return"LINESTRING ("+n(o)+")"}else if(e instanceof giscloud.geometry.Multiline&&e.lines!=null){o=[];for(l=0,u=e.lines.length;l<u;l++){s=[];for(c=0,d=e.lines[l].points.length;c<d;c++){s.push(i(e.lines[l].points[c]))}o.push("("+n(s)+")")}return"MULTILINESTRING ("+n(o)+")"}else if(e instanceof giscloud.geometry.Polygon&&e.rings!=null){o=[];for(l=0,u=e.rings.length;l<u;l++){s=[];for(c=0,d=e.rings[l].points.length;c<d;c++){s.push(i(e.rings[l].points[c]))}s.push(i(e.rings[l].points[0]));o.push("("+n(s)+")")}return"POLYGON ("+r(o)+")"}else if(e instanceof giscloud.geometry.Multipolygon&&e.polygons!=null){o=[];for(l=0,d=e.polygons.length;l<d;l++){s=[];for(c=0,f=e.polygons[l].rings.length;c<f;c++){a=[];for(u=0,h=e.polygons[l].rings[c].points.length;u<h;u++){a.push(i(e.polygons[l].rings[c].points[u]))}a.push(i(e.polygons[l].rings[c].points[0]));s.push("("+n(a)+")")}o.push("("+r(s)+")")}return"MULTIPOLYGON ("+o.join()+")"}else if(e instanceof giscloud.geometry.GeometryCollection&&e.geometries!=null){o=[];for(l=0,d=e.geometries.length;l<d;l++){o.push(e.geometries[l].toOGC())}return"GEOMETRYCOLLECTION ("+o.join()+")"}else{return null}}catch(e){return null}},fromOGC:function(e){var n,t,i,r,o,s,a,l,c,u,d,f,h,p,g,m,v,y;r=/^([A-Z]+(?:\s*Z\s*)?)\s?(\([A-Ze\d.,()\s\-]*\))$/;o=e&&e.match&&e.match(r);s=o&&o[1];if(/Z\s*$/.test(s)){s=s.replace(/\s*Z\s*$/,"");i=true}a=o&&o[2]&&o[2].replace(/\s+/g," ").replace(/, /g,",");if(s==null||a==null){return null}if(s==="GEOMETRYCOLLECTION"){o=a.match(/([A-Z]+\s?\([\-\d.e,( )]*\))(?=\s?,|\s?\)\s?$)/g);if(o===null){return[]}l=[];for(n=0,t=o.length;n<t;n++){l.push(giscloud.geometry.fromOGC(o[n]))}return new giscloud.geometry.GeometryCollection(l)}a=a.replace(/([\d.e\-]+ [\d.e\-]+( [\d.e\-]+)?)/g,"[$1]");l=[];n=0;g=function(){var e,t=[""],i=0;while(true){n++;e=a[n];if(e==="]"){break}else if(e===" "){t.push("");i++;if(i>2){throw"Error parsing wkt: invalid value"}}else{t[i]+=e}}return t.length===3?[parseFloat(t[0]),parseFloat(t[1]),parseFloat(t[2])]:[parseFloat(t[0]),parseFloat(t[1])]};p=function(){var e,t=[];while(n<a.length){n++;e=a[n];switch(e){case"(":t.push(p());break;case",":break;case")":return t;case"[":t.push(g());break;default:throw"Error parsing wkt: invalid structure"}}return t};c=o&&p();if(c.length<1){throw"Error parsing wkt: invalid geometry"}m=function(e){if(i&&e.length!==3){throw"Error parsing wkt: invalid geometry"}if(e.length!==2&&e.length!==3){throw"Error parsing wkt: invalid geometry"}return new giscloud.geometry.Point(e[0],e[1],e[2])};v=function(e,t){var i,n,r;if(e.length===0){throw"Error parsing wkt: invalid geometry"}i=[];for(n=0,r=e.length-(t?1:0);n<r;n++){i.push(m(e[n]))}return new giscloud.geometry.Line(i)};y=function(e){var t,i,n;if(e.length===0){throw"Error parsing wkt: invalid geometry"}t=[];for(i=0,n=e.length;i<n;i++){t.push(v(e[i]))}return new giscloud.geometry.Polygon(t)};switch(s){case"POINT":if(c.length>1){throw"Error parsing wkt: invalid point geometry"}return m(c[0]);case"MULTIPOINT":d=[];for(n=0,t=c.length;n<t;n++){if(c[n].length===2||c[n].length===3){d.push(m(c[n]))}else if(c[n].length===1){d.push(m(c[n][0]))}else{throw"Error parsing wkt: invalid geometry"}}return new giscloud.geometry.Multipoint(d);case"LINESTRING":return v(c);case"MULTILINESTRING":f=[];for(n=0,t=c.length;n<t;n++){f.push(v(c[n]))}return new giscloud.geometry.Multiline(f);case"POLYGON":return y(c);case"MULTIPOLYGON":h=[];for(n=0,t=c.length;n<t;n++){h.push(y(c[n]))}return new giscloud.geometry.Multipolygon(h);default:throw"Error parsing wkt: unknown geometry type"}return u},fromGeoJSON:function(e){if(typeof e=="string"){e=JSON.parse(e)}switch(e.type){case"Point":return e.coordinates.length===3?new giscloud.geometry.Point(e.coordinates[0],e.coordinates[1],e.coordinates[2]):new giscloud.geometry.Point(e.coordinates[0],e.coordinates[1]);case"LineString":return new giscloud.geometry.Line($.map(e.coordinates,function(e){return e.length===3?new giscloud.geometry.Point(e[0],e[1],e[2]):new giscloud.geometry.Point(e[0],e[1])}));case"Polygon":return new giscloud.geometry.Polygon($.map(e.coordinates,function(e){return new giscloud.geometry.Line($.map(e,function(e){return e.length===3?new giscloud.geometry.Point(e[0],e[1],e[2]):new giscloud.geometry.Point(e[0],e[1])}))}));default:return null}}};giscloud.Geometry=e=function(){};e.prototype={bounds:function(e){var t,i,n,r;e=e||0;if(this.x&&this.y){return new giscloud.Bounds(this.x-e,this.y-e,this.x+e,this.y+e)}n=this.points||this.lines||this.rings||this.polygons||this.geometries;if(!n||!n.length)return null;r=n[0].bounds();for(t=1,i=n.length;t<i;t++){r.include(n[t].bounds())}return r},toOGC:function(){return giscloud.geometry.toOGC(this)},hasZ:function(){return giscloud.geometry.hasZ(this)}};giscloud.geometry.Point.prototype=new e;giscloud.geometry.Multipoint.prototype=new e;giscloud.geometry.Line.prototype=new e;giscloud.geometry.Multiline.prototype=new e;giscloud.geometry.Polygon.prototype=new e;giscloud.geometry.Multipolygon.prototype=new e;giscloud.geometry.GeometryCollection.prototype=new e})();(function(w){giscloud.Color=function(e,t,i,n){var r,o,s,a,l,u,d,f,h,p,g,m,v,y,_,b;if(e!==w&&typeof e=="number"){if(e>255){r=255}else if(e<0){r=0}else{r=Math.round(e)}v=true;y=true;b=true}else{_=true}if(t!==w&&typeof t=="number"){if(t>255){o=255}else if(t<0){o=0}else{o=Math.round(t)}v=true;y=true;b=true}else{_=true}if(i!==w&&typeof i=="number"){if(i>255){s=255}else if(i<0){s=0}else{s=Math.round(i)}v=true;y=true;b=true}else{_=true}if(n!==w&&typeof n=="number"){if(n>100){a=100}else if(n<0){a=0}else{a=Math.round(n)}}else{a=100}v=true;y=true;b=true;this.hex=function(){var e=arguments[0],t=/^((#)|(0x))?([a-f0-9]{3}$)|([a-f0-9]{6}$)/i,i;if(e&&typeof e=="string"){if(e.match(t)){i=giscloud.Color.hexToRgb(e);r=i[0];o=i[1];s=i[2];v=true;y=true;b=true;return this}else{return giscloud.Color.rgbToHex(this.rgb(),e)}}else{return giscloud.Color.rgbToHex(this.rgb(),e)}};this.rgb=function(){var e,t;if(arguments.length>0){for(e=0;e<3;e++){t=arguments[e];if(t!==w&&t!==null&&typeof t=="number"){if(t>255){t=255}else if(t<0){t=0}else{t=Math.round(t)}switch(e){case 0:r=t;break;case 1:o=t;break;case 2:s=t;break}v=true;y=true;b=true}}return this}else{if(_){if(!v){t=giscloud.Color.hslToRgb(l,u,f)}else if(!y){t=giscloud.Color.hsvToRgb(l,d,h)}else if(!b){t=giscloud.Color.labToRgb(p,g,m)}r=t[0];o=t[1];s=t[2];_=false}return[r,o,s]}};this.rgba=function(){if(arguments.length>0){this.rgb.apply(this,Array.prototype.slice(arguments));if(arguments[3]!=null){this.alpha(arguments[3])}return this}if(_){if(!v){c=giscloud.Color.hslToRgb(l,u,f)}else if(!y){c=giscloud.Color.hsvToRgb(l,d,h)}else if(!b){c=giscloud.Color.labToRgb(p,g,m)}r=c[0];o=c[1];s=c[2];_=false}return[r,o,s,a]};this.hsl=function(e){var t,i;if(arguments.length===3){for(t=0;t<3;t++){i=arguments[t];if(i!==w&&i!==null&&typeof i=="number"){if(t===0){if(i>=360){i-=360}else if(i<0){i+=360}else{i=Math.round(i)}l=i}else{if(i>100){i=100}else if(i<0){i=0}if(t===1){u=i}else{f=i}}_=true;y=true;b=true}}v=false;return this}else{if(v){if(!_){i=giscloud.Color.rgbToHsl(r,o,s)}else if(!y){i=giscloud.Color.hsvToHsl(l,d,h)}else if(!b){i=giscloud.Color.labToHsl(p,g,m)}l=i[0];u=i[1];f=i[2];v=false}if(e){return[Math.round(l),Math.round(u),Math.round(f)]}else{return[l,u,f]}}};this.hsv=function(e){var t,i;if(arguments.length===3){for(t=0;t<3;t++){i=arguments[t];if(i!==w&&i!==null&&typeof i=="number"){if(t===0){if(i>=360){i-=360}else if(i<0){i+=360}else{i=Math.round(i)}l=i}else{if(i>100){i=100}else if(i<0){i=0}if(t===1){d=i}else{h=i}}_=true;v=true;b=true}}y=false;return this}else{if(y){if(!_){i=giscloud.Color.rgbToHsv(r,o,s)}else if(!v){i=giscloud.Color.hslToHsv(l,u,f)}else if(!b){i=giscloud.Color.labToRgb(p,g,m)}l=i[0];d=i[1];h=i[2];y=false}if(e){return[Math.round(l),Math.round(d),Math.round(h)]}else{return[l,d,h]}}};this.lab=function(e){var t,i;if(arguments.length===3){for(t=0;t<3;t++){i=arguments[t];if(i!==w&&i!==null&&typeof i=="number"){if(t===0){p=i}else if(t===1){g=i}else{m=i}_=true;v=true;y=true}}b=false;return this}else{if(b){if(!_){i=giscloud.Color.rgbToLab(r,o,s)}else if(!v){i=giscloud.Color.hslToLab(l,u,f)}else if(!y){i.giscloud.Color.hsvToLab(l,d,h)}p=i[0];g=i[1];m=i[2];b=false}if(e){return[Math.round(p),Math.round(g),Math.round(m)]}else{return[p,g,m]}}};this.alpha=function(e){if(e!==w&&typeof e=="number"){if(e>100){a=100}else if(e<0){a=0}else{a=Math.round(e)}}else{return a}};this.clone=function(){var e=this.rgba();return new giscloud.Color(e[0],e[1],e[2],e[3])}};giscloud.Color.prototype={brighter:function e(t){var i=this.hsl();t=t||20;return giscloud.Color.fromHsl(i[0],i[1],i[2]+t)},darker:function e(t){var i=this.hsl();t=t||20;return giscloud.Color.fromHsl(i[0],i[1],i[2]-t)},equals:function e(t){var i,n;if(t instanceof giscloud.Color){n=t.rgb();i=this.rgb();return i[0]===n[0]&&i[1]===n[1]&&i[2]===n[2]&&this.alpha()===t.alpha()}else{return false}},toRgbaString:function e(){return"rgba("+this.rgba().join(", ")+")"},toRgbString:function e(){return"rgb("+this.rgb().join(", ")+")"}};giscloud.Color.fromRgb=function(e,t,i){return new giscloud.Color(e,t,i)};giscloud.Color.fromRgb=function(e,t,i,n){return new giscloud.Color(e,t,i,n)};giscloud.Color.fromHsl=function(e,t,i){var n=new giscloud.Color;n.hsl(e,t,i);return n};giscloud.Color.fromHsv=function(e,t,i){var n=new giscloud.Color;n.hsv(e,t,i);return n};giscloud.Color.fromLab=function(e,t,i){var n=new giscloud.Color;n.lab(e,t,i);return n};giscloud.Color.fromHex=function(e){var t=giscloud.Color.hexToRgb(e);return t&&new giscloud.Color(t[0],t[1],t[2])};giscloud.Color.fromRgbString=function(e){var t=/^rgb\((\d+)[,\s]*(\d+)[,\s]*(\d+)\)$/i,i=e&&e.match&&e.match(t);if(i&&i.length===4){return new giscloud.Color(parseInt(i[1]),parseInt(i[2]),parseInt(i[3]))}else{return null}};giscloud.Color.fromRgbaString=function(e){var t=/^rgba\((\d+)[,\s]*(\d+)[,\s]*(\d+)[,\s]*(\d+)\)$/i,i=e&&e.match&&e.match(t),n;if(i&&i.length===5){n=parseInt(i[4])<1?parseInt(i[4])*100:parseInt(i[4]);return new giscloud.Color(parseInt(i[1]),parseInt(i[2]),parseInt(i[3]),n)}else{return null}};giscloud.Color.fromString=function(e){return null||giscloud.Color.fromRgbaString(e)||giscloud.Color.fromRgbString(e)||giscloud.Color.fromHex(e)};giscloud.Color.hexToRgb=function(e){var t,i,n,r;if(typeof e=="string"){r=e.match(/^(?:#|0x)?(?:([a-f0-9]{1,2})([a-f0-9]{1,2})([a-f0-9]{1,2}))$/i);if(r&&r.length===4){t=parseInt(r[1],16);i=parseInt(r[2],16);n=parseInt(r[3],16);return[t,i,n]}else{return null}}else if(typeof e=="number"){t=(e&16711680)>>16;i=(e&65280)>>8;n=e&255;return!isNaN(t+i+n)&&[t,i,n]||null}};giscloud.Color.rgbToHex=function(e,t,i,n){var r,o,s;if(e.length&&e.length===3){if(typeof t=="string"){n=t}t=e[1];i=e[2];e=e[0]}r=e>15?e.toString(16):"0"+e.toString(16);o=t>15?t.toString(16):"0"+t.toString(16);s=i>15?i.toString(16):"0"+i.toString(16);if(n===w||n===null){n="#"}return n+r+o+s};giscloud.Color.rgbToHsl=function(e,t,i){var n,r,o,s,a,l,c,u,d,f;if(e.length&&e.length===3){n=e[0]/255;r=e[1]/255;o=e[2]/255}else{n=e/255;r=t/255;o=i/255}s=Math.min(n,r,o);a=Math.max(n,r,o);l=a-s;c=a+s;f=c/2;if(l===0){u=0;d=0}else{switch(a){case n:u=(r-o)/l;break;case r:u=2+(o-n)/l;break;case o:u=4+(n-r)/l;break}u=Math.min(Math.round(u*60),360);u=u<0?u+360:u;if(f<=.5){d=l/c}else{d=l/(2-c)}}return[u,d*100,f*100]};giscloud.Color.hslToRgb=function(e,t,i){var n,r,o,s,a,l,c,u,d;if(e.length&&e.length===3){c=e[0]/360;u=e[1]/100;d=e[2]/100}else{c=e/360;u=t/100;d=i/100}if(u===0){n=r=o=Math.round(d*255);return[n,r,o]}else{a=d<.5?d*(1+u):d+u-d*u;s=2*d-a;l=function(e,t,i){var n;if(i<0){i=i+1}else if(i>1){i=i-1}if(6*i<1){n=e+(t-e)*6*i}else if(2*i<1){n=t}else if(3*i<2){n=e+(t-e)*(2/3-i)*6}else{n=e}return n};n=l(s,a,c+1/3);r=l(s,a,c);o=l(s,a,c-1/3);return[Math.round(n*255),Math.round(r*255),Math.round(o*255)]}};giscloud.Color.rgbToHsv=function(e,t,i){var n,r,o,s,a,l,c,u,d;if(e.length&&e.length===3){n=e[0];r=e[1];o=e[2]}else{n=e;r=t;o=i}s=Math.min(n,r,o);a=Math.max(n,r,o);l=a-s;if(a===0){u=0}else{u=l/a*100}if(l===0){c=0}else{switch(a){case n:c=(r-o)/l;break;case r:c=2+(o-n)/l;break;case o:c=4+(n-r)/l;break}c=Math.min(Math.round(c*60),360);c=c<0?c+360:c}d=a/255*100;return[c,u,d]};giscloud.Color.hsvToRgb=function(e,t,i){var n,r,o,s,a,l,c,u;if(e.length&&e.length===3){l=e[0];c=e[1]/100;u=e[2]/100}else{l=e;c=t/100;u=i/100}a=Math.floor(l/60)%6;n=l/60-Math.floor(l/60);r=Math.round(255*u*(1-c));o=Math.round(255*u*(1-c*n));s=Math.round(255*u*(1-c*(1-n)));u=Math.round(255*u);switch(a){case 0:return[u,s,r];case 1:return[o,u,r];case 2:return[r,u,s];case 3:return[r,o,u];case 4:return[s,r,u];case 5:return[u,r,o]}};giscloud.Color.hslToHsv=function(e,t,i){var n,r,o;if(e.length&&e.length===3){n=e[0];r=e[1];o=e[2]}else{n=e;r=t;o=i}return giscloud.Color.rgbToHsv(giscloud.Color.hslToRgb(n,r,o))};giscloud.Color.hsvToHsl=function(e,t,i){var n,r,o;if(e.length&&e.length===3){n=e[0];r=e[1];o=e[2]}else{n=e;r=t;o=i}return giscloud.Color.rgbToHsl(giscloud.Color.hsvToRgb(n,r,o))};giscloud.Color.hsvToLab=function(e,t,i){var n,r,o;if(e.length&&e.length===3){n=e[0];r=e[1];o=e[2]}else{n=e;r=t;o=i}return giscloud.Color.rgbToLab(giscloud.Color.hsvToRgb(n,r,o))};giscloud.Color.hslToLab=function(e,t,i){var n,r,o;if(e.length&&e.length===3){n=e[0];r=e[1];o=e[2]}else{n=e;r=t;o=i}return giscloud.Color.rgbToLab(giscloud.Color.hslToRgb(n,r,o))};giscloud.Color.rgbToXyz=function(e,t,i){var n,r,o,s,a,l;if(e.length&&e.length===3){n=e[0]/255;r=e[1]/255;o=e[2]/255}else{n=e/255;r=t/255;o=i/255}if(n>.04045){n=Math.pow((n+.055)/1.055,2.4)}else{n=n/12.92}if(r>.04045){r=Math.pow((r+.055)/1.055,2.4)}else{r=r/12.92}if(o>.04045){o=Math.pow((o+.055)/1.055,2.4)}else{o=o/12.92}n=n*100;r=r*100;o=o*100;s=n*.4124+r*.3576+o*.1805;a=n*.2126+r*.7152+o*.0722;l=n*.0193+r*.1192+o*.9505;return[s,a,l]};giscloud.Color.xyzToRgb=function(e,t,i){var n,r,o;if(e.length&&e.length===3){t=e[1]/100;i=e[2]/100;e=e[0]/100}else{e=e/100;t=t/100;i=i/100}n=e*3.2406+t*-1.5372+i*-.4986;r=e*-.9689+t*1.8758+i*.0415;o=e*.0557+t*-.204+i*1.057;if(n>.0031308){n=1.055*Math.pow(n,1/2.4)-.055}else{n=12.92*n}if(r>.0031308){r=1.055*Math.pow(r,1/2.4)-.055}else{r=12.92*r}if(o>.0031308){o=1.055*Math.pow(o,1/2.4)-.055}else{o=12.92*o}n=n*255;r=r*255;o=o*255;return[n,r,o]};giscloud.Color.labToXyz=function(e,t,i){var n,r,o;if(e.length&&e.length===3){t=e[1];i=e[2];e=e[0]}r=(e+16)/116;n=t/500+r;o=r-i/200;if(r*r*r>.008856){r=r*r*r}else{r=(r-16/116)/7.787}if(n*n*n>.008856){n=n*n*n}else{n=(n-16/116)/7.787}if(o*o*o>.008856){o=o*o*o}else{o=(o-16/116)/7.787}n=95.047*n;r=100*r;o=108.883*o;return[n,r,o]};giscloud.Color.xyzToLab=function(e,t,i){var n,r,o;if(e.length&&e.length===3){t=e[1];i=e[2];e=e[0]}e=e/95.047;t=t/100;i=i/108.883;if(e>.008856){e=Math.pow(e,1/3)}else{e=7.787*e+16/116}if(t>.008856){t=Math.pow(t,1/3)}else{t=7.787*t+16/116}if(i>.008856){i=Math.pow(i,1/3)}else{i=7.787*i+16/116}n=116*t-16;r=500*(e-t);o=200*(t-i);return[n,r,o]};giscloud.Color.rgbToLab=function(e,t,i){var n=giscloud.Color.rgbToXyz(e,t,i);return giscloud.Color.xyzToLab(n)};giscloud.Color.labToRgb=function(e,t,i){var n=giscloud.Color.labToXyz(e,t,i);return giscloud.Color.xyzToRgb(n)};giscloud.Color.labToHsl=function(e,t,i){var n=giscloud.Color.labToXyz(e,t,i);return giscloud.Color.rgbToHsl(giscloud.Color.xyzToRgb(n))};giscloud.Color.labToHsl=function(e,t,i){var n=giscloud.Color.labToXyz(e,t,i);return giscloud.Color.rgbToHsv(giscloud.Color.xyzToRgb(n))};giscloud.Color.randomHue=function(e,t){return giscloud.Color.fromHsv(Math.round(Math.random()*360),e,t)};giscloud.Color.range=function(e,t,i,n){var r,o,s,a,l,c,u,d,f=[];if(e instanceof giscloud.Color&&t instanceof giscloud.Color&&i>=2){if(i===2){return[e.clone(),t.clone()]}else{u=[];c=(n||"hsl cw").match(/^((\w+)?\s)?(ccw$|cw$)/);if(c){n=c[2]||"hsl";d=c[3]}else{d="cw"}if(n==="rgb"){o=e.rgba();s=t.rgba();u=[(s[0]-o[0])/(i-1),(s[1]-o[1])/(i-1),(s[2]-o[2])/(i-1),(s[3]-o[3])/(i-1)]}else{if(n==="hsv"){o=e.hsv();s=t.hsv()}else{o=e.hsl();s=t.hsl()}o.push(e.alpha());s.push(t.alpha());if(d==="cw"){u=[s[0]>=o[0]?(s[0]-o[0])/(i-1):(360-o[0]+s[0])/(i-1),(s[1]-o[1])/(i-1),(s[2]-o[2])/(i-1),(s[3]-o[3])/(i-1)]}else{u=[s[0]<o[0]?(s[0]-o[0])/(i-1):(s[0]-o[0]-360)/(i-1),(s[1]-o[1])/(i-1),(s[2]-o[2])/(i-1),(s[3]-o[3])/(i-1)]}}l=[o[0],o[1],o[2],o[3]];for(r=0;r<i;r++){if(n==="rgb"){f.push(new giscloud.Color(l[0],l[1],l[2],l[3]))}else if(n==="hsv"){a=new giscloud.Color.fromHsv(l[0],l[1],l[2]);a.alpha(l[3]);f.push(a.clone())}else{a=new giscloud.Color.fromHsl(l[0],l[1],l[2]);a.alpha(l[3]);f.push(a.clone())}l[0]+=u[0];l[1]+=u[1];l[2]+=u[2];l[3]+=u[3]}return f}}else{return null}};giscloud.Color.hexNrToString=function(e,t){if(typeof e=="number"){return(t||"")+(16777216|e).toString(16).substr(1)}else{return null}};giscloud.Color.hexStringToNr=function(e,t){var i;if(typeof e=="string"&&e){t=t||"#";i=new RegExp("^(?:"+t+"|0x)?([a-f0-9]{3})([a-f0-9]{3})?$","i");return parseInt(e.replace(i,"$1$2"),16)}else{return NaN}};giscloud.Color.linearGradient=function(e,t,i,n){var r,o,s;if(!e||!t){console.warn("No input for linear gradient!");return null}if(typeof e!=="object"||Object.keys(e).length<2||typeof t!=="number"){console.warn("Wrong input type for linear gradient!");return null}if(!window.chroma){console.warn("No chroma library!");return null}o=Object.keys(e);if(i){o=o.reverse()}s=chroma.scale(o).domain(Object.values(e));r=s.colors(t);if(n==="rgb"){r=r.map(function(e){return giscloud.Color.hexToRgb(e)})}return r}})();(function(e,a,u,d){var n,f=new giscloud.Color(255,180,0);giscloud.FlagMarker=function(e,t,i,n){var r=t||"",o=i||"",s=n&&n instanceof giscloud.Color?n:f,a=e&&e instanceof giscloud.LonLat?e:null,l=true,c=function(){var e,t=this.sig,i;i=u.markers&&u.markers[t];if(t&&i){e=i.id;if(e!==d&&e!==null){i.m.remove(e)}if(l&&a){i.id=i.m.add(a.lon,a.lat,s.hex("0x"),r,o,null,i.open)}else{i.id=null}if(i.id&&i.initHandler){i.initHandler()}}};this.title=function(){var e;if(arguments.length>0){r=arguments[0];if(this.sig){e=u.markers[this.sig].id;if(e){u.markers[this.sig].m.setTitle(e,r)}}return this}else{return r}};this.content=function(){var e;if(arguments.length>0){o=arguments[0];if(this.sig){e=u.markers[this.sig].id;if(e){u.markers[this.sig].m.setContent(e,o)}}return this}else{return o}};this.color=function(){var e=arguments[0];if(arguments.length>0){if(e&&e instanceof giscloud.Color&&!e.equals(s)){s=e?e:f;c.call(this)}return this}else{return s}};this.visible=function(e){if(arguments.length>0){if(e!==l){l=!!e;c.call(this)}return this}else{return l}};this.position=function(){var e=arguments[0];if(arguments.length>0){if(e&&!e.equals(a)){a=e instanceof giscloud.LonLat?e:null;c.call(this)}return this}else{return a}}};giscloud.Marker=function(e,t){var i;t=t||{};i={location:e||null,title:t.title==null?null:t.title,content:t.content==null?null:t.content,visible:t.visible===false?false:true,icon:t.icon||null,label:t.label||null,rotation:t.rotation||0,popup:t.popup===true?true:false,color:t.color||f.clone(),clickable:t.clickable===false?false:true,marker:this};this.title=n.call(this,i,"title");this.content=n.call(this,i,"content");this.location=n.call(this,i,"location");this.visible=n.call(this,i,"visible");this.popup=n.call(this,i,"popup");this.icon=n.call(this,i,"icon");this.rotation=n.call(this,i,"rotation");this.label=n.call(this,i,"label");this.clickable=n.call(this,i,"clickable")};giscloud.LabelMarker=function(e,t){var i;t=t||{};i={location:e||null,content:t.content==null?null:t.content,visible:t.visible===false?false:true,marker:this};this.content=n.call(this,i,"content");this.location=n.call(this,i,"location");this.visible=n.call(this,i,"visible")};n=function(n,r,o){var s=this;return function(e,t){var i;if(e===d){return n[r]}else{if(o&&!o(e)){throw{msg:"Invalid value for "+(r||"???"),target:s}}else{i=n[r];n[r]=e;if(!t){a(s).triggerHandler("stateChanged",[{property:r,oldValue:i,newValue:e,state:n}])}return s}}}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,r,t,i){"use strict";giscloud.Resource=function e(t){t=t||{};this.id=t.id;this.type=t.type!=null&&parseInt(t.type,10);this.targetId=t.target_resource_id,this.created=t.created!=null&&new Date(t.created*1e3)||null;this.modified=t.modified!=null&&new Date(t.modified*1e3)||null;this.accessed=t.access_time!=null&&new Date(t.access_time*1e3)||null;this.owner=t.owner_id};giscloud.Resource.prototype={update:function e(t){var i=this,n={type:parseInt(this.type),target_resource_id:this.targetId};if(this.id!=null)return giscloud.resources.update(this.id,n,t);return giscloud.resources.create(n,t).done(function(e){i.id=e})},remove:function e(t){return giscloud.resources.remove(this.id,t)},target:function e(t){var i=this,n;if(t!=null&&t!==true){if(t.id!=null){this.targetResourceId=t.id;this.targetResource=t}return this}if(this.targetResource&&t!==true){return this.targetResource}if(this.type===giscloud.resourceTypes.DATASOURCE)n=giscloud.datasources.byId(this.targetId);if(this.type===giscloud.resourceTypes.FEATURE_TABLE)n=giscloud.tables.byId(this.targetId);if(this.type===giscloud.resourceTypes.USER)n=giscloud.users.byId(this.targetId);if(this.type===giscloud.resourceTypes.LAYER)n=giscloud.layers.byId(this.targetId);if(this.type===giscloud.resourceTypes.MAP)n=giscloud.maps.byId(this.targetId);if(this.type===giscloud.resourceTypes.NOTIFICATION)n=giscloud.notifications.byId(this.targetId);if(this.type===giscloud.resourceTypes.STREAM)n=giscloud.streams.byId(this.targetId);if(this.type===giscloud.resourceTypes.GRAPHIC)n=giscloud.graphicFeatures.byId(this.targetId);if(n)n.done(function(e){i.targetResource=e});return n||r.Deferred().fail("Bad resource type")}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(s,a){"use strict";giscloud.resourceTypes={DATASOURCE:1,FEATURE_TABLE:2,USER:3,LAYER:4,MAP:5,PAYMENT:6,ORGANIZATION:7,APP:8,APP_INSTANCE:9,HOOK:10,ROLE:11,NOTIFICATION:12,STREAM:13,GRAPHIC:14,FILE:15};giscloud.resources={permissions:function(e,t){var i="resources/"+e+"/permission",n=new s.Deferred;a.rest.get(i,t).done(function(e){n.resolve(e)}).fail(function(){n.reject()});return n.promise()},addPermission:function(e,t){var n=new s.Deferred,r=this;a.rest.call("post","resources/"+e+"/permission",JSON.stringify(t),"application/json").done(function(e,t){var i=t&&t.match(/sharing\/(\w+)/);n.resolveWith(r,[i&&i[1]])}).fail(function(){n.rejectWith(r,arguments)});return n.promise()},removePermission:function(e,t){var i=new s.Deferred,n=this;a.rest.call("DELETE","resources/"+e+"/permission/"+t).done(function(){i.resolve()}).fail(function(){i.reject()});return i.promise()},byId:function(e,t,i){var n="resources/"+e,r=new s.Deferred,o=this;t=t||{};if(typeof t==="function"){i=t;t=null}else{i=i||t.callback}a.rest.get(n,t).done(function(){var e=arguments[0],t;try{t=e;if(typeof i=="function"){i(t)}r.resolve(t)}catch(e){r.reject()}}).fail(function(){r.reject(o,arguments)});return r.promise()},update:function(e,t){var i=new s.Deferred,n=this;if(e==null){return this.create(t)}a.rest.call("PUT","resources/"+e,JSON.stringify(t),"application/json").done(function(){i.resolveWith(n)}).fail(function(){i.rejectWith(n,arguments)});return i.promise()}}})(giscloud.exposeJQuery(),giscloud.common());(function(s,a){"use strict";giscloud.addressmodels={list:function(e){var t="addressmodels.json",i=new s.Deferred;a.rest.get(t,e).done(function(e){if(e&&e.data&&e.data.length>0){var t=0;for(t;t<e.data.length;t++)e.data[t].definition=s.parseJSON(e.data[t].definition)}i.resolve(e)}).fail(function(){i.reject()});return i.promise()},create:function(e,t){var i="addressmodels.json",n=new s.Deferred,r={name:e,definition:typeof t==="string"?t:JSON.stringify(t)};a.rest.call("post",i,r,"application/json").done(function(e,t){n.resolve(t&&t.match&&t.match(/addressmodels\/(\d+)/)[1])}).fail(function(){n.reject()});return n.promise()},update:function(e,t,i){var n="addressmodels/"+e+".json",r=new s.Deferred,o={name:t,definition:typeof i==="string"?i:JSON.stringify(i)};a.rest.call("put",n,o,"application/json").then(r.resolve,r.reject);return r.promise()},remove:function(e){var t=new s.Deferred,i=this;a.rest.call("DELETE","addressmodels/"+e).done(function(){t.resolveWith(i)}).fail(function(){t.rejectWith(i,arguments)});return t.promise()}}})(giscloud.exposeJQuery(),giscloud.common());(function(y){"use strict";giscloud.Queue=function(e){var o=false,s=0,a=e.slice(),l=this===giscloud?{}:this,t=new y.Deferred,c=[],i=[],u=[],d=null,f={},n=function(){return f},r=Array.prototype.slice;function h(){t.resolveWith(l,[u,i])}function p(){t.rejectWith(l,[u])}function g(){i.push(r.apply(arguments));u=i[i.length-1]}function m(){t.notifyWith(l,d!=null?[d].concat(i[s-1]):i[s-1])}function v(){var e,t,i,n,r;if(o){return}e=y.isArray(a[s].params)?u.concat(a[s].params):u,t=y.isFunction(a[s])?a[s]:a[s].func,i=y.isFunction(a[s])?l:a[s].context,n=y.isFunction(a[s])?null:a[s].msg,r=t.apply(i,e);if(r===f){h()}else{c.push(r);s++;d=n;r.always(g,m).done(v).fail(p)}}a.push(n);v();l.abort=function e(){p();o=true};l.results=function e(){return i};l.promises=function e(){return c};return t.promise(l)}})(giscloud.exposeJQuery());(function(r){"use strict";function e(e){var t,i,n;this.options=e;if(e.init){e.init.call(this)}for(t=0,i=e.triggers.length;t<i;t++){n=e.triggers[t];r(n.element).on(n.eventName,r.proxy(this.check,this))}}e.prototype={state:null,activate:function(){var e;this.state="active";if(this.options.onActivation){e=Array.prototype.slice.apply(arguments);this.options.onActivation.apply(this,e)}},deactivate:function(){var e;this.state="inactive";if(this.options.onDeactivation){e=Array.prototype.slice.apply(arguments);this.options.onDeactivation.apply(this,e)}},check:function(){var e,t=Array.prototype.slice.apply(arguments);if(this.options.check){e=this.options.check.apply(this,t);if(this.options.toggle&&this.state){if(e&&this.state!=="active"){this.activate()}else if(!e&&this.state!=="inactive"){this.deactivate()}}else{if(e){this.activate()}else{this.deactivate()}}}else{this.activate()}return e}};if(giscloud){giscloud.Relay=e}})(giscloud&&giscloud.exposeJQuery()||$||jQuery);(function(n){"use strict";var t=1.2.toLocaleString().match(/^[\d١٢۱۲]+(.+)[\d١٢۱۲]+$/)[1]||".";function r(e){if(!e||!e.replace){return e}return e.replace(/[٠١٢٣٤٥٦٧٨٩]/g,function(e){return e.charCodeAt(0)-1632}).replace(/[۰۱۲۳۴۵۶۷۸۹]/g,function(e){return e.charCodeAt(0)-1776}).replace(t,".")}function o(e,t){if(t==null){return e==null}if(e==null){return t==null||t==="null"}if(n.isArray(t)||n.isPlainObject(t)){return JSON.stringify(t)===JSON.stringify(e)}if(typeof t==="number"){return t===parseFloat(e)}if(t.toString&&e.toString){return t.toString()===e.toString()}return t===e}function s(e,t){if(typeof t==="number"){return parseFloat(e)>t}return e>t}function a(e,t){if(typeof t==="number"){return parseFloat(e)>=t}return e>=t}function l(e,t){if(typeof t==="number"){return parseFloat(e)<t}return e<t}function c(e,t){if(typeof t==="number"){return parseFloat(e)<=t}return e<=t}function u(e,t){if(e==null||e.length===0){return false}if(typeof e.indexOf==="function"){return e.indexOf(t)>-1}return false}function d(e){return e!==null&&e!==undefined&&e!==""&&(n.isArray(e)?!!e.length:true)}function i(e){return window[e.name]!=null}function f(e){var t,i=this.itemByUuid(e.name);if(!i)return false;if(!i.visible||i.visible.state==="inactive")return false;if(e.hasValue)return d(i.value);if(!e.value)return false;if(i.type==="numeric"){t=r(i.value)}else{t=i.value}if(e.value.hasOwnProperty("lessThan"))return l(t,e.value.lessThan);if(e.value.hasOwnProperty("lessThanOrEqual"))return c(t,e.value.lessThanOrEqual);if(e.value.hasOwnProperty("equals"))return o(t,e.value.equals);if(e.value.hasOwnProperty("moreThanOrEqual"))return a(t,e.value.moreThanOrEqual);if(e.value.hasOwnProperty("moreThan"))return s(t,e.value.moreThan);if(e.value.hasOwnProperty("contains"))return u(t,e.value.contains);return false}function h(e,t){var i,n;for(i=0,n=t.length;i<n;i++){if(m.call(this,e,t[i]))return true}return false}function p(e,t){var i,n;for(i=0,n=t.length;i<n;i++){if(!m.call(this,e,t[i]))return false}return true}function g(e,t){var i,n,r=0;for(i=0,n=t.length;i<n;i++){if(m.call(this,e,t[i])){r++;if(r>1)return false}}return r===1}function m(e,t){if(!t)return false;if(t.env)return i.call(this,t.env);if(t.item)return f.call(this,t.item);if(t.all)return p.call(this,e,t.all);if(t.any)return h.call(this,e,t.any);if(t.one)return g.call(this,e,t.one);if(t.none)return!h.call(this,e,t.none);return false}function v(e,t){var i;if(e==null||typeof e!=="object"){return false}if(e.hasOwnProperty(t)){return true}for(i in e){if(e.hasOwnProperty(i)&&v(e[i],t)){return true}}return false}function e(e){this.formHasDependencies=false;this.formHasItemDependencies=false;this.formHasEnvDependencies=false;this.items=[];this.itemIndex={};this.triggArray=e.triggers||[];this.items=n.map(e.formItems||[],n.proxy(function e(t,i){if(!t.uuid){t.uuid=giscloud.uuid()}this.itemIndex[t.uuid]=i;if(typeof t.active==="object"){this.formHasEnvDependencies=this.formHasEnvDependencies||v(t.active,"env");this.formHasItemDependencies=this.formHasItemDependencies||v(t.active,"item")}return t},this));this.formHasDependencies=this.formHasEnvDependencies||this.formHasItemDependencies}e.prototype.addItem=function(e){this.itemIndex[e.uuid]=this.items.length;this.items.push(e);if(typeof e.active==="object"){this.formHasEnvDependencies=this.formHasEnvDependencies||v(e.active,"env");this.formHasItemDependencies=this.formHasItemDependencies||v(e.active,"item");this.formHasDependencies=this.formHasEnvDependencies||this.formHasItemDependencies}};e.prototype.itemByUuid=function(e){return this.items[this.itemIndex[e]]};e.prototype.resolveDependency=function e(t,i){if(i==null)return true;if(!n.isPlainObject(i))return!!i;return new giscloud.Relay({init:function(){this.item=t},onActivation:function(){this.item.show&&this.item.show()},onDeactivation:function(){this.item.hide&&this.item.hide()},check:n.proxy(function(){return m.call(this,t,i)},this),triggers:this.triggArray,toggle:false})};e.prototype.check=function e(t){return m.call(this,{},t)};if(giscloud){giscloud.DependencyResolver=e}})(giscloud&&giscloud.exposeJQuery()||$||jQuery);(function(o){"use strict";var t=1.2.toLocaleString().match(/^[\d١٢۱۲]+(.+)[\d١٢۱۲]+$/)[1]||".";function n(e,t){var i;if(e==null||typeof e!=="object"){return false}if(e.all&&e.all.filter(function(e){return e.value&&e.value.type===t}).length>0){return true}return false}function s(e){if(!e||!e.replace){return e}return e.replace(/[٠١٢٣٤٥٦٧٨٩]/g,function(e){return e.charCodeAt(0)-1632}).replace(/[۰۱۲۳۴۵۶۷۸۹]/g,function(e){return e.charCodeAt(0)-1776}).replace(t,".")}function a(e,t,i,n){var r=0;if(!e||!t||!i||i.indexOf("form")<0){return true}for(r;r<this.items.length;r++){if(t.indexOf(this.items[r].def.uuid)<0){continue}if(e==this.items[r].value&&this.items[r].value){this.messages.push({uuid:n.uuid,text:(n.def.title||n.def.name)+__(" value ")+'"'+this.items[r].value+'"'+__(" exists in ")+(this.items[r].def.title||this.items[r].def.name)+"."});return false}}return true}function i(e,t){var i,n=t&&t.type,r=t&&t.among,o=t&&t.scope;if(!e){return false}if(!t){return false}if(!n){return false}if(e.type==="numeric"){i=s(e.value)}else{i=e.value}if(n==="unique"){return true}if(n==="unique-among"){return a.call(this,i,r,o,e)}return false}function r(e,t){var i,n;for(i=0,n=t.length;i<n;i++){if(!u.call(this,e,t[i])){return false}}return true}function l(e,t){var i,n;for(i=0,n=t.length;i<n;i++){if(u.call(this,e,t[i])){return true}}return false}function c(e,t){var i,n,r=0;for(i=0,n=t.length;i<n;i++){if(u.call(this,e,t[i])){r++;if(r>1){return false}}}return r===1}function u(e,t){if(!t){return true}if(t.value){return i.call(this,e,t.value)}if(t.all){return r.call(this,e,t.all)}if(t.any){return l.call(this,e,t.any)}if(t.one){return c.call(this,e,t.one)}if(t.none){return!l.call(this,e,depdef.none)}return false}function e(e){this.formHasValidation=false;this.formHasUniqueAmongValidation=false;this.items=[];this.messages=[];this.itemIndex={};this.triggArray=e.triggers||[];this.items=o.map(e.formItems||[],o.proxy(function e(t,i){if(!t.uuid){t.uuid=giscloud.uuid()}this.itemIndex[t.uuid]=i;if(typeof t.valid==="object"){this.formHasValidation=true;this.formHasUniqueAmongValidation=n(t.valid,"unique-among")}return t},this))}e.prototype.addItem=function(e){this.itemIndex[e.uuid]=this.items.length;this.items.push(e);if(typeof e.valid==="object"){this.formHasValidation=true;this.formHasUniqueAmongValidation=n(e.valid,"unique-among")}};e.prototype.itemByUuid=function(e){return this.items[this.itemIndex[e]]};e.prototype.isValid=function e(t,i){var n=0,r;if(i==null){return true}if(!o.isPlainObject(i)){return!!i}if(!this.formHasValidation){return true}return u.call(this,t,i)};e.prototype.check=function e(t,i){this.messages=[];return u.call(this,t,i)};e.prototype.getMessages=function e(){return this.messages};if(giscloud){giscloud.FormValidator=e}})(giscloud&&giscloud.exposeJQuery()||$||jQuery);(function(e,a,l,t){giscloud.maps={list:function(i,n){var e="maps",r=new a.Deferred;if(typeof i==="function"){n=i;i=null}else{n=n||i&&i.callback}if(i&&!i.perpage)i.nototal=1;l.rest.get(e,i).done(function(){var e=arguments[0],t=[];try{a.each(e.data,function(){t.push(new giscloud.Map(this))});if(!i||i.nototal)e.total=t.length;if(typeof n=="function"){n(t,e.total)}r.resolve(t,e.total)}catch(e){r.reject()}}).fail(function(){r.reject()});return r.promise()},byId:function(e,t,i,n){var r="maps/"+e,o=new a.Deferred;if(typeof t==="function"){i=t;t=null}else{i=i||t&&t.callback}l.rest.get(r,t).done(function(){var e=arguments[0],t;try{t=n?e:new giscloud.Map(e);if(typeof i=="function"){i(t)}o.resolve(t)}catch(e){o.reject()}}).fail(function(){o.reject()});return o.promise()},remove:function(e){return l.rest.call("DELETE","maps/"+e)},archive:function(e){return l.rest.call("PUT","maps/"+e,l.toXml("map",{archived:true}),"text/xml")},restore:function(e){return l.rest.call("PUT","maps/"+e,l.toXml("map",{archived:false}),"text/xml")},update:function(e,t){return l.rest.call("PUT","maps/"+e,l.toXml("map",t),"text/xml")},create:function(e){var n=new a.Deferred;l.rest.call("post","maps/",l.toXml("map",e),"text/xml").fail(n.reject).done(function(e,t){var i=t&&t.match(/maps\/(\d+)/);if(i&&i[1]!=null){n.resolve(i[1])}else{n.reject()}});return n.promise()},users:function(e){var t=new a.Deferred,i,r={owner:null,editors:[],viewers:[]};this.byId(e,{expand:"owner"}).done(function(e){r.owner={id:e.owner.id,username:e.owner.username};giscloud.resources.permissions(e.resourceId,{expand:"user"}).done(function(e){if(e&&e.data&&e.data.length){a.each(e.data,function(e,i){var n={permissions:i.permissions};if(i.role){n.role=true;n.id=i.role.id;n.rolename=i.role.name}if(i.user){if(i.user.username==="anonymous"){return}n.id=i.user.id;n.username=i.user.username}a.each(i.permissions,function(e,t){if(t.type==="READ"||t.type==="EDIT"||t.type==="SHARE"||t.type==="EXPORT"){if(i.permissions.length===1&&t.type==="READ"){r.viewers.push(n)}else{r.editors.push(n)}return false}})});return t.resolve(r)}})});return t.promise()},reset:function(e,t,i){var n=new a.Deferred,r=this,o={},s="/2";if(a.isArray(t))o.layers=t.join();else if(t==null)o.layers=t;if(i){if(i.init===0)s="/0";if(i.init===1)s="/1"}if(i&&i.cascade)o.cascade=true;l.rest.call("DELETE","map_cache/"+e+s,o).done(function(){n.resolveWith(r)}).fail(function(){n.rejectWith(r,arguments)});return n.promise()}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,c,u,t){giscloud.layers={list:function(i,n){var e="layers",r=new c.Deferred;i=i||{};if(typeof i==="function"){n=i;i=null}else{n=n||i.callback}if(i&&!i.perpage)i.nototal=1;u.rest.get(e,i).done(function(){var e=arguments[0],t=[];try{c.each(e.data,function(){t.push(new giscloud.Layer(this))});if(!i||i.nototal)e.total=t.length;if(typeof n=="function"){n(t,e.total)}r.resolve(t,e.total)}catch(e){r.reject()}}).fail(function(){r.reject()});return r.promise()},byId:function(e,t,i){var n="layers/"+e,r=new c.Deferred;t=t||{};if(typeof t==="function"){i=t;t=null}else{i=i||t.callback}u.rest.get(n,t).done(function(){var e=arguments[0],t;try{t=new giscloud.Layer(e);if(typeof i=="function"){i(t)}r.resolve(t)}catch(e){r.reject()}}).fail(function(){r.reject()});return r.promise()},byMapId:function(e,i,n){var t="maps/"+e+"/layers",r=new c.Deferred;i=i||{};if(typeof i==="function"){n=i;i=null}else{n=n||i.callback}if(i&&!i.perpage)i.nototal=1;u.rest.get(t,i).done(function(){var e=arguments[0],t=[];try{c.each(e.data,function(){t.push(new giscloud.Layer(this))});if(!i||i.nototal)e.total=t.length;if(typeof n=="function"){n(t,e.total)}r.resolve(t,e.total)}catch(e){r.reject()}}).fail(function(){r.reject()});return r.promise()},remove:function(e){var t=new c.Deferred,i=this;u.rest.call("DELETE","layers/"+e).done(function(){t.resolveWith(i)}).fail(function(){t.rejectWith(i,arguments)});return t.promise()},update:function(e,t){var i=new c.Deferred,n=this,r=o(t||{});if(e==null){return this.create(r)}u.rest.call("PUT","layers/"+e,JSON.stringify(r),"application/json").done(function(){i.resolveWith(n)}).fail(function(){i.rejectWith(n,arguments)});return i.promise()},create:function(e){var n=new c.Deferred,r=this,t=o(e);delete t.id;u.rest.call("POST","layers/",JSON.stringify(t),"application/json").done(function(e,t){var i=t&&t.match(/layers\/(\d+)/);n.resolveWith(r,[i&&i[1]])}).fail(function(){n.rejectWith(r,arguments)});return n.promise()},reset:function(e,t,i){var n=new c.Deferred,r=this,o={};if(i&&i.cascade){o.cascade=true}u.rest.call("DELETE","map_cache/"+e+"/2?layers="+t.join(),o).done(function(){n.resolveWith(r)}).fail(function(){n.rejectWith(r,arguments)});return n.promise()},render:function(e,t,i,n){var r=u.rest.url()+"layers/"+e+"/render."+t+"?invalidate=true";if(i&&n){r+="&width="+i+"&height="+n}return r},export:function(e,t,i){var n=u.rest.url()+"layers/"+e+"/export."+t;if(i){n+=".zip"}return n},refreshColumns:function(e){var t=new c.Deferred,i=this;u.rest.call("PUT","layers/"+e+"/refresh_columns.json").done(function(){t.resolveWith(i)}).fail(function(){t.rejectWith(i,arguments)});return t.promise()},createBuffer:function(e,t){var i=new c.Deferred,n="layers/"+e+"/buffer",r={},o,s,a,l;t=t||{};if(!t.hasOwnProperty("name")){console.error("Name parameter is missing from options.");i.reject("Name parameter is missing from options.");return i.promise()}else if(!t.hasOwnProperty("size")){console.error("Size parameter is missing from options.");i.reject("Size parameter is missing from options.");return i.promise()}r.name=t.name;r.size=t.size;t.hasOwnProperty("units")&&(r.units=t.units);t.hasOwnProperty("mergeGeom")&&(r.merge_geom=t.mergeGeom);t.hasOwnProperty("borderWidth")&&(r.border_width=t.borderWidth);t.hasOwnProperty("borderColor")&&(r.border_color=t.borderColor);t.hasOwnProperty("fillColor")&&(r.fill_color=t.fillColor);if(r.border_color instanceof giscloud.Color){r.border_color=r.border_color.rgb().join(", ")}if(r.fill_color instanceof giscloud.Color){r.fill_color=r.fill_color.rgb().join(", ")}u.rest.call("POST",n,r).done(function(){o=arguments;try{s=o[1]&&o[1].split("/");a=s&&s.length&&s[s.length-1];i.resolve(a)}catch(e){i.reject("Unable to process response.")}}).fail(function(){l={status:arguments[0],error:arguments[4],message:arguments[5]&&arguments[5].msg?arguments[5].msg:""};i.reject(l)});return i.promise()},attributeOps:{distinct:function(e,t,i){var n="layers/"+e+"/attributeops/distinct.json";i=i||{perpage:10,page:1};i.attribute=t;return u.rest.get(n,i).pipe(function(e){return e},function(e){return e}).promise()},info:function(e,t){var i="layers/"+e+"/attributeops/info.json";return u.rest.get(i,t).pipe(function(e){return e},function(e){return e}).promise()}}};function i(t){try{return typeof t==="object"?JSON.stringify(t):t}catch(e){console.warn("Error while converting value to JSON",t,e);return t}}function o(e){var t=Object.assign({},e||{});delete t.modified;delete t.created;delete t.accessed;if(t.datasourceId){t.datasource_id=t.datasourceId;delete t.datasourceId}if(t.mapId){t.map_id=t.mapId;delete t.mapId}if(t.source)t.source=i(t.source);if(t.styles)t.styles=i(t.styles);if(t.label_placement)t.label_placement=i(t.label_placement);return t}})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,a,l,c){function t(e){var t,i,n={};for(i in e){if(e.hasOwnProperty(i)){t=i.replace(".","\\.");n[t]=e[i]}}return n}giscloud.features={byLayer:function(n,e,r){var t="layers/"+n+"/features",o=new a.Deferred;e=e||{};if(typeof e==="function"){r=e;e=null}else{r=r||e.callback}l.rest.get(t,e).done(function(e){var t=e,i=[];a.each(t.data,function(){this.layerId=n;this.meta=t.meta;i.push(new giscloud.Feature(this))});if(typeof r=="function"){r(i,t.total)}o.resolve(i,t.total)}).fail(function(){o.reject()});return o.promise()},byId:function(n,e,t,r){var i="layers/"+n+"/features/"+e,o=new a.Deferred;t=t||{};if(typeof t==="function"){r=t;t=null}else{r=r||t.callback}l.rest.get(i,t).done(function(e){var t=e,i;t.layerId=n;i=new giscloud.Feature(t);if(typeof r=="function"){r(i)}o.resolve(i)}).fail(function(){o.reject()});return o.promise()},byBounds:function(n,e,r,o){var t="layers/"+n+"/features",s=new a.Deferred,i;r=r||{};if(typeof r==="function"){o=r;r={}}else{o=o||r.callback}r.bounds=e.toString();if(r.requestByPost){r.requestByPost=c;i=l.rest.call("post",t+"?_method=GET",r)}else{i=l.rest.get(t,r)}i.done(function(e){var t=e,i=[];a.each(t.data,function(){this.layerId=n;i.push(new giscloud.Feature(this))});if(typeof o=="function"){o(i,t.total,n,r)}s.resolve(i,t.total,n,r)}).fail(function(){s.reject()});return s.promise()},remove:function(e,t){var i=new a.Deferred,n=this;l.rest.call("DELETE","layers/"+e+"/features/"+t).done(function(){i.resolveWith(n)}).fail(function(){i.rejectWith(n,arguments)});return i.promise()},update:function(e,t,i,n){var r=new a.Deferred,o=this,s;if(i&&i.geometry){if(i.geometry.toOGC){i.geometry=i.geometry.toOGC()}}if(t==null){return this.create(e,i,n)}s="layers/"+e+"/features/"+t;if(n){s+="?"+a.map(n,function(e,t){return t+"="+e}).join("&")}l.rest.call("PUT",s,JSON.stringify(i),"application/json").done(function(){r.resolveWith(o,[t])}).fail(function(){r.rejectWith(o,arguments)});return r.promise()},create:function(e,t,i){var o=new a.Deferred,s=this,n="layers/"+e+"/features/";if(i){n+="?"+a.map(i,function(e,t){return t+"="+e}).join("&")}l.rest.call("post",n,JSON.stringify(t),"application/json").done(function(e,t,i){var n=t||i.getResponseHeader("Location"),r=n&&n.match(/features\/(\d+)/);o.resolveWith(s,[r&&r[1]])}).fail(function(){o.rejectWith(s,arguments)});return o.promise()},email:function(e){var t="layers/"+e.layer_id+"/features/email",i=new a.Deferred,n=this;if(!e||!e.layer_id||!e.feature_ids||!e.usernames&&!e.emails)return i.reject();e.feature_ids=jQuery.type(e.feature_ids)=="array"?e.feature_ids.join():e.feature_ids;e.usernames=jQuery.type(e.usernames)=="array"?e.usernames.join():e.usernames;e.emails=jQuery.type(e.emails)=="array"?e.emails.join():e.emails;l.rest.get(t,e).done(function(){i.resolve()}).fail(function(e){var t=a.parseJSON(e.responseText);i.rejectWith(n,[e,t])});return i.promise()},emailCSV:function(e){var t="layers/"+e.layer_id+"/features.csv",i=new a.Deferred,n=this;if(!e||!e.layer_id)return i.reject();e.format=1;e.emails=jQuery.type(e.emails)=="array"?e.emails.join():e.emails;l.rest.get(t,e).done(function(){i.resolve()}).fail(function(e){var t=a.parseJSON(e.responseText);i.rejectWith(n,[e,t])});return i.promise()}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,s,a,t){giscloud.graphicFeatures={list:function(t,n){var e="graphicfeatures",r=new s.Deferred;if(typeof t==="function"){n=t;t=null}else{n=n||t&&t.callback}if(t&&!t.perpage)t.nototal=1;a.rest.get(e,t).done(function(){var e=arguments[0],i=[];try{s.each(e.data,function(e,t){i.push(new giscloud.GraphicFeature({id:t.id,resourceId:t.resource_id,geometry:giscloud.geometry.fromOGC(t.geometry),style:giscloud.GraphicStyle.parse(t.style)}))});if(!t||t.nototal)e.total=i.length;if(typeof n=="function"){n(i,e.total)}r.resolve(i,e.total)}catch(e){r.reject()}}).fail(function(){r.reject()});return r.promise()},byId:function(e,t,i){var n=e&&e.match?parseInt(e.match(/^(?:graphic_orig)?(\d+)$/)[1],10):e,r="graphicfeatures/"+n,o=new s.Deferred;if(t&&t.context&&t.contextId){r=t.context+"/"+t.contextId+"/"+r}if(typeof t==="function"){i=t;t=null}else{i=i||t&&t.callback}a.rest.get(r,t).done(function(e){var t;try{t=new giscloud.GraphicFeature({id:e.id,resourceId:e.resource_id,geometry:giscloud.geometry.fromOGC(e.geometry),style:giscloud.GraphicStyle.parse(e.style)});if(typeof i=="function"){i(t)}o.resolve(t)}catch(e){o.reject()}}).fail(function(){o.reject()});return o.promise()},remove:function(e){var t=e&&e.match?parseInt(e.match(/^(?:graphic_orig)?(\d+)$/)[1],10):e;return a.rest.call("DELETE","graphicfeatures/"+t)},update:function(e,t){var i=e&&e.match?parseInt(e.match(/^(?:graphic_orig)?(\d+)$/)[1],10):e;return a.rest.call("PUT","graphicfeatures/"+i,a.toXml("graphicfeature",t),"text/xml")},create:function(e){var n=new s.Deferred;a.rest.call("POST","graphicfeatures/",a.toXml("graphicfeature",e),"text/xml").fail(n.reject).done(function(e,t){var i=t&&t.match(/graphicfeatures\/(\d+)/);if(i&&i[1]!=null){n.resolve(i[1])}else{n.reject()}});return n.promise()}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(s,a,e){giscloud.search={features:function(e,t,i,n,r){var o;n=n||{};if(typeof n==="function"){r=n;n=null}else{r=r||n.callback}n.query=e;n.fields=t&&t.toString();if(i){if(i instanceof giscloud.LonLat){n.x=i.lon;n.y=i.lat}else if(i.x!=null&&i.y!=null){n.x=i.x;n.y=i.y}}else{n.x=n.y=0}o=new s.Deferred;a.rest.get("search",n).done(function(e){var t=[];try{s.each(e.data,function(){t.push(new giscloud.Feature(this))});o.resolve(t,e.total)}catch(e){o.reject()}}).fail(function(){o.reject()});if(r){o.done(r)}return o.promise()}}})(giscloud.exposeJQuery(),giscloud.common());(function(t,r){var o,s,a,l=["id","created","lastlog","modified","username","email",{field:"email_md5",alias:"emailMd5"},"file_feature_count","db_feature_count","feature_count_limit","storage_raster","storage_raster_limit","subscriptions","resource","options","active","roles",{field:"parent_id",alias:"parentId"}],c=["created","lastlog","modified"],u=["language",{field:"firstname",alias:"firstName"},{field:"lastname",alias:"lastName"},"info","phone","mobile","company",{field:"web",alias:"website"}];giscloud.User=function(e){var t,i,n;for(t=0,i=l.length;t<i;t++){n=l[t];this[n.alias||n]=o(n.field||n,e)}for(t=0,i=u.length;t<i;t++){n=u[t];this[n.alias||n]=s(n.field||n,e)}for(t=0,i=c.length;t<i;t++){n=c[t];e[n.field||n]=a(e[n.field||n])}};giscloud.User.prototype={update:function(){var e,t,i,n;n={};for(e=0,t=u.length;e<t;e++){i=u[e];n[i.field||i]=this[i.alias||i]()}return giscloud.users.update(this.id(),n)},remove:function(){return giscloud.users.remove(this.id())},unsubscribe:function(e){return giscloud.users.unsubscribe(this.id(),e)},optionByName:function(e,t){return giscloud.options.byName(this.id(),e,{},t)},gravatarElement:function(e,t,i){var n=this.emailMd5()||this.email();if(!n||!giscloud.gravatar)return null;return giscloud.gravatar.element(this,n,e,t,i)},gravatarImage:function(e,t,i,n){var r=this.emailMd5()||this.email();if(!r||!giscloud.gravatar)return null;return giscloud.gravatar.image(r,e,t,i,n)},gravatarUrl:function(e,t,i){var n=this.emailMd5()||this.email();if(!n||!giscloud.gravatar)return null;return giscloud.gravatar.url(n,e,t,i)},gravatarProfile:function(){var e=this.emailMd5()||this.email();if(!e||!giscloud.gravatar)return t.Deferred().fail(null);return giscloud.gravatar.profile(e)}};a=function(e){var t=new Date(e*1e3);if(t&&!isNaN(t.getTime())){return t}else{return e}};o=function(e,t){return function(){return t[e]}};s=function(t,i,n){return function(e){if(e!==r){i[t]=e;return n}else{return i[t]}}}})(giscloud.exposeJQuery());(function(e,s,a,t){giscloud.users={list:function(e,r){var t="users",o=new s.Deferred;e=e||{};if(typeof e==="function"){r=e;e={}}else{r=r||e.callback}e.expand="roles, options";a.rest.get(t,e).done(function(i){var n,e,t=[];try{for(n=0,e=i.data.length;n<e;n++){if(i.data[n].options&&i.data[n].options.length){i.data[n]._options={};s.each(i.data[n].options,function(e,t){i.data[n]._options[t.name]=t.value});i.data[n].options=i.data[n]._options;delete i.data[n]._options}else{i.data[n].options=null}t.push(new giscloud.User(i.data[n]))}if(typeof r=="function"){r(t)}o.resolve(t)}catch(e){o.reject()}}).fail(function(){o.reject()});return o.promise()},byId:function(e,t,n){var i="users/"+e,r=new s.Deferred;t=t||{};if(typeof t==="function"){n=t;t={}}else{n=n||t.callback}t.expand="roles,options,subscriptions,resource";a.rest.get(i,t).done(function(i){var e;try{if(i.options&&i.options.length){i._options={};s.each(i.options,function(e,t){i._options[t.name]=t.value});i.options=i._options;delete i._options}else{i.options=null}e=new giscloud.User(i);if(typeof n=="function"){n(e)}r.resolve(e)}catch(e){r.reject()}}).fail(function(){r.reject()});return r.promise()},current:function(e,t){var i="users/current",n=new s.Deferred;e=e||{};if(typeof e==="function"){t=e;e={}}else{t=t||e.callback}e.expand="roles,options";a.rest.get(i,e).done(function(i){var e;try{if(i.options&&i.options.length){i._options={};s.each(i.options,function(e,t){i._options[t.name]=t.value});i.options=i._options;delete i._options}else{i.options=null}e=new giscloud.User(i);if(typeof t=="function"){t(e)}n.resolve(e)}catch(e){n.reject()}}).fail(function(){n.reject()});return n.promise()},remove:function(e){var t=new s.Deferred,i=this;a.rest.call("DELETE","users/"+e).done(function(){t.resolveWith(i)}).fail(function(){t.rejectWith(i,arguments)});return t.promise()},unsubscribe:function(e,t){var i=new s.Deferred,n=this;a.rest.call("DELETE","users/"+e+"/subscriptions/"+t).done(function(){i.resolveWith(n)}).fail(function(){i.rejectWith(n,arguments)});return i.promise()},update:function(e,t){var i=new s.Deferred,n=this;a.rest.call("PUT","users/"+e,JSON.stringify(t),"application/json").done(function(){i.resolveWith(n)}).fail(function(){i.rejectWith(n,arguments)});return i.promise()},create:function(e){var n=new s.Deferred,r=this;if(!e||!e.username||!e.password){return n.rejectWith(r,["No username or password"])}if(e.password.length<10){return n.rejectWith(r,["Use min 10 characters for password"])}a.rest.call("post","users/",JSON.stringify(e),"application/json").done(function(e,t){var i=t&&t.match(/users\/(\d+)/);n.resolveWith(r,[i&&i[1]])}).fail(function(){n.rejectWith(r,arguments)});return n.promise()}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,o){"use strict";giscloud.userOptions={userId:function(){return"current"},list:function(){var e="users/"+this.userId()+"/options.json";return o.rest.get(e).pipe(function(e){return e.data})},byId:function(e){var t="users/"+this.userId()+"/options/"+e+".json";return o.rest.get(t).promise()},byName:function(e){return this.byId(e)},create:function(e,t){var i="users/"+this.userId()+"/options.json",n={name:e,value:t||null};return o.rest.call("post",i,n,"application/json").pipe(function(e,t){return t&&t.match&&t.match(/options\/(\d+)/)[1]})},update:function(e,t,i){var n="users/"+this.userId()+"/options/"+e+".json",r={name:typeof i==="undefined"?e:t,value:typeof i==="undefined"?t:i};return o.rest.call("put",n,r,"application/json").promise()},remove:function(e){var t="users/"+this.userId()+"/options/"+e+".json";return o.rest.call("DELETE",t).promise()}}})(giscloud.exposeJQuery(),giscloud.common());(function(r,o){"use strict";function i(e){return{id:e.id,description:e.key_desc,created:new Date(e.created),accessed:new Date(e.accessed),trunc:e.key_trunc,scope:e.scope&&(e.scope.split?e.scope.split(","):[e.scope]),active:e.active==="t"}}giscloud.keys={list:function(){return o.rest.get("keys.json").then(function(e){var t=e&&r.map(e.data||[],i);if(!t){return r.Deferred().reject(e)}return r.Deferred().resolve(t,e.total)})},byId:function(e){return o.rest.get("keys/"+e+".json").then(i)},add:function(e){var t="keys.json",i=new r.Deferred,n;if(typeof e==="string"){n={key_desc:e}}else if(r.isPlainObject(e)){n=e;if(n.description){n["key_desc"]=n.description;delete n.description}}else{n={}}if(n.scope&&r.isArray(n.scope)){n.scope=n.scope.join(",")}o.rest.call("post",t,JSON.stringify(n),"application/json",true).done(function(e,t){i.resolve({id:t&&t.match&&t.match(/keys\/(\d+)/)[1],key:e.value})}).fail(function(){i.reject()});return i.promise()},remove:function(e){var t=new r.Deferred,i=this;o.rest.call("DELETE","keys/"+e).done(function(){t.resolveWith(i)}).fail(function(){t.rejectWith(i,arguments)});return t.promise()}}})(giscloud.exposeJQuery(),giscloud.common());(function(e,t){"use strict";e.basemaps={list:function e(){return t.rest.get("basemaps").then(function(e){return e.data})}}})(giscloud,giscloud.common());(function(e,s,a,t){giscloud.payment=giscloud.payment||{};giscloud.payment.plans={list:function(e,r){var t="payment/plans",o=new s.Deferred;e=e||{};if(typeof e==="function"){r=e;e={}}else{r=r||e.callback}a.rest.get(t,e).done(function(i){var e,t,n=[];try{for(e=0,t=i.data.length;e<t;e++){if(i.data[e].options&&i.data[e].options.length){i.data[e]._options={};s.each(i.data[e].options,function(e,t){i.data[e]._options[t.name]=t.value});i.data[e].options=i.data[e]._options;delete i.data[e]._options}else{i.data[e].options=null}n.push(i.data[e])}if(typeof r=="function"){r(n)}o.resolve(n)}catch(e){o.reject()}}).fail(function(){o.reject()});return o.promise()},create:function(e){var n=new s.Deferred;a.rest.call("post","payment/plans",e,"application/json").done(function(e,t){var i=t&&t.match(/plans\/(\w+)/);n.resolve([i&&i[1]])}).fail(function(){n.reject(arguments)});return n.promise()},remove:function(e){var t=new s.Deferred;a.rest.call("DELETE","payment/plans/"+e).done(function(){t.resolve()}).fail(function(){t.reject()});return t.promise()},update:function(e,t){var i=new s.Deferred,n=this;a.rest.call("PUT","payment/plans/"+e,JSON.stringify(t),"application/json").done(function(){i.resolveWith(n)}).fail(function(){i.rejectWith(n,arguments)});return i.promise()},byId:function(e,t,n){var i="payment/plans/"+e,r=new s.Deferred;t=t||{};if(typeof t==="function"){n=t;t={}}else{n=n||t.callback}a.rest.get(i,t).done(function(i){var e;try{if(i.options&&i.options.length){i._options={};s.each(i.options,function(e,t){i._options[t.name]=t.value});i.options=i._options;delete i._options}else{i.options=null}e=i;if(typeof n=="function"){n(e)}r.resolve(e)}catch(e){r.reject()}}).fail(function(){r.reject()});return r.promise()}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,s,a,t){giscloud.payment=giscloud.payment||{};giscloud.payment.coupons={list:function(e,r){var t="payment/coupons",o=new s.Deferred;e=e||{};if(typeof e==="function"){r=e;e={}}else{r=r||e.callback}a.rest.get(t,e).done(function(e){var t,i,n=[];try{for(t=0,i=e.data.length;t<i;t++){n.push(e.data[t])}if(typeof r=="function"){r(n)}o.resolve(n)}catch(e){o.reject()}}).fail(function(){o.reject()});return o.promise()},byId:function(e,t,i){var n="payment/coupons/"+e,r=new s.Deferred;if(!e||!(e.length>0)){console.warn("Coupon id is not specified.")}t=t||{};if(typeof t==="function"){i=t;t={}}else{i=i||t.callback}a.rest.get(n,t).done(function(e){var t;try{t=e;if(typeof i=="function"){i(t)}r.resolve(t)}catch(e){r.reject()}}).fail(function(){r.reject()});return r.promise()}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,s,a,t){giscloud.payment=giscloud.payment||{};giscloud.payment.cards={add:function(e,t){var i=new s.Deferred;if(!e||!t){return}var n="payment/customers/"+e+"/cards",r={token:t};a.rest.call("post",n,a.toXml("card",r),"text/xml").done(function(e,t){i.resolve()}).fail(function(){i.reject(arguments)});return i.promise()},makeDefault:function(e,t){var i=new s.Deferred,n=this,r;var r="payment/customers/"+e+"/cards/"+t+"/makedefault";a.rest.call("PUT",r,null,"application/json").done(function(){i.resolveWith(n,[])}).fail(function(){i.rejectWith(n,arguments)});return i.promise()},remove:function(e,t){var i=new s.Deferred;var n="payment/customers/"+e+"/cards/"+t;a.rest.call("DELETE",n).done(function(){i.resolve()}).fail(function(){i.reject()});return i.promise()},list:function(e,t,r){var i="payment/customers/"+e+"/cards",o=new s.Deferred;t=t||{};if(typeof t==="function"){r=t;t={}}else{r=r||t.callback}a.rest.get(i,t).done(function(e){var t,i,n=[];try{for(t=0,i=e.data.length;t<i;t++){n.push(e.data[t])}if(typeof r=="function"){r(n)}o.resolve(n)}catch(e){o.reject()}}).fail(function(){o.reject()});return o.promise()}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,s,a,t){giscloud.payment=giscloud.payment||{};giscloud.payment.customers={create:function(e){var t="payment/customers",n=new s.Deferred,r=this;a.rest.call("post",t,JSON.stringify(e),"application/json").done(function(e,t){var i=t&&t.match(/payment\/customers\/(\d+)/);n.resolveWith(r,[i&&i[1]])}).fail(function(){n.rejectWith(r,arguments)});return n.promise()},remove:function(e){var t="payment/customers/"+e,i=new s.Deferred,n=this;a.rest.call("DELETE",t).done(function(){i.resolveWith(n)}).fail(function(){i.rejectWith(n,arguments)});return i.promise()},list:function(e,r){var t="payment/customers",o=new s.Deferred;e=e||{};if(typeof e==="function"){r=e;e={}}else{r=r||e.callback}if(e&&e.userId){t="users/"+e.userId+"/payment/customers"}if(e&&e.expand){t+="?expand="+e.expand}a.rest.get(t,e).done(function(e){var t,i,n=[];try{for(t=0,i=e.data.length;t<i;t++){n.push(e.data[t])}if(typeof r=="function"){r(n)}o.resolve(n)}catch(e){o.reject()}}).fail(function(){o.reject()});return o.promise()}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,s,a,t){giscloud.payment=giscloud.payment||{};giscloud.payment.subscriptions={list:function(e,t,r){var i="payment/customers/"+e+"/subscriptions",o=new s.Deferred;t=t||{};if(typeof t==="function"){r=t;t={}}else{r=r||t.callback}a.rest.get(i,t).done(function(e){var t,i,n=[];try{for(t=0,i=e.data.length;t<i;t++){n.push(e.data[t])}if(typeof r=="function"){r(n)}o.resolve(n)}catch(e){o.reject()}}).fail(function(){o.reject()});return o.promise()},remove:function(e){var t="payment/subscriptions/"+e,i=new s.Deferred,n=this;a.rest.call("DELETE",t).done(function(){i.resolveWith(n)}).fail(function(){i.rejectWith(n,arguments)});return i.promise()},create:function(e,t){var i="payment/customers/"+e+"/subscriptions",n=new s.Deferred,r=this;a.rest.call("post",i,JSON.stringify(t),"application/json").done(function(e,t){var i=t&&t.match(/payment\/subscriptions\/(\d+)/);n.resolveWith(r,[i&&i[1]])}).fail(function(){n.rejectWith(r,arguments)});return n.promise()},update:function(e,t){var i="payment/subscriptions/"+e,n=new s.Deferred,r=this;a.rest.call("PUT",i,JSON.stringify(t),"application/json").done(function(){n.resolveWith(r)}).fail(function(){n.rejectWith(r,arguments)});return n.promise()},byId:function(e,t,i){var n="payment/subscriptions/"+e,r=new s.Deferred;t=t||{};if(typeof t==="function"){i=t;t={}}else{i=i||t.callback}a.rest.get(n,t).done(function(e){var t;try{t=e;if(typeof i=="function"){i(t)}r.resolve(t)}catch(e){r.reject()}}).fail(function(){r.reject()});return r.promise()}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,s,a,t){giscloud.apps={list:function(e,r){var t="apps",o=new s.Deferred;e=e||{};if(typeof e==="function"){r=e;e={}}else{r=r||e.callback}a.rest.get(t,e).done(function(e){var t,i,n=[];try{for(t=0,i=e.data.length;t<i;t++){n.push(e.data[t])}if(typeof r=="function"){r(n)}o.resolve(n)}catch(e){o.reject()}}).fail(function(){o.reject()});return o.promise()},byId:function(e,t,i){var n="apps/"+e,r=new s.Deferred;t=t||{};if(typeof t==="function"){i=t;t={}}else{i=i||t.callback}a.rest.get(n,t).done(function(e){var t;try{t=e;if(typeof i=="function"){i(t)}r.resolve(t)}catch(e){r.reject()}}).fail(function(){r.reject()});return r.promise()}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,s,a,t){giscloud.appinstances={list:function(e,r){var t="appinstances",o=new s.Deferred;e=e||{};if(typeof e==="function"){r=e;e={}}else{r=r||e.callback}a.rest.get(t,e).done(function(e){var t,i,n=[];try{for(t=0,i=e.data.length;t<i;t++){n.push(e.data[t])}if(typeof r=="function"){r(n)}o.resolve(n)}catch(e){o.reject()}}).fail(function(){o.reject()});return o.promise()},create:function(e){var n=new s.Deferred;a.rest.call("post","appinstances",e,"application/json").done(function(e,t){var i=t&&t.match(/appinstances\/(\w+)/);n.resolve([i&&i[1]])}).fail(function(){n.reject(arguments)});return n.promise()},remove:function(e){var t=new s.Deferred;a.rest.call("DELETE","appinstances/"+e).done(function(){t.resolve()}).fail(function(){t.reject()});return t.promise()},update:function(e,t){var i=new s.Deferred,n=this;a.rest.call("PUT","appinstances/"+e,JSON.stringify(t),"application/json").done(function(){i.resolveWith(n)}).fail(function(){i.rejectWith(n,arguments)});return i.promise()},byId:function(e,t,i){var n="appinstances/"+e,r=new s.Deferred;t=t||{};if(typeof t==="function"){i=t;t={}}else{i=i||t.callback}a.rest.get(n,t).done(function(e){var t;try{t=e;if(typeof i=="function"){i(t)}r.resolve(t)}catch(e){r.reject()}}).fail(function(){r.reject()});return r.promise()}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(s,a){"use strict";giscloud.forms={byId:function(e,t){return a.rest.get("forms/"+e+".json",t||{}).then(function(e){return e})},byLayerAndId:function(e,t,i){return a.rest.get("layers/"+e+"/forms/"+t+".json",i||{}).then(function(e){return e})},create:function(e,t){var i="forms.json",n=new s.Deferred,r={name:e,definition:typeof t==="string"?t:JSON.stringify(t)};a.rest.call("post",i,r,"application/json").done(function(e,t){n.resolve(t&&t.match&&t.match(/forms\/(\d+)/)[1])}).fail(function(){n.reject()});return n.promise()},update:function(e,t,i){var n="forms/"+e+".json",r=new s.Deferred,o={name:t,definition:typeof i==="string"?i:JSON.stringify(i)};a.rest.call("put",n,o,"application/json").then(r.resolve,r.reject);return r.promise()},setLayerMappings:function(e,t,i){var n="layers/"+e+"/forms/"+t+".json",r=new s.Deferred,o={};if(i!=null){o.mappings=i}a.rest.call("put",n,o,"application/json").done(function(){r.resolve()}).fail(function(){r.reject()});return r.promise()},remove:function(e){var t=new s.Deferred,i=this;a.rest.call("DELETE","forms/"+e).done(function(){t.resolveWith(i)}).fail(function(){t.rejectWith(i,arguments)});return t.promise()}}})(giscloud.exposeJQuery(),giscloud.common());(function(p,g){"use strict";function r(e){return"?"+p.map(e,function(e,t){if(t=="connectionId"){t="connection_id"}if(t=="noGeometryField"){t="no_geometry_field"}if(t=="perPage"){t="perpage"}return t+"="+e}).join("&")}giscloud.tables={list:function(e){var t="tables",i=new p.Deferred;if(e){t+="?"+p.map(e,function(e,t){if(t=="connectionId"){t="connection_id"}if(t=="meta"){t="expand";e="meta"}return t+"="+e}).join("&")}g.rest.get(t).done(function(e){i.resolve(e)}).fail(function(){i.reject(arguments)});return i.promise()},export:function(e,t){var i=g.rest.url()+"tables/"+e+"/rows.csv";if(t){i+=r(t)}return i},byName:function(e,i){var t="tables/"+e,n=new p.Deferred;if(i){p.each(i,function(e,t){if(e=="connectionId"){i["connection_id"]=t;delete i[e]}if(e=="count"){i["expand"]="count";delete i[e]}})}g.rest.get(t,i).done(function(e){n.resolve(e)}).fail(function(){n.reject(arguments)});return n.promise()},rows:{list:function(e,t){var i="tables/"+e+"/rows",n=new p.Deferred;if(t){i+=r(t)}g.rest.get(i).done(function(e){n.resolve(e)}).fail(function(){n.reject(arguments)});return n.promise()},add:function(e,t,i){var n="tables/"+e+"/rows",r=new p.Deferred;if(!t){return}if(i){n+="?"+p.map(i,function(e,t){if(t=="connectionId"){t="connection_id"}return t+"="+e}).join("&")}g.rest.call("post",n,g.toXml("table",t),"text/xml").done(function(e,t){var i=t&&t.match(/tables\/rows\/(\w+)/);r.resolve(i&&i[1])}).fail(function(){r.reject(arguments)});return r.promise()},remove:function(e,t,i){var n="tables/"+e+"/rows/"+t,r=new p.Deferred;if(i){n+="?"+p.map(i,function(e,t){if(t=="connectionId"){t="connection_id"}return t+"="+e}).join("&")}g.rest.call("DELETE",n).done(function(){r.resolve()}).fail(function(){r.reject(arguments)});return r.promise()},update:function(e,i,t,n){var r="tables/"+e+"/rows/"+i,o=new p.Deferred;if(!t){return}if(n){r+="?"+p.map(n,function(e,t){if(t=="connectionId"){t="connection_id"}return t+"="+e}).join("&")}g.rest.call("put",r,JSON.stringify(t),"application/json").done(function(e,t){o.resolve([i])}).fail(function(){o.reject(arguments)});return o.promise()}},reset:function(e,t){var i=new p.Deferred,n="tables/"+e+"/reset";if(t){n+="?"+p.map(t,function(e,t){if(t=="connectionId"){t="connection_id"}return t+"="+e}).join("&")}g.rest.call("DELETE",n).done(function(){i.resolve()}).fail(function(){i.reject(arguments)});return i.promise()},remove:function(e,t){var i=new p.Deferred,n="tables/"+e;if(t){n+="?"+p.map(t,function(e,t){if(t=="connectionId"){t="connection_id"}return t+"="+e}).join("&")}g.rest.call("DELETE",n).done(function(){i.resolve()}).fail(function(){i.reject(arguments)});return i.promise()},create:function(e,t){var n=new p.Deferred,i="tables";if(!e){return}if(e.geometry==="line"||e.geometry==="LINE"){e.geometry="LINESTRING"}if(t){i+="?"+p.map(t,function(e,t){if(t=="connectionId"){t="connection_id"}return t+"="+e}).join("&")}g.rest.call("post",i,g.toXml("table",e),"text/xml").done(function(e,t){var i=t&&t.match(/tables\/(\w+)/);n.resolve([i&&i[1]])}).fail(function(){n.reject(arguments)});return n.promise()},join:function(e,t,i,n,r,o,s){var a=new p.Deferred,l=e.table||e,c=t.table||t,u=!!e.readOnly,d=!!t.readOnly,f="tables/"+l+"/join.json",h={connection_id:t.connection_id||-1,schema:t.schema||null,table:c,name:i,on:n,id_fields:r,source_read_only:u,target_read_only:d};if(o&&p.isArray(o.source)&&p.isArray(o.target)){h.fields=o}if(typeof s==="string"){h.join_type=s}g.rest.call("get",f,h,"application/json").done(function(e,t,i){var n=i.getResponseHeader("Location"),r=n&&n.match(/tables\/(\w+)/);a.resolve([r&&r[1]])}).fail(function(){a.reject(arguments)});return a.promise()},query:function(e,t,i){var n="tables/"+e+"/query.json?orm="+t.toString(),r=new p.Deferred;if(t.options){i=p.extend({},t.options,i||{})}if(i){n+="&"+p.map(i,function(e,t){if(t=="connectionId"){t="connection_id"}return t+"="+e}).join("&")}g.rest.get(n).done(function(e){r.resolve(e)}).fail(function(){r.reject(arguments)});return r.promise()}}})(giscloud.exposeJQuery(),giscloud.common());(function(o,s){"use strict";giscloud.bookmarks={list:function(e){var t="bookmarks",i=new o.Deferred;s.rest.get(t,e).done(function(e){i.resolve(e)}).fail(function(){i.reject()});return i.promise()},byMapId:function(e,t,i){var n="maps/"+e+"/bookmarks",r=new o.Deferred;s.rest.get(n,t).done(function(e){r.resolve(e)}).fail(function(){r.reject()});return r.promise()},remove:function(e){var t=new o.Deferred;s.rest.call("DELETE","bookmarks/"+e).done(function(){t.resolve()}).fail(function(){t.reject()});return t.promise()},create:function(e){var n=new o.Deferred;if(!e){return}s.rest.call("post","bookmarks",s.toXml("bookmark",e),"text/xml").done(function(e,t){var i=t&&t.match(/bookmarks\/(\w+)/);n.resolve([i&&i[1]])}).fail(function(){n.reject(arguments)});return n.promise()}}})(giscloud.exposeJQuery(),giscloud.common());(function(e,t,i,n){"use strict";giscloud.Role=function e(t){t=t||{};this.id=t.id;this.name=t.name;this.app_role=t.app_role||false;this.owner_id=t.owner_id||null;this.parent_id=t.parent_id||null;this.app_instance_id=t.app_instance_id||null};giscloud.Role.prototype={update:function e(t){var i=this,n={name:this.name};if(this.id!=null)return giscloud.roles.update(this.id,n,t);return giscloud.roles.create(n,t).done(function(e){i.id=e})},remove:function e(t){return giscloud.roles.remove(this.id,t)}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(o,s){"use strict";giscloud.roles={byId:function(e,t,i){var n="roles/"+e,r=new o.Deferred;t=t||{};if(typeof t==="function"){i=t;t=null}else{i=i||t.callback}s.rest.get(n,t).done(function(){var e=arguments[0],t;try{t=e;if(typeof i=="function"){i(t)}r.resolve(t)}catch(e){r.reject()}}).fail(function(){r.reject()});return r.promise()},list:function(i,n){var e="roles",r=new o.Deferred;i=i||{};if(typeof i==="function"){n=i;i=null}else{n=n||i.callback}if(i&&!i.perpage)i.nototal=1;s.rest.get(e,i).done(function(){var e=arguments[0],t=[];try{o.each(e.data,function(){t.push(new giscloud.Role(this))});if(!i||i.nototal)e.total=t.length;if(typeof n=="function"){n(t,e.total)}r.resolve(t,e.total)}catch(e){r.reject()}}).fail(function(){r.reject()});return r.promise()},create:function(e){var t=new o.Deferred,i=this;if(e.id!=null){return this.update(e.id,e)}s.rest.call("POST","roles/",JSON.stringify(e),"application/json").done(function(){t.resolveWith(i)}).fail(function(){t.rejectWith(i,arguments)});return t.promise()},update:function(e,t){var i=new o.Deferred,n=this;if(e==null){return this.create(t)}s.rest.call("PUT","roles/"+e,JSON.stringify(t),"application/json").done(function(){i.resolveWith(n)}).fail(function(){i.rejectWith(n,arguments)});return i.promise()},remove:function(e){var t=new o.Deferred,i=this;s.rest.call("DELETE","roles/"+e).done(function(){t.resolveWith(i)}).fail(function(){t.rejectWith(i,arguments)});return t.promise()},permissions:{list:function(e,t,i){var n=new o.Deferred;s.rest.get("roles/"+e+"/permissions/list",t).done(function(){var e=arguments[0],t;try{t=e;if(typeof i=="function"){i(t)}n.resolve(t)}catch(e){n.reject()}}).fail(function(){n.reject()});return n.promise()},add:function(e,t){var i=new o.Deferred,n=this;s.rest.call("POST","roles/"+e+"/permissions/add",JSON.stringify(t),"application/json").done(function(){i.resolveWith(n)}).fail(function(){i.rejectWith(n,arguments)});return i.promise()},remove:function(e,t){var i=new o.Deferred,n=this;s.rest.call("DELETE","roles/"+e+"/permissions/remove",JSON.stringify(t),"application/json").done(function(){i.resolveWith(n)}).fail(function(){i.rejectWith(n,arguments)});return i.promise()}},users:{list:function(e,i){var n=new o.Deferred;s.rest.get("roles/"+e+"/users/list").done(function(){var e=arguments[0],t;try{t=e;if(typeof i=="function"){i(t)}n.resolve(t)}catch(e){n.reject()}}).fail(function(){n.reject()});return n.promise()},add:function(e,t){var i=new o.Deferred,n=this;s.rest.call("POST","roles/"+e+"/users/add",JSON.stringify(t),"application/json").done(function(){i.resolveWith(n)}).fail(function(){i.rejectWith(n,arguments)});return i.promise()},remove:function(e,t){var i=new o.Deferred,n=this;s.rest.call("DELETE","roles/"+e+"/users/remove",JSON.stringify(t),"application/json").done(function(){i.resolveWith(n)}).fail(function(){i.rejectWith(n,arguments)});return i.promise()}}}})(giscloud.exposeJQuery(),giscloud.common());(function(e,i,t,n){"use strict";giscloud.File=function e(t){t=t||{};this.id=t.id;this.resourceId=t.resourceId||t.resource_id;this.created=t.created&&new Date(t.created*1e3);this.modified=t.modified&&new Date(t.modified*1e3);this.owner=t.owner?new giscloud.User(t.owner):t.owner_id;this.pathname=t.pathname;this.path=t.path;this.filename=t.filename;this.extension=t.extension;this.size=t.size;if(t.details)this.details=t.details;if(t.exif){this.exif={};if(t.exif.gps&&t.exif.gps.lon&&t.exif.gps.lat)this.exif.gps=new giscloud.LonLat(t.exif.gps.lon,t.exif.gps.lat);this.exif.date=t.exif.date}if(t.xmp){this.xmp={};this.xmp.panorama=t.xmp.panorama?true:false}this.isDir=t.isDir==null?t.is_dir==="t":t.isDir};giscloud.File.prototype={listContents:function(e){var t;if(!this.isDir){throw"giscloud.File: this is not a directory."}if(e){t=i.extend(true,{},e);if(t.expand){if(i.isArray(t.expand)&&i.inArray("dir")===-1){t.expand.push("dir");t.expand=t.expand.join(",")}else{t.expand=[t.expand,"dir"].join(",")}}t.expand="dir"}else{t={expand:"dir"}}return giscloud.files.byPath(this.pathname,t)},getDetails:function(){var t=this;return giscloud.files.byPath(this.pathname,{expand:"details"}).then(function(e){if(e.details){t.details=i.extend(true,{},e.details)}return t})},update:function(){var t=this,e={path:this.path,filename:this.filename,size:this.size};if(this.id==null){return giscloud.files.create(e).done(function(e){t.id=e})}return giscloud.files.update(this.id,e)},remove:function(){return giscloud.files.remove(this.id)}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(r,o){"use strict";function n(e){return encodeURIComponent(e).replace(/%2F/g,"/").replace(/%25/g,"%2525")}function s(e){var t;try{if(e.type==="files"){t=r.map(e.data||[],function(e){return new giscloud.File(e)});return r.Deferred().resolve(t,e.total)}return r.Deferred().resolve(new giscloud.File(e))}catch(e){console.log("Error creating giscloud.File",e);return r.Deferred().reject("Error creating giscloud.File",e)}}giscloud.files={list:function(e){var t="files",i=new r.Deferred;o.rest.get(t,e).then(function(e){if(!e.data){return r.Deferred().reject()}return s(e)}).done(function(e,t){i.resolve(e,t)}).fail(function(e,t){i.reject(e,t)});return i.promise()},byId:function(e,t){var i="files/"+e,n=new r.Deferred;if(t&&t.context&&t.contextId){i=t.context+"/"+t.contextId+"/"+i}o.rest.get(i,t).then(function(e){return s(e)}).done(function(e,t){n.resolve(e,t)}).fail(function(e,t){n.reject(e,t)});return n.promise()},byPath:function(e,t){return this.byId(n(e)+"/bypath.json",t)},create:function(e){var t=e.path==null||e.path===""||e.path==="/"?"":e.path+"/",i="files/"+n(t)+e.filename;return o.rest.call("POST",i,{},"application/json").then(function(e,t){var i=t&&t.match(/files\/(\w+)/);dfrd.resolve(i&&i[1])})},update:function(e,t){var i="files/"+e;return o.rest.call("PUT",i,JSON.stringify(t),"application/json")},remove:function(e){return o.rest.call("DELETE","files/"+e)}}})(giscloud.exposeJQuery(),giscloud.common());(function(r,o){"use strict";function s(e){try{return new giscloud.Stream(e)}catch(e){console.log("Error creating stream object",err);return null}}giscloud.streams={list:function(e,t){var i="resources/"+e+"/streams",n=new r.Deferred;o.rest.get(i,t).done(function(e){n.resolve(r.map(e.data,s))}).fail(function(){n.reject()});return n.promise()},byId:function(e,t){var i="streams/"+e,n=new r.Deferred;o.rest.get(i,t).done(function(e){n.resolve(s(e))}).fail(function(){n.reject()});return n.promise()},update:function(e,t){var i=new r.Deferred,n=this;o.rest.call("PUT","streams/"+e,JSON.stringify(t),"application/json").done(function(){i.resolveWith(n)}).fail(function(){i.rejectWith(n,arguments)});return i.promise()},remove:function(e){var t=new r.Deferred;o.rest.call("DELETE","streams/"+e).done(function(){t.resolve()}).fail(function(){t.reject()});return t.promise()},create:function(e){var n=new r.Deferred,t=e.context_id||e.contextId,i="resources/"+t+"/streams";if(!e){return}o.rest.call("post",i,e,"application/json").done(function(e,t){var i=t&&t.match(/streams\/(\w+)/);n.resolve(i&&i[1])}).fail(function(){n.reject(arguments)});return n.promise()}}})(giscloud.exposeJQuery(),giscloud.common());(function(r,o){"use strict";function s(e){try{return new giscloud.Post(e)}catch(e){console.log("Error creating post",err);return null}}giscloud.postTypes={COMMENT:1,DOCUMENT:2,DOODLE:3,LINK:4};giscloud.posts={list:function(e,t){var i="streams/"+e+"/posts",n=new r.Deferred;o.rest.get(i,t).done(function(e){n.resolve(r.map(e.data||[],s))}).fail(function(){n.reject()});return n.promise()},byId:function(e,t){var i="posts/"+e,n=new r.Deferred;o.rest.get(i,t).done(function(e){n.resolve(s(e))}).fail(function(){n.reject()});return n.promise()},update:function(e,t){var i=new r.Deferred,n=this;o.rest.call("PUT","posts/"+e,JSON.stringify(t),"application/json").done(function(){i.resolveWith(n)}).fail(function(){i.rejectWith(n,arguments)});return i.promise()},remove:function(e){var t=new r.Deferred;o.rest.call("DELETE","posts/"+e).done(function(){t.resolve()}).fail(function(){t.reject()});return t.promise()},create:function(e,t){var n=new r.Deferred;if(!t){return}o.rest.call("post","streams/"+e+"/posts",t,"application/json").done(function(e,t){var i=t&&t.match(/posts\/(\w+)/);n.resolve(i&&i[1])}).fail(function(){n.reject(arguments)});return n.promise()}}})(giscloud.exposeJQuery(),giscloud.common());(function(e,r,t,i){"use strict";function n(e){return r.map(e||[],function(e){return new giscloud.Resource(e)})}function o(e){if(e==null)return null;if(parseInt(e,10).toString()===e)return new Date(e*1e3);return new Date(e)}giscloud.Stream=function e(t){t=t||{};this.id=t.id;this.created=o(t.created);this.modified=o(t.modified);this.owner=t.owner;this.title=t.title;this.description=t.description;this.contextId=t.context_id||t.contextId;this.resources=n(t.resources);this.resourceId=t.resource_id||t.resourceId};giscloud.Stream.prototype={listPosts:function e(t){return giscloud.posts.list(this.id,t)},addPost:function e(t){if(!t||!(t instanceof giscloud.Post))throw"Invalid post";if(t.id!=null)return this.updatePost(t);t.streamId=this.id;return t.update()},updatePost:function e(t){if(!t||!(t instanceof giscloud.Post))throw"Invalid post";if(t.id==null){return this.addPost(t)}if(t.streamId!==this.streamId)throw"Post is not from this stream";return t.update()},update:function e(t){var i=this,n={title:this.title,description:this.description,resources:r.map(this.resources||[],function(e){return e.id}),resource_id:this.resourceId,context_id:this.contextId};if(this.id!=null)return giscloud.streams.update(this.id,n,t);return giscloud.streams.create(n,t).done(function(e){i.id=e})},remove:function e(t){return giscloud.streams.remove(this.id,t)}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,i,t,n){"use strict";function r(e){if(e.id)return new giscloud.Resource(e);return e}giscloud.Post=function e(t){t=t||{};this.id=t.id;this.streamId=t.stream_id||t.streamId;this.created=t.created&&new Date(t.created*1e3);this.modified=t.modified&&new Date(t.modified*1e3);this.owner=t.owner?new giscloud.User(t.owner):t.owner_id;this.type=t.type!=null&&giscloud.postTypes[t.type]||t.type;this.content=t.content;this.resourceId=t.resourceId!=null?t.resourceId:t.resource_id;this.attachments=i.isArray(t.attachments)?i.map(t.attachments,r):[]};giscloud.Post.prototype={update:function e(t){var i=this,n={content:this.content,type:parseInt(this.type),stream_id:this.streamId,attachments:this.attachments};if(this.id==null)return giscloud.posts.create(this.streamId,n).done(function(e){i.id=e});return giscloud.posts.update(this.id,n,t)},remove:function e(t){return giscloud.posts.remove(this.id,t)}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,s,a,t){function l(e){return encodeURIComponent(e).replace(/%2F/g,"/")}giscloud.storage={db:{import:function(e){if(e==null){e={}}if(e.geometryColumns){e.geometry_column_x=e.geometryColumns.x||e.geometryColumns.lon||e.geometryColumns.easting;e.geometry_column_y=e.geometryColumns.y||e.geometryColumns.lat||e.geometryColumns.northing;delete e.geometryColumns}else if(e.geometryColumn){e.geometry_column=e.geometryColumn;delete e.geometryColumn;if(e.geometryFormat){e.geometry_format=e.geometryFormat;delete e.geometryFormat}if(e.geometryType){e.geometry_type=e.geometryType;delete e.geometryType}}else{if(e.geometryColumnX){e.geometry_column_x=e.geometryColumnX;delete e.geometryColumnX}if(e.geometryColumnY){e.geometry_column_y=e.geometryColumnY;delete e.geometryColumnY}}if(e.geometrySRS!=null){e.geometry_srs=e.geometrySRS;delete e.geometrySRS}if(e.ifExists!=null){e.if_exists=e.ifExists||"fail";delete e.ifExists}else{e.if_exists=e.if_exists||"fail"}return a.rest.call("post","storage/db",e,"application/json").promise()}},fs:{list:function(e,t){var i="storage/fs/"+l(e)+"/info",n=new s.Deferred;t=t||{};a.rest.get(i,t).done(function(e){n.resolve(e)}).fail(function(){n.reject()});return n.promise()},get:function(e,t){var i="storage/fs/"+l(e)+"/get",n=new s.Deferred;t=t||{};a.rest.get(i,t).done(function(e){n.resolve(e)}).fail(function(){n.reject()});return n.promise()},update:function(e,t,i){var n=new s.Deferred,r=this,o;o="storage/fs/"+l(e);if(i){o+="?"+s.map(i,function(e,t){return t+"="+e}).join("&")}a.rest.call("PUT",o,JSON.stringify(t),"application/json").done(function(){n.resolveWith(r,[])}).fail(function(){n.rejectWith(r,arguments)});return n.promise()},mkdir:function(e){var n=new s.Deferred,r=this,t="storage/fs/"+l(e)+"/mkdir";a.rest.call("post",t,null,"application/json").done(function(e,t,i){n.resolveWith(r)}).fail(function(){n.rejectWith(r,arguments)});return n.promise()},create:function(e,t){var n=new s.Deferred,r=this,i="storage/fs/"+l(e);a.rest.call("post",i,JSON.stringify(t),"application/json").done(function(e,t,i){n.resolveWith(r)}).fail(function(){n.rejectWith(r,arguments)});return n.promise()},remove:function(e){var t=new s.Deferred,i=this,n="storage/fs/"+l(e);a.rest.call("delete",n).done(function(){t.resolveWith(i)}).fail(function(){t.rejectWith(i,arguments)});return t.promise()}}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(s,o){"use strict";giscloud.logs={list:function(e){var t="logs",i=new s.Deferred;e=e||{};e.expand="user,custom";o.rest.get(t,e).done(function(e){i.resolve(e)}).fail(function(){i.reject()});return i.promise()},byUserId:function(e,t,i){var n="users/"+e+"/logs",r=new s.Deferred;o.rest.get(n,t).done(function(e){r.resolve(e)}).fail(function(){r.reject()});return r.promise()},create:function(e){var n=new s.Deferred;if(!e){return}o.rest.call("post","logs",o.toXml("log",e),"text/xml").done(function(e,t){var i=t&&t.match(/logs\/(\w+)/);n.resolve([i&&i[1]])}).fail(function(){n.reject(arguments)});return n.promise()},analytics:{get:function(e){var t="logs/analytics",i=new s.Deferred;e=e||{};e.expand="";o.rest.get(t,e).done(function(e){i.resolve(e)}).fail(function(){i.reject()});return i.promise()}}};giscloud.log={actions:{sign_in:{code:1,desc:"signed in"},sign_out:{code:2,desc:"signed out"},map_create:{code:1001,desc:"created '${map.name}' map",intercom:{alias:"created-map"}},map_update:{code:1002,desc:"updated '${map.name}' map",intercom:{alias:"updated-map"}},layer_new:{code:1003,desc:"added '${layer.name}' layer",intercom:{alias:"added_layer"}},layer_update:{code:1004,desc:"updated '${layer.name}' layer"},share_map_to_user:{code:1005,desc:"shared map",intercom:{alias:"shared-map"}},share_map_remove_user:{code:1006,desc:"unshared map",intercom:{alias:"unshared-map"}},share_map_change_user_access:{code:1007,desc:"changed map access",intercom:{alias:"shared-map"}},share_map_public:{code:1008,desc:"made map public",intercom:{alias:"shared-map"}},layer_export:{code:1009,desc:"exported '${layer.name}' layer "},map_delete:{code:1010,desc:"deleted '${mid}' map"},layer_delete:{code:1011,desc:"deleted '${lid}' layer(s)"},layer_create:{code:1012,desc:"created new '${layer.name}' layer"},csv_import:{code:1013,desc:"imported '${source}' CSV file to '${output}' table"},feature_edit:{code:1014,desc:"updated feature in the '${layer.name}' layer"},feature_add:{code:1015,desc:"added feature in the '${layer.name}' layer",intercom:{alias:"added_feature"}},feature_delete:{code:1016,desc:"deleted feature in the '${layer.name}' layer"},resource_share:{code:1017,desc:"shared resource",intercom:{alias:[{condition:"type",value:100,alias:"shared-map"}]}},resource_unshare:{code:1018,desc:"unshared resource",intercom:{alias:[{condition:"type",value:100,alias:"unshared-map"}]}},tool_set:{code:1019,skipWoopra:true,desc:"Switch tool to '${tool}'"},ui_click:{code:1020,skipWoopra:true,desc:""},form_close:{code:1021,skipWoopra:true},form_open:{code:1022,skipWoopra:true},source_browser_view_type:{code:1023,skipWoopra:true},show_feature_info:{code:1024,skipWoopra:true},assign_license_in_organization:{code:1025,desc:"assigned licence to '${username}'"},remove_license_in_organization:{code:1026,desc:"removed licence to '${username}'"},remove_custom_app_in_manager:{code:1027,desc:"removed custom app with id '${appinstanceid}' in manager"},disable_user_in_organization:{code:1028,desc:"disable user with id '${id}' in organization"},add_new_attr_in_table:{code:1029,desc:"Added new attribute '${attribute}' in table '${table}'"},edit_attr_in_editor:{code:1030,desc:"Edit attribute '${changedattrs}' in layer '${layerid}'"},create_custom_app_in_manager:{code:1031,desc:"Create custom app '${appinstanceid}' in manager",intercom:{alias:"created_custom_app"}},create_user_in_manager:{code:1032,desc:"Create user '${username}' by owner '${owner}' in manager"},rename_file_in_file_manager:{code:1033,desc:"Rename file '${newname}' in file manager by user '${username}'"},rename_table_in_db_manager:{code:1034,desc:"Rename table '${newname}' in db manager by user '${username}'"},custom_app_update_in_manager:{code:1035,desc:"Custom app updated in manager"},create_folder_in_layerlist:{code:1036,desc:"Create folder in layerlist in map '${mapid}'"},remove_file_from_storage:{code:1037,desc:"Remove files '${files}' from storage"},change_email_in_manager:{code:1038,desc:"Change email '${newemail}' in manager"},filemanager_upload:{code:1039,desc:"Upload file '${filename}' in file manager in source '${source}'",intercom:{alias:"uploaded-file"}},delete_project_in_mdcp:{code:1040,desc:"Delete project '${project}' in mdcp"},remove_table_from_db_manager:{code:1041,desc:"Remove table '${tables}' from db manager"},manager_dashboard_visit:{code:1041,desc:"manager dashboard visit"},consent_form_submit:{code:1042,desc:"user successfully submitted the consent form"},map_archive:{code:1050,desc:"user successfully archived map"},map_restore:{code:1051,desc:"user successfully restored map"},"used appearance wizard":{code:1052,desc:"user has successfully used the appearance wizard",intercom:{alias:"used_appearance_wizard"}},"opened appearance window":{code:1053,desc:"user has successfully opened the appearance window",intercom:{alias:"opened_appearance_window"}},"created report":{code:1054,desc:"user created report from layer '${layerId}"},"spatial selection":{code:1055,desc:"user used spatial selection"},"connect to external database":{code:1056,desc:"user has successfully created a connection to external PostGIS database",intercom:{alias:"connected_to_external_database"}},paste_layer_styles:{code:1060,desc:"user clicked on paste layer styles button"},switch_to_3d:{code:1062,desc:"user switched to 3D view",intercom:{alias:"switched_to_3D"}},switch_to_2d:{code:1063,desc:"user switched to 2D view"},mouse_down_with_ctrl:{code:1064,desc:"user pressed mouse down with CTRL key"},choose_subscription:{code:11001,desc:"Chosen subscription"},gt_user_add:{code:12100,desc:"added user (username '${username})'"},gt_device_add:{code:12100,desc:"added device with ID '${gps_device_id}'"},gt_device_edit:{code:12101,desc:"edit device with ID '${gps_device_id}'"},gt_requested_report:{code:12120,desc:"requested a report (report type id = ${report_type})"},gt_switch_to_new_app:{code:12121,desc:"user clicked on 'Switch to new app' button"},oauth_sign_in:{code:1e4,desc:"(OAuth) signed in"},oauth_sign_out:{code:10001,desc:"(OAuth) signed out"},"mdc proj create":{code:20001,desc:"mdc proj create",intercom:{alias:"created-mdc-project"}},"mdc proj option update":{code:20011,desc:"mdc proj option update"},"mdc proj option update failed":{code:20012,desc:"mdc proj option update failed"},"mdc proj name update":{code:20021,desc:"mdc proj name update"},"mdc proj name update failed":{code:20022,desc:"mdc proj name update failed"},"mdc proj item add":{code:20031,desc:"mdc proj item add"},"mdc proj item add failed":{code:20032,desc:"mdc proj item add failed"},"mdc proj item reorder":{code:20041,desc:"mdc proj item reorder"},"mdc proj item reorder failed":{code:20042,desc:"mdc proj item reorder failed"},"mdc proj item rename":{code:20051,desc:"mdc proj item rename"},"mdc proj item rename failed":{code:20052,desc:"mdc proj item rename failed"},"mdc proj item type change":{code:20061,desc:"mdc proj item type change"},"mdc proj item type change failed":{code:20062,desc:"mdc proj item type change failed"},"mdc proj item remove":{code:20071,desc:"mdc proj item remove"},"mdc proj item remove failed":{code:20072,desc:"mdc proj item remove failed"},"mdc proj form definition change":{code:20081,desc:"mdc proj form definition change"},"mdc proj form definition change failed":{code:20082,desc:"mdc proj form definition change failed"},"mdc proj projects button is first click":{code:20091,desc:"mdc proj projects button is first click"},mdc_sign_up:{code:25e3,desc:"signed up to MDC"},mdc_sign_in:{code:25001,desc:"signed in to MDC"},mdc_sign_out:{code:25002,desc:"signed out to MDC"},mdc_insert:{code:25003,desc:"sent new submission"},mdc_update:{code:25004,desc:"updated submission"},mdc_delete:{code:25005,desc:"deleted submission"},mdc_error:{code:25999,desc:"error occured"},"sign up social media -click":{code:3e4,desc:"Came to Sign Up form using social media."},"sign up create account button":{code:30001,desc:"Came to Sign Up form using Create account button."},"sign up step 1":{code:30002,desc:"Open Sign up step 1."},"sign up step 2":{code:30003,desc:"Open Sign up step 2."},"sign up step 3":{code:30004,desc:"Open Sign up step 3."},"sign up step 4":{code:30005,desc:"Open Sign up step 4."},"sign up step 5":{code:30006,desc:"Open Sign up step 5."},"manager visit":{code:30007,desc:"Open Manager after Sign Up."},p2_sign_in:{code:32e3,desc:"signed in"},p2_sign_out:{code:32001,desc:"signed out"},p2_switch_to_old_app:{code:32002,desc:"user returned to p1 app from p2 track web"},_:{}},push:function(t,n,i,e){n=n||{};var r=giscloud.log.actions[t];if(r&&r.code>=1e3){var o=s.extend(true,null,n);delete o.module;delete o.task;delete o.msg;delete o.result;if(!e)giscloud.logs.create({event:r.code,custom:o})}if(!r||r&&!r.skipWoopra){(function e(){if(!window.woopra){if(window.dfdWoopra)window.dfdWoopra.done(function(){giscloud.log.push(t,n,i,true)});return}window.woopra.track(t,n,i)})()}(function e(){var t;if(!window.intercomSettings||!window.intercomWrapper){return}else if(r&&r.intercom&&r.intercom.alias){t=r.intercom.alias;if(typeof t==="string"){window.intercomWrapper.sendEvent(t,n)}else if(Array.isArray(t)){for(var i in t){if(t[i].alias&&t[i].condition!==undefined&&n[t[i].condition]==t[i].value){window.intercomWrapper.sendEvent(t[i].alias,n)}}}}})()},getActionByCode:function(i,e){var n=null;if(e)i=i*1+1e5;s.each(giscloud.log.actions,function(e,t){if(t.code==i){n=t;return true}});return n},formatLogDetails:function(e){var t="";t+=moment.utc(e.time*1e3).local().format("DD/MM/YYYY hh:mm");if(e.log=="log"){t+=" App: "+e.domain}t+=" Device: ";if(e.log=="log"){switch(e.device_type*1){case 1:t+="Computer";break;case 2:t+="Tablet";break;case 3:t+="Mobile";break;default:}}else{t+=e.custom.device_model+" v"+e.custom.device_version}return t},formatLogMsg:function(e){var t,i=giscloud.log.getActionByCode(e.event,e.log=="mdc");t="User '"+e.user.username+"' ";if(i){try{t+=s.tmpl(i.desc,e.custom).text()}catch(e){t+=i.desc}}else{t+="did '"+e.event+"' event"}t+=" "+moment.utc(e.time*1e3).local().fromNow();t+=".";return t}}})(giscloud.exposeJQuery(),giscloud.common());(function(o,s){"use strict";giscloud.organizations={list:function(e){var t="organizations",i=new o.Deferred;s.rest.get(t,e).done(function(e){i.resolve(e)}).fail(function(){i.reject()});return i.promise()},byId:function(e,t,i){var n="/organizations/"+e,r=new o.Deferred;s.rest.get(n,t).done(function(e){r.resolve(e)}).fail(function(){r.reject()});return r.promise()},remove:function(e){var t=new o.Deferred;s.rest.call("DELETE","organizations/"+e).done(function(){t.resolve()}).fail(function(){t.reject()});return t.promise()},create:function(e){var n=new o.Deferred;if(!e){return}s.rest.call("post","organizations",s.toXml("organization",e),"text/xml").done(function(e,t){var i=t&&t.match(/organizations\/(\w+)/);n.resolve([i&&i[1]])}).fail(function(){n.reject(arguments)});return n.promise()}}})(giscloud.exposeJQuery(),giscloud.common());(function(o,s){"use strict";giscloud.HookType={CREATE:1,READ:2,UPDATE:3,DELETE:4};giscloud.hooks={list:function(e){var t="hooks",i=new o.Deferred;s.rest.get(t,e).done(function(e){i.resolve(e)}).fail(function(){i.reject()});return i.promise()},byId:function(e,t,i){var n="/hooks/"+e,r=new o.Deferred;s.rest.get(n,t).done(function(e){r.resolve(e)}).fail(function(){r.reject()});return r.promise()},remove:function(e){var t=new o.Deferred;s.rest.call("DELETE","hooks/"+e).done(function(){t.resolve()}).fail(function(){t.reject()});return t.promise()},update:function(e,t){var i=new o.Deferred,n=this;s.rest.call("PUT","hooks/"+e,JSON.stringify(t),"application/json").done(function(){i.resolveWith(n)}).fail(function(){i.rejectWith(n,arguments)});return i.promise()},create:function(e){var n=new o.Deferred;if(!e){return}s.rest.call("post","hooks",s.toXml("hook",e),"text/xml").done(function(e,t){var i=t&&t.match(/hooks\/(\w+)/);n.resolve([i&&i[1]])}).fail(function(){n.reject(arguments)});return n.promise()}}})(giscloud.exposeJQuery(),giscloud.common());(function(e,n,r,t){giscloud.tasks={list:function(e){e=e||{};return r.rest.get("tasks",e).pipe(function(e){if(e&&e.data){if(e.data.length===0){return[]}return n.map(e.data,function(e){return new giscloud.Task(e)})}return null},function(){return null}).promise()},byType:function(e,t){t=t||{};t["type"]=e;return this.list(t)},byId:function(e,t){var i="tasks/"+e;t=t||{};return r.rest.get(i,t).pipe(function(e){try{return new giscloud.Task(e)}catch(e){return null}},function(){return null}).promise()},remove:function(e){return r.rest.call("DELETE","tasks/"+e).pipe(function(){return null},function(){return null}).promise()},create:function(e,t){var i="tasks/";if(t){i+="?"+n.map(t,function(e,t){return t+"="+e}).join("&")}if(e.id!=null){delete e.id}return r.rest.call("post",i,JSON.stringify(e),"application/json").pipe(function(e,t,i){var n=t||i.getResponseHeader("Location"),r=n&&n.match(/tasks\/(\d+)/);return r&&r[1]},function(){return null}).promise()}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,t){"use strict";giscloud.permissions={OWNER:"OWNER",READ:"READ",EDIT:"EDIT",EXPORT:"EXPORT",EDIT_MOBILE:"EDIT_MOBILE",EDIT_WITH_SHARE:"EDIT_WITH_SHARE",INSERT:"INSERT",INSERT_MDC:"INSERT_MDC",UPDATE:"UPDATE",UPDATE_MDC:"UPDATE_MDC",DELETE:"DELETE",DELETE_MDC:"DELETE_MDC",SHARE:"SHARE"}})(giscloud.exposeJQuery(),giscloud.common());(function(o,e,t){function i(e,t,i){var n=e.promise,r=Array.prototype.slice.apply(i);return n[t].apply(n,r)}giscloud.Query=function(e,t){this.table=e;this.options=t;this.actions=[]};giscloud.Query.prototype={select:function(e){this.actions.push(["select",[e]]);return this},selectFunction:function(e,t){this.actions.push(["select_function",[e,t]]);return this},where:function(e,t,i){this.actions.push(["where",[e,t,i]]);return this},whereOpen:function(){this.actions.push(["where_open"]);return this},whereClose:function(){this.actions.push(["where_close"]);return this},andWhere:function(e,t,i){this.actions.push(["and_where",[e,t,i]]);return this},andWhereOpen:function(){this.actions.push(["and_where_open"]);return this},andWhereClose:function(){this.actions.push(["and_where_close"]);return this},orWhere:function(e,t,i){this.actions.push(["or_where",[e,t,i]]);return this},orWhereOpen:function(){this.actions.push(["or_where_open"]);return this},orWhereClose:function(){this.actions.push(["or_where_close"]);return this},equalTo:function(e,t){return this.where(e,"=",t)},notEqualTo:function(e,t){return this.where(e,"<>",t)},greaterThan:function(e,t){return this.where(e,">",t)},greaterThanOrEqualTo:function(e,t){return this.where(e,">=",t)},lessThan:function(e,t){return this.where(e,"<",t)},lessThanOrEqualTo:function(e,t){return this.where(e,"<=",t)},limit:function(e){this.actions.push(["limit",[e]]);return this},offset:function(e){this.actions.push(["offset",[e]]);return this},ascending:function(e){this.actions.push(["order_by",[e,"ASC"]]);return this},descending:function(e){this.actions.push(["order_by",[e,"DESC"]]);return this},find:function(){this.actions.push(["find_all"]);this.promise=giscloud.tables.query(this.table,this.toString(),this.options);return this},first:function(){this.actions.push(["find"]);this.promise=giscloud.tables.query(this.table,this.toString(),this.options);return this},count:function(){this.actions.push(["count_all"]);this.promise=giscloud.tables.query(this.table,this.toString(),this.options);return this},join:function(e,t){this.actions.push(["join",[e,t]]);return this},on:function(e,t,i){this.actions.push(["on",[e,t,i]]);return this},delete:function(){this.actions.push(["delete"]);this.promise=giscloud.tables.query(this.table,this.toString(),this.options);return this},set:function(e,t){this.actions.push(["__set",[e,t]]);return this},save:function(){this.actions.push(["save"]);this.promise=giscloud.tables.query(this.table,this.toString(),this.options);return this},saveAll:function(){this.actions.push(["save_all"]);this.promise=giscloud.tables.query(this.table,this.toString(),this.options);return this},groupBy:function(e){this.actions.push(["group_by",[e]]);return this},fail:function(){return i(this,"fail",arguments)},done:function(){return i(this,"done",arguments)},always:function(){return i(this,"always",arguments)},progress:function(){return i(this,"progress",arguments)},then:function(){return i(this,"then",arguments)},each:function(t){return this.promise.done(function(e){o.each(e.data,t)})},toString:function(){return JSON.stringify(this.actions)}};giscloud.Query.or=function(e){var t,i,n,r=new giscloud.Query;if(o.isArray(e)){i=e}else{i=Array.prototype.slice.apply(arguments)}for(n=0;n<i.length;n++){t=i[n];if(t.table&&!r.table)r.table=t.table;if(t.options&&!r.options)r.options=t.options;r.orWhereOpen();r.actions=r.actions.concat(t.actions);r.orWhereClose()}return r}})(giscloud.exposeJQuery(),giscloud.common());(function(s,a){"use strict";giscloud.options={list:function(e){var t;e=e||{};if(s.isNumeric(e)){t="resources/"+e+"/options"}else if(e.resource&&e.id){t=e.resource+"/"+e.id+"/options";delete e.resource;delete e.id}else{t="options"}return a.rest.get(t,e).promise()},byId:function(e,t,i){var n="options/"+e,r=new s.Deferred;t=t||{};if(typeof t==="function"){i=t;t=null}else{i=i||t.callback}a.rest.get(n,t).done(function(){var e=arguments[0],t;try{t=e;if(typeof i=="function"){i(t)}r.resolve(t)}catch(e){r.reject()}}).fail(function(){r.reject()});return r.promise()},byName:function(e,n,t,r){var i="users/"+e+"/options",o=new s.Deferred;t=t||{};n=n||t.name;t.expand=t.expand||[];if(!s.isArray(t.expand)){t.expand=[t.expand]}if(s.inArray("dependency",t.expand)){t.expand.push("dependency")}a.rest.get(i,t).done(function(){var e=arguments[0],i=[];try{s.each(e.data,function(e,t){if(t.name==n){i.push(t)}});if(typeof r=="function"){r(i)}o.resolve(i)}catch(e){o.reject()}}).fail(function(){o.reject()});return o.promise()},update:function(e,t,i){var n=t.resource+"/"+t.id+"/options/"+e;if(e==null){return this.create(t,i)}return a.rest.call("PUT",n,JSON.stringify(i),"application/json").promise()},remove:function(e){return a.rest.call("DELETE","options/"+e).promise()},create:function(e,t){var i;if(!t){throw"No option data supplied."}if(s.isNumeric(e)){i="resources/"+e+"/options"}else if(e&&e.resource&&e.id){i=e.resource+"/"+e.id+"/options"}else{throw"Bad target definition."}return a.rest.call("post",i,t,"application/json").then(function(e,t){var i=t&&t.match(/options\/(\w+)/);return i&&i[1]})}}})(giscloud.exposeJQuery(),giscloud.common());(function(s,a){"use strict";function r(e){return"?"+s.map(e,function(e,t){if(t=="connectionId"){t="connection_id"}if(t=="noGeometryField"){t="no_geometry_field"}if(t=="perPage"){t="perpage"}return t+"="+e}).join("&")}giscloud.datasources={types:{FOLDER:5,DATABASE:10,DATABASE_ANY:15,TABLE:15,FILE:20,WMS_ANY:40,WMS:50,TMS:60,WFS:70,WMTS:80},typeCodeToTypeName:function e(t){var i=parseInt(t,10);switch(i){case 5:return a.__("Folder");case 15:case 10:return a.__("Table");case 20:return a.__("File");case 40:case 50:return a.__("WMS");case 60:return a.__("TMS");case 70:return a.__("WFS");case 80:return a.__("WMTS");default:return""}},typeNameToTypeCode:function e(t){var i=t.toLocaleLowerCase&&t.toLocaleLowerCase();switch(i){case"folder":return 5;case"database":return 10;case"database_any":return 15;case"table":return 15;case"file":return 20;case"wmts":return 80;case"wms_any":return 40;case"wms":return 50;case"tms":return 60;case"wfs":return 70;case a.__("Folder").toLocaleLowerCase():return 5;case a.__("Table").toLocaleLowerCase():return[10,15];case a.__("File").toLocaleLowerCase():return 20;case a.__("WMTS").toLocaleLowerCase():return 80;case a.__("WMS").toLocaleLowerCase():return[40,50];case a.__("TMS").toLocaleLowerCase():return 60;case a.__("WFS").toLocaleLowerCase():return 70;default:return null}},list:function(e){var t="datasources",i=new s.Deferred;a.rest.get(t,e).done(function(e){i.resolve(e)}).fail(function(){i.reject()});return i.promise()},byId:function(e,t,i){var n="datasources/"+e,r=new s.Deferred;t=t||{};if(typeof t==="function"){i=t;t=null}else{i=i||t.callback}a.rest.get(n,t).done(function(){var e=arguments[0],t;try{t=new giscloud.datasources.Datasource(e);if(typeof i=="function"){i(t)}r.resolve(t)}catch(e){r.reject()}}).fail(function(){r.reject()});return r.promise()},update:function(e,t){var i=new s.Deferred,n=this;if(e==null){return this.create(t)}a.rest.call("PUT","datasources/"+e,JSON.stringify(t),"application/json").done(function(){i.resolveWith(n)}).fail(function(){i.rejectWith(n,arguments)});return i.promise()},remove:function(e){var t=new s.Deferred;a.rest.call("DELETE","datasources/"+e).done(function(){t.resolve()}).fail(function(){t.reject()});return t.promise()},create:function(e){var n=new s.Deferred;if(!e){return}a.rest.call("post","datasources",e,"application/json").done(function(e,t){var i=t&&t.match(/datasources\/(\w+)/);n.resolve([i&&i[1]])}).fail(function(){n.reject(arguments)});return n.promise()},columns:function(e,t,i){var n,r=new s.Deferred;if(s.isNumeric(e)){n="datasources/"+e+"/columns"}else{n="datasources/columns?source="+e}t=t||{};if(typeof t==="function"){i=t;t={}}else{i=i||t.callback}a.rest.get(n,t).done(function(){var e=arguments[0];try{if(typeof i=="function"){i(e)}r.resolve(e)}catch(e){r.reject(e)}}).fail(function(e){r.reject(e)});return r.promise()},addColumn:function(e,t,i){var n,r=new s.Deferred;if(!t){return}if(s.isNumeric(e)){n="datasources/"+e+"/columns?"}else{n="datasources/columns?source="+e}if(i){if(i.connid)n+="&connid="+i.connid;if(i.schema)n+="&schema="+i.schema;if(i.type)n+="&type="+i.type}a.rest.call("post",n,a.toXml("column",t),"text/xml").done(function(e,t){var i=t&&t.match(/datasources\/(\w+)/);r.resolve([i&&i[1]])}).fail(function(){r.reject.apply(r,arguments)});return r.promise()},dropColumn:function(e,t,i){var n,r=new s.Deferred,o=this;if(!t){return}if(s.isNumeric(e)){n="datasources/"+e+"/columns?"}else{n="datasources/columns?source="+e}if(i){if(i.connid)n+="&connid="+i.connid;if(i.schema)n+="&schema="+i.schema;if(i.type)n+="&type="+i.type}a.rest.call("DELETE",n,a.toXml("column",t),"text/xml").done(function(){r.resolveWith(o)}).fail(function(){r.reject(arguments)});return r.promise()},updateColumn:function(e,t,i){var n,r=new s.Deferred,o=this;if(!t){return}if(s.isNumeric(e)){n="datasources/"+e+"/columns?"}else{n="datasources/columns?source="+e}if(i){if(i.connid)n+="&connid="+i.connid;if(i.schema)n+="&schema="+i.schema;if(i.type)n+="&type="+i.type}a.rest.call("PUT",n,a.toXml("column",t),"text/xml").done(function(){r.resolveWith(o)}).fail(function(){r.reject(arguments)});return r.promise()},data:{list:function(e,t){var i="datasources/"+e+"/data",n=new s.Deferred;if(t){i+=r(t)}a.rest.get(i).done(function(e){n.resolve(e)}).fail(function(){n.reject(arguments)});return n.promise()},add:function(e,t,i){var n="datasources/"+e+"/data",r=new s.Deferred;if(!t){return}if(i){n+="?"+s.map(i,function(e,t){if(t=="connectionId"){t="connection_id"}return t+"="+e}).join("&")}a.rest.call("post",n,a.toXml("datasource",t),"text/xml").done(function(e,t){var i=t&&t.match(/datasources\/data\/(\w+)/);r.resolve(i&&i[1])}).fail(function(){r.reject(arguments)});return r.promise()},remove:function(e,t,i){var n="datasources/"+e+"/data/"+t,r=new s.Deferred;if(i){n+="?"+s.map(i,function(e,t){if(t=="connectionId"){t="connection_id"}return t+"="+e}).join("&")}a.rest.call("DELETE",n).done(function(){r.resolve()}).fail(function(){r.reject(arguments)});return r.promise()},update:function(e,i,t,n){var r="datasources/"+e+"/data/"+i,o=new s.Deferred;if(!t){return}if(n){r+="?"+s.map(n,function(e,t){if(t=="connectionId"){t="connection_id"}return t+"="+e}).join("&")}a.rest.call("put",r,JSON.stringify(t),"application/json").done(function(e,t){o.resolve([i])}).fail(function(){o.reject(arguments)});return o.promise()}}}})(giscloud.exposeJQuery(),giscloud.common());(function(e,t,i){var n;giscloud.datasources.Datasource=function(e){n=e;if(n){this.id=n.id;this.resource_id=n.resource_id;this.name=n.name;this.owner=n.owner_id;this.type=n.type;this.epsg=n.epsg&&parseInt(n.epsg,10);this.proj4=n.proj4;this.description=n.description;this.copyright=n.copyright;if(n.type!=15&&n.type!=20){this.params=t.parseJSON(n.params)}else{this.params=n.params}if(n.x_min&&n.x_max&&n.y_min&&n.y_max){this.bounds=new giscloud.Bounds(n.x_min,n.y_min,n.x_max,n.y_max)}}else{n={}}this.share=function(e,t){return giscloud.datasources.share(this.id,e,t)};this.remove=function(){return giscloud.datasources.remove(this.id)};this.update=function(e){return;var t;n.data=this.data;t=this.bounds;that=this;if(t){n.__x_min=t&&t.left;n.__y_min=t&&t.bottom;n.__x_max=t&&t.right;n.__y_max=t&&t.top}if(this.id!=null){return giscloud.datasources.update(this.id,n)}else{return giscloud.datasources.update(n.id,n).done(function(e){that.id=e})}};this.clone=function(){return giscloud.datasources.create(n.data)}}})(window,giscloud.exposeJQuery());(function(o,s){"use strict";var a=null;giscloud.datasources.sfdc={checkAuth:function(e){var t,i;if(e!=null){t="datasources/"+e+"/sfdc/oauth.json"}else if(a!=null){t="datasources/"+a+"/sfdc/oauth.json"}else{throw"No datasource id"}i=new o.Deferred;s.rest.get(t,options).fail(i.reject).done(function(e){if(e.access_token){i.resolve(e)}else{i.reject(e)}});return i.promise()},get:function(e,t){var i;if(typeof e==="string"){if(a!=null){i="datasources/"+a+"/sfdc/"+e}else{throw"No datasource id"}}else{if(e.datasource!=null){i="datasources/"+e.datasource+"/sfdc/"+e.resource}else if(a!=null){i="datasources/"+a+"/sfdc/"+e.resource}else{throw"No datasource id"}}return s.rest.get(i,t).promise()},create:function(e,t,i){var n=new o.Deferred,r;if(e.datasource!=null){r="datasources/"+e.datasource+"/sfdc/"+e.resource}else if(a!=null){r="datasources/"+a+"/sfdc/"+e.resource}else{throw"No datasource id"}return s.rest.call("post",r,JSON.stringify(t),"application/json",i).pipe(function(e,t){if(e.success)return e.id},function(){return null})},remove:function(e,t,i){var n=new o.Deferred,r;if(e.datasource!=null){r="datasources/"+e.datasource+"/sfdc/"+e.resource}else if(a!=null){r="datasources/"+a+"/sfdc/"+e.resource}else{throw"No datasource id"}return s.rest.call("DELETE",r+"/"+t)},datasource:function(e){if(e===undefined){return a}a=e;return this}}})(giscloud.exposeJQuery(),giscloud.common());(function(o,r){"use strict";giscloud.datasources.wms={getFeatureInfo:function(e,t){var i=new o.Deferred,n="layers/"+e+"/getfeatureinfo";r.rest.call("get",n,t,"text/html").done(function(){var e=arguments[0];try{i.resolve(e.responseText)}catch(e){i.reject()}}).fail(function(){var e=arguments[0];i.reject(e.responseText)});return i.promise()},getCapabilities:function(e,t){var i=new o.Deferred,n,r;n="/modules_gc/layer/cwms.php";r={task:"getcapabilities",module:"wms",wms:e,version:t?t:"1.1"};o.ajax({url:n,type:"GET",cache:false,dataType:"json",data:r}).done(function(){var e=Array.prototype.slice.apply(arguments);i.resolve.apply(i,e)}).fail(function(){var e=Array.prototype.slice.apply(arguments);i.reject.apply(i,e)});return i.promise()}};giscloud.datasources.wmts={getCapabilities:function(e,t){var i=new o.Deferred,n,r;n="/datasource/wmts_info";r={url:e,version:t?t:"1.1"};o.ajax({url:n,type:"GET",cache:false,dataType:"json",data:r}).done(function(){var e=Array.prototype.slice.apply(arguments);i.resolve.apply(i,e)}).fail(function(){var e=Array.prototype.slice.apply(arguments);i.reject.apply(i,e)});return i.promise()}}})(giscloud.exposeJQuery(),giscloud.common());(function(a,l){"use strict";giscloud.spatialrelationship={within:function(e,t,i,n,r){var o="geometry/within",s=new a.Deferred;r=r||{};r.layer1_id=e;r.layer2_id=i;r.feature1_id=t;r.feature2_id=n;l.rest.get(o,r).done(function(e,t,i){s.resolve(i.status==201)}).fail(function(){s.reject()});return s.promise()},intersects:function(e,t,i,n,r){var o="geometry/intersects",s=new a.Deferred;r=r||{};r.layer1_id=e;r.layer2_id=i;r.feature1_id=t;r.feature2_id=n;l.rest.get(o,r).done(function(e,t,i){s.resolve(i.status==201)}).fail(function(){s.reject()});return s.promise()}}})(giscloud.exposeJQuery(),giscloud.common());(function(e,o,t){function i(e){if(e==null){return null}if(typeof e==="string"){try{return JSON.parse(e)}catch(e){return null}}else{return e}}giscloud.Layer=function(t){var e=[];if(t.sublayers){o.each(t.sublayers,function(){e.push(new giscloud.Layer(this))})}o.extend(this,{id:t.id,resourceId:t.resource_id,name:t.name||null,owner:t.owner,source:i(t.source),datasourceId:t.datasource_id,columns:t.columns||null,onscale:t.onscale||null,offscale:t.offscale||null,label:t.label||null,textfield:t.textfield||null,styles:i(t.styles),alpha:t.alpha||null,encoding:t.encoding||null,margin:t.margin||null,created:t.created&&new Date(t.created*1e3)||null,visible:t.visible||null,lock:t.lock||null,raster:t.raster||null,grp:t.grp||null,exportable:t.exportable!="f",parent:t.parent||null,epsg:t.epsg||null,tooltip:t.tooltip||null,label_placement:i(t.label_placement),mapId:t.map_id||null,type:t.type||null,opened:t.opened,order:t.order,sublayers:e,useInfoWindow:t.use_info_window!=null?t.use_info_window:false,modified:t.modified&&new Date(t.modified*1e3)||null,form:t.form||null,bounds:new giscloud.Bounds(t.x_min,t.y_min,t.x_max,t.y_max)});if(t.datasource){this.datasource={id:t.datasource_id,type:t.datasource.type,owner_id:t.datasource.owner_id,permissions:t.datasource.permissions,resource_id:t.datasource.resource_id}}if(t.analysis){this.analysis={id:t.analysis.id,layer_id:t.analysis.layer_id,type:t.analysis.type,params:t.analysis.params}}if(t.options){this.options=t.options}if(this.form&&typeof this.form.definition==="string"){this.form.definition=JSON.parse(this.form.definition)}this.copyStylesFrom=function(e){var t,i,n,r;r=this;t=new o.Deferred;i=this.styles;giscloud.layers.byId(e).done(function(e){n=e.styles;r.styles=n;t.resolve({newStyles:n,oldStyles:i})}).fail(function(){t.reject()});return t.promise()};this.remove=function(){return giscloud.layers.remove(this.id)};this.update=function(){var e;t.name=this.name||null;t.source=this.source&&JSON.stringify(this.source)||null;t.datasource_id=this.datasourceId||null;t.columns=this.columns||null;t.onscale=this.onscale||null;t.offscale=this.offscale||null;t.label=this.label||null;t.textfield=this.textfield||null;t.alpha=this.alpha||null;t.encoding=this.encoding||null;t.margin=this.margin||null;t.visible=this.visible||null;t.lock=this.lock||null;t.raster=this.raster||null;t.grp=this.grp||null;t.parent=this.parent||null;t.tooltip=this.tooltip||null;t.label_placement=this.label_placement&&JSON.stringify(this.label_placement)||null;t.styles=this.styles&&JSON.stringify(this.styles)||null;t.map_id=this.mapId||null;t.type=this.type||null;t.opened=this.opened;t.order=this.order||null;t.form=this.form;t.use_info_window=this.useInfoWindow!=null?this.useInfoWindow:null;e=this.bounds;if(e&&e.valid()){t.x_min=e.left;t.y_min=e.bottom;t.x_max=e.right;t.y_max=e.top}return giscloud.layers.update(t.id,t)};this.clone=function(){var e={};o.extend(e,t);delete e.id;return giscloud.layers.create(e)};this.reset=function(){return giscloud.layers.reset(this.mapId,[this.id])}};giscloud.Layer.prototype={createBuffer:function(e){return giscloud.layers.createBuffer(this.id,e)}}})(window,giscloud.exposeJQuery());(function(e,t,i){function n(e){if(!e){return}if(typeof e==="number"){e=e*1e3}return new Date(e)}function r(e){var t={};if(e.__score){t.score=e.__score}if(e.__match){t.match=e.__match}if(e.__distance){t.distance=e.__distance}return t}giscloud.Feature=function(e){var i=e,t=r(i);if(i){this.id=i.__id!=null?i.__id:i.id;this.created=n(i.__created);this.modified=n(i.__modified);this.owner=i.__owner;this.layerId=i.__layerId!=null?i.__layerId:i.__layer_id||i.layerId;this.geometry=i.__geometry||i.geometry||null;this.bounds=new giscloud.Bounds(i.__xmin,i.__ymin,i.__xmax,i.__ymax);this.data=i.data||{};this.meta=i.meta;if(Object.keys(t).length>0){this.searchResult=t}}else{i={}}this.remove=function(){return giscloud.features.remove(this.layerId,this.id)};this.update=function(e){var t;i.layerId=this.layerId;i.data=this.data;i.geometry=this.geometry;t=this.bounds;that=this;delete i.__geometry;if(t){i.__x_min=t&&t.left;i.__y_min=t&&t.bottom;i.__x_max=t&&t.right;i.__y_max=t&&t.top}if(this.id!=null){return giscloud.features.update(i.layerId,this.id,i,e)}else{return giscloud.features.update(i.layerId,null,i,e).done(function(e){that.id=e})}};this.clone=function(){return giscloud.features.create(this.layerId,{data:i.data,geometry:i.geometry})}}})(window,giscloud.exposeJQuery());(function(e,n,t,s){giscloud.ViewerLayer=function(e){var t,i;if(e){this.id=parseInt(e.getId().replace(/layer(\d+)/,"$1"),10);i=e.getData();this.sourceId=i&&i.srcId;this.source=i&&i.src;t=e.getBound();this.bounds=t&&new giscloud.Bounds(t.xMin,t.yMin,t.xMax,t.yMax);this.instance=e}else{throw"Invalid arguments."}};giscloud.ViewerLayer.prototype={visible:function(){var e=arguments[0],t;if(n.type(e)=="boolean"){t=this.instance.viewer&&this.instance.viewer.getLayerByName("llayer"+this.id);if(e){this.instance.enable();t&&t.enable()}else{this.instance.disable();t&&t.disable()}return this}else{return this.instance.getVisibility()}},selectable:function(){var e=arguments[0];if(n.type(e)=="boolean"){this.instance.setSelectable(e);return this}else{return this.instance.getSelectable()}},opacity:function(){var e=arguments[0];if(n.type(e)=="number"){this.instance.setAlpha(e);return this}else{return this.instance.getAlpha()}},expressions:function(t){var i=this;if(!this.instance||!this.instance.features)throw"Invalid layer.";return n.map(this.instance.features,function(e){if(t&&t.withExpression&&t.withExpression!=e.expression)return;if(t&&t.withLabel&&t.withLabel!=e.expressionLabel)return;return new giscloud.ViewerLayerExpression(i,e)}).reverse()},redraw:function(){var e;e=this.instance.viewer.getLayerByName("llayer"+this.id);if(e){e.redraw()}this.instance.redraw()},expressionVisible:function(e,t){var i,n,r;if(e==null)throw"No index param provided.";if(!this.instance||!this.instance.features||!this.instance.features[e])throw"Invalid layer expression.";i=this.instance.features.length-e-1;if(t===s)return this.instance.features[i].visible!==false;n=this.instance.viewer.getLayerByName("llayer"+this.id);r=this.instance.features[i].expression;this.instance.features[i].visible=!!t;if(n){for(var o=0;o<n.features.length;o++){if(n.features[o].expression===r){n.features[o].visible=!!t}}n.redraw(true)}this.instance.features[i].visible=!!t;this.instance.calculateFeatureVisibility();this.instance.redraw(true);return this}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,t,i,n){var r;giscloud.ViewerLayerExpression=function(e,t){var i,n;if(t){this.instance=t;r=e;this.expression=t&&t.expression;this.label=t&&t.expressionLabel}else{throw"Invalid arguments."}};giscloud.ViewerLayerExpression.prototype={visible:function(e){this.instance.visible=!!e;r.instance.calculateFeatureVisibility();r.instance.redraw();return this}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,c,u,d){giscloud.ViewerSelection=function(e){var r={},o=e,s={},a=0,l=u.oid(),t={};if(e&&e.constructor===giscloud.Viewer){c.extend(this,{add:function(e,t,i){if(r[t]===d){r[t]=[]}if(c.inArray(r[t],e)===-1){r[t].push(e);a++;if(!i){c(s).triggerHandler("featureAdd",[{featureId:e,layerId:t},this])}}return this},highlightSelected:function e(){var i=null,n=null;c.each(r,function(e,t){n=parseInt(e,10);c.each(t,function(e,t){i=parseInt(t,10);u.highlight(o.instance,i,n,false)})});return this},clearHighlight:function e(){u.highlight(o.instance,"",null,true);return this},remove:function(e,t){var i,n=r[t];if(n!==d){i=c.inArray(e,n);if(i>-1){n.splice(i,1);a--;c(s).triggerHandler("featureRemove",[{featureId:e,layerId:t},this])}}return this},toggle:function(e,t){if(this.isSelected(e,t)){this.remove(e,t)}else{this.add(e,t)}return this},clear:function(e){if(e!==d&&r[e]!==d){a-=r[e].length;delete r[e]}else{a=0;r={}}this.clearHighlight();c(s).triggerHandler("selectionClear",[this]);return this},isSelected:function(e,t){return r[t]!==d&&c.inArray(e,r[t])>-1},selected:function(e){var t=[],i=this.add,n=true;if(c.isArray(e)){if(a>0){this.clear()}c.each(e,function(e,t){i(t.featureId,t.layerId,n)});c(s).triggerHandler("multipleFeaturesAdd",[c.map(e,function(e){return{featureId:e.featureId,layerId:e.layerId}}),this]);return this}c.each(r,function(e){c.each(this,function(){t.push({featureId:this,layerId:e})})});return t},count:function(){return a},bind:function(e,t){var i=this,n;if(e&&typeof e=="string"&&typeof t=="function"){n=function(){t.apply(i,Array.prototype.slice.call(arguments,1))};c(s).on(e,n);if(!t.gcunbind){t.gcunbind={}}t.gcunbind[l+e]=n}return this},unbind:function(e,t){var i;if(e&&typeof e=="string"&&typeof t=="function"){i=t.gcunbind&&t.gcunbind[l+e];if(i){c(s).off(e,i)}}return this},featureAdd:function(e){return this.bind("featureAdd",e)},featureRemove:function(e){return this.bind("featureRemove",e)},selectionClear:function(e){return this.bind("selectionClear",e)},ctrlDown:false})}else{throw"Invalid constructor arguments."}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(p,m,g,v){var y=/^layer(\d+)\|\|(\d+)$/,i,a,r,_,b,w,x,k,C,L,T,j,M,I;giscloud.Viewer=function(){var s=this,e=arguments,o=g.oid(),c={},a=["columns","options"],l=new m.Deferred,u,d,t,f,h;if(typeof e[0]==="string"){this.containerId=t=e[0];this.mapId=f=e[1];h=e[2]||{};this.initializing=new m.Deferred;this.loading=new m.Deferred;this.layersLoading=new m.Deferred;h.graphicScalebar=true;if(h.offscreenRendering===true){try{this.offscreenRendering=p.OffscreenCanvas&&new OffscreenCanvas(1,1).getContext("2d")&&new OffscreenCanvas(1,1).transferToImageBitmap&&p.Worker}catch(e){this.offscreenRendering=false}}this.mode=h.mode==="3D"&&giscloud.browserSupportsGL()?"3D":"2D";i.call(this,t,h).done(function(e){var t,i,n,r=s.flashnavigator,o=new k(e);o.plugins={};o.plugins.marker=new C(o);o.plugins.kartehr=new L(o);o.plugins.canvas=new T(o);o.plugins.tooltip=new j(o);o.plugins.kartehr.liveSite("http://www.mapcow.org/");if(h.scalebar){o.plugins.scalebar=new M(o)}if(h.slider){o.plugins.slider=new I(o)}o.enablePanWithMiddleButton();s.instance=o;o.parent=s;o.addEventListener("layerRemoved",m.proxy(_,s));o.addEventListener("load",function(){m.when(u,d).always(function(e,t){if(h.dontWaitForLayers){if(giscloud&&giscloud.layers&&s.mapId!=null){giscloud.layers.byMapId(s.mapId,{expand:a.join(",")}).done(function(e){b(s,e,t,a);s.layersLoading.resolveWith(s,[e,t])}).fail(s.layersLoading.reject)}}b(s,e,t,a);if(e){s.layersLoading.resolveWith(s,[e,t])}s.graphic=new giscloud.Graphic(s);if(!s.selection){s.selection=new giscloud.ViewerSelection(s);s.selection.featureAdd(function(e){g.highlight(s.instance,e.featureId,e.layerId,false);m(c).triggerHandler("selectionChange",{action:"add",feature:e})});s.selection.bind("multipleFeaturesAdd",function(e){var t={},i,n,r;for(i=0,n=e.length;i<n;i++){r=e[i].layerId;if(t[r]===v){t[r]=[e[i].featureId]}else{t[r].push(e[i].featureId)}}for(r in t){if(t.hasOwnProperty(r)){g.highlightMultiple(s.instance,t[r],r,false)}}m(c).triggerHandler("selectionChange",{action:"add",feature:e})});s.selection.featureRemove(function(e,t){var i=m.map(t.selected(),function(e){return"layer"+e.layerId+"||"+e.featureId}).join();g.highlight(s.instance,i,null,true);m(c).triggerHandler("selectionChange",{action:"remove",feature:e})});s.selection.selectionClear(function(){s.instance.modifyObject(null,{},null,true);m(c).triggerHandler("selectionChange",{action:"clear"})})}if(giscloud.proj4){giscloud.proj4.defs("GC_MAP_CURRENT",s.instance.projection)}s.projection=s.instance.projection;s.loading.resolveWith(s,[]);m(c).triggerHandler("loaded",[s]);m(c).triggerHandler("ready",[s])})});o.addEventListener("reload",function(){m.when(u,d).always(function(e,t){if(h.dontWaitForLayers){if(giscloud&&giscloud.layers&&s.mapId!=null){giscloud.layers.byMapId(s.mapId,{expand:a.join(",")}).then(function(e){e=e||[];e=e.sort(function(e,t){if(e.order!=null&&e.order!=null){return parseInt(e.order,10)>parseInt(t.order,10)?1:-1}return 0});return e}).done(function(e){b(s,e,t,a);s.layersLoading.resolveWith(s,[e,t])}).fail(s.layersLoading.reject)}}b(s,e,t,a);if(e){s.layersLoading.resolveWith(s,[e,t])}if(giscloud.proj4){giscloud.proj4.defs("GC_MAP_CURRENT",s.instance.projection)}s.projection=s.instance.projection;s.loading.resolveWith(s,[]);m(c).triggerHandler("reloaded",[s])})});if(s.instance.setLayerFeatureFilter&&r.extraOptions){for(t in r.extraOptions.data){s.instance.setLayerFeatureFilter("layer"+t,r.extraOptions.data[t])}}i=w.call(s,h.filterFeatures);n=x.call(s,h.initialBounds);n.fail(function(){console.warn("Not loading map due to initialBounds error.")});m.when(i,n,l).then(function(e,t){if(f){s.loadMap(f,v,t)}s.initializing.resolveWith(s,[]);m(c).triggerHandler("init",[s])})});this.initializing.done(function(){this.instance.addControlPlaceholders();this.instance.addAttributionControl();if(g.giscloudToolbar){p.toolbarControl=this.instance.addControl(g.giscloudToolbar)}if(g.LocationToolbar){p.locationToolbarControl=this.instance.addControl(g.LocationToolbar)}this.areaMeasure=giscloud.ui.defaultTools.tool("areaMeasure");this.areaMeasure.viewer=this;this.distanceMeasure=giscloud.ui.defaultTools.tool("distanceMeasure");this.distanceMeasure.viewer=this});if(h.graphicScalebar){this.initializing.done(function(){this.instance.addScaleControl()})}}else{g.setError(this,"constructor","Invalid constructor arguments")}this.activeLayer=null;this.markers=[];this.editing=null;m.extend(this,{bind:function(e,n){var r=this,t;if(e&&typeof e==="string"&&typeof n==="function"){switch(e){case"mouseDown":t=function(e){n.call(r,new giscloud.LonLat(e.x,e.y),{containerX:e.containerX,containerY:e.containerY})};this.initializing.done(function(){r.instance.addEventListener("mousedown",t)});break;case"mouseUp":t=function(e){n.call(r,new giscloud.LonLat(e.x,e.y))};this.initializing.done(function(){r.instance.addEventListener("mouseup",t)});break;case"mouseMove":t=function(e){n.call(r,new giscloud.LonLat(e.x,e.y))};this.initializing.done(function(){r.instance.addEventListener("mousemove",t)});break;case"doubleClick":t=function(e){n.call(r,new giscloud.LonLat(e.x,e.y))};this.initializing.done(function(){r.instance.addEventListener("doubleClick",t)});break;case"dragEnd":t=function(){n.call(r)};this.initializing.done(function(){r.instance.addEventListener("dragend",t)});break;case"scaleChange":t=function(e){n.call(r,r.instance.convertScale(e.zoom))};this.initializing.done(function(){r.instance.addEventListener("scalechange",t)});break;case"boundsChange":t=function(e){var t=new giscloud.Bounds(e.bounds.xMin,e.bounds.yMin,e.bounds.xMax,e.bounds.yMax);n.call(r,t)};this.initializing.done(function(){r.instance.addEventListener("boundschange",t)});break;case"featureClick":t=function(e){var t=e.id.match(y),i={layerId:parseInt(t[1],10),featureId:parseInt(t[2],10),key:e.key,attributes:e.object?e.object.attributes:e.attributes};n.call(r,i)};this.initializing.done(function(){r.instance.addEventListener("object_click",t)});break;case"featureDoubleclick":t=function(e){var t=e.id.match(y);n.call(r,{layerId:parseInt(t[1],10),featureId:parseInt(t[2],10),key:e.key,attributes:e.object?e.object.attributes:e.attributes})};this.initializing.done(function(){r.instance.addEventListener("object_dblclick",t)});break;case"featureOver":t=function(e){var t=e.id.match(y);n.call(r,{layerId:parseInt(t[1],10),featureId:parseInt(t[2],10),key:e.key,attributes:e.object?e.object.attributes:e.attributes})};this.initializing.done(function(){r.instance.addEventListener("object_over",t)});break;case"featureOut":t=function(e){var t=e.id.match(y);n.call(r,{layerId:parseInt(t[1],10),featureId:parseInt(t[2],10),key:e.key,attributes:e.object?e.object.attributes:e.attributes})};this.initializing.done(function(){r.instance.addEventListener("object_out",t)});break;case"mapTilesReady":this.initializing.done(function(){r.instance.addEventListener("mapTilesReady",n)});break;case"measure":this.initializing.done(function(){r.instance.on("measure",n)});break;default:t=function(){var e=Array.prototype.slice.call(arguments,1);n.apply(r,e)};m(c).on(e,t);break}if(!n.gcunbind){n.gcunbind={}}n.gcunbind[o+e]=t}return this},getRenderParams:function(e){var u=this,t=e;function d(e){var t=u.instance.calculateScaleZoom(e);return u.instance.convertScale(t)}function f(e,t){var i=e/d(t);return-1*Math.floor(Math.log(i)/Math.log(2))}function i(e){var t,i,n,r,o,s,a,l,c=u.scale();t=f(e,c);i=Math.pow(2,t);n=d(c)/i/e;r=m(u.container());o=r.width()*i;s=r.height()*i;a=Math.round(n*o);l=Math.round(n*s);return{scale:n,width:a,height:l}}return i(t)},unbind:function(e,t){var i=this,n;if(e&&typeof e==="string"&&typeof t==="function"){n=t.gcunbind&&t.gcunbind[o+e];if(n){switch(e){case"mouseDown":this.initializing.done(function(){i.instance.removeEventListener("mousedown",n)});break;case"mouseUp":this.initializing.done(function(){i.instance.removeEventListener("mouseup",n)});break;case"mouseMove":this.initializing.done(function(){i.instance.removeEventListener("mousemove",n)});break;case"doubleClick":this.initializing.done(function(){i.instance.removeEventListener("doubleClick",n)});break;case"dragEnd":this.initializing.done(function(){i.instance.removeEventListener("dragend",n)});break;case"scaleChange":this.initializing.done(function(){i.instance.removeEventListener("scalechange",n)});break;case"boundsChange":this.initializing.done(function(){i.instance.removeEventListener("boundschange",n)});break;case"featureClick":this.initializing.done(function(){i.instance.removeEventListener("object_click",n)});break;case"featureDoubleclick":this.initializing.done(function(){i.instance.removeEventListener("object_dblclick",n)});break;case"featureOver":this.initializing.done(function(){i.instance.removeEventListener("object_over",n)});break;case"featureOut":this.initializing.done(function(){i.instance.removeEventListener("object_out",n)});break;case"measure":this.initializing.done(function(){i.instance.off("measure",n)});break;default:m(c).off(e,n);break}}}return this},fire:function(e,t){m(c).triggerHandler(e,t)},zoomToCurrentLocation:function(n){var e;m(c).triggerHandler("startGeolocation");if(navigator.geolocation==null){console.log("Browser doesn't support geolocation.");m(c).triggerHandler("endGeolocation",{error:"Browser doesn't support geolocation."});return this}if(giscloud.proj4){e=this.loading}else{e=m.when(giscloud.includeJs(g.liveSite()+"libs/proj4js/proj4.js"),this.loading)}e.fail(function(e){m(c).triggerHandler("endGeolocation",{error:e})}).done(m.proxy(function(){var e={enableHighAccuracy:true,timeout:1e4,maximumAge:n?Infinity:2e4},t=function(e){var t;if(e){switch(e.code){case 1:t="No permission to get geolocation.";break;case 2:t="No geolocation available.";break;case 3:t="Geolocation request timed out.";break;default:t="Error acquiring geolocation (code: "+(e.code||"?")+")."}console.log(t);m(c).triggerHandler("endGeolocation",{error:t});if(e.message){console.log(e.message)}}else{console.log("Error acquiring geolocation.");m(c).triggerHandler("endGeolocation",{error:"Error acquiring geolocation."})}},i=m.proxy(function(e){var t={x:e.coords.longitude,y:e.coords.latitude},i=Math.max(e.coords.accuracy,70),n=this.bounds(),r,o,s,a=p.navigator.userAgent,l=a.indexOf("MSIE ");if(typeof this.projection==="string"){giscloud.proj4.defs("GC_MAP_CURRENT",this.projection)}t=giscloud.proj4("EPSG:4326",this.projection,t);if(l>0){return this.center(new giscloud.LonLat(t.x,t.y),11)}if(!i){return this.center(new giscloud.LonLat(t.x,t.y))}n.center(new giscloud.LonLat(t.x,t.y));if(this.projection.units==="degrees"){if(this.projection.a){if(this.projection.b){o=(this.projection.a+this.projection.b)/2}else{o=this.projection.a}}r=g.haversine(n.top,n.left,n.bottom,n.right,o);s=r/2/i;i=Math.max(n.width(),n.height())/s}else{i=giscloud.fromMeters(this.projection.units,i)}if(n.width()>n.height()){n.height(i*3,true)}else{n.width(i*3,true)}this.bounds(n);m(c).triggerHandler("endGeolocation",{bounds:n,center:n.center(),radius:i})},this);navigator.geolocation.getCurrentPosition(i,t,e)},this));return this},addLayersExpandParam:function(){var e=Array.prototype.slice.call(arguments),t=Array.prototype.concat.apply([],e),i;for(i=t.length-1;i>=0;i--){if(a.indexOf(t[i])===-1){a.push(t[i])}}},removeLayersExpandParam:function(){var e=Array.prototype.slice.call(arguments),t=Array.prototype.concat.apply([],e),i,n;for(i=t.length-1;i>=0;i--){n=a.indexOf(t[i]);if(n>-1){a.splice(n,1)}}},getXmlUrl:function(e){var t=[],i=g.liveSite()+"maps/map"+(e||this.mapId)+".xml",n;if(h.silentAccess){t.push("silent_access")}if(giscloud.oauth2){n=giscloud.oauth2.token();if(n){t.push("oauth_token="+n)}}n=giscloud.apiKey();if(n){t.push("api_key="+n);if(g.https()&&g.liveSite().indexOf("http://giscloud.local")!==0){i=i.replace("http:","https:")}}if(t.length>0)i+="?"+t.join("&");return i},loadLayersAndStates:function(){if(giscloud&&giscloud.layers&&this.mapId!=null&&!h.dontWaitForLayers){u=giscloud.layers.byMapId(this.mapId,{expand:a.join(",")}).then(function(e){e=e||[];e=e.sort(function(e,t){if(e.order!=null&&e.order!=null){return parseInt(e.order,10)>parseInt(t.order,10)?1:-1}return 0});return e})}else{u=m.Deferred().resolve(null)}if(giscloud&&giscloud.userOptions&&this.mapId!=null&&h.userLayerStates){d=giscloud.userOptions.byName("MAP_"+this.mapId+"_LAYERS_STATES").then(function(e){var t;try{t=e&&e.value&&JSON.parse(e.value);if(!t){return{}}return t}catch(e){return{}}},function(){return m.Deferred().resolve({})})}else{d=m.Deferred().resolve({})}return m.when(u,d)}});l.resolve()};m.extend(giscloud.Viewer.prototype,{loadMap:function(e,t,i){var n,r,o;if(!this.instance){g.setError(this,"loadMap","No viewer instance.");return this}if(!e){g.setError(this,"loadMap","Invalid map id.");return this}n=this.getXmlUrl(e);if(this.loading.state()!=="pending"){this.loading=new m.Deferred}if(this.layersLoading.state()!=="pending"){this.layersLoading=new m.Deferred}this.instance.src(true);if(i){o=i;if(!m.isFunction(o.valid)){o=new giscloud.Bounds(o.left,o.bottom,o.right,o.top)}if(o.valid()){o={xMin:o.left,yMin:o.top,xMax:o.right,yMax:o.bottom}}else{console.warn("Initial bounds are not valid.",i);o=null}}this.mapId=e;var s=this;this.loadLayersAndStates().always(function(){s.instance.load(n,false,t,o)});return this},reloadMap:function(e){var t,i;if(!this.instance){g.setError(this,"reloadMap","No viewer instance.");return this}if(!this.mapId){g.setError(this,"reloadMap","Invalid map id.");return this}t=this.getXmlUrl();if(this.loading.state()!=="pending"){this.loading=new m.Deferred}if(this.layersLoading.state()!=="pending"){this.layersLoading=new m.Deferred}var n=this;this.loadLayersAndStates().always(function(){if(e){n.instance.unload()}n.instance.reload(t)});return this},ready:function(e){return this.bind("ready",e)},mapTilesReady:function(e){return this.bind("mapTilesReady",e)},init:function(e){return this.bind("init",e)},mouseDown:function(e){return this.bind("mouseDown",e)},mouseUp:function(e){return this.bind("mouseUp",e)},mouseMove:function(e){return this.bind("mouseMove",e)},doubleClick:function(e){return this.bind("doubleClick",e)},dragEnd:function(e){return this.bind("dragEnd",e)},scaleChange:function(e){return this.bind("scaleChange",e)},boundsChange:function(e){return this.bind("boundsChange",e)},featureClick:function(e){return this.bind("featureClick",e)},featureDoubleclick:function(i){this.initializing.done(function(){this.instance.addEventListener("object_dblclick",function(e){var t=e.id.match(y);i({layerId:t[1],featureId:t[2],key:e.key,attributes:e.object?e.object.attributes:e.attributes})})});return this},featureOver:function(i){this.initializing.done(function(){this.instance.addEventListener("object_over",function(e){var t=e.id.match(y);i({layerId:t[1],featureId:t[2],key:e.key,attributes:e.object?e.object.attributes:e.attributes})})});return this},featureOut:function(i){this.initializing.done(function(){this.instance.addEventListener("object_out",function(e){var t=e.id.match(y);i({layerId:t[1],featureId:t[2],key:e.key,attributes:e.object?e.object.attributes:e.attributes})})});return this},selectionChange:function(e){return this.bind("selectionChange",e)},container:function(e){if(e===v){return m("#"+this.containerId)[0]}else{m("#"+e).append(m("#"+this.containerId).detach());this.containerId=e;return this}},width:function(e){if(e!==v){m("#"+this.containerId).width(e);if(this.instance){this.instance.invalidateSize()}return this}else{return m("#"+this.containerId).width()}},height:function(e){if(e!==v){m("#"+this.containerId).height(e);if(this.instance){this.instance.invalidateSize()}return this}else{return m("#"+this.containerId).height()}},bounds:function(e,t){var i;if(e!==v){this.loading.done(function(){this.instance.setViewBound(e.left,e.bottom,e.right,e.top,null,!t)});return this}else{i=this.instance.getViewBound();return new giscloud.Bounds(i.xMin,i.yMin,i.xMax,i.yMax)}},center:function(t,i,n,r){if(t!==v){if(!t||!(t instanceof giscloud.LonLat)){throw"Parameter 'center' should be a giscloud.LonLat instance."}else{this.loading.done(function(){var e=this.bounds();if(e&&e.center()){this.instance.setLocation(t.lon,t.lat,i,n,r)}else{throw"Viewer bounds are not set."}});return this}}else{var e=this.instance.getCenter();return new giscloud.LonLat(e.x,e.y)}},scale:function(e){if(e!==v){if(!isFinite(e)){throw"Parameter 'scale' should be a finite number."}else{this.loading.done(function(){this.instance.setScale(e)});return this}}else{return this.instance.getScale()}},bearing:function(e){if(e!==v){if(!isFinite(e)){throw"Parameter 'bearing' should be a finite number."}else{this.loading.done(function(){this.instance.setBearing(e)});return this}}else{return this.instance.getBearing()}},pitch:function(e){if(e!==v){if(!isFinite(e)){throw"Parameter 'pitch' should be a finite number."}else{this.loading.done(function(){this.instance.setPitch(e)});return this}}else{return this.instance.getPitch()}},showLayer:function(i){var e;e=this.layers.reduce(function(e,t){if(e){return e}if(t.id===i){e=t}return e},null);if(e){e.visible(true);this.showLayerLabels(i)}return this},hideLayer:function(i){var e;e=this.layers.reduce(function(e,t){if(e){return e}if(t.id===i){e=t}return e},null);if(e){e.visible(false);this.hideLayerLabels(i)}return this},showLayerLabels:function(e){giscloud.util.mediator.publish("labels/show",e);var t="llayer"+e,i=this.instance.getLayerByName(t);if(i){i.enable()}},hideLayerLabels:function(e){giscloud.util.mediator.publish("labels/hide",e);var t="llayer"+e,i=this.instance.getLayerByName(t);if(i){i.disable()}},layerById:function(e){var t,i,n;if(this.loading.state()==="resolved"){n=parseInt(e,10);for(t=0,i=this.layers.length;t<i;t++){if(this.layers[t].id===n){return this.layers[t]}}}return null},showTip:function(e,t){var i=this.instance.plugins.tooltip;this.initializing.done(function(){i.show(e,t)});return this},hideTip:function(){var e=this.instance.plugins.tooltip;this.initializing.done(function(){e.hide()});return this},addMarker:function(f){this.loading.done(function(){var u=this.instance.plugins.marker,n,e,t,i,l,d;l=function(e,t,i,n,r,o){var s,a,l,c;a=f.rotation();l=f.label();c=f.clickable();i=i||"";n=n?d(i,n):"";if(t.url!=null){s=o.loadPoi(e.lon,e.lat,t.url,{hoverText:i,popupContent:n,popupVisible:r},c,t.width,t.height,v,t.anchor)}else{s=o.loadPoi(e.lon,e.lat,t,{hoverText:i,popupContent:n,popupVisible:r},c);if(l){o.attachLabel({marker:s,data:l})}if(a){o.move(s,e.lon,e.lat,a)}}u.ready(s).done(function(e){if(!e._popup)return;if(f._popupCloseHandler){e._popup.on("close",f._popupCloseHandler)}if(f._popupOpenHandler){e._popup.on("open",f._popupOpenHandler)}});return s};d=function(e,t){var i=m("<div/>");if(e){i.append(m("<div/>",{class:"gc-info-popup-title"}).html(e))}if(t){i.append(m("<div/>",{class:"gc-info-popup-content"}).html(t))}return i.html()};i=function(e,t){var i=this.instance.plugins.marker,n=t.state,r=n.marker,o=r._id||null,s=t.newValue,a=r.location();if(t.oldValue===s){return}switch(t.property){case"location":if(s&&s instanceof giscloud.LonLat&&s.valid()&&r.visible()){if(o){i.move(o,s.lon,s.lat)}else{r._id=l(s,r.icon(),r.title(),r.content(),r.popup(),i)}}else{o&&i.remove(o);r._id=null}break;case"rotation":if(o){i.move(o,a.lon,a.lat,s)}break;case"visible":if(s&&a&&a instanceof giscloud.LonLat&&a.valid()){r._id=l(a,r.icon(),r.title(),r.content(),r.popup(),i)}else{o&&i.remove(o);r._id=null}break;case"popup":if(o){i.remove(o);r._id=l(a,r.icon(),r.title(),r.content(),s,i)}break;case"title":if(o){i.remove(o);r._id=l(a,r.icon(),s,r.content(),r.popup(),i)}break;case"content":if(o){i.remove(o);r._id=l(a,r.icon(),r.title(),s,r.popup(),i)}break;case"icon":if(o){i.remove(o);r._id=l(a,s,r.title(),r.content(),r.popup(),i)}break;case"label":if(o){if(s){i.attachLabel({marker:o,data:s})}else{i.remove(o);r._id=l(a,r.icon(),r.title(),r.content(),r.popup(),i)}}break;default:}};if(f instanceof giscloud.Marker){t=f.location();e=f.visible();ico=f.icon()||null;this.markers.push(f);m(f).on("stateChanged",m.proxy(i,this));f._popupCloseHandler=function(){f.popup(false,true)};f._popupOpenHandler=function(){f.popup(true,true)};if(e&&t&&t instanceof giscloud.LonLat&&t.valid()){f._id=l(t,ico,f.title(),f.content(),f.popup(),u)}}else if(f instanceof giscloud.FlagMarker){n=f.sig;if(n&&g.markers[n].m){throw"This marker has already been added to a viewer."}else{f.sig="m"+g.oid();n=f.sig;if(!g.markers){g.markers={}}g.markers[n]={m:u};e=f.visible();t=f.position();if(e&&t){g.markers[n].id=u.add(t.lon,t.lat,f.color().hex("0x"),f.title(),f.content(),null,true)}else{g.markers[n].id=null}this.markers.push(f);g.markers[n].open=true;g.markers[n].openCloseHandler=function(e,t,i){if(g.markers[n]){g.markers[n].open=i}};g.markers[n].initHandler=function(){u.getObject(g.markers[n].id).on("toggle",g.markers[n].openCloseHandler);g.markers[n].initHandler=null};if(g.markers[n].id){g.markers[n].initHandler()}}}else if(f instanceof giscloud.LabelMarker){n=f.sig;if(n&&g.markers[n].m){throw"This marker has already been added to a viewer."}f.sig="m"+g.oid();n=f.sig;if(!g.markers){g.markers={}}g.markers[n]={m:u,label:{className:"gc-map-tip",type:"div"}};t=f.location();e=f.visible();this.markers.push(f);m(f).on("stateChanged",m.proxy(r,this));if(e&&t&&t instanceof giscloud.LonLat&&t.valid()){t=this.instance.toInternalCoords(t.lon,t.lat);g.markers[n].marker=this.instance.newMarker(t,{icon:g.markers[n].label,clickable:false},f.content()||"");this.instance.addComponentToMap(g.markers[n].marker)}}else{throw"Not a giscloud marker."}});return this},removeMarker:function(n){this.loading.done(function(){var e=this.instance.plugins.marker,t;if(n instanceof giscloud.Marker){if(n._id){var i=e.getObject(n._id);if(i._popup){if(n._popupCloseHandler){i._popup.off("close",n._popupCloseHandler);n._popupCloseHandler=null}if(n._popupOpenHandler){i._popup.off("open",n._popupOpenHandler);n._popupOpenHandler=null}}e.remove(n._id)}t=m.inArray(n,this.markers);if(t>-1){this.markers.splice(t,1)}}else if(n instanceof giscloud.FlagMarker){if(n.sig&&g.markers[n.sig].m===e){if(e.getObject(g.markers[n.sig].id))e.getObject(g.markers[n.sig].id).off("toggle",g.markers[n.sig].openCloseHandler);g.markers[n.sig].m.remove(g.markers[n.sig].id);delete g.markers[n.sig].openCloseHandler;delete g.markers[n.sig];t=m.inArray(n,this.markers);if(t>-1){this.markers.splice(t,1)}delete n.sig}else if(n.sig){throw"This is not a marker which belongs to this viewer."}}else if(n instanceof giscloud.LabelMarker){if(n.sig&&g.markers[n.sig].m===e){g.markers[n.sig].marker.remove();delete g.markers[n.sig];t=m.inArray(n,this.markers);if(t>-1){this.markers.splice(t,1)}delete n.sig;m(n).off("stateChanged",r)}else if(n.sig){throw"This is not a marker which belongs to this viewer."}}else{throw"Not a giscloud marker."}});return this},createAsMaplimProject:function(e){var t=new m.Deferred;if(!this.options||!this.options.EMBLIM_PROJECT||this.options.EMBLIM_PROJECT!=="1"){giscloud.options.create({resource:"maps",id:e},{option_name:"EMBLIM_PROJECT",option_value:"1"}).done(function(){t.resolve()}).fail(function(){t.reject()})}else{t.resolve()}return t.promise()},openInMaplim:function(){var t=parseInt(this.mapId,10),i;this.createAsMaplimProject.call(this,t).done(function(){giscloud.maps.byId(t).done(function(e){i=getUrlFromAppName("maplim");i+="map/"+t+"/"+e.name;p.open(i)})}).fail(function(){alert("Problem with opening map in Maplim! You don't have edit rights for this map. Please contact owner of the map!")})},fullExtent:function(){var e=this.instance;this.loading.done(function(){e.setViewBound()});return this},measure:function(){var e=this;this.loading.done(function(){e.select(false);e.instance.setTool("MeasureTool")});return this},areaZoom:function(){var e=this;this.loading.done(function(){e.select(false);e.instance.setTool("SelectAreaTool")});return this},pan:function(){var e=this;this.loading.done(function(){e.select(false);e.instance.setTool("DragTool")});return this},zoomToLayer:function(t){var i=this;this.loading.done(function(){var e=i.layerById(t);if(e){i.bounds(e.bounds)}});return this},select:function(e){var l=this,t;if(e===true){this.instance.setTool("DragTool");this.instance.enableSelection();t=m(this).data("selectFeatureClickCallback");if(!t){t=function(e){var t=e.id.match(y),i=parseInt(t[2],10),n=parseInt(t[1],10),r=e.key===17,o=l.selection,s=l.instance,a=function(e,t,i){g.highlight(s,e,t,i)};if(r||o.ctrlDown){if(o.isSelected(i,n)){s.demodifyObjectsColor();o.remove(i,n);m.each(l.selection.selected().slice(0),function(){var e=this.featureId.toString(),t=this.layerId.toString();a(e,t,false)})}else{a(i,n,false);o.add(i,n)}}else{if(o.isSelected(i,n)&&o.count()===1){s.demodifyObjectsColor();o.remove(i,n)}else{o.clear();a(i,n,true);o.add(i,n)}}};m(this).data("selectFeatureClickCallback",t)}this.instance.addEventListener("object_click",t)}else if(e===false){this.instance.disableSelection();this.instance.removeEventListener("object_click",m(this).data("selectFeatureClickCallback"))}else{return!!(this.instance&&this.instance.selectionEnabled)}return this},selectFeature:function(e,t,i){var n=this.selection,r=n.isSelected(t,e),o=parseInt(t,10),s=parseInt(e,10),a=this;i=i===false?false:true;this.loading.done(function(){if(r&&!i){a.instance.demodifyObjectsColor();n.remove(o,s);m.each(n.selected().slice(0),function(){var e=this.featureId.toString(),t=this.layerId.toString();g.highlight(a.instance,e,t,false)})}else if(!r&&i){g.highlight(a.instance,o,s,false);n.add(o,s)}});return this},selectFeaturesByBounds:function(r,e,t){this.loading.done(function(){var n=this;if(t){this.instance.demodifyObjectsColor();this.selection.clear()}if(r!==null||r!==v){giscloud.features.byBounds(r,e).done(function(e){var t,i;for(t=0,i=e.length;t<i;t++){if(e[t].id!==v){n.selectFeature(r,e[t].id,true)}}})}})},editFeature:function(n,e,r){var o=this,t=this.editing,i,s;if(a(t)){i=m.proxy(t.fail,t);this.editCancel()}else{i=m.proxy(this.loading.done,this.loading)}s=new m.Deferred;r=r||{};i(function(){if(n==null||o.layerById(n)==null){s.reject("Invalid layer id");return}if(e==null){return}o.select(false);s.always(function(){o.select(true)});giscloud.features.byId(n,e,{geometry:"wkt"}).fail(function(){s.reject("Unknown feature")}).done(function(t){var e=giscloud.geometry.fromOGC(t.geometry),i=e&&new giscloud.GraphicFeature(e);if(!i){s.reject("Invalid feature geometry");return}if(i.geometry()instanceof giscloud.geometry.Line){i.style({size:5})}p.editGraphic=i;o.graphic.add(i).edit(i).fail(function(){s.reject("Cancelled")}).done(function(e){giscloud.features.update(t.layerId,t.id,{geometry:e.toOGC()},{use_map_srid:true}).done(function(){var e={};if(r&&r.cascade){e.cascade=true}if(r.dontReset){s.resolve()}else{giscloud.layers.reset(o.mapId,[n],e).always(function(){s.resolve()}).done(function(){o.instance.reload()})}}).fail(function(){s.reject("Error updating feature")})});s.always(function(){o.graphic.remove(i)})})});this.editing=s;return s.promise()},editAccept:function(){if(a(this.editing)){this.graphic.editAccept()}return this},editCancel:function(){if(a(this.editing)){this.graphic.editCancel()}return this},filterFeatures:function(r,o){var s=this;this.initializing.done(function(){var e,t,i,n=o?o.filter:v;if(n&&!o.context){console.warn("[giscloud] filterFeatures method requires context property to "+"be set when filter function is used. Use context property to have "+"data transfered to your filter function (as second argument). "+"Functions that depend on scope outside them will be deprecated.")}if(r){e="layer"+r,s.instance.setLayerFeatureFilter(e,o);t=s.instance.getLayerByName(e);i=t.filterFunction!=n;t.filterFunction=n;if(t&&i){t.redraw()}labelLayerName="llayer"+r,labelLayerObject=s.instance.getLayerByName(labelLayerName);if(t===0&&labelLayerObject===0){s.instance.setLayerFeatureFilter(labelLayerName,o)}else if(labelLayerObject){s.instance.setLayerFeatureFilter(labelLayerName,o);if(i){labelLayerObject.redraw()}}}})},changeMode:function(e,t){if(["3D","2D"].indexOf(e)===-1){throw"Invalid map mode"}this.instance.changeMode(e,t)},getMode:function(){return this.instance.getMode()}});giscloud.Viewer.__googleMapsApiLoaded=new m.Deferred;a=function(e){return e&&e.state()==="pending"};b=function(e,t,i,n){var r,o,s,a,l,c,u,d,f,h=/^layer(\d+)$/,p=[],g=e.instance;layerIndex={};e.layers=[];if(t&&t.length===2&&m.isArray(t[0])&&m.isNumeric(t[1])){t=t[0]}if(t&&t.length){for(l=0,d=t.length;l<d;l++){p.push(t[l]);if(t[l].sublayers&&t[l].sublayers.length){for(c=0,u=t[l].sublayers.length;c<u;c++){p.push(t[l].sublayers[c])}}}}try{for(l=0,c=g.getLayerCount();l<c;l++){o=g.getLayer(l);r=o.getId();u=r.match(h);if(u){r=u[1];layerIndex[r]=l;o=new giscloud.ViewerLayer(o);a=i&&i[r.toString()];if(a&&a.v!=null){o.visible(a.v)}if(a&&a.e!=null){o.expressions().forEach(function(e){var t=e.expression||"<empty>",i=a.e[t];if(i!=null){e.visible(i)}})}e.layers.push(o)}}if(p.length){for(l=0,d=p.length;l<d;l++){s=p[l];for(f=0;f<e.layers.length;f++){if(parseInt(s.id)===e.layers[f].id){o=e.layers[f];break}else{o=null}}if(o){a=i&&i[o.id.toString()];o.name=s.name;o.type=s.type;o.source=s.source.src||s.source.layer||s.source.service_name||"";o.sourceType=s.source.type;o.datasourceId=s.datasourceId;if(s.options){for(f=0,u=s.options.length;f<u;f++){if(s.options[f].option_name=="SUPPORT_INCOMPLETE_TILE_COVERAGE"&&s.options[f].option_value=="1"){o.instance.incompleteTileCoverage=true;break}}}o.opacity(s.alpha);m.each(n||[],function(e,t){o[t]=s[t]});if(!a||a.v==null){o.visible(s.visible==="t")}if(s.visible){o.visible(s.visible)}if(!a||a.l==null){o.selectable(s.lock==null||s.lock!=="t")}else{o.selectable(!a.l)}}}}}catch(e){console.log(e)}m.data(e,"layerIndex",layerIndex);giscloud.util.mediator.publish("labels/redraw")};_=function(e){var t=e&&e.id.match(/^layer(\d+)$/)[1],i=m.data(this,"layerIndex"),n=i[t],r;if(!isNaN(n)){this.layers.splice(n,1);i={};for(n=0,r=this.layers.length;n<r;n++){i[this.layers[n].id]=n}m.data(this,"layerIndex",i)}};r=function(e,t){var i=t.state,n=i.marker,r=n.sig,o=t.newValue,s=n.location();if(t.oldValue===o){return}switch(t.property){case"location":if(o&&o instanceof giscloud.LonLat&&o.valid()&&n.visible()){s=this.instance.toInternalCoords(s.lon,s.lat);if(g.markers[r].marker){g.markers[r].marker.setLatLng(s)}else{g.markers[r].marker=this.instance.newMarker(s,{icon:g.markers[r].label,clickable:false},i.content||"");this.instance.addComponentToMap(g.markers[r].marker)}}else{if(g.markers[r].marker){g.markers[r].marker.remove();g.markers[r].marker=null}}break;case"visible":if(o&&s&&s instanceof giscloud.LonLat&&s.valid()){s=this.instance.toInternalCoords(s.lon,s.lat);g.markers[r].marker=this.instance.newMarker(s,{icon:g.markers[r].label,clickable:false},i.content||"");this.instance.addComponentToMap(g.markers[r].marker)}else{g.markers[r].marker.remove();g.markers[r].marker=null}break;case"content":if(g.markers[r].marker){g.markers[r].marker.html(o)}break;default:}};i=function(e,t,i){var n="tooltip,marker,kartehr,canvas",r=new m.Deferred,o=this;t=t||{};this.flashnavigator=p.createFlashnavigator();this.flashnavigator.offscreenRendering=this.offscreenRendering;this.html5Map=new g.LegacyHtml5Map(this.flashnavigator);if(t.scalebar){n+=",scalebar"}if(t.slider){n+=",slider"}if(t.flashnavigatorInclude){n=t.flashnavigatorInclude}this.flashnavigator.include(n);this.flashnavigator.setOptions(t);if(g.deferreds.flashnavigator===v){g.deferreds.flashnavigator={}}g.deferreds.flashnavigator[e]=r;r.done(i||null);this.flashnavigator.container(this,e,{onLoad:function(e){k=o.flashnavigator.legacyObjects.fnViewer;C=o.flashnavigator.legacyObjects.fnMarker;L=o.flashnavigator.legacyObjects.fnKartehr;T=o.flashnavigator.legacyObjects.fnCanvas;j=o.flashnavigator.legacyObjects.fnTooltip;M=o.flashnavigator.legacyObjects.fnScalebar;I=o.flashnavigator.legacyObjects.fnSlider;r.resolve(e)}});return r};w=function e(t){var i,n,r=this;if(!t)return m.Deferred().resolve();try{if(typeof t==="function"){i=t();if(!i)return m.Deferred().resolve();if(typeof i.then==="function"){n=i}else{n=m.Deferred().resolve(i)}}else{n=m.Deferred().resolve(t)}n.done(function(e){if(!e)return;m.each(e,function(e,t){r.filterFeatures(e,t)})});return n}catch(e){console.error("Error applying the filterFeatures option",e);return m.Deferred().reject()}};x=function e(t){var i,n;if(typeof t!=="function"){return m.Deferred().resolve(t)}try{i=t();return i&&typeof i.then==="function"?i:m.Deferred().resolve(i)}catch(e){console.error("Error applying the filterFeatures option",e);return m.Deferred().reject()}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(c,u,d,f){var h,b,p;d.deferreds.leafletLoading=new u.Deferred;if(c.L&&c.L.Map){b=c.L;d.deferreds.leafletLoading.resolve()}giscloud.exposeLeaflet=function(){return b};d.ViewerLeaflet=function(t,e,i){var r,_,o,s,n,a;r=this;s=d.oid();_={options:i};o={};_.layers=[];_.viewer=t;this.modeId="2D";if(d.deferreds.leafletLoading.state()!=="resolved"){giscloud.includeJs(d.assetsSite()+"libs/leaflet-git/"+giscloud_config.leafletScript(),function(){if(c.L){b=c.L;d.deferreds.leafletLoading.resolve()}else{d.deferreds.leafletLoading.reject();d.deferreds.leafletLoading=new u.Deferred}});if(!p){if(u.browser.msie&&parseFloat(u.browser.version)<9&&!("opacity"in document.createElement("div").style)){a=u.when(giscloud.includeCss(d.assetsSite()+"libs/leaflet-git/leaflet.css"),giscloud.includeCss(d.assetsSite()+"libs/leaflet-git/leaflet.ie.css"),giscloud.includeCss(d.assetsSite()+"assets/api/1/viewer/leaflet/viewer.leaflet.css"),giscloud.includeCss(d.assetsSite()+"assets/api/1/viewer.css"))}else{a=u.when(giscloud.includeCss(d.assetsSite()+"libs/leaflet-git/leaflet.css"),giscloud.includeCss(d.assetsSite()+"assets/api/1/viewer/leaflet/viewer.leaflet.css"),giscloud.includeCss(d.assetsSite()+"assets/api/1/viewer.css"))}a.done(function(){p=true})}}this.init=new u.Deferred;this.init.done(function(){r.map=_.map;r.container=_.map._container;this.overrideLeafletAddLayer();this._control=new d.ViewerLeafletControl(_);_.map.on("zoomend",function(){u(o).triggerHandler("scaleChanged")});_.map.on("zoomstart",function(){_.viewer.html5Map.html5ResetLoaders()})});function l(t,e,i){var n,r;if(u.isArray(e)){return u.map(e,function(e){return[l(t,e,i)]})}else if(e instanceof b.LatLng){r=t.fromInternalCoords(e);if(i){r.z=r.z||0}return r}else if(e instanceof b.Marker){r=t.fromInternalCoords(e.getLatLng());if(i){r.z=r.z||0}return r}else if(e instanceof b.Polygon){n=e.getLatLngs();if(u.isArray(n[0])){return new giscloud.geometry.Polygon(u.map(n,function(e){return new giscloud.geometry.Line(u.map(e,function(e){return l(t,e,i)}))}))}return new giscloud.geometry.Polygon([new giscloud.geometry.Line(u.map(n,function(e){return l(t,e,i)}))])}else if(e instanceof b.MultiPolygon){return new giscloud.geometry.Multipolygon(u.map(e._layers,function(e){return l(t,e,i)}))}else if(e instanceof b.Polyline){return new giscloud.geometry.Line(u.map(e.getLatLngs(),function(e){return l(t,e,i)}))}else if(e instanceof b.MultiPolyline){return new giscloud.geometry.Multiline(u.map(e._layers,function(e){return l(t,e,i)}))}else if(e instanceof b.FeatureGroup){if(e._gcType=="Multipoint"){return new giscloud.geometry.Multipoint(u.map(e._layers,function(e){return l(t,e,i)}))}return new giscloud.geometry.GeometryCollection(u.map(e._layers,function(e){return l(t,e,i)}))}else{return null}}this.fromViewerGeometry=function(e,t){return l(this,e,t)};this.overrideLeafletAddLayer=function(){var n,e=navigator.userAgent.match(/chrome\/(\d+)\./i);var r=_.map;function o(){r.on("zoomend",function(){var e=this._container.style.display||"block";this._container.style.display="none";this._container.offsetHeight;this._container.style.display=e});r.addLayer=n}if(e&&e.length===2){e=parseInt(e[1],10);if(!r.addLayerOverridden&&e>=38){n=r.addLayer;r.addLayer=function e(){var t=Array.prototype.slice.call(arguments),i=t[0];if(!r.svgFixApplied&&i._latlngs){setTimeout(o,0);r.svgFixApplied=true}return n.apply(this,t)};r.addLayerOverridden=true}}};d.deferreds.leafletLoading.done(function(){h(_,e,i);r.init.resolveWith(r)});this.bind=function(e,t){var i,n;if(typeof t!=="function"){throw"Handler is not a function!"}switch(e){case"click":i="click";break;case"mouseDown":i="mousedown";break;case"doubleClick":i="dblclick";break;case"mouseMove":i="mousemove";break;default:n=function(){t.apply(r,Array.prototype.slice.call(arguments,1))};u(o).on(e,n);t[e+s]=n;return this}n=function(e){t.apply(r,[new giscloud.LonLat(e.latlng.lng,e.latlng.lat)])};_.map.on(i,n);t[e+s]=n;return this};this.unbind=function(e,t){var i,n;if(typeof t!=="function"){throw"Handler is not a function!"}n=t[e+s];if(!n){return this}switch(e){case"click":i="click";break;case"mouseDown":i="mousedown";break;case"doubleClick":i="dblclick";break;case"mouseMove":i="mousemove";break;default:u(o).off(e,n);delete t[e+s];return this}_.map.off(i,n);delete t[e+s];return this};u.each(["click","doubleClick","mouseMove","mouseDown"],function(e,t){r[t]=function(e){r.bind(t,e)}});this.center=function(e,t){if(e==null){e=_.map.getCenter();return e&&new giscloud.LonLat(e.lng,e.lat)}else{_.map.setView(new c.L.LatLng(e.lat,e.lon),_.map.getZoom(),t);return this}};this.zoom=function(e,t){if(e==null){return _.map.getZoom()}else{_.map.setView(_.map.getCenter(),Math.floor(e),t);return this}};this.setMinZoom=function(e){if(e>0){_.map.options.minZoom=e}else{delete _.map.options.minZoom}};this.getMinZoom=function(){return _.map.options.minZoom?_.map.options.minZoom:0};this.setScale=function(e){var t=this.getViewBound();this.setLocation((t.xMin+t.xMax)/2,(t.yMin+t.yMax)/2,Math.floor(e))};this.getScale=function(){return _.map._zoom};this.addComponentToMap=function(e){e.addTo(_.map)};this.newPopup=function(e){return new d.ViewerLeafletPopup(e)};this.newMarker=function(e,t,i){return new d.ViewerLeafletMarker(e,t,i)};this.newPointGeom=function(e,t){var i=new b.DivIcon({iconSize:new b.Point(t.width,t.width),className:"leaflet-div-icon"});i.__div=i.createIcon();i.createIcon=function(){return this.__div};u(i.__div).css("background-color",t.fill).css("border","solid "+t.border+"px "+t.color).css("border-radius",t.borderRadius).css("-moz-border-radius",t.borderRadius).css("-webkit-border-radius",t.borderRadius).css("opacity",t.opacity);var n=new b.Marker(e,{icon:i,draggable:false});n.on("dragend",function(){t.parentShape.cursor=n.getLatLng()});n.isMarker=true;return n};this.newViewerGeometry=function(e,t,i,n){var r;if(i.isMulti){r=new b.FeatureGroup(t,i,n)}else if(e=="LineString"){r=new b.Polyline(t,i,n)}else if(e=="Polygon"){r=new b.Polygon(t,i,n)}else if(e=="Point"){r=this.newPointGeom(t,i)}if(n){_.map.addLayer(r)}return r};this.getViewerGeometry=function(e,t,i,n){var r=null;if(e instanceof giscloud.geometry.Multipolygon){r=new b.MultiPolygon(i,t)}else if(e instanceof giscloud.geometry.Polygon){r=new b.Polygon(i,t)}else if(e instanceof giscloud.geometry.Multiline){r=new b.MultiPolyline(i,t)}else if(e instanceof giscloud.geometry.Line){r=new b.Polyline(i,t)}else{t=t||{};t.icon=t.icon||(new b.Handler.PolyEdit).options.icon;t.draggable=t.draggable||false;if(e instanceof giscloud.geometry.Multipoint){r=new b.FeatureGroup(u.map(i,function(e){return new b.Marker(e,t)}),t);r._gcType="Multipoint"}else if(e instanceof giscloud.geometry.Point){r=new b.Marker(i,t)}}return n?[r]:r};this.extendLineGeometry=function(e,t){e.addLatLng(t)};this.initDrawing=function(){};this.getDrawingController=function(e,t){return new d.ViewerLeafletDrawing(e,_.map,t)};this.removeGeom=function(e){_.map.removeLayer(e)};this.enableGeometryEdit=function(e,t){var i,n=e.editing||e.dragging;if(n){if(t===false){n.disable()}else{n.enable()}return}if(e.shapes){if(t===false){i=function(e,t){if(t.editing){t.editing.disable()}else if(t.dragging){t.dragging.disable()}else if(t._layers){u.each(t._layers,i)}}}else{i=function(e,t){if(t.editing){t.editing.enable()}else if(t.dragging){t.dragging.enable()}else if(t._layers){u.each(t._layers,i)}}}u.each(e.shapes,i)}};this.toInternalCoords=function(e,t,i,n){var r=(1<<_.map._zoom)*256,o=_.map.getPixelBounds(),s=(e-_.map.gc_bounds.xmin)/_.map.gc_bounds.max*r-_.map._mapPane._leaflet_pos.x-o.min.x,a=(_.map.gc_bounds.ymax-t)/_.map.gc_bounds.max*r-_.map._mapPane._leaflet_pos.y-o.min.y,l=_.map.layerPointToLatLng(new b.Point(s,a));if(i!=null){l.z=i}if(n)l._o={x:e,y:t};return l};this.fromInternalCoords=function(e){var t,i,n=_.map.gc_bounds;if(e._o){t=e._o.x;i=e._o.y}else{var r=_.map.latLngToLayerPoint(e),o=(1<<_.map._zoom)*256,s=_.map.getPixelBounds();t=n.xmin+(r.x+_.map._mapPane._leaflet_pos.x+s.min.x)/o*n.max,i=n.ymax-(r.y+_.map._mapPane._leaflet_pos.y+s.min.y)/o*n.max}if(e.z!=null){return new giscloud.geometry.Point(t,i,e.z)}return new giscloud.geometry.Point(t,i)};this.toLeafletCoords=this.toInternalCoords;this.fromLeafletCoords=this.fromInternalCoords;this.on=function(e,t){if(e=="mousemove"||e=="mousedown"||e=="mouseup"||e=="click"||e=="touchstart"||e=="touchend"||e=="touchmove"){var r=t;if(!t._gc_event_proxy){t._gc_event_proxy={}}t._gc_event_proxy[e]=function(e){var t=_.map.gc_bounds,i,n;if(!t)return;if(!e.layerPoint&&e.originalEvent.targetTouches&&e.originalEvent.targetTouches[0]){e.layerPoint=_.map.mouseEventToLayerPoint(e.originalEvent.targetTouches[0])}e.z=_.map._zoom;if(e.layerPoint){i=_.map.getPixelBounds();n=1<<e.z;e.mapX=(i.min.x+e.layerPoint.x+_.map._mapPane._leaflet_pos.x)/256;e.mapY=(i.min.y+e.layerPoint.y+_.map._mapPane._leaflet_pos.y)/256;e.x=t.xmin+t.max*e.mapX/n;e.y=t.ymax-t.max*e.mapY/n;r(e)}};t=t._gc_event_proxy[e]}if(e=="touchstart"||e=="touchend"||e=="touchmove"){u(_.map._container).on(e,t)}else{_.map.on(e,t)}};this.off=function(e,t){if(t._gc_event_proxy&&t._gc_event_proxy[e]){var i=t._gc_event_proxy[e];delete t._gc_event_proxy[e];if(Object.keys(t._gc_event_proxy).length===0){delete t._gc_event_proxy}t=i}if(e=="touchstart"||e=="touchend"||e=="touchmove"){u(_.map._container).off(e,t)}else{_.map.off(e,t)}};this.fireSelectAreaEvent=function(e,t,i,n){var r=(1<<_.map._zoom)*256;var o=_.map.getPixelBounds();var s=_.map.gc_bounds;var a=Math.abs(t.x-e.x);var l=Math.abs(t.y-e.y);if(a>10&&l>10){var c=s.xmin+s.max*(e.x+_.map._mapPane._leaflet_pos.x+o.min.x)/r;var u=s.ymax-s.max*(e.y+_.map._mapPane._leaflet_pos.y+o.min.y)/r;var d=s.xmin+s.max*(t.x+_.map._mapPane._leaflet_pos.x+o.min.x)/r;var f=s.ymax-s.max*(t.y+_.map._mapPane._leaflet_pos.y+o.min.y)/r;n("areaselection",{originalEvent:i,xMin:c,yMin:u,xMax:d,yMax:f})}};this.fireSelectAreaToolEvent=function(e,t,i){var n=Math.abs(t.x-e.x);var r=Math.abs(t.y-e.y);if(n>10&&r>10){var o=new b.LatLngBounds(_.map.layerPointToLatLng(e),_.map.layerPointToLatLng(t));_.map.fitBounds(o)}};this.addLayer=function(e,t){if(t){e._tilesToRemove=[];for(var i in e._tiles){e._tiles[i].transferToAnotherViewer=true}}d.ViewerLeafletLayerFactory(e,_.map);e.addToMap();_.layers.push(e);if(t){e.gcmap.redraw();var i,n;for(i in e._tiles){n=e._tiles[i];if(!n.transferToAnotherViewer){e.viewerLayer.tileOnLoad(n)}}}};this.removeLayer=function(e){var t=_.layers.indexOf(e);if(t>-1){_.layers.splice(t,1)}e.removeFromMap()};this.whenIdle=function(e){t.instance.onRender=function(){delete t.instance.onRender;e()}};this.unload=function(){_.map.setView(new b.LatLng(0,0),0,true)};this.isLoaded=function(){return _.map._loaded};this.getViewBound=function(){var e=_.map.getPixelBounds();var t=_.map.gc_bounds;var i=t.max/(Math.pow(2,_.map._zoom)*256);var n=new Object;n.xMin=t.xmin+i*e.min.x;n.yMin=t.ymax-i*e.max.y;n.xMax=t.xmin+i*e.max.x;n.yMax=t.ymax-i*e.min.y;return n};this._setView=function(e,t,i){var n=_.map.gc_bounds;var r=_.map.getSize();_.map._zoom=i;var o=n.max/(Math.pow(2,i)*256);e=Math.round((e-n.xmin)/o-r.x/2);t=Math.round((n.ymax-t)/o-r.y/2);_.map._initialTopLeftPoint=new b.Point(e,t);b.DomUtil.setPosition(_.map._mapPane,new b.Point(0,0));_.map._tileLayersToLoad=_.map._tileLayersNum;if(_.map._tileBg)_.map._tileBg.innerHTML="";_.map.fire("viewreset",{hard:true});_.map.fire("move");_.map.fire("zoomend");_.map.fire("moveend");if(!_.map._loaded){_.map._loaded=true;_.map.fire("load")}};this.setViewUsingInternalCoords=function(e,t){_.map.setView(new b.LatLng(e[1],e[0]),t)};this.setViewBound=function(e,t,i,n,r,o){var s=_.map.gc_bounds;var a=_.map.layersMaxLevel;if(_.map._loaded&&!o){var l=(1<<_.map._zoom)*256;var c=_.map.getPixelBounds();var u=new b.LatLngBounds(this.toInternalCoords(e,t),this.toInternalCoords(i,n));var d=_.map.getBoundsZoom(u);if(d>a)d=a;if(this.mapViewPadding){if(this.mapViewPadding.left)e-=s.max/Math.pow(2,d)/256*this.mapViewPadding.left;u=new b.LatLngBounds(this.toInternalCoords(e,t),this.toInternalCoords(i,n));d=_.map.getBoundsZoom(u);if(d>a)d=a}_.map.setView(b.latLngBounds(u).getCenter(),d)}else{var l=i-e>n-t?i-e:n-t;var f=_.map.getSize();var h=_.map.getSize(),d=_.map.getMinZoom(),p=_.map.getMaxZoom(),g,m,v;if(!p||p>a)p=a;do{d++;var y=Math.pow(2,d)*256;m={x:i/s.max*y,y:t/s.max*y};v={x:e/s.max*y,y:n/s.max*y};g=new b.Point(m.x-v.x,v.y-m.y)}while(g.x-h.x<1e-4&&g.y-h.y<1e-4&&d<=p);d-=r;this._setView((i+e)/2,(n+t)/2,d)}};this.getCenter=function(){return this.fromInternalCoords(_.map.getCenter())};this.setLocation=function(e,t,i,n,r,o,s){if(e!==f&&t!==f){if(!(i>=0)){i=_.map._zoom}i=Math.floor(i);if(_.map._loaded){_.map.setView(this.toInternalCoords(e,t),i,o===0)}else{this._setView(e,t,i)}}if(s){s()}};this.getBearing=function(){return 0};this.setBearing=function(){};this.getPitch=function(){return 0};this.setPitch=function(){};this.invalidateSize=function(){_.map.invalidateSize()};this.initialize=function(){};this.uninitialize=function(){};this.show=function(){_.container.show()};this.hide=function(){_.container.hide()};this.setZIndex=function(e){_.container.css("z-index",e)};this.extractLayer=function(){return _.layers.pop()};this.resetZoomBearingPitch=function(e,t){t()};this.toggleInteractions=function(t){var e=["boxZoom","doubleClickZoom","scrollWheelZoom","touchZoom"];e.forEach(function(e){if(t){_.map[e].enable()}else{_.map[e].disable()}})};this.getBackgroundColor=function(){return this._backgroundColor};this.setBackgroundColor=function(e){this._backgroundColor=e;if(e){_.map._container.style.backgroundColor=e}else{_.map._container.style.backgroundColor="#ffffff"}};this.addScaleControl=function(){_.map.scaleControl=b.control.scale();_.map.scaleControl.original_update=_.map.scaleControl._update;_.map.scaleControl.original_updateScales=_.map.scaleControl._updateScales};this.setTool=function(e,t,i,n){if(t==="MeasureTool"){if(_.map.measure.enabled()){_.map.measure.disable()}}if(t==e){return}_.map.boxZoom._onDone=null;_.map.boxZoom.force(false);if(e=="SelectAreaTool"||e=="AreaSelection"){_.map.dragging.disable();_.map.boxZoom._onDone=n;_.map.boxZoom.force(true)}else{_.map.dragging.enable()}var r={tool:e,previous_tool:t};i("toolchange",r);return e};this.setProjection=function(e){if(e===3857){_.map.options.crs=b.CRS.EPSG3857}if(e===4326){_.map.options.crs=b.CRS.EPSG4326}};this.setCursor=function(e){this.container.style.cursor=e};this.reloadTerrain=function(){};this.dragging={enable:function(){_.map.dragging.enable()},disable:function(){_.map.dragging.disable()},enabled:function(){return _.map.dragging.enabled()}};this.doubleClickZoom={enable:function(){_.map.doubleClickZoom.enable()},disable:function(){_.map.doubleClickZoom.disable()},enabled:function(){return _.map.doubleClickZoom.enabled()}}};h=function(e,t,i){var n,r,o;try{n=[];o={layers:n,worldCopyJump:false,closePopupOnClick:false};if(e.options.latloncrs){o.crs=b.CRS.EPSG4326}if(e.options.lockZoom){u.extend(o,{touchZoom:false,scrollWheelZoom:false,doubleClickZoom:false,zoomControl:false})}if(e.options.hideZoomButtons){u.extend(o,{zoomControl:false})}var s=u("<div/>");s.css("position","absolute").css("width","100%").css("height","100%");u("#"+t).append(s);r=new b.Map(s[0],o);e.container=s;if(i.background){if(i.background.hex){u(".leaflet-container").css("background-color",i.background.hex())}else{u(".leaflet-container").css("background-color",i.background)}}if(i.center&&i.zoom){r.setView(new b.LatLng(i.center.lat,i.center.lon),i.zoom,true)}else if(i.bounds){r.fitBounds(new b.LatLngBounds(new b.LatLng(i.bounds.bottom,i.bounds.left),new b.LatLng(i.bounds.top,i.bounds.right)))}e.map=r;e.layers=n}catch(e){throw{name:"Leaflet error on viewer init.",err:e}}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,t,i,n){var s,r,o,a;i.ViewerLeafletLayerFactory=function(e,t){if(e.isTileLayer){new i.ViewerLeafletTileLayer(e,t)}else if(e.isBaseMapLayer){new i.ViewerLeafletBasemapLayer(e,t)}else{new i.ViewerLeafletLayer(e,t)}};a={initialize:function(e,t){this._layer=new r;this.initializeCommon(e,t)},initializeCommon:function(e,t){this._map=t;s.Util.setOptions(this._layer,e.options);this._layer._url=e._url;e.viewerLayer=this;this._layer.fnLayer=e;this._layer.viewerLayer=this},uninitialize:function(){},addToMap:function(){this._map.addLayer(this._layer)},removeFromMap:function(){this.uninitialize();this._map.removeLayer(this._layer)},setVisible:function(e){var t=this._layer;if(t._container){t._container.style.display=e?"block":"none"}this._updateLayerCount(e);t.options.visible=e;if(t instanceof s.TileLayer){t._update()}},update:function(){this._layer._update()},loaded:function(){return!!this._layer._map},setOpacity:function(e){this._layer.setOpacity(e)},setZIndex:function(e){this._layer.setZIndex(e)},_updateLayerCount:function(e){var t=this._layer;if(t.options.visible!=e&&t._map.options.zoomAnimation&&s.TileLayer&&t instanceof s.TileLayer){if(e){t._map._tileLayersNum++;t._map._tileLayersToLoad++;t.on("load",t._map._onTileLayerLoad,t._map)}else{t._map._tileLayersNum--;t._map._tileLayersToLoad--;t.off("load",t._map._onTileLayerLoad,t._map)}}},cleanTileCss:function(e){s.DomUtil.removeClass(e,"leaflet-tile");s.DomUtil.removeClass(e,"leaflet-tile-loaded")},onTileLoad:function(e,t){s.DomUtil.addClass(e,"leaflet-tile-loaded");e.complete=true;this._layer.fire("tileload",{tile:e,url:t});this._layer._tileLoaded()},onTileError:function(e,t){var i;this._layer.fire("tileerror",{tile:e,url:t});i=this.options.errorTileUrl;if(i&&i!=e.src){e.src=i}this._layer._tileLoaded()},tileShouldBeLoaded:function(e){return this._layer._tileShouldBeLoadedOriginal(e)},tileShouldBeVisible:function(e){if(!this._layer._map)return false;var t=this._layer._map.getPixelBounds(),i=this._layer.options.tileSize;var n=new s.Point(Math.floor(t.min.x/i),Math.floor(t.min.y/i)),r=new s.Point(Math.floor(t.max.x/i),Math.floor(t.max.y/i)),o=new s.Bounds(n,r);if(e.x<o.min.x||e.x>o.max.x||e.y<o.min.y||e.y>o.max.y){return false}return true},getTileUrl:function(e,t){return this._layer.getTileUrl(e,t)},repaint:function(){}};i.ViewerLeafletLayer=i.LayerClass.extend(a);var o={initialize:function(e,t){s.setOptions(this,t)},_loadTile:function(e,t){e._layer=this;e.onload=this._tileOnLoad;e.onerror=this._tileOnError;this.fnLayer._loadTile(e,t)},getVisible:function(e){return this.options.visible}};i.deferreds.leafletLoading.done(function(){s=e.L;r=s.TileLayer.extend(o);r.prototype._tileShouldBeLoadedOriginal=r.prototype._tileShouldBeLoaded;r.prototype._tileShouldBeLoaded=function(e,t,i){return this.fnLayer._tileShouldBeLoaded(e,t,i)};i._LeafletLayer=r})})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,t,i,n){var r,o,s,a;a={initialize:function(e,t){var i=new o;this._layer=i;this.initializeCommon(e,t);i._updateOriginalFnLayer=i._update;i._update=function(){this._updateOriginalFnLayer();if(!this.fnLayer.viewer)return;this.fnLayer.viewer._layersForUpdateCount--;if(this.fnLayer.viewer._layersForUpdateCount<=0){this.fnLayer.legacyHtml5Map.Html5SendRequests();this.fnLayer.viewer._layersForUpdateCount=0}};i.on("tileerror",function(e){i.fnLayer.onTileError(e.tile)});i.on("load",function(){if(!t.options.zoomAnimation){i.fnLayer.cleanUpCanvasPool();i.unloadTilesOnClearBg=false}});i.on("tileunload",function(e){e.imidiateRelease=!i.unloadTilesOnClearBg;i.fnLayer._unloadTile(e)});i.on("stoploadingtiles",function(){i.fnLayer.onStopLoadingTiles()});this.clearTileBgHandler=function(){i.fnLayer.cleanUpCanvasPool();i.unloadTilesOnClearBg=false};this.zoomStartHandler=function(){i.unloadTilesOnClearBg=true;i.fnLayer.onZoomChange()};t.on("cleartilebg",this.clearTileBgHandler);t.on("zoomstart",this.zoomStartHandler)},uninitialize:function(){this._map.off("cleartilebg",this.clearTileBgHandler);this._map.off("zoomstart",this.zoomStartHandler)},tileOnLoad:function(e){this._layer._tileOnLoad.call(e);if(this._layer._oldContainer){l(e)}},tilesToLoad:function(){return this._layer._tilesToLoad&&this._layer._tilesToLoad>0},resetCache:function(){},render:function(){}};i.ViewerLeafletTileLayer=i.ViewerLeafletLayer.extend(a);s={_loadTile:function(e,t){if(this.viewerLayer.switching){return}this.fnLayer._loadTile(e,t)},_createTileProto:function(){this._canvasProto=r.DomUtil.create("canvas","leaflet-tile leaflet-tile-loaded")},_createTile:function(e){var t=this.fnLayer._tiles[e.x+":"+e.y+":"+e.z];if(t&&t.transferToAnotherViewer){if(!t.getContext){var i=t.gc_state;var n=this.fnLayer._createTile();n.gc_state=i;n.transferToAnotherViewer=true;t=n}}else{t=this.fnLayer._createTile()}t._layer=this;r.DomUtil.addClass(t,"leaflet-tile");r.DomUtil.addClass(t,"leaflet-tile-loaded");return t}};function l(e){var t=e._leaflet_pos.x;var i=e._leaflet_pos.y;var n=lv.map._animateScale;if(!n)return;var r=Math.round(lv.map._animateOrigin.x);var o=Math.round(lv.map._animateOrigin.y);var s=e._layer._oldContainer.childNodes;for(var a=0,l=s.length;a<l;a++){if(!s[a].gc_state._drawn)continue;var c=(s[a]._leaflet_pos.x-r)*n+r;var u=(s[a]._leaflet_pos.y-o)*n+o;var d=s[a].width*n;var f={xmin:t,ymin:i,xmax:t+e.width,ymax:i+e.height};var h={xmin:c,ymin:u,xmax:c+d,ymax:u+d};if(intersects(f,h)){rect={xmin:getmax(f.xmin,h.xmin),ymin:getmax(f.ymin,h.ymin),xmax:getmin(f.xmax,h.xmax),ymax:getmin(f.ymax,h.ymax)};var p={x:Math.floor((rect.xmin-c)/n),y:Math.floor((rect.ymin-u)/n),w:Math.ceil((rect.xmax-rect.xmin)/n),h:Math.ceil((rect.ymax-rect.ymin)/n),c:s[a]};var g=p.c.getContext("2d",flashnavigator.canvasOptions);g.clearRect(p.x,p.y,p.w,p.h)}}}i.deferreds.leafletLoading.done(function(){r=e.L;o=i._LeafletLayer.extend(s)})})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,t,i,n){var r,o,s;s={initialize:function(e,t){this._layer=new o;this.initializeCommon(e,t)}};i.ViewerLeafletBasemapLayer=i.ViewerLeafletLayer.extend(s);leafletBasemapLayerDef={_createTileProto:function(){this._tileImg=r.DomUtil.create("canvas","leaflet-tile");this._tileImg.width=this._tileImg.height=this.options.tileSize*this.options.tileScaleFactor;if(this.options.tileScaleFactor!==1){this._tileImg.style.width="256px";this._tileImg.style.height="256px"}},_loadTile:function(e,t){this.fnLayer._loadTile(e,t)}};i.deferreds.leafletLoading.done(function(){r=e.L;o=i._LeafletLayer.extend(leafletBasemapLayerDef)})})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,t,i,n){var r,o;o={initialize:function(e,t,i){this._map=null;this._type="marker";this._subtype="standard";this._clickable=t.clickable!==false;if(!e)e=new r.LatLng(0,0);if(t.icon){if(t.icon.type=="div"){t.icon=new r.DivIcon(t.icon);this._subtype="icon"}else{t.icon=new r.Icon.Label(t.icon);this._subtype="label"}}this._marker=new r.Marker(e,t);if(this._marker._icon){this._marker._icon.innerHTML=i||""}},move:function(e){var t=e.latlng||e;this._marker.setLatLng(t)},addTo:function(e){this._map=e;e.addLayer(this._marker);this._gc_container=t(this._marker._icon);this._gc_container.find(".leaflet-marker-iconlabel").addClass("gc-marker-iconlabel");this._gc_container.find(".leaflet-marker-icon").addClass("gc-marker-icon");if(!this._clickable){this._gc_container.css("pointer-events","none")}},text:function(e){this._gc_container.text(e)},html:function(e){this._gc_container.html(e)},remove:function(){this._map.removeLayer(this._marker)},bindPopup:function(e,t){this._marker.bindPopup(e,t);this._popup=new i.ViewerLeafletPopup(this._marker._popup);this._popup._map=this._map},setContent:function(e){this._marker.setContent(e)},setLabelText:function(e){if(this.isLabel()){this._marker.setLabelText(e)}},setLabel:function(e){if(this._marker.setLabelText){this._marker.setLabelText(e)}else if(this._marker.options.icon&&this._marker.options.icon.setLabelText){this._marker.options.icon.setLabelText(e)}else{t(this._marker._icon).find(".leaflet-marker-iconlabel").html(e)}},on:function(){this._gc_container.on.apply(this._gc_container,arguments);return this},off:function(){this._gc_container.off.apply(this._gc_container,arguments);return this},setLatLng:function(e){this._marker.setLatLng(e)},setRotation:function(e){this._marker.setRotation(e)}};i.ViewerLeafletMarker=i.LayerClass.extend(o);i.deferreds.leafletLoading.done(function(){r=e.L})})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,t,i,n){var r,o;r={initialize:function(e){this._type="popup";this._map=null;if(e instanceof o.Popup){this._popup=e}else{this._popup=new o.Popup(e)}},move:function(e){var t=e.latlng||e;this._popup.setLatLng(t)},addTo:function(e){this._map=e;e.addLayer(this._popup);this._gc_container=t(this._popup._wrapper);t(this._popup._closeButton).addClass("gc-info-popup-close-button");this._gc_container.addClass("gc-info-popup-content-wrapper");this._gc_container.find(".leaflet-popup-content").addClass("gc-info-popup-content-outer");t(this._popup._tipContainer).find(".leaflet-popup-tip").addClass("gc-popup-tip");t(this._popup._container).on("mouseup mousedown mousemove mouseover touchstart",".leaflet-popup-close-button",function(e){e.stopPropagation()})},setContent:function(e){this._popup.setContent(e)},remove:function(){this._map.removeLayer(this._popup)},_initEventHandler:function(e,t){var i=this._popup;if(!this._gc_events){this._gc_events={}}this._gc_events[t]=function(e){if(e.popup===i){t()}}},fire:function(e,t){this._gc_container.triggerHandler(e,t)},on:function(e,t){if(e==="open"||e==="close"){this._initEventHandler(e,t);e="popup"+e;this._map.on(e,this._gc_events[t])}else{this._gc_container.on.apply(this._gc_container,arguments)}return this},off:function(e,t){if(e==="open"||e==="close"){e="popup"+e;this._map.off(e,this._gc_events[t])}else{this._gc_container.off.apply(this._gc_container,arguments)}return this}};i.ViewerLeafletPopup=i.LayerClass.extend(r);i.deferreds.leafletLoading.done(function(){o=e.L;if(!o.Popup.prototype._original_updatePosition)s()});function s(){o.Popup.prototype._original_updatePosition=o.Popup.prototype._updatePosition;o.Popup.prototype._updatePosition=function(){if(!this._map){return}var e=this._map.latLngToLayerPoint(this._latlng),t=this._animated,i=this.options.offset;e.x=Math.round(e.x);e.y=Math.round(e.y);if(t){o.DomUtil.setPosition(this._container,e)}this._containerBottom=-i.y-(t?0:e.y);this._containerLeft=-Math.round(this._containerWidth/2)+i.x+(t?0:e.x);this._container.style.bottom=this._containerBottom+"px";this._container.style.left=this._containerLeft+"px"}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,P,t,i){t.ViewerLeafletDrawing=function(y,p,g){var r,o,s,i=(new L.Handler.PolyEdit).options.icon,a=[],l=[],c=null,u=false,d=false,f,h=[];function m(e){var t=new L.Marker(e,{icon:i});p.addLayer(t);l.push(t)}function v(){if(u==="line"){l[l.length-1].off("click",v)}else if(u==="polygon"){if(l&&l.length)l[0].off("click",v)}else if(u==="rectangle"){if(a.length!==5)a=null;P(document).off("mouseup",v);p.dragging.enable()}g.hideMeasureMarker();D()}function _(e,t){return Math.sqrt((e.x-t.x)*(e.x-t.x)+(e.y-t.y)*(e.y-t.y))}function b(e,t,i){var n,r,o,s,a,l,c;if(e.y===t.y&&e.x===t.x)e.y-=Number.MIN_VALUE;n=(i.y-e.y)*(t.y-e.y)+(i.x-e.x)*(t.x-e.x);r=Math.pow(t.y-e.y,2)+Math.pow(t.x-e.x,2);n/=r;o=new giscloud.geometry.Point(e.x+n*(t.x-e.x),e.y+n*(t.y-e.y));return o}function w(e,t,i){var n,r,o,s,a,l,c,u,d,f,h,p,g,m,v;n=y.fromInternalCoords(e);r=y.fromInternalCoords(t);o=y.fromInternalCoords(i);s=new giscloud.geometry.Point(r.x-n.x,r.y-n.y);a=new giscloud.geometry.Point(o.x-r.x,o.y-r.y);l=Math.sqrt(s.x*s.x+s.y*s.y);c=Math.sqrt(a.x*a.x+a.y*a.y);if(l===0||c===0)return i;u=new giscloud.geometry.Point(c*s.x/l,c*s.y/l);f=b(r,new giscloud.geometry.Point(r.x+-1*u.y,r.y+u.x),o);h=b(r,new giscloud.geometry.Point(r.x+u.y,r.y+-1*u.x),o);p=b(r,new giscloud.geometry.Point(r.x+u.x,r.y+u.y),o);g=f?_(o,f):Number.MAX_VALUE;m=h?_(o,h):Number.MAX_VALUE;v=p?_(o,p):Number.MAX_VALUE;d=Math.min(g,m,v);if(d===Number.MAX_VALUE)return i;if(d===g)return y.toInternalCoords(f.x,f.y);if(d===m)return y.toInternalCoords(h.x,h.y);return y.toInternalCoords(p.x,p.y)}function x(e,t){var i=l.length,n=!!t;if(!t){if(e===true||g.getInputValue()!==null){t=new L.LatLng(f.lat,f.lng)}else{t=g.snapping()?g.checkForSnapping(e.latlng):e.latlng;if(i>1&&d){t=w(a[i-2],a[i-1],t)}}}if(f&&f.isTempPoint){a.pop()}if(n){t.isTempPoint=true}a.push(t);f=t;if(!n){h.push(t);m(t)}if(u==="point"){D();return}else if(u==="line"||u==="polygon"&&a.length<3){if(!n){if(i>0&&u==="line"||i>1&&u==="polygon"){l[i-1].off("click",v)}l[i].on("click",v)}if(a.length>=2){if(r){r.setLatLngs(a)}else{r=new L.Polyline(a,{color:"#fbb03b",weight:2,dashArray:"1, 4",opacity:1});p.addLayer(r)}}}else if(u==="polygon"){if(!n){if(i!==0&&a.length>=3){l[i-1].off("click",v)}l[i].on("click",v)}if(a.length>=3){if(r instanceof L.Polyline){p.removeLayer(r);r=null}if(r){r.setLatLngs(a)}else{r=new L.Polygon(a,{color:"#fbb03b",fillColor:"#fbb03b",opacity:1,weight:2,dashArray:"1, 4"});p.addLayer(r)}}}s&&s.notify(u,a,n)}function n(e){var t=e.latlng;p.off("click",x);p.off("mousedown",n);p.dragging.disable();P(document).on("mouseup",function(){p.dragging.enable()}).on("mouseup",v);u="rectangle";a=[e.latlng]}function t(e,t){var i=a.length-1,n=g.snapping()?g.checkForSnapping(e.latlng):e.latlng,r;if(i<0||u==="point"){return}n=e.latlng;c={latlng:new L.LatLng(n.lat,n.lng)};if(!t){n=g.getOverridenPoint(n)}if(u==="line"||u==="polygon"){}else if(u==="rectangle"){if(!o){a=[a[0],new L.LatLng(a[0].lat,n.lng),new L.LatLng(n.lat,n.lng),new L.LatLng(n.lat,a[0].lng),a[0]];o=new L.Polyline(a,{color:"#fbb03b",weight:2,dashArray:"5, 5"});p.addLayer(o)}else{a.splice(1,3,new L.LatLng(a[0].lat,n.lng),new L.LatLng(n.lat,n.lng),new L.LatLng(n.lat,a[0].lng));o.setLatLngs(a)}}else{return}if(u!=="rectangle"){x(e,n)}}function e(){d=true}function k(){d=false}function C(e,t,i){var n=Math.sin(t),r=Math.cos(t),o,s;i.x-=e.x;i.y-=e.y;o=i.x*r-i.y*n;s=i.x*n+i.y*r;i.x=o+e.x;i.y=s+e.y;return i}function T(){if(L.Handler.PolyEdit.prototype._fnCanvasOverriden)return;L.Handler.PolyEdit.prototype.addHooks=function(){if(this._poly._map){if(!this._markerGroup){this._initMarkers()}this._poly._map.addLayer(this._markerGroup);this._poly.on("mousedown",this._onPolyMousedown,this);P(document).one("keydown",null,"r",P.proxy(this._rKeyDown,this)).one("keydown",null,"t",P.proxy(this._tKeyDown,this)).one("keydown",null,"ctrl",P.proxy(this._ctrlKeyDown,this))}};L.Handler.PolyEdit.prototype._origRemoveHooks=L.Handler.PolyEdit.prototype.removeHooks;L.Handler.PolyEdit.prototype.removeHooks=function(){P(document).off("keydown",this._rKeyDown).off("keydown",this._tKeyDown).off("keydown",this._ctrlKeyDown);this._origRemoveHooks.apply(this,Array.prototype.slice.apply(arguments))};L.Handler.PolyEdit.prototype._hideMarkers=function(){this._markerGroup.eachLayer(function(e){e._origOpacity=e.options.opacity;e.options.opacity=0;e._updateOpacity()})};L.Handler.PolyEdit.prototype._showMarkers=function(){this._markerGroup.eachLayer(function(e){if(e._origOpacity!=null)e.options.opacity=e._origOpacity||1;else e.options.opacity=1;e._updateOpacity()})};L.Handler.PolyEdit.prototype._showCenter=function(){var e=new L.LatLng(0,0),t,i,n,r,o,s=0,a,l,c,u;l=u=Number.MAX_VALUE;a=c=-1*Number.MAX_VALUE;e.x=e.y=0;i=this._poly._latlngs.length;if(this._poly._latlngs[i-1].lat===this._poly._latlngs[0].lat&&this._poly._latlngs[i-1].lng===this._poly._latlngs[0].lng){i--}for(t=0;t<i;t++){s=y.fromInternalCoords(this._poly._latlngs[t]);e.x+=s.x;e.y+=s.y}e.x/=i;e.y/=i;this._center=y.toInternalCoords(e.x,e.y);this._center.x=e.x;this._center.y=e.y;e.lat=this._center.lat;e.lng=this._center.lng;this._centerMarker=new L.Marker(e,{draggable:false,icon:this.options.icon});this._centerMarker.addTo(this._poly._map)};L.Handler.PolyEdit.prototype._hideCenter=function(){if(this._centerMarker&&this._centerMarker._map){this._centerMarker._map.removeLayer(this._centerMarker);this._centerMarker=null}};L.Handler.PolyEdit.prototype._rKeyDown=function(e){this._rotatePolys=true;this._hideMarkers();this._showCenter();P(document).one("keyup",null,"r",P.proxy(function(){this._rotatePolys=false;this._showMarkers();this._hideCenter();P(document).one("keydown",null,"r",P.proxy(this._rKeyDown,this))},this))};L.Handler.PolyEdit.prototype._tKeyDown=function(e){this._dragWholePolys=true;this._hideMarkers();P(document).one("keyup",null,"t",P.proxy(function(){this._dragWholePolys=false;this._showMarkers();P(document).one("keydown",null,"t",P.proxy(this._tKeyDown,this))},this))};L.Handler.PolyEdit.prototype._ctrlKeyDown=function(e){this._dragPerpendicular=true;P(document).one("keyup",null,"r",P.proxy(function(){this._dragPerpendicular=false;P(document).one("keydown",null,"ctrl",P.proxy(this._ctrlKeyDown,this))},this))};L.Handler.PolyEdit.prototype._onPolyMousedown=function(e){var t=y.fromInternalCoords(e.latlng);this._mousedownLatlng=e.latlng;this._mousedownLatlng.x=t.x;this._mousedownLatlng.y=t.y;if(this._dragWholePolys)return this._startPolyDrag(e);if(this._rotatePolys)return this._startPolyRotate(e)};L.Handler.PolyEdit.prototype._saveOrigins=function(){var e,t,i,n,r,o,s;t=this._markerGroup._layers;for(e in t){if(t.hasOwnProperty(e)){i=t[e].getLatLng();t[e]._origin=new L.LatLng(i.lat,i.lng);s=y.fromInternalCoords(t[e]._origin);t[e]._origin.x=s.x;t[e]._origin.y=s.y}}n=this._poly._latlngs;for(r=0,o=n.length;r<o;r++){n[r]._origin=new L.LatLng(n[r].lat,n[r].lng);s=y.fromInternalCoords(n[r]._origin);n[r]._origin.x=s.x;n[r]._origin.y=s.y}};L.Handler.PolyEdit.prototype._startPolyDrag=function(e){this._poly._map.on("mousemove",this._onPolyDragging,this);P(document).one("mouseup",P.proxy(this._endPolyDrag,this));this._saveOrigins()};L.Handler.PolyEdit.prototype._startPolyRotate=function(e){this._v1=new giscloud.geometry.Point(this._mousedownLatlng.y-this._center.y,this._mousedownLatlng.x-this._center.x);this._v1Atan=Math.atan2(this._v1.y,this._v1.x);this._poly._map.on("mousemove",this._onPolyRotate,this);P(document).one("mouseup",P.proxy(this._endPolyRotate,this));this._saveOrigins(e)};L.Handler.PolyEdit.prototype._onPolyDragging=function(e){var n=e.latlng.lng-this._mousedownLatlng.lng,r=e.latlng.lat-this._mousedownLatlng.lat,t=this._poly._latlngs,i,o,s,a,l,c,u,d,f,h;if(g.snapping()){a=this._markerGroup._layers;for(l in a){if(a.hasOwnProperty(l)){s=a[l]._origin;s=new L.LatLng(a[l]._origin.lat+r,a[l]._origin.lng+n);c=g.checkForSnapping(s);if(c&&!c.equals(s)){n=c.lng-a[l]._origin.lng;r=c.lat-a[l]._origin.lat;break}}}}this._markerGroup.eachLayer(function(e){var t=e._origin.lat+r,i=e._origin.lng+n;e.setLatLng(new L.LatLng(t,i));if(e._origLatLng){L.extend(e._origLatLng,e._latlng);e._origLatLng._o=null}});for(i=0,o=t.length;i<o;i++){t[i].lng=t[i]._origin.lng+n;t[i].lat=t[i]._origin.lat+r}this._poly.redraw();if(g.measureDisplay()){u=p.measure;d=this._mousedownLatlng;f=new L.LatLng(d.lat+r,d.lng+n);g.showMeasureMarker(1,d,f);if(!this._measureLine){this._measureLine=new L.Polyline([d,f],{color:"#333",weight:3,dashArray:"5, 5"});this._poly._map.addLayer(this._measureLine)}else{this._measureLine.setLatLngs([d,f])}}else{g.hideMeasureMarker(1);if(this._measureLine){this._poly._map.removeLayer(this._measureLine);this._measureLine=null}}};L.Handler.PolyEdit.prototype._onPolyRotate=function(e){var t=y.fromInternalCoords(e.latlng),i=new giscloud.geometry.Point(t.y-this._center.y,t.x-this._center.x),n=this._v1Atan-Math.atan2(i.y,i.x),r=this._center,o=this._poly._latlngs,s,a,l;this._markerGroup.eachLayer(function(e){var t=new giscloud.geometry.Point(e._origin.x,e._origin.y),i;C(r,n,t);i=y.toInternalCoords(t.x,t.y);e.setLatLng(i);if(e._origLatLng){L.extend(e._origLatLng,e._latlng);e._origLatLng._o=null}});for(s=0,a=o.length;s<a;s++){t=new giscloud.geometry.Point(o[s]._origin.x,o[s]._origin.y);t=C(this._center,n,t);o[s].x=t.x;o[s].y=t.y;t=y.toInternalCoords(t.x,t.y);o[s].lat=t.lat;o[s].lng=t.lng}this._poly.redraw()};L.Handler.PolyEdit.prototype._endPolyDrag=function(){var e=[],t,i,n;this._poly._map.off("mousemove",this._onPolyDragging);y.parent.hideTip();g.hideMeasureMarker(1);if(this._measureLine){this._poly._map.removeLayer(this._measureLine);this._measureLine=null}for(i=0,n=this._markers.length;i<n;i++){e.push(this._markers[i]._origLatLng)}this._poly.setLatLngs(e);this._poly.redraw();this._fireEdit()};L.Handler.PolyEdit.prototype._endPolyRotate=function(){var e=[],t,i,n;this._poly._map.off("mousemove",this._onPolyRotate);y.parent.hideTip();g.hideMeasureMarker(1);if(this._measureLine){this._poly._map.removeLayer(this._measureLine);this._measureLine=null}for(i=0,n=this._markers.length;i<n;i++){e.push(this._markers[i]._origLatLng)}this._poly.setLatLngs(e);this._poly.redraw();this._fireEdit()};L.Handler.PolyEdit.prototype._fnCanvasOverriden=true}function j(){if(!L.Handler.PolyEdit.prototype._onMarkerDragOrig){L.Handler.PolyEdit.prototype._onMarkerDragOrig=L.Handler.PolyEdit.prototype._onMarkerDrag;L.Handler.PolyEdit.prototype._onMarkerDrag=function(e){var t=e.target,i,n,r;t._origLatLng._o=null;if(g.snapping()){t.setLatLng(g.checkForSnapping(t._latlng))}if(g.measureDisplay()){if(t._prev){i=t._latlng;n=t._prev._latlng;g.showMeasureMarker(1,i,n)}else{g.hideMeasureMarker(1)}if(t._next){i=t._latlng;n=t._next._latlng;g.showMeasureMarker(2,i,n)}else{g.hideMeasureMarker(2)}}else{g.hideMeasureMarker(1);g.hideMeasureMarker(2)}this._onMarkerDragOrig(e)}}if(!L.Handler.PolyEdit.prototype._fireEditOrig){L.Handler.PolyEdit.prototype._fireEditOrig=L.Handler.PolyEdit.prototype._fireEdit;L.Handler.PolyEdit.prototype._fireEdit=function(e){y.parent.hideTip();g.hideMeasureMarker();this._fireEditOrig(e)}}}function M(){L.Handler.PolyEdit.prototype._onMarkerDrag=L.Handler.PolyEdit.prototype._onMarkerDragOrig;L.Handler.PolyEdit.prototype._fireEdit=L.Handler.PolyEdit.prototype._fireEditOrig;delete L.Handler.PolyEdit.prototype._onMarkerDragOrig;delete L.Handler.PolyEdit.prototype._fireEditOrig;g.hideMeasureMarker()}function I(){if(r){p.removeLayer(r);r=null}if(o){p.removeLayer(o);o=null}P.map(l,function(e){p.removeLayer(e);e=null});l=[];a=[];c=null;p.off("click",x);p.off("mousemove",t);g.cleanUp()}function D(e){if(s){if(a===null)s.reject(e);else s.resolve(a,e);I()}u=false;if(s)return s.promise()}function S(e){if(s){s.reject(e);I()}return s.promise()}return{initSnapping:j,endSnapping:M,initEdit:T,handleNumericKeypress:function(){if(c){t(c)}},addPoint:function(e){x(e)},currentlyDrawing:function(){return u},currentShapeGeometry:function(){if(u){return{currentlyDrawing:u,points:a,lastPoint:f}}return null},getPoint:function(e){if(e<0){e+=a.length}var t=a[e];if(!t)return null;return{lng:t.lng,lat:t.lat}},rectangleMode:function(e){if(e){p.dragging.disable();p.boxZoom.disable();p.on("mousedown",n)}else{p.off("mousedown",n);p.boxZoom.enable()}},start:function(e){p.doubleClickZoom.disable();u=e;p.on("click",x);p.on("mousemove",t);p.on("dblclick",v);s=new P.Deferred;return s.promise()},end:D,cancel:S,setPoints:function(e){a=e}}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,W,t,i){t.ViewerLeafletControl=function(e){var H=e.viewer,F=e.map;this.selectExtent=function(e){var x,k,i,c,n,r,C,T,j,M,o,s,a,l,u={color:"#0092E4",weight:4,opacity:1},d={color:"#00c697",weight:8},t=function(e){x=H.instance;k=new L.DivIcon({className:"gc-select-extent-label"});F.dragging.disable();F.on("mousedown",h);W(H.container()).addClass("gc-cursor-crosshair")},f=function(){N();F.off("mousedown",h).off("mousemove",p).off("mousedown",N).off("mousemove",D).off("mousemove",S).off("mousemove",P).off("mousemove",E);W(H.container()).removeClass("gc-cursor-crosshair")},h=function(e){var t=e.latlng,i=new L.LatLngBounds(t,t);n=t.lat;r=t.lng;F.off("mousedown",h);F.off("mousedown",N);F.on("mousemove",p);W(document).on("mouseup",g);c=new L.Rectangle(i).addTo(F)},p=function(e){var t=R(e.latlng);c.setBounds(t);m(t)},g=function(){F.off("mousemove",p);W(document).off("mouseup",g);F.on("mousedown",N);F.on("mousedown",h);y()},m=function(e){var t=e.getCenter(),i=e.getNorthEast(),n=e.getSouthWest(),r=i.lat,o=i.lng,s=n.lat,a=n.lng,l=x.fromInternalCoords(i),c=x.fromInternalCoords(n),u=l.y,d=l.x,f=c.y,h=c.x,p=new L.LatLng(r,t.lng),g=new L.LatLng(t.lat,o),m=new L.LatLng(t.lat,a),v=new L.LatLng(s,t.lng),y,_,b,w;if(C==null){C=new L.Marker(p,{icon:k,html:u}).addTo(F);T=new L.Marker(g,{icon:k,html:d}).addTo(F);M=new L.Marker(m,{icon:k,html:h}).addTo(F);j=new L.Marker(v,{icon:k,html:f}).addTo(F)}else{C.setLatLng(p)._icon.innerHTML=u;T.setLatLng(g)._icon.innerHTML=d;M.setLatLng(m)._icon.innerHTML=h;j.setLatLng(v)._icon.innerHTML=f}y=W(C._icon);_=W(T._icon);b=W(M._icon);w=W(j._icon);y.css("margin-left",y.outerWidth()/-2).css("margin-top",-25);_.css("margin-left",5).css("margin-top",_.outerHeight()/-2);b.css("margin-left",b.outerWidth()*-1-5).css("margin-top",b.outerHeight()/-2);w.css("margin-left",w.outerWidth()/-2).css("margin-top",5)},v=function(){if(C==null){return}F.removeLayer(C);F.removeLayer(T);F.removeLayer(M);F.removeLayer(j);C=null;T=null;M=null;j=null},y=function(){var e=c.getBounds(),t=e.getNorthEast(),i=e.getSouthWest(),n=new L.LatLng(t.lat,i.lng),r=new L.LatLng(i.lat,t.lng);c.setStyle({stroke:false});o=new L.Polyline([n,t],u).addTo(F).on("mouseover",_).on("mouseout",b).on("mousedown",w);s=new L.Polyline([r,t],u).addTo(F).on("mouseover",_).on("mouseout",b).on("mousedown",w);a=new L.Polyline([i,n],u).addTo(F).on("mouseover",_).on("mouseout",b).on("mousedown",w);l=new L.Polyline([i,r],u).addTo(F).on("mouseover",_).on("mouseout",b).on("mousedown",w)},_=function(e){var t=e.target;if(i){return}F.removeLayer(t).addLayer(t);e.target.setStyle(d)},b=function(e){e.target.setStyle(u)},w=function(e){var t=e.target;if(i){return}i=t;t.off("mouseover",_).off("mouseout",b);W(document).on("mouseup",I);switch(t){case o:F.on("mousemove",D);break;case s:F.on("mousemove",S);break;case a:F.on("mousemove",P);break;case l:F.on("mousemove",E);break}},I=function(){W(document).off("mouseup",I);switch(i){case o:F.off("mousemove",D);break;case s:F.off("mousemove",S);break;case a:F.off("mousemove",P);break;case l:F.off("mousemove",E);break}i.on("mouseover",_).on("mouseout",b);i=null},D=function(e){var t=c.getBounds(),i=t.getNorthEast(),n=t.getSouthWest(),r=F.latLngToContainerPoint(n),o=e.containerPoint.y,s=r.y;if(o>s-d.weight){return}t=new L.LatLngBounds(new L.LatLng(e.latlng.lat,i.lng),n);c.setBounds(t);m(t);O(t)},S=function(e){var t=c.getBounds(),i=t.getNorthEast(),n=t.getSouthWest(),r=F.latLngToContainerPoint(n),o=e.containerPoint.x,s=r.x;if(o<s+d.weight){return}t=new L.LatLngBounds(new L.LatLng(i.lat,e.latlng.lng),n);c.setBounds(t);m(t);O(t)},P=function(e){var t=c.getBounds(),i=t.getSouthWest(),n=t.getNorthEast(),r=F.latLngToContainerPoint(n),o=e.containerPoint.x,s=r.x;if(o>s-d.weight){return}t=new L.LatLngBounds(n,new L.LatLng(i.lat,e.latlng.lng));c.setBounds(t);m(t);O(t)},E=function(e){var t=c.getBounds(),i=t.getSouthWest(),n=t.getNorthEast(),r=F.latLngToContainerPoint(n),o=e.containerPoint.y,s=r.y;if(o<s+d.weight){return}t=new L.LatLngBounds(n,new L.LatLng(e.latlng.lat,i.lng));c.setBounds(t);m(t);O(t)},O=function(e){var t=e.getNorthEast(),i=e.getSouthWest(),n=new L.LatLng(t.lat,i.lng),r=new L.LatLng(i.lat,t.lng);o.setLatLngs([n,t]);s.setLatLngs([r,t]);a.setLatLngs([i,n]);l.setLatLngs([i,r])},A=function(){if(o==null){return}F.removeLayer(o);F.removeLayer(s);F.removeLayer(a);F.removeLayer(l);o=null;s=null;a=null;l=null},N=function(){if(c==null){return}v();A();F.removeLayer(c);n=null;r=null;c=null},R=function(e){var t=new L.LatLng(Math.min(n,e.lat),Math.min(r,e.lng)),i=new L.LatLng(Math.max(n,e.lat),Math.max(r,e.lng));return new L.LatLngBounds(t,i)},z=function(){var e=c&&c.getBounds(),t,i,n,r,o,s,a,l;if(e==null){return null}t=e.getNorthEast();i=e.getSouthWest();n=x.fromInternalCoords(t);r=x.fromInternalCoords(i);o=n.y;s=n.x;a=r.y;l=r.x;return new giscloud.Bounds(l,a,s,o)};return{init:t,getExtent:z,finalize:f}}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(c,d,f,h){var p,g;f.deferreds.mapboxLoading=new d.Deferred;f.ViewerMapbox=function(e,t,i){var o,u,r,s,n,a;o=this;s=f.oid();u={options:i};r={};u.layers=[];u.viewer=e;this.modeId="3D";if(f.deferreds.mapboxLoading.state()!=="resolved"){a=d.when(giscloud.includeJs(f.assetsSite()+"libs/mapbox-gl/mapbox-gl.js"),giscloud.includeJs(f.assetsSite()+"libs/mapbox-gl/mapbox-gl-draw.js"));a.done(function(){if(c.mapboxgl){f.deferreds.mapboxLoading.resolve()}else{f.deferreds.mapboxLoading.reject();f.deferreds.mapboxLoading=new d.Deferred}});if(!g){n=d.when(giscloud.includeCss(f.assetsSite()+"libs/mapbox-gl/mapbox-gl.css"),giscloud.includeCss(f.assetsSite()+"assets/api/1/viewer/mapbox/viewer.mapbox.css"),giscloud.includeCss(f.assetsSite()+"assets/api/1/viewer.css"));n.done(function(){g=true})}}this.init=new d.Deferred;this.init.done(function(){o.map=u.map;u.map.on("zoomend",function(e){d(r).triggerHandler("scaleChanged")});this._control=new f.ViewerMapboxControl(u)});f.deferreds.mapboxLoading.done(function(){p(u,t,i);u.map.on("load",function(){o.init.resolveWith(o)})});this.initialize=function(){this.initOnFirstLayerAdd=true};this.setupTerrain=function(){u.map.addSource("mapbox-dem",{type:"raster-dem",url:"mapbox://mapbox.mapbox-terrain-dem-v1",tileSize:512,maxzoom:o.demMaxZoom});u.map.setTerrain({source:"mapbox-dem",exaggeration:o.exaggeration})};this.initOnLayerAdd=function(){if(!this.initOnFirstLayerAdd){return}if(u.viewer.instance.epsg==900913||u.viewer.instance.epsg==3857){u.map.setProjection("globe")}else{u.map.setProjection("mercator")}if(u.viewer.instance.epsg==900913||u.viewer.instance.epsg==3857||u.viewer.instance.layersDEM){if(!u.map.getTerrain()){this.setupTerrain()}}u.map.setFog({"horizon-blend":.1,color:"#add8e6","high-color":"#87CEEB","space-color":"#87CEEB","star-intensity":0,range:[6,10]});this.initOnFirstLayerAdd=false};this.uninitialize=function(){if(u.draw){u.map.removeControl(u.draw);u.draw=null}u.layers.forEach(function(e){e.resetCache()})};this.hide=function(){u.container.hide()};this.show=function(){u.container.show()};this.setZIndex=function(e){u.container.css("z-index",e)};this.extractLayer=function(){return u.layers.pop()};this.resetZoomBearingPitch=function(e,t){if(Math.abs(u.map.getZoom()-e+1)<.01){e=h}this.setLocation(h,h,e,0,0,h,t,"easeTo")};this.toggleInteractions=function(t){var e=["scrollZoom","boxZoom","dragRotate","dragPan","doubleClickZoom","touchZoomRotate"];e.forEach(function(e){if(t){u.map[e].enable()}else{u.map[e].disable()}})};this.fromViewerGeometry=function(e,t){if(!e._id){return l(this,e,t)}var i=e._id;var n=i.length;var r;if(n===1){r=u.draw.get(i[0]);return l(this,r,t)}var o=[];for(var s=0;s<n;s++){r=u.draw.get(i[s]);o.push(l(this,r,t))}return o};this.bind=function(e,t){var i,n;if(typeof t!=="function"){throw"Handler is not a function!"}switch(e){case"click":i="click";break;case"mouseDown":i="mousedown";break;case"doubleClick":i="dblclick";break;case"mouseMove":i="mousemove";break;default:n=function(){t.apply(o,Array.prototype.slice.call(arguments,1))};d(r).on(e,n);t[e+s]=n;return this}n=function(e){t.apply(o,[new giscloud.LonLat(e.latlng.lng,e.latlng.lat)])};u.map.on(i,n);t[e+s]=n;return this};this.unbind=function(e,t){var i,n;if(typeof t!=="function"){throw"Handler is not a function!"}n=t[e+s];if(!n){return this}switch(e){case"click":i="click";break;case"mouseDown":i="mousedown";break;case"doubleClick":i="dblclick";break;case"mouseMove":i="mousemove";break;default:d(r).off(e,n);delete t[e+s];return this}u.map.off(i,n);delete t[e+s];return this};d.each(["click","doubleClick","mouseMove","mouseDown"],function(e,t){o[t]=function(e){o.bind(t,e)}});this.zoom=function(e,t){if(e==null){return u.map.getZoom()}else{u.map.setView(u.map.getCenter(),e,t);return this}};this.setMinZoom=function(e){if(e===h||e<0){u.map.setMinZoom(-2)}else{u.map.setMinZoom(e+.5)}};this.getMinZoom=function(){return u.map.getMinZoom()-.5};this.setScale=function(e,t){e--;if(t){u.map.setZoom(e)}else{u.map.zoomTo(e)}};this.getScale=function(){return Math.ceil(u.map.getZoom()+.5)};this.addScaleControl=function(){};this.newPopup=function(e){return new f.ViewerMapboxPopup(e)};this.addComponentToMap=function(e){e.addTo(u.map)};this.newMarker=function(e,t,i){return new f.ViewerMapboxMarker(e,t,i)};this.newIcon=function(e){return new f.ViewerMapboxIcon(e)};this.initDrawing=function(e){u.drawing=e;if(!u.draw){u.drawing.initialize()}};this.newViewerGeometry=function(e,t,i){if(e=="Polygon"){var n=t[t.length-1];if(t[0]!==n[0]||t[1]!==n[1]){t.push(t[0])}t=[t]}if(e=="Point"){}if(i.isMulti){var r=[];feature={type:"FeatureCollection",features:r};if(e=="MultiPolygon"){for(var o=0,s=t.length;o<s;o++){r.push({type:"Feature",properties:{},geometry:{type:"Polygon",coordinates:t[o]}})}}else if(e=="MultiPoint"){for(var o=0,s=t.length;o<s;o++){r.push({type:"Feature",properties:{},geometry:{type:"Point",coordinates:t[o]}})}}}else{feature={type:"Feature",properties:{},geometry:{type:e,coordinates:t}}}var a=u.draw.add(feature);return{_id:a,_draw:u.draw,_feature:feature,hasGeom:true}};this.getViewerGeometry=function(e,t,i){return i};this.getDrawingController=function(e,t){return new f.ViewerMapboxDrawing(e,u,t)};this.removeGeom=function(e){u.draw.delete(e._id)};this.enableGeometryEdit=function(e,t){if(t===false){u.draw.changeMode("static")}else{var i=e.featureGroup?e.featureGroup._id:e._id;if(i.length==1&&!e.featureGroup&&e._feature.geometry.type!=="Point")u.draw.changeMode("direct_select",{featureId:i[0]});else u.draw.changeMode("simple_select",{featureIds:i})}};this.extendLineGeometry=function(e,t){e._feature.geometry.coordinates.push(t);var i={id:e._id[0],type:"Feature",properties:{},geometry:e._feature.geometry};e._draw.add(i)};this.toInternalCoords=function(e,t,i,n,r){var o=u.map.gc_bounds.max/2,s=e*180/o,a=Math.atan(Math.exp(t*Math.PI/o))*360/Math.PI-90,l=new mapboxgl.LngLat(s,a);if(r){l=[l.lng,l.lat]}else{if(i!=null){l.push(i)}}if(n)l._o={x:e,y:t};return l};this.fromInternalCoords=function(e,t){var i,n;if(e._o){i=e._o.x;n=e._o.y}else{var r=t?e[0]:e.lng,o=t?e[1]:e.lat;if(r<-180)r+=360;if(r>180)r-=360;var s=r/180*Math.PI,a=o/180*Math.PI,l=u.map.gc_bounds.max/Math.PI/2;i=l*s;n=l*Math.log((Math.sin(a)+1)/Math.cos(a))}if(e.z!=null){return new giscloud.geometry.Point(i,n,e.z)}return new giscloud.geometry.Point(i,n)};this.toLeafletCoords=this.toInternalCoords;this.fromLeafletCoords=this.fromInternalCoords;this.on=function(e,t){if(e=="mousemove"||e=="mousedown"||e=="mouseup"||e=="click"||e=="touchstart"||e=="touchend"||e=="touchmove"){var r=t;if(!t._gc_event_proxy){t._gc_event_proxy={}}t._gc_event_proxy[e]=function(e){var t=u.map.gc_bounds,i,n;e.latLng=e.lngLat;e.latlng=e.lngLat;if(t){i=o.fromInternalCoords(e.latLng);e.x=i.x;e.y=i.y;e.z=o.getScale();n=1<<e.z;e.mapX=(e.x-t.xmin)/t.max*n;e.mapY=(t.ymax-e.y)/t.max*n;r(e)}};t=t._gc_event_proxy[e]}u.map.on(e,t)};this.off=function(e,t){if(t._gc_event_proxy&&t._gc_event_proxy[e]){var i=t._gc_event_proxy[e];delete t._gc_event_proxy[e];if(Object.keys(t._gc_event_proxy).length===0){delete t._gc_event_proxy}t=i}u.map.off(e,t)};this.fireSelectAreaEvent=function(e,t,i,n){var r,o,s=Math.abs(t.x-e.x),a=Math.abs(t.y-e.y);if(s>10&&a>10){r=this.fromInternalCoords(u.map.unproject(e));o=this.fromInternalCoords(u.map.unproject(t));n("areaselection",{originalEvent:i,xMin:r.x,yMin:r.y,xMax:o.x,yMax:o.y})}};this.fireSelectAreaToolEvent=function(e,t,i){var n=Math.abs(t.x-e.x),r=Math.abs(t.y-e.y);if(n>10&&r>10){var o=new mapboxgl.LngLatBounds(u.map.unproject(e),u.map.unproject(t));u.map.fitBounds(o)}};this.addLayer=function(e,t){if(t){e._tilesToRemove=[];for(var i in e._tiles){e._tiles[i].transferToAnotherViewer=true}}this.initOnLayerAdd();f.ViewerMapboxLayerFactory(e,u.map);e.addToMap();u.layers.push(e)};this.removeLayer=function(e){var t=u.layers.indexOf(e);if(t>-1){u.layers.splice(t,1)}e.removeFromMap();if(u.layers.length==0){var i=i?i:u.map.getTerrain();if(i){u.map.setTerrain(null);u.map.style.removeSource("mapbox-dem")}u.map.setProjection("mercator");this.initOnFirstLayerAdd=true}};this.whenIdle=function(e){u.map.once("idle",e)};this.unload=function(){u.map.setPitch(0)};this.isLoaded=function(){return u.map._loaded};this.getViewBound=function(){var e=u.map.getBounds();var t=this.fromInternalCoords(e._ne);var i=this.fromInternalCoords(e._sw);var n=new Object;n.xMin=i.x;n.xMax=t.x;n.yMin=i.y;n.yMax=t.y;return n};this.setViewUsingInternalCoords=function(e,t){t--;u.map.flyTo({center:e,zoom:t})};this.setViewBound=function(e,t,i,n,r,o,s){var a=this.toInternalCoords(e,t);var l=this.toInternalCoords(i,n);var c=new mapboxgl.LngLatBounds(a,l);if(u.map._loaded&&!o&&!s)u.map.fitBounds(c);else u.map.fitBounds(c,{duration:0});return};this.getCenter=function(){return this.fromInternalCoords(u.map.getCenter())};this.setLocation=function(e,t,i,n,r,o,s,a){if(u.map._loaded){var l={};if(e!==h&&t!==h){l.center=this.toInternalCoords(e,t)}if(i!==h){l.zoom=i-1}if(n!==h){l.bearing=n}if(r!==h){l.pitch=r}if(o!=h){l.duration=o}if(s){u.map.once("moveend",s)}if(a=="easeTo"){u.map.easeTo(l)}else if(a=="jumpTo"){u.map.jumpTo(l)}else{u.map.flyTo(l)}}};this.getBearing=function(){return u.map.getBearing()};this.setBearing=function(e){u.map.setBearing(e)};this.getPitch=function(){return u.map.getPitch()};this.setPitch=function(e){u.map.setPitch(e)};this.invalidateSize=function(){u.map.resize()};this.getBackgroundColor=function(){return this._backgroundColor};this.setBackgroundColor=function(e){this._backgroundColor=e;if(u.map.getLayer("background")){u.map.removeLayer("background")}if(e&&e!=="#ffffff"){u.map.addLayer({id:"background",type:"background",paint:{"background-color":e}},u.layers[0]?u.layers[0].id:h)}};this.setTool=function(e,t,i,n){u.map.boxSelect._onDone=null;if(e=="SelectAreaTool"||e=="AreaSelection"){u.map.boxSelect._onDone=n;u.map.boxSelect.enable()}else{u.map.boxSelect.disable()}var r={tool:e,previous_tool:t};i("toolchange",r);return e};this.setProjection=function(e){};this.setCursor=function(e){u.container.css("cursor",e);u.map._canvasContainer.style.cursor=e};this.reloadTerrain=function(){if(u.map.getTerrain()){u.map.setTerrain();u.map.removeSource("mapbox-dem");this.setupTerrain()}};this.dragging={enable:function(){u.map.dragPan.enable()},disable:function(){u.map.dragPan.disable()},enabled:function(){return u.map.dragPan.isEnabled()}};this.doubleClickZoom={enable:function(){u.map.doubleClickZoom.enable()},disable:function(){u.map.doubleClickZoom.disable()},enabled:function(){return u.map.doubleClickZoom.isEnabled()}};function l(t,e,i){var n,r,o;if(e.geometry)o=e.geometry.type;if(e instanceof Array){r=t.fromInternalCoords(e,true);if(i){r.z=r.z||0}return r}else if(o==="Point"){return t.fromInternalCoords(e.geometry.coordinates,true)}else if(o==="Polygon"){n=e.geometry.coordinates;if(d.isArray(n[0])){return new giscloud.geometry.Polygon(d.map(n,function(e){return new giscloud.geometry.Line(d.map(e,function(e){return l(t,e,i)}))}))}return new giscloud.geometry.Polygon([new giscloud.geometry.Line(d.map(n,function(e){return l(t,e,i)}))])}else if(o==="LineString"){return new giscloud.geometry.Line(d.map(e.geometry.coordinates,function(e){return l(t,e,i)}))}else{return null}}};p=function(a,e,t){var i,n,r;try{i=[];var o=d("<div/>");o.css("position","absolute").css("width","100%").css("height","100%");d("#"+e).append(o);a.container=o;r={container:o[0],attributionControl:false,projection:"mercator"};if(a.options.lockZoom){d.extend(r,{touchZoom:false,scrollWheelZoom:false,doubleClickZoom:false,zoomControl:false})}if(a.options.hideZoomButtons){d.extend(r,{zoomControl:false})}mapboxgl.accessToken="pk.eyJ1IjoiZ2lzLWNsb3VkIiwiYSI6ImNsNXdpc2U3czBrMHkzY25wdHBpMmd3amMifQ.abdXJowhfoRKhR4Zc3k4AQ";n=new mapboxgl.Map(r);n.options={};n.is_mapbox_gl=true;n.on("boxselect",function(e){if(n.boxSelect._onDone){n.boxSelect._onDone(e.startPos,e.endPos,e.originalEvent)}});n.overrideDEMTileURL=function(e,t){var i,n,r,o,s;if(!a.viewer.instance.layersDEM){return e}i=1<<t.z;n=a.map.gc_bounds;o=a.viewer.instance.layersDEM;for(s=0;s<o.length;s++){r=o[s];if(!r.fnLayer.options.visible){continue}if(t.x>Math.floor((r.xmin-n.xmin)/n.max*i)&&t.x<Math.floor((r.xmax-n.xmin)/n.max*i)&&t.y>Math.floor((n.ymax-r.ymax)/n.max*i)&&t.y<Math.floor((n.ymax-r.ymin)/n.max*i)){return f.tileSite()+"r/"+r.timestamp+"/"+a.viewer.instance._mid+"/"+r.id+"/"+t.z+"/"+t.x+"/"+t.y+".png"}}return e};a.map=n;a.layers=i}catch(e){throw{name:"Mapbox error on viewer init.",err:e}}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(r,e,t,i){var n;t.supportedMapbox=o;t.notSupportedReasonMapbox=s;function o(e){if(n===i){n=!s(e)}return n}function s(e){if(!a())return"not a browser";if(!l())return"insufficent Array support";if(!c())return"insufficient Function support";if(!u())return"insufficient Object support";if(!d())return"insufficient JSON support";if(!f())return"insufficient worker support";if(!h())return"insufficient Uint8ClampedArray support";if(!p())return"insufficient ArrayBuffer support";if(!g())return"insufficient Canvas/getImageData support";if(!v(e&&e.failIfMajorPerformanceCaveat))return"insufficient WebGL support";if(!b())return"insufficient ECMAScript 6 support"}function a(){return typeof r!=="undefined"&&typeof document!=="undefined"}function l(){return Array.prototype&&Array.prototype.every&&Array.prototype.filter&&Array.prototype.forEach&&Array.prototype.indexOf&&Array.prototype.lastIndexOf&&Array.prototype.map&&Array.prototype.some&&Array.prototype.reduce&&Array.prototype.reduceRight&&Array.isArray}function c(){return Function.prototype&&Function.prototype.bind}function u(){return Object.keys&&Object.create&&Object.getPrototypeOf&&Object.getOwnPropertyNames&&Object.isSealed&&Object.isFrozen&&Object.isExtensible&&Object.getOwnPropertyDescriptor&&Object.defineProperty&&Object.defineProperties&&Object.seal&&Object.freeze&&Object.preventExtensions}function d(){return"JSON"in r&&"parse"in JSON&&"stringify"in JSON}function f(){if(!("Worker"in r&&"Blob"in r&&"URL"in r)){return false}var e=new Blob([""],{type:"text/javascript"});var t=URL.createObjectURL(e);var i;var n;try{n=new Worker(t);i=true}catch(e){i=false}if(n){n.terminate()}URL.revokeObjectURL(t);return i}function h(){return"Uint8ClampedArray"in r}function p(){return ArrayBuffer.isView}function g(){var e=document.createElement("canvas");e.width=e.height=1;var t=e.getContext("2d");if(!t){return false}var i=t.getImageData(0,0,1,1);return i&&i.width===e.width}var m={};function v(e){if(m[e]===i){m[e]=_(e)}return m[e]}o.webGLContextAttributes={antialias:false,alpha:true,stencil:true,depth:true};function y(e){var t=document.createElement("canvas");var i=Object.create(o.webGLContextAttributes);i.failIfMajorPerformanceCaveat=e;return t.getContext("webgl",i)||t.getContext("experimental-webgl",i)}function _(e){var t=y(e);if(!t){return false}var i;try{i=t.createShader(t.VERTEX_SHADER)}catch(e){return false}if(!i||t.isContextLost()){return false}t.shaderSource(i,"void main() {}");t.compileShader(i);return t.getShaderParameter(i,t.COMPILE_STATUS)===true}function b(){return!document.documentMode}})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,t,i,n){var r;i.ViewerMapboxLayerFactory=function(e,t){if(e.isTileLayer){new i.ViewerMapboxTileLayer(e,t)}else if(e.isBaseMapLayer){new i.ViewerMapboxBasemapLayer(e,t)}else{new i.ViewerMapboxLayer(e,t)}};r={initialize:function(e,t){this.initializeCommon(e,t)},initializeCommon:function(e,t){this._map=t;this._layer._url=e._url;e.viewerLayer=this;this._layer.fnLayer=e},addToMap:function(){this._map.addLayer(this._layer)},removeFromMap:function(){if(this.resetCache){this.resetCache()}this._map.removeLayer(this._layer.id);this._map.removeSource(this._layer.id+"_src")},setVisible:function(e){},update:function(){this._layer.fnLayer.legacyHtml5Map.Html5SendRequests()},loaded:function(){return!!this._map},setOpacity:function(e){},setZIndex:function(e){},cleanTileCss:function(e){},onTileLoad:function(e,t){},onTileError:function(e,t){},tileShouldBeLoaded:function(e){return true},tileShouldBeVisible:function(e){},getTileUrl:function(e,t){},repaint:function(){this._map._sourcesDirty=true;this._map.triggerRepaint()}};i.ViewerMapboxLayer=i.LayerClass.extend(r)})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,t,i,c){var n,r;var o=0;r={type:"raster",tileSize:256,dontRetain:true,_getCanvasTile:function(e){return this._fnLayer._tiles[this._viewerLayer.getTileKey(e.tileID)]},_onStoreToCache:function(e){if(!this._fnLayer._tiles[e.gc_state._tileIndex]||this._viewerLayer.switching){return}e.gc_state._cacheId=++o;delete this._fnLayer._tiles[e.gc_state._tileIndex];this._fnLayer.gcmap.storeTileToCache(e)},_onRestoreFromCache:function(e){var t=this._viewerLayer.getTileKey(e.tileID);e.gc_state._tileIndexWrap=e.tileID.wrap;e.gc_state._tileIndex=t;this._fnLayer._tiles[t]=e.gc_state._canvas;e.state="loading";e.gc_state.cacheRestore=true;this._fnLayer.gcmap.restoreTileFromCache(e.gc_state._canvas);delete e.gc_state._cacheId},_abortTile:function(e){this._fnLayer.abortTileRequest(this._getCanvasTile(e))},_unloadTile:function(e){if(e.gc_state){this._fnLayer._unloadTile({tile:e.gc_state._canvas,imidiateRelease:true})}},_hasTile:function(e){return this._fnLayer._tileShouldBeLoaded(e.canonical,c,c,true)},_loadTile:function(e,t){var i=this._fnLayer,n=this._getCanvasTile(e);if(this._viewerLayer.switching){return}if(n&&n.transferToAnotherViewer){var r=n.coord;var o=n.zoom;var s=n.gc_state;delete n.transferToAnotherViewer;n.gc_state=null;n.coord=null;i._tilesToRemove.push(n);var a=i._createTile(true);a.gc_state=s;a.coord=r;a.zoom=o;a._layer=i;a.gc_state.viewerTile={tile:e,callback:t,isLoaded:true};e.gc_state=s;s._canvas=a;i._tiles[this._viewerLayer.getTileKey(e.tileID)]=a;this._fnLayer.render(a,n,{x:0,y:0},c,true);this._fnLayer.viewerLayer.tileOnLoad(a);return}n=i._createTile(true);n.gc_state.viewerTile={tile:e,callback:t,isLoaded:false};sourceObj=this;e.gc_state=n.gc_state;n._layer=i;n.gc_state.gc_layer=i;n.gc_state._canvas=n;var l=i._loadTile(n,e.tileID.canonical,e.tileID.wrap);if(!l){e.state="errored";t(null)}if(i._updateTimeout){clearTimeout(i._updateTimeout)}i._updateTimeout=setTimeout(function(){i._updateTimeout=null;i.update()},0)}};n={initialize:function(e,t){var i=e.id+"_src";var s=this;t.addSource(i,r);this._layer={id:e.id,type:"raster",source:i,paint:{"raster-fade-duration":0}};this.initializeCommon(e,t);this._source=t.getSource(i);this._source._offscreenRendering=!!this._layer.fnLayer.viewer.parent.offscreenRendering;this._source._getCanvasTile=r._getCanvasTile;this._source._fnLayer=this._layer.fnLayer;this._source._viewerLayer=this;this._source._sourceCache=this._map.style._sourceCaches["other:"+this._source.id];this._source._sourceCache.onHandleWrapJump=function(e){var t=s._layer.fnLayer._tiles,i,n,r,o;i={};for(o in t){n=t[o];r=t[o].gc_state;r._tileIndex=s.getTileKey(r.viewerTile.tile.tileID);r._tileIndexWrap=r.viewerTile.tile.tileID.wrap;i[r._tileIndex]=n}s._layer.fnLayer._tiles=i;if(s._source._offscreenRendering){s._layer.fnLayer.gcmap.workerWrapTiles(s._layer.id,e)}}},tileOnLoad:function(e){var t=e.gc_state;if(!t)return;var i=t.viewerTile;if(i.tile){i.isLoaded=true;if(i.tile.state!=="loaded"){i.tile.state="loaded";i.callback(null)}}},tilesToLoad:function(){return this._layer._tilesToLoad&&this._layer._tilesToLoad>0},setZIndex:function(){},resetCache:function(){var e=this._map.style._sourceCaches["other:"+this._source.id];if(e){e._cache.reset()}},render:function(e,t,i,n,r){var o,s,a=t;if(!r&&(!e.gc_state||!e.gc_state.viewerTile||!i)){return false}o=e.gc_state.viewerTile;s=!!o.tile.texture;if(n){a=this._layer.fnLayer.gcmap.getCanvasFromPool(i.width,i.height);a.getContext("2d").drawImage(t,i.xmin,i.ymin,i.width,i.height,0,0,i.width,i.height)}this._source.renderTile(o.tile,a,{x:i.xmin,y:i.ymin},s);if(a!==t){this._layer.fnLayer.gcmap.releaseCanvasToPool(a)}if(e.gc_state.cacheRestore){delete e.gc_state.cacheRestore;o.tile.state="loaded"}if(o.tile.state==="loaded"){o.callback(null)}return true},getTileKey:function(e){return this._layer.fnLayer.gcmap.getTileKey(e.canonical.x,e.canonical.y,e.canonical.z,e.wrap)}};i.ViewerMapboxTileLayer=i.ViewerMapboxLayer.extend(n)})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,u,i,n){var t,r;t={initialize:function(e,t,i){this._map=null;this._type="marker";this._subtype="standard";var n=u("<div>");var r=null;if(!e)e=[0,0];if(i){n.html(i)}else{var o=t.icon;if(o){if(o.iconUrl||t.iconInit){var s=u("<img>",{class:"gc-marker-icon"}).appendTo(n);this.markerIcon=s;if(o.iconAnchor){s.css({marginLeft:o.iconAnchor.x,marginTop:o.iconAnchor.y})}if(o.iconSize){s.width(o.iconSize.x);s.height(o.iconSize.y)}if(o.iconUrl){s[0].src=o.iconUrl}if(t.iconInit){t.iconInit(s)}}}if(t.icon.type!=="div"){r=u("<span>",{class:"gc-marker-iconlabel"}).appendTo(n)}if(o){if(o.wrapperAnchor){n.css({marginLeft:-o.wrapperAnchor.x,marginTop:-o.wrapperAnchor.y})}if(o.labelAnchor){r.css({marginLeft:o.labelAnchor.x,marginTop:o.labelAnchor.y})}}}this._marker=new mapboxgl.Marker(n[0],{anchor:"top-left"}).setLngLat(e);var a={};for(var l in t){a[l]=t[l]}this._marker.options=a;this._marker._icon=n[0];if(r){this._marker._label=r;this._marker.setLabelText=function(e){u(this._label).html(e)}}u(n).addClass(t.icon.className);var c=this;this.dragging={enable:function(){c._marker.setDraggable(true);u(c._marker._icon).css("cursor","pointer")},disable:function(){c._marker.setDraggable(false);u(c._marker._icon).css("cursor","")}}},move:function(e){var t=e.lngLat||e;this._marker.setLngLat(t)},addTo:function(e){this._map=e;this._marker.addTo(e);if(this._rotationHandler){this._map.on("rotate",this._rotationHandler)}this._gc_container=u(this._map._container)},text:function(e){u(this._marker._icon).text(e)},html:function(e){u(this._marker._icon).html(e)},remove:function(){if(this._rotationHandler){this._map.off("rotate",this._rotationHandler)}this._marker.remove();this._map=null},bindPopup:function(e,t){this._popup=new i.ViewerMapboxPopup(t);this._popup.setContent(e);this._popup._map=this._map;this._marker.setPopup(this._popup._popup)},isLabel:function(){return this._subtype==="label"},isIcon:function(){return this._subtype==="icon"},setContent:function(e){this._marker.setContent(e)},setLabelText:function(e){if(this.isLabel()){this._marker.setLabelText(e)}},setLabel:function(e){if(this._marker.setLabelText){this._marker.setLabelText(e)}else if(this._marker.options.icon&&this._marker.options.icon.setLabelText){this._marker.options.icon.setLabelText(e)}else{u(this._marker._icon).find(".gc-marker-iconlabel").html(e)}},getLatLng:function(){var e=this._marker.getLngLat();return new i.GeomLatLng(e.lat,e.lng)},setLatLng:function(e){this._marker.setLngLat(e)},setRotation:function(e){if(!this.markerIcon){this._marker.setRotation(e);return}if(e!==n){this._rotation=e;if(!this._rotationHandler){var t=this;this._rotationHandler=function(){t.setRotation()};if(this._map){this._map.on("rotate",this._rotationHandler)}}}else{e=this._rotation}if(this._map){e-=this._map.getBearing()}this.markerIcon.css({"-webkit-transform":"rotate("+e+"deg)","-moz-transform":"rotate("+e+"deg)","-ms-transform":"rotate("+e+"deg)",transform:"rotate("+e+"deg)"})},on:function(e,t){if(e==="dragend"){this._marker.on(e,t)}else{this._gc_container.on.apply(this._gc_container,arguments)}return this},off:function(e,t){if(e==="dragend"){this._marker.off(e,t)}else{this._gc_container.off.apply(this._gc_container,arguments)}return this}};i.ViewerMapboxMarker=i.LayerClass.extend(t)})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,t,i,n){var r;r={initialize:function(e){this._type="popup";this._map=null;e.anchor="bottom";e.closeOnClick=false;this._popup=new mapboxgl.Popup(e);this._gc_content=t("<div>",{class1:e.className}).css({"min-width":e.minWidth})},move:function(e){var t=e.lngLat||e;this._popup.setLngLat(t)},addTo:function(e){this._map=e;this._popup.addTo(e);this._gc_container=t(this._popup._container);this._gc_container.find(".mapboxgl-popup-close-button").addClass("gc-info-popup-close-button");this._gc_container.find(".mapboxgl-popup-content").addClass("gc-info-popup-content-wrapper")},setContent:function(e){this._gc_content.html(e);this._popup.setHTML(this._gc_content.prop("outerHTML"))},remove:function(){this._popup.remove()},fire:function(e,t){this._gc_container.triggerHandler(e,t)},on:function(e,t){if(e==="open"||e==="close"){this._popup.on(e,t)}else{this._gc_container.on.apply(this._gc_container,arguments)}return this},off:function(e,t){if(e==="open"||e==="close"){this._popup.off(e,t)}else{this._gc_container.off.apply(this._gc_container,arguments)}return this}};i.ViewerMapboxPopup=i.LayerClass.extend(r)})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,p,t,g){t.ViewerMapboxDrawing=function(e,i,t){var n=[],r,o=false;var s={enable:function e(t){setTimeout(function(){if(!t.map||!t.map.doubleClickZoom||!t.map.dragPan||!t._ctx||!t._ctx.store||!t._ctx.store.getInitialConfigValue)return;if(!t._ctx.store.getInitialConfigValue("doubleClickZoom"))return;t.map.doubleClickZoom.enable();t.map.dragPan.enable()},0)},disable:function e(t){setTimeout(function(){if(!t.map||!t.map.doubleClickZoom||!t.map.dragPan)return;t.map.doubleClickZoom.disable();t.map.dragPan.disable()},0)}};var a={onSetup:function e(t){var i=this.newFeature({type:"Feature",properties:{},geometry:{type:"Polygon",coordinates:[[]]}});this.addFeature(i);this.clearSelectedFeatures();s.disable(this);this.updateUIClasses({mouse:"add"});this.setActionableState({trash:true});return{rectangle:i}},onTap:function e(t,i){if(t.startPoint)this.onMouseMove(t,i);this.onClick(t,i)},onClick:function e(t,i){if(t.startPoint&&t.startPoint[0]!==i.lngLat.lng&&t.startPoint[1]!==i.lngLat.lat){this.updateUIClasses({mouse:"pointer"});t.endPoint=[i.lngLat.lng,i.lngLat.lat];this.changeMode("simple_select",{featuresId:t.rectangle.id})}var n=[i.lngLat.lng,i.lngLat.lat];t.startPoint=n},onDrag:function e(t,i){this.updateUIClasses({mouse:"add"});if(!t.startPoint)t.startPoint=[i.lngLat.lng,i.lngLat.lat];if(t.startPoint){l(t,i)}t.endPoint=[i.lngLat.lng,i.lngLat.lat]},onMouseUp:function e(t,i){if(t.startPoint&&t.endPoint){this.updateUIClasses({mouse:"pointer"});this.changeMode("simple_select",{featuresId:t.rectangle.id})}},onMouseMove:function e(t,i){if(t.startPoint){l(t,i)}},onKeyUp:function e(t,i){if(i.keyCode===27)return this.changeMode("simple_select")},onStop:function e(t){s.enable(this);this.updateUIClasses({mouse:"none"});this.activateUIButton();if(this.getFeature(t.rectangle.id)===g)return;t.rectangle.removeCoordinate("0.4");if(t.rectangle.isValid()){this.map.fire("draw.create",{features:[t.rectangle.toGeoJSON()]})}else{this.deleteFeature([t.rectangle.id],{silent:true});this.changeMode("simple_select",{},{silent:true})}},toDisplayFeatures:function e(t,i,n){var r=i.properties.id===t.rectangle.id;i.properties.active=r?"true":"false";if(!r)return n(i);if(!t.startPoint)return;return n(i)},onTrash:function e(t){this.deleteFeature([t.rectangle.id],{silent:true});this.changeMode("simple_select")}};function l(e,t){e.rectangle.updateCoordinate("0.0",e.startPoint[0],e.startPoint[1]);e.rectangle.updateCoordinate("0.1",t.lngLat.lng,e.startPoint[1]);e.rectangle.updateCoordinate("0.2",t.lngLat.lng,t.lngLat.lat);e.rectangle.updateCoordinate("0.3",e.startPoint[0],t.lngLat.lat);e.rectangle.updateCoordinate("0.4",e.startPoint[0],e.startPoint[1])}var c={};c.onSetup=function(){this.setActionableState();return{}};c.toDisplayFeatures=function(e,t,i){i(t)};function u(){if(MapboxDraw._gcOverrides)return;MapboxDraw.modes.draw_rectangle=a;MapboxDraw.modes.static=c;MapboxDraw.modes.direct_select.onDrag2=MapboxDraw.modes.direct_select.onDrag;MapboxDraw.modes.direct_select.onDrag=function(e,t){var i=this._ctx.map._gcState;t.lngLat=i.drawing.checkSnapping(t);this.onDrag2(e,t);if(!i.fnCanvas.measureDisplay())return;if(e.selectedCoordPaths&&e.selectedCoordPaths.length>=1){var n=e.selectedCoordPaths[0].split(".");var r=e.feature.coordinates[n[0]*1];var o=r.length;var s=n[1]*1;var a=s-1;var l=s+1;if(a<0){a=o-1}if(l>=o){l=0}s=f(r[s]);a=f(r[a]);l=f(r[l]);i.fnCanvas.showMeasureMarker(1,s,a);i.fnCanvas.showMeasureMarker(2,s,l)}};MapboxDraw.modes.direct_select.stopDragging2=MapboxDraw.modes.direct_select.stopDragging;MapboxDraw.modes.direct_select.stopDragging=function(e){var t=this._ctx.map._gcState;if(e.dragMoving){t.fnCanvas.hideSnappingTooltip();t.fnCanvas.hideMeasureMarker()}this.stopDragging2(e)};MapboxDraw.modes.draw_polygon.onKeyUp=function(){};MapboxDraw.modes.draw_polygon.onMouseMove2=MapboxDraw.modes.draw_polygon.onMouseMove;MapboxDraw.modes.draw_polygon.onMouseMove=function(e,t){var i=this._ctx.map._gcState;i.drawCurrentMode=this;i.drawLastMouseEvent=t;i.drawCurrentGeometryState=e;i.drawStore=e.polygon.ctx.store;i.drawing.setPoints(e.polygon.coordinates[0]);this.onMouseMove2(e,{lngLat:i.fnCanvas.getOverridenPoint(t.lngLat)});i.drawTriggerUpdate(e.polygon.coordinates[0],true)};MapboxDraw.modes.draw_polygon.clickAnywhere2=MapboxDraw.modes.draw_polygon.clickAnywhere;MapboxDraw.modes.draw_polygon.clickAnywhere=function(e,t){var i=this._ctx.map._gcState;var n=e.currentVertexPosition;i.drawing.setPoints(e.polygon.coordinates[0]);this.clickAnywhere2(e,{lngLat:i.fnCanvas.getOverridenPoint(t.lngLat)});if(n!=e.currentVertexPosition){i.drawTriggerUpdate(e.polygon.coordinates[0])}};MapboxDraw.modes.draw_line_string.onMouseMove2=MapboxDraw.modes.draw_line_string.onMouseMove;MapboxDraw.modes.draw_line_string.onMouseMove=function(e,t){var i=this._ctx.map._gcState;i.drawCurrentMode=this;i.drawLastMouseEvent=t;i.drawCurrentGeometryState=e;i.drawStore=e.line.ctx.store;this.onMouseMove2(e,{lngLat:i.fnCanvas.getOverridenPoint(t.lngLat)});i.drawTriggerUpdate(e.line.coordinates,true)};MapboxDraw.modes.draw_line_string.clickAnywhere2=MapboxDraw.modes.draw_line_string.clickAnywhere;MapboxDraw.modes.draw_line_string.clickAnywhere=function(e,t){var i=this._ctx.map._gcState;var n=e.currentVertexPosition;i.currentGeometry=e;this.clickAnywhere2(e,{lngLat:i.fnCanvas.getOverridenPoint(t.lngLat)});if(n!=e.currentVertexPosition){i.drawTriggerUpdate(e.line.coordinates)}};MapboxDraw.modes.draw_rectangle.onMouseMove2=MapboxDraw.modes.draw_rectangle.onMouseMove;MapboxDraw.modes.draw_rectangle.onMouseMove=function(e,t){var i=this._ctx.map._gcState;this.onMouseMove2(e,t);i.drawTriggerUpdate(e.rectangle.coordinates[0],true)};MapboxDraw._gcOverrides=true}function d(){u();var e=new MapboxDraw({displayControlsDefault:false,defaultMode:"static"});i.map._gcState=i;i.fnCanvas=t;i.drawTriggerUpdate=h;i.map.addControl(e);i.draw=e;i.map.on("draw.create",function(e){if(i.drawing){var t=e.features[0];if(t.geometry.type=="Point"){i.drawing.setPoints([t.geometry.coordinates])}else if(t.geometry.type=="Polygon"){i.drawing.setPoints(t.geometry.coordinates[0])}else{i.drawing.setPoints(t.geometry.coordinates)}i.drawing.end();i.draw.delete(t.id)}})}function f(e){return{lng:e[0],lat:e[1]}}function h(e,t){n=e;r&&r.notify(o,n,t)}return{initialize:function(){d()},initSnapping:function(){},endSnapping:function(){},initEdit:function(){},addPoint:function(){if(i.drawCurrentMode){i.drawCurrentMode.clickAnywhere(i.drawCurrentGeometryState,i.drawLastMouseEvent)}},handleNumericKeypress:function(){if(i.drawCurrentMode){i.drawCurrentMode.onMouseMove(i.drawCurrentGeometryState,i.drawLastMouseEvent);i.drawStore.render()}},currentlyDrawing:function(){return o},rectangleMode:function(e){i.drawCurrentMode=null;if(e){o="rectangle";i.draw.changeMode("draw_rectangle")}else{i.draw.changeMode("draw_polygon")}},checkSnapping:function(e){return t.snapping()?t.checkForSnapping(e.lngLat):e.lngLat},hideSnappingTooltip:function(){t.hideSnappingTooltip()},currentShapeGeometry:function(e){if(o){return{currentlyDrawing:o,points:n}}return null},getPoint:function(e){if(e<0){e+=n.length}var t=n[e];return t?f(t):null},start:function(e){o=e;var t="draw_polygon";if(e=="line"){t="draw_line_string"}else if(e=="point"){t="draw_point"}i.drawCurrentMode=null;i.draw.changeMode(t);r=new p.Deferred;return r.promise()},end:function(e){if(!o)return;o=false;i.drawCurrentMode=null;i.draw.changeMode("simple_select");if(r){if(n===null)r.reject(e);else r.resolve(n,e);n=[];t.cleanUp()}if(r)return r.promise()},cancel:function(e){o=false;i.drawCurrentMode=null;i.draw.changeMode("simple_select");if(r){r.reject(e);n=[];t.cleanUp()}return r.promise()},reloadSnappingData:function(){loadSnappingData()},setPoints:function(e){n=e}}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,t,i,n){i.ViewerMapboxControl=function(g){var m=g.viewer;this.selectExtent=function(e){var f,t,h,p;t=function(e,t){var i=f.fromInternalCoords(g.map.unproject(e)),n=f.fromInternalCoords(g.map.unproject(t)),r,o,s,a,l,c,u,d;if(i.x<n.x){r=i.x;o=n.x}else{r=n.x;o=i.x}if(i.y<n.y){s=i.y;a=n.y}else{s=n.y;a=i.y}l=[new giscloud.geometry.Point(r,s),new giscloud.geometry.Point(o,s),new giscloud.geometry.Point(o,a),new giscloud.geometry.Point(r,a),new giscloud.geometry.Point(r,s)];c=new giscloud.GraphicStyle("polygon");u=new giscloud.geometry.Line(l);d=new giscloud.geometry.Polygon([u]);if(p){m.graphic.remove(p)}p=new giscloud.GraphicFeature(d,c);m.graphic.add(p);h=new giscloud.Bounds(r,s,o,a)},init=function(e){f=m.instance;g.map.boxSelect._onDone=t;g.map.boxSelect.enable();f.setCursor("crosshair")},finalize=function(){g.map.boxSelect.disable();g.map.boxSelect._onDone=null;if(p){m.graphic.remove(p)}p=null},getExtent=function(){return h};return{init:init,getExtent:getExtent,finalize:finalize}}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,D,S,P){var t={};var E;giscloud.Graphic=function(l){var a={},c=this,r={},o=S.oid(),u=false,n=false,s,t=false,d=false,i={},f=new giscloud.GraphicStyle("line"),h,e,p,g,m;f.color=giscloud.Color.fromHex("#0092E4");f.color.alpha(80);f.size=6;function v(i){var n,e;if(!u){D.each(a,function(e,t){if(t.gid===i.id){n=t.feat;return null}});e={click:"click",dblclick:"doubleClick",mousedown:"mouseDown",mouseover:"mouseOver",mouseout:"mouseOut"}[i.type]||i.type;if(e&&n){D(r).triggerHandler(e,[n]);D(n).triggerHandler(e)}}}function y(e){var t=a[this.id],i=t&&t.gid,n,r;if(h&&i){if(e){h.remove(i);t.gid=null;if(e instanceof giscloud.geometry.Point||e instanceof giscloud.geometry.Multipoint){n=new giscloud.GraphicStyle("point")}else if(e instanceof giscloud.geometry.Line||e instanceof giscloud.geometry.Multiline){n=new giscloud.GraphicStyle("line")}else if(e instanceof giscloud.geometry.Polygon||e instanceof giscloud.geometry.Multipolygon){n=new giscloud.GraphicStyle("polygon")}else{n=new giscloud.GraphicStyle}r=t.feat.style();r.fill=n.fill?r.fill||n.fill:null;r.size=n.size?r.size||n.size:null;t.feat.style(r);i=h.addShape({geom:e,color:r.color.hex("0x"),fill:r.fill&&r.fill.hex("0x"),alpha:Math.max(r.color.alpha(),r.fill?r.fill.alpha():0),width:r.size,size:r.size},null,true);t.gid=i}}}function _(e){var t=a[this.id],i=t&&t.gid,n;if(h&&i){if(e.color!=null){h.setAttributeGeometry(i,"color",e.color.hex("#"),true)}if(e.fill!=null){h.setAttributeGeometry(i,"fill",e.fill.hex("#"),true)}if(e.size!=null){h.setAttributeGeometry(i,"size",e.size,true);h.setAttributeGeometry(i,"width",e.size,true)}if(e.border!=null){h.setAttributeGeometry(i,"border",e.border,true)}if(e.shape==="circle"){n=(e.size||0)+(e.border||0);h.setAttributeGeometry(i,"borderRadius",n,true)}else{h.setAttributeGeometry(i,"borderRadius",0,true)}h.redrawGeometry(i)}}function b(e){var t=a[this.id],i=t&&t.gid;if(h&&i){h.setGeometryVisible(i,!!e)}}function w(e){h.init();m=e;i={dragging:l.instance.dragging.enabled(),doubleClickZoom:l.instance.doubleClickZoom.enabled()};l.instance.dragging.disable();l.instance.doubleClickZoom.disable();l.instance.on("mousedown",k);l.instance.on("touchstart",k);D(document).keyup(x);t=false;d=false;return new D.Deferred}function x(e){if(e.which===27){M()}else if(e.which===13){j()}else{return true}}function k(e){l.instance.off("mousedown",k);l.instance.on("mousedown",C);l.instance.off("touchstart",k);l.instance.on("touchmove",C);if(e.type==="mousedown"){E=e.originalEvent.button;C(e)}}function C(e){if(E!==e.originalEvent.button)return;var t,i,n,r,o;if((e.type==="touchmove"||e.type==="touchstart")&&e.originalEvent){e.originalEvent.preventDefault()}if(e.originalEvent&&e.originalEvent.touches&&e.originalEvent.touches.length>1){return}l.instance.off("touchmove",C);t=m.style;if(!t.color||!t.color.hex){n="#0092E4";r=.8}else{n=t.color.hex();r=t.color.alpha()/100}i={color:n,opacity:r,weight:t.size!=null?parseFloat(t.size):4};if(i.opacity>1)i.opacity/=100;var s=l.instance.fromInternalCoords(e.latlng);o=new giscloud.geometry.Line([s,s]);d=new giscloud.GraphicFeature(o,m.style);c.add(d);l.instance.on("mousemove",L);l.instance.on("mouseup",T);l.instance.on("touchmove",L);l.instance.on("touchend",T)}function L(e){if(e.type==="touchmove"&&e.originalEvent){e.originalEvent.preventDefault();if(e.originalEvent.touches&&e.originalEvent.touches.length>1){return}}d.geometry().points.push(l.instance.fromInternalCoords(e.latlng));y.call(d,d.geometry())}function T(){var e;l.instance.off("mousemove",L);l.instance.off("mouseup",T);l.instance.off("touchmove",L);l.instance.off("touchend",T);l.instance.on("touchmove",C);if(!d)return;e=d.geometry();if(!t){e=new giscloud.geometry.Multiline([e]);t=new giscloud.GraphicFeature(e,m.style);c.add(t)}else{t.geometry().lines.push(e);y.call(t,t.geometry())}c.remove(d);d=null}function j(){I()}function M(){if(t){c.remove(t);t=null}I()}function I(){i.dragging?l.instance.dragging.enable():l.instance.dragging.disable();i.doubleClickZoom?l.instance.doubleClickZoom.enable():l.instance.doubleClickZoom.disable();l.instance.off("mousedown",k);l.instance.off("mousedown",C);l.instance.off("mouseup",T);l.instance.off("mousemove",L);l.instance.off("touchstart",k);l.instance.off("touchstart",C);l.instance.off("touchend",T);l.instance.off("touchmove",C);l.instance.off("touchmove",L);D(document).off("keyup",x);u=false;if(t){c.remove(t);p.resolveWith(c,[t])}else{p.rejectWith(c,[null])}}l.initializing.done(function(){h=l.instance.plugins.canvas;h.addEventListener("click",v);h.addEventListener("dblclick",v);h.addEventListener("mousedown",v);h.addEventListener("mouseover",v);h.addEventListener("mouseout",v)});e=this.features=[];this.bind=function(e,t){var i=this,n=function(){var e=Array.prototype.slice.call(arguments,1);t.apply(i,e)};D(r).on(e,n);if(!t.gcunbind){t.gcunbind={}}t.gcunbind[o+e]=n;return this};this.unbind=function(e,t){var i;i=t.gcunbind&&t.gcunbind[o+e];D(r).off(e,i);return this};this.isFeatureCountOkForSnapping=function(){var e,i,t,n,r,o=new D.Deferred;if(!h){o.reject();return o.promise()}e=h.snappingLayers();i=0;for(t in e){if(e[t]){r++;l.layerById(t).instance.getFeatureIds(function(e,t){i+=t.length;h.setSnappingLayerFids(e,t);r--;if(r===0){n=i<1e4;h.canSnap(n);if(n){o.resolve()}else{o.reject()}}})}}return o.promise()};this.snapToLayersGeometry=function(r){var e,t,i,o,s=false,n,a;if(r==null){if(l.initializing.state()!=="resolved"||l.loading.state()!=="resolved"){return false}i={};o=h.snappingLayers();e=l.layers||[];for(n=e.length-1;n>=0;n--){t=e[n];a=t.id.toString();if(t.type&&D.inArray(t.type,["tile","wms","wfs","wmts","raster","folder"])>-1){continue}i[a]=h.snapping()&&!!o[a]}return i}l.initializing.done(function(){o={};if(r===false){h.snappingLayers({});h.snapping(false);return}D.each(l.layers,function(e,t){var i=t.id.toString(),n=r===true||!!r[i];if(t.type&&D.inArray(t.type,["tile","wms","wfs","wmts","raster","folder"])>-1){return true}s=s||n;o[i]=n});h.snappingLayers(o);h.snapping(s)});return this};this.draw=function(e,t,i,n){var o,s=this;if(!D.isFunction(t)&&!D.isFunction(i)){n=t||{}}if(p&&p.state()==="pending"){if(u==="freehand"){j()}else{h.endDraw()}}if(e===false){return p.promise()}else{g=function e(t,i){var n,r;if(!i){i=t}else if(t&&t instanceof giscloud.GraphicStyle){r=t}if(i&&i.geom){n=new giscloud.GraphicFeature(giscloud.geometry.fromOGC(i.geom));if(n){a[n.id]={gid:o,feat:n,ind:s.features.length};_.call(n,r||n.style());s.features.push(n);n.bind("geometryChanged",y);n.bind("styleChanged",_);n.bind("visibilityChanged",b);p.resolveWith(s,[n])}else{p.rejectWith(s,[])}}else{p.rejectWith(s,[])}u=false},onDraw=function e(t,i){p.notify(t,i)};if(e==="point"||e==="line"||e==="polygon"){p=new D.Deferred;h.addEventListener("add",g.bind(this,n));h.addEventListener("draw",onDraw);p.always(function(){h.removeEventListener("add",g.bind(this,n));h.removeEventListener("draw",onDraw)});u=e;o=h.add(e)}else if(e==="freehand"){if(!n){n={}}else if(n instanceof giscloud.GraphicStyle){n={style:n}}if(!n.style){n.style=f}p=w(n);u="freehand"}else{throw"Invalid type. Use 'point', 'line', 'polygon' or 'freehand'."}if(typeof t==="function"){p.done(t)}if(typeof i==="function"){p.fail(i)}return p.promise()}};this.acceptDraw=function(){if(p&&p.state()==="pending"){if(u==="freehand"){j()}else{h.endDraw({cancel:false});p.reject()}}return this};this.cancelDraw=function(){if(p&&p.state()==="pending"){if(u==="freehand"){M()}else{h.endDraw({cancel:true});p.reject()}}return this};this.exists=function(e){return a[e.id]};this.setId=function(e,t){if(this.exists(e)){a[t]=a[e.id];delete a[e.id]}e.id=t};this.add=function(r){var o=this;l.initializing.done(function(){var e,t,i,n;if(r instanceof giscloud.GraphicFeature){t=r.geometry();if(t){i=r.style();n=i.fill&&i.color.alpha()<i.fill.alpha()?i.fill.alpha():i.color.alpha();if(n>1)n=n/100;e=h.addShape({geom:t,color:i.color&&i.color.hex("0x"),fill:i.fill&&i.fill.hex("0x"),alpha:n,width:i.size,size:i.size,border:i.border,shape:i.shape},null,true);a[r.id]={gid:e,feat:r,ind:o.features.length};r.graphicScene=o;o.features.push(r);r.bind("geometryChanged",y);r.bind("styleChanged",_);r.bind("visibilityChanged",b)}}});return this};this.edit=function(t){var e,i=a[t.id];if(!i){throw"Unknown graphic feature."}if(n&&n.state()==="pending"){this.cancel()}e=h.getGeometry?h.getGeometry(i.gid):giscloud.geometry.fromOGC(h.serializeGeometryOpenGIS(i.gid));n=(new D.Deferred).done(function(){h.editGeometryEnd(i.gid);var e=h.getGeometry?h.getGeometry(i.gid):giscloud.geometry.fromOGC(h.serializeGeometryOpenGIS(i.gid));t.geometry(e)}).fail(function(){h.editGeometryEnd(i.gid);t.geometry(e)});h.editGeometry(i.gid);s=t;return n.pipe(function(){return t},function(){return t}).always(function(){s=null})};this.editAccept=function(){if(n&&n.state()==="pending"){n.resolve()}return this};this.editCancel=function(){if(n&&n.state()==="pending"){n.reject()}return this};this.editedFeature=function(){return s};this.remove=function(t){var i=this;l.initializing.done(function(){var e;if(t instanceof giscloud.GraphicFeature){if(t.graphicScene)delete t.graphicScene;t=t.id}e=a[t];if(e!==P){h.remove(e.gid);i.features.splice(e.ind,1);e.feat.unbind("geometryChanged",y);e.feat.unbind("styleChanged",_);e.feat.unbind("visibilityChanged",b);delete a[t];e=null}});return this};this.clear=function(){if(h){if(p&&p.state()==="pending"){h.endDraw()}h.clear();D.each(this.features,function(e,t){t.unbind("geometryChanged",y);t.unbind("styleChanged",_);t.unbind("visibilityChanged",b)});this.features=[];a={}}return this};this.measureDisplay=function(e){if(e==null)return h.measureDisplay();else h.measureDisplay(e);return this}};giscloud.GraphicFeature=function(e,t){var i=S.oid(),n,r,o,s=true;if(e&&e.geometry&&e.style&&t===P){n=e;i=n.id!=null?"_orig"+n.id:i;r=n.geometry;o=n.style;this.epsg=n.epsg||null;this.proj4=n.proj4||null;this.resourceId=n.resourceId}else{if(!t||t.constructor!==giscloud.GraphicStyle){if(e instanceof giscloud.geometry.Point||e instanceof giscloud.geometry.Multipoint){o=new giscloud.GraphicStyle("point")}else if(e instanceof giscloud.geometry.Line||e instanceof giscloud.geometry.Multiline){o=new giscloud.GraphicStyle("line")}else if(e instanceof giscloud.geometry.Polygon||e instanceof giscloud.geometry.Multipolygon){o=new giscloud.GraphicStyle("polygon")}else{o=new giscloud.GraphicStyle}}else{o=t}if(e instanceof giscloud.Geometry)r=e}this.geometry=function(e){if(e){r=e;D(this).triggerHandler("geometryChanged",[r]);return this}else{return r}};this.style=function(e){if(e){D.extend(o,e);D(this).triggerHandler("styleChanged",[o]);return this}else{return o}};this.visibility=function(e){if(typeof e==="boolean"){s=e;D(this).triggerHandler("visibilityChanged",[s]);return this}else{return s}};this.id="graphic"+i;this.bind=function(e,t){var i=this,n=function(){var e=Array.prototype.slice.call(arguments,1);t.apply(i,e)};D(this).on(e,n);if(!t.gcunbind){t.gcunbind={}}t.gcunbind[this.id+e]=n;return this};this.unbind=function(e,t){var i;i=t.gcunbind&&t.gcunbind[this.id+e];D(this).off(e,i);return this};this.toOGC=function(){if(r){return r.toOGC()}else{return null}}};giscloud.GraphicFeature.prototype={toDataObject:function(){var e={};if(typeof this.id==="string"&&this.id.indexOf("orig")>-1){e.id=parseInt(this.id.match(/graphic_orig(\d+)/)[1],10)}e.resourceId=this.resourceId;e.geometry=new giscloud.geometry.GeometryCollection([this.geometry()]).toOGC();e.style=this.style().stringify();e.epsg=this.epsg||null;e.proj4=this.proj4||null;return e},update:function(){var t=this,e=this.toDataObject(),i;if(e.id!=null){i=e.id;delete e.id;return giscloud.graphicFeatures.update(i,e)}return giscloud.graphicFeatures.create(e).then(function(e){if(t.graphicScene){t.graphicScene.setId(t,"graphic_orig"+e)}else{t.id="graphic_orig"+e}return t}).promise()},remove:function(){return giscloud.graphicFeatures.remove(this.toDataObject().id)}};giscloud.GraphicStyle=function(e){if(typeof e==="string"){switch(e){case"point":D.extend(true,this,t.pointStyle);break;case"line":D.extend(true,this,t.lineStyle);break;case"polygon":D.extend(true,this,t.polygonStyle);break;default:break}}else{e=e||{};this.color=e.color!=null&&e.color instanceof giscloud.Color?e.color:null;this.fill=e.fill!=null&&e.fill instanceof giscloud.Color?e.fill:null;this.size=typeof e.size==="number"?e.size:null;this.border=typeof e.border==="number"?e.border:null;this.shape=e.shape==="circle"?"circle":e.shape==="square"?"square":null}};giscloud.GraphicStyle.prototype.stringify=function e(){var t={};if(this.color!=null)t.color=this.color.toRgbaString();if(this.fill!=null)t.fill=this.fill.toRgbaString();if(this.size!=null)t.size=parseInt(this.size,10);if(this.border!=null)t.border=parseInt(this.border,10);if(this.shape!=null)t.shape=this.shape;return JSON.stringify(t)};giscloud.GraphicStyle.parse=function e(t){var i=JSON.parse(t);if(i.color!=null)i.color=giscloud.Color.fromString(i.color);if(i.fill!=null)i.fill=giscloud.Color.fromString(i.fill);if(i.size!=null){i.size=parseInt(i.size,10);if(isNaN(i.size))i.size=null}return new giscloud.GraphicStyle(i)};t={pointStyle:new giscloud.GraphicStyle({color:new giscloud.Color(0,0,0,100),fill:new giscloud.Color(255,255,255,100),size:8,border:1,shape:"circle"}),lineStyle:new giscloud.GraphicStyle({color:new giscloud.Color(0,0,0,100),size:1}),polygonStyle:new giscloud.GraphicStyle({color:new giscloud.Color(0,0,0,100),fill:new giscloud.Color(255,0,0,100)})}})(window,giscloud.exposeJQuery(),giscloud.common());(function(s,i){var n=/[a-z0-9._%+\-]+@[a-z0-9.\-]+/i,c=i&&i.exposeJQuery()||s.jQuery;gravatar={hash:function(e){var t=i.md5||s.md5;if(!t){throw"No window.md5 hashing function available."}if(typeof e==="string"){if(n.test(e))return t(e.toLowerCase());return e}return null},element:function(e,t,i,n,r){var o,s=new c.Deferred,a,l={width:i,height:i,borderRadius:i};o=this.url(t,i,n,"404");if(e.firstName()&&e.lastName()){a=e.firstName().charAt(0)+e.lastName().charAt(0)}else{a=e.username().charAt(0)}a=a.toUpperCase();c.ajax({url:o,context:this}).always(function(e,t){if(t.toLowerCase().indexOf("error")>-1){l=c.extend(l,{backgroundColor:"#f5f5f5",border:"1px solid #e3e3e3",textAlign:"center",lineHeight:i+"px",fontWeight:700,fontSize:i/2-2+"px"},r);s.resolve(c("<div>",{css:l,text:a}))}else{l=c.extend(l,{backgroundImage:"url("+o+")"},r);s.resolve(c("<div>",{css:l}))}});return s},url:function(e,t,i,n){var r,o;r=this.hash(e);if(typeof t!=="number"){t=80}if(i){o="https:"}else{o=s.location.protocol=="https:"?"https:":"http:"}if(n==null){n="mm"}return[o,"//www.gravatar.com/avatar/",r,"?r=g&s=",t,"&d=",n].join("")},image:function(e,t,i,n,r){var o,s;s=c("<img/>",{src:this.url(e,t,n,r)});if(i){if(i.jquery){o=c(i)}else{o=c("#"+i)}}if(o&&o.length){o.append(s)}return s},profile:function(e){var t=gravatar.hash(e),i=["https://www.gravatar.com/",t,".json"].join("");return c.ajax(i,{dataType:"jsonp"}).then(function(e){return e},function(){return null})}};if(i){i.gravatar=gravatar}else{s.gravatar=gravatar}})(window,giscloud);(function(e,a,l,o){giscloud.Map=function(){var e=this,t=arguments,i=t.length,n={},r=l.oid(),o,s;a.extend(this,{id:null,resourceId:null,name:null,description:null,owner:null,active:null,copyright:null,proj4:null,epsg:null,units_proj4:null,units:null,measure_unit:null,maxzoom:null,share:null,bgcolor:null,wmsaccess:null,archived:null,modified:null,accessed:null,created:null,visited:null,bounds:null});if(typeof t[0]=="number"){this.id=t[0];this.refresh(t[2],t[1])}else if(typeof t[0]=="object"){o=t[0];this.id=parseInt(o.id,10);this.resourceId=parseInt(o.resource_id,10);this.name=o.name;this.description=o.description;this.owner=o.owner;this.active=o.active;this.copyright=o.copyright;this.proj4=o.proj4;this.epsg=o.epsg;this.units=o.units;this.measure_unit=o.measure_unit;this.units_proj4=o.units_proj4;this.maxzoom=o.maxzoom;this.share=o.share;this.bgcolor=o.bgcolor;this.wmsaccess=o.wmsaccess;this.archived=o.archived;this.modified=new Date(o.modified*1e3);this.accessed=new Date(o.accessed*1e3);this.created=new Date(o.created*1e3);this.visited=isNaN(o.visited)?null:parseInt(o.visited,10);if(o.options){this.options=o.options}if(o.permissions){this.permissions=o.permissions}if(o.bounds){try{s=o.bounds&&a.parseJSON(o.bounds)}catch(e){s=null}if(s){this.bounds=new giscloud.Bounds(parseFloat(s.xmin),parseFloat(s.ymin),parseFloat(s.xmax),parseFloat(s.ymax))}}if(t[1]){this.refreshLayers(t[2])}a.extend(true,this,{remove:function(){return giscloud.maps.remove(this.id)},archive:function(){return giscloud.maps.archive(this.id)},restore:function(){return giscloud.maps.restore(this.id)},update:function(){var e,t=a.extend({},o);t.name=this.name;if(this.bounds){e={xmin:this.bounds.left,ymin:this.bounds.bottom,xmax:this.bounds.right,ymax:this.bounds.top}}t.bounds=JSON.stringify(e);t.description=this.description;t.active=this.active;t.copyright=this.copyright;t.proj4=this.proj4;t.units=this.units;t.measure_unit=this.measure_unit;t.units_proj4=this.units_proj4;t.maxzoom=this.maxzoom;t.share=this.share;t.bgcolor=this.bgcolor;t.wmsaccess=this.wmsaccess;t.archived=this.archived;delete t.id;delete t.resourceId;return giscloud.maps.update(o.id,t)},clone:function(){var e={};a.extend(e,o);delete e.id;delete e.resourceId;return giscloud.maps.create(e)},users:function(){var e,t,i={owner:null,editors:[],viewers:[]};if(typeof this.owner==="object"){i.owner={id:this.owner.id,username:this.owner.username}}else{i.owner=this.owner}t=l.rest.get("maps/"+this.id+"/sharing").done(function(e){if(e&&e.data&&e.data.length){a.each(e.data,function(e,t){if(t.view==="t"){i.viewers.push({id:t.user_id,username:t.username})}if(t.edit==="t"){i.editors.push({id:t.user_id,username:t.username})}})}});e=a.when(t);return e.pipe(function(){return i}).promise()}})}else{l.setError(this,"constructor","Invalid constructor arguments")}};a.extend(giscloud.Map.prototype,{refresh:function(t,i){var n=this,e=this.id,r=function(e){if(typeof t=="function"){t(e)}};if(typeof e===o||e===null){l.setError(this,"refresh","Map id is not set.")}else{giscloud.maps.byId(e,function(e){n.resourceId=parseInt(e.resource_id,10);n.name=e.name;n.description=e.description;n.owner=e.owner;n.active=e.active;n.copyright=e.copyright;n.proj4=e.proj4;n.epsg=e.epsg;n.units=e.units;n.measure_unit=e.measure_unit;n.units_proj4=e.units_proj4;n.maxzoom=e.maxzoom;n.share=e.share;n.bgcolor=e.bgcolor;n.wmsaccess=e.wmsaccess;n.archived=e.archived;n.modified=new Date(e.modified);n.accessed=new Date(e.accessed);n.created=new Date(e.created);if(e.bounds){b=e.bounds&&a.parseJSON(e.bounds);if(b){n.bounds=new giscloud.Bounds(parseFloat(b.xmin),parseFloat(b.ymin),parseFloat(b.xmax),parseFloat(b.ymax))}}if(i){n.refreshLayers(r)}else{r(n)}},true)}return this},refreshLayers:function(t){var i=this,e=this.id;if(!isFinite(e)){l.setError(this,"refreshLayers","Map id is not set.")}else{giscloud.layers.byMapId(e,function(e){i.layers=e;if(typeof t=="function"){t(i)}})}return this},reset:function(e){return giscloud.maps.reset(this.id,e)},imageUrl:function(e,t){if(typeof e!=="number"&&typeof t!=="number"){e=400;t=400}return l.rest.url(["maps/",this.id,"/render.png?width=",e,"&height=",t,"&timestamp="+this.modified].join(""))},iframeUrl:function(e,t){var i,n,r,o,s;if(typeof e==="object"){n=e}i=l.rest.url("maps/"+this.id+"/render.iframe");if(n){r=[];for(o in n){if(n.hasOwnProperty(o)){s=n[o]!=null?n[o].toString():"";r.push(o+"="+s)}}i+=r.length>0?"?"+r.join("&"):""}else if(typeof e==="number"&&typeof t==="number"){i+="?width="+e+"&height="+t}return i}})})(window,giscloud.exposeJQuery(),giscloud.common());(function(t,e,i){giscloud.Task=function(e){t.extend(this,{id:e&&e.id||null,owner:e&&e.owner_id||null,type:e&&e.task_type_id||null,params:e&&e.params||null,alternateEmail:e&&e.alternate_email||null,status:e&&!isNaN(e.status)?e.status:null,priority:e&&!isNaN(e.priority)?e.priority:null,appId:e&&!isNaN(e.appId)?e.gc_app_id:null,timeSpent:e&&!isNaN(e.time_spent)?e.time_spent:null,requested:e&&!isNaN(e.timestamp_requested)&&new Date(e.timestamp_requested)||null,processed:e&&!isNaN(e.timestamp_processed)&&new Date(e.timestamp_processed)||null,scheduled:e&&!isNaN(e.timestamp_scheduled)&&new Date(e.timestamp_scheduled)||null})};giscloud.Task.prototype={create:function(e){return giscloud.tasks.create({task_type_id:this.type,alternate_email:this.alternateEmail,gc_app_id:this.appId,priority:this.priority,params:e||this.params})},remove:function(){return giscloud.tasks.remove(this.id)}}})(giscloud.exposeJQuery(),giscloud.common());(function(e,m,v,t){giscloud.ui={Toolbar:function(r){var n=this,e,t,i=r.viewer,o=v.oid(),s={},a,l=[],c={},u=function(e){var t="gctoolbar"+"_"+o+"_"+e.name,i;i=m("<div/>",{id:t,class:r.type==="vertical"?"gc-toolbar-placeholder gc-toolbar-placeholder-vertical":"gc-toolbar-placeholder gc-toolbar-placeholder-horizontal"});i.appendTo(a);e.render(t);s[e.name]=t},d=function(e){var t=l.length>0?l[l.length-1]:null,i;if(t){i=n.tools[t];i.deactivate()}l.push(e.name);if(l.length>99){l.shift()}m(c).triggerHandler("toolChange",[i,e])},f=function(){var e=l.length>0?l[l.length-1]:null;if(e){n.tools[e].activate()}};if(!v.toolbarCssIncluded){giscloud.includeCss(v.apiHost()+"/assets/api/1/css/toolbar.css");v.toolbarCssIncluded=true}this.viewer=i;this.tools={};if(r.container){a=m("#"+r.container);a.addClass("gc-toolbar");if(r.type==="vertical"){a.addClass("gc-toolbar-vertical")}else{a.addClass("gc-toolbar-horizontal")}}this.add=function(){var e,t,i,n=true;for(e=0,t=arguments.length;e<t;e++){i=arguments[e];if(i&&i instanceof giscloud.ui.Toolbar.Tool){if(!i.toolbar||i.toolbar!==this){i.toolbar=this}else{n=false}this.tools[i.name]=i;i.bind("activation",d);i.bind("deactivation",f);if(r.container&&n){u(i)}}}return this};if(r.defaultTools){for(e=0,t=r.defaultTools.length;e<t;e++){this.add(giscloud.ui.defaultTools.tool(r.defaultTools[e]))}if(m.inArray("pan",r.defaultTools)>-1){this.tools.pan.activate()}}this.remove=function(e){var t=m.inArray(e,l);if(t>-1&&t===l.length-1){this.deactivateTool()}else if(t>-1){l.splice(t,1)}delete this.tools[e];if(s[e]){m("#"+s[e]).remove();delete s[e]}return this};this.bind=function(e,t){var i=this,n;if(e&&typeof e=="string"&&typeof t=="function"){n=function(){var e=Array.prototype.slice.call(arguments,1);t.apply(i,e)};m(c).on(e,n);if(!t.gcunbind){t.gcunbind={}}t.gcunbind[o+e]=n}return this};this.unbind=function(e,t){var i;if(e&&typeof e=="string"&&typeof t=="function"){i=t.gcunbind&&t.gcunbind[o+e];if(i){m(c).off(e,i)}}return this};this.toolChange=function(e){return this.bind("toolChange",e)}}};giscloud.ui.Toolbar.Tool=function(e,d){var o,s,f=false,h,p,g=v.oid(),a={};this.options=d;this.name=e;this.isToggle=function(){return h};this.isActive=function(){return f};this.toolbar=d.toolbar;this.viewer=d.viewer;o=d.actions.activation;s=d.actions.deactivation;h=d.toggle;this.activate=function(e){var t=this,i=this.toolbar&&this.toolbar.viewer||this.viewer,n=Array.prototype.slice.call(arguments,0),r="gctool_"+this.name+"_"+g;if(!f&&i){i.initializing.done(function(){if(d.instant){n.splice(0,0,this);o.apply(this,n)}else{f=true;m("#"+r).addClass(d.styles.active||"gc-tool-active");if(!e){m(a).triggerHandler("activation",[t])}if(o){n.splice(0,0,this);o.apply(t,n)}}})}return this};this.deactivate=function(e){var t=this,i=this.toolbar&&this.toolbar.viewer||this.viewer,n=Array.prototype.slice.call(arguments,0),r="gctool_"+this.name+"_"+g;if(f&&i){i.initializing.done(function(){f=false;m("#"+r).removeClass(d.styles.active||"gc-tool-active");if(s){n.splice(0,0,this);s.apply(t,n)}if(!e){m(a).triggerHandler("deactivation",[t])}})}return this};this.render=function(e){var t=this,i=d.styles||{},n="gctool_"+this.name+"_"+g,r,o,s,a,l,c,u;if(!v.toolbarCssIncluded){giscloud.includeCss(v.apiHost()+"/assets/api/1/css/toolbar.css");v.toolbarCssIncluded=true}p=m("#"+e);p.html("");if(i.icon){r="gctoolicon_"+this.name+"_"+g;l=m("<img/>",{id:r,src:i.icon,alt:i.caption||""});if(i.iconHover){o="gctoolicon_hover_"+this.name+"_"+g;c=m("<img/>",{id:o,src:i.iconHover,alt:i.caption||"",css:{display:"none"}})}if(i.iconActive){s="gctoolicon_active_"+this.name+"_"+g;u=m("<img/>",{id:s,src:i.iconActive,alt:i.caption||"",css:{display:"none"}})}}a=m("<div/>",{id:n,class:i.cssClass||"gc-tool",title:i.caption||"",mouseover:function(e){m(this).addClass(i.hover||"gc-tool-hover");if(c){c.show();u.hide();l.hide()}e.stopPropagation();e.preventDefault()},mouseout:function(e){m(this).removeClass(i.hover||"gc-tool-hover");if(c){c.hide();if(f){u.show();l.hide()}else{u.hide();l.show()}}e.stopPropagation();e.preventDefault()},click:function(e){if(d.instant){t.activate()}else{if(f&&h){t.deactivate()}else if(!f){t.activate()}e.stopPropagation();e.preventDefault()}}});if(r){a.append(l);if(s){a.append(u)}if(o){a.append(c)}}else if(i.caption&&i.showCaption){a.append(i.caption)}else{a.append("&nbsp;")}a.appendTo("#"+e);return this};this.bind=function(e,t){var i=this,n;if(e&&typeof e=="string"&&typeof t=="function"){n=function(){var e=Array.prototype.slice.call(arguments,1);t.apply(i,e)};m(a).on(e,n);if(!t.gcunbind){t.gcunbind={}}t.gcunbind[g+e]=n}return this};this.trigger=function(e,t){m(a).trigger(e,t)};this.unbind=function(e,t){var i;if(e&&typeof e=="string"&&typeof t=="function"){i=t.gcunbind&&t.gcunbind[g+e];if(i){m(a).off(e,i)}}return this}};giscloud.ui.defaultTools={pan:function(e){return new giscloud.ui.Toolbar.Tool("pan",m.extend({styles:{caption:"Pan",showCaption:false,cssClass:"gc-tool-pan",active:"gc-tool-pan-active",hover:"gc-tool-pan-hover"},actions:{activation:function(e){e.pan()}}},e||{}))},zoom:function(e){return new giscloud.ui.Toolbar.Tool("zoom",m.extend({styles:{caption:"Zoom",showCaption:false,cssClass:"gc-tool-zoom",active:"gc-tool-zoom-active",hover:"gc-tool-zoom-hover"},actions:{activation:function(e){e.areaZoom()}}},e||{}))},full:function(e){return new giscloud.ui.Toolbar.Tool("full",m.extend({styles:{caption:"Full",showCaption:false,cssClass:"gc-tool-full",active:"gc-tool-full-active",hover:"gc-tool-full-hover"},actions:{activation:function(e){e.fullExtent()}},instant:true},e||{}))},measure:function(e){return new giscloud.ui.Toolbar.Tool("measure",m.extend({styles:{caption:"Measure",showCaption:false,cssClass:"gc-tool-measure",active:"gc-tool-measure-active",hover:"gc-tool-measure-hover"},actions:{activation:function(e){e.measure()}}},e||{}))},select:function(e){return new giscloud.ui.Toolbar.Tool("select",m.extend({styles:{caption:"Select",showCaption:false,cssClass:"gc-tool-select",active:"gc-tool-select-active",hover:"gc-tool-select-hover"},actions:{activation:function(e){e.select(true)}}},e||{}))},info:function(t){function i(){var e=m(v).data("marker");if(e){this.viewer.removeMarker(e);m(v).data("marker",false)}}function e(e){m(this).data("lastLonLat",e)}function n(e){v.viewerShowFeatureInfo(this.viewer,e.layerId,e.featureId,m(this).data("lastLonLat"),t&&t.renderFunction)}function r(){if(!m(this).data("tracking")){this.getMouse=m.proxy(e,this);this.viewer.bind("mouseMove",this.getMouse);m(this).data("tracking",true)}}function o(){if(m(this).data("tracking")){m(this).data("tracking",false);this.viewer.unbind("mouseMove",this.getMouse);this.getMouse=null}}return new giscloud.ui.Toolbar.Tool("info",m.extend({styles:{caption:"Info",showCaption:false,cssClass:"gc-tool-info",active:"gc-tool-info-active",hover:"gc-tool-info-hover"},actions:{activation:function(e){m(this).data("prevState",e.select());if(!this.viewer){this.viewer=e||this.toolbar&&this.toolbar.viewer}if(!this.options.dontShow){this.onFeatureOver=m.proxy(r,this);this.onFeatureOut=m.proxy(o,this);this.onFeatureAdd=m.proxy(n,this);this.hideInfo=m.proxy(i,this);e.bind("featureOver",this.onFeatureOver);e.bind("featureOut",this.onFeatureOut);e.bind("mouseDown",this.hideInfo);e.selection.bind("featureAdd",this.onFeatureAdd)}e.select(true)},deactivation:function(e){e.select(m(this).data("prevState"));if(!this.options.dontShow){e.unbind("featureOver",this.onFeatureOver);e.unbind("featureOut",this.onFeatureOut);e.bind("mouseDown",this.hideInfo);e.selection.unbind("featureAdd",this.onFeatureAdd);this.onFeatureOver=null;this.onFeatureOut=null;this.hideInfo=null;this.onFeatureAdd=null}}}},t||{}))},areaSelect:function(e){var n=v.oid(),t=function(e){var t=new giscloud.Bounds(parseFloat(e.xMin),parseFloat(e.yMin),parseFloat(e.xMax),parseFloat(e.yMax)),i=v.refs[n];v.refs[n].selectFeaturesByBounds(i.activeLayer,t)};return new giscloud.ui.Toolbar.Tool("areaSelect",m.extend({styles:{caption:"Select area",showCaption:false,cssClass:"gc-tool-areaselect",active:"gc-tool-areaselect-active",hover:"gc-tool-areaselect-hover"},actions:{activation:function(e){e.loading.done(function(){var e=this.instance;v.refs[n]=this;e.addEventListener("areaselection",t);e.setTool("AreaSelection")})},deactivation:function(e){e.loading.done(function(){this.instance.removeEventListener("areaselection",t);this.instance.setTool("DragTool");delete v.refs[n]})}}},e||{}))},pickCoordinates:function(e){var t;function i(e){t.coordinates=e;t.deactivate()}t=new giscloud.ui.Toolbar.Tool("pickCoordinates",m.extend({styles:{caption:"Coordinate picker",showCaption:false,cssClass:"coordinate-tool",active:"coordinate-tool-active",hover:"coordinate-tool-hover"},actions:{activation:function(e){this.coordinates=null;e.loading.done(function(){m(e.container()).addClass("gc-cursor-crosshair");e.bind("mouseDown",i)})},deactivation:function(e){e.loading.done(function(){e.unbind("mouseDown",i);m(e.container()).removeClass("gc-cursor-crosshair")})}}},e||{}));return t},selectExtent:function(e){var i,n={};return new giscloud.ui.Toolbar.Tool("selectExtent",m.extend({extent:null,styles:{caption:v.__("Select extent"),showCaption:false,cssClass:"gc-tool-selectextent",active:"gc-tool-selectextent-active",hover:"gc-tool-selectextent-hover"},actions:{activation:function(e){var t=this;this.extent=null;e.loading.done(function(){i=e.instance.selectExtentTool();n.dragging=e.instance.dragging.enabled();i.init(t)})},deactivation:function(e){var t=this;e.loading.done(function(){t.extent=i.getExtent();i.finalize();n.dragging?e.instance.dragging.enable():e.instance.dragging.disable()})}}},e||{}))},tool:function(e,t){switch(e){case"pan":return this.pan(t);case"zoom":return this.zoom(t);case"full":return this.full(t);case"measure":return this.measure(t);case"select":return this.select(t);case"info":return this.info(t);case"areaSelect":return this.areaSelect(t);case"selectExtent":return this.selectExtent(t);case"freehandSelect":return giscloud.ui.defaultTools.freehand(t);case"azimuth":return giscloud.ui.defaultTools.azimuth(t);case"areaMeasure":return giscloud.ui.defaultTools.areaMeasure(t);case"distanceMeasure":return giscloud.ui.defaultTools.distanceMeasure(t);case"countByPolygon":return giscloud.ui.defaultTools.countByPolygon(t);default:return null}}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(_,b,w,x){var C,L,h,p,g,T,j,l,M,I,m,v,f=[],D={selectable:true,locks:true,dnd:true,dropdownMenu:false,hiddenLayerIds:[]};(function(g,e){"use strict";var m,v,a=document.createElement("div");a.className="jstree-dropdown fa fa-ellipsis-v";function t(e,t){var i,n,r,o,s,a,l,c,u,d,f;function h(){m.addClass("gc-hidden")}function p(e){g(j).triggerHandler("menu_action",[g(e.currentTarget).attr("data-action"),n])}if(!m){m=g("<div/>").attr("id","gc_layer_list_dropdown").addClass("gc-layer-list-dropdown").addClass("gc-hidden").appendTo(g("body")).click(function(e){e.stopPropagation();m.toggleClass("gc-hidden")}).mouseenter(function(){g("#gc_layers_box").css("z-index",17007);g("#gc_layer_list_dropdown").css("z-index",17008)}).mouseleave(function(){g("#gc_layers_box").css("z-index",999);g("#gc_layer_list_dropdown").css("z-index",1e3)})}g(document).one("click",h);i=t.id&&t.id.split("_");n=i&&i.length&&i[2];r=I.layerById(n),o;if(t.id!=v){m.removeClass("gc-hidden")}else{m.toggleClass("gc-hidden")}v=t.id;m.empty();l=r?r.grp?"layer_group_"+n:"layer"+n:null;c=l?I.instance.getLayerByName(l):null;if(c&&t.data.type!=="folder"&&t.data.type!=="giscloud"){o=1-c.getAlpha()/100;a=g("<div/>",{class:"dragdealer",id:"demo-simple-slider"}).append(g("<div/>",{class:"gc-opacity-info",text:w.__("Transparency")}),g("<div/>",{class:"handle red-bar"})).prependTo(m).click(function(e){e.stopImmediatePropagation();e.preventDefault()});new Dragdealer("demo-simple-slider",{x:o,animationCallback:function(e){var t=Math.round(e*100),i=Math.round((1-e)*100);g("#demo-simple-slider .red-bar").text(t);c.setAlpha(i);g(j).triggerHandler("opacity",[n,i])}})}s=[{action:"zoomtolayer",text:w.__("Zoom_to_Layer")}];g(j).triggerHandler("menu_before",[s,t]);d=g("<ul/>",{class:"gc-list"});for(f=0;f<s.length;f++){if(s[f].text==="separator"){u=g("<li/>",{class:"gc-separator"})}else{u=g("<li/>",{class:"gc-list-item",text:s[f].text}).attr("data-action",s[f].action).click(p)}u.appendTo(d)}d.appendTo(m);m.position({my:"right top",at:"right top+"+e.height(),of:e,collision:"fit"});if(_.gcapp&&gcapp.config&&gcapp.config.newDatagrid){m.css("z-index",17008)}}g.jstree.defaults.dropdown=g.noop;g.jstree.plugins.dropdown=function(e,s){this.bind=function(){s.bind.call(this);this.element.on("dblclick.jstree",".jstree-dropdown",g.proxy(function(e){e.stopImmediatePropagation();e.preventDefault();this.settings.dropdown.call(this,this.get_node(e.target))},this)).on("click.jstree",".jstree-dropdown",g.proxy(function(e){e.stopImmediatePropagation();e.preventDefault();t(g(e.currentTarget),this.get_node(e.target))},this))};this.redraw_node=function(e,t,i){e=s.redraw_node.call(this,e,t,i);if(e){var n=a.cloneNode(true),r=this.get_node(e.id),o;if(!r||!r.data||r.data.type=="style"||r.data.type=="button"){return e}o=g(e).children(".jstree-wholerow");g(o).append(n)}return e}}})(b);(function(e,t){e.jstree.plugins.nohover=function(){this.hover_node=jQuery.noop}})(b);(function(e,t){e.jstree.plugins.noselect=function(){this.select_node=jQuery.noop}})(b);(function(h,e){"use strict";var p=document.createElement("i");p.className="gc-ll-icon gc-vicon gc-eye";h.jstree.defaults.visibility=h.noop;h.jstree.plugins.visibility=function(e,f){this.bind=function(){f.bind.call(this);this.element.on("dblclick.jstree",".gc-eye",h.proxy(function(e){e.stopImmediatePropagation();e.preventDefault();this.settings.visibility.call(this,this.get_node(e.target))},this)).on("click.jstree",".gc-eye",h.proxy(function(e){var s=h(e.target),t=s.closest("li"),i=t.attr("id").split("_"),n,r,o,a;e.stopImmediatePropagation();e.preventDefault();s.toggleClass("gc-eye-visible");if(t.hasClass("gc-layer-child-node")){r=t.attr("exprindex");if(!r){return}if(typeof r==="string"){r=parseInt(r)}n=I.layerById(t.attr("layerid"));if(s.hasClass("gc-eye-visible")){n.expressionVisible(r,true);h(j).triggerHandler("expressionVisibilityChange",[n.id,r,true])}else{n.expressionVisible(r,false);h(j).triggerHandler("expressionVisibilityChange",[n.id,r,false])}}else{a=s.siblings(".jstree-children").children();n=I.layerById(i[2]);a.each(function(e,t,i){var n=e&&e.expressions();var r=h(i).attr("exprindex");var o=h(i).children(".gc-vicon");if(s.hasClass("gc-eye-visible")){if(n&&n.length>0&&n[r]&&!n[r].instance.visible){return o.removeClass("gc-eye-visible")}o.addClass("gc-eye-visible")}else{o.removeClass("gc-eye-visible")}}.bind(this,n));o=L.recursive(i[2]);h.each(o,function(e,i){var t=i.data.id&&I.layerById(i.data.id);var n=t&&t.expressions();var r;if(s.hasClass("gc-eye-visible")){if(n&&n.length>0){n.forEach(function(e,t){r=h("#"+i.children[t]).children(".gc-vicon");if(!e.instance.visible){r.removeClass("gc-eye-visible")}else{r.addClass("gc-eye-visible")}})}L.show(i.data.id)}else{if(n&&n.length>0){n.forEach(function(e,t){r=h("#"+i.children[t]).children(".gc-vicon");r.removeClass("gc-eye-visible")})}L.hide(i.data.id)}h(j).triggerHandler("visibility",[i.data.id,s.hasClass("gc-eye-visible")])})}},this))};this.allChildrenVisible=function(){};this.redraw_node=function(e,t,i){var r,n,o,s,a,l,c,u,d;try{e=f.redraw_node.call(this,e,t,i)}catch(e){console.error("We are unable to call redraw_node method");return}if(e){n=this.get_node(e.id);if(n.data.type==="style"||n.data.type==="button"){return e}r=p.cloneNode(true),this.allChildrenVisible(n.data.id);e.insertBefore(r,e.childNodes[2]);o=e.id;s=o&&o.split("_");a=s&&s.length&&s[2];l=I.layerById(a);u=L.getLayerById(a);d=u&&(u.type==="folder"?u:null);if(d){if(d.visible==="t"){r.className+=" gc-eye-visible"}else{e.className+=" gc-layer-hidden"}e.insertBefore(r,e.childNodes[2]);return e}if(!l){return e}if(n.children.length>0){c=h(e.children).filter("ul.jstree-children");h.each(n.children,function(e,t){var i=h(r.cloneNode(true));var n=l.instance.features.length-1-e;if(n<0||!l.instance.features[n]){console.warn("Layers data from map.xml doesn't match data from REST!",l,t);return}if(l.instance.features[n].visible){i.addClass("gc-eye-visible")}else{i.addClass("gc-layer-hidden")}c.find("#"+t+" .jstree-icon.jstree-ocl").after(i)});if(l.visible()){r.className+=" gc-eye-visible"}else{e.className+=" gc-layer-hidden"}}if(l){if(l.visible()){r.className+=" gc-eye-visible"}else{e.className+=" gc-layer-hidden"}}}return e}}})(b);(function(u,e){"use strict";var d=document.createElement("i");d.className="jstree-icon jstree-locks";u.jstree.defaults.locks=u.noop;u.jstree.plugins.locks=function(e,c){this.bind=function(){c.bind.call(this);this.element.on("dblclick.jstree",".jstree-locks",u.proxy(function(e){e.stopImmediatePropagation();e.preventDefault();this.settings.locks.call(this,this.get_node(e.target))},this)).on("click.jstree",".jstree-locks",u.proxy(function(e){var t,i,n;e.stopImmediatePropagation();e.preventDefault();if(!I){return}t=u(e.target);i=t.closest("li");n=i.attr("id").split("_");L.selectability(n[2],!t.hasClass("jstree-lock-icon"))},this))};this.redraw_node=function(e,t,i){var n,r,o,s,a,l;e=c.redraw_node.call(this,e,t,i);if(e){r=this.get_node(e.id);if(r.data.type==="folder"||r.data.type==="style"){return e}o=e.id;s=o&&o.split("_");a=s&&s.length&&s[2];l=I.layerById(a);if(!l){return e}n=d.cloneNode(true);if(l.selectable&&u.inArray(r.data.type,["point","line","polygon","wms"])!==-1){n.className+=l.selectable()?" jstree-no-lock-icon":" jstree-lock-icon";e.insertBefore(n,e.childNodes[3])}}return e}}})(b);(function(o,e){"use strict";var u=document.createElement("i");u.className="jstree-icon jstree-settings ";o.jstree.defaults.settings=o.noop;o.jstree.plugins.settings=function(e,c){this.bind=function(){c.bind.call(this);this.element.on("dblclick.jstree",".jstree-settings",o.proxy(function(e){e.stopImmediatePropagation();e.preventDefault();this.settings.settings.call(this,this.get_node(e.target))},this)).on("click.jstree",".jstree-settings",o.proxy(function(e){var t,i,n,r;e.stopImmediatePropagation();e.preventDefault();if(!I){return}t=o(e.target);i=t.closest("li");n=i.attr("id").split("_");r=L.getLayerById(n[2]);o(j).triggerHandler("setting",[n[2],t.hasClass("jstree-lock-icon")])},this))};this.redraw_node=function(e,t,i){var n,r,o,s,a,l;e=c.redraw_node.call(this,e,t,i);if(e){r=this.get_node(e.id);if(r.data.type==="style"){return e}o=e.id;s=o&&o.split("_");a=s&&s.length&&s[2];l=I.layerById(a);n=u.cloneNode(true);if(r.data.type==="folder"){e.insertBefore(n,e.childNodes[3])}else{e.insertBefore(n,e.childNodes[4])}}return e}}})(b);giscloud.ui.LayerList=function(e,t,n,r){var s=w.oid(),o=!!(_.mdc&&_.cordova),a,l,c,u,d,f,h,p,g,m,v,y=false;if(!e){throw"No viewer to attach to."}L=this;this.initialized=false;this.layersLoading=new b.Deferred;M=t;I=e;b.extend(D,r);j={};c={};if(o&&!n||_.user&&_.user.id>-1){v=giscloud.userOptions.byName("MAP_"+I.mapId+"_LAYERS_STATES").then(function(e){var t;try{t=e&&e.value&&JSON.parse(e.value);if(!t){return{}}return t}catch(e){return{}}},function(){return b.Deferred().resolve({})})}else{v=b.Deferred().resolve({})}initTree=function(){var o=!_.mdc||!_.cordova;if(n){I.addLayersExpandParam("form","datasource","analysis","options");a=I.layersLoading}else{a=b.when(giscloud.layers.byMapId(I.mapId,{expand:"form,datasource,analysis,options"}),v)}o&&b("#"+M).loader("show");a.done(function(e,n){n=n||{};o&&b("#"+M).loader("hide");l=b.isArray(e[0])&&(e[0].length===0||e[0][0]instanceof giscloud.Layer)?e[0]:e;c={};function r(e){b.each(e,function(e,t){var i=t.id.toString();c[i]=t;if(n[i]){if(n[i].v!=null){t.visible=n[i].v?"t":"f"}if(t.opened!=null&&n[i].o!=null){t.opened=n[i].o?"t":"f"}}if(t.sublayers&&t.sublayers.length>0)r(t.sublayers)})}r(l);S(l);if(b.jstree.reference("#"+M)!=null){b("#"+M).jstree("destroy").empty();b("#"+M).trigger("jstree.after_destroy")}u=C(l,s,I);u.on({"before.jstree":function(){},"check_node.jstree":function(e,t){f(t.rslt.obj[0].id)},"uncheck_node.jstree":function(e,t){h(t.rslt.obj[0].id)},"check_all.jstree":function(){p()},"uncheck_all.jstree":function(){g()},"ready.jstree":function(){b(j).triggerHandler("ready");if(!D.dnd){b("#"+M).find(".jstree-container-ul li").on("mousedown",function(){return false})}if(!D.selectable){b("#"+M).find("a.jstree-anchor").css("cursor","default")}},"after_open.jstree":function(){b(j).triggerHandler("afterOpen")},"mousedown.jstree":function(){y=true},"mouseup.jstree":function(){y=false},"open_node.jstree":function(e,t){var i=t.node.id.split("_");b(j).triggerHandler("open",[i[2],t.node.state.opened])},"close_node.jstree":function(e,t){var i=t.node.id.split("_");b(j).triggerHandler("close",[i[2],t.node.state.opened])},"after_close.jstree":function(e,t){var i=t.node.id.split("_");b(j).triggerHandler("afterClose")},"rename_node.jstree":function(e,t){b(j).triggerHandler("rename",[t.node.data.id,t.old,t.text])},"select_node.jstree":function(e,t){var i=t.node.id.split("_");if(i.length>3)b(j).triggerHandler("select",["select",i[3],i[4],c[i[2]]]);else b(j).triggerHandler("select",["select",i[1],i[2],c[i[2]]])},"deselect_node.jstree":function(e,t){var i=t.node.id.split("_");if(i.length>3)b(j).triggerHandler("unselect",["unselect",i[3],i[4],c[i[2]]]);else b(j).triggerHandler("unselect",["unselect",i[1],i[2],c[i[2]]])},"dblclick.jstree":function(e,t){var i,n,r=b(e.target).hasClass("jstree-icon")?"style":"general",o=b(e.target).closest("li");if(o.length<1)return;i=o.attr("id");if(typeof i!=="string")return;n=i.split("_");node=b("#"+M).jstree().get_node("#"+i);if(node&&node.data.type==="style")b(j).triggerHandler("dblclick",["dblclick",n[3],n[4],c[n[2]],r]);else b(j).triggerHandler("dblclick",["dblclick",n[1],n[2],c[n[2]],r])},"changed.jstree":function(e,t){var i=b.map(t&&t.selected||[],function(e){var t=e.split("_");if(t.length>3)return{type:t[3],id:t[4],layer:c[t[2]]};else return{type:t[1],id:t[2],layer:c[t[2]]}});b(j).triggerHandler("changed",["changed",i])}});b("#"+M).on("move_node.jstree",function(e,t){var i=t.node.id.split("_"),n=i[2],r=t.parent.split("_"),o=t.old_parent.split("_"),s=r==o;r=r&&r.length==3?r[2]*1:null;o=o&&o.length==3?o[2]*1:null;var a=L.recursive(),l=[];b.each(a,function(e,t){l.push({id:t.data.id})});b(j).triggerHandler("orderchange",[l,n,r,o])});b(j).triggerHandler("reload");L.initialized=true;if(_.gcapp&&gcapp.config&&gcapp.config.newDatagrid){var t=b("#gc_layers_box");var i=b("#layer_list_parent ul");t.add(i).mouseenter(function(){t.css("z-index",17007);b("#gc_layer_list_dropdown").css("z-index",17008)});t.mouseleave(function(){t.css("z-index",999);b("#gc_layer_list_dropdown").css("z-index",1e3)})}});a.then(L.layersLoading.resolve,L.layersLoading.reject)};I.loading.done(initTree);this.bind=function(e,t){var i=this,n=function(){var e=Array.prototype.slice.call(arguments,1);t.apply(i,e)};b(j).on(e,n);if(!t.gcunbind){t.gcunbind={}}t.gcunbind[s+e]=n;return this};this.unbind=function(e,t){var i;i=t.gcunbind&&t.gcunbind[s+e];b(j).off(e,i);return this};this.selectAll=function(){if(!c)return;var i=[];b.each(c,function(e,t){i.push(t)});this.select(i)};this.isDragging=function(){return y};this.select=function(e,n){if(e){if(!c)return;if(!b.isArray(e)){e=[e]}b.each(e,function(e,t){var i;if(!(t instanceof giscloud.Layer)){t=c[t]}if(!t)return;i=s+(t.type==="folder"?"_folder_":"_layer_")+t.id;if(!n&&u&&u.jstree)u.jstree("select_node","#"+i)})}return this};this.unselect=function(e){if(e){if(!b.isArray(e)){e=[e]}b.each(e,function(e,t){var i;if(!(t instanceof giscloud.Layer)){t=c[t]}i=s+(t.type==="folder"?"_folder_":"_layer_")+t.id;u.jstree("deselect_node","#"+i)})}else{if(u&&u.jstree)u.jstree("deselect_all")}return this};this.selected=function(){if(!u)return;return b.map(b("#"+M).jstree("get_selected"),function(e){var t;if(typeof e!=="string")return;t=e.split("_");return c[t[2]]})};this.toggle=function(e,n){if(!c)return;if(e){if(!b.isArray(e)){e=[e]}b.each(e,function(e,t){var i;if(!(t instanceof giscloud.Layer)){t=c[t]}i=s+(t.type==="folder"?"_folder_":"_layer_")+t.id;if(n)u.jstree("open_node","#"+i);else u.jstree("close_node","#"+i)})}return this};this.expandAll=function(){u.jstree("open_all")};this.collapseAll=function(){u.jstree("close_all")};this.rename=function(e){var t=this.getNodeById(e);if(!t)return;b("#"+M).jstree("edit",t.id)};this.lock=function(e){this.selectability(e,true)};this.unlock=function(e){this.selectability(e,false)};this.selectability=function(e,t){var i=L.getLayerById(e),n=I.layerById(e);if(i&&n){i.lock=t?"t":"f";var r=getNodeByLayerId("#",e),o=b("#"+r.id+" .jstree-locks");if(t){n.selectable(false);o.addClass("jstree-lock-icon");o.removeClass("jstree-no-lock-icon")}else{n.selectable(true);o.addClass("jstree-no-lock-icon");o.removeClass("jstree-lock-icon")}b(j).triggerHandler("lock",[e,t])}};this.show=function(e){this.visibility(e,true)};this.hide=function(e){this.visibility(e,false)};this.visibility=function(e,t){var n=L.getLayerById(e),r=I.layerById(e);if(n){n.visible=t?"t":"f";var o=getNodeByLayerId("#",e);var s=b("#"+o.id).children(".gc-vicon");if(t){b("#"+o.id).removeClass("gc-layer-hidden");s.addClass("gc-eye-visible")}else{b("#"+o.id).addClass("gc-layer-hidden");s.removeClass("gc-eye-visible")}if(t){if(n.type!="folder"){I.showLayer(e)}}else{if(n.type!="folder"){I.hideLayer(e)}else{cl=d(e);if(cl){for(i=0,k=cl.length;i<k;i++){I.hideLayer(cl[i])}}}}}};this.check=function(e){if(e){if(!b.isArray(e)){e=[e]}b.each(e,function(e,t){var i;if(!(t instanceof giscloud.Layer)){t=c[t]}i=s+(t.type==="folder"?"_folder_":"_layer_")+t.id;var n=u.get_node("#"+i)})}return this};this.uncheck=function(e){if(e){if(!b.isArray(e)){e=[e]}b.each(e,function(e,t){var i;if(!(t instanceof giscloud.Layer)){t=c[t]}i=s+(t.type==="folder"?"_folder_":"_layer_")+t.id;b("#"+M).jstree("uncheck_node","#"+i)})}return this};this.checkAll=function(){u.jstree("check_all");return this};this.uncheckAll=function(){u.jstree("uncheck_all");return this};this.destroy=function(){b("#"+M).jstree("destroy").empty();b("#customDemList").empty();b("#"+M).trigger("jstree.after_destroy");j={};c={}};this.layers=function(){return l};this.width=function(e){if(e===x){return b("#"+M).width()}b("#"+M).width(e);return this};this.height=function(e){if(e===x){return b("#"+M).height()}b("#"+M).height(e);return this};this.layersOrder=function(){var e=[];return e};this.loader=_.mdc&&_.cordova?b.noop:function(e){var t=b("#"+M);if(e==="hide"){t.loader("hide");t.children().show()}else if(e==="show"){t.children().hide();t.loader("show")}};recursive=function(e,t,i){var n=[],r;if(!e)e=b("#"+M).jstree().get_node(t);if(!e){return n}else if(e.data&&e.data.type!="style"||e.id=="#"){r=i&&i.excludeEmbededLayers&&e.data.type&&e.data.type=="giscloud";if(e.id!="#")n=[e];if(e.children&&!r){for(var o=0;o<e.children.length;o++){n=b.merge(n,recursive(null,e.children[o],i))}}}return n};this.recursive=function(e,t){var i=e?getNodeByLayerId("#",e):this.getNode("#");return recursive(i,null,t)};this.getNode=function(e){return b("#"+M).jstree().get_node(e)};getNodeByLayerId=function(e,t){var i=b("#"+M).jstree().get_node(e);if(!i){return null}else if(i.data&&i.data.id==t){return i}else if(i.children){var n;for(var r=0;r<i.children.length;r++){var o=getNodeByLayerId(i.children[r],t);if(o)return o}}};this.getNodeById=function(e){return getNodeByLayerId("#",e)};this.getLayerById=function(e){return c[e]};f=function(e){var t,i,n,r=e.split("_");if(r[1]==="layer"){I.showLayer(r[2])}else{n=d(e);if(n){for(t=0,i=n.length;t<i;t++){I.showLayer(n[t])}}}};h=function(e){var t,i,n,r=e.split("_");if(r[1]==="layer"){I.hideLayer(r[2])}else{n=d(e);if(n){for(t=0,i=n.length;t<i;t++){I.hideLayer(n[t])}}}};p=function(){b.each(I.layers,function(e,t){t.visible(true)})};g=function(){b.each(I.layers,function(e,t){t.visible(false)})};d=function(e){var i=[];b("#"+e).find("li[rel!='style']").each(function(e,t){if(this.id.indexOf("folder")===-1){i.push(this.id.split("_")[2])}});return T(i)};m=function(e,t){var i=I.layerById(e);if(i){i.selectable(t)}}};C=function(e,t,i){var n=["themes","ui","types","wholerow","visibility"];if(D.locks===true)n.push("locks");l=b.browser.msie&&b.inArray(jQuery.browser.version,["8.0","9.0"])>-1;if(D.dropdownMenu&&!l)n.push("dropdown");if(D.dnd===true)n.push("dnd");if(!D.selectable){n.push("nohover");n.push("noselect")}var r,o=h(e,t),s=_.mdc&&_.cordova?"libs/giscloud/giscloud.ui.css":w.apiHost()+"/1/giscloud.ui.css?modules=layerlist",a={plugins:n,dnd:{copy:false},types:{max_depth:-2,max_children:-2,valid_children:["layer","folder"],layer:{valid_children:["style"]},folder:{valid_children:["layer","folder"]},style:{valid_children:[],start_drag:false,move_node:false,hover_node:false,dehover_node:false,select_node:false}},ui:{selected_parent_close:false},core:{check_callback:function(e,t,i,n,r){if(e=="move_node"){if(t.data&&t.data.type=="style"){return false}if(t.original&&t.original.belongsToGcMap){return false}if(i.original&&i.original.belongsToGcMap){return false}if(!i.parent)return true;return i.data&&i.data.type=="folder"?true:false}},themes:{url:giscloud.app?null:s,theme:"giscloud",dots:false,responsive:D.responsive||false},multiple:false,animation:0,data:o}};r=b("#"+M).jstree(a);b.each(f,function(e){b("#"+f[e]+" > a > i").addClass("nocolorLayerList")});return r};m=function(e){if(e.showlabel){return giscloud.xssSafe(e.label)}else if(e.value_min!==x&&e.value_max!==x){return e.value_min+" - "+e.value_max}else{return giscloud.xssSafe(e.expression)||""}};h=function(e,c,t){var i,n,r,o,s,u,a,l=[],d={},f=[];if(!e){return{}}for(i=0,n=e.length;i<n;i++){r=e[i];o=null;if(b.inArray(r.id*1,D.hiddenLayerIds)>-1)continue;if(r.type==="folder"){s="folder"+r.id;if(d[s]){d[s].obj=r;d[s].shouldExpand=!!r.opened&&r.opened==="t";o=d[s]}else{o={id:s,obj:r,nodes:[],shouldExpand:!!r.opened&&r.opened==="t"};d[s]=o}}else{s="layer"+r.id;o={id:s,obj:r,shouldExpand:!!r.opened&&r.opened==="t"}}if(r.parent===null){l.push(o)}else{a="folder"+r.parent;if(!d[a]){d[a]={id:r.parent,obj:null,nodes:[]}}d[a].nodes.push(o)}}u=function(e,a){var t;function l(e){return!!e&&(e.hatchUrl||e.galleryUrl||e.hatchGalleryUrl||e.url&&!/^\/icons\//i.test(e.url))}t=e.sort(g);return b.map(t,function(i){var e,t;if(i.nodes){return{id:c+"_folder_"+i.obj.id,text:giscloud.xssSafe(i.obj.name),data:{type:"folder",title:giscloud.xssSafe(i.obj.name),id:i.obj.id*1},belongsToGcMap:a,children:u(i.nodes,a),state:{opened:i.shouldExpand},li_attr:{title:"ID: "+i.obj.id+"\n"+w.__("Name")+": "+giscloud.xssSafe(i.obj.name)+"\nType: 'Folder'",rel:"folder",id:c+"_folder_"+i.obj.id,class:"jstree-undetermined"+(i.shouldExpand?" jstree-open":"")}}}else if(i.obj.type=="giscloud"){e=e&&e[0];return{id:c+"_gcmap_"+i.obj.id,text:giscloud.xssSafe(i.obj.name),icon:p("giscloud"),children:h(i.obj.sublayers,c,true),data:{type:i.obj.type,title:giscloud.xssSafe(i.obj.name),id:i.obj.id*1},state:{opened:i.shouldExpand},li_attr:{title:"ID: "+i.obj.id+"\n"+w.__("Name")+": "+giscloud.xssSafe(i.obj.name)+"\n"+w.__("Type")+": '"+i.obj.source.type+"'\n"+w.__("Source")+": '"+i.obj.source.src+(i.obj.datasourceId?"'\n"+w.__("Datasource_ID")+": "+i.obj.datasourceId:""),rel:"layer",id:c+"_layer_"+i.obj.id,class:i.obj.visible==="t"?"jstree-checked":""}}}else{e=i.obj.styles;var n=i.obj.source.type&&i.obj.source.type==="raster"?i.obj.source.type:i.obj.source.dbtype||i.obj.source.type;if(e&&e.length>1){var r=false;if(e[0].relief_color!==x&&e[0].value_stop!==x){r=true}return{id:c+"_layer_"+i.obj.id,text:giscloud.xssSafe(i.obj.name),icon:p(null,"multi"),data:{type:i.obj.type,title:giscloud.xssSafe(i.obj.name),id:i.obj.id*1},state:{opened:i.shouldExpand},li_attr:{title:"ID: "+i.obj.id+"\n"+w.__("Name")+": "+giscloud.xssSafe(i.obj.name)+"\n"+w.__("Type")+": '"+n+"'\n"+w.__("Source")+": '"+i.obj.source.src+(i.obj.datasourceId?"'\n"+w.__("Datasource_ID")+": "+i.obj.datasourceId:""),rel:"layer",id:c+"_layer_"+i.obj.id,class:(i.obj.visible==="t"?"jstree-checked":"")+(i.shouldExpand?" jstree-open":"")},belongsToGcMap:a,children:function(){if(r){return[{id:c+"_layer_"+i.obj.id+"_expression_"+i.obj.id,text:"",icon:v(e,i.obj.id),data:{type:"style",title:""},li_attr:{rel:"style",layerid:i.obj.id,exprindex:i.obj.id,id:c+"_layer_"+i.obj.id+"_expression_"+i.obj.id,class:"jstree-style-node gc-layer-child-node jstree-cover gradient"},belongsToGcMap:a}]}return b.map(e,function(e,t){return{id:c+"_layer_"+i.obj.id+"_expression_"+t,text:m(e),icon:p("geometry",e.offlineUrl&&e||e.symbol||(e.galleryUrl||e.url)&&e||e.hatchGalleryUrl&&e||{type:i.obj.type,color:e.color,border:e.bordercolor,relief_color:e.relief_color}),data:{type:"style",title:m(e)},li_attr:{rel:"style",layerid:i.obj.id,exprindex:t,id:c+"_layer_"+i.obj.id+"_expression_"+t,class:"jstree-style-node gc-layer-child-node"+(l(e)?" jstree-cover":"")},belongsToGcMap:a}})}()}}else{e=e&&e[0];var o="",s=false;if(i.obj&&i.obj.source)o="ID: "+i.obj.id+"\n"+w.__("Name")+": "+giscloud.xssSafe(i.obj.name)+"\n"+w.__("Type")+": '"+n+"'\n"+w.__("Source")+": '"+i.obj.source.src+(i.obj.datasourceId?"'\n"+w.__("Datasource_ID")+": "+i.obj.datasourceId:"");if(i.obj&&i.obj.type&&i.obj.type==="dem")s=true;return{id:c+"_layer_"+i.obj.id,text:giscloud.xssSafe(i.obj.name),icon:p(i.obj.type,e&&(e.offlineUrl&&e||e.symbol||(e.galleryUrl||e.url||e.hatchUrl||e.hatchGalleryUrl)&&e||{type:i.obj.type,color:e.color,border:e.bordercolor}),i.obj&&i.obj.source&&i.obj.source.type,c+"_layer_"+i.obj.id),data:{type:i.obj.type,title:giscloud.xssSafe(i.obj.name),id:i.obj.id*1},li_attr:{title:o,rel:"layer",id:c+"_layer_"+i.obj.id,class:(i.obj.visible==="t"?"jstree-checked":"")+(l(e)?" jstree-cover":"")+(s?" hidden":"")},belongsToGcMap:a}}}})};f=u(l,t);return f};g=function(e,t){var i,n;if(typeof e.obj.order==="string"){i=parseInt(e.obj.order,10);n=parseInt(t.obj.order,10)}else{i=e.obj.order;n=t.obj.order}return n-i};T=function(e){var t,i,n,r=[];for(t=0,i=e.length;t<i;t++){n=e[t];if(Object.prototype.toString.call(n)==="[object Array]"){r=r.concat(T(n))}else{r.push(n)}}return r};v=function(i,e){var t,n,r="";b.each(i,function(e,t){r=r+t.relief_color+" "+t.value_stop*100+"%";if(e!==i.length-1){r=r+", "}});for(t=0,n=document.styleSheets.length;t<n;t++){console.log(document.styleSheets[t]);if(document.styleSheets[t].href===null){document.styleSheets[t].addRule(".jstree-themeicon-custom.raster_gradient_"+e,"background-image: linear-gradient("+r+")");break}}return"raster_gradient_"+e};p=function(e,t,i,n){var r,o,s,a,l=D.responsive?18:10,c=_.location.protocol=="https:"?"https:":"http:",u=giscloud.offlineMode()&&giscloudOffline.documentDirectory;if(t==="multi"){r="/assets/images/layertree/color_swatch.gif"}else{switch(e){case"folder":r="/assets/images/layertree/folder.gif";break;case"analysis":r="/assets/images/layertree/color_swatch.gif";break;case"raster":r="/assets/images/image.gif";break;case"giscloud":case"wms":case"wfs":case"wmts":case"tile":r="/assets/images/world.gif";break;case"point":case"line":case"polygon":case"geometry":if(t&&u&&t.offlineUrl){r="/assets/"+t.offlineUrl}else if(i=="wfs"){r="/assets/images/world.gif"}else if(t&&t.galleryUrl){r=t.galleryUrl.replace(/^.*\/rest\//i,"/")}else if(t&&t.url){r="/assets/icon.php?p="+encodeURI(t.url).replace("(","%28").replace(")","%29")}else if(t&&t.hatchUrl){return"/assets/icon.php?p="+encodeURI(t.hatchUrl).replace("(","%28").replace(")","%29")}else if(t&&t.hatchGalleryUrl){r=t.hatchGalleryUrl.replace(/^.*\/rest/i,"")}else if(t){s=parseInt(t.size,10)||0;a=parseInt(t.bw,10)||0;o=(s+2*a)/l;if(o){a=Math.round(a/o)}s=l-2*a;if(t.color===x&&t.type==="line"){t.color="";if(t.border===x){f.push(n)}}else if(t.color===x){t.color="255,255,255";if(t.border===x){f.push(n)}}if(t.border===x){t.border="0,0,0"}if(t.relief_color){var d=giscloud.Color.hexToRgb(t.relief_color);t.color=d?d.join(","):t.relief_color;t.border=d?d.join(","):t.relief_color;t.type="box"}if(t.color===""){r="/assets/icon.php?type="+t.type+"&border="+t.border+"&bw="+a+"&size="+s}else{r="/assets/icon.php?type="+t.type+"&color="+t.color+"&border="+t.border+"&bw="+a+"&size="+s}}break;default:return null}}if(u){return"file://"+giscloudOffline.documentDirectory.slice(0,-1)+r}if(r.indexOf("assets/icon.php")===-1){if(r.indexOf("/1/icons/")===0){r="/rest"+r}return giscloud_config.assetsSite()+r.substr(1)}return w.apiHost().replace("http:",c)+r};function r(e){var t,i,n;if(e.env){return e}if(e.item){return null}if(e.all){i="all"}else if(e.any){i="any"}else if(e.one){i="one"}else if(e.none){i="none"}else{console.log("unknown deps operator",e);return null}n=b.map(e[i],r);if(n.length===0){return null}t={};t[i]=n;return t}function o(e){if(!e||!e.form||!e.form.definition||!e.form.definition.items){return}return b.map(e.form.definition.items,function(e){var t;if(!b.isPlainObject(e.active)){return}t=r(e.active);if(t){return{uuid:e.uuid,name:e.name,active:t}}})}function S(r){b.each(r||[],function(e,t){var i,n;if(!t.form){return}i=o(t);if(!i||i.length===0){r[e].hideFields=[];return}n=new giscloud.DependencyResolver({formItems:i});r[e].hideFields=b.map(i,function(e){var t=n.resolveDependency(e,e.active);if(t&&t.check&&!t.check()||t===false){return e.name}})})}})(window,giscloud.exposeJQuery(),giscloud.common());(function(e){var p=[0,3614090360,3905402710,606105819,3250441966,4118548399,1200080426,2821735955,4249261313,1770035416,2336552879,4294925233,2304563134,1804603682,4254626195,2792965006,1236535329,4129170786,3225465664,643717713,3921069994,3593408605,38016083,3634488961,3889429448,568446438,3275163606,4107603335,1163531501,2850285829,4243563512,1735328473,2368359562,4294588738,2272392833,1839030562,4259657740,2763975236,1272893353,4139469664,3200236656,681279174,3936430074,3572445317,76029189,3654602809,3873151461,530742520,3299628645,4096336452,1126891415,2878612391,4237533241,1700485571,2399980690,4293915773,2240044497,1873313359,4264355552,2734768916,1309151649,4149444226,3174756917,718787259,3951481745],t=[[0,7,1],[1,12,2],[2,17,3],[3,22,4],[4,7,5],[5,12,6],[6,17,7],[7,22,8],[8,7,9],[9,12,10],[10,17,11],[11,22,12],[12,7,13],[13,12,14],[14,17,15],[15,22,16]],i=[[1,5,17],[6,9,18],[11,14,19],[0,20,20],[5,5,21],[10,9,22],[15,14,23],[4,20,24],[9,5,25],[14,9,26],[3,14,27],[8,20,28],[13,5,29],[2,9,30],[7,14,31],[12,20,32]],n=[[5,4,33],[8,11,34],[11,16,35],[14,23,36],[1,4,37],[4,11,38],[7,16,39],[10,23,40],[13,4,41],[0,11,42],[3,16,43],[6,23,44],[9,4,45],[12,11,46],[15,16,47],[2,23,48]],r=[[0,6,49],[7,10,50],[14,15,51],[5,21,52],[12,6,53],[3,10,54],[10,15,55],[1,21,56],[8,6,57],[15,10,58],[6,15,59],[13,21,60],[4,6,61],[11,10,62],[2,15,63],[9,21,64]];function o(e,t,i){return e&t|~e&i}function s(e,t,i){return e&i|t&~i}function a(e,t,i){return e^t^i}function l(e,t,i){return t^(e|~i)}var g=[[o,t],[s,i],[a,n],[l,r]];function m(e){return String.fromCharCode(e&255)+String.fromCharCode(e>>>8&255)+String.fromCharCode(e>>>16&255)+String.fromCharCode(e>>>24&255)}function c(e){return e.charCodeAt(0)|e.charCodeAt(1)<<8|e.charCodeAt(2)<<16|e.charCodeAt(3)<<24}function v(e){while(e<0)e+=4294967296;while(e>4294967295)e-=4294967296;return e}function y(e,t,i,n,r){var o,s,a,l,c,u,d,f,h;o=n[0];s=n[1];a=n[2];l=n[3];c=r[0];u=r[1];d=r[2];h=i(t[s],t[a],t[l]);f=t[o]+h+e[c]+p[d];f=v(f);f=f<<u|f>>>32-u;f+=t[s];t[o]=v(f)}function u(e){var t,i,n,r,o,s,a,l,c,u,d,f,h;n=[1732584193,4023233417,2562383102,271733878];o=e.length;s=o&63;a=s<56?56-s:120-s;if(a>0){e+="";for(u=0;u<a-1;u++){e+="\0"}}e+=m(o*8);e+=m(0);o+=a+8;t=[0,1,2,3];i=[16];r=[4];for(f=0;f<o;f+=64){for(u=0,d=f;u<16;u++,d+=4){i[u]=e.charCodeAt(d)|e.charCodeAt(d+1)<<8|e.charCodeAt(d+2)<<16|e.charCodeAt(d+3)<<24}for(u=0;u<4;u++)r[u]=n[u];for(u=0;u<4;u++){l=g[u][0];c=g[u][1];for(d=0;d<16;d++){y(i,r,l,t,c[d]);h=t[0];t[0]=t[3];t[3]=t[2];t[2]=t[1];t[1]=h}}for(u=0;u<4;u++){n[u]+=r[u];n[u]=v(n[u])}}return m(n[0])+m(n[1])+m(n[2])+m(n[3])}function d(e){var t,i,n;var r;r=u(e);i="";for(t=0;t<16;t++){n=r.charCodeAt(t);i+="0123456789abcdef".charAt(n>>4&15);i+="0123456789abcdef".charAt(n&15)}return i}function f(e){e=e?e:"";return d(e.toString())}giscloud.md5=f;if(e){e.md5=f}else{window.md5=f}})(typeof giscloud!=="undefined"?giscloud.common():null);(function(e){function t(e){var t=Math.random()*16|0,i=e=="x"?t:t&3|8;return i.toString(16)}function i(){return"xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g,t)}giscloud.uuid=i;if(e){e.uuid=i}else{window.uuid=i}})(typeof giscloud!=="undefined"?giscloud.common():null);(function(e,o,s,t){giscloud.proxy={call:function(e,t,i){var n="proxy",r=new o.Deferred;t=t||{};if(typeof t==="function"){i=t;t={}}else{i=i||t.callback}t.url=e;s.rest.get(n,t).done(function(e){try{if(typeof i=="function"){i(e)}r.resolve(users)}catch(e){r.reject()}}).fail(function(){r.reject()});return r.promise()}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(c,u){"use strict";giscloud.geoutils={merge:function(e,t){var o=new c.Deferred,i="geo_utils/merge.json",n={sources:e};if(t&&t.fieldsMap){t.fields_map=c.isArray(t.fieldsMap)?t.fieldsMap.join():t.fieldsMap;delete t.fieldsMap}c.extend(n,t);u.rest.get(i,n,"application/json").done(function(e,t,i){var n=i.getResponseHeader("Location"),r=n&&n.match(/tables\/(\w+)/);o.resolve([r&&r[1]])}).fail(function(){o.reject(arguments)});return o.promise()},featuresAtPoint:function(e,t,i,n){var r=new c.Deferred,o="geo_utils/features_at_point.json?",s={},a=e&&e instanceof giscloud.LonLat?e:null;if(!a||!t)return;if(typeof i==="function"){n=i;i=null}else{n=n||i&&i.callback}o+="point_x="+a.lon;o+="&point_y="+a.lat;o+="&layer_id="+t.join(",");if(i&&i.srid){o+="&srid="+i.srid}if(i&&i.buffer){o+="&buffer="+i.buffer}u.rest.get(o).done(function(){var e=arguments[0],t=[];try{c.each(e,function(){t.push(new giscloud.Feature(this))});r.resolve(t)}catch(e){r.reject()}}).fail(function(){r.reject()});if(n){r.done(n)}return r.promise()},featuresAtPointForMap:function(n,e,t){var r=new c.Deferred;giscloud.layers.byMapId(e,function(e){var t,i=new Array;try{c.each(e,function(e,t){i.push(t.id)});giscloud.geoutils.featuresAtPoint(n,i,t,function(e){try{r.resolve(e)}catch(e){r.reject()}})}catch(e){r.reject()}});return r.promise()},nearest:function(e,t,i,n){var r=new c.Deferred,o="geo_utils/nearest.json?",s=e&&e instanceof giscloud.LonLat?e:null;if(!s||!t){return}if(typeof i==="function"){n=i;i=null}else{n=n||i&&i.callback}o+="point_x="+s.lon;o+="&point_y="+s.lat;o+="&layer_id="+t.join(",");if(i&&i.srid){o+="&srid="+i.srid}if(i&&i.results){o+="&results="+i.results}u.rest.get(o).done(function(){var e=arguments[0],t=[];try{c.each(e,function(){t.push(new giscloud.Feature(this))});r.resolve(t)}catch(e){r.reject(e)}}).fail(function(){r.reject(arguments)});if(n){r.done(n)}return r.promise()},spatialFilter:function(e,t,i,n){var s=new c.Deferred,r="geo_utils/spatial_filter.json",o={perPage:5e3,page:1};function a(n,r,o){u.rest.call("POST",n,r).done(function(e){var t=o||[],i;if(e.length===5e3&&r.page<4){i=true}try{c.each(e,function(){t.push(new giscloud.Feature(this))});if(i){r.page=r.page+1;r.perPage=r.perpage;delete r.perpage;a(n,r,t)}else{s.resolve(t)}}catch(e){s.reject()}}).fail(function(){s.reject()})}if(!t)return;if(typeof i==="function"){n=i;i=null}else{n=n||i&&i.callback}if(i&&i.srid){o.srid=i.srid}if(i&&i.operation){o.operation=i.operation}if(i&&i.onlyFeatureIds){o.only_feature_ids=1}if(i&&i.filterByExpression){o.filter_by_expression=1}if(typeof e==="string"){o.features=e}else if(e instanceof giscloud.Geometry){o.filter=e.toOGC()}o.layer_ids=t.join(",");a(r,o);if(n){s.done(n)}return s.promise()},area:function(e,t,i,n){var r=e;if(r.rings){var o=new giscloud.GraphicStyle("polygon");r=new giscloud.GraphicFeature(e,o)}var s=new c.Deferred,a="geo_utils/area.json?geometry="+r.toOGC()+"&geometry_srid="+t+"&output_srid="+i;u.rest.call("POST",a).done(function(){var e=arguments[0],t="";try{c.each(e,function(){t=this.toString()});s.resolve(t)}catch(e){s.reject()}}).fail(function(){s.reject()});if(n){s.done(n)}return s.promise()},featureArea:function(e,t,i,n,r){if(!e||!t){console.log("Please define layer id and feature id to proceed.");return}if(!i){i="900913"}if(!n){n=i}var o=e,s=t,a="",l=new c.Deferred;giscloud.features.byId(o,s,{geometry:"wkt"}).done(function(e){if(e.geometry){a=e.geometry;var t="geo_utils/area.json?geometry="+a+"&geometry_srid="+i+"&output_srid="+n;u.rest.call("POST",t).done(function(){var e=arguments[0],t="";try{c.each(e,function(){t=this.toString()});l.resolve(t)}catch(e){l.reject()}}).fail(function(){l.reject()})}else{console.log("Geometry is not defined.");return}});if(r){l.done(r)}return l.promise()},featureBounds:function(e,t,i){var n=new c.Deferred,r="geo_utils/feature_bounds.json?",o={};if(!e)return;r+="layer_id="+e;if(t&&t.where){r+="&where="+encodeURIComponent(t.where)}if(t&&t.srid){r+="&srid="+t.srid}if(t&&t.proj4){r+="&proj4="+encodeURIComponent(t.proj4)}u.rest.get(r).done(function(){var e=arguments[0];n.resolve(e)}).fail(function(){n.reject(arguments)});if(i){n.done(i)}return n.promise()}}})(giscloud.exposeJQuery(),giscloud.common());(function(s,a){"use strict";giscloud.geocoder={query:function(e,t,i){var n=new s.Deferred,r="geocoder.json",o={service:"tt"};if(typeof t==="function"){i=t;t=null}else{i=i||t&&t.callback}if(typeof e=="object"){s.extend(o,e)}else if(typeof e=="string"){s.extend(o,{address:e})}else{console.log("Invalid first arg.");return n}if(t&&t.srid){o.srid=t.srid}if(t&&t.service){o.service=t.service.toLowerCase()}a.rest.get(r,o).done(function(){var e=arguments[0],t={};if(o.service=="tt"){try{t.results=e.geoResponse.geoResult;s.each(t.results,function(e,t){delete t.geohash;delete t.mapName;delete t.isCensusMicropolitanFlag;delete t.iteration;delete t.widthMeters;delete t.heightMeters});n.resolve(t)}catch(e){n.reject()}}else{t.results=e;n.resolve(t)}}).fail(function(){var e=arguments[0],t=e?s.parseJSON(e.responseText):null;n.reject(t,e?e.status:null)});if(i){n.done(i)}return n.promise()}}})(giscloud.exposeJQuery(),giscloud.common());(function(e,c,u,n){"use strict";giscloud.ui.FeatureForm=function e(i,r,o){var s,a,l;function t(){var n=new c.Deferred;var e="layers/"+r;if(o!=null){e+="/features/"+o}e+="/form.html";function t(e,t,i){s=t;a=i;n.resolve("form ready").promise()}c(i).one("formReady.gc-custom-form",t);u.rest.call("get",e,{buttons:"none"},"text/html").always(function(e){var t=c(e.responseText);l=t.attr("id");t.appendTo(i)});return n}this.loaded=t();this.save=function(){var i=c.Deferred();c(s).trigger("save.gc-custom-form");c(s).on("submitSuccess.gc-custom-form",function(e,t){i.resolve(t).promise()});return i};this.data=function(e){if(Object.prototype.toString.call(e)==="[object Object]"){for(var t in e){if(e.hasOwnProperty(t)){c(s).trigger("setFieldValue.gc-custom-form",[t,e[t]])}}}else if(e===n){return a.gatherData().data}else{return}};this.reset=function(){a.reset()};this.clear=function(){var e=this.data();var t={};for(var i in e){if(e.hasOwnProperty(i)){t[i]=null}}this.data(t)};this.destroy=function(){c(s).off("submitSuccess.gc-custom-form");c("#"+l).remove();c(s).trigger("destroy.gc-custom-form")}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,t,i,n){var r,o,s,a,l,c,u=Math.PI/180,d,f,h,p,g,m,v,y,_,b={color:new giscloud.Color(160,160,160,100),size:1},w=new giscloud.GraphicStyle(b),x=new giscloud.GraphicStyle("point"),k,C=false,L,T,j;giscloud.ui.defaultTools.azimuth=function(){return new giscloud.ui.Toolbar.Tool("azimuth",{styles:{caption:"Azimuth",showCaption:false,cssClass:"gc-tool-azimuth",active:"gc-tool-azimuth-active",hover:"gc-tool-azimuth-hover"},actions:{activation:function(e){j=e;j.loading.done(function(){j.bind("mouseDown",M);j.bind("mouseMove",I);j.instance.setCursor("crosshair")})},deactivation:function(e){j=e;for(var t=0;t<j.markers.length;t++){j.markers[t].visible(false)}j.graphic.unbind("doubleClick",D);j.unbind("mouseMove",I);j.unbind("mouseDown",M);j.instance.setCursor("");j.graphic.clear();k=null;m=null;r=null;C=false;p=null}}})};function M(e){if(k){j.graphic.add(k);h=new giscloud.LabelMarker;j.addMarker(h);h.location(e).content(L);k=null}d=new giscloud.geometry.Point(e.lon,e.lat);a=e.lon*u;s=e.lat*u;if(!C){g=new giscloud.GraphicFeature(d,x);j.graphic.add(g);j.graphic.bind("doubleClick",D)}C=true}function I(e){var t,i,n,r;if(!C){return}f=new giscloud.geometry.Point(e.lon,e.lat);v=new giscloud.geometry.Line([d,f]);if(!k){k=new giscloud.GraphicFeature(v,w);j.graphic.add(k)}k.geometry(v);if(!m){m=new giscloud.GraphicFeature(f,x);j.graphic.add(m)}m.geometry(f);c=e.lon*u;l=e.lat*u;y=c-a;_=l-s;if(y>0&&_>0){t=Math.atan(y/_)*(1/u)}else if(y>0&&_<0){t=Math.atan(y/_)*(1/u)+180}else if(y<0&&_<0){t=Math.atan(y/_)*(1/u)+180}else if(y<0&&_>0){t=Math.atan(y/_)*(1/u)+360}else if(y===0&&_>0){t=0}else if(y===0&&_<0){t=180}else if(y>0&&_===0){t=90}else if(y<0&&_===0){t=270}else if(y===0&&_===0){t=0}else{console.log("Problem with azimuth!")}i=t|0;n=Math.abs(t-i)*60|0;r=Math.abs(t-i)*3600-n*60|0;L=i+"°"+n+"'"+r+"''";if(!p){p=new giscloud.LabelMarker;j.addMarker(p)}p.location(e).content(L)}function D(){k=null;m=null;r=null;C=false;p=null;return}})(window,giscloud.exposeJQuery(),giscloud.common());(function(r,t,e,i){var n=this,o,s,a,l=new giscloud.GraphicStyle({color:giscloud.Color.fromHex(0),size:1}),c=new giscloud.GraphicStyle({size:1,color:new giscloud.Color(0,0,0),fill:new giscloud.Color(255,0,0)});giscloud.ui.defaultTools.freehand=function(e){o=new giscloud.ui.Toolbar.Tool("freehand",{styles:{caption:"Freehand",showCaption:false,cssClass:"gc-tool-freehand",active:"gc-tool-freehand-active",hover:"gc-tool-freehand-hover"},actions:{activation:function(e){a=e;a.loading.done(function(){u();a.instance.setCursor("crosshair")})},deactivation:function(e){d()}}});o.layerId=e&&e.layerId?e.layerId:null;return o};function u(){if(s)a.graphic.remove(s);a.instance.setTool("SelectTool");p()}function d(){if(s)a.graphic.remove(s);a.graphic.cancelDraw();t(a.container()).off("mousedown",h);t(a.container()).off("mouseup",f)}function f(e){n.lastMouseEvent=e;a.graphic.acceptDraw()}function h(e){if(t.inArray(t(e.target).prop("tagName").toLowerCase(),["svg","canvas"])==-1){p();return}t(document).one("mouseup",f)}function p(){t(a.container()).one("mousedown",h);a.graphic.draw("freehand",l).done(function(e){if(s)a.graphic.remove(s);var t=e.geometry(),i,n;t.lines[0].points.push(t.lines[0].points[0]);t=new giscloud.geometry.Polygon(t.lines);i=o.layerId?o.layerId:null;if(!i){n=r.gcapp&&gcapp.gclayer.llist?gcapp.gclayer.llist.getSelected():null;i=n?n.id:null}if(!i){if(giscloud.ui&&giscloud.ui.alert)giscloud.ui.alert.red(__("No layer selected"),2e3);p();return}if(n&&n.lock=="t"){if(giscloud.ui&&giscloud.ui.alert)giscloud.ui.alert.red(__("The currently selected layer is locked"),2e3);p();return}if(giscloud.ui&&giscloud.ui.alert)giscloud.ui.alert.green(__("PleaseWait"));giscloud.geoutils.spatialFilter(t,[i],{srid:a.instance.epsg,operation:"intersect",onlyFeatureIds:1}).always(function(){if(giscloud.ui&&giscloud.ui.alert)giscloud.ui.alert.hide()}).done(function(e){g(e)});s=new giscloud.GraphicFeature(t,c);a.graphic.add(s);o.trigger("select",{geometry:t});p()})}function g(e){o.trigger("selectFeatures",{features:e});if(r.gcapp){var i={lid:gcapp.gclayer.llist.getSelected().id,fids:[]};t.each(e,function(e,t){i.fids.push(t.id)});i.fids=i.fids.join(",");gcapp.selo.onGetFeaturesByBoundComplete(i,n.lastMouseEvent.originalEvent)}else{a.selection.clear();t.each(e,function(e,t){a.selectFeature(o.layerId,t.id)})}}})(window,giscloud.exposeJQuery(),giscloud.common());(function(n,t,e,i){var a,l=[],c={url:"data:image/gif;base64,R0lGODlhAQABAAD/ACwAAAAAAQABAAACADs=",width:0,height:0},u,d=[],f=[],h,p,g=3410,m,v="m",r;giscloud.ui.defaultTools.areaMeasure=function(e){if(e&&e.srid){giscloud.ui.defaultTools.areaMeasure.outputSrid(e.srid)}if(e&&e.unit){giscloud.ui.defaultTools.areaMeasure.measureUnit(e.unit)}return new giscloud.ui.Toolbar.Tool("areaMeasure",t.extend({styles:{caption:"Area measure",showCaption:false,cssClass:"gc-tool-areaMeasure",active:"gc-tool-areaMeasure-active",hover:"gc-tool-areaMeasure-hover"},actions:{activation:o,deactivation:s}},e||{}))};function o(e){r=true;p=e;t(document).keyup(_);p.loading.done(function(){p.instance.setCursor("crosshair");var e=function(){m=giscloud.proj4(p.projection,"EPSG:"+g);p.graphic.draw("polygon").progress(w).then(k)};if(giscloud.proj4.defs("EPSG:"+g)){e()}else{giscloud.includeJs("/rest/1/geo_utils/epsg_to_proj4js?srid="+g).done(e)}})}function s(e){r=false;t(document).unbind("keyup");p.graphic.clear();y();while(a=l.pop()){p.removeMarker(a)}}function y(){d=[];f=[];a=null;p.graphic.cancelDraw()}function _(e){if(e.keyCode==27){s(p)}}giscloud.ui.defaultTools.areaMeasure.outputSrid=function(e){var t;if(!e){if(n.user&&n.user.options&&user.options.UNIT_SRID){t=user.options.UNIT_SRID}}else{t=e}if(!t){return}var i=function(){m=giscloud.proj4(giscloud.ui.map?"EPSG:CURRENT":p.projection,"EPSG:"+t)};if(giscloud.proj4.defs("EPSG:"+t)){i()}else{giscloud.includeJs("/rest/1/geo_utils/epsg_to_proj4js?srid="+t).done(i)}return t};giscloud.ui.defaultTools.areaMeasure.measureUnit=function(e){if(e!==i&&b(e)){v=e}return v};function b(e){if(typeof e!=="string"){return null}if(!giscloud.toSqMeterRatio[e]&&!giscloud.toMeterRatios[e]){return null}return e}function w(e,t){if(e){var i={lon:e.rings[0].points[e.rings[0].points.length-1].x,lat:e.rings[0].points[e.rings[0].points.length-1].y};x(i,t)}return}function x(e,t){var i,n,r=giscloud.proj4.defs("EPSG:"+g)?giscloud.proj4.defs("EPSG:"+g).units:giscloud.proj4.defs("GC_MAP_CURRENT").units,o;if(!r){r="degrees"}u=new giscloud.geometry.Point(e.lon,e.lat);d.push(u);f.push(m.forward({x:u.x,y:u.y}));if(d.length>2){if(p.instance.epsg){h=parseInt(p.instance.epsg)}else{h=3410}areaCount=giscloud.math.util.calculatePolygonAreaAndCentroid(f).area;if(!a&&!t){a=new giscloud.Marker;a.icon(c);p.addMarker(a);l.push(a)}var s=areaCount;if(v!==r&&r!=="degrees"&&areaCount!=="0"){if(v=="acre"||v=="ha"){areaCount=giscloud.toMeters(r,parseFloat(areaCount),true);areaCount=giscloud.fromSquareMeter(v,areaCount)}else{areaCount=giscloud.toMeters(r,parseFloat(areaCount),true);areaCount=giscloud.fromMeters(v,areaCount,true)}}areaCount=parseFloat(areaCount).toFixed(2).toString().replace(".",",");switch(v){case"foot":case"us survey foot":case"foot_us":o="ft";break;case"meter":case"meters":o="m";break;case"acres":o="acres";break;default:o=v}p.fire("areaMeasure",{epsg_area:s,epsg_unit:r,epsg:h});n=areaCount.split(",");j=0;i=n[0].length-3;for(i;i>0;i=i-3){areaCount=[areaCount.slice(0,i),".",areaCount.slice(i)].join("");j++}if(v=="acre"||v=="ha"){areaCount=areaCount+"&nbsp;"+o+"&nbsp;"}else{areaCount=areaCount+"&nbsp;"+o+"<sup>2</sup>"}if(!t){centroid=giscloud.math.util.calculatePolygonAreaAndCentroid(d).centroid;centroid=new giscloud.LonLat(centroid.x,centroid.y);a.location(centroid)}if(a){a.label(areaCount)}}if(t){d.pop();f.pop()}}function k(){y();setTimeout(function(){if(r){p.graphic.draw("polygon").progress(w).then(k)}},0)}})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,i,s,t){var a=[],l={icon:"data:image/gif;base64,R0lGODlhAQABAAD/ACwAAAAAAQABAAACADs=",width:0,height:0},c,u,d,f,h,p=0,g,n;giscloud.ui.defaultTools.distanceMeasure=function(e){return new giscloud.ui.Toolbar.Tool("distanceMeasure",i.extend({styles:{caption:"Distance measure",showCaption:false,cssClass:"gc-tool-distanceMeasure",active:"gc-tool-distanceMeasure-active",hover:"gc-tool-distanceMeasure-hover"},actions:{activation:r,deactivation:o}},e||{}))};function r(e){n=true;f=e;i(document).keyup(v);f.loading.done(function(){g=giscloud.proj4(f.projection,"EPSG:4326");f.instance.setCursor("crosshair");f.graphic.draw("line").progress(y).then(b)})}function o(e){var t=null;f=e;n=false;i(document).unbind("keyup");f.graphic.clear();m();while(t=a.pop()){f.removeMarker(t)}}function m(){p=0;d=null;u=null;h=null;f.graphic.cancelDraw()}function v(e){if(e.keyCode==27){o(f)}}function y(e,t){if(e){var i={lon:e.points[e.points.length-1].x,lat:e.points[e.points.length-1].y};_(i,t)}return}function _(e,t){var i=giscloud.proj4.defs("EPSG:4326").units,n;c=new giscloud.geometry.Point(e.lon,e.lat);n=g.forward({x:c.x,y:c.y});d=new giscloud.LonLat(e.lon,e.lat);if(u){var r=p+s.haversine(u.y,u.x,n.y,n.x);if(!t){p=r}var o;if(h)o=h;else{o=new giscloud.Marker;o.icon(l.icon);o.clickable(false);f.addMarker(o);a.push(o)}f.fire("distanceMeasure",{epsg_distance:r,epsg_unit:i});o.location(d).label(f.instance.measureLabelFunction(r));if(t){h=o}else{h=null}}if(!t){u=n}}function b(){m();setTimeout(function(){if(n){f.graphic.draw("line").progress(y).then(b)}},0);return}})(window,giscloud.exposeJQuery(),giscloud.common());(function(e,t,i,n){var c,u,d;giscloud.ui.defaultTools.countByPolygon=function(){return new giscloud.ui.Toolbar.Tool("countByPolygon",{styles:{caption:"Count by polygon",showCaption:false,cssClass:"gc-tool-countByPolygon",active:"gc-tool-countByPolygon-active",hover:"gc-tool-countByPolygon-hover"},actions:{activation:function(e){c=e;c.loading.done(function(){c.instance.setTool("AreaSelection");c.instance.addEventListener("areaselection",r)})},deactivation:function(e){c.instance.removeEventListener("areaselection",r)}}})};function f(){if(u)c.graphic.remove(u);if(d)c.removeMarker(d)}function r(e){var t=giscloud.ui.layerList.selected();if(t==null||isNaN(t)){alert("Please select the layer first.");return}var i=new giscloud.Bounds(Math.min(e.xMin,e.xMax),Math.min(e.yMin,e.yMax),Math.max(e.xMin,e.xMax),Math.max(e.yMin,e.yMax));f();var n=[];n.push(new giscloud.geometry.Point(e.xMin,e.yMin));n.push(new giscloud.geometry.Point(e.xMax,e.yMin));n.push(new giscloud.geometry.Point(e.xMax,e.yMax));n.push(new giscloud.geometry.Point(e.xMin,e.yMax));n.push(new giscloud.geometry.Point(e.xMin,e.yMin));var r=new giscloud.GraphicStyle("polygon"),o=new giscloud.geometry.Line(n),s=new giscloud.geometry.Polygon([o]);u=new giscloud.GraphicFeature(s,r);u.bind("click",f);c.graphic.add(u);var a=new giscloud.LonLat(i.left,i.top),l="Loading...";d=new giscloud.LabelMarker;c.addMarker(d);d.location(a).content(l);giscloud.features.byBounds(t,i).done(function(e){var t=e.length>=5e3?e.length+"+":e.length;d.content(t)})}})(window,giscloud.exposeJQuery(),giscloud.common());(function(window,$,common,undefined){giscloud.help=function(){if(giscloud.help.def)return showHelp(giscloud.help.def.giscloud);return""};giscloud.help.ignore=[];giscloud.help.category=[];giscloud.help.objects=[];giscloud.help.namespaces={};function findCategory(e){var t=giscloud.help.category;for(var i in t){if(!t.hasOwnProperty(i))continue;if(i.indexOf("*")>0){var n=new RegExp(i);if(e.match(n)){return t[i]}}}if(t[e])return t[e]}var classes=[];function listApi(root,parent){var objects=giscloud.help.objects;var ignore=giscloud.help.ignore;var namespaces=giscloud.help.namespaces;var category=giscloud.help.category;var output={};output.category=findCategory(root);try{eval('var desc = giscloud.help.def["'+root+'"].desc');output.desc=desc}catch(e){}try{eval('var fiddle = giscloud.help.def["'+root+'"].fiddle');if(fiddle)output.fiddle=fiddle}catch(e){}try{eval('var disabled = giscloud.help.def["'+root+'"].disabled');if(disabled)output.disabled=true}catch(e){}if(!output.desc){output.desc=""}var s=[];var def=[];var types=[];var property_ref=[];var ns;try{ns=eval(root)}catch(e){return""}var nextlevel=[];var methods=[];var methods_map={};var properties=[];var properties_map=[];var events={};try{eval("var _example = giscloud.help.def['"+root+"']._example");output._example=_example}catch(e){}for(var j=1;j<10;j++){try{eval("var _example"+j+" = giscloud.help.def['"+root+"']._example"+j);eval("output._example"+j+" = _example"+j)}catch(e){}}try{eval("var events = giscloud.help.def['"+root+"']._events");if(events){output._events=events}}catch(e){console.log(e)}for(var l=1;l<20;l++){try{eval("var events"+l+" = giscloud.help.def['"+root+"']._events"+l);eval("output._events"+l+" = events"+l)}catch(e){console.log(e)}}for(var i in ns){if(!ns.hasOwnProperty(i))continue;if(typeof ns[i]=="function"){if(i[0]===i[0].toUpperCase()){if(ignore[root+"."+i])continue;classes.push({ref:ns[i],name:root+"."+i});s.push(root+"."+i);def[root+"."+i]=[];if(objects[root+"."+i]){obj=objects[root+"."+i]}else{try{obj=new ns[i]({})}catch(e){console.log("error ",root+"."+i)}}for(var p in obj){def[root+"."+i].push(p);types[root+"."+i+"."+p]={type:typeof obj[p],ref:obj[p]}}def[root+"."+i].sort()}}}s.sort();for(var i=0;i<s.length;i++){var name=s[i];var name_def='["'+name.substr(0,name.lastIndexOf("."))+'"]'+name.substr(name.lastIndexOf("."));var cl={class:name};var p=def[s[i]];try{eval("var desc = giscloud.help.def"+name_def+".desc");cl.desc=desc}catch(e){}try{eval("var fiddle = giscloud.help.def"+name_def+".fiddle");if(fiddle)cl.fiddle=fiddle}catch(e){}try{eval("var disabled = giscloud.help.def"+name_def+".disabled");if(disabled)cl.disabled=true}catch(e){}if(!cl.desc){cl.desc=""}cl.category=findCategory(name);try{eval("var _example = giscloud.help.def"+name_def+"._example");cl._example=_example}catch(e){}for(var j=1;j<10;j++){try{eval("var _example"+j+" = giscloud.help.def"+name_def+"._example"+j);eval("cl._example"+j+" = _example"+j)}catch(e){}}try{eval("var events = giscloud.help.def"+name_def+"._events");if(events){cl._events=events}}catch(e){console.log(e)}for(var l=1;l<20;l++){try{eval("var events"+l+" = giscloud.help.def"+name_def+"._events"+l);eval("cl._events"+l+" = events"+l)}catch(e){console.log(e)}}cl._constructor={params:"",usage:"",desc:""};try{eval("var _constructor = giscloud.help.def"+name_def+"._constructor");if(_constructor.params)cl._constructor.params=_constructor.params;if(_constructor.usage)cl._constructor.usage=_constructor.usage;if(_constructor.desc)cl._constructor.desc=_constructor.desc;if(_constructor.fiddle)cl._constructor.fiddle=_constructor.fiddle;if(_constructor.disabled)cl._constructor.disabled=_constructor.disabled}catch(e){}for(var j=0;j<p.length;j++){if(types[s[i]+"."+p[j]].type=="function"){if(ignore[s[i]+"."+p[j]])continue;var m={};try{eval("var desc = giscloud.help.def"+name_def+"._methods."+p[j]);m.params=desc.params;m.returns=desc.returns;m.desc=desc.desc;if(desc.fiddle)m.fiddle=desc.fiddle;if(desc.disabled)m.disabled=desc.disabled}catch(e){m.params="";m.returns="";m.desc=""}if(!cl._methods)cl._methods={};cl._methods[p[j]]=m}}for(var j=0;j<p.length;j++){if(types[s[i]+"."+p[j]].type!="function"){if(ignore[s[i]+"."+p[j]])continue;var type=types[s[i]+"."+p[j]];var property={ref:type.ref};try{eval("var desc = giscloud.help.def"+name_def+"._properties."+p[j]);property.type=desc.type;property.desc=desc.desc;if(desc.fiddle)property.fiddle=desc.fiddle;if(desc.disabled)property.disabled=desc.disabled}catch(e){property.type="";property.desc=""}if(!cl._properties)cl._properties={};cl._properties[p[j]]=property}}output[name.substr(name.lastIndexOf(".")+1)]=cl}for(var i in ns){if(!ns.hasOwnProperty(i))continue;if(typeof ns[i]=="function"){if(i[0]!=i[0].toUpperCase()){if(ignore[root+"."+i])continue;m={};try{eval('var desc = giscloud.help.def["'+root+'"]._methods.'+i);m.params=desc.params;m.returns=desc.returns;m.desc=desc.desc;if(desc.fiddle)m.fiddle=desc.fiddle;if(desc.disabled)m.disabled=desc.disabled}catch(e){m.params="";m.returns="";m.desc=""}methods_map[i]=m;methods.push(i)}}else if(giscloud.help.include_namespace[root+"."+i]){if(ignore[root+"."+i])continue;nextlevel.push(root+"."+i)}else{if(ignore[root+"."+i]||ignore[root+"._properties"])continue;var property={};try{eval('var desc = giscloud.help.def["'+root+'"]._properties.'+i);property.type=desc.type;property.desc=desc.desc;if(desc.fiddle)property.fiddle=desc.fiddle;if(desc.disabled)property.disabled=desc.disabled}catch(e){property.type="";property.desc=""}properties_map[i]=property;properties.push(i)}}namespaces[root]=output;nextlevel.sort();for(var i=0;i<nextlevel.length;i++){listApi(nextlevel[i],output)}methods.sort();properties.sort();if(methods.length>0){output._methods={};for(var i=0;i<methods.length;i++){output._methods[methods[i]]=methods_map[methods[i]]}}if(properties.length>0){output._properties={};for(var i=0;i<properties.length;i++){output._properties[properties[i]]=properties_map[properties[i]]}}}function generateCharSpace(e,t){var i="";for(var n=0;n<t;n++)i+=e;return i}function makeMultiLine(e,t,i){var n="";var r=e;var o=0;while(r.length+o>t){while(e.length+o>t){e=e.substr(0,e.lastIndexOf(" "))}if(n){n+="\n"+generateCharSpace(" ",i+3)}n+=e;r=r.substr(e.length);e=r;o=i}if(n){n+="\n"+generateCharSpace(" ",i+3)}n+=r;return n}function formatMethod(e,t,i,n){var r=t.params||"";var o=t.desc||"";var s="\t"+e+generateCharSpace(" ",i-e.length)+r+generateCharSpace(" ",n-r.length)+o;return makeMultiLine(s,100,i+n)+"\n"+generateCharSpace(" ",4)+generateCharSpace("-",100)+"\n"}function showHelp(e){var t="\n";if(e._example){t+="Example:\n\n";t+=e._example;t+="\n"}if(e._methods){t+="Methods:\n\n";var i=0;var n=0;for(var r in e._methods){if(r.length>i)i=r.length;if(e._methods[r].params&&e._methods[r].params.length>n)n=e._methods[r].params.length}i+=3;n+=3;for(var r in e._methods){t+=formatMethod(r,e._methods[r],i,n)}}var o="";for(var r in e){if(r[0]!="_"&&r[0]===r[0].toUpperCase()){if(!o){o+="Classes:\n\n"}o+="\t"+r+"\n"}}t+=o;return t}function findHelpItem(root,ns,n){if(n>5)return;for(var i in root){if(!root.hasOwnProperty(i))continue;if(i[0]=="_"||i=="category")continue;if(root[i]._methods&&ns+i!="giscloud"){var obj="";if(root[i]["class"])obj='["'+ns.substr(0,ns.length-1)+'"].'+i;else obj='["'+ns+i+'"]';try{eval(ns+i+".help = function() { return showHelp(giscloud.help.def"+obj+"); }")}catch(e){}}var t=typeof root[i];var k=n;if(!k)k=0;findHelpItem(root[i],ns+i+".",k+1)}}function findClassType(e){for(var t=0;t<classes.length;t++){if(e instanceof classes[t].ref){return classes[t].name}}return null}giscloud.help.load=function(){giscloud.includeJs("/assets/api/1/help.def.js",function(){findHelpItem(giscloud.help.def,"")})};giscloud.help.write=function(format){giscloud.includeJs("/assets/api/1/help.def.js",function(){giscloud.help.init();listApi("giscloud");for(var i in giscloud.help.namespaces){var ns=giscloud.help.namespaces[i];for(var p in ns._properties){eval("var property = "+i+"."+p+";");var type=findClassType(property);if(type)ns._properties[p].type=type}for(var k in ns){if(!ns[k]||!ns[k]["class"])continue;var cl=ns[k];for(var p in cl._properties){var type=typeof cl._properties[p].ref;if(type!="undefined"){var gc_type=findClassType(cl._properties[p].ref);if(gc_type){cl._properties[p].type=gc_type}else{type=type[0].toUpperCase()+type.slice(1);cl._properties[p].type=type}}delete cl._properties[p].ref}}}var url;if(format=="markdown"||format=="md"){url="/modules_gc/utils/write-jsapi-docs-md.php"}else{url="/modules_gc/utils/write-jsapi-docs.php"}jQuery.ajax({type:"POST",url:url,processData:false,contentType:"application/json",data:JSON.stringify(giscloud.help.namespaces),dataType:"json",success:function(e){if(e&&e.msg)console.error("error!",e.msg);else console.log("done!")}})})};giscloud.help.stats=function(){giscloud.includeJs("/assets/api/1/help.def.js",function(){var e=0;var t=0;var i=0;var n=0;for(var r in giscloud.help.def){var o=giscloud.help.def[r];if(o._methods){for(var s in o._methods){var a=o._methods[s];e++;if(a.desc)t++;else console.log("method",s)}}if(o._properties){for(var s in o._properties){var a=o._properties[s];i++;if(a.desc)n++;else console.log("property",s)}}for(var l in o){if(!o[l]["class"])continue;for(var s in o[l]._methods){var a=o[l]._methods[s];e++;if(a.desc)t++;else console.log("method",l,s)}for(var s in o[l]._properties){var a=o[l]._properties[s];i++;if(a.desc)n++;else console.log("property",l,s)}}}console.log("Total methods: "+e+" (defined "+t+", "+Math.round(t/e*100)+"%)");console.log("Total properties: "+i+" (defined "+n+", "+Math.round(n/i*100)+"%)")})};giscloud.help.init=function(){var e=giscloud.help.ignore=[];var t=giscloud.help.category=[];var i=giscloud.help.objects=[];var n=giscloud.help.include_namespace={};giscloud.help.namespaces={};classes=[];n["giscloud"]=1;n["giscloud.address"]=1;n["giscloud.addressmodels"]=1;n["giscloud.bookmarks"]=1;n["giscloud.datasources"]=1;n["giscloud.datasources.wms"]=1;n["giscloud.date"]=1;n["giscloud.features"]=1;n["giscloud.formats"]=1;n["giscloud.formats.exportFormats"]=1;n["giscloud.formats.renderFormats"]=1;n["giscloud.forms"]=1;n["giscloud.geometry"]=1;n["giscloud.geoutils"]=1;n["giscloud.keys"]=1;n["giscloud.resources"]=1;n["giscloud.layers"]=1;n["giscloud.layers.attributeOps"]=1;n["giscloud.maps"]=1;n["giscloud.oauth2"]=1;n["giscloud.options"]=1;n["giscloud.permissions"]=1;n["giscloud.proxy"]=1;n["giscloud.rest"]=1;n["giscloud.search"]=1;n["giscloud.spatialrelationship"]=1;n["giscloud.tables"]=1;n["giscloud.tables.rows"]=1;n["giscloud.tasks"]=1;n["giscloud.ui"]=1;n["giscloud.ui.alert"]=1;n["giscloud.ui.columns"]=1;n["giscloud.ui.dataGrid"]=1;n["giscloud.ui.edit"]=1;n["giscloud.ui.layerList"]=1;n["giscloud.ui.selectExtent"]=1;n["giscloud.userOptions"]=1;n["giscloud.ui.defaultTools"]=1;n["giscloud.ui.customForm"]=1;n["giscloud.ui.search"]=1;n["giscloud.users"]=1;n["giscloud.files"]=1;e["giscloud.Html5Map"]=1;e["giscloud.Events"]=1;e["giscloud.ui.Datagrid"]=1;e["giscloud.ui.DatasourceBrowser"]=1;e["giscloud.ui.FILESilterBuilder"]=1;e["giscloud.ui.FilterBuilder"]=1;e["giscloud.ui.FilterBuilderManager"]=1;e["giscloud.ui.LayerFilterForm"]=1;e["giscloud.Html5MapSetSelection"]=1;e["giscloud.help.write"]=1;e["giscloud.wms"]=1;e["giscloud.datasources.apollo"]=1;e["giscloud.ui.apollo"]=1;e["giscloud.html5ResetLoaders"]=1;e["giscloud.Html5MapRefreshUrls"]=1;e["giscloud.gravatar"]=1;e["giscloud.ddupload"]=1;e["giscloud.construct"]=1;e["giscloud.contextMenu"]=1;e["giscloud.log"]=1;e["giscloud.logDeferredResults"]=1;e["giscloud.md5"]=1;e["giscloud.Layer.offscale"]=1;e["giscloud.Layer.onscale"]=1;e["giscloud.Layer.grp"]=1;e["giscloud.Layer.raster"]=1;e["giscloud.Layer.textfield"]=1;e["giscloud.Layer.label"]=1;e["giscloud.Layer.label_placement"]=1;e["giscloud.Map.mobileacess"]=1;e["giscloud.Query.actions"]=1;e["giscloud.Query.table"]=1;e["giscloud.ViewerLayer.instance"]=1;e["giscloud.address"]=1;e["giscloud.addressmodels"]=1;e["giscloud.oauth2.uriMismatch"]=1;e["giscloud.rest"]=1;e["giscloud.ui.ProjectionPicker"]=1;e["giscloud.ui.ProjectionPicker.init"]=1;e["giscloud.ui.ProjectionPicker.options"]=1;e["giscloud.ui.customForm.beforeOpen"]=1;e["giscloud.ui.Options"]=1;e["giscloud.ui.Options.init"]=1;e["giscloud.ui.Options.addbt"]=1;e["giscloud.ui.Options.inpdiv"]=1;e["giscloud.ui.Options.keyinp"]=1;e["giscloud.ui.Options.keylabel"]=1;e["giscloud.ui.Options.template"]=1;e["giscloud.ui.Options.ulcont"]=1;e["giscloud.ui.Options.valinp"]=1;e["giscloud.ui.Options.vallabel"]=1;e["giscloud.ui.Options.restOptions"]=1;e["giscloud.ui.Panel"]=1;e["giscloud.ui.Window"]=1;e["giscloud.ui.Search"]=1;e["giscloud.ui.alert"]=1;e["giscloud.ui.columns"]=1;e["giscloud.ui.customForm"]=1;e["giscloud.ui.dataGrid"]=1;e["giscloud.ui.edit"]=1;e["giscloud.ui.search"]=1;e["giscloud.ui.selectExtent"]=1;e["giscloud.ui.LayerList"]=1;e["giscloud.userOptions"]=1;e["giscloud.tasks"]=1;e["giscloud.Task"]=1;e["giscloud.Color.lab"]=1;e["giscloud.__googleMapsApiLoadedGeocoder"]=1;e["giscloud.cards"]=1;e["giscloud.coupons"]=1;e["giscloud.organization"]=1;e["giscloud.dashboard"]=1;e["giscloud.Color.lab"]=1;e["giscloud.options"]=1;e["giscloud.User"]=1;e["giscloud.Html5SendRequest"]=1;e["giscloud._properties"]=1;e["giscloud.File"]=1;e["giscloud.Post"]=1;e["giscloud.Resource"]=1;e["giscloud.Stream"]=1;e["giscloud.Vehicle"]=1;e["giscloud.FuelReading"]=1;t["giscloud.Graphic.*"]=t["giscloud.Map"]=t["giscloud.Layer"]=t["giscloud.Viewer"]=t["giscloud.ViewerLayer"]=t["giscloud.ViewerSelection"]=t["giscloud.Feature"]=t["giscloud.FlagMarker"]=t["giscloud.Marker"]=t["giscloud.LabelMarker"]="map";t["giscloud.Task"]=t["giscloud.tasks"]=t["giscloud.forms"]=t["giscloud.Query"]=t["giscloud.search"]=t["giscloud.tables"]=t["giscloud.tables.rows"]=t["giscloud.maps"]=t["giscloud.layers"]=t["giscloud.features"]=t["giscloud.users"]="resources";t["giscloud.datasources"]="datasources";t["giscloud.ui.map.*"]="ui.map";t["giscloud.ui.*"]="ui";t["giscloud.spatialrelationship"]=t["giscloud.geoutils"]=t["giscloud.Bounds"]=t["giscloud.Geometry"]=t["giscloud.LonLat"]=t["giscloud.geometry.*"]="geometry";t["giscloud.datasources.*"]=t["giscloud.wms.*"]="datasources";t["giscloud.keys"]=t["giscloud.oauth2"]=t["giscloud.resources"]=t["giscloud.permissions.*"]="users";i["giscloud.Graphic"]=new giscloud.Graphic(giscloud.ui.map);i["giscloud.Color"]=new giscloud.Color;i["giscloud.Queue"]=new giscloud.Queue([]);i["giscloud.GraphicFeature"]=new giscloud.GraphicFeature(new giscloud.geometry.Point);i["giscloud.ui.Options"]=new giscloud.ui.Options(document,{},{});i["giscloud.ViewerSelection"]=new giscloud.ViewerSelection(giscloud.ui.map);i["giscloud.Layer"]=new giscloud.Layer({alpha:100,bounds:new giscloud.Bounds,created:new Date,encoding:"enc",exportable:true,label:" ",lock:true});i["giscloud.LonLat"]=new giscloud.LonLat(0,0);{var r=new fnLayer;r.source={};r.id="layer0";i["giscloud.ViewerLayer"]=new giscloud.ViewerLayer(r)}i["giscloud.Promise"]=new giscloud.Promise;i["giscloud.ui.LayerList"]=new giscloud.ui.LayerList(giscloud.ui.map,"layerlist",true);i["giscloud.ui.Panel"]=new giscloud.ui.Panel({id:"info_panel",type:"vertical",position:"right",push:false,open:true,content:"<div id='infotable' ></div>"})}})(window,giscloud.exposeJQuery());delete giscloud.common;if(giscloud.proj4){giscloud.proj4.defs("EPSG:3410","+proj=cea +lon_0=0 +lat_ts=30 +x_0=0 +y_0=0 +a=6371228 +b=6371228 +units=m +no_defs")}})(window);